//===================================================================
/*

	AnalysisProcess.cc

	Ver0.1	10-Sep-2000	Y. Shimizu

*/
//==================================================================
#include<iostream.h>
#include<string.h>
#include<unistd.h>
#include<stdlib.h>
#include<signal.h>
#include<KonoePrimitives.hh>
#include<system/KonoeSignalClient.hh>
#include<system/KonoeSignalHandler.hh>
#include<system/KonoeNameSpaceValue.hh>
#include<system/KonoeNameSpaceTable.hh>
#include<system/KonoeNameSpaceItem.hh>
#include<system/KonoeNetworkNameSpaceManager.hh>

#include"DemoAnalysis.hh"
#include"AnalysisProcess.hh"

AnalysisProcess::AnalysisProcess( ){


	flag = OFF;

	ana_mode = INIT;

	KonoeNameSpaceTable *table;
	KonoeNameSpaceValue *value;

	table = new KonoeNameSpaceTable( );

	value = table->getValue("MASTER_HOST");
	if( value ){
		masterhost = (KChar*)*value;
	}
	else {
		cerr << "MASTER_HOST is not defined " << endl;
		exit(0);
	}


	command_process = new KonoeUDPClientSocket( masterhost , 50005);

	log = new KonoeLogMessenger( masterhost );

	handler = new KonoeSignalHandler( SIGINT , this );
	handler->enable();

///////  write this host and pid on NAMESPACE  /////////

	msg = new KonoeLogMessage(" Analysis constructor",1);

	KonoeNetworkNameSpaceManager * mgr1;
        mgr1 = new KonoeNetworkNameSpaceManager( masterhost );
	mgr1->setValue("ANA_PID",msg->getPID());
	delete mgr1;


	KonoeNetworkNameSpaceManager * mgr2;
        mgr2 = new KonoeNetworkNameSpaceManager( masterhost );
	mgr2->setValue("ANA_HOST",msg->getHostName() );
	delete mgr2;

	delete msg;

}
AnalysisProcess::~AnalysisProcess( ){
      
}

KInt AnalysisProcess::init( KInt pnumber ){

	KonoeNetworkNameSpaceManager * mgr1;
        mgr1 = new KonoeNetworkNameSpaceManager( masterhost );
	mgr1->setValue("UI_REQUEST","OFF");

	delete mgr1;

	number = pnumber;
	init();

}
KInt AnalysisProcess::init( ){

	if( flag == OFF){
	  KonoeNetworkNameSpaceManager *mgr;
          mgr = new KonoeNetworkNameSpaceManager( masterhost );
          mgr->setValue("CMD_STATUS","true");
	  delete mgr;

	  msg = new KonoeLogMessage(" Analysis init ",1);
	  log->send( msg->getLogMsg(),256);
	  delete msg;
	
//	  ana = new DemoAnalysis( masterhost );
	  cout << " analysis init " << endl;

	}

	handler->wait();
	flag = ON;

	if( ana_mode == INIT)
		init();
	else if( ana_mode == BEGIN )
		begin( );
	else if( ana_mode == END ){
		cout << " OK! analysis END " << endl;
		end();
	}
	else if( ana_mode == UNKNOWN ){
		cout << " what?? " << endl;
		init();
	}
	
	return -1;


}
	
KInt AnalysisProcess::begin( ){

        ana = new DemoAnalysis( masterhost );

	KonoeNetworkNameSpaceManager *mgr;
        mgr = new KonoeNetworkNameSpaceManager( masterhost );
        mgr->setValue("CMD_STATUS","true");
	delete mgr;

	msg = new KonoeLogMessage(" analysis begin ",0);
	log->send( msg->getLogMsg(), 256 );
	delete msg;

	cout << " ===== ANALYSIS START ===== " << endl;


	////////////////////////////////////////////////////
	ana->go( number );
	///////////////////////////////////////////////////

	delete ana;
	
	cout << " ===== ANALYSIS STOP ===== " << endl;

	handler->wait();

	if( ana_mode == INIT )
		init();
	else if(  ana_mode == END ){
		end();
	}
	else if(  ana_mode == BEGIN ){
		begin();
	}

	return -1;

}

KInt AnalysisProcess::end( ){

	KonoeNetworkNameSpaceManager *mgr;
        mgr = new KonoeNetworkNameSpaceManager( masterhost );
        mgr->setValue("CMD_STATUS","true");
	delete mgr;

	msg = new KonoeLogMessage(" analysis end ",0);
	log->send( msg->getLogMsg(), 256 );
	delete msg;
//	delete ana;

	sleep(1);

	return 0;

}


void AnalysisProcess::catchSignal( KInt signal ){

	delete handler;

	flag = OFF;
	cout << " catch signal !! " << endl;

	KChar mode[256];
	
	command_process->send("ready",256);
	command_process->receive(mode,256);

	if(strcmp(mode,"init") == 0 )
		ana_mode = INIT;
	else if(strcmp(mode,"begin") == 0 )
		ana_mode = BEGIN; 
	else if(strcmp(mode,"end") == 0 )
		ana_mode = END;
	else{
		ana_mode = UNKNOWN;
	}

	cout << " analysis mode is " << ana_mode << endl;

	handler = new KonoeSignalHandler( SIGINT , this );
	handler->enable();

}

