//====================================================================
/*

	DefaultSectionAnalyzer.cc

	Version 0.2.0	14-May-1998	H. Sakamoto

*/
//====================================================================

#include	"DefaultSectionAnalyzer.hh"

DefaultSectionAnalyzer::DefaultSectionAnalyzer( KInt psection,
		KInt ptablesize, KInt ptag )
	: KonoeSectionAnalyzer( psection ) {

	rawdatavalue = new RawDataset( ptablesize, ptag );

}

KInt	DefaultSectionAnalyzer::clear( ) {

	return rawdatavalue -> clear( );

}

KInt	DefaultSectionAnalyzer::analyze( KonoeDataSection * section ) {

	KonoeDataSegment	* segment;
	KonoeDataElement	* element;

	section -> reset( );
	while( segment = section -> next( ) ) {
	    segment -> reset( );
	    while( element = segment -> next( ) ) {
		rawdatavalue -> add( section -> getID( ),
			segment -> getID( ), element );
	    }
	}
	return 0;
}

KonoePhysicalValue	* DefaultSectionAnalyzer::getPhysicalValue( ) {

	return ( KonoePhysicalValue * ) rawdatavalue;

}
