//===================================================================
/*

	RawDataset.cc

	Version 0.6.0	22-Aug-2000	T. Matuo

*/
//===================================================================

#include	"RawDataset.hh"

const KChar	* RawDataset::dataNameList[ ] = {
	"Section ID", "Segment ID", "Subaddress", "Data",
	"CsI_ID","Scinti_ID" };

RawDataset::RawDataset( KInt ptablesize, KInt ptag )
	: KonoePhysicalValue( ptag ) {

	list = new KonoeList<KonoeDataMultiplet>( ptablesize );
//!!! In this implementation, this order is very important.
	specifier = new KonoeMultipletDescriptor( MULTIPLET_SIZE );

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SECTION_ID_INDEX ] ) );
	section_id_index = SECTION_ID_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SEGMENT_ID_INDEX ] ) );
	segment_id_index = SEGMENT_ID_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SUBADDRESS_INDEX ] ) );
	subaddress_index = SUBADDRESS_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ DATA_INDEX ] ) );
	data_index = DATA_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ CSI_DETECTOR_ID ] ) );
	csi_detector_id  = CSI_DETECTOR_ID;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SC_DETECTOR_ID ] ) );
	sc_detector_id  = SC_DETECTOR_ID;

}

KInt	RawDataset::clear( ) {

	return list -> clear( );

}

KInt	RawDataset::reset( ) {

	list -> reset( );
	return 0;
}

KInt	RawDataset::getDataCount( ) {

	list -> reset( );
	return list -> getCount( );

}

KonoeDataMultiplet	* RawDataset::next( ) {

	return list -> next( );

}

KInt	RawDataset::add( KInt sectionid, KInt segmentid,
		KonoeDataElement * element ) {

	KonoeDataMultiplet	* multiplet;
	KInt 	id;

	multiplet = new KonoeDataMultiplet( specifier );
	multiplet -> setValue( section_id_index, sectionid );
	multiplet -> setValue( segment_id_index, segmentid );
	multiplet -> setValue( subaddress_index, element -> getAddress( ) );
	multiplet -> setValue( data_index,
			KFloat( * ( KInt * ) element -> getStore( ) ) );
	if(sectionid == 1||sectionid == 2){
		id = segmentid*8 + element -> getAddress( );
		multiplet -> setValue( csi_detector_id,id);
		multiplet -> setValue( sc_detector_id,-1);
	}
	else if(sectionid == 3 || sectionid == 4 ){
		id = element -> getAddress( );
		multiplet -> setValue( csi_detector_id,-1);
		multiplet -> setValue( sc_detector_id, id );
	}
	else{
		multiplet -> setValue( csi_detector_id, -1);
		multiplet -> setValue( sc_detector_id, -1);
	}
	return list -> add( multiplet );

}
