//===================================================================
/*

	RawDataset.hh

	Version 0.2.0	14-May-1998	H. Sakamoto

*/
//===================================================================

#ifndef	__RAWDATASET_HH
#define	__RAWDATASET_HH

#include	<analysis/KonoePhysicalValue.hh>
#include	<analysis/KonoeDataElement.hh>
#include	<analysis/KonoeMultipletDescriptor.hh>

class	RawDataset	: public KonoePhysicalValue {

public :
	enum	{	MAX_MULTIPLETS = 1024	};
	enum	DATA_INDEX_	{
			SECTION_ID_INDEX,
			SEGMENT_ID_INDEX,
			SUBADDRESS_INDEX,
			DATA_INDEX,
			CSI_DETECTOR_ID,
			SC_DETECTOR_ID,
			MULTIPLET_SIZE		};

protected :
	KonoeList<KonoeDataMultiplet>	* list;
	KonoeMultipletDescriptor	* specifier;
	KInt	section_id_index;
	KInt	segment_id_index;
	KInt	subaddress_index;
	KInt	data_index;
	KInt	csi_detector_id;
	KInt 	sc_detector_id;
public :
	RawDataset( KInt ptablesize, KInt tag );
	KInt	clear( );
	KInt	reset( );
	KInt	getDataCount( );
	KonoeDataMultiplet	* next( );
	KonoeMultipletDescriptor	* getDescriptor( )
		{	return specifier;	}
	KInt	add( KInt sectionid, KInt segmentid, KonoeDataElement * e );
	static	const KChar	* dataNameList[ MULTIPLET_SIZE ];
};

#endif
