//=================================================
//        demo.hh 
//
//         Version 0.6.0	22-Aug-2000	T.Matuo
//
//=================================================

#ifndef __DEMO_HH_
#define	__DEMO_HH_


#include <analysis/Konoe1DHistogram.hh>
#include <analysis/Konoe2DHistogram.hh>
#include <analysis/KonoeDataRecordCM.hh>
#include <analysis/KonoeDataAnalyzer.hh>
#include <analysis/KonoeDataRecord.hh>
#include <analysis/KonoeFillDataExtractor.hh>
#include <analysis/KonoeFillData.hh>
#include <analysis/KonoeHistoFillerList.hh>
#include <analysis/KonoeHistogramFiller.hh>
#include <analysis/KonoeDefaultSectionAnalyzer.hh>
#include <analysis/KonoeLinearDataScale.hh>


#include <system/KonoeServerSocket.hh>
#include <system/KonoeOutputObjSocket.hh>
#include <system/KonoeInputObjSocket.hh>
#include <system/KonoeFDSet.hh>
#include <system/KonoeFDClient.hh>
#include <system/KonoeOutputObjFile.hh>
#include <analysis/KonoeDetectorList.hh>
#include <analysis/KonoeDetector.hh>
#include <analysis/KonoeDataAddressSet.hh>
#include <analysis/KonoeTDCCalibrator.hh>
#include <analysis/KonoeHitDataset.hh>
#include <analysis/KonoeBoxGeometry.hh>

#include "Extractor_1d.hh"
#include "DefaultSectionAnalyzer.hh"

#include <string.h>
#include <stdlib.h>

enum {
        GENERAL_SECTION,
        CSI_TDC_SECTION,
        CSI_ADC_SECTION,
        S_TDC_SECTION,
        S_ADC_SECTION,
        REG_SECTION,
        N_SECTION
};

enum {
        TDC_CHANNEL     = 8,
        ADC_CHANNEL     = 16,
        REG_CHANNEL     = 1,
        GENE_CHANNEL    = 2,
	CSI_TDC		= 4,
	CSI_ADC		= 2
};

enum {
	CSI 	 	= 25,
	SCIN		= 8,
	NUM_2D		= 3 
};

enum {
	DAQ_PORT	= 12341,
	UI_PORT		= 12342,
	ED_PORT		= 12343
};

const KInt  BUFFER_SIZE = 256;

class Demo {
protected:
	Konoe2DHistogram		* c_tdc_x_count_histo;
	Konoe2DHistogram		* c_adc_x_count_histo;
	Konoe2DHistogram		* sc_tdc_x_count_histo;
	Konoe2DHistogram		* sc_adc_x_count_histo;
	Konoe1DHistogram		* csi_tdc_histogram[CSI];
	Konoe1DHistogram		* csi_adc_histogram[CSI];
	Konoe1DHistogram		* s_tdc_histogram[SCIN];
	Konoe1DHistogram		* s_adc_histogram[SCIN];
	Extractor_1d			* csi_tdc_1d_extractor;
	Extractor_1d			* csi_adc_1d_extractor;
	KonoeFillDataExtractor		* csi_tdc_2d_extractor;
	KonoeFillDataExtractor		* csi_adc_2d_extractor;
	Extractor_1d			* sc_tdc_1d_extractor;
	Extractor_1d			* sc_adc_1d_extractor;
	KonoeHistoFillerList		* filler_list;
	KonoeDataAnalyzer		* analyzer;
	KonoeDataAnalyzer		* hit_dataanalyzer;
	DefaultSectionAnalyzer		* csi_tdc_analyzer;
	DefaultSectionAnalyzer		* csi_adc_analyzer;
	DefaultSectionAnalyzer		* s_tdc_analyzer;
	DefaultSectionAnalyzer		* s_adc_analyzer;
	DefaultSectionAnalyzer		* reg_analyzer;
	DefaultSectionAnalyzer		* general_analyzer;
	KonoeDataRecordCM		* datarecord_cm;

	KonoeServerSocket		* daq_server;
	KonoeServerSocket		* ui_server;
	KonoeServerSocket		* ed_server;
	KonoeInputObjSocket		* daq_socket;
	KonoeOutputObjSocket		* ui_socket;
	KonoeOutputObjSocket		* ed_socket;
	KonoeFDSet			* readfds;
	KonoeOutputObjFile		* file;




public:

	Demo();
	~Demo();
	KInt go();
	KInt outtoui(KChar* buffer );
};

#endif

