//=================================================================================
/*

	hist_dumper.cc

	11-Sep-2000	Y. Shimizu

*/
//=================================================================================
#include	<system/KonoeInputObjFile.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<analysis/KonoePhysicalValueCM.hh>
#include	<analysis/Konoe1DHistogram.hh>
#include	<analysis/KonoeLinearDataScale.hh>

int main( int argc, char** argv){
	if( argc != 2 ){
		cerr << " ./objtest <objfile> " << endl;
		exit(8);
	}

	argv++;

	KonoeInputObjFile * ofile;
	Konoe1DHistogram  * hist;

	ofile = new KonoeInputObjFile(*argv);
	
	KonoeHistogramCM     * h_cm;
	KonoePhysicalValueCM * p_cm;

	h_cm = new KonoeHistogramCM;
	p_cm = new KonoePhysicalValueCM;
	
	ofile->installCM( h_cm );
	ofile->installCM( p_cm );

	hist = ( Konoe1DHistogram *) ofile->get( );

	if( hist == 0 ){
		cerr << " ofile->get( ) error "  <<  endl;
		exit(8);
	}

	hist->dump(cout);

	return (0);

}
		
	
