// $Id: DemoAction.hh,v 1.5 2000/11/14 11:54:18 iwai Exp $
// ==================================================================
//  DemoAction.hh
//  01-September-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __DEMOACTION_HH
#define __DEMOACTION_HH

// -----------------------------------------------
//  KONOE header files
// -----------------------------------------------
#include <KonoePrimitives.hh>
#include <system/KonoeOutputObjSocket.hh>
#include <system/KonoeClientSocket.hh>

class DemoStatus;
class DemoModule;

class DemoAction {
private:
  // DAQ actions(command)                status   
  // ----------------------------------------------------
  void begin();                   // [init] => [busy]
  void pause();                   // [busy] => [idle]
  void resume();                  // [idle] => [busy]
  void end();                     // [idle] => [init]
  void shutdown();                // [init] => [dead]

  DemoStatus* status;
  DemoModule* module;

  KChar* anaHost;
  KInt anaPort;
  KonoeClientSocket * csocket ;
  KonoeOutputObjSocket* outputSocket;


public:
  DemoAction();
  DemoAction(KChar* host_name, KInt port_number);
  ~DemoAction();

  // utilities
  void executeCommand(KChar* str);
};

#endif
