// $Id: DemoModule.hh,v 1.3 2000/11/14 11:54:18 iwai Exp $
// ==================================================================
//  DemoModule.hh
//  03-September-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __DEMOMODULE_HH
#define __DEMOMODULE_HH
#include <KonoePrimitives.hh>
#include <daq/KonoeSoftwareCrate.hh>
#include <daq/KonoeSimTDCModule.hh>
#include <daq/KonoeSimADCModule.hh>
#include <daq/KonoeSoftCounter.hh>
#include <daq/KonoeReadoutList.hh>

class DemoModule {
private:
  KonoeSoftwareCrate* crate;
  KonoeReadoutList* readoutList;

  // modules
  KonoeSoftCounter* runNumber;
  KonoeSoftCounter* eventNumber;
  KonoeSimTDCModule* tdc8chCsI[4];
  KonoeSimADCModule* adc16chCsI[2];
  KonoeSimTDCModule* tdc8chScinti;
  KonoeSimADCModule* adc8chScinti;
  KonoeSimADCModule* interruptRegister;

  // These are called from only installModule().
  // Thus, private and const member.
  void generate();

public:
  // default constructor
  DemoModule();
  // destructor
  ~DemoModule();

  // copy constructor and assignment operator
  DemoModule(const DemoModule& right);
  KBool operator==(const DemoModule& right) const;
  KBool operator!=(const DemoModule& right) const;
  const DemoModule& operator=(const DemoModule& right);

  // utilities
  // This method calls generateModule(), generateCrate().
  // And then, install some modules to crate, create ReadoutList.
  // I think this method should be called main().
  void install();
  inline void update() { crate -> update(); }

  // set/get methods
  // This method should be called main() when data is read.
  inline KonoeReadoutList* getReadoutList() const { return readoutList; }
  inline const KonoeSoftwareCrate* getCrate() const { return crate; }
};

#endif
