// $Id: DemoNameSpace.cc,v 1.5 2000/11/14 11:54:18 iwai Exp $
// ==================================================================
//  DemoNameSpace.cc
//  01-September-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
// native header files
#include <iostream.h>
#include <string.h>

// KONOE general header files
#include <system/KonoeHostSystem.hh>
#include <system/KonoeSignalHandler.hh>
#include <system/KonoeNetworkNameSpaceManager.hh>
#include <system/KonoeNameSpaceTable.hh>
#include <system/KonoeNameSpaceValue.hh>

// user defined header files
#include "DemoNameSpace.hh"
#include "DemoStatus.hh"
#include "DemoAction.hh"

DemoNameSpace::DemoNameSpace()
{

  table = new KonoeNameSpaceTable();
  value = table -> getValue("MASTER_HOST");

  if ( value ) {
    masterHost = (KChar*)*value;
    manager = new KonoeNetworkNameSpaceManager(masterHost);
  } else {
    cerr << "[daq] <MASTER_HOST> is not defined " << endl
	 << "[daq] This process is going to abort ..." << endl;
    KonoeHostSystem::exit(0);
  }

  command_process = new KonoeUDPClientSocket( masterHost , 50005 );

  handler = new KonoeSignalHandler(SIGINT, this);
  handler -> enable();

  //action = new DemoAction();
  //status = new DemoStatus();
}

DemoNameSpace::~DemoNameSpace()
{
  if ( handler ) {
    handler -> disable();
    delete handler;
  }    
  if ( manager ) delete manager;
  if ( table ) delete table;
  if ( action ) delete action;
}

void DemoNameSpace::catchSignal(KInt signal)
{
//   cout << "[daq] called DemoNameSpace::catchSignal()" << endl;
//   if ( status -> getStatus() == 0 )
//     cout << "[daq] status is boot" << endl;
//   if ( status -> getStatus() == 1 )
//     cout << "[daq] status is init" << endl;
//   if ( status -> getStatus() == 2 )
//     cout << "[daq] status is busy" << endl;
//   if ( status -> getStatus() == 3 )
//     cout << "[daq] status is init" << endl;
//   if ( status -> getStatus() == 4 )
//     cout << "[daq] status is dead" << endl;
//   if ( status -> getCommand() == 0 )
//     cout << "[daq] command is unknown" << endl;
//   if ( status -> getCommand() == 1 )
//     cout << "[daq] command is begin" << endl;
//   if ( status -> getCommand() == 2 )
//     cout << "[daq] command is pause" << endl;
//   if ( status -> getCommand() == 3 )
//     cout << "[daq] command is resume" << endl;
//   if ( status -> getCommand() == 4 )
//     cout << "[daq] command is end" << endl;
//   if ( status -> getCommand() == 5 )
//     cout << "[daq] command is shutdown" << endl;
//   if ( status -> getCommandStatus() == 0 )
//     cout << "[daq] command status is false" << endl;
//   if ( status -> getCommandStatus() == 1 )
//     cout << "[daq] command status is true" << endl;

  KChar daq_cmd[256];
  
  command_process->send("ready",256);
  command_process->receive(daq_cmd,256);

  if ( status -> isValidCommand(daq_cmd) ) {
    manager -> setValue("CMD_STATUS", "true");
    status -> setCommandStatus(KTrue);

    if ( (strcmp(daq_cmd, "begin") == 0) )
      status -> setCommand(DemoStatus::begin);
    else if ( (strcmp(daq_cmd, "pause") == 0) )
      status -> setCommand(DemoStatus::pause);
    else if ( (strcmp(daq_cmd, "resume") == 0) )
      status -> setCommand(DemoStatus::resume);
    else if ( (strcmp(daq_cmd, "end") == 0) )
      status -> setCommand(DemoStatus::end);
    else if ( (strcmp(daq_cmd, "shutdown") == 0) )
      status -> setCommand(DemoStatus::shutdown);
    else
      status -> setCommand(DemoStatus::unknown);

  } else {
    manager -> setValue("CMD_STATUS", "false");
    status -> setCommandStatus(KFalse);
  }
  return;
}
