// $Id: DemoSlaveDaemon.cc,v 1.4 2000/11/14 11:54:18 iwai Exp $
// ==================================================================
//  DemoSlaveDaemon.cc
//  01-September-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#include "DemoSlaveDaemon.hh"
#include <system/KonoeNameSpaceTable.hh>
#include <system/KonoeNameSpaceValue.hh>
#include <system/KonoeHostSystem.hh>
#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <sys/wait.h>
#include <unistd.h>

DemoSlaveDaemon::DemoSlaveDaemon(KChar* master)
{
  KChar buffer[256];
  KonoeNameSpaceValue* value;

  ked = new KonoeExecutorDaemon;

  // create NameSpace for master host 
  masterHost = new KonoeNetworkNameSpaceManager(master);
  masterHost -> setValue("MASTER_HOST", master);
  delete masterHost;

  // create NameSpace for daemon port 
  daemonPort = new KonoeNetworkNameSpaceManager(master);
  sprintf( buffer, "%d", ked -> getPort() );
  daemonPort -> setValue("EXECUTE_DAEMON_PORT", buffer);
  delete daemonPort;

  hostname = new KChar[HOSTNAMELENGTH];

  if ( KonoeHostSystem::getHostName(hostname, HOSTNAMELENGTH) < 0 ) {
    cerr << "[system] can't get hostname" << endl;
    strcpy(hostname, " unknwon host");
  }
  cout << "[system] hostname " << hostname << " ";


  // create NameSpace for slave host 
  slaveHost = new KonoeNetworkNameSpaceManager(master);
  slaveHost -> getTable();
  if ( value = (slaveHost->getTable()) -> getValue("SLAVE_HOST") )
    slaveHost -> addValue("SLAVE_HOST", hostname);
  else 
    slaveHost -> setValue("SLAVE_HOST", hostname);
  delete slaveHost;

  commandStatus = new KonoeNetworkNameSpaceManager(master);
  // CMD_STATUS has "true" or "false"
  commandStatus -> getTable();
  commandStatus -> setValue("CMD_STATUS", "empty");
  delete commandStatus;

  daqStatus = new KonoeNetworkNameSpaceManager(master);
  // DAQ_STATUS has one of the "boot" "idle" "init" "busy" "dead"
  daqStatus -> getTable();
  daqStatus -> setValue("DAQ_STATUS", "empty");
  delete daqStatus;

}

KInt DemoSlaveDaemon::go()
{
  KChar buffer[256];

  if ( fork() == 0 ) ked -> go();
  else wait(0);

  return (0);
}
