// $Id: DemoStatus.cc,v 1.5 2000/11/14 11:54:18 iwai Exp $
// ==================================================================
//  DemoStatus.cc
//  01-September-2000'
//  Yasunobu Sakamoto [yasube@hep.sc.niigata-u.ac.jp]
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
// native header files
#include <iostream.h>

#include <KonoePrimitives.hh>
#include <system/KonoeNameSpaceTable.hh>
#include <system/KonoeNameSpaceValue.hh>

// user defined header files
#include "DemoStatus.hh"

DemoStatus::Status DemoStatus::daqStatus = DemoStatus::boot;
DemoStatus::Command DemoStatus::daqCommand = DemoStatus::unknown;
KBool DemoStatus::daqCommandStatus = KFalse;

KInt DemoStatus::initialize(const DemoStatus::Status status)
{
  if ( daqStatus == boot && status != boot ) {
    daqStatus = status;
    return (1);
  } else {
    return (0);
  }
}

KInt DemoStatus::finalize()
{
  if ( daqStatus != boot ) {
    daqStatus = boot;
    return (1);
  } else {
    return (0);
  }
}

void DemoStatus::showStatus()
{
  if ( daqStatus == boot )
    cout << "[daq] boot" << endl;
  else if ( daqStatus == init )
    cout << "[daq] init" << endl;
  else if ( daqStatus == busy )
    cout << "[daq] busy" << endl;
  else if ( daqStatus == idle )
    cout << "[daq] idle" << endl;
  else if ( daqStatus == dead )
    cout << "[daq] dead" << endl;
  else
    cout << "[daq] unknown status" << endl;
  return;
}

KBool DemoStatus::isInstanciate() 
{ 
  return ( daqStatus != boot ); 
}

KBool DemoStatus::isValidCommand(KChar* str)
{
  KonoeNameSpaceTable* table = new KonoeNameSpaceTable();
  KonoeNameSpaceValue* value = table -> getValue("DAQ_STATUS");
  char* daq_status;
  daq_status = (KChar*)*value;

  switch ( daqStatus ) {
  case init:
    if ( ( strcmp(daq_status, "init") == 0 ) &&
         ( (strcmp(str, "begin") == 0) || (strcmp(str, "shutdown") == 0) ) )
      return KTrue;
    else 
      return KFalse;
  case busy:
    if ( ( strcmp(daq_status, "busy") == 0 ) &&
         (strcmp(str, "begin") == 0) || (strcmp(str, "pause") == 0) ||
	 (strcmp(str, "resume") == 0) )
      return KTrue;
    else 
      return KFalse;
  case idle:
    if ( ( strcmp(daq_status, "idle") == 0 ) && 
	 ( strcmp(str, "resume") == 0 ) || ( strcmp(str, "end") == 0 ) )
      return KTrue;
    else 
      return KFalse;
  case boot:
  case dead:
  default:
    return KFalse;
  }
}
