// $Id: DemoStatus.hh,v 1.3 2000/11/14 11:54:19 iwai Exp $
// ==================================================================
//  DemoStatus.hh
//  01-September-2000'
//  Yasunobu Sakamoto [yasube@hep.sc.niigata-u.ac.jp]
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __DEMOSTATUS_HH
#define __DEMOSTATUS_HH
#include <KonoePrimitives.hh>

class DemoStatus {
public:
  enum Status { boot, init, busy, idle, dead };
  enum Command { unknown, begin, pause, resume, end, shutdown };

private:
  static Status daqStatus;
  static Command daqCommand;
  static KBool daqCommandStatus;
  
  static KInt initialize(const DemoStatus::Status status = DemoStatus::init);
  static KInt finalize();

public:
  DemoStatus(const DemoStatus::Status status = DemoStatus::init)
  { initialize(status); }
  ~DemoStatus() { finalize(); }

  // utilities
  static void showStatus();

  // These functions may be called from other classes.
  static KBool isValidCommand(KChar* str);
  static KBool isInstanciate();

  // set/get member functions
  inline static void setStatus(DemoStatus::Status status) 
  { daqStatus = status; }
  inline static Status getStatus() 
  { return daqStatus; }
  inline static void setCommand(DemoStatus::Command command) 
  { daqCommand = command; }
  inline static Command getCommand() 
  { return daqCommand; }
  inline static void setCommandStatus(KBool flag) 
  { daqCommandStatus = flag; }
  inline static KBool getCommandStatus()
  { return daqCommandStatus; }
};

#endif
