//===========================================================================
/*
	DemoSDaemon.cc

	25-Aug-2000	Y. Shimizu

	slave-host daemon

*/
//===========================================================================
#include	"DemoSDaemon.hh"
#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeLogMessage.hh>
#include	<system/KonoeLogMessenger.hh>
#include	<system/KonoeHostSystem.hh>
#include	<iostream.h>
#include	<string.h>
#include	<stdio.h>
#include	<sys/wait.h>
#include	<unistd.h>

DemoSDaemon::DemoSDaemon( KChar* master ){

	KChar buffer[256];
	KonoeNameSpaceValue * value;

	ked   = new KonoeExecutorDaemon;

	log = new KonoeLogMessenger( master );

	manager1 = new KonoeNetworkNameSpaceManager( master );
	manager1->setValue("MASTER_HOST",master );
	delete manager1;

	manager2 = new KonoeNetworkNameSpaceManager( master );
	sprintf(buffer,"%d",ked->getPort( ) );
	manager2->setValue("EXECUTE_DAEMON_PORT",buffer);
	delete manager2;

	hostname = new KChar[HOSTNAMELENGTH];

	if( KonoeHostSystem::getHostName( hostname, HOSTNAMELENGTH ) < 0 ) {
		cerr << " can't get hostname " << endl;
		strcpy(hostname, "unknwon host");
	}
	
	cout << " hostname " << hostname;

	manager3 = new KonoeNetworkNameSpaceManager( master );

	manager3->getTable();
	if( value = (  manager3->getTable( ) )->getValue("SLAVE_HOST") )
	  manager3->addValue("SLAVE_HOST",hostname);
	else 
	  manager3->setValue("SLAVE_HOST",hostname);

	delete manager3;

	manager4 = new KonoeNetworkNameSpaceManager( master );
	manager4->setValue("DAQ_STATUS","empty");
	delete manager4;
}

KInt DemoSDaemon::go( ){
	KChar buffer[256];

	if( fork()==0 ){
	msg1 = new KonoeLogMessage("execute daemon Start",1) ;
	//log->send( msg1 );
	log->send( msg1->getLogMsg( ), 256  );
	log->receive( buffer , 256 );
	delete msg1;
	ked->go( );
	}
	msg2 = new KonoeLogMessage("execute daemon's wait(0) ",1) ;
	//log->send( msg2 );
	log->send( msg2->getLogMsg( ), 256  );
	log->receive( buffer , 256 );
	delete msg2;

	wait( 0 );

	return (0);
}
