//=============================================
/*
	controler.cc

	11-Sep-2000	Y. Shimizu

*/
//=============================================
#include"DemoControler.hh"
#include"DemoStateChecker.hh"
#include<system/KonoeNameSpaceTable.hh>
#include<system/KonoeNameSpaceValue.hh>
#include<system/KonoeNetworkNameSpaceManager.hh>
#include<string.h>
#include<unistd.h>

int main(){

  DemoControler *controler;
  DemoStateChecker * checker;

  KonoeNameSpaceTable * table;
  KonoeNameSpaceValue * value;
  KonoeNetworkNameSpaceManager * mgrinit;
  KonoeNetworkNameSpaceManager * mgrbusy;
  KonoeNetworkNameSpaceManager * mgridle;
  KonoeNetworkNameSpaceManager * mgrdead;

  KChar * masterhost ;

  KChar * daq_host;
  KChar * ana_host;

  KInt ana_pid;
  KInt daq_pid;

  KChar command[256];
 
  table = new KonoeNameSpaceTable();
////////  masterhost extracting /////////////////////
 
  value = table->getValue("MASTER_HOST");
  if( value == 0 ){
     cout << " MASTER_HOST is not defined!!" << endl;
     exit(0);
  }
  else{
     masterhost = (KChar*)*value;
  }
////////   DAQ  host , pid  extracting //////////////////


  value = table->getValue("DAQ_HOST");
  if( value == 0 ){
     cout << " DAQ_HOST is not defined!!" << endl;
     daq_host = 0;
  }
  else{
     daq_host = (KChar*)*value;
     cout << "daq_host is " << daq_host << endl;
  }
  
  value = table->getValue("DAQ_PID");
  if( value == 0 ){
     cout << " DAQ_PID is not defined!!" << endl;
     daq_pid = 0;
  }
  else {
     daq_pid = (KInt)*value;
     cout << "daq_pid is " << daq_pid  << endl;
  }

////////   ANALYSIS  host , pid  extracting //////////////////

  value = table->getValue("ANA_HOST");
  if( value == 0 ){
     cout << " ANA_HOST is not defined!!" << endl;
     ana_host = 0;
  }
  else {
     ana_host = (KChar*)*value;
     cout << "ana_host is " << ana_host << endl;
  }
  
  value = table->getValue("ANA_PID");
  if( value == 0 ){
     cout << " ANA_PID is not defined!!" << endl;
     ana_pid = 0;
  }
  else {
     ana_pid = (KInt)*value;
     cout << "ana_pid is " << ana_pid  << endl;
  }

///////////////// ENTRY //////////////////////////////////////

  controler = new DemoControler;
  if(ana_host)
    controler->entry(ana_host);
  if(daq_host)
    controler->entry(daq_host);

  checker = new DemoStateChecker;

  mgrinit = new KonoeNetworkNameSpaceManager( masterhost ); 
  mgrinit->setValue("DAQ_STATUS","init");
  delete mgrinit;

  while(1){


    cout << "process ??>" ;
    cin.getline(command,256);
    
    checker->init();

    if( strcmp(command, "ana") == 0 ){
      cout << "COMMAND?? >";
      cin.getline(command,256);
      controler->control(command,ana_pid,ana_host);
    }
    else if( strcmp( command, "daq" ) == 0 ){
      cout << "COMMAND?? >";
      cin.getline(command,256);
      if( strcmp(command,"begin") == 0){ 
        controler->control(command,daq_pid,daq_host);
        mgrbusy = new KonoeNetworkNameSpaceManager( masterhost ); 
        mgrbusy->setValue("DAQ_STATUS","busy");
        delete mgrbusy;
      }
      else if( strcmp(command,"pause") == 0){ 
        controler->control(command,daq_pid,daq_host);
        mgridle = new KonoeNetworkNameSpaceManager( masterhost ); 
        mgridle->setValue("DAQ_STATUS","idle");
        delete mgridle;
      }
      else if( strcmp(command,"resume") == 0){ 
        controler->control(command,daq_pid,daq_host);
        mgridle = new KonoeNetworkNameSpaceManager( masterhost ); 
        mgridle->setValue("DAQ_STATUS","idle");
        delete mgridle;
      }
      else if( strcmp(command,"end") == 0){ 
        controler->control(command,daq_pid,daq_host);
        mgrinit = new KonoeNetworkNameSpaceManager( masterhost ); 
        mgrinit->setValue("DAQ_STATUS","init");
        delete mgrinit;
      }
      else if( strcmp(command,"shutdown") == 0){ 
        controler->control(command,daq_pid,daq_host);
        mgrdead = new KonoeNetworkNameSpaceManager( masterhost ); 
        mgrdead->setValue("DAQ_STATUS","dead");
        delete mgrdead;
      }
      else { 
        cout << "what?"<< endl;
      }

    }

    sleep(1);

    cout << " status " << checker->check() << endl;
  
    
  }

  delete controler;
  delete checker;
  
  return (0);
	
}
