//==================================================================
/*
	daq_control

	25-Aug-2000	Y. Shimizu

*/
//==================================================================
#include<iostream.h>
#include<stdlib.h>
#include<unistd.h>
#include<system/KonoeNetworkNameSpaceManager.hh>
#include<system/KonoeNameSpaceTable.hh>
#include<system/KonoeNameSpaceValue.hh>
#include<system/KonoeUDPServerSocket.hh>
#include<system/KonoeSignalSender.hh>
#include<system/KonoeLogMessage.hh>
#include<system/KonoeLogMessenger.hh>
#include<system/KonoeHostSystem.hh>

int main(int argc , char** argv){
  
  KChar buffer[256];
  KChar ans[256];
  KChar * masterhost;
  
  KChar * daq_host;
  KInt  daq_pid;

  KChar* state;

  KonoeNetworkNameSpaceManager * mgr;
  KonoeUDPServerSocket	       * command_sender;
  KonoeNameSpaceTable * table;
  KonoeNameSpaceValue * value;
  KonoeLogMessage	    * message;
  KonoeLogMessenger   * log;
  KonoeSignalSender   * killer;

  command_sender = new KonoeUDPServerSocket( 50005 );  
  
  table = new KonoeNameSpaceTable( );
  
  value = table->getValue("MASTER_HOST");
  if( value == 0 ){
    cerr << " MASTER_HOST is not set " << endl;
    KonoeHostSystem::exit(0);
  }

  masterhost = (KChar*)*value;
    
  value = table->getValue("DAQ_HOST");
  if( value == 0 ){
    KonoeHostSystem::exit(0);
  }
  daq_host = (KChar*)*value;
  cout << " daq_host is " << daq_host << endl;
    
  value = table->getValue("DAQ_PID");
  if( value == 0 ){
    KonoeHostSystem::exit(0);
  }
  daq_pid = (KInt)*value;
  cout << " daq_pid is " << daq_pid << endl;
  
  message = new KonoeLogMessage("daq_control - start",1);
  log = new KonoeLogMessenger( masterhost );
  log->send( message->getLogMsg(), 256 );
  log->receive( buffer , 256 );
  

  
  while(1){

    killer = new KonoeSignalSender;
    killer->entry( daq_host );	

    mgr = new KonoeNetworkNameSpaceManager( masterhost );

    mgr->setValue("CMD_STATUS","empty");
    delete mgr ;

    cout << "COMMAND ?> ";
    cin.getline( buffer , 256 );

    killer->kill( daq_host, daq_pid ,SIGINT  );
    command_sender->receive( ans , 256 );

    command_sender->reply( buffer , 256 );

    value = table->getValue("CMD_STATUS");
    if( value == 0 ){
      KonoeHostSystem::exit(0);
    }
    state = (KChar*)*value;

    cout << " CMD_STATUS is " << state << endl;

    delete killer;  
  }

  delete log ;
  delete message;
  delete command_sender;
  delete table;

  
  return (0);
  
}

