//=============================================
/*
	controler.cc

	11-Sep-2000	Y. Shimizu

*/
//=============================================
#include<system/KonoeSignalSender.hh>
#include<system/KonoeNameSpaceTable.hh>
#include<system/KonoeNameSpaceValue.hh>
#include<string.h>
#include<unistd.h>

int main(){

  KonoeSignalSender   * killer;

  KonoeNameSpaceTable * table;
  KonoeNameSpaceValue * value;

  KChar * daq_host;
  KChar * ana_host;

  KInt ana_pid;
  KInt daq_pid;
  
////////   DAQ  host , pid  extracting //////////////////

  table = new KonoeNameSpaceTable();

  value = table->getValue("DAQ_HOST");
  if( value == 0 ){
     cout << " DAQ_HOST is not defined!!" << endl;
     daq_host = 0;
  }
  else{
     daq_host = (KChar*)*value;
     cout << "daq_host is " << daq_host << endl;
  }
  
  value = table->getValue("DAQ_PID");
  if( value == 0 ){
     cout << " DAQ_PID is not defined!!" << endl;
  }
  else {
     daq_pid = (KInt)*value;
     cout << "daq_pid is " << daq_pid  << endl;
  }

////////   ANALYSIS  host , pid  extracting //////////////////

  value = table->getValue("ANA_HOST");
  if( value == 0 ){
     cout << " ANA_HOST is not defined!!" << endl;
     ana_host = 0;
  }
  else {
     ana_host = (KChar*)*value;
     cout << "ana_host is " << ana_host << endl;
  }
  
  value = table->getValue("ANA_PID");
  if( value == 0 ){
     cout << " ANA_PID is not defined!!" << endl;
  }
  else {
     ana_pid = (KInt)*value;
     cout << "ana_pid is " << ana_pid  << endl;
  }

///////////////// ENTRY //////////////////////////////////////

  killer = new KonoeSignalSender;
  if( ana_host != 0)
    killer->entry(ana_host);
  if( daq_host != 0)
    killer->entry(daq_host);

  if( daq_host != 0)
    killer->kill( daq_host , daq_pid , SIGKILL);
  if( ana_host != 0)
    killer->kill( ana_host , ana_pid , SIGKILL);

  delete killer;
  
  return (0);
	
}
