//============================================================================
/*
	ksigd.cc	signal daemon

	25-Aug-2000	Y. Shimizu

*/
//============================================================================
#include	<system/KonoeSignalDaemon.hh>
#include	<system/KonoeLogMessage.hh>
#include	<system/KonoeLogMessenger.hh>
#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeNetworkNameSpaceManager.hh>
#include	<system/KonoeHostSystem.hh>
#include	<stdio.h>

int main( int argc , char** argv ){
	KChar* 	masterhost;
	KChar	buffer[256]; 	
	KChar	sig_port[32];
	KonoeNameSpaceTable	* table;
	KonoeNameSpaceValue	* value;
	KonoeSignalDaemon	* ksigd;
	KonoeLogMessage		* message;
	KonoeLogMessenger	* log;
	KonoeNetworkNameSpaceManager * mgr;

	table = new KonoeNameSpaceTable( );

	value = table->getValue("MASTER_HOST");
	if( value == 0 ){
		cerr << " MASTER_HOST is not set " << endl;
		KonoeHostSystem::exit(0);
	}
	masterhost = (KChar*)*value;

	mgr = new KonoeNetworkNameSpaceManager(masterhost); 	
	log = new KonoeLogMessenger( masterhost );

	ksigd = new KonoeSignalDaemon;
	message = new KonoeLogMessage("signal daemon go",1);
	log = new KonoeLogMessenger( masterhost );
	log->send( message->getLogMsg( ), 256 );
	log->receive( buffer, 256 );

	sprintf(sig_port,"%d",ksigd->getPort());
	mgr->setValue("SIGNAL_DAEMON_PORT",sig_port);

	delete mgr;
	delete table;
	ksigd->go();

	return (0);

}
		
	
