// $Id: adc.cc,v 1.3 2000/11/13 12:56:39 iwai Exp $
// ==================================================================
//  adc.cc
//  23-October-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#include "modules.h"

#include <daq/KonoeCAMACCrate.hh>
#include <daq/KonoeCAMACADC.hh>
#include <daq/KonoeReadoutList.hh>
#include <system/KonoeOutputObjFile.hh>

int main(int argc, char** argv)
{
  // --------------------------------------------------------------
  //  constants for KonoeDataRecord 
  static const KInt N_SECTION(1);
  static const KInt RECORDTYPE(1000);
  static const KInt N_SEGMENT(1);
  static const KInt N_ELEMENT(16);
  static const KInt SECTIONTYPE(10000);
  static const KInt SEGMENTTYPE(20000);
  // --------------------------------------------------------------

  
  KonoeCAMACCrate* cc7700 = new KonoeCAMACCrate( NODENAME, CCID );
  KonoeCAMACADC* adc 
    = new KonoeCAMACADC( cc7700, ADC );

  KonoeReadoutList* readoutList 
    = new KonoeReadoutList( N_SECTION, RECORDTYPE );
  
  KonoeReadoutSection* section;
  KonoeReadoutSegment* segment;
  KonoeReadoutItem* element;

  section = new KonoeReadoutSection(N_SEGMENT, SECTIONTYPE);
  readoutList -> add(section);
  segment = new KonoeReadoutSegment(N_ELEMENT, SEGMENTTYPE);
  section -> add(segment);

  for ( int i = 0; i < N_ELEMENT; i++ ) {
    element = new KonoeReadoutItem( adc, i );
    segment -> add(element);
  }

  cc7700 -> install(adc);  
  KonoeOutputObjFile* file = new KonoeOutputObjFile("adc.dat");  

  for ( int i = 0; i < 10; i++ ) {
    KonoeDataRecord* data = readoutList -> read();
#ifdef DEBUG
    data -> dump( cout );
#endif
    file -> put( data );
    cc7700 -> clear();
    delete data;
  }

  delete file;
  delete cc7700;

  return (0);
}
