// $Id: camac.cc,v 1.6 2000/11/12 20:58:12 iwai Exp $
// ============================================================
//  camac.cc
//  23-October-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ============================================================
#include "modules.h"

#include <daq/KonoeCAMACCrate.hh>
#include <daq/KonoeCAMACSwitchRegister.hh>
#include <daq/KonoeReadoutList.hh>
#include <system/KonoeOutputObjFile.hh>

int main(int argc, char** argv)
{
  // --------------------------------------------------------------
  //  constants for KonoeDataRecord 
  static const KInt N_SECTION(0x01000000);
  static const KInt RECORDTYPE(1000);
  static const KInt N_SEGMENT(1);
  static const KInt SECTIONTYPE(200);
  static const KInt SEGMENTTYPE(100);
  // --------------------------------------------------------------

  KonoeCAMACCrate* cc7700 = new KonoeCAMACCrate( NODENAME, CCID );
  KonoeCAMACSwitchRegister* sw 
    = new KonoeCAMACSwitchRegister( cc7700, SWITCHREGISTER );

  KonoeReadoutList* readoutList 
    = new KonoeReadoutList( N_SECTION, RECORDTYPE );
  KonoeReadoutSection* section 
    = new KonoeReadoutSection( N_SEGMENT, SECTIONTYPE );
  KonoeReadoutSegment* segment 
    = new KonoeReadoutSegment( sw, SEGMENTTYPE );
  section -> add( segment );
  readoutList -> add(section);

  cc7700 -> install(sw);
  KonoeOutputObjFile* file = new KonoeOutputObjFile("camac.dat");
  KonoeDataRecord* data;

  for ( int i = 0; i < N_SECTION; i++ ) {  
    sw -> write( (KUInt)i );
    data = readoutList -> read();
#ifdef DEBUG
    data -> dump( cout );
#endif
    file -> put( data );
    delete data;
  }

  // do NOT delete sw ! It's called destructor in cc7700.
  delete file;
  delete cc7700;

  return (0);
}
