// $Id: timer.cc,v 1.4 2001/01/01 09:50:10 iwai Exp $
// ==================================================================
//  timer.cc
//  23-October-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#include <daq/KonoeReadoutList.hh>
#include <daq/KonoeOptionalNumberModule.hh>
#include <daq/KonoeTimerModule.hh>
#include <daq/KonoeClockModule.hh>
#include <system/KonoeOutputObjFile.hh>
#include <unistd.h>

int main(int argc, char** argv)
{
  // --------------------------------------------------------------
  //  constants for KonoeDataRecord 
  static const KInt N_SECTION(1);
  static const KInt RECORDTYPE(1000);
  static const KInt N_SEGMENT(1);
  static const KInt N_ELEMENT(4);
  static const KInt SECTIONTYPE(200);
  static const KInt SEGMENTTYPE(100);
  static const KInt NUMBER1(0);
  static const KInt NUMBER2(4);
  static const KInt TIMER(15);
  static const KInt CLOCK(100);
  // --------------------------------------------------------------
  

  KonoeOptionalNumberModule* number1 = new KonoeOptionalNumberModule(1815);
  KonoeOptionalNumberModule* number2 = new KonoeOptionalNumberModule(1025);
  KonoeTimerModule* timer = new KonoeTimerModule();
  KonoeClockModule* clock = new KonoeClockModule();

  KonoeReadoutSection* section;
  KonoeReadoutSegment* segment;
  KonoeReadoutItem* element;

  KonoeReadoutList* readoutList 
    = new KonoeReadoutList( N_SECTION, RECORDTYPE );

  section = new KonoeReadoutSection( N_SEGMENT, SECTIONTYPE );
  readoutList -> add(section);
  segment = new KonoeReadoutSegment( N_ELEMENT, SEGMENTTYPE );
  section -> add(segment);
  element = new KonoeReadoutItem( number1 , NUMBER1 );
  segment -> add(element);
  element = new KonoeReadoutItem( number2, NUMBER2 );
  segment -> add(element);
  element = new KonoeReadoutItem( timer, TIMER );
  segment -> add(element);
  element = new KonoeReadoutItem( clock, CLOCK );
  segment -> add(element);

  KonoeOutputObjFile* file = new KonoeOutputObjFile("timer.dat");

  for ( int i = 0; i < 5; i++ ) {
    number1 -> update();
    number2 -> update();
    timer -> update();
    clock -> update();
    KonoeDataRecord* data = readoutList -> read();
#ifdef DEBUG
    data -> dump(cout);
#endif
    file -> put(data);
    delete data;
    sleep(i);
  }

  return (0);
}
