//
//   control process
//      for message demo
//
//   9.Mar.'98   H.Kamata
//
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>
#include <KonoePrimitives.hh>
#include <system/KonoeMessageClientSocket.hh>

#include "getParameter.hh"

// define host name
static KChar host_name[] = {"ngtsun2.hep.sc.niigata-u.ac.jp"};

KInt displayPrompt( void )
{
    // set error command
    KChar errorCommand[10] = {"error"};

    // display control prompt
    cout << " --- KONOE control process for message demo ---" << endl;
    cout << endl;
    cout << " 1) Run Begin" << endl;
    cout << " 2) Run End" << endl;
    cout << " 3) Suspend" << endl;
    cout << " 4) Resume" << endl;
    cout << " 5) Clear" << endl;
    cout << endl;
    cout << " Please enter menu number (1 - 5 / q) : ";

    KChar command[10];
    cin >> command;

    // check command
    if ( strcmp(command, "1") == 0 || strcmp(command, "2") == 0 |
	 strcmp(command, "3") == 0 || strcmp(command, "4") == 0 |
	 strcmp(command, "5") == 0 )
	return( atoi(command) );
    else if ( strcmp(command, "q") == 0 )
	exit( 0 );
    else if ( strlen(command) <= 1 )
	return( -1 );
    else {
	cout << "command = " << command << endl;
	return( -1 );
    }
};

// send command
KInt sendCommand( KInt port, KChar *send_message, KInt size ) {
    // make socket
    // host_name -> static parameter
    KonoeMessageClientSocket *socket;
    socket = new KonoeMessageClientSocket( host_name, port );

    // send command
    KInt byte = socket -> write( (void *)send_message, size );
    
    // delete socket
    delete socket;
    
    return( 1 );
};


main(KInt argc, KChar *argv[]) {

    // get parameter
    KInt controlPort;
    KInt sendPort;
    KInt receivePort;
    KChar sendAddress[100];
    KChar receiveAddress[100];
    getParameter( &controlPort, &sendPort, &receivePort, 
                  sendAddress, receiveAddress );
    
    while ( 1 ) { // while No.1
	// display prompt and accept user command
	KInt command = displayPrompt( );
	
	// error 
	if ( command == -1 ) {
	    cout << endl;
	    cout << " >>> Unknown Command!! <<<\a" << endl;
	    cout << endl;
	    continue;
	}
	
	// accept command
	else {
	    // Run Begin
	    if ( command == 1 ) {
		KChar send_message[2] = {"B"};
		sendCommand( controlPort, send_message, sizeof(send_message) );
	    }
	    // Run End
	    else if ( command == 2 ) {
		KChar send_message[2] = {"E"};
		sendCommand( controlPort, send_message, sizeof(send_message) );
	    }
	    // Suspend
	    else if ( command == 3 ) {
		KChar send_message[2] = {"S"};
		sendCommand( controlPort, send_message, sizeof(send_message) );
	    }
	    // Resume
	    else if ( command == 4 ) {
		KChar send_message[2] = {"R"};
		sendCommand( controlPort, send_message, sizeof(send_message) );
	    }
	    // Clear
	    else if ( command == 5 ) {
		KChar send_message[2] = {"C"};
		sendCommand( controlPort, send_message, sizeof(send_message) );
	    }
	    // other case
	    else {
		cerr << "Unexpected error." << endl;
		exit( 0 );
	    }
	    
	} //-- end accept command
    } //-- end while No.1
    
}

