//
//   slave deamon process
//     for message demo
//
//   9.Mar.'98   H.Kamata
//
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <KonoePrimitives.hh>
#include <system/KonoeMessageServerSocket.hh>
#include <system/KonoeMessageCM.hh>
#include <system/KonoeMessage.hh>

#include "getParameter.hh"

//#if     KCC_HAS_SIG_PF
//#else
//typedef void    SIG_FUNC_TYP    (int);
//typedef SIG_FUNC_TYP*   SIG_PF;
//#endif

// catch signal from child process
void catchSignal(KInt sig, KInt code, \
		 struct sigcontext *scp, KChar *addr) {
    wait( 0 );
};

main(KInt argc, KChar *argv[]) {

    // get parameter
    KInt controlPort;
    KInt sendPort;
    KInt receivePort;
    KChar sendAddress[100];
    KChar receiveAddress[100];
    getParameter( &controlPort, &sendPort, &receivePort,
                  sendAddress, receiveAddress );

    // make socket and install category manager
    KonoeMessageServerSocket *socket;
    KonoeMessageCM *message_cm;
    if ( strcmp(argv[1], "send") == 0 )
	socket = new KonoeMessageServerSocket( sendPort );
    else if ( strcmp(argv[1], "receive") == 0 )
	socket = new KonoeMessageServerSocket( receivePort );
    else {
	cout << "usage : % slaveDeamon send" << endl;
	cout << "        % slaveDeamon receive" << endl;
	exit( 0 );
    }
    message_cm = new KonoeMessageCM( );
    socket -> installCM( message_cm );

    KonoeMessage *message;

    // define child process ID
    KInt pid;
	
    while ( 1 ) {
	// wait connection
	while( (socket -> waitConnection( )) == -1 );

	// get and dump message
	message = ( KonoeMessage * ) socket -> get( 0 );
	message -> dump( cout );

	socket -> closeConnection( );

	// --- Run Begin ---
	if ( strcmp(message -> getMessage( ), "runbegin") == 0 ) {
	    // fork child process
	    if ( (pid = fork( )) == 0 ) {
		execl( message -> getProcessName( ), 0 );
		kill( getppid( ), SIGCHLD );
		exit( 0 );
	    } //-- end child process
	    
	    // parent process
	    else {
		signal( SIGCHLD, ( SIG_PF ) catchSignal );
	    }
	} 

	// --- Run End ---
	else if ( strcmp(message -> getMessage( ), "runend") == 0 ) {
	    kill( pid, SIGTERM );
	} 

	// --- Suspend ---
	else if ( strcmp(message -> getMessage( ), "suspend") == 0 ) {
	    cout << "Suspend message arrived." << endl;
	}

	// --- Resume ---
	else if ( strcmp(message -> getMessage( ), "resume") == 0 ) {
	    cout << "Resume message arrived." << endl;
	}

	// --- Clear ---
	else if ( strcmp(message -> getMessage( ), "clear") == 0 ) {
	    // kill process
	    kill( pid, SIGTERM );
	    // fork child process
	    if ( (pid = fork( )) == 0 ) {
		execl( message -> getProcessName( ), 0 );
		kill( getppid( ), SIGCHLD );
		exit( 0 );
	    } //-- end child process
	    
	    // parent process
	    else {
		signal( SIGCHLD, ( SIG_PF ) catchSignal );
	    }

	}

    } // end while ( 1 )

    // delete message category manager and message
    delete message_cm;
    delete message;

}
