#include <system/KonoeInputObjFile.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeHistogramCM.hh>
#include <analysis/KonoePhysicalValueCM.hh>

#include "exConstants.hh"

int main( int argc, char** argv, char** envv )
{
  KonoeInputObjFile* ifile
    = new KonoeInputObjFile( kFileNameForHistogram );

  KonoeHistogramCM* histCM = new KonoeHistogramCM();
  KonoePhysicalValueCM* physCM = new KonoePhysicalValueCM();
  ifile -> installCM( histCM );
  ifile -> installCM( physCM );

  Konoe1DHistogram* histogram = 0;

  while ( ( histogram = (Konoe1DHistogram*)( ifile -> get() ) ) ) {
    histogram -> dump( cout );
    delete histogram;
  }

  delete ifile;
  delete histCM;
  delete physCM;

  return( 0 );
}
