#include <system/KonoeOutputObjFile.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeFillData.hh>
#include <analysis/KonoeLinearDataScale.hh>

#include "exConstants.hh"

int main( int argc, char** argv, char** envv )
{
  KonoeOutputObjFile* ofile =
    new KonoeOutputObjFile( kFileNameForHistogram );

  KonoeLinearDataScale* scale
    = new KonoeLinearDataScale( 0.0, 1000.0, 100 );

  Konoe1DHistogram* histogram
    = new Konoe1DHistogram( scale );


  for ( KInt i = 0; i < kNumberOfEvents; i ++ ) {
    histogram -> fill( new KonoeFillData( 100.0 * i ) );
    histogram -> dump( cout );
    ofile -> put( histogram );
  }

  delete histogram;
  delete ofile;

  return( 0 );
}
