#include "ADCValue.hh"

ADCValue::ADCValue(KInt ptag, KInt number_of_channels, KInt number_of_modules) 
: KonoePhysicalValue(ptag), 
  counter(0), 
  data_count(number_of_channels * number_of_modules) {

    elements = new KonoePhysIntElement[data_count];
}

ADCValue::~ADCValue() {
    delete[] elements;
}

KInt ADCValue::getDataCount( ) { return data_count; }

void ADCValue::reset() { counter = 0; }

KonoePhysValueElement *ADCValue::next() { 
    if (counter >= data_count) return 0;
    counter++;
    return elements + counter;
}

void ADCValue::dump(ostream &os)
{
    for (int i = 0; i < data_count; i++) {
	elements[i].dump(os);
    }
}
