#include "CalorieMeterSectionAnalyzer.hh"

CalorieMeterSectionAnalyzer::CalorieMeterSectionAnalyzer(KInt ptag) 
: KonoeSectionAnalyzer(ptag) {
    adc_value = new ADCValue(ptag, 16, 64);
}

CalorieMeterSectionAnalyzer::~CalorieMeterSectionAnalyzer() {
    delete adc_value;
}

KInt CalorieMeterSectionAnalyzer::analyze(KonoeDataSection *section) {
    KonoeDataSegment *segment;
    KonoeDataElement *element;
    KInt address;
    KInt value;

    adc_value->reset();
    section->reset();

    int count = 0;
    while (segment = section->next()) {
	segment->reset();
	while (element = segment->next()) {
	    address = (segment->getID() - 3) * 16 + element->getAddress();
	    value = *((KInt*)(element->getStore()));

	    KonoePhysIntElement* e = (KonoePhysIntElement*)(adc_value->next());
	    if (e != 0) e->set(address, value);
	    count++;
#if 0
static int i = 0;
cerr << "Cal " << i++ << ": " << address << ", " << value << endl;
// OK
#endif
	}
    }

    adc_value->setDataCount(count);

    return 0;
}

KonoePhysicalValue *CalorieMeterSectionAnalyzer::getPhysicalValue() {
    adc_value->reset();
    return adc_value;
}
