
#include <analysis/KonoePhysValueScale.hh>
#include <analysis/KonoePhysValueElement.hh>
#include <analysis/KonoeFillData.hh>
#include <analysis/KonoeFillDataExtractor.hh>


DemoC1Extractor::DemoC1Extractor(KInt pmanner)
: KonoeFillDataExtractor(pmanner)
{
}

DemoC1Extractor::~DemoC1Extractor( )
{
}

KInt DemoC1Extractor::getDataCount(KonoePhysicalValue *value)
{
    return value->getDataCount();
}

KonoeFillData *DemoC1Extractor::next(KonoePhysicalValue *value)
{
    KonoePhysValueElement *element = value->next();
    if (element == 0) {
	return 0;
    }

    KFloat x = 0, y = 0, z = 0;
    switch (manner) {
      case MNR_C1ENERGY:
	x = element->getInteger();
	break;
      case MNR_C1POSITION:
	Channel2XY(element->getAddress(), x, y);
	break;
      default:
	cerr << "No manner to extract physical value" << endl;;
    }

    return new KonoeFillData(x, y, z);
}

KInt DemoC1Extractor::Channel2XY(KInt Channel, KFloat &x, KFloat &y)
{
    x = (KFloat) (Channel / 32);
    y = (KFloat) (Channel % 32);

    return 0;
}
