#include "GeneralSectionAnalyzer.hh"

GeneralSectionAnalyzer::GeneralSectionAnalyzer(KInt ptag) : KonoeSectionAnalyzer(ptag) {
    event_info_value = new EventInfoValue(ptag);
}

GeneralSectionAnalyzer::~GeneralSectionAnalyzer() {
    delete event_info_value;
}

KInt GeneralSectionAnalyzer::analyze(KonoeDataSection *section) {
    KonoeDataSegment *segment;
    KonoeDataElement *element;
    KInt address;
    KInt value;

    event_info_value->reset();
    section->reset();
    while (segment = section->next()) {
	segment->reset();
	while (element = segment->next()) {
	    address = element->getAddress();
	    value = *((KInt*)(element->getStore()));
	    ((KonoePhysIntElement*)(event_info_value->next()))->set(address, value);
	}
    }

    return 0;
}

KonoePhysicalValue *GeneralSectionAnalyzer::getPhysicalValue() {
    event_info_value->reset();
    return event_info_value;
}
