#include "ScintilatorSectionAnalyzer.hh"

ScintilatorSectionAnalyzer::ScintilatorSectionAnalyzer(KInt ptag) 
: KonoeSectionAnalyzer(ptag) {
    adc_value = new ADCValue(ptag, 16, 4);
}

ScintilatorSectionAnalyzer::~ScintilatorSectionAnalyzer() {
    delete adc_value;
}

KInt ScintilatorSectionAnalyzer::analyze(KonoeDataSection *section) {
    KonoeDataSegment *segment;
    KonoeDataElement *element;
    KInt address;
    KInt value;

    adc_value->reset();
    section->reset();
    while (segment = section->next()) {
	segment->reset();
	while (element = segment->next()) {
	    address = element->getAddress();
	    value = *((KInt*)(element->getStore()));
	    ((KonoePhysIntElement*)(adc_value->next()))->set(address, value);
	}
    }

    return 0;
}

KonoePhysicalValue *ScintilatorSectionAnalyzer::getPhysicalValue() {
    adc_value->reset();
    return adc_value;
}
