//========================================================
/*
	HVStatus.java
	
	Version 0.0.1	22-Jun-1998	H. Sakamoto

*/
//========================================================

import	java.awt.*;
import	konoe.ui.meter.*;

public class HVStatus extends Panel {

  public static final int OFFLINE = 0;
  public static final int CONNECTING = 1;
  public static final int STANDBY = 2;
  public static final int ASCENDING = 3;
  public static final int SHOULDER = 4;
  public static final int ATTACKING = 5;
  public static final int PEAK = 6;
  public static final int WITHDRAWING = 7;
  public static final int DESCENDING = 8;
  public static final int DISCONNECTING = 9;
  public static final int TRIPPED = 10;
  public static final int N_STATES = 11;
  
  public static final String [] statenames = {
  	"Offline", "Connecting", "Standby", "Ascending",
  	"Shoulder", "Attacking", "Peak", "Withdrawing",
  	"Descending", "Disconnecting",
  	"Tripped" };
  	
  public static Color [] statecolors = {
  	Color.gray, Color.lightGray, Color.cyan, Color.green,
  	Color.yellow, Color.orange, Color.red, Color.orange,
  	Color.green, Color.lightGray };

  Label		namelabel;
  Label		statelabel;
  String	name;
  int		state;
  KonoeAlarmMeterPanel	voltagemeter;
  KonoeAlarmMeterPanel	currentmeter;

  public HVStatus( String name ) {
    System.out.println( "HVStatus = " + name );
    this.name = name;
    namelabel = new Label( name );
    add( namelabel );
    state = OFFLINE;
    statelabel = new Label( "             " );
    add( statelabel );
    voltagemeter = new KonoeAlarmMeterPanel( null, 240, 30,
    	120.0, 6 );
    voltagemeter.setLimit( -10, 90 );
    add( voltagemeter );
    currentmeter = new KonoeAlarmMeterPanel( null, 240, 30,
    	120.0, 6 );
    currentmeter.setLimit( -10, 90 );
    add( currentmeter );
  }
  
  public void setState( int newstate ) {
  
    if( newstate < 0 || newstate >= N_STATES ) {
      System.out.println( "Invalid state = " + newstate );
      return;
    }
    state = newstate;
    statelabel.setBackground( statecolors[ newstate ] );
    statelabel.setText( statenames[ newstate ] );
  }
  
  public void setValues( double voltage, double current ) {
  
    voltagemeter.setValue( voltage );
    currentmeter.setValue( current );

  }

}