//====================================================================
/*

	DemoAnalysis.hh

	Version 0.4.1	 02-Aug-1999	Sanshiro Enomoto

*/
//====================================================================


#ifndef	__DEMOANALYSIS_HH
#define	__DEMOANALYSIS_HH


#include <system/KonoeInputObjectStream.hh>
#include <system/KonoeOutputObjectStream.hh>

#include <analysis/KonoeDataRecordCM.hh>
#include <analysis/KonoeHistogramCM.hh>
#include <analysis/KonoeDataRecord.hh>
#include <analysis/KonoeDataAnalyzer.hh>
#include <analysis/KonoeSectionAnalyzer.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/Konoe2DHistogram.hh>
#include <analysis/KonoeDataScale.hh>
#include <analysis/KonoeFillDataExtractor.hh>
#include <analysis/KonoeHistogramFiller.hh>
#include <analysis/KonoeHistoFillerList.hh>


class DemoAnalysis {

public:
    DemoAnalysis( KonoeInputObjectStream * is_source );
    ~DemoAnalysis( );    
    KInt go( );
    KInt installHistogram( KonoeHistogramBase * , int) {return 0;}
    
protected:
    KonoeDataAnalyzer *analyzer;
    
    Konoe1DHistogram *cal_q_energy_histogram;
    Konoe2DHistogram *cal_t_position_histogram;
    KonoeHistoFillerList *filler_list;

    KonoeInputObjectStream *input_stream;
    //KonoeOutputObjectStream *output_stream;

    KonoeDataRecordCM *data_record_cm;
    KonoeHistogramCM *histogram_cm;
};


#endif
