//===================================================================
/*

	DemoAnalysisOrderly.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida and S. Enomoto

*/
//===================================================================

#ifndef	__DEMOANALYSISORDERLY_HH
#define	__DEMOANALYSISORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	"DemoAnalysis.hh"
#include	<ui/KonoeCommandProcessor.hh>

class	DemoAnalysisOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = 0x00910000 + 0x200 };
	enum	{	CMD_CREATE,
			CMD_GO,
			CMD_INSTALLHISTOGRAM,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_ISSOURCE,
			ARG_CREATE_OSVIEWER,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_GO	};
	enum	{	ARG_INSTALLHISTOGRAM_HISTBASE,
			ARG_INSTALLHISTOGRAM_HISTID,
			N_ARG_INSTALLHISTOGRAM	};

protected :
	static const KChar	* classname;

	DemoAnalysis	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	GoUnit	: public KonoeCommandProcessor {
	public :
		GoUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	InstallHistogramUnit	: public KonoeCommandProcessor {
	public :
		InstallHistogramUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	DemoAnalysisOrderly( KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};

#endif








