//====================================================================
/*

	DemoCommand.cc

	Version 0.0.1	 04-Aug-1998	S. Nishida and S. Enomoto

*/
//====================================================================

#include	<ui/KonoeCommander.hh>
#include	<ui/KonoeCommandSource.hh>
#include        <iostream.h>
#include	<stdlib.h>
#include 	<string.h>
#include	"DemoCommander.hh"


class DemoCommand	{

protected :

	KonoeCommander	* commander;
	KonoeCommandSource *command_source;

public :
	DemoCommand( KonoeCommander *pcommander, KonoeCommandSource * psource );
	int	go( );

};

DemoCommand::DemoCommand( KonoeCommander *pcommander, KonoeCommandSource * psource ) {

	commander = pcommander;
	command_source = psource;

}

int	DemoCommand::go( ) {

	while( 1 ) {

	  static KChar command_string[256];
	  strcpy(command_string, command_source -> getNext( ));
	  cerr << "[" << command_string << "]" << endl;

	  if ( commander -> dispatch( command_string, cout ) < 0 )
	    break;

	}
	return 0;

}


int	main( int argc, char ** argv ) {

	KonoeCommander * commander = new DemoCommander( "democommander" );
	KonoeCommandSource * command_source;

	if (argc < 2) {
	  cerr << "Usage: " << endl;
	  cerr << "  DemoCommand term" << endl;
	  cerr << "  DemoCommand file 'filename'" << endl;
	  cerr << "  DemoCommand server 'port'" << endl;
	  cerr << "  DemoCommand client 'hostname' 'port'" << endl;
	  cerr << endl;

	  return 0;
        }

	if (strncmp(argv[1], "term", 4) == 0) {
	  command_source = new KonoeTerminalCommandSource( );
	}

	else if (strncmp(argv[1], "file", 4) == 0) {
	  KChar *filename = argv[2];
	  command_source = new KonoeFileCommandSource( filename );
	}

	else if (strncmp(argv[1], "server", 6) == 0) {
	  KInt port = atoi(argv[2]);
	  command_source = new KonoeServerSocketCommandSource( port );
	}

	else if (strncmp(argv[1], "client", 6) == 0) {
	  KChar *hostname = argv[2];
	  KInt port = atoi(argv[3]);
	  command_source = new KonoeClientSocketCommandSource( hostname, port );
	}


	DemoCommand	democommand(commander, command_source);

	return democommand.go( );

}
