//==================================================================
/*

	DemoEventGenerator.hh

	Version 0.3.0	 5-Jun-1998	Sanshiro Enomoto

*/
//==================================================================


#ifndef __DEMO_EVENT_GENERATOR_H
#define __DEMO_EVENT_GENERATOR_H

#include <analysis/KonoeEventGenerator.hh>


#define LIGHT_SPEED 0.3         /* [m/ns] */
#define PION_MASS 0.1396        /* [GeV]  */
#define PROTON_MASS 0.9383      /* [GeV]  */
#define CHARGE_UNIT 1.602e-19   /* [C]    */

#define INCIDENT_ENERGY 1.0            /* [GeV] */
#define MAGNETIC_FIELD_INTENSITY 0.1   /* [Tm]  */
#define MAGNETIC_FIELD_POSITION 2.0    /* [m]   */
#define DETECTER_END_POSITION 4.0      /* [m]   */
#define ACCEPTANCE 0.24                /* [rad] */


class DemoEventVertex;
class ThinMagneticField;

class DemoEventGenerator: public KonoeEventGenerator {
  public:
    DemoEventGenerator();
    virtual ~DemoEventGenerator();
    virtual KonoeSimEvent *generate();
  private:
    void generateTrackSegment(
        KonoeTrackSegment *tracksegment[4], 
        Konoe3Vector pion_momentum, Konoe3Vector proton_momentum
    );
    DemoEventVertex *vertex;
    ThinMagneticField *magnetic_field;
};

#endif
