//==================================================================
/*

	DemoSource.hh

	Version 0.2.0	30-Apr-1998	H. Sakamoto
	Version 0.3.0    5-Jun-1998     D. Takagi
	Version 0.4.0	 4-Aug-1999	T. Yamashita
*/
//==================================================================

#ifndef __DemoSource_hh
#define __DemoSource_hh 1

#include	<daq/KonoeSimCrate.hh>
#include	<daq/KonoeSimTOFTDC.hh>
#include        <daq/KonoeSimADCDigitizer.hh>
#include	<daq/KonoeSimTDCModule.hh>
#include	<daq/KonoeSimADCModule.hh>

#include	<daq/KonoeReadoutList.hh>
#include	<daq/KonoeSoftwareCrate.hh>
#include	<daq/KonoeSoftCounter.hh>
#include	<daq/KonoeCrateList.hh>
#include	<daq/KonoeTimerXaction.hh>
#include	<analysis/KonoeDataRecordCM.hh>
#include	<analysis/KonoeGeometryCM.hh>
#include	<analysis/KonoeBoxGeometry.hh>
#include	<system/KonoeOutputObjFile.hh>
#include        <system/KonoeServerSocket.hh>
#include        <system/KonoeOutputObjSocket.hh>

#include	<iostream.h>
#include 	<stdio.h>
#include        "DemoEventGenerator.hh"
#include	"DemoSimulator.hh"

class	DemoSource	{
public :
	enum	{ N_EVENT = 20 };
	enum	{ TDC_GAIN = 10, ADC_GAIN =  1000 };

protected :
	KonoeDetectorList	* detectorList;
	KonoeDetector	        * scifi[8];
	KonoeDetector	        * cal;

	KonoeSoftwareCrate	* softcrate;
	KonoeSoftCounter	* eventnumber;

	KonoeCrateList		* cratelist;
	KonoeReadoutList	* readoutlist;

	DemoEventGenerator	* generator;

	DemoSimulator   	* simulator;

	KonoeTimerXaction	* transaction;
        KonoeOutputObjFile      * outputfile;
	KonoeOutputObjectStream* dataout;

public :
	DemoSource( KonoeOutputObjectStream* );
	~DemoSource( );
	KInt	go();


};

#endif
