//===================================================================
/*

	DemoSourceOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Nishida and S. Enomoto

*/
//===================================================================

#ifndef	__DEMOSOURCEORDERLY_HH
#define	__DEMOSOURCEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	"DemoSource.hh"
#include	<ui/KonoeCommandProcessor.hh>

class	DemoSourceOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = 0x00910000 + 0x100 };
	enum	{	CMD_CREATE,
			CMD_GO,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_OSANALYSIS,
			ARG_CREATE_OSVIEWER,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_GO	};

protected :
	static const KChar	* classname;

	DemoSource	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	GoUnit	: public KonoeCommandProcessor {
	public :
		GoUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	DemoSourceOrderly( KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};

#endif








