/*
	CRDAQAction.cc

	Version 0.0.0	19-Aug-2002	mor
*/

#include <unistd.h>
#include <stdlib.h>

#include "CRDAQAction.hh"
#include "CRDAQNameSpace.hh"

#include <system/KonoeHostSystem.hh>

void CRDAQAction::begin() const
{
  CRDAQNameSpace* ns = new CRDAQNameSpace();
  ns -> setDaqStatus( "busy" );
  delete ns;

  cout << "[DAQ] CRDAQAction::begin is called" << endl;
  cout << "[DAQ] status change, STATDBY -> BUSY" << endl;

  return;
}

void CRDAQAction::pause() const
{
  CRDAQNameSpace* ns = new CRDAQNameSpace();
  ns -> setDaqStatus( "idle" );
  delete ns;

  cout << "[DAQ] CRDAQAction::pause() is called" << endl;
  cout << "[DAQ] status change, BUSY -> IDLE" << endl;

  return;
}

void CRDAQAction::resume() const
{
  CRDAQNameSpace* ns = new CRDAQNameSpace();
  ns -> setDaqStatus( "busy" );
  delete ns;

  cout << "[DAQ] CRDAQAction::resume() is called" << endl;
  cout << "[DAQ] status change, IDLE -> BUSY" << endl;

  return;
}

void CRDAQAction::end() const
{
  CRDAQNameSpace* ns = new CRDAQNameSpace();
  ns -> setDaqStatus( "standby" );
  delete ns;

  cout << "[DAQ] CRDAQAction::end() is called" << endl;
  cout << "[DAQ] status change, IDLE -> STANDBY" << endl;

  return;
}

void CRDAQAction::shutdown() const
{
  CRDAQNameSpace* ns = new CRDAQNameSpace();
  ns -> setDaqStatus( "none" );
  ns -> setDaqPid( -1 );
  delete ns;

  cout << "[DAQ] CRDAQAction::shutdown() is called" << endl;
  cout << "[DAQ] status change, STANDBY -> NONE" << endl;

  return;
}

void CRDAQAction::lastAction()
{
  cout << "[DAQ] CRDAQAction::lastAction() is called" << endl;
  cout << "[DAQ] process is going to shutdown after 1 second." << endl;

  sleep(1);
  KonoeHostSystem::exit(-1);
}
