/*
	CRDAQModuleConstruction.hh

	Version 0.0.0	19-Aug-2002	mor
*/

#ifndef __CRDAQMODULECONSTRUCTION_HH
#define __CRDAQMODULECONSTRUCTION_HH

#include <daq/KonoeCAMACCrate.hh>
#include <daq/KonoeCAMACADC.hh>
#include <daq/KonoeCAMACTDC.hh>
#include <daq/KonoeCAMACInterruptRegister.hh>
#include <daq/KonoeCAMACOutputRegister.hh>
#include <daq/KonoeCAMACScaler.hh>

#include <daq/KonoeReadoutList.hh>

#include <daq/KonoeSoftCounter.hh>
#include <daq/KonoeOptionalNumberModule.hh>
#include <daq/KonoeTimerModule.hh>
#include <daq/KonoeClockModule.hh>

#include "CRDAQNameSpace.hh"

class CRDAQModuleConstruction : public CRDAQNameSpace {
private:
  CRDAQNameSpace* ns;

  KonoeReadoutList* eventList;

  KonoeCAMACCrate* theCrate;
  KonoeCAMACADC** theADC;
  KonoeCAMACTDC** theTDC;
  KonoeCAMACInterruptRegister* theIR;
  KonoeCAMACOutputRegister* theOR;
  KonoeCAMACScaler** theScaler;

  KonoeTimerModule* theTimer;
  KonoeClockModule* theClock;
  KonoeSoftCounter* eventNumber;
  KonoeOptionalNumberModule* thePlace;
  KonoeOptionalNumberModule* tm;

  void generate();
  void install() const;
  void add( KonoeReadoutSection* aSection );
  void construct();

public:
  CRDAQModuleConstruction();
  ~CRDAQModuleConstruction();

  KonoeDataRecord* read();
  KonoeDataRecord* read_test();
  KonoeDataRecord* read_ir();

  inline void cancelLatch() const { this -> theOR -> writePulse(1); }
  inline void setI() { this -> theOR -> writeLevel(1); }
  inline void removeI() const { this -> theOR -> writeLevel(0); }

  void clear() const {;}
  void update() const;
  void initialize() const;
};

#endif
