/*
	CRDAQNameSpace.hh

	Version 0.0.0	19-Aug-2002	mor
*/

#ifndef __CRDAQNAMESPACE_HH
#define __CRDAQNAMESPACE_HH

#include <string.h>
#include <system/KonoeHostSystem.hh>
#include "CRNameSpaceExtractor.hh"
#include "CRNameSpaceSetter.hh"

class CRDAQNameSpace : public CRNameSpaceSetter,
		       public CRNameSpaceExtractor {
private:
  enum { CHAR_LENGTH = 256 };

  KInt daqPID;
  KInt daqCommandPort;
  KInt dataHubInputPort;
  KInt preDHInputPort;

  KChar masterHost[CHAR_LENGTH];
  KChar dataHubHost[CHAR_LENGTH];
  KChar preDHHost[CHAR_LENGTH];
  KChar daqStatus[CHAR_LENGTH];
  KChar daqHost[CHAR_LENGTH];

  KBool isValidItem( KChar* item );

protected:
// daq_constant
  KInt numSection;
  KInt eventRecord;

  KInt generalSecType;
  KInt generalNumSeg;
  KInt runInfoSegType;
  KInt runInfoNumEle;
  KInt timeInfoSegType;
  KInt timeInfoNumEle;

  KInt tdcSecType;
  KInt tdcNumSeg;
  KInt* tdcSegType;
  KInt* tdcNumEle;
 
  KInt adcSecType;
  KInt adcNumSeg;
  KInt* adcSegType;
  KInt* adcNumEle; 

  KInt scalerSecType;
  KInt scalerNumSeg;
  KInt* scalerSegType;
  KInt* scalerNumEle;

  KInt irNumEle;
  KInt irSegType;

  KInt daqBufferSize;
  KInt timeout;

// daq_module
  KChar nodeName[CHAR_LENGTH];

  KInt cc_Id;
  KInt* tdc;
  KInt* adc;
  KInt* scaler;
  KInt inr;
  KInt outr;

  KInt place;
  KInt timer;

  KInt adcFlag;
  KInt tdcFlag;
  KInt scalFlag;

public:
  CRDAQNameSpace();
  ~CRDAQNameSpace();

  void update();
  void timerUpdate();
  void update( KChar* item, KInt value );
  void update( KChar* item, KChar* value );
  void extract();
  void show();

  inline KInt getDaqPort() const { return (this -> daqCommandPort); }
  inline KInt getDaqPid() const { return (this -> daqPID); }
  inline KInt getDataHubPort() const { return (this -> dataHubInputPort); }
  inline KInt getPreDHPort() const { return (this -> preDHInputPort); }

  inline KInt getTime() { timerUpdate(); return (this -> timer); }

  inline KChar* getMasterHost() { return (this -> masterHost); }
  inline KChar* getDataHubHost() { return (this -> dataHubHost); }
  inline KChar* getPreDHHost() { return (this -> preDHHost); }
  inline KChar* getDaqStatus() { return (this -> daqStatus); }
  inline KChar* getDaqHost() { return (this -> daqHost); }

  inline void setDaqPid( KInt val ) { (this -> daqPID) = val; }
  inline void setDaqStatus( KChar* str ) { strcpy(this -> daqStatus, str); }
  inline void setDaqHost( KChar* str ) { strcpy(this -> daqHost, str); }

  inline void showDaqPort() const
  { cout << "DAQ_CMD_PORT = " << this -> getDaqPort() << endl; }
  inline void showDaqPid() const
  { cout << "DAQ_PID = " << this -> getDaqPid() << endl; }
  inline void showDataHubPort() const
  { cout << "DATAHUB_INPUT_PORT = " << this -> getDataHubPort() << endl; }
  inline void showPreDHPort() const
  { cout << "PRE_DH_INPUT_PORT = " << this -> getPreDHPort() << endl; }
  inline void showMasterHost()
  { cout << "MASTER_HOST = " << this -> getMasterHost() << endl; }
  inline void showDataHubHost()
  { cout << "DATAHUB_HOST = " << this -> getDataHubHost() << endl; }
  inline void showPreDHHost()
  { cout << "PRE_DH_HOST = " << this -> getPreDHHost() << endl; }
  inline void showDaqStatus()
  { cout << "DAQ_STATUS = " << this -> getDaqStatus() << endl; }
  inline void showDaqHost()
  { cout << "DAQ_HOST = " << this -> getDaqHost() << endl; }

  void showModuleConstruction();
  void showTime();
};

#endif
