/*
	CRDAQStatus.hh

	Version 0.0.0 19-Aug-2002	mor
*/

#ifndef __CRDAQSTATUS_HH
#define __CRDAQSTATUS_HH

#include <KonoePrimitives.hh>

class CRDAQStatus {
public:
  enum DAQStatus { none, standby, busy, idle };
  enum DAQCommand { unknown, begin, pause, resume, end, shutdown };

private:
  static DAQStatus DAQ_STATUS;
  static DAQCommand DAQ_COMMAND;

  static KInt initialize( const DAQStatus status = standby );
  static KInt finalize();

public:
  CRDAQStatus( const DAQStatus status = standby ) { initialize( status ); }
  ~CRDAQStatus() { finalize(); }

  static void showStatus();
  static void showCommand();

  static KBool isValidCommand( KChar* str );
  static KBool isInstanciate();

  inline static void setStatus( DAQStatus status )
  { DAQ_STATUS = status; }
  inline static DAQStatus getStatus()
  { return (DAQ_STATUS); }
  inline static void setCommand( DAQCommand command )
  { DAQ_COMMAND = command; }
  inline static DAQCommand getCommand()
  { return (DAQ_COMMAND); }
};

#endif
