/*
	CROfflineDAQMC.cc

	Version 0.0.0	26-Dec-2002	mor
*/

#include "CROfflineDAQMC.hh"
#include "CRDAQStatus.hh"

CROfflineDAQMC::CROfflineDAQMC() 
{
	eventList = new KonoeReadoutList( 2, 3000 );
	ns = new CRDAQNameSpace();

	this -> generate();
	this -> install();

	this -> construct();
}

CROfflineDAQMC::~CROfflineDAQMC()
{
	delete theCrate;

	delete tm;

	delete eventList;
}

void CROfflineDAQMC::generate()
{
	theCrate = new KonoeSoftwareCrate( 7 );
	theADC = new KonoeSimADCModule( KInt(1), KInt(1) );
//	theTDC = new KonoeSimTDCModule( KInt(1), KInt(1) );
	tm = new KonoeOptionalNumberModule();

	return;
}

void CROfflineDAQMC::install() const
{
	this -> theCrate -> install(this -> theADC);
//	this -> theCrate -> install(this -> theTDC);

	return;
}

void CROfflineDAQMC::add( KonoeReadoutSection* sec )
{
	this -> eventList -> add( sec );

	return;
}

void CROfflineDAQMC::construct()
{
	KonoeReadoutSection* sec;
	KonoeReadoutSegment* seg;
	KonoeReadoutItem* ele;

	sec = new KonoeReadoutSection( 1, KInt(0) );
	seg = new KonoeReadoutSegment( this->theADC, KInt(0) );
	sec -> add( seg );
	this -> add( sec );
/*
	sec = new KonoeReadoutSection( 1, KInt(1) );
	seg = new KonoeReadoutSegment( this->theTDC, KInt(0) );
	sec -> add( seg );
	this -> add( sec );
*/

	sec = new KonoeReadoutSection( 1, KInt(2) );
	seg = new KonoeReadoutSegment( 1, KInt(0) );
	sec -> add( seg );
	ele = new KonoeReadoutItem( this->tm, KInt(0) );
	seg -> add( ele );
	this -> add( sec );

	return;
}

KonoeDataRecord* CROfflineDAQMC::read()
{

	KonoeDataRecord* rec;
	rec = this -> eventList -> read();
	this -> update();
	return rec;
}

void CROfflineDAQMC::update() const
{
	this -> theCrate -> update();
	this -> tm -> setNumber( ns -> getTime() );
	return;
}

void CROfflineDAQMC::initialize() const
{
	this -> theCrate -> initialize();

	return;
}
