/*
	CROfflineDAQMC.hh

	Version 0.0.0	26-Dec-2002	mor
*/

#ifndef __CROFFLINEDAQMC_HH
#define __CROFFLINEDAQMC_HH

#include <daq/KonoeSoftwareCrate.hh>
#include <daq/KonoeSimADCModule.hh>
#include <daq/KonoeSimTDCModule.hh>

#include <daq/KonoeOptionalNumberModule.hh>
#include <daq/KonoeReadoutList.hh>

#include "CRDAQNameSpace.hh"

class CROfflineDAQMC {
public:
	CROfflineDAQMC();
	~CROfflineDAQMC();

	KonoeDataRecord* read();

	void clear() const;
	void update() const;
	void initialize() const;

private:
	CRDAQNameSpace* ns;

	KonoeReadoutList* eventList;

	KonoeOptionalNumberModule* tm;

	KonoeSoftwareCrate* theCrate;
	KonoeSimADCModule* theADC;
	KonoeSimTDCModule* theTDC;

	void generate();
	void install() const;
	void add( KonoeReadoutSection* sec );
	void construct(); 
};

#endif
