/*
	CRDataHub.cc

	Version 0.0.0	06-Aug-2002	mor
*/

#include <unistd.h>

#include "CRDataHub.hh"
#include <system/KonoeHostSystem.hh>
#include <system/KonoeFDSet.hh>
#include <system/KonoeFDClient.hh>

CRDataHub::CRDataHub()
{

  ns = new CRDataHubNameSpace();

  ns -> show();

  i_port = ns -> getDataHubInputPort();
  file_name = ns -> getDataHubStorageFileName();

  in_server = new KonoeObjectServerSocketBuffered( i_port );
  manager = new KonoeDataRecordCM();
  in_server -> installCM( manager );

  o_port = ns -> getDataHubOutputPort();
  out_server = new KonoeServerSocket( o_port );

  out_file = new KonoeOutputObjFileBuffered( file_name );

  out_soc = new KonoeOutputObjSocketBuffered( out_server );

  buffer_size = ns -> getDataHubBufferSize();
  buffer = new void* [ buffer_size ];
  for( KInt i=0; i<buffer_size; i++ ) {
    buffer[i] = 0;
  }

  write_address = 0;

  out_server -> setSendMode( KonoeServerSocket::SEND_TO_LAST );

}

CRDataHub::CRDataHub( KChar* in_file_name )
{
  ns = new CRDataHubNameSpace();

  ns -> show();

  file_name = ns -> getDataHubStorageFileName();

  o_port = ns -> getDataHubOutputPort();
  out_server = new KonoeServerSocket( o_port );

  in_file = new KonoeInputObjFileBuffered( in_file_name );
  manager = new KonoeDataRecordCM();
  in_file -> installCM( manager );

  out_file = new KonoeOutputObjFileBuffered( file_name );

  out_soc = new KonoeOutputObjSocketBuffered( out_server );

  buffer_size = ns -> getDataHubBufferSize();
  buffer = new void* [ buffer_size ];
  for( KInt i=0; i<buffer_size; i++ ) {
    buffer[i] = 0;
  }

  write_address = 0;

  out_server -> setSendMode( KonoeServerSocket::SEND_TO_LAST );

}


CRDataHub::~CRDataHub()
{
  delete manager;
  delete ns;
  delete in_server;
  delete out_file;
  for( KInt i=0; i<buffer_size; i++ ) {
    delete buffer[i];
  }
  delete [] buffer;
}

KInt CRDataHub::ring_counter( KInt value )
{
  while( value < 0 ) {
    value += buffer_size;
  }
  while( value >= buffer_size ) {
    value -= buffer_size;
  }
  return value;
}

void CRDataHub::get_data()
{
  rec = (KonoeDataRecord*)( in_server -> get() );

  if( rec ) {
    out_file -> put( rec );
//   rec -> dump( cout );
  }

  write_address = this -> ring_counter( write_address + 1 );

  delete (KonoeDataRecord*)buffer[ write_address ];
  buffer[ write_address ] = rec;

}

void CRDataHub::get_data_from_file()
{
  rec = (KonoeDataRecord*)( in_file -> get() );
  if( rec ) {
    out_file -> put( rec );
  }
  write_address = this -> ring_counter( write_address + 1 );

  delete (KonoeDataRecord*)buffer[ write_address ];
  buffer[ write_address ] = rec;
  return;
}

void CRDataHub::put_data()
{

  KChar* buf;
  KInt bufsize = 5;
  KChar buff[] = "neko";

  out_server -> receive( buf, bufsize );

  if( strcmp( buf, buff ) == 0 ) {
//  out_soc -> put( (KonoeDataRecord*)( buffer[ write_address ] ) );
    out_soc -> put( (KonoeDataRecord*)( buffer[ 2 ] ) );
    out_soc -> flush();
  }
}

void CRDataHub::go()
{
  while(1){

    obj_soc = in_server -> wait(0);
    if( obj_soc ) {
//    sleep(1);
    cout << "get" << endl;
    get_data();
    }

    soc_con = out_server -> wait(0);
    if( soc_con ) {
      cout << "put" << endl;
//      sleep(1);
      put_data();
    }

  }
  return;
}
