/*
	CRDataHub.hh

	Version 0.0.0	06-Aug-2002	mor
*/

#ifndef __CRDATAHUB_HH
#define __CRDATAHUB_HH

#include <string.h>
#include <stdlib.h>
#include <KonoePrimitives.hh>

#include <system/KonoeObjectServerSocketBuffered.hh>
#include <system/KonoeObjectSocketBuffered.hh>
#include <system/KonoeServerSocket.hh>
#include <system/KonoeSocketConnection.hh>
#include <system/KonoeInputObjFileBuffered.hh>
#include <system/KonoeOutputObjFileBuffered.hh>
#include <system/KonoeOutputObjSocketBuffered.hh>

#include <analysis/KonoeDataRecord.hh>
#include <analysis/KonoeDataRecordCM.hh>

#include "CRDataHubNameSpace.hh"
#include "CRDataHubDataBuffer.hh"

class CRDataHub : public CRDataHubNameSpace {
private:
  KonoeObjectServerSocketBuffered* in_server;
  KonoeObjectSocketBuffered* obj_soc;
  KonoeServerSocket* out_server;
  KonoeSocketConnection* soc_con;
  KonoeOutputObjSocketBuffered* out_soc;
  KonoeInputObjFileBuffered* in_file;
  KonoeOutputObjFileBuffered* out_file;

  CRDataHubNameSpace* ns;

  KonoeDataRecord* rec;
  KonoeDataRecordCM* manager;

  void** buffer;
  KInt write_address;
  KInt buffer_size;
  KInt data_length[ KonoeObjectServerSocketBuffered::MAX_CLIENTS ];

  KInt i_port;
  KInt o_port;
  KChar* file_name;
  KChar* in_file_name;

public:
  CRDataHub();
  CRDataHub( KChar* in_file_name );
  ~CRDataHub();

  void go();
  KInt ring_counter( KInt value );
  void get_data();
  void get_data_from_file();
  void put_data();
};

#endif
