/*
	CRDataHubNameSpace.hh

	Version 0.0.0	20-Aug-2002	mor
*/

#ifndef __CRDATAHUBNAMESPACE_HH
#define __CRDATAHUBNAMESPACE_HH

#include <string.h>
#include <system/KonoeHostSystem.hh>
#include "CRNameSpaceExtractor.hh"
#include "CRNameSpaceSetter.hh"

class CRDataHubNameSpace : public CRNameSpaceSetter,
			   public CRNameSpaceExtractor {
private:
  enum { CHAR_LENGTH = 256 };

  KChar dataHubHost[ CHAR_LENGTH ];
  KChar dataHubHost2[ CHAR_LENGTH ];
  KChar dataHubHost3[ CHAR_LENGTH ];
  KChar dataHubStatus[ CHAR_LENGTH ];
  KChar dataHub2Status[ CHAR_LENGTH ];
  KChar dataHub3Status[ CHAR_LENGTH ];
  KChar preDataHubHost[ CHAR_LENGTH ];
  KChar preDataHubStatus[ CHAR_LENGTH ];

  KInt dataHubPID;
  KInt preDataHubPID;

  KInt dataHubCommandPort;
  KInt dataHubInputPort;
  KInt dataHubInputPort2;
  KInt dataHubInputPort3;
  KInt dataHubOutputPort;
  KInt dataHub2OutputPort;
  KInt dataHub3OutputPort;
  KInt preDHInputPort;
  KInt preDHOutputPort;

protected:

  KInt flag1;
  KInt flag2;
  KInt flag3;

  KInt dataHubBufferSize;
  KChar dataHubStorageFileName[ CHAR_LENGTH ];

  inline void changeFlag1( KInt i ) { flag1 = i; }
  inline void changeFlag2( KInt i ) { flag2 = i; }
  inline void changeFlag3( KInt i ) { flag3 = i; }

public:
  CRDataHubNameSpace();
  CRDataHubNameSpace( KChar* option );
  ~CRDataHubNameSpace();

  void update();
  void extract();
  void show();
  void pre_update();
  void pre_extract();
  void pre_show();

  inline KChar* getDataHubStatus() { return (this -> dataHubStatus); }
  inline KChar* getPreDataHubStatus() { return (this -> preDataHubStatus); }
  inline KChar* getDataHubHost() { return (this -> dataHubHost); }
  inline KChar* getDataHubHost2() { return (this -> dataHubHost2); }
  inline KChar* getDataHubHost3() { return (this -> dataHubHost3); }
  inline KChar* getPreDataHubHost() { return (this -> preDataHubHost); }

  inline KInt getDataHubPid() { return (this -> dataHubPID); }
  inline KInt getPreDataHubPid() { return (this -> preDataHubPID); }
  inline KInt getDataHubCommandPort() { return (this -> dataHubCommandPort); }
  inline KInt getDataHubInputPort() { return (this -> dataHubInputPort); }
  inline KInt getDataHubInputPort2() { return (this -> dataHubInputPort2); }
  inline KInt getDataHubInputPort3() { return (this -> dataHubInputPort3); }
  inline KInt getDataHubOutputPort() { return (this -> dataHubOutputPort); }
  inline KInt getPreDHInputPort() { return (this -> preDHInputPort); }
  inline KInt getPreDHOutputPort() { return (this -> preDHOutputPort); }
  inline KInt getDataHubBufferSize() { return (this -> dataHubBufferSize); }

  inline KChar* getDataHubStorageFileName() { return (this -> dataHubStorageFileName); }

  inline void showDataHubHost()
  { cout << "DATAHUB_HOST : " << this -> getDataHubHost() << endl; }
  inline void showPreDataHubHost()
  { cout << "PREDATAHUB_HOST : " << this -> getPreDataHubHost() << endl; }
  inline void showDataHubStatus() 
  { cout << "DATAHUB_STATUS : " << this -> getDataHubStatus() << endl; }
  inline void showPreDataHubStatus() 
  { cout << "PREDATAHUB_STATUS : " << this -> getPreDataHubStatus() << endl; }
  inline void showDataHubPid() 
  { cout << "DATAHUB_PID : " << this -> getDataHubPid() << endl; }
  inline void showPreDataHubPid() 
  { cout << "PREDATAHUB_PID : " << this -> getPreDataHubPid() << endl; }
  inline void showDataHubCommandPort()
  { cout << "DATAHUB_COMMAND_PORT : " << this -> getDataHubCommandPort() << endl; }
  inline void showDataHubInputPort() 
  { cout << "DATAHUB_INPUT_PORT : " << this -> getDataHubInputPort() << endl; }
  inline void showDataHubOutputPort() 
  { cout << "DATAHUB_OUTPUT_PORT : " << this -> getDataHubOutputPort() << endl; }
  inline KChar* showDataHubStorageFileName()
  { cout << "DATAHUB_STORAGE_FILENAME : " << this -> dataHubStorageFileName << endl; }
  inline KInt showPreDHInputPort()
  { cout << "PREDATAHUB_INPUT_PORT : " << this -> getPreDHInputPort() << endl; }
  inline KInt showPreDHOutputPort()
  { cout << "PREDATAHUB_OUTPUT_PORT : " << this -> getPreDHOutputPort() << endl; }
};

#endif
