/*
	CRPreDH.cc

	Version 0.0.0	06-Aug-2002	mor
*/

#include <unistd.h>

#include "CRPreDH.hh"
#include <system/KonoeHostSystem.hh>
#include <system/KonoeFDSet.hh>
#include <system/KonoeFDClient.hh>

CRPreDH::CRPreDH()
{

  ns = new CRDataHubNameSpace( "pre" );
  ns -> pre_show();

  i_port = ns -> getPreDHInputPort();

  manager = new KonoeDataRecordCM();

  in_server = new KonoeObjectServerSocketBuffered( i_port );
  in_server -> installCM( manager );

	if( flag1 ) {
    o_port1 = ns -> getDataHubInputPort();
    strcpy( this -> o_host1, getDataHubHost() );
 	  out_soc1 = new KonoeOutputObjSocketBuffered( o_host1, o_port1 );
	}

  if( flag2 ) {
    o_port2 = ns -> getDataHubInputPort2();
    strcpy( this -> o_host2, getDataHubHost2() );
    out_soc2 = new KonoeOutputObjSocketBuffered( o_host2, o_port2 );
  }

  if( flag3 ) {
    o_port3 = ns -> getDataHubInputPort3();
    strcpy( this -> o_host3, getDataHubHost3() );
    out_soc3 = new KonoeOutputObjSocketBuffered( o_host3, o_port3 );
  }


  KInt o_port = ns -> getPreDHOutputPort();
  out_server = new KonoeServerSocket( o_port );
  out_server -> setSendMode( KonoeServerSocket::SEND_TO_LAST );

}

CRPreDH::~CRPreDH()
{
  delete ns;
  delete manager;
  delete in_server;
  if( flag1 ) {
    delete out_soc1;
  }
  if( flag2 ) {
    delete out_soc2;
  }
  if( flag3 ) {
    delete out_soc3;
  }
  delete out_server;
}

void CRPreDH::get_data()
{
  rec = (KonoeDataRecord*)( in_server -> get() );

  if( rec ) {
//    rec -> dump( cout );
    put_data( rec );    
  }
}

void CRPreDH::put_data( KonoeDataRecord* data )
{
  if( flag1 ) {
    out_soc1 -> put( data );
    out_soc1 -> flush();
  }
	if( flag2 ) {
	  out_soc2 -> put( data );
	  out_soc2 -> flush();
	}
	if( flag3 ) {
	  out_soc3 -> put( data );
	  out_soc3 -> flush();
	}

	return;
}

void CRPreDH::burial()
{
  KChar mes[CHAR_LENGTH];

  out_server -> receive( mes, CHAR_LENGTH );

  if( strcmp( mes, getDataHubHost()) == 0 ) {
    if( flag1 ) {
      changeFlag1( 0 );
      delete out_soc1;
      cout << "Flag1 off" << endl;
    } else {
      changeFlag1( 1 );
 	    out_soc1 = new KonoeOutputObjSocketBuffered( o_host1, o_port1 );
      cout << "Flag1 on" << endl;
    }
  } else if( strcmp( mes, getDataHubHost2()) == 0 ) {
    if( flag2 ) {
      changeFlag2( 0 );
      delete out_soc2;
      cout << "Flag2 off" << endl;
    } else {
      changeFlag2( 1 );
 	    out_soc2 = new KonoeOutputObjSocketBuffered( o_host2, o_port2 );
      cout << "Flag2 on" << endl;
    }
  } else if( strcmp( mes, getDataHubHost3()) == 0 ) {
    if( flag3 ) {
      changeFlag3( 0 );
      delete out_soc3;
      cout << "Flag3 off" << endl;
    } else {
      changeFlag3( 1 );
 	    out_soc3 = new KonoeOutputObjSocketBuffered( o_host3, o_port3 );
      cout << "Flag3 on" << endl;
    }
  } else {
    cerr << "There in no such a host." << endl;
    cerr << "...or connection?" << endl;
  }
  return;
}

void CRPreDH::go()
{
  while(1){
    obj_soc = in_server -> wait(0);
    if( obj_soc ) {
    get_data();
    }

    soc_con = out_server -> wait(0);
    if( soc_con ) {
      cout << "kitadesu" << endl;
      burial();
    }
  }
  return;
}
