/*
	binary_gps.cc

	Version 0.0.0	17-Dec-2002	mor
*/

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include "rslib.c"
#include "gpslib.c"

#include <KonoePrimitives.hh>
#include "CRGPSNameSpace.hh"

void stop_message( int mesID, unsigned char* mes )
{

        unsigned int up;
        unsigned int down;
        unsigned int chksm_up;
        unsigned int chksm_down;

        mes[0] = 0xFF;
        mes[1] = 0x81;

        up = mesID;
        up = up >> 8;

        down = mesID;
        down = down << 24;
        down = down >> 24;

        mes[2] = down;
        mes[3] = up;

        mes[4] = 0x0;
        mes[5] = 0x0;
        mes[6] = 0x0;
        mes[7] = 0x80;

        chksm_down = 0xFF - down + 0x2;
        mes[8] = chksm_down;
        chksm_up = 0xFD - up;
        mes[9] = chksm_up;

}


void start_message( int mesID, unsigned char* mes )
{

        unsigned int up;
        unsigned int down;
        unsigned int chksm_up;
        unsigned int chksm_down;

        mes[0] = 0xFF;
        mes[1] = 0x81;

        up = mesID;
        up = up >> 8;

        down = mesID;
        down = down << 24;
        down = down >> 24;

        mes[2] = down;
        mes[3] = up;

        mes[4] = 0x0;
        mes[5] = 0x0;
        mes[6] = 0x0;
        mes[7] = 0x40;

        chksm_down = 0xFF - down + 0x2;
        mes[8] = chksm_down;
        chksm_up = 0x3D - up;
        mes[9] = chksm_up;

}

KInt main( KInt argc, KChar** argv )
{
  CRGPSNameSpace* ns = new CRGPSNameSpace();

  int i;
  int time;
  int neco = 0;
  int nRsHandle;

  unsigned char szCmd[10];
  unsigned char rec[64];

  nRsHandle = OpenGps();

  if( nRsHandle == 0 ) {
    printf("Can't use this GPS receiver.");
    return 0;
  }

  memset( szCmd, 0, sizeof(szCmd) );

  stop_message( 1000, szCmd );
  if( write( nRsHandle, szCmd, sizeof(szCmd) == -1 ) ) {
    printf("dame desu.\n");
  }
  sleep(1);
  stop_message( 1002, szCmd );
  if( write( nRsHandle, szCmd, sizeof(szCmd) == -1 ) ) {
    printf("dame desu.\n");
  }
  sleep(1);
  stop_message( 1003, szCmd );
  if( write( nRsHandle, szCmd, sizeof(szCmd) == -1 ) ) {
    printf("dame desu.\n");
  }
  sleep(1);
  stop_message( 1135, szCmd );
  if( write( nRsHandle, szCmd, sizeof(szCmd) == -1 ) ) {
    printf("dame desu.\n");
  }
  sleep(1);

  printf("construct end\n");

  for(;;) {
    memset( rec, 0, sizeof(rec) );

    Rs232cRecGet( (char*)rec, 64 );
    i = 0;

    for(;;) {
      if( rec[i] == 0xff ) {
	if( rec[i+1] == 0x81 ) {
	  break;
	}
      }
      i++;
    }

    if( i<12 ) {
      time =  (int)(rec[i+28])*256*256 + (int)(rec[i+27])*256 + (int)(rec[i+26]);
//      printf("%2d\t%2x%2x%2x\n", i, rec[i+28], rec[i+27], rec[i+26] );
//      printf(" time : %6d\n",time);
    } else if( 14<i ) {
      time =  (int)(rec[i-11])*256*256 + (int)(rec[i-12])*256 + (int)(rec[i-13]);
//      printf("%2d\t%2x%2x%2x\n", i, rec[i-12], rec[i-13], rec[i-14] );
//      printf(" time : %6d\n",time);

    }

    ns -> setTime( time );

//	ns -> setTime( neco++ );
	cout << "neco : " << ns -> getTime() << endl;


    ns -> update();
  }

  CloseGps();
  delete ns;
  return 0;
}
