/********1*********2*********3*********4*********5*********6*********7********
*
*	ԥѥإåեUNIXѡ
*	GPS.H			Ver 1.0											1999
*					(c) Copyright 	G. Kou							1999
*					(c) Copyright	System Producer Associates Corp.1999
*						All Rights Reserved
*/
/********1*********2*** */
#ifndef __GPS_H
#define __GPS_H

#ifndef FALSE
#define FALSE 0
#define TRUE (!FALSE)
#endif

#define cON             1
#define cOFF            0
#define cYES            1
#define cNO             0
#define cOK             1
#define cNG             0
#define cTimeOut        -1

#define cTAB            0x09
#define cLF             0x0a
#define cCR             0x0d
#define cESC            0x1b
#define cSPACE          0x20
#define cENTER          cCR

#define cFileNameMax    256
#define cTextMax        256

#define cGpsLogBufMax    10
#define cGpsLogRecMax    128         /* >    cGpsRecMax   */
#define cGpsDatLen       20
#define cGpsGetRecWait   3
#define cGpsGetStsWait   5
#define cGpsGetOrbitWait 10

/* ХɹߤTimeout ÿ */
#define cGpsGetByteTimeOut	 1
/* 쥳ɹߤTimeout ÿ 
#define cGpsGetRecTimeOut	 7 */

#define cGpsLatN		"N"
#define cGpsLngE		"E"
#define cGpsStsOK		'1'
#define cGpsStsNG		'0'

#define cGpsOrbitMax    36
#define cGpsOrbitXmax   4
#define cGpsOrbitUseYES '1'
#define cGpsOrbitUseNO  '0'

#define cGpsSetDumpMax	10


/********1*********2*** ¤*/
struct tGpsDateTime {			/*	աǡ					*/
	char year  [cGpsDatLen];	/*			ǯ	[00..99]			*/
	char month [cGpsDatLen];	/*				  [01..12]			*/
	char day   [cGpsDatLen];	/*				  [01..31]			*/
	char hour  [cGpsDatLen];	/*			  [00..23]			*/
	char minute[cGpsDatLen];	/*				ʬ  [00..59]			*/
	char second[cGpsDatLen];	/*				  [00..59]			*/
};

struct tGpsPos	{				/*	֥ǡ							*/
	char lat  [cGpsDatLen];		/*				[N:̰, S:]	*/
	char lat_d[cGpsDatLen];		/*					[0090]			*/
	char lat_m[cGpsDatLen];		/*     			ʬ[00.00059.999]    */
	char lng  [cGpsDatLen];		/*				[E:, W:]	*/
	char lng_d[cGpsDatLen];		/*              ١[000180]          */
	char lng_m[cGpsDatLen];		/*              ʬ  [00.00059.999]    */
	char alt  [cGpsDatLen];		/*			m	[=999999]			*/
	char vel  [cGpsDatLen];		/*		®	km/h[000.0999.9]		*/
	char head [cGpsDatLen];		/*				[000.0359.9]		*/
};

struct tGpsStatus	{			/*	¬̾								*/
	char cond     [cGpsDatLen];	/*				[1:¬, 	 0:¬]	*/
	char dgps     [cGpsDatLen];	/*		DGPS		[1:DGPS,     0:DGPS]	*/
	char mode     [cGpsDatLen];	/*		⡼		[2:2D, 3:3D, 0:̤¬]	*/
	char obt_track[cGpsDatLen];	/*		ª	[0099]				*/
	char obt_view [cGpsDatLen];	/*		Ļ	[0099]				*/
	char hdop     [cGpsDatLen];	/*		HDOP		[00.099.9]			*/
	char pdop     [cGpsDatLen];	/*		PDOP		[00.099.9]			*/
	char antn     [cGpsDatLen];	/*		ݎÎŹ⤵ m	[-99.999.9]			*/
	char mag_dig  [cGpsDatLen];	/*		к 	[000.0359.9]			*/
	char mag_EW   [cGpsDatLen];	/*		к 	[E:졤W:]		*/
};

struct tGpsOrbit	{			/*    ǡ    					*/
	char prn[cGpsDatLen];		/*		ֹ	[00..36]			*/
	char use[cGpsDatLen];		/*		¬̻	[1:, 0:̤]	*/
	char elv[cGpsDatLen];		/*		ĳ		[-90..90]			*/
	char azm[cGpsDatLen];	   	/*				[000...360]			*/
	char sn [cGpsDatLen];		/*		S/N		[00..99]			*/
};

/********1*********2*** ؿץȥ
*/
int OpenGps(void)				/*	ǣУӤΥץ
									return value:
										cOK
										cNG
								*/
;
int CloseGps(void)				/*	ǣУӤΥ
									return value:
										cOK
										cNG
								*/
;
int GetGpsData(int)				/*	ǣУӥǡμ
									return value:
										n:	record count
										0:	data nothing
										-1:	error
								*/
;
int ExtractPosition(			/*	֥ǡμ						*/
		struct tGpsPos *pOutPos	/*		֥ǡ							*/
		)						/*	return value:
										cOK
										cNG
								*/
;
int ExtractDateTime(			/*	աǡμ					*/
	struct tGpsDateTime *pOutDT	/*		ǡ							*/
	)							/*	return value:
										cOK
										cNG
								*/
;
int ExtractStatus(				/*	¬̾ǡμ					*/
	struct tGpsStatus *pOutSts	/*		¬̥ǡ							*/
	)							/*	return value:
										cOK
										cNG
								*/
;
int ExtractOrbit(               /*  ǡμ                        */
	struct tGpsOrbit gUpdObt[]  /*     ¬̥ǡ                           */
	)							/*  return value:
									   cOK
									   cNG
								*/
;
void ChangeUtcToJapan(			/*	գԣû֤ܻ֤Ѵ			*/
	struct tGpsDateTime dInUtc,	/*		գԣû							*/
	struct tGpsDateTime *pOutJpn/*		ܻ							*/
	)							/*
								*/
;
void GpsDatDump(void)           /*  ǣУӥǡΥɽ
								*/
;
void GpsRecDump(				/*ǣУӥ쥳ɤΥɽ			  */
			int iInRecNo		/*		쥳ɷ						  */
			)
;
void ParmGet(                   /*  ưѥ᡼μ                  */
			int  iInParmCnt,    /*      ưѥ᡼                  */
			char *pInParmVal[], /*      ưѥ᡼                  */
			int  iInGetCnt,     /*      ѥ᡼                    */
			...                 /*      ѥ᡼
								*/
			)
;
clock_t TimeSet(void)           /*  ޡåȡʥॢȸѡ
									return value:
										¬ϻ
								*/
;
int TimeOut(                    /*  ॢȸ                        */
			clock_t lInBegin,   /*      ¬ϻ                        */
			int     iInSec      /*      ॢ                      */
			)                   /*  return value:
										cYES    ॢ
										cNO
								*/
;
void TimeGet(                   /*  աμ                    */
				char sOutDat[]  /*      ա                      */
			)
;
int Rs232cOpen(void)			/*	ңӣäν
									return value:
										cOK
										cNG
								*/
;
void Rs232cClose(void)			/*	ңӣäθ
								*/
;
int Rs232cRecPut(				/*	쥳								*/
				char sInOut[],	/*		ϥǡ							*/
				int  iInOutLen	/*		ϥǡĹ						*/
				)				/*	return value:
										cOK
										cNG
								*/
;
int Rs232cRecGet(               /*  쥳ɼ		                    */
				char sOutRec[], /*      쥳                        */
				int  iInOutMax	/*		ǡĹʸ          */
				)				/*	return value:
										cOK
										cNG
								*/
;

/********1*********2*********3*********4*********5*********6*********7*******/

#endif
