#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include "gps.h"

/********1*********2*********3*********4*********5*********6*********7********
*
*	ԥΣΣͣţϣǣУӥ饤֥
*			GPSLIB.C				                                 1999
*					(c) Copyright 	G.Kou							 1999
*					(c) Copyright	System Producer Associates Corp. 1999
*						All Rights Reserved
********1*********2***	*/

#define cNmeaIdMax	9 + 1 /* add for Jupiter (111215) */
const char cNmeaId[cNmeaIdMax][20] = {
	"GPGGA",
	"GPGLL",
	"GPGSA",
	"GPRMC",
	"GPVTG",
	"GPZDA",
	"GPGSV",
	"GPGSV,*,2",
	"GPGSV,*,3",
	"PRWIZCH",	/* add for Jupiter (111215) */
};
enum eNmeaId {
	cNmeaGGA,
	cNmeaGLL,
	cNmeaGSA,
	cNmeaRMC,
	cNmeaVTG,
	cNmeaZDA,
	cNmeaGSV,
	cNmeaGSV2,
	cNmeaGSV3,
	cNmeaZCH, /* add for Jupiter (111215) */
};

#define cNmeaRmcDataValid 	"A"

#define cExtPosMax	4
struct tExtPos {
	enum eNmeaId id;
	int	lat;
	int	lng;
	int	alt;
	int	vel;
	int	head;
	int	end;
};
struct tExtPos cExtPos[cExtPosMax] = {
	/*	id,		lat,lng,alt,vel,head,end	*/	
	{cNmeaGGA,	2,	4,	11,	0,	0,	11},
	{cNmeaGLL,	1,	3,	0,	0,	0,	4},
	{cNmeaRMC,	3,	5,	0,	0,	8,	8},
	{cNmeaVTG,	0,	0,	0,	7,	1,	7},
};

#define cExtDateTimeMax	3
struct tExtDateTime {
	enum eNmeaId id;
	int	time;
	int	date;
	int	dd;
	int	mm;
	int	yyyy;
	int end;
};
struct tExtDateTime cExtDateTime[cExtDateTimeMax] = {
	/*	id,		time, date, dd, mm, yyyy, end	*/	
	{cNmeaGGA,	1,		0,	0,	0,	0,		1},
	{cNmeaRMC,	1,		9,	0,	0,	0,		9},
	{cNmeaZDA,	1,		0,	2,	3,	4,		4},
};

#define cExtStatusMax	4
struct tExtStatus {
	enum eNmeaId id;
	int	conD;
	int	conM;
	int	con;
	int	satT;
	int	satV;
	int	hdop;
	int	pdop;
	int	antn;
	int	magD;
	int	magEW;
	int end;
};
struct tExtStatus cExtStatus[cExtStatusMax] = {
	/*	id,		conD, conM, con, satT, satV, hdop, pdop, antn, magD, magEW, end	*/	
	{cNmeaGGA,	6,    0,    0,   7,    0,    8,    0,    9,    0,    0,      9},
	{cNmeaGSA,	0,    2,    0,   0,    0,    16,   15,   0,    0,    0,     16},
	{cNmeaGSV,	0,    0,    0,   0,    3,    0,    0,    0,    0,    0,      3},
	{cNmeaRMC,	0,    0,    2,   0,    0,    0,    0,    0,    10,   11,    11},
};

#define cExtOrbitMax    4
struct tExtOrbit {
	enum eNmeaId id;
	int use;
	int orb1;
	int orb2;
	int orb3;
	int orb4;
	int end;
};
struct tExtOrbit cExtOrbit[cExtOrbitMax] = {
	/*  id,     use, orb1, orb2, orb3, orb4, end */
	{cNmeaGSA,  3,   0,    0,    0,    0,    14},
	{cNmeaGSV,  0,   4,    8,    12,   16,   19},
	{cNmeaGSV2, 0,   4,    8,    12,   16,   19},
	{cNmeaGSV3, 0,   4,    8,    12,   16,   19},
};

#define cGpsTimeDiffer	9
#define cGpsRecMax		(cGpsLogRecMax - 28)
#define cGpsDatRecMax   cNmeaIdMax
#define cGpsDatFldMax   30

enum eGpsErr {
	cGpsErrOK,
	cGpsErrFormat,
	cGpsErrFldLong,
	cGpsErrCheckSum,
	cGpsErrNmeaId,
};



/********1*********2***	ѿ
*/
char sGpsLogBuf[cGpsLogBufMax][cGpsLogRecMax];



/********1*********2***	ѿ*/
static	char    sGpsDat[cGpsDatRecMax][cGpsDatFldMax][cGpsDatLen];
static	int  	iGpsDatCnt[cGpsDatRecMax];
static	clock_t lGpsDatTim[cGpsDatRecMax];
/*static	int 	iGpsOpen = cOFF;*/
static	int 	iGpsOpen = FALSE;

/********1*********2***	ؿץȥ*/
int NmeaCheckSum(               /*  Σͣţåθ              */
				char sInRec[]	/*		ϥ쥳						*/
				)				/*	return value:
										cOK
										cNG
								*/
;
int NmeaGetLatLng(				/*  ١ͤΥåȡʣΣͣţ		*/
				char sInDat[],	/*		ϥǡ							*/
				char sOutDig[],	/*		ٷ١						*/
				char sOutMin[] /*      ٷ١ʬ                    	*/
				)				/*	return value:
										cOK
										cNG
								*/
;
int NmeaGetDateTime(			/*  աͤΥåȡʣΣͣţ		*/
				char sInDat[],	/*		ϥǡ							*/
				char sOutDH[],	/*		ա					*/
				char sOutMM[],	/*		ա	ʬ				*/
				char sOutYS[]	/*		աǯ					*/
				)				/*	return value:
										cOK
										cNG
								*/
;
void NmeaGetCondDgps(           /*  ¬̡ģǣУӾͤΥåȡʣΣͣţ*/
				char sInDat[],  /*      ϥǡ                          */
				char sOutCond[],/*      ¬桿¬                      */
				char sOutDgps[] /*      ģǣУӡģǣУ                */
				)				/*
								*/
;
void NmeaGetCondMode(           /*  ¬̾⡼ͤΥåȡʣΣͣţ  */
				char sInDat[],	/*		ϥǡ							*/
				char sOutCond[],/*		¬桿¬						*/
				char sOutMode[]	/*		ġ							*/
				)				/*
								*/
;
int NmeaGetOrbitUse(            /*  ѡѤʣΣͣţ      */
	char sInDat[][cGpsDatLen],  /*      ϥǡ                          */
	int  iInBgn,                /*          ϥǥå                */
	int  iInNo,                 /*      ǡ                        */
	struct tGpsOrbit gOutObt[]  /*      ǡ                          */
	)							/*	return value:
										cOK
										cNG
								*/
;
int NmeaGetOrbitAtr(            /*  ǡ°μʣΣͣţ      */
	char sInDat[][cGpsDatLen],	/*		ϥǡ							*/
	int  iInBgn,                /*          ϥǥå                */
	struct tGpsOrbit gOutObt[]  /*      ǡ                          */
	)							/*	return value:
										cOK
										cNG
								*/
;
int NmeaDatSet(					/*  ǣУӥ쥳ɤΣͣţǡΥå*/
				char sInRec[]   /*      ǣУӥ쥳                      */
				)				/*	return value:
										0:	OK
										n:	error no
									update data:
										sGpsDat
								*/
;



/*=======1=========2=========3=========4=========5=========6=========7======*/
int OpenGps(void)				/*	ǣУӤΥץ
									return value:
										cOK
										cNG
								*/
{
	int i;
	int handle;

	for (i = 0; i < cGpsDatRecMax; i++) {
		iGpsDatCnt[i] = 0;
		lGpsDatTim[i] = (clock_t)0;
	}
		
	if (iGpsOpen == TRUE) {
		puts("GpsOpenٸƤФޤ");
		CloseGps();
		return(cNG);
	}
	
	handle = Rs232cOpen();
	if ( handle == cNG) {
		puts("ңӡäν꤬ǤޤǤ");
		return(cNG);
	}

	iGpsOpen = TRUE;
	
/*	if (GetGpsData() <= 0) {
		puts("ǣУӥ쥷ФǡǤޤǤ");
		CloseGps();
		return(cNG);
	}
*/	
	return(handle);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int CloseGps(void)				/*	ǣУӤΥ
									return value:
										cOK
										cNG
								*/
{
	if (iGpsOpen != TRUE) {
		puts("GpsOpenƤФCloseGpsƤФޤ");
		return(cNG);
	}
	
	Rs232cClose();
	
	iGpsOpen = FALSE;
	return(TRUE);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int GetGpsData(int handle)			/*	ǣУӥǡμ
									return value:
										n:	record count
										0:	data nothing
										-1:	error
								*/
{
	int		cnt = 0;
	int		dat_get = cOFF;
	int		rc, err;
	char	rec[cGpsLogRecMax];
	clock_t stime;

	stime = TimeSet();
	
	if (iGpsOpen != TRUE) {
		puts("GpsOpenƤФGetGpsDataƤФޤ");
		return(-1);
	}

	while (cnt < cGpsLogBufMax) {
		memset(rec,0,sizeof(rec));
		rc = Rs232cRecGet(rec, cGpsRecMax);

		if (rc == cOK) {
			err = NmeaDatSet(rec);
			switch (err)
			{
			case cGpsErrFormat:
			case cGpsErrFldLong:
			case cGpsErrCheckSum:
			case cGpsErrNmeaId:
		/*		sprintf(rec, "%s ****** ERROR %d ******", rec, err);*/
				break;
			case cGpsErrOK:
			default:
				dat_get = cON;
				strcpy(sGpsLogBuf[cnt], rec);
				cnt++;
			}
		} else {
			break;
/*			if (dat_get == cON) {
				break;
			}else if(TimeOut(stime,cGpsGetRecTimeOut)){
				break;
			}*/
		}
	}
	return(cnt);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int ExtractPosition(			/*	֥ǡμ						*/
		struct tGpsPos *pOutPos	/*		֥ǡ							*/
		)						/*	return value:
										cOK
										cNG
								*/
{
	int i, di, fi;
	int rc = cNG;
	clock_t tim = 0;
	struct tGpsPos pos;

	memset(&pos, 0x00, sizeof(pos));

	for (i = 0; i < cExtPosMax; i++) {
		di = cExtPos[i].id;

		if ((iGpsDatCnt[di] >= cExtPos[i].end) &&
			(lGpsDatTim[di] > tim)) {
			
			fi = cExtPos[i].lat;
		
			if (fi > 0) {
				NmeaGetLatLng(sGpsDat[di][fi], pos.lat_d, pos.lat_m);
				strcpy(pos.lat, sGpsDat[di][fi+1]);
			}
			
			fi = cExtPos[i].lng;
			if (fi > 0) {
				NmeaGetLatLng(sGpsDat[di][fi], pos.lng_d, pos.lng_m);
				strcpy(pos.lng, sGpsDat[di][fi+1]);
			}
			
			fi = cExtPos[i].alt;
			if (fi > 0) {
				strcpy(pos.alt, sGpsDat[di][fi]);
			}
			
			fi = cExtPos[i].vel;
			if (fi > 0) {
				strcpy(pos.vel, sGpsDat[di][fi]);
			}
			
			fi = cExtPos[i].head;
			if (fi > 0) {
				strcpy(pos.head, sGpsDat[di][fi]);
			}
			
			rc = cOK;
		}
	}

	*pOutPos = pos;

	return(rc);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int ExtractDateTime(			/*	աǡμ					*/
	struct tGpsDateTime *pOutDT	/*		ǡ							*/
	)							/*	return value:
										cOK
										cNG
								*/
{
	int i, di, fi, l;
	int rc = cNG;
	clock_t tim = 0;
	struct tGpsDateTime dt;

	memset(&dt, 0x00, sizeof(dt));
	
	for (i = 0; i < cExtDateTimeMax; i++) {
		di = cExtDateTime[i].id;

		if ((iGpsDatCnt[di] >= cExtDateTime[i].end) &&
			(lGpsDatTim[di] > tim)) {
			
			fi = cExtDateTime[i].time;
			if (fi > 0) {
				NmeaGetDateTime(sGpsDat[di][fi], dt.hour, dt.minute, dt.second);
			}
			
			fi = cExtDateTime[i].date;
			if (fi > 0) {
				NmeaGetDateTime(sGpsDat[di][fi], dt.day, dt.month, dt.year);
			}
			
    		fi = cExtDateTime[i].dd;
			if (fi > 0) {
				strcpy(dt.day, sGpsDat[di][fi]);
			}
			
			fi = cExtDateTime[i].mm;
			if (fi > 0) {
				strcpy(dt.month, sGpsDat[di][fi]);
			}
			
			fi = cExtDateTime[i].yyyy;
			if (fi > 0) {
				l = strlen(sGpsDat[di][fi]);
				if (l >= 2 ) {
					strcpy(dt.year, &sGpsDat[di][fi][l-2]);
				}
			}
			
			rc = cOK;
		}
	}
	
	*pOutDT = dt;

	return(rc);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int ExtractStatus(				/*	¬̾ǡμ					*/
	struct tGpsStatus *pOutSts	/*		¬̥ǡ							*/
		)						/*	return value:
										cOK
										cNG
								*/
{
	int i, di, fi;
	int rc = cNG;
	clock_t tim = 0;
	struct tGpsStatus sts;
	
	memset(&sts, 0x00, sizeof(sts));
		
	for (i = 0; i < cExtStatusMax; i++) {
		di = cExtStatus[i].id;

		if ((iGpsDatCnt[di] >= cExtStatus[i].end) &&
			(lGpsDatTim[di] > tim)) {
			
			fi = cExtStatus[i].conD;
			if (fi > 0) {
				NmeaGetCondDgps(sGpsDat[di][fi], sts.cond, sts.dgps);
			}
			
			fi = cExtStatus[i].conM;
			if (fi > 0) {
				NmeaGetCondMode(sGpsDat[di][fi], sts.cond, sts.mode);
			}
			
			fi = cExtStatus[i].con;
			if (fi > 0) {
				/* strcmpi */
				if (strcmp(sGpsDat[di][fi], cNmeaRmcDataValid) == 0) {
					sts.cond[0] = cGpsStsOK;
				}
				else {
					sts.cond[0] = cGpsStsNG;
				}
				sts.cond[1] = 0x00;
			}
			
			fi = cExtStatus[i].satT;
			if (fi > 0) {
				strcpy(sts.obt_track, sGpsDat[di][fi]);
			}
			
			fi = cExtStatus[i].satV;
			if (fi > 0) {
				strcpy(sts.obt_view, sGpsDat[di][fi]);
			}
			
			fi = cExtStatus[i].hdop;
			if (fi > 0) {
				strcpy(sts.hdop, sGpsDat[di][fi]);
			}
			
			fi = cExtStatus[i].pdop;
			if (fi > 0) {
				strcpy(sts.pdop, sGpsDat[di][fi]);
			}
			
			fi = cExtStatus[i].antn;
			if (fi > 0) {
				strcpy(sts.antn, sGpsDat[di][fi]);
			}
			
			fi = cExtStatus[i].magD;
			if (fi > 0) {
				strcpy(sts.mag_dig, sGpsDat[di][fi]);
			}
			fi = cExtStatus[i].magEW;
			if (fi > 0) {
				strcpy(sts.mag_EW, sGpsDat[di][fi]);
			}
			
			rc = cOK;
		}
	}
	
	*pOutSts = sts;

	return(rc);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int ExtractOrbit(               /*  ǡμ                        */
	struct tGpsOrbit gUpdObt[]  /*     ¬̥ǡ                           */
		)                       /*  return value:
									   cOK
									   cNG
								*/
{

	int i, di, fi, n;
	int rc = cNG;
	clock_t tim = 0;

	for (i = 0; i < cExtOrbitMax; i++) {
		di = cExtOrbit[i].id;

		if (lGpsDatTim[di] > tim) {
			
			if (iGpsDatCnt[di] >= cExtOrbit[i].use) {
				fi = cExtOrbit[i].use;
				if (fi > 0) {
					n = cExtOrbit[i].end - fi + 1;
					NmeaGetOrbitUse(sGpsDat[di], fi, n, gUpdObt);
				}
			}

			if (iGpsDatCnt[di] >= (cExtOrbit[i].orb2 - 1)) {
				fi = cExtOrbit[i].orb1;
				if (fi > 0) {
					NmeaGetOrbitAtr(sGpsDat[di], fi, gUpdObt);
				}
			}

			if (iGpsDatCnt[di] >= (cExtOrbit[i].orb3 - 1)) {
				fi = cExtOrbit[i].orb2;
				if (fi > 0) {
					NmeaGetOrbitAtr(sGpsDat[di], fi, gUpdObt);
				}
			}

			if (iGpsDatCnt[di] >= (cExtOrbit[i].orb4 - 1)) {
				fi = cExtOrbit[i].orb3;
				if (fi > 0) {
					NmeaGetOrbitAtr(sGpsDat[di], fi, gUpdObt);
				}
			}

			if (iGpsDatCnt[di] >= (cExtOrbit[i].end)) {
				fi = cExtOrbit[i].orb4;
				if (fi > 0) {
					NmeaGetOrbitAtr(sGpsDat[di], fi, gUpdObt);
				}
			}
			
			rc = cOK;
		}
	}
	
	return(rc);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void ChangeUtcToJapan(			/*	գԣû֤ܻ֤Ѵ			*/
	struct tGpsDateTime dInUtc,	/*		գԣû							*/
	struct tGpsDateTime *pOutJpn/*		ܻ							*/
	)							/*
								*/

{

	int iy, im, id, ih;
	struct tGpsDateTime dt;

	memset(&dt, 0x00, sizeof(dt));

	iy = atoi(dInUtc.year);
	im = atoi(dInUtc.month);
	id = atoi(dInUtc.day);
	ih = atoi(dInUtc.hour);
	
	ih += cGpsTimeDiffer;
	if (ih >= 24) {
		ih -= 24;
		id++;
	}
	
	if (id > 31) {
		id = 1;
		im++;
	}
	else if (id > 30) {
		if ((im == 4) || (im == 6) || (im == 9) || (im == 11)) {
			id = 1;
			im++;
		}
	}
	else if (id > 28) {
		if (im == 2) {
			id = 1;
			im++;
		}
	}
	
	if (im > 12) {
		im = 1;
		iy++;
	}
	
	sprintf(dt.year,  "%02d", iy);
	sprintf(dt.month, "%02d", im);
	sprintf(dt.day,   "%02d", id);
	sprintf(dt.hour,  "%02d", ih);
	strcpy(dt.minute, dInUtc.minute);
	strcpy(dt.second, dInUtc.second);
	
	*pOutJpn = dt;

	return;
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void GpsDatDump(void)           /*  ǣУӥǡΥɽ
								*/
{
	int i, j;
	char rec[cTextMax];
	
	for (i = 0; i < cGpsDatRecMax; i++) {
		if (iGpsDatCnt[i] > 0) {
			rec[0] = 0x00;
			for (j = 0; j < iGpsDatCnt[i]; j++) {
				if (sGpsDat[i][j][0] == '*') {
					rec[strlen(rec)-1] = 0x00;
				}
				strcat(rec, sGpsDat[i][j]);
				strcat(rec, ",");
			}
			rec[strlen(rec)-1] = 0x00;

			printf("%s\n", rec);
			fflush(stdout);
		}
    }
    
	return;
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void GpsRecDump(				/*ǣУӥ쥳ɤΥɽ			  */
			int iInRecNo		/*		쥳ɷ						  */
			)
{
	int i;

	for (i = 0; i < iInRecNo; i++) {
		printf("%s\n", sGpsLogBuf[i]);
		fflush(stdout);
	}
    
	return;
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void ParmGet(                   /*  ưѥ᡼μ                  */
			int  iInParmCnt,    /*      ưѥ᡼                  */
			char *pInParmVal[], /*      ưѥ᡼                  */
			int  iInGetCnt,     /*      ѥ᡼                    */
			...                 /*      ѥ᡼
								*/
			)
{
	int i;
	char *p_outparm;
	va_list arg_list;

	va_start(arg_list, iInGetCnt);

	for (i = 1; (i < iInParmCnt) && (i <= iInGetCnt); i++) {
		p_outparm = va_arg(arg_list, char *);
		if (*pInParmVal[i] != ',') {
			strcpy(p_outparm, pInParmVal[i]);
		}
	}
	va_end(arg_list);

	return;
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
clock_t TimeSet(void)           /*  ޡåȡʥॢȸѡ
									return value:
										¬ϻ
								*/
{
	return(clock());
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int TimeOut(                    /*  ॢȸ                        */
			clock_t lInBegin,   /*      ¬ϻ                        */
			int     iInSec      /*      ॢ                      */
			)                   /*  return value:
										cYES    ॢ
										cNO
								*/
{
	clock_t etime, ptime;

	if (iInSec < 0) {
		return(cNO);
	}

	etime = lInBegin + ((clock_t)iInSec * CLOCKS_PER_SEC);
	ptime = clock();
	
	if (ptime < etime)
		return(FALSE);
	else
		return(TRUE);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void TimeGet(                   /*  աμ                        */
				char sOutDat[]  /*      ա                      */
			)
{
	time_t ptime;
	struct tm *ptm;

	ptime = time(NULL);
	ptm = localtime(&ptime);

	/* ptm->tm_yearϸߤǯ1900 */
	/* Τᡢ̤Ȥ褦ˤ롡 */
	if(ptm->tm_year >= 100)
		ptm->tm_year = ptm->tm_year % 100;

	sprintf(sOutDat, "%02d/%02d/%02d %02d:%02d:%02d",
			ptm->tm_year, (ptm->tm_mon + 1), ptm->tm_mday,
			ptm->tm_hour, ptm->tm_min, ptm->tm_sec);

	return;
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaCheckSum(               /*  Σͣţåθ              */
				char sInRec[]	/*		ϥ쥳						*/
				)				/*	return value:
										cOK
										cNG
								*/
{
	unsigned char ch, sum[10];
	int len, i;
	int rc = cOK;
		
	len = strlen(sInRec);
	ch = 0x00;
	for (i = 1; i < len; i++) {
		if (sInRec[i] == '*') {
			break;
		}
		ch = (ch ^ sInRec[i]) & 0xff;
	}
	if (i < len) {
		if ((i + 2) < len) {
			sprintf((char*)sum, "%2x", ch);
			if (memcmp(sum, &sInRec[i+1], 2) != 0) {
				rc = cNG;
			}
		}
		else {
			rc = cNG;
		}
	}

	return(rc);
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaGetLatLng(				/*  ١ͤΥåȡʣΣͣţ		*/
				char sInDat[],	/*		ϥǡ							*/
				char sOutDig[],	/*		ٷ١						*/
				char sOutMin[] /*      ٷ١ʬ                    	*/
				)				/*	return value:
										cOK
										cNG
								*/
{
	int i, len;
	int rc = cNG;

	sOutDig[0] = '\0';
	sOutMin[0] = '\0';

	len = strlen(sInDat);
	if (len > 0) {

		i = strcspn(sInDat, ".");
		
		if (i > 2) {
			memcpy(sOutDig, sInDat, (i - 2));
			sOutDig[i-2] = '\0';
			strcpy(sOutMin, &sInDat[i - 2]);
		}
		else if (i >= len) {
			strcpy(sOutDig, sInDat);
		}
		else {
			strcpy(sOutMin, sInDat);
		}
		rc = cOK;
	}
	
	return(rc);
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaGetDateTime(			/*  աͤΥåȡʣΣͣţ		*/
				char sInDat[],	/*		ϥǡ							*/
				char sOutDH[],	/*		ա					*/
				char sOutMM[],	/*		ա	ʬ				*/
				char sOutYS[]	/*		աǯ					*/
				)				/*	return value:
										cOK
										cNG
								*/
{
	int len;
	int rc = cNG;

	sOutDH[0] = '\0';
	sOutMM[0] = '\0';
	sOutYS[0] = '\0';

	len = strlen(sInDat);
	if (len >= 6) {
	
		memcpy(sOutDH, &sInDat[len-6], 2);
		sOutDH[2] = 0x00;
		memcpy(sOutMM, &sInDat[len-4], 2);
		sOutMM[2] = 0x00;
		strcpy(sOutYS, &sInDat[len-2]);
		
		rc = cOK;
		
	}
	
	return(rc);
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
void NmeaGetCondDgps(           /*  ¬̡ģǣУӾͤΥåȡʣΣͣţ*/
				char sInDat[],  /*      ϥǡ                          */
				char sOutCond[],/*      ¬桿¬                      */
				char sOutDgps[] /*      ģǣУӡģǣУ                */
				)				/*
								*/
{
	sOutCond[0] = cGpsStsNG;
	sOutCond[1] = 0x00;
	sOutDgps[0] = cGpsStsNG;
	sOutDgps[1] = 0x00;

	if (sInDat[0] == '1') {
		sOutCond[0] = cGpsStsOK;
	}
	else if (sInDat[0] == '2') {
		sOutCond[0] = cGpsStsOK;
		sOutDgps[0] = cGpsStsOK;
	}
	
	return;
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
void NmeaGetCondMode(           /*  ¬̾⡼ͤΥåȡʣΣͣţ  */
				char sInDat[],	/*		ϥǡ							*/
				char sOutCond[],/*		¬桿¬						*/
				char sOutMode[]	/*		ġ							*/
				)				/*
								*/
{
	sOutCond[0] = cGpsStsNG;
	sOutCond[1] = 0x00;
	sOutMode[0] = cGpsStsNG;
	sOutMode[1] = 0x00;

	if ((sInDat[0] == '2') || (sInDat[0] == '3')) {
		sOutCond[0] = cGpsStsOK;
		sOutMode[0] = sInDat[0];
	}
	
	return;
}
/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaGetOrbitUse(            /*  ѡѤʣΣͣţ      */
	char sInDat[][cGpsDatLen],  /*      ϥǡ                          */
	int  iInBgn,                /*          ϥǥå                */
	int  iInNo,                 /*      ǡ                        */
	struct tGpsOrbit gOutObt[]  /*      ǡ                          */
	)							/*	return value:
										cOK
										cNG
								*/
{

	int i, id;
	int rc = cOK;

	for (i = 0; i < cGpsOrbitMax; i++) {
		gOutObt[i].use[0] = cGpsOrbitUseNO;
		gOutObt[i].use[1] = 0x00;
	}
	
	for (i = 0; i < iInNo; i++) {
		if (sInDat[iInBgn + i][0] != 0x00) {
			id = atoi(sInDat[iInBgn + i]);
			if ((0 < id) && (id <= cGpsOrbitMax)) {
				gOutObt[id-1].use[0] = cGpsOrbitUseYES;
			}
			else {
				rc =cNG;
				break;
			}
		}
	}
	return(rc);
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaGetOrbitAtr(            /*  ǡ°μʣΣͣţ      */
	char sInDat[][cGpsDatLen],	/*		ϥǡ							*/
	int  iInBgn,                /*          ϥǥå                */
	struct tGpsOrbit gOutObt[]  /*      ǡ                          */
	)							/*	return value:
										cOK
										cNG
								*/
{
	int id;
	int rc = cNG;

	id = atoi(sInDat[iInBgn]);
	if ((0 < id) && (id <= cGpsOrbitMax)) {
		id--;
		
		strcpy(gOutObt[id].prn, sInDat[iInBgn]);
		strcpy(gOutObt[id].elv, sInDat[iInBgn+1]);
		strcpy(gOutObt[id].azm, sInDat[iInBgn+2]);
		strcpy(gOutObt[id].sn,  sInDat[iInBgn+3]);
		rc = cOK;
	}
	return(rc);
}

/*-------1---------2---------3---------4---------5---------6---------7------*/
int NmeaDatSet(					/*  ǣУӥ쥳ɤΣͣţǡΥå*/
				char sInRec[]   /*      ǣУӥ쥳                      */
				)				/*	return value:
										0:	OK
										n:	error no
									update data:
										sGpsDat
								*/
{
	int i, j, len;
	int rc, ni;
	char dlm;
	char save = 0x00;
	char rec[cGpsLogRecMax];
	char *sp, *pt;
	enum eGpsErr err;
	err = cGpsErrOK;
	 
	strcpy(rec, sInRec);
	len = strlen(rec);
	if (len <= 6) {
		err = cGpsErrFormat;
	}
	else {
/*		//	å̵Ȥ	1998/1
		//rc = NmeaCheckSum(rec);
*/		rc = cOK;

		if (rc != cOK) {
			err = cGpsErrCheckSum;
		}
		else {
			for (i = 0; i < cNmeaIdMax; i++) {
				if (memcmp(&rec[1], cNmeaId[i], strlen(cNmeaId[i])) == 0) {
					break;
				}
			}

			if (i >= cNmeaIdMax) {
				err = cGpsErrNmeaId;
			}
			else {
				strcat(rec, ",");
				sp = rec;
				for (j = 0; j < cGpsDatFldMax; j++) {
					pt = strpbrk(sp, ",*");
					if (pt == NULL) {
						break;
					}
					
					dlm = *pt;
					*pt = '\0';

					if (strlen(sp) < cGpsDatLen) {
					
						if ((i == cNmeaGSV) && (j == 2)) {
							ni = 0;
							if (*sp == '2') {		/* $GPGSV,n,2	*/
								ni = cNmeaGSV2;
							}
							else if (*sp == '3') {  /* $GPGSV,n,3   */
								ni = cNmeaGSV3;
							}
								
							if (ni > 0) {
								strcpy(sGpsDat[ni][0], sGpsDat[i][0]);
								strcpy(sGpsDat[ni][1], sGpsDat[i][1]);
								i = ni;
							}
						}
						
						sGpsDat[i][j][0] = '\0';
						if (save == '*') {
							strcpy(sGpsDat[i][j], "*");
						}
						strcat(sGpsDat[i][j], sp);
					}
					else {
						err = cGpsErrFldLong;
						break;
					}

					save = dlm;
					sp = pt;
					sp++;
				}
				if (err == cGpsErrOK) {
					iGpsDatCnt[i] = j;
					lGpsDatTim[i] = clock();
				}
				else {
					iGpsDatCnt[i] = 0;
					lGpsDatTim[i] = (clock_t)0;
				}
			}
		}
	}

	return(err);
}

/********1*********2*********3*********4*********5*********6*********7*******/
