/********1*********2*********3*********4*********5*********6*********7********
*
*	ңӡݣ̿饤֥ʡUNIXС󡡡
*			RSLIB.C					                                 1999
*					(c) Copyright 	G.Kou							 1999
*					(c) Copyright	System Producer Associates Corp. 1999
*						All Rights Reserved
*/
/********1*********2*********3*********4*********5*********6*********7********/

/* 󥯥롼 */
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include "gps.h"

#include <stdlib.h>
#include <math.h>
#include <termio.h>
#include <limits.h>

/*  */
#define			SYSCONFIGFILE	"JupCfg.txt"	/* ƥĶե̾ */
#define			RS_SPEED		B4800			/* ̿ܡ졼 */

/* ؿ */
int				gps_output_set();
int				read_config();
char			log_flag();

/* RS-232C󥿡եؿ */
int				rs_open(void);
int				rs_setup(int);
unsigned char	rs_getc(void);

/* Хѿ */
int				gRsHandle;			/* RS-232C ϥɥ */
struct			termios gRsInitSet;	/* RS-232C¸ */

/* ƥĶեѿ */
char			gDevice[20];		/* ̿ݡ̾ */
char			gLogout[20];			/* ϥե饰 */

/*  */
#define cRs232cBufMax		1024

/* ѿ */
static int	iRs232cGetRecCnt;

/*=======1=========2=========3=========4=========5=========6=========7======*/
int Rs232cOpen(void)			/*	ңӣäν
									return value:
										handle
										cNG
								*/
{
	int		ret;
	FILE	*fp;

	/* Ķեɤ */
	ret = read_config();
	if(ret < 0){
		return cNG;
	}
	
	/* GPSν */
	gps_output_set();

	/* RS232C򳫤 */
	ret = rs_open();
	if (ret < 0){
		return(cNG);
	}

	/* RS232C */
	ret = rs_setup(FALSE);
	if (ret < 0){
		return(cNG);
	}

// neco
//	printf("gRsHandle : %d\n",gRsHandle);

	return(gRsHandle);
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
void Rs232cClose(void)			/*	ңӣäθ
								*/
{
	tcsetattr(gRsHandle, TCSAFLUSH, &gRsInitSet);

	close(gRsHandle);
	return;
}

/*=======1=========2=========3=========4=========5=========6=========7======*/
int Rs232cRecGet(               /*  쥳ɼ		                    */
				char sOutRec[], /*      쥳                        */
				int  iInOutMax	/*		ǡĹʸ          */
				)				/*	return value:
										cOK
										cNG
								*/
{
	int i=0;
	unsigned char ch=0;
	int eor = cOFF;
	clock_t stime;

	stime = TimeSet();
	while(i < iInOutMax){
		/* timeoutޤǥ롼 */
		for(;;){
			ch = rs_getc();
			if(ch != 0x77)
//			if(ch != cNG)
				break;
			if (TimeOut(stime, cGpsGetByteTimeOut)) {
/*				printf("Rs232cRecGet time out\n");*/
				return cTimeOut;
			}
		}
//		printf("%x",ch);
		sOutRec[i] = ch;

		/*ʸLFˤǥ쥳ɤڤ */
		if(sOutRec[i] == cLF) {
			sOutRec[i] = 0x00;
			iRs232cGetRecCnt++;
			break;
		}
		i++;
	}
	return(cOK);
}
/************************************************************************/
/*   rs_open		                                                    */
/************************************************************************/
int	rs_open(void)
{
	gRsHandle = open(gDevice, O_RDWR|O_NDELAY );
	if(gRsHandle == -1){
		printf("fail to open serial port!\n");
		printf("gDevice = %s ,rs_handle = %d\n", gDevice,gRsHandle);
	}else{
		printf("Device %s opened.\n", gDevice);
		/* Хåե󥯥ꥢ */
		tcflush(gRsHandle, TCIOFLUSH);
	}
	
	return(gRsHandle);
}
/************************************************************************/
/*   rs_setup															*/
/*   :  TRUE ߥ⡼	FALSE ϥ⡼						*/
/************************************************************************/
int	rs_setup(int bWriteMode)
{
	struct	termios tms;
    int   i;

	/* ͤ */
	if((ioctl(gRsHandle, TCGETS, &tms)) ==-1){
		fprintf(stderr,"ioctrl error.\n");
		close(gRsHandle);
		exit(1);
	}

	/* ͤ¸ */
	gRsInitSet = tms;

	/* 1ʸΥӥåĹ8ˤ */
	tms.c_cflag |= CSIZE;
	tms.c_cflag |= CS8;

	/* ȥåץӥåȤ1ӥåȤˤ */
	tms.c_cflag &= ~CSTOPB;

	if(bWriteMode == TRUE){
		/* GPS̵ */
		tms.c_cflag &= ~CREAD;
	}else{
		/* ͭ */
		tms.c_cflag |= CREAD;
	}

	/* ѥƥӥåȤʤˤ */
	tms.c_cflag &= ~PARENB;

	/* ߤ̵ˤ */
	tms.c_lflag &= ~ISIG;

	/* ʸECHOʤ */
	tms.c_lflag &= ~ECHO;

	/* ޤϤХåե󥰤 */
	tms.c_lflag &= ~ICANON;

	/* ̵뤹 */
	tms.c_iflag |= IGNCR;

	/* ̿ܡ졼 */
	tms.c_cflag &= ~CBAUD;
	tms.c_cflag |= RS_SPEED;

	tms.c_oflag &= ~OPOST;

	tms.c_iflag &= ~BRKINT;
	tms.c_lflag &= ~ECHO;
	tms.c_iflag |= IGNPAR;
	tms.c_iflag &= ~ISTRIP;
	tms.c_iflag &= ~INLCR;
	
	tms.c_iflag &= ~ICRNL;
	tms.c_iflag &= ~IUCLC;
	tms.c_iflag &= ~IXON;
	tms.c_iflag &= ~IXANY;
	tms.c_iflag |= IXOFF;
	tms.c_cc[VMIN] = 1;

	if((ioctl(gRsHandle, TCSETS, &tms)) == -1){
		fprintf(stderr,"failed to set mode, \n");
		close(gRsHandle);
		exit(1);	
	}	

	return(0);
}
/************************************************************************/
/*   ؿ̾:rs_getc                                                     */
/*     :RS-232C1ʸ                                  */
/*   :                                                            */
/*   :ʸ                                                    */
/************************************************************************/
unsigned char	rs_getc(void)
{
	unsigned char	c;
	int	ret;

	ret = read(gRsHandle, &c, 1);
//	printf("%4x",c);
	if (ret < 1){
		return(0x77);
//		return(cNG);
	}

	return(c);
}

/************************************************************************/
/*   ؿ̾:gps_output_set                                              */
/*																	    */
/************************************************************************/
int gps_output_set()
{
	char	buf[64];
	char	sentence[64];
	char	c;
	int		ret = cOK;
	int		handle;
	struct	termios tms;

//	printf("GPSνѹޤ(y/n)");
//	gets(buf);c = buf[0];
//	if( (c != 'Y') && (c != 'y') )
		return cOK;

	memset(buf,0,sizeof(buf));
	memset(sentence,0,sizeof(sentence));

	/* open Rs232c for tempory use */
	gRsHandle = open(gDevice, O_WRONLY|O_NDELAY );
	if(handle == -1){
		printf("fail to open serial port for gps set!\n");
	}else{
		tcflush(handle, TCIOFLUSH);
	}
	
	rs_setup(TRUE);

	/* GGA */
	printf("GGAνϤONˤޤ(y/n)");
	gets(buf);c = buf[0];
	if( (c == 'Y') || (c == 'y') ){
		printf("ϼäˤޤ");
		gets(buf);
		sprintf(sentence,"$PRWIILOG,GGA,A,T,%s,0\r\n",buf);
		if(write(gRsHandle,sentence,sizeof(sentence)) == -1){
			printf("fail to set!\n");
			ret = cNG; 
		}
	}else if( (c == 'N') || (c == 'n') ){
		if(write(gRsHandle,"$PRWIILOG,GGA,V,T,1,0\r\n",24)==-1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else{/* ̵ϡߤξ֤Ѥʤ */
		ret = cNG;
	}

	/* GSA */
	printf("GSAνϤONˤޤ(y/n)");
	gets(buf);c = buf[0];
	if( (c == 'Y') || (c == 'y') ){
		printf("ϼäˤޤ");
		gets(buf);
		sprintf(sentence,"$PRWIILOG,GSA,A,T,%s,0\r\n",buf);
		if(write(gRsHandle,sentence,sizeof(sentence)) == -1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else if( (c == 'N') || (c == 'n') ){
		if(write(gRsHandle,"$PRWIILOG,GSA,V,T,1,0\r\n",24)==-1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else{/* ̵ϡߤξ֤Ѥʤ */
		ret = cNG;
	}

	/* GSV */
	printf("GSVνϤONˤޤ(y/n)");
	gets(buf);c = buf[0];
	if( (c == 'Y') || (c == 'y') ){
		printf("ϼäˤޤ");
		gets(buf);
		sprintf(sentence,"$PRWIILOG,GSV,A,T,%s,0\r\n",buf);
		if(write(gRsHandle,sentence,sizeof(sentence)) == -1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else if( (c == 'N') || (c == 'n') ){
		if(write(gRsHandle,"$PRWIILOG,GSV,V,T,1,0\r\n",24)==-1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else{/* ̵ϡߤξ֤Ѥʤ */
		ret = cNG;
	}

	/* RMC */
	printf("RMCνϤONˤޤ(y/n)");
	gets(buf);c = buf[0];
	if( (c == 'Y') || (c == 'y') ){
		printf("ϼäˤޤ");
		gets(buf);
		sprintf(sentence,"$PRWIILOG,RMC,A,T,%s,0\r\n",buf);
		if(write(gRsHandle,sentence,sizeof(sentence)) == -1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else if( (c == 'N') || (c == 'n') ){
		if(write(gRsHandle,"$PRWIILOG,RMC,V,T,1,0\r\n",24)==-1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else{/* ̵ϡߤξ֤Ѥʤ */
		ret = cNG;
	}

	/* ZCH */
	printf("ZCHνϤONˤޤ(y/n)");
	gets(buf);c = buf[0];
	if( (c == 'Y') || (c == 'y') ){
		printf("ϼäˤޤ");
		gets(buf);
		sprintf(sentence,"$PRWIILOG,ZCH,A,T,%s,0\r\n",buf);
		if(write(gRsHandle,sentence,sizeof(sentence)) == -1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else if( (c == 'N') || (c == 'n') ){
		if(write(gRsHandle,"$PRWIILOG,ZCH,V,T,1,0\r\n",24)==-1){
			printf("fail to set!\n");
			ret = cNG;
		}
	}else{/* ̵ϡߤξ֤Ѥʤ */
		ret = cNG;
	}

	Rs232cClose();

	return ret;
}

/************************************************************************/
/*   ؿ̾:read_config                                                 */
/*     :ƥĶեɤ                                  */
/*   :                                                            */
/*   :0->,->ERROR                                         */
/************************************************************************/
int read_config()
{
    FILE    *fp;
    char    *p;
    char    ReadBuffer[128];
    char    EditBuffer[128];
    char    filename[100];
    int     i,j;

    memset(gDevice,0,sizeof(gDevice));
    memset(gLogout,0,sizeof(gLogout));
    
	/*--- open configration file ---*/
	strcpy(filename, SYSCONFIGFILE);

    fp=fopen(filename,"r");
    if (fp == NULL){
		printf("ƥĶե륪ץ󥨥顼\n");
		return(-1);
    }

    for ( ; !feof(fp) ; )
    {
        memset(ReadBuffer,0,sizeof(ReadBuffer));
        if (fgets(ReadBuffer,sizeof(ReadBuffer),fp) == NULL)
            continue;
        else if(ReadBuffer[0] == 0x1A || /* EOF           */
                ReadBuffer[0] == 0x0D || /* CR only       */
                ReadBuffer[0] == 0x0A || /* LF only       */
                ReadBuffer[0] == '#'  || /* commect line  */
                ReadBuffer[0] == 0x0)
            continue;

        if (strstr(ReadBuffer,"DEVICE="))
        {
            p = strstr(ReadBuffer,"=");
            memset(EditBuffer,0,sizeof(EditBuffer));
            for(i=j=0; *(p+1+i) != 0x0a && *(p+1+i) != 0x0d;i++) j++;
            memcpy(EditBuffer,p+1,j);
            strcpy(gDevice,EditBuffer);
        }
        if (strstr(ReadBuffer,"LOGOUT="))
        {
            p = strstr(ReadBuffer,"=");
            memset(EditBuffer,0,sizeof(EditBuffer));
            for(i=j=0; *(p+1+i) != 0x0a && *(p+1+i) != 0x0d;i++) j++;
            memcpy(EditBuffer,p+1,j);
            strcpy(gLogout,EditBuffer);
        }
	}
    fclose(fp);
    return ( 0 );
}
/************************************************************************/
/*   ؿ̾:read_config                                                 */
/*     :ƥĶեɤ                                  */
/*   :                                                            */
/*   :0->,->ERROR                                         */
/************************************************************************/
char log_flag()
{
	char* p = gLogout;
	while (*p == 0x20){
		p++;
	}
	return *p;
}
