/*
	CRConnectServer.cc

	Version 0.0.0	2-Jan-2003	mor
*/

#include "CRConnectServer.hh"

CRConnectServer::CRConnectServer( KInt pport, KChar* phost )
{
	serverPort = pport;
	strcpy( serverHost, phost );

	cli_soc = new KonoeClientSocket( serverHost, serverPort );
	in_soc = new KonoeInputObjSocketBuffered( cli_soc );
	manager = new KonoeDataRecordCM();
	in_soc -> installCM( manager );
}

CRConnectServer::CRConnectServer( KChar* pfile )
{
	strcpy( file_name, pfile );
	serverPort = 0;

	in_file = new KonoeInputObjFileBuffered( file_name );
	manager = new KonoeDataRecordCM();
	in_file -> installCM( manager );
}

CRConnectServer::~CRConnectServer()
{
	delete manager;
	if( serverPort == 0 ) {
		delete in_soc;
		delete cli_soc;
	}
	if( file_name == 0 ) {
		delete in_file;
	}
}

void CRConnectServer::connect()
{
	while( (cli_soc -> getStatus()) != KonoeSocketIO::CONNECTED ) {
		cerr << "NOT CONNECT. ";
		cerr << "Try to connect after 3 sec." << endl;
		cli_soc ->connect();
	}
	return;
}

void CRConnectServer::sendMessage( KChar* mes )
{
	cli_soc -> send( mes, strlen(mes) );
}

KonoeDataRecord* CRConnectServer::getRecord()
{
	KonoeDataRecord* rec = (KonoeDataRecord*)( in_soc -> get() );
	return (KonoeDataRecord*)rec;
}
