/*
	CRHistogramDisplay.cc

	Version 0.0.0	1-Jan-2003	mor
*/

#include "CRHistogramDisplay.hh"

CRHistogramDisplay::CRHistogramDisplay()
{
	this -> initialize();
	this -> construct();
}

CRHistogramDisplay::~CRHistogramDisplay()
{
	;
}

void CRHistogramDisplay::construct()
{
	KChar* tmp = new KChar [64];

	mw = new KonoeTclMainWindow( title );

	frame = new KonoeTclFrame* [numFrame];
	for( int i=0; i<numFrame; i++ ) {
		frame[i] = new KonoeTclFrame( mw, tmpnam(tmp) );
	}

	dummy = new Konoe1DHistogram* [numHist];
	panel = new KonoeTclDrawPanel* [numHist];
	canvas = new KonoeTclDrawCanvas* [numHist];
	for( int i=0; i<numHist; i++ ) {
		dummy[i] = new Konoe1DHistogram( 
			new KonoeLinearDataScale( minScale, maxScale, (KInt)maxScale ) ); 
		dummy[i] -> clear();
		panel[i] = new KonoeTclDrawPanel( 
			frame[i%numFrame], tmpnam(tmp) );
		canvas[i] = new KonoeTclDrawCanvas( 
			panel[i], tmpnam(tmp), dummy[i],
			KonoeTclDimension( getTate(), getYoko() ),
			this -> histTitle[i] );
		panel[i] -> setCanvas( canvas[i], tmpnam(tmp) );
		canvas[i] -> setBackGround( this -> histBGColor[i] );
		canvas[i] -> setHistoColor( this -> histColor[i] );
		canvas[i] -> setHorizontalScale( 
			(KInt)minScale, (KInt)maxScale, (KInt)maxScale );
	}

	for( int i=0; i<numFrame; i++ ) {
		frame[i] -> setLayoutType( "left" );
		frame[i] -> setFrame();
	}

	return;
}

void CRHistogramDisplay::update( Konoe1DHistogram** hist )
{
	for( int i=0; i<numHist; i++ ) {
		canvas[i] -> setDataSource( hist[i] );
		canvas[i] -> draw();
	}
	canvas[0] -> update();

	return;
}

void CRHistogramDisplay::initialize()
{

	strcpy( this -> title, getMWTitle() );
	this -> numPanel = getNumHist();
	this -> numCanvas = getNumHist();
	this -> numFrame = getNumFrame();
	this -> numHist = getNumHist();

	this -> histTitle = new KChar* [numHist];
	this -> histColor = new KChar* [numHist];
	this -> histBGColor = new KChar* [numHist];
	for( int i=0; i<numHist; i++ ) {
		this -> histTitle[i] = getHistTitle(i);
		this -> histColor[i] = getHistColor(i);
		this -> histBGColor[i] = getHistBGColor(i);
	}

	return;
}
