/*
	CRHistgramDisplay.hh

	Version 0.0.0	1-Jan-2003	mor
*/

#ifndef __CRHISTOGRAMDISPLAY_HH
#define __CRHISTOGRAMDISPLAY_HH

#include <ui/KonoeTclMainWindow.hh>
#include <ui/KonoeTclDrawCanvas.hh>
#include <ui/KonoeTclDrawPanel.hh>
#include <ui/KonoeTclDimension.hh>
#include <analysis/KonoeLinearDataScale.hh>

#include "CRHistogramNameSpace.hh"

class CRHistogramDisplay : public CRHistogramNameSpace {
public:
	CRHistogramDisplay();
	~CRHistogramDisplay();

	void construct();
	void update( Konoe1DHistogram** hist );
	void initialize();
	
private:
	enum { CHAR_LENGTH = 256 };
	KonoeTclMainWindow* mw;
	KonoeTclDrawPanel** panel;
	KonoeTclDrawCanvas** canvas;
	KonoeTclFrame** frame;
	Konoe1DHistogram** dummy;

	KChar title[CHAR_LENGTH];
	KInt numFrame;
	KInt numHist;
	KInt numPanel;
	KInt numCanvas;

	KDouble minScale;
	KDouble maxScale;

	KChar** histTitle;
	KChar** histColor;
	KChar** histBGColor;
	KInt tate;
	KInt yoko;
};

#endif
