/*
	CRHistogramNameSpace.hh

	Version 0.0.0	2-Jan-2003	mor
*/

#ifndef __CRHISTOGRAMNAMESPACE_HH
#define __CRHISTOGRAMNAMESPACE_HH

#include <string.h>
#include "CRNameSpaceExtractor.hh"
#include "CRNameSpaceSetter.hh"

class CRHistogramNameSpace : public CRNameSpaceExtractor,
			    public CRNameSpaceSetter {
public:
	CRHistogramNameSpace();
	virtual ~CRHistogramNameSpace();

	void extract();
	void update();
	void show();

	inline KInt getHubPort() { return (this -> hubPort); }
	inline KChar* getHubHost() { return (this -> hubHost); }

	inline KChar* getMWTitle() { return (this -> title); }
	inline KInt getNumHist() { return (this -> numHist); }
	inline KInt getNumFrame() { return (this -> numFrame); }
	inline KInt getMinScale() { return (this -> minScale); }
	inline KInt getMaxScale() { return (this -> maxScale); }
	inline KInt getTate() { return (this -> tate); }
	inline KInt getYoko() { return (this -> yoko); }

	inline void showHubHost()
	{ cout << "HubPort : " << this -> getHubPort() << endl; }
	inline void showHubPort()
	{ cout << "HubHost : " << this -> getHubHost() << endl; }
	inline void showMWTitle()
	{ cout << "MWTitle : " << this -> getMWTitle() << endl; }
	inline void showNumHist()
	{ cout << "Number_Hist : " << this -> getNumHist() << endl; }
	inline void showNumFrame()
	{ cout << "Number_Frame : " << this -> getNumFrame() << endl; }
	inline void showMinScale()
	{ cout << "minScale : " << this -> getMinScale() << endl; }
	inline void showMaxScale()
	{ cout << "maxScale : " << this -> getMaxScale() << endl; }
	inline void showTate()
	{ cout << "TATE : " << this -> getTate() << endl; }
	inline void showYoko()
	{ cout << "YOKO : " << this -> getYoko() << endl; }

	inline KChar* getHistColor( KInt i )
	{ return histColor[i]; }
	inline KChar* getHistBGColor( KInt i )
	{ return histBGColor[i]; }
	inline KChar* getHistTitle( KInt i )
	{ return histTitle[i]; }

private:
	enum { CHAR_LENGTH = 128 };
	KInt hubPort;
	KChar hubHost[CHAR_LENGTH];

	KChar title[CHAR_LENGTH];
	KInt numHist;
	KInt numFrame;
	KInt minScale;
	KInt maxScale;
	KInt tate;
	KInt yoko;

	KChar* histTitle[256];
	KChar* histColor[256];
	KChar* histBGColor[256];
//	KChar** histTitle;
//	KChar** histColor;
//	KChar** histBGColor;
};

#endif
