/*
	CRRecieveData.hh

	Version 0.0.0	07-Jan-2003	mor
*/

#ifndef __CRRECIEVEDATA_HH
#define __CRRECIEVEDATA_HH

#include <vector>
#include <string.h>
#include <unistd.h>
#include "CRHistogramNameSpace.hh"
#include "CRConnectServer.hh"
#include "CRHistogramDisplay.hh"

#include <analysis/KonoeDataRecord.hh>
#include <analysis/KonoeDataRecordCM.hh>
#include <analysis/KonoeDataSection.hh>
#include <analysis/KonoeDataSegment.hh>
#include <analysis/KonoeDataElement.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeLinearDataScale.hh>
#include <analysis/KonoeFillData.hh>

class CRRecieveData : public CRHistogramNameSpace {
public:
	CRRecieveData();
	virtual ~CRRecieveData();

	void go();

private:
	enum { CHAR_LENGTH = 256 };

	CRConnectServer* con_soc;
	CRHistogramDisplay* hist_dis;

  KonoeDataRecord* rec;
  KonoeDataSection* sec;
  KonoeDataSegment* seg;
  KonoeDataElement* ele;
  KInt* place;

	KInt hubPort;
	KChar hubHost[CHAR_LENGTH];

	KInt numHist;
	KFloat minScale;
	KFloat maxScale;
};

#endif
