/*
	CRNameSpaceExtractor.cc

	Version 0.0.0	07-Aug-2002	mor
	Version 0.0.1	20-Dec-2002	mor
*/

#include "CRNameSpaceExtractor.hh"
#include <stdlib.h>
#include <string.h>

CRNameSpaceExtractor::CRNameSpaceExtractor()
{
  table = new KonoeNameSpaceTable();
}

CRNameSpaceExtractor::~CRNameSpaceExtractor()
{
  delete table;
}

KInt CRNameSpaceExtractor::getKIntValue( KChar* item )
{
  KonoeNameSpaceValue* value;
  value = table -> getValue( item );

  if( value == 0 ) {
    delete value;
    return -1;
  }else {
    ext_kint = atoi( (KChar*)*value );
    delete value;
    return ext_kint;
  }
}

KChar* CRNameSpaceExtractor::getKCharValue( KChar* item )
{
  KonoeNameSpaceValue* value;
  value = table -> getValue( item );

  if( value == 0) {
    delete value;
    return (KChar*)-1;
  }else {
    strcpy( ext_kchar, (KChar*)*value );
    delete value;
    return ext_kchar;
  }
}

KInt CRNameSpaceExtractor::getKIntValue( KChar* item, KInt cnt )
{
  KInt j = 0;
  KInt k = 0x30 + cnt;
  KChar* tmp = new KChar [64];
  KonoeNameSpaceValue* value;

  for( int i=0; i<strlen(item); i++,j++ ) {
    if( item[i] == '[' ) {
      tmp[j] = k;
      i++;
      i++;
    } else {
      tmp[j] = item[i];
    }
  }
  tmp[j] = 0x0;


  value = table -> getValue( tmp );

  if( value == 0 ) {
    delete value;
    return -1;
  } else {
    ext_kint = atoi( (KChar*)*value );
    delete value;
    return ext_kint;
  }
}

KChar* CRNameSpaceExtractor::getKCharValue( KChar* item, KInt cnt )
{
  KInt j = 0;
  KInt k = 0x30 + cnt;
  KChar* tmp = new KChar [64];
  KonoeNameSpaceValue* value;

  for( int i=0; i<strlen(item); i++,j++ ) {
    if( item[i] == '[' ) {
      tmp[j] = k;
      i++;
      i++;
    } else {
      tmp[j] = item[i];
    }
  }
  tmp[j] = 0x0;

  value = table -> getValue( tmp );

  if( value == 0) {
    delete value;
    return (KChar*)-1;
  }else {
    strcpy( ext_kchar, (KChar*)*value );
    delete value;
    return ext_kchar;
  }
}
