/*
	CRReconstructNameSpace.hh

	Version 0.0.0	23-Aug-2002	mor
*/

#ifndef __CRRECONSTRUCTNAMESPACE_HH
#define __CRRECONSTRUCTNAMESPACE_HH

#include <system/KonoeHostSystem.hh>
#include "CRNameSpaceExtractor.hh"
#include "CRNameSpaceSetter.hh"

class CRReconstructNameSpace : public CRNameSpaceSetter,
                               public CRNameSpaceExtractor { 
private:
  enum { CHAR_LENGTH = 256 };

  KChar reconstHost[ CHAR_LENGTH ];
  KChar reconstStatus[ CHAR_LENGTH ];
  KChar dataHubHost[ CHAR_LENGTH ];

  KInt reconstPID;
  KInt reconstCommandPort;
  KInt dataHubOutputPort;

public:
  CRReconstructNameSpace();
  ~CRReconstructNameSpace();

  void update();
  void extract();
  void show();

  inline KChar* getReconstHost() { return (this -> reconstHost); }
  inline KChar* getReconstStatus() { return (this -> reconstStatus); }
  inline KChar* getDataHubHost() { return (this -> dataHubHost); }

  inline KInt getReconstPid() { return (this -> reconstPID); }
  inline KInt getReconstCommandPort() { return (this -> reconstCommandPort); }
  inline KInt getDataHubOutputPort() { return (this -> dataHubOutputPort); }

  inline void showReconstHost()
  { cout << "RECONSTRUCT_HOST : " << this -> getReconstHost() << endl; }
  inline void showReconstStatus()
  { cout << "RECONSTRUCT_STATUS : " << this -> getReconstStatus() << endl; }
  inline void showReconstPid()
  { cout << "RECONSTRUCT_PID : " << this -> getReconstPid() << endl; }
  inline void showReconstCommandPort()
  { cout << "RECONSTRUCT_COMMAND_PORT : " << this -> getReconstCommandPort() << endl; }
  inline void showDataHubHost()
  { cout << "DATAHUB_HOST : " << this -> getDataHubHost() << endl; }
  inline void showDataHubOutputPort()
  { cout << "DATAHUB_OUTPUT_PORT : " << this -> getDataHubOutputPort() << endl; }
};

#endif
