/*
	CRDAQControl.cc

	Version 0.0.2	31-Aug-2002	mor
*/

#include <system/KonoeFDClient.hh>
#include "CRDAQControl.hh"
#include <stdlib.h>
#include <string.h>

CRDAQControl::CRDAQControl( KInt port ) : CRRunControlBase( port )
{
  host = ext -> getKCharValue( "DAQ_HOST" );
  if( host == (KChar*)-1 ) {
    cerr << "DAQ_HOST is not defined." << endl;
  }
}

KInt CRDAQControl::control( KChar* command )
{
  KonoeFDClient* cl = 0;

  if( !strcmp( command, "boot" ) ) {
    return this -> boot();
  }

  KInt pid = ext -> getKIntValue( "DAQ_PID" );
  if( pid == -1 ) {
    cerr << "DAQ_PID is not defined." << endl;
    return -1;
  }

  killer -> kill( host, pid, SIGINT );

  KChar buffer[ 256 ];

  cl = fdset -> wait( 1000 );
  if( cl ) {
    cmd_sender -> receive( buffer, 256 );
    cmd_sender -> reply( command, 256 );
  }
  cl = fdset -> wait( 200 );
  if( cl ) {
    cmd_sender -> receive( buffer, 256 );
    cout << "CRDAQControl cmd reply = " << buffer << endl;
    if( !strcmp( buffer, "true" ) ) {
      return 1;
    }
    if( !strcmp( buffer, "false" ) ) {
      return 0;
    }
  }
  return 0;
}

KInt CRDAQControl::boot()
{
  KChar cmd[64];

  if( ext -> getKIntValue( "DAQ_PID" ) == -1 ) {
    KInt eport = ext -> getKIntValue( "EXE_PORT" );
    if( eport == -1 ) {
      cerr << "EXE DAEMON_PORT is not defined." << endl;
      return -1;
    }

    exe = new KonoeExecutor( eport );

    if( getenv( "CR_ROOT" ) ) {
      strcpy( cmd, getenv( "CR_ROOT" ) );
      strcat( cmd, "/" );
      strcat( cmd, "CRdaq &" );
      exe -> exec( host, cmd );
      delete exe;
      return 1;
    } else {
      exe -> exec( host, "../DAQ/CRdaq &" );
      delete exe;
      return 1;
    }
  }
  return 0;
}
