/*
	CRProcess.cc

	Version 0.0.0	11-Aug-2002	mor
*/

#include "CRProcess.hh"
#include <system/KonoeHostSystem.hh>
#include <string.h>

CRProcess::CRProcess( KInt port ) : cmd_port( port )
{
  ext = new CRNameSpaceExtractor();
  KChar* master_host = ext -> getKCharValue( "MASTER_HOST" );

  if( master_host == (KChar*)-1 ) {
    cerr << "MASTER_HOST is not defined : abort " << endl;
    KonoeHostSystem::exit(0);
  }

  cmd_process = new KonoeUDPClientSocket( master_host, cmd_port );
  handler = new KonoeSignalHandler( SIGINT, this );
  handler -> enable();
}

CRProcess::~CRProcess()
{
  delete ext;
  delete cmd_process;
  delete handler;
}

KInt CRProcess::begin()
{
  return 0;
}

KInt CRProcess::pause()
{
  return 0;
}

KInt CRProcess::end()
{
  return 0;
}

KInt CRProcess::resume()
{
  return 0;
}

KInt CRProcess::shutdown()
{
  return 0;
}

void CRProcess::catchSignal( KInt signal )
{
  KChar cmd[256];

  cmd_process -> send( "ready", 256 );
  cmd_process -> receive( cmd, 256 );

  if( strcmp( cmd, "begin" ) == 0 )
    mode = READY;
  else if( strcmp( cmd, "resume" ) == 0 )
    mode = READY;
  else if( strcmp( cmd, "pause" ) == 0 )
    mode = IDLE;
  else if( strcmp( cmd, "end" ) == 0 )
    mode = STANDBY;
  else if( strcmp( cmd, "shutdown" ) == 0 )
    mode = NONE;
  else
    mode = UNKNOWN;

  cmd_process -> send( "done", 256 );
}
