/*
	CRProcess.hh

	Version 0.0.0	11-Aug-2002	mor
*/

#ifndef __CRPROCESS_HH
#define __CRPROCESS_HH

#include <KonoePrimitives.hh>
#include <system/KonoeSignalClient.hh>
#include <system/KonoeSignalHandler.hh>
#include <system/KonoeUDPClientSocket.hh>
#include <system/KonoeIntervalTimer.hh>

#include "CRNameSpaceExtractor.hh"

class CRProcess : public KonoeSignalClient {
public:
  enum { UNKNOWN = -1 , NONE , STANDBY, READY , IDLE };
  enum { DEFAULTCOMMAND_PORT = 50005 };

protected:
  KInt cmd_port;
  KChar* master_host;
  KonoeSignalHandler* handler;
  KonoeUDPClientSocket* cmd_process;
  virtual void catchSignal( KInt signal );

  CRNameSpaceExtractor* ext;
  KInt mode;

public:
  CRProcess( KInt cmdport = DEFAULTCOMMAND_PORT );
  ~CRProcess();

  virtual KInt begin();
  virtual KInt pause();
  virtual KInt end();
  virtual KInt resume();
  virtual KInt shutdown();
};

#endif
