/*
	CRRunControlBase.cc

	Version 0.0.0	07-Aug-2002	mor
*/

#include "CRRunControlBase.hh"
#include <system/KonoeHostSystem.hh>

CRRunControlBase::CRRunControlBase( KInt port )
{
  cmd_port = port;
  ext = new CRNameSpaceExtractor();
  cmd_sender = new KonoeUDPServerSocket( cmd_port );

  fdset = new KonoeFDSet;
  fdset -> install( cmd_sender );
  killer = new KonoeSignalSender( ext -> getKIntValue( "SIGNAL_PORT" ) );

  if( ext -> getKIntValue( "SIGNAL_PORT" ) == -1 ) {
    cerr << "SIGNAL_PORT is not defined : exit" << endl;
    KonoeHostSystem::exit(0);
  }
}

CRRunControlBase::~CRRunControlBase()
{
  delete ext;
  delete killer ;
	
}
