/*
	daq_controler.cc (CUI)
	
	Version 0.0.0	07-Aug-2002	mor
*/

#include	<system/KonoeIntervalTimer.hh>
#include	<system/KonoeSignalHandler.hh>
#include 	<KonoePrimitives.hh>
#include	"CRDAQControl.hh"
#include	"CRTimeoutHandler.hh"
#include        <system/KonoeHostSystem.hh>
#include        <string.h>

KInt main( KInt argc,KChar* argv[])
{
  enum { UNKNOWN = -1, NONE, STANDBY, READY, IDLE };
  KInt status;
  KInt answer = 0;

  CRTimeoutHandler* timeout = new CRTimeoutHandler();

  KChar cmd[256];

  CRNameSpaceExtractor* ext = new CRNameSpaceExtractor();

  KInt cmd_port = ext -> getKIntValue( "DAQ_CMD_PORT" );

  if( cmd_port == -1 ) {
    cerr << "DAQ_CMD_PORT is not defined : fin" << endl;
    KonoeHostSystem::exit(0);
  }

  cout << "DAQ_CMD_PORT = " << cmd_port << endl;

  CRDAQControl* control = new CRDAQControl( cmd_port );

  status = STANDBY;

  while(1) {
    answer = 0;
    cout << "DAQ:CMD > ";
    cin.getline( cmd, 256 );
    if( !strcmp( cmd, "bye" ) ) {
      cout << "fin ..."<< endl;
      KonoeHostSystem::exit(0);
    } else if( ( status == STANDBY || status == NONE ) && !strcmp( cmd, "begin" ) ) {
      timeout -> setTime( 2000 );
      answer = control -> control( cmd );
      timeout -> setTime( 0 );
      if( answer ) {
        status = READY;
      } else {
        cout << "CMD not reaced! Try again." << endl;
      }
    } else if( status == STANDBY && !strcmp( cmd, "shutdown" ) ) {
      timeout -> setTime( 2000 );
      answer = control -> control( cmd );
      timeout -> setTime( 0 );
      if( answer ) {
        status = NONE;
      } else {
        cout << "CMD not reaced! Try again." << endl;
      }
    } else if( status == READY && !strcmp( cmd, "pause" ) ) {
      timeout -> setTime( 2000 );
      answer = control -> control( cmd );
      timeout -> setTime( 0 );
      if( answer ) {
        status = IDLE;
      } else {
        cout << "CMD not reaced! Try again." << endl;
      }
    } else if( status == IDLE &&  !strcmp( cmd, "end" ) ) {
      timeout -> setTime( 2000 );
      answer = control -> control( cmd );
      timeout -> setTime( 0 );
      if( answer ) {
        status = STANDBY;
      } else {
        cout << "CMD not reaced! Try again." << endl;
      }
    } else if( status == IDLE && !strcmp( cmd, "resume" ) ) {
      timeout -> setTime( 2000 );
      answer = control -> control( cmd );
      timeout -> setTime( 0 );
      if( answer ) {
        status = READY;
      } else {
        cout << "CMD not reaced! Try again." << endl;
      }
    } else {
        cout << "invalid CMD! Try again." << endl;
        cout << "You should type ";
        if( status == STANDBY ) {
          cout << "\"shutdown\" or \"begin\"." << endl;
        } else if( status == NONE ) {
          cout << "\"begin\"." << endl;
        } else if( status == READY ) {
          cout << "\"pause\"." << endl;
        } else if( status == IDLE ) {
          cout << "\"end\" or \"resume\"." << endl;
        } else {
          cout << "??????" << endl;
        }
    }
  }
  delete control;

  return 0;
}
