// $Id: OfflineDAQModuleConstruction.hh,v 1.5 2000/12/28 13:09:04 iwai Exp $
// ==================================================================
//  OfflineDAQModuleConstruction.hh
//  03-December-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __OFFLINEDAQMODULECONSTRUCTION_HH
#define __OFFLINEDAQMODULECONSTRUCTION_HH

#include <daq/KonoeSoftwareCrate.hh>
#include <daq/KonoeSimADCModule.hh>
#include <daq/KonoeSimTDCModule.hh>
#include <daq/KonoeSoftCounter.hh>
#include <daq/KonoeOptionalNumberModule.hh>
#include <daq/KonoeTimerModule.hh>
#include <daq/KonoeClockModule.hh>

#include <daq/KonoeReadoutList.hh>

class OfflineDAQModuleConstruction {

private:
  enum { MAX_SLOT = 32 };

private:
  KonoeReadoutList* runBeginList;
  KonoeReadoutList* runEndList;
  KonoeReadoutList* eventList;
  KonoeReadoutList* spillEndList;

  KonoeSoftwareCrate* theCrate;
  KonoeSimADCModule* theADC0;
  KonoeSimADCModule* theADC1;
  KonoeSimADCModule* theADC2;
  KonoeSimTDCModule* theTDC0;
  KonoeSimTDCModule* theTDC1;
  KonoeSimTDCModule* theTDC2;
  KonoeSimTDCModule* theTDC3;
  KonoeSimTDCModule* theTDC4;
  KonoeSimTDCModule* theTDC5;

  KonoeOptionalNumberModule* theIR0;
  KonoeOptionalNumberModule* theIR1;

  KonoeSimTDCModule* theScaler0;
  KonoeSimTDCModule* theScaler1;

  KonoeOptionalNumberModule* theCR0;
  KonoeOptionalNumberModule* theCR1;
  KonoeOptionalNumberModule* theCR2;

  KonoeTimerModule* theTimer;
  KonoeClockModule* theClock;
  KonoeOptionalNumberModule* theAppend;

  KonoeOptionalNumberModule* runNumber;
  KonoeSoftCounter* eventNumber;
  KonoeOptionalNumberModule* runType;

  KonoeTimerModule* localTimer;

  void generate();
  void install() const;
  void add( KInt recordType, KonoeReadoutSection* aSection );
  void construct( KInt recordType );

  KBool spillEnd;

  KDouble lastTime;
  KDouble currentTime;

public:
  OfflineDAQModuleConstruction();
  ~OfflineDAQModuleConstruction();

  KonoeDataRecord* read( KInt recordType );
  KonoeDataRecord* read();

  void clear() const {;}
  void update() const;
  void initialize() const;
  void spillEndUpdate() const;

  KBool isSpillEnd() const { return ( this -> spillEnd ); }

};

#endif
