// $Id: T473DAQAction.cc,v 1.15 2001/05/20 23:14:01 iwai Exp $
// ==================================================================
//  T473DAQAction.cc
//  05-November-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#include <unistd.h>
#include <stdlib.h>

#include "T473DAQAction.hh"
#include "T473DAQNameSpace.hh"

void T473DAQAction::begin() const
{
  T473DAQNameSpace* ns = new T473DAQNameSpace();
  daqStatus -> setRunNumber( ns -> getRunNumber() );
  daqStatus -> setRunType( ns -> getRunType() );
  ns -> setDaqStatus( "busy" );
  delete ns;
  cout << "[DAQ] T473DAQAction::begin() is called" << endl;
  cout << "[DAQ] status change, STANDBY -> BUSY" << endl;
  return;
}

void T473DAQAction::pause() const
{
  T473DAQNameSpace* ns = new T473DAQNameSpace();
  ns -> setDaqStatus( "idle" );  
  delete ns;
  cout << "[DAQ] T473DAQAction::pause() is called" << endl;
  cout << "[DAQ] status change, BUSY -> IDLE" << endl;
  return;
}

void T473DAQAction::resume() const
{
  T473DAQNameSpace* ns = new T473DAQNameSpace();
  ns -> setDaqStatus( "busy" );
  delete ns;
  cout << "[DAQ] T473DAQAction::resume() is called" << endl;
  cout << "[DAQ] status change, IDLE -> BUSY" << endl;
  return;
}

void T473DAQAction::end() const
{
  T473DAQNameSpace* ns = new T473DAQNameSpace();
  ns -> setDaqStatus( "standby" );  
  delete ns;
  cout << "[DAQ] T473DAQAction::end() is called" << endl;
  cout << "[DAQ] status change, IDLE -> STANDBY" << endl;
  return;
}

void T473DAQAction::shutdown() const
{
  T473DAQNameSpace* ns = new T473DAQNameSpace();
  ns -> setDaqStatus( "none" );  
  ns -> setDaqPid( -1 );
  delete ns;
  cout << "[DAQ] T473DAQAction::shutdown() is called" << endl;
  cout << "[DAQ] status change, STANDBY -> NONE" << endl;
  return;
}

void T473DAQAction::lastAction()
{
  cout << "[DAQ] T473DAQAction::lastAction() is called !" << endl;
  cout << "[DAQ] process is going to shutdown after 1 second." << endl;
  this -> shutdown();
  sleep(1);
  exit(-1);
}
