// $Id: T473DAQModuleConstruction.hh,v 1.21 2000/12/28 13:09:04 iwai Exp $
// ==================================================================
//  T473DAQModuleConstruction.hh
//  05-November-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __T473DAQMODULECONSTRUCTION_HH
#define __T473DAQMODULECONSTRUCTION_HH

#include <daq/KonoeCAMACCrate.hh>
#include <daq/KonoeCAMACADC.hh>
#include <daq/KonoeCAMACTDC.hh>
#include <daq/KonoeCAMACInterruptRegister.hh>
#include <daq/KonoeCAMACOutputRegister.hh>
#include <daq/KonoeCAMACScaler.hh>
#include <daq/KonoeCAMACCoincidenceRegister.hh>

#include <daq/KonoeCAMACXaction.hh>
#include <daq/KonoeReadoutList.hh>

#include <daq/KonoeSoftCounter.hh>
#include <daq/KonoeOptionalNumberModule.hh>
#include <daq/KonoeTimerModule.hh>
#include <daq/KonoeClockModule.hh>

class T473DAQModuleConstruction {

private:
  KonoeReadoutList* runBeginList;
  KonoeReadoutList* runEndList;
  KonoeReadoutList* eventList;
  KonoeReadoutList* spillEndList;

  KonoeCAMACCrate* theCrate;
  KonoeCAMACADC* theADC0;
  KonoeCAMACADC* theADC1;
  KonoeCAMACADC* theADC2;
  KonoeCAMACTDC* theTDC0;
  KonoeCAMACTDC* theTDC1;
  KonoeCAMACTDC* theTDC2;
  KonoeCAMACTDC* theTDC3;
  KonoeCAMACTDC* theTDC4;
  KonoeCAMACTDC* theTDC5;
  KonoeCAMACInterruptRegister* theIR0;
  KonoeCAMACInterruptRegister* theIR1;
  KonoeCAMACOutputRegister* theOR0;
  KonoeCAMACOutputRegister* theOR1;
  KonoeCAMACScaler* theScaler0;
  KonoeCAMACScaler* theScaler1;
  KonoeCAMACCoincidenceRegister* theCR0;
  KonoeCAMACCoincidenceRegister* theCR1;
  KonoeCAMACCoincidenceRegister* theCR2;

  KonoeTimerModule* theTimer;
  KonoeClockModule* theClock;
  KonoeOptionalNumberModule* theAppend;

  KonoeOptionalNumberModule* runNumber;
  KonoeSoftCounter* eventNumber;
  KonoeOptionalNumberModule* runType;

  void generate();
  void install() const;
  void add( KInt recordType, KonoeReadoutSection* aSection );
  void construct( KInt recordType );

  KBool spillEnd;

public:
  T473DAQModuleConstruction();
  ~T473DAQModuleConstruction();

  KonoeDataRecord* read( KInt recordType );
  KonoeDataRecord* read();

  inline void cancellLatch() const { this -> theOR0 -> writePulse(1); }
  inline void setI() { this -> theOR1 -> writeLevel(1); }
  inline void removeI() const { this -> theOR1 -> writeLevel(0); }

  void clear() const {;}
  void update() const;
  void initialize() const;
  void spillEndUpdate() const;

  KBool isSpillEnd() const { return ( this -> spillEnd ); }

};

#endif
