// $Id: T473DAQNameSpace.cc,v 1.7 2000/12/09 15:12:04 iwai Exp $
// ==================================================================
//  T473DAQNameSpace.cc
//  15-November-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#include "T473DAQNameSpace.hh"

T473DAQNameSpace::T473DAQNameSpace()
{
  this -> extract();
  this -> update();
}

T473DAQNameSpace::~T473DAQNameSpace()
{
  this -> update();
}

void T473DAQNameSpace::extract()
{
  runNumber = getKIntValue("RUN_NUMBER");
  daqCommandPort = getKIntValue("DAQ_CMD_PORT");
  this -> daqPID = KonoeHostSystem::getPid();
  dataHubInputPort = getKIntValue("DATAHUB_INPUT_PORT");

  strcpy( this -> masterHost, getKCharValue("MASTER_HOST") );
  strcpy( this -> runType, getKCharValue("RUN_TYPE") );
  strcpy( this -> dataHubHost, getKCharValue("DATAHUB_HOST") );
  strcpy( this -> daqStatus, getKCharValue("DAQ_STATUS") );

  KChar tmp[CHAR_LENGTH];
  KonoeHostSystem::getHostName(tmp, CHAR_LENGTH);
  strcpy( this -> daqHost, tmp );

  return;
}

KInt T473DAQNameSpace::getRunType() const
{ 
  if ( strcmp( this -> runType, "luminosity_run" ) == 0 )
    return (0);
  else if ( strcmp( this -> runType, "electron_run" ) == 0 )
    return (1);
  else if ( strcmp( this -> runType, "hadron_run" ) == 0 )
    return (2);
  else if ( strcmp( this -> runType, "cosmic_ray_run" ) == 0 )
    return (3);
  else if ( strcmp( this -> runType, "pedestal_run" ) == 0 )
    return (4);
  else if ( strcmp( this -> runType, "other_run" ) == 0 )
    return (5);
  else
    return (5);
}

KBool T473DAQNameSpace::isValidItem(KChar* item)
{
  KInt a = strcmp(item, "DAQ_STATUS");
  KInt b = strcmp(item, "DAQ_PID");
  KInt c = strcmp(item, "DAQ_HOST");
  return ( a==0 | b==0 | c==0 );
}

void T473DAQNameSpace::update()
{
  set( "DAQ_STATUS", this -> getDaqStatus() );
  set( "DAQ_PID", this -> getDaqPid() );
  set( "DAQ_HOST", this -> getDaqHost() );
  return;
}

void T473DAQNameSpace::update(KChar* item, KInt value)
{
  if ( (this->isValidItem(item)) == KFalse )
    return;
  else if ( strcmp(item, "DAQ_PID") == 0 )
    this -> setDaqPid(value);
  this -> update();
  return;
}

void T473DAQNameSpace::update(KChar* item, KChar* value)
{
  if ( (this->isValidItem(item)) == KFalse )
    return;
  else if ( strcmp(item, "DAQ_STATUS") == 0 )
    this -> setDaqStatus(value);
  else if ( strcmp(item, "DAQ_HOST") == 0 )
    this -> setDaqHost(value);
  this -> update();
  return;
}

void T473DAQNameSpace::show()
{
  this -> showRunNumber();
  this -> showDaqPort();
  this -> showDaqPid();
  this -> showDataHubPort();
  this -> showRunType();
  this -> showMasterHost();
  this -> showDataHubHost();
  this -> showDaqStatus();
  this -> showDaqHost();
  return;
}
