// $Id: T473DAQNameSpace.hh,v 1.9 2001/05/20 23:13:45 iwai Exp $
// ==================================================================
//  T473DAQNameSpace.hh
//  15-November-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __T473DAQNAMESPACE_HH
#define __T473DAQNAMESPACE_HH

#include <system/KonoeHostSystem.hh>
#include <string.h>
#include "T473NameSpaceExtractor.hh"
#include "T473NameSpaceSetter.hh"

class T473DAQNameSpace : public T473NameSpaceSetter, public T473NameSpaceExtractor {

private:
  enum { CHAR_LENGTH = 256 };

private:
  KInt runNumber;
  KInt daqCommandPort;
  KInt daqPID;
  KInt dataHubInputPort;

  KChar runType[CHAR_LENGTH];
  KChar masterHost[CHAR_LENGTH];
  KChar dataHubHost[CHAR_LENGTH];
  KChar daqStatus[CHAR_LENGTH];
  KChar daqHost[CHAR_LENGTH];

  KBool isValidItem(KChar* item);

public:
  T473DAQNameSpace();
  ~T473DAQNameSpace();

  // utilities
  void update();
  void update(KChar* item, KInt value);
  void update(KChar* item, KChar* value);
  void extract();
  void show();

  // set/get member functions
  inline KInt getRunNumber() const { return ( this -> runNumber ); }
  inline KInt getDaqPort() const { return ( this -> daqCommandPort ); }
  inline KInt getDaqPid() const { return ( this -> daqPID ); }
  inline KInt getDataHubPort() const { return ( this -> dataHubInputPort ); }
  inline KChar* getMasterHost() { return ( this -> masterHost ); }
  inline KChar* getDataHubHost() { return ( this -> dataHubHost ); }
  inline KChar* getDaqStatus() { return ( this -> daqStatus ); }
  inline KChar* getDaqHost() { return ( this -> daqHost ); }
  KInt getRunType() const;

  inline void setDaqPid(KInt val) { (this -> daqPID) = val; }
  inline void setDaqStatus(KChar* str) { strcpy(this -> daqStatus, str); }
  inline void setDaqHost(KChar* str) { strcpy(this -> daqHost, str); }

  inline void showRunNumber() const 
  { cout << "RUN_NUMBER=" << this -> getRunNumber() << endl; }
  inline void showDaqPort() const
  { cout << "DAQ_CMD_PORT=" << this -> getDaqPort() << endl; }
  inline void showDaqPid() const
  { cout << "DAQ_PID=" << this -> getDaqPid() << endl; }
  inline void showDataHubPort() const
  { cout << "DATAHUB_INPUT_PORT=" << this -> getDataHubPort() << endl; }
  inline void showMasterHost()
  { cout << "MASTER_HOST=" << this -> getMasterHost() << endl; }
  inline void showDataHubHost()
  { cout << "DATAHUB_HOST=" << this -> getDataHubHost() << endl; }
  inline void showDaqStatus()
  { cout << "DAQ_STATUS=" << this -> getDaqStatus() << endl; }
  inline void showDaqHost()
  { cout << "DAQ_HOST=" << this -> getDaqHost() << endl; }
  inline void showRunType()
  { cout << "RUN_TYPE=" << this -> getRunType() << endl; }

};

#endif
