// $Id: T473DAQStatus.hh,v 1.7 2000/12/05 08:51:57 iwai Exp $
// ==================================================================
//  T473DAQStatus.hh
//  05-November-2000'
//  Go Iwai [iwai@hep.sc.niigata-u.ac.jp]
// ==================================================================
#ifndef __T473DAQSTATUS_HH
#define __T473DAQSTATUS_HH

#include <KonoePrimitives.hh>

class T473DAQStatus {

public:
  enum DAQStatus { none, standby, busy, idle };
  enum DAQCommand { unknown, begin, pause, resume, end, shutdown };

private:
  static DAQStatus DAQ_STATUS;
  static DAQCommand DAQ_COMMAND;
  static KInt RUN_NUMBER;
  static KInt RUN_TYPE;
  
  static KInt initialize( const DAQStatus status = standby );
  static KInt finalize();

public:
  T473DAQStatus( const DAQStatus status = standby ) { initialize(status); }
  ~T473DAQStatus() { finalize(); }

  static void showStatus();
  static void showCommand();

  static KBool isValidCommand(KChar* str);
  static KBool isInstanciate();

  // set/get member functions
  inline static void setStatus( DAQStatus status ) 
  { DAQ_STATUS = status; }
  inline static DAQStatus getStatus() 
  { return (DAQ_STATUS); }
  inline static void setCommand( DAQCommand command ) 
  { DAQ_COMMAND = command; }
  inline static DAQCommand getCommand() 
  { return (DAQ_COMMAND); }
  inline static void setRunType( KInt type ) 
  { RUN_TYPE = type; }
  inline static KInt getRunType() 
  { return (RUN_TYPE); }
  inline static void setRunNumber( KInt number ) 
  { RUN_NUMBER = number; }
  inline static KInt getRunNumber()
  { return (RUN_NUMBER); }

};

#endif
