//=================================================================
/*

        T473DataHub.hh

        Version 0.6.0   04-Oct-2000     Kentaro Mizouchi

*/
//=================================================================
/*
   Dual port version.
   Input port is independent on output port.
*/

#ifndef  __T473DATAHUB_HH
#define  __T473DATAHUB_HH

#include <string.h>
#include <stdlib.h>
#include <KonoePrimitives.hh>
// #include <system/KonoeDataHub.hh>
#include <system/KonoeObjectServerSocket.hh>
#include <system/KonoeOutputObjFile.hh>
#include <system/KonoeNameSpaceTable.hh>
#include <analysis/KonoeDataRecord.hh>

class T473DataHub
				//  : public KonoeDataHub 
			{

public:
// name space entry string
	static const KChar* DATAHUB_INPUT_PORT;
	static const KChar* DATAHUB_OUTPUT_PORT;
	static const KChar* DATAHUB_STORAGE_FILE_NAME;
	static const KChar* DATAHUB_BUFFER_SIZE;

// command strings
	static const KChar* DATAHUB_CMD_FILE_CLOSE;
	static const KChar* DATAHUB_CMD_NEW_FILE;
	static const KChar* DATAHUB_CMD_CHANGE_BUFFER_SIZE;
	static const KChar* DATAHUB_CMD_IGNORE_OUTPUT_PORT;

// request strings
	static const KChar* DATAHUB_REQ_HEAD;
	static const KChar* DATAHUB_REQ_CURRENT;
	static const KChar* DATAHUB_REQ_TAIL;

protected:		
	KChar *			name;	// ID
	KonoeObjectServerSocket	* in_server, * out_server; 	
	KonoeObjectSocket   *	client;
	KonoeOutputObjFile  *	out_file;	
	KonoeNameSpaceTable *	name_table;	

	void **	buffer;
	KInt	buffer_size;	

	KInt	write_address;
	KInt	data_length[ KonoeObjectServerSocket::MAX_CLIENTS ];

	KBool	WRITE_TO_FILE,  IGNORE_OUTPUT_PORT;
	

// default value 
	enum	{
		INPUT_PORT = 81000, OUTPUT_PORT = 81001, 
		BUFFER_SIZE = 1000 
		};

	static const KChar * DEFAULT_STORAGE_FILE_NAME;

public:
	T473DataHub( KChar*  tag_name);
	~T473DataHub();
	
	KInt	go();

protected:
	KInt	ring_counter( KInt counter );
	KInt    find_index( KonoeObjectSocket * client );
	void	get_data();
	void	put_data( void * obj );
	void	request_analyzer();
	void	cmd_new_file();
};


#endif
