//=====================================================================
/*

    T473Tcl2DEventDisplay.hh

    Version 0.0.1   28-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCL2DEVENTDISPLAY_HH
#define __T473TCL2DEVENTDISPLAY_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclAction.hh>

class KonoeTclWindow;
class KonoeTclSubWindow;
class KonoeTclCanvas;
class KonoeTcl2DrawPanel;
class KonoeTcl2DrawCanvas;
class KonoeTcl2DrawCanvasController;
class KonoeTcl2DHistogram;
class KonoeDataScale;

class T473Tcl2DEventDisplay : public KonoeTclEventProcessor,
                              public KonoeTclMouseAction,
                              public KonoeTclWindowAction {

  public:
    T473Tcl2DEventDisplay(KonoeTclWindow* pwin);
    ~T473Tcl2DEventDisplay();
    void setDataSource(
            KInt pADCvalue[], KFloat pADCenergy[], KFloat pHitTime[] );
    void setVerticalScale( KonoeDataScale* pScale );
    void setDisplayData(KInt mode);
    void setSize( KInt width, KInt height );

    void draw();

  private:
    void initPanel();
    void drawADCenergy();
    void drawADCvalue();

    void mouseAction(KonoeTclCanvas* btp, KInt type, KInt button,
                      Time time, KInt x, KInt y);
    void windowAction(KonoeTclWindow* kcv, XEvent* xev);

  private:
    KonoeTclSubWindow* subWindow;
    KonoeTcl2DrawPanel* drawPanel;
    KonoeTcl2DrawCanvas* drawCanvas;
    KonoeTcl2DrawCanvasController* controller;

    KInt   adcValue[25];
    KFloat adcEnergy[25];
    KFloat hitTime[25];

    KInt displayData;
    enum { KHITENERGY, KADCVALUE, KHITENERGY_HITTIME, KADCVALUE_HITTIME };
};

#endif
