//=====================================================================
/*

    T473TclEventDisplay.hh

    Version 0.0.1   09-Oct-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLEVENTDISPLAY_HH
#define __T473TCLEVENTDISPLAY_HH

#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclWidget.hh>

class KonoeClientSocket;
class KonoeInputObjSocket;

class KonoeTclWindow;
class KonoeTclSubWindow;
class KonoeTclEventViewCanvas;
class KonoeTclEventViewPanel;
class KonoeTclPhysPlacement;
class KonoeTclEventHitPoint;
//class T473TclEventDisplayData;
class T473TclEventDisplayInfo;
class T473ReconstructData;
//class T473Tcl2DEventDisplay;

#include <analysis/KonoeDetectorList.hh>
class T473TclSetup;


class T473TclEventDisplay : public KonoeTclEventProcessor,
                            public KonoeTclWindowAction {

  public:
    T473TclEventDisplay(KonoeTclWindow* kwin, KonoeDetectorList* dl);
    ~T473TclEventDisplay();

    void setViewLotation(KFloat value);
    void setViewAngle(KFloat value);
    void saveToPostScript(KChar* fName);
    void saveToXWD(KChar* fName);
    void setMagnification(KFloat value);
    void setCenterEye(KInt eyeX, KInt eyeY);
    void showGeometry();
    void hideGeometry();

    void draw();
    void drawEventInfo();
    void update();
    void dump( ostream& os );

    void setForceWireFrame();
    void unsetForceWireFrame();
    void setScale();
    void unsetScale();

    void rotateY(KFloat thetaY);

    void setSlowDraw();
    void unsetSlowDraw();

    void setDisplayData(KInt n);
    void setStatus( T473ReconstructData* rec_data );
    void setHitColor();
    void setThetaY();

    KFloat* getHitEnergy() { return hitEnergy; }
    KFloat* getHitTime()   { return hitTime; }
    KInt*   getADCValue()  { return adcValue; }
    KInt*   getTDCValue()  { return tdcValue; }

  private:
    void initWidget();
    void drawCoincidence();
    KChar coin[16];

    void windowAction(KonoeTclCanvas* kcv, XEvent* xev);

  private:
    KonoeTclWindow* kwin;
    KonoeTclSubWindow* subWindow;
    KonoeTclFrame* leftFrame;
    KonoeTclFrame* rightFrame;

    KonoeTclEventViewCanvas* eventCanvas;
    KonoeTclEventViewPanel* drawPanel;

    T473TclEventDisplayInfo* info;
    T473TclSetup* setup;

    KonoeTclPhysPlacement** phys1;
    KonoeDetectorList* detectorList;

    KonoeTclEventHitPoint* hitPoint;

    KChar** str;

    KInt   eventNumber; 
    KInt   runNumber; 
    KFloat hitPointX; 
    KFloat hitPointY; 
    KFloat hitPointZ;

    KFloat hitEnergy[25];
    KFloat hitTime[25];
    KInt adcValue[25];
    KInt tdcValue[25];

    KInt displayData;
    enum { KHITENERGY, KADCVALUE, KHITENERGY_HITTIME, KADCVALUE_HITTIME };
};

#endif
