//=====================================================================
/*

    T473TclEventDisplayControl.hh

    Version 0.0.1   04-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLEVENTDISPLAYCONTROL_HH
#define __T473TCLEVENTDISPLAYCONTROL_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclSpaceManager.hh>

#include <T473TclEventDisplay.hh>
#include <T473TclEventDisplayRequest.hh>
#include <T473Tcl2DEventDisplay.hh>
#include <T473TclEventDisplayData.hh>

class KonoeDetector;
class KonoeDetectorList;

class T473TclEventDisplayControl : public KonoeTclActionListener,
                                   public KonoeTclMouseAction,
                                   public KonoeTclEventProcessor,
                                   public KonoeTclKeyAction,
                                   public KonoeTclTimer {

  public:
    T473TclEventDisplayControl(KonoeTclWindow* kwin);
    ~T473TclEventDisplayControl();

    void createEventDisplay();
    void create2DEventDisplay();
    void setRequestType(KInt type);
    void changeState(KInt st);
    void setDisplayData(KInt mode);

  public:
    enum { REQUEST_INTERVAL = 3000 }; //mili second
    enum { EVENT_TRIGGER, XENON_TRIGGER, RANDOM_TRIGGER };
    enum { KReqType, KGet, KInfoChange, KReqChange };

  private:
    void initWidget();
    void setThetaY();
    void setButtonAction();
    void postscriptAction();
    void xwdAction();

    void mouseAction(KonoeTclButton* btp, KInt type, KInt button,
                      Time time, KInt x, KInt y);
    void mouseAction(KonoeTclWindow* btp, KInt type, KInt button,
                      Time time, KInt x, KInt y);
    void keyAction(KonoeTclEntry* kbt, KInt type, KeySym keysym, KInt state);
    void timer();

  private:
    KonoeTclWindow* kwin;

    KonoeDetector* d;
    KonoeDetectorList* dl;
    T473TclEventDisplay* ed;
    T473TclEventDisplayRequest* req;
    T473TclEventDisplayData* data;
    T473Tcl2DEventDisplay* ed2d;


    KonoeTclFrame* globalFrame;
    KonoeTclFrame* frame1;
    KonoeTclFrame* frame2;
    KonoeTclFrame* frame3;
    KonoeTclFrame* frame4;
    KonoeTclFrame* frame5;
    KonoeTclFrame* frame6;
    KonoeTclFrame* frame7;
    KonoeTclFrame* frame8;
    KonoeTclFrame* frame9;
    KonoeTclFrame* frame10;
    KonoeTclFrame* frame11;
    KonoeTclFrame* frame12;

    KonoeTclLabel* viewLotationLabel;
    KonoeTclSlider* viewLotationSlider;
    KonoeTclLabel* viewAngleLabel;
    KonoeTclSlider* viewAngleSlider;

    KonoeTclLabel* viewingModeLabel;
    KonoeTclRadioButton* wireFrameRadio;
    KonoeTclRadioButton* surfaceRadio;

    KonoeTclLabel* targetPointLabel;
    KonoeTclLabel* xCoordLabel;
    KonoeTclEntry* xCoordEntry;
    KonoeTclLabel* yCoordLabel;
    KonoeTclEntry* yCoordEntry;

    KonoeTclLabel* magnificationLabel;
    KonoeTclEntry* magnificationEntry;

    KonoeTclLabel* displayAxesLabel;
    KonoeTclRadioButton* displayAxesYesRadio;
    KonoeTclRadioButton* displayAxesNoRadio;

    KonoeTclLabel* drawModeLabel;
    KonoeTclRadioButton* slowDrawRadio;
    KonoeTclRadioButton* fastDrawRadio;

    KonoeTclRadioButton* showGeometryRadio;
    KonoeTclRadioButton* hideGeometryRadio;

    KonoeTclButton* postscriptButton;
    KonoeTclEntry* postscriptEntry;

    KonoeTclButton* xwdButton;
    KonoeTclEntry* xwdEntry;

    KonoeTclButton* setupButton;

    KFloat thetaY;

    KBool isDetail;
    KInt state;
    KInt reqtype;
};

#endif
