//=====================================================================
/*

    T473TclEventDisplayData.cc

    Version 0.0.1   21-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclEventDisplayData.hh>
#include <system/KonoeNameSpaceTable.hh>
#include <system/KonoeClientSocket.hh>
#include <system/KonoeInputObjSocket.hh>
#include <analysis/KonoePhysicalValueCM.hh>
#include <analysis/KonoeGeometryCM.hh>
#include <Reconstruct/T473CsIdata.hh>
#include <Reconstruct/T473ReconstructCM.hh>
#include <Reconstruct/T473ReconstructData.hh>

#include <stdlib.h>
#include <unistd.h>

T473TclEventDisplayData::T473TclEventDisplayData()
{
  rec_host = (KChar*) table.getValue( "RECONSTRUCT_HOST" )->get();
  value = (KChar*)table.getValue( "REC_TO_GUI_PORT" )->get();
cout << rec_host << " : " << value << endl;

  client_socket = new KonoeClientSocket(rec_host, atoi(value));
  recv_socket = new KonoeInputObjSocket(client_socket);
  fd_set.install( client_socket );

  recv_socket->installCM( new KonoePhysicalValueCM() );
  recv_socket->installCM( new KonoeGeometryCM() );
  recv_socket->installCM( new T473ReconstructCM() );
}

T473TclEventDisplayData::~T473TclEventDisplayData()
{
  delete client_socket;
}

void T473TclEventDisplayData::requestType(KInt reqtype)
{
  KChar buffer[256];

  switch(reqtype){
    case EVENT_TRIGGER :
      client_socket->send( "EVENT_TRIGGER", 256 );
      //client_socket->receive( buffer, 256 );
cout << buffer << endl;
      break;
    case XENON_TRIGGER :
      client_socket->send( "XENON_TRIGGER", 256 );
      //client_socket->receive( buffer, 256 );
cout << buffer << endl;
      break;
    case RANDOM_TRIGGER :
      client_socket->send( "RANDOM_TRIGGER", 256 );
      //client_socket->receive( buffer, 256 );
cout << buffer << endl;
      break;
    default: cout << "################  default" << endl;
  }
}

T473ReconstructData* T473TclEventDisplayData::getReconstructData()
{
  KInt st;
  const KChar* request = "GUI_REQ_CURRENT";

  if( client_socket -> getStatus() != KonoeClientSocket::CONNECTED )
    return 0;

  st = client_socket -> send( request, 256 );
    if ( st < 0 ) return 0;

  KInt i = 30;
  while( i-- ){
    if( !(fd_client = fd_set.wait(100)) ){
      continue;
    }
    else{
      rec_data = (T473ReconstructData*) recv_socket->get(0);
      return rec_data;
    }
  }

}

void T473TclEventDisplayData::infoChange()
{
  KChar buffer[256];
  client_socket->send("CHANGE_INFO_TYPE", 256);

  //client_socket->receive( buffer, 256 );
}

void T473TclEventDisplayData::requestChange()
{
  client_socket->send("CHANGE_REQUEST_TYPE", 256);
}
