//=====================================================================
/*

    T473TclEventDisplayInfo.cc

    Version 0.0.1   24-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclEventDisplayInfo.hh>

T473TclEventDisplayInfo::T473TclEventDisplayInfo(KonoeTclWindow* pwin)
{
  kwin = pwin;

  initWidget();
}

T473TclEventDisplayInfo::~T473TclEventDisplayInfo()
{ ; }

void T473TclEventDisplayInfo::initWidget()
{
  KChar name[256];
  KChar value[256];
  KInt i;

  hpFrame = new KonoeTclFrame(kwin, "hpFrame");


// Run Number and Event Number
  runNumLabel = new
         KonoeTclLabel(hpFrame, "runNumLabel", "Run Number", 0, 0);
  eventNumLabel = new
         KonoeTclLabel(hpFrame, "eventNumLabel", "Event Number", 0, 1);
  runNumVLabel = new
         KonoeTclLabel(hpFrame, "runNumVLabel", "", 2, 0);
  eventNumVLabel = new
         KonoeTclLabel(hpFrame, "eventNumVLabel", "", 2, 1);

  runNumLabel->setGridSticky("w");
  eventNumLabel->setGridSticky("w");
  runNumVLabel->setGridSticky("e");
  eventNumVLabel->setGridSticky("e");


// Hit Point
  hpLabel = new KonoeTclLabel(hpFrame, "hpLabel", "Hit Point", 0, 2);
  hpValueLabel = new KonoeTclLabel(hpFrame, "hpValueLabel", "(0, 0, 0)", 2, 2);

  hpLabel->setGridSticky("w");


// Coincidence Register
  coinRegLabel0 = new
      KonoeTclLabel(hpFrame, "coinRegLabel0", "coincidence\nregister 0", 0, 3);
  coinRegLabel1 = new
      KonoeTclLabel(hpFrame, "coinRegLabel1", "coincidence\nregister 1", 0, 4);
  coinRegLabel2 = new
      KonoeTclLabel(hpFrame, "coinRegLabel2", "coincidence\nregister 2", 0, 5);

  coinRegVLabel0 = new KonoeTclLabel(hpFrame, "coinRegVLabel0", "", 2, 3);
  coinRegVLabel1 = new KonoeTclLabel(hpFrame, "coinRegVLabel1", "", 2, 4);
  coinRegVLabel2 = new KonoeTclLabel(hpFrame, "coinRegVLabel2", "", 2, 5);

  coinRegLabel0->setGridSticky("w");
  coinRegLabel1->setGridSticky("w");
  coinRegLabel2->setGridSticky("w");

  coinRegVLabel0->setGridSticky("e");
  coinRegVLabel1->setGridSticky("e");
  coinRegVLabel2->setGridSticky("e");

  dummyA = new KonoeTclFrame(hpFrame, "dummyA", 1, 0);
  dummyA->setGridRowspan(6);
  dummyA->setSize(10, 1);

  hpFrame->setFrame();
  hpFrame->fillX();


// CsI data
  dummy0 = new KonoeTclFrame(kwin, "dummy0");
  dummy0->setFrame();
  dummy0->fillX();
  dummy0->setSize(0, 5);

  csiFrame = new KonoeTclFrame(kwin, "csiFrame");

  aFrame = new KonoeTclFrame(csiFrame, "aFrame");
  hitEnergyLabel = new KonoeTclLabel(aFrame, "hitEnergyLabel", "Hit Energy");
  for(i=0; i<25; i++){
    sprintf(name, "lbla%d", i+1);
    lbla[i] = new KonoeTclLabel(aFrame, name, name);
  }

  bFrame = new KonoeTclFrame(csiFrame, "bFrame");
  hitTimeLabel = new KonoeTclLabel(bFrame, "hitTimeLabel", "Hit Time");
  for(i=0; i<25; i++){
    sprintf(name, "lblb%d", i+1);
    lblb[i] = new KonoeTclLabel(bFrame, name, name);
  }

  dFrame = new KonoeTclFrame(csiFrame, "dFrame");
  adcValueLabel = new KonoeTclLabel(dFrame, "adcValueLabel", " ADC ");
  for(i=0; i<25; i++){
    sprintf(name, "lbld%d", i+1);
    lbld[i] = new KonoeTclLabel(dFrame, name, name);
  }

  eFrame = new KonoeTclFrame(csiFrame, "eFrame");
  tdcValueLabel = new KonoeTclLabel(eFrame, "tdcValueLabel", " TDC ");
  for(i=0; i<25; i++){
    sprintf(name, "lble%d", i+1);
    lble[i] = new KonoeTclLabel(eFrame, name, name);
  }

  cFrame = new KonoeTclFrame(csiFrame, "cFrame");
  KonoeTclLabel* dummyLabel = new KonoeTclLabel(cFrame, "dummyLabel", "");
  for(i=0; i<25; i++){
    sprintf(name, "lblc%d", i+1);
    sprintf(value, "CsI %d", i+1);
    lblc[i] = new KonoeTclLabel(cFrame, name, value);
    lblc[i]->setAnchor(KW);
  }

  dummy1 = new KonoeTclFrame(csiFrame, "dummy1");
  dummy2 = new KonoeTclFrame(csiFrame, "dummy2");
  dummy3 = new KonoeTclFrame(csiFrame, "dummy3");
  dummy4 = new KonoeTclFrame(csiFrame, "dummy4");

  kwin->setLayoutType("left");
  aFrame->setLayoutType("left");
  bFrame->setLayoutType("left");
  cFrame->setLayoutType("left");
  dFrame->setLayoutType("left");
  eFrame->setLayoutType("left");
  dummy1->setLayoutType("left");
  dummy2->setLayoutType("left");
  dummy3->setLayoutType("left");
  dummy4->setLayoutType("left");


  cFrame->setFrame();
  dummy1->setFrame();
  aFrame->setFrame();
  dummy2->setFrame();
  bFrame->setFrame();
  dummy3->setFrame();
  dFrame->setFrame();
  dummy4->setFrame();
  eFrame->setFrame();

  dummy1->fillY();
  dummy1->setSize(10, 0);

  dummy2->fillY();
  dummy2->setSize(10, 0);

  dummy3->fillY();
  dummy3->setSize(10, 0);

  dummy4->fillY();
  dummy4->setSize(10, 0);

  csiFrame->setFrame();
}
