//=====================================================================
/*

    T473TclEventDisplayRequest.hh

    Version 0.0.1   23-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLEVENTDISPLAYREQUEST_HH
#define __T473TCLEVENTDISPLAYREQUEST_HH

#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclWindow.hh>

class T473TclEventDisplay;
class T473TclEventDisplayControl;

class T473TclEventDisplayRequest : public KonoeTclEventProcessor,
                                   public KonoeTclMouseAction {

  public:
    T473TclEventDisplayRequest(KonoeTclWindow* kwin,
                                 T473TclEventDisplayControl* cont);
    ~T473TclEventDisplayRequest();

    void setEventDisplay(T473TclEventDisplay* eventDisplay);

  private:
    void initWidget();
    void request();

    void mouseAction(KonoeTclButton* kbtn, KInt type,
                         KInt button, Time time, KInt x, KInt y);
    void eventButtonAction();
    void xenonButtonAction();
    void randomButtonAction();

  private:
    T473TclEventDisplay* ed;
    T473TclEventDisplayControl* control;

    KonoeTclWindow* kwin;
    KonoeTclFrame* requestTypeFrame;
    KonoeTclFrame* dummyFrame;
    KonoeTclFrame* displayDataFrame;

    KonoeTclLabel*  requestTypeLabel;
    KonoeTclButton* eventButton;
    KonoeTclButton* xenonButton;
    KonoeTclButton* randomButton;
    KonoeTclButton* infoChange;

    KonoeTclButton* displayDataButton;
    KonoeTclRadioButton* modeHitEnergy;
    KonoeTclRadioButton* modeADCValue;
    KonoeTclCheckButton* modeHitTime;

    KonoeTclButton* requestButton;

    KChar fontName[256];
    KInt  fontSize;
    KChar backColor[32];
};

#endif
