//=====================================================================
/*

    T473TclSetup.cc

    Version 0.0.1   06-Dec-2000 T. Hosoi

*/
//====================================================================

#include <T473TclSetup.hh>

T473TclSetup::T473TclSetup( KonoeTclCanvas* canvas, KInt sX, KInt sY,
                                                   KInt w,  KInt h )
{
  c = canvas;
  startX = sX;
  startY = sY;
  width  = w;
  height = h;

  gcSize = 3;
  csiSize = 3;
  feSize = 3;
  xeSize = 3;
}

void T473TclSetup::draw()
{
  KInt binWidth = (KInt)(width/36. + 0.5);
  KInt x;
  KInt y;

  c->setBackGround("white");

  x = startX + binWidth;
  y = startY + 20;

  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height/2, "s1r");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height/2);
  c->drawString(x - 5, y - 15, "S1R");

  y += height/2;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height/2, "s1l");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height/2);
  c->drawString(x - 5, y + height/2 + 5, "S1L");

  x += binWidth;
  x += binWidth;
  y = startY + 20;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s1p");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S1\'");

  x += binWidth;
  x += binWidth;
  y = startY + 20;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s2");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S2");

  x += binWidth;
  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*gcSize, height, "gc1");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*gcSize, height);
  c->drawString(x, y + height + 5, "GC1");

  x += binWidth;
  x += binWidth*gcSize;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*gcSize, height, "gc2");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*gcSize, height);
  c->drawString(x, y + height + 5, "GC2");

  x += binWidth;
  x += binWidth*gcSize;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s3");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S3");

  x += binWidth;
  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s4");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S4");

  x += binWidth;
  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*csiSize, height, "csi");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*csiSize, height);
  c->drawString(x, y + height + 5, "CsI");

  x += binWidth;
  x += binWidth*csiSize;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s5");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S5");

  x += binWidth;
  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*feSize, height, "fe1");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*feSize, height);
  c->drawString(x, y + height + 5, "Fe");


  x += binWidth;
  x += binWidth*feSize;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s6");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S6");

  x += binWidth;
  x += binWidth;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*feSize, height, "fe2");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*feSize, height);
  c->drawString(x, y + height + 5, "Fe");

  x += binWidth;
  x += binWidth*feSize;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth, height, "s7");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth, height);
  c->drawString(x, y + height + 5, "S7");

  x += binWidth;
  x += binWidth*3;
  c->setColor("#d9d9d9");
  c->drawFillRectangle(x, y, binWidth*xeSize, height, "xe");
  c->setColor("black");
  c->drawRectangle(x, y, binWidth*xeSize, height);
  c->drawString(x, y + height + 5, "Xe");
}

void T473TclSetup::draw(KInt sX, KInt sY, KInt w, KInt h)
{
  startX = sX;
  startY = sY;
  width  = w;
  height = h;

  draw();
}

void T473TclSetup::hitS1R()
{
  c->setFillRectBack("s1r", "green");
}

void T473TclSetup::hitS1L()
{
  c->setFillRectBack("s1l", "green");
}

void T473TclSetup::hitS1P()
{
  c->setFillRectBack("s1p", "green");
}

void T473TclSetup::hitS2()
{
  c->setFillRectBack("s2", "green");
}

void T473TclSetup::hitS3()
{
  c->setFillRectBack("s3", "green");
}

void T473TclSetup::hitS4()
{
  c->setFillRectBack("s4", "green");
}

void T473TclSetup::hitS5()
{
  c->setFillRectBack("s5", "green");
}

void T473TclSetup::hitS6()
{
  c->setFillRectBack("s6", "green");
}

void T473TclSetup::hitS7()
{
  c->setFillRectBack("s7", "green");
}

void T473TclSetup::hitGC1()
{
  c->setFillRectBack("gc1", "green");
}

void T473TclSetup::hitGC2()
{
  c->setFillRectBack("gc2", "green");
}

void T473TclSetup::hitXe()
{
  c->setFillRectBack("xe", "green");
}
