//=============================================================
/*
	T4731DHistoGetter.hh

	 8-Nov-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu

*/
//=============================================================
#include"T4731DHistoCatcher.hh"
#include"T473HistoInfo.hh"
#include<analysis/Konoe1DHistogram.hh>
#include<system/KonoeSocketIO.hh>
#include<iostream.h>
#include<unistd.h>
#include <string.h>

T4731DHistoCatcher::T4731DHistoCatcher(KChar* phostname,KInt pport)
	: hostname(phostname), port(pport) {

  h_cm = new KonoeHistogramCM;
  p_cm = new KonoePhysicalValueCM;
  ms = new KonoeMicroSleep;

  csocket = new 
    KonoeClientSocket( hostname, port );

  fd_set.install( csocket );

  osocket = new KonoeInputObjSocket( csocket );
  osocket->installCM( h_cm );
  osocket->installCM( p_cm );

}

T4731DHistoCatcher::~T4731DHistoCatcher(){

  delete p_cm;
  delete h_cm;
  if( csocket )
    delete csocket;
  if( osocket )
    delete osocket;

}

Konoe1DHistogramList * T4731DHistoCatcher::getHistoList(KChar * histo_name){

  KInt i = 10;
  KInt j = 10;
  while( i-- ){

    if( csocket->getStatus() != KonoeSocketIO::CONNECTED )  csocket->connect();
    else  csocket->send(histo_name,strlen(histo_name));
    
    KChar buff[256];
    
    if( !(fd_client = fd_set.wait(100)) ){
      continue;
    }
    else{
      hist_list = (Konoe1DHistogramList *)osocket->get(0);

      if( hist_list ){
        return hist_list;
      }
      ms->sleep(70);
    }
     
  }

  return 0;
  
}
