//==================================================
/*
	T4731DHistoCatcher.hh

	8-Nov-2000	Y. Shimizu
*/
//===================================================
#include<system/KonoeInputObjSocket.hh>
#include<system/KonoeClientSocket.hh>
#include<analysis/Konoe1DHistogramList.hh>
#include<analysis/Konoe1DHistogram.hh>
#include<analysis/KonoeHistogramCM.hh>
#include<analysis/KonoePhysicalValueCM.hh>
#include<system/KonoeMicroSleep.hh>
#include <system/KonoeFDSet.hh>
#include <system/KonoeFDClient.hh>
#include"../Namespace/T473NameSpaceSetter.hh"
#include"../Namespace/T473NameSpaceExtractor.hh"


#ifndef __T4731DHISTOCATCHER_HH
#define __T4731DHISTOCATCHER_HH

class T4731DHistoCatcher {
protected:
  Konoe1DHistogramList *hist_list;
  KonoeHistogramCM     *h_cm;
  KonoePhysicalValueCM     *p_cm;
  KonoeInputObjSocket  *osocket;
  KonoeClientSocket    *csocket;
  T473NameSpaceSetter  *setter;
  T473NameSpaceExtractor  *ext;
  KonoeMicroSleep         * ms;
  KChar                *hostname;
  KInt			port;
  KonoeFDSet     fd_set;
  KonoeFDClient  *fd_client;
public:
  T4731DHistoCatcher(KChar* hostname,KInt port);
  ~T4731DHistoCatcher();

  Konoe1DHistogramList* getHistoList(KChar* histo_name);

};


#endif
