//=======================================================
/*
	T473CsIADCHistoFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	<stdio.h>
#include	"T473CsIADCHistoFiller.hh"
#include	"../Namespace/T473NameSpaceExtractor.hh"
#include	"T473HistoInfo.hh"

T473CsIADCHistoFiller::T473CsIADCHistoFiller( KonoeDefaultSectionAnalyzer * pana){

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i;
  KChar pedtxt[64];

  scale = new KonoeLinearDataScale( 0.0 , 4096 , 4096 );
  
  ana = pana ;

  KInt j = -1;

  for( i = 0 ; i < HISTO_NUM ; i++){    // HISTO_NUM = CSI_ADC_HISTO_NUM = 25

    if( ( i / CHANNEL ) * CHANNEL  == i )
	j++;
	
    // extractro set 
    sprintf(pedtxt,"CSI_ADC_%d_%d_PED",j, i - ( j*CHANNEL ));
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0;
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
    extractor[i]->setTarget( j, i - ( j * CHANNEL ));
    extractor[i]->setIndex( 3, 1 ,2 );
    extractor[i]->setPedestal( ped[i]  );

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    xenon_hist[i] = new Konoe1DHistogram( scale );

    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
    xenon_filler[i] = new KonoeHistogramFiller( extractor[i] , xenon_hist[i] );

  }

  delete ext;

}

T473CsIADCHistoFiller::~T473CsIADCHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

KInt T473CsIADCHistoFiller::setPedestal(){
cout << "T473CsIADCHistoFiller::setPedestal()"<<endl;

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;

  KInt i;
  KInt j = -1;
  KChar pedtxt[64];

  for( i = 0 ; i < HISTO_NUM ; i++){   // HISTO_NUM = CSI_TDC_HISTO_NUM =25
  
    if( ( i / CHANNEL ) * CHANNEL  == i )
	j++;
    sprintf(pedtxt,"CSI_ADC_%d_%d_PED",j,i - ( j * CHANNEL ) );
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0;
    cout << pedtxt << " = " << ped[i] << endl;
    extractor[i]->setPedestal( ped[i] );

  }

  delete ext;

  return (0);

}
