//=======================================================
/*
	T473CsIADCHistoFiller.hh

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473CSIADCHISTOFILLER_HH
#define	__T473CSIADCHISTOFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473SubAddressExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473CsIADCHistoFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::CSI_ADC_HISTO };
	enum { CHANNEL = T473HistoInfo::CSI_ADC_CHANNEL };
protected:
	KInt				  ped[ HISTO_NUM ];
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	KonoeHistogramFiller 		* xenon_filler[ HISTO_NUM ];
	Konoe1DHistogram     		* xenon_hist[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	T473SubAddressExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473CsIADCHistoFiller( KonoeDefaultSectionAnalyzer * pana);
	~T473CsIADCHistoFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
	KonoeHistogramFiller * getXenonFiller(KInt i){ return xenon_filler[i];}
	Konoe1DHistogram * getXenonHisto(KInt i ) { return xenon_hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473SubAddressExtractor		* getExt(KInt i){ return extractor[i];}
	KInt 			setPedestal();
};

#endif
