//=======================================================
/*
	T473CsIADCSumFiller.cc

	20-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473CsIADCSumFiller.hh"
#include	"../Namespace/T473NameSpaceExtractor.hh"
#include	"T473HistoInfo.hh"
#include	<stdio.h>

T473CsIADCSumFiller::T473CsIADCSumFiller( KonoeDefaultSectionAnalyzer * pana){

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i, ped;
  KChar pedtxt[256];

  scale = new KonoeLinearDataScale( 0.0 , 5000 , 5000 );
 
  ana = pana ;  
  KInt j  = -1;

  extractor[0] = new T473CsIADCSumExtractor( ana->getPhysicalValue() );
  extractor[0]->setIndex( 3, 1, 2 );

  for( i = 0 ; i < T473HistoInfo::CSI_ADC_HISTO; i++){

	if( (i / CHANNEL ) * CHANNEL == i )
		j++;

	sprintf(pedtxt,"CSI_ADC_%d_%d_PED",j, i - ( j * CHANNEL ));
	ped = ext->getKIntValue(pedtxt);
	if( ped < 0 )
		ped = 0;
	extractor[0]->setPedestal( i , ped );

  }


    // Histogram set 
  hist[0] = new Konoe1DHistogram( scale );
    // HistoFiller set 
  filler[0] = new KonoeHistogramFiller( extractor[0] , hist[0] );

  delete ext;
}

T473CsIADCSumFiller::~T473CsIADCSumFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

KInt T473CsIADCSumFiller::setPedestal(){

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i, ped;
  KInt j  = -1;
  KChar pedtxt[256];
  
  for( i = 0 ; i < T473HistoInfo::CSI_ADC_HISTO; i++){

	if( (i / CHANNEL ) * CHANNEL == i )
		j++;

	sprintf(pedtxt,"CSI_ADC_%d_%d_PED",j, i - ( j * CHANNEL ));
	ped = ext->getKIntValue(pedtxt);
	if( ped < 0 )
		ped = 0;
	extractor[0]->setPedestal( i , ped );

  }

  delete ext;

  return (0);

}
