//=======================================================
/*
	T473CsIADCSumFiller.hh 

	20-Nov-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473CSIADCSUMFILLER_HH
#define __T473CSIADCSUMFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473CsIADCSumExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473CsIADCSumFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::CSIADCSUM_HISTO };
	enum { CHANNEL = T473HistoInfo::CSI_ADC_CHANNEL };
protected:
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473CsIADCSumExtractor 		* extractor[ HISTO_NUM ];	
public:
	T473CsIADCSumFiller( KonoeDefaultSectionAnalyzer * pana);
	~T473CsIADCSumFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473CsIADCSumExtractor 		* getExt(KInt i){return extractor[i];}	
	KInt setPedestal();
};

#endif
