//=======================================================
/*
	T473CsITDCHistoFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	<stdio.h>
#include	"T473CsITDCHistoFiller.hh"
#include	"T473HistoInfo.hh"
#include	"../Namespace/T473NameSpaceExtractor.hh"

T473CsITDCHistoFiller::T473CsITDCHistoFiller( KonoeDefaultSectionAnalyzer * pana ){
  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i;
  KChar pedtxt[256];

  scale = new KonoeLinearDataScale( 0.0 , 4096 , 4096 );
  
  ana = pana ;  

  KInt j = -1;

  for( i = 0 ; i < HISTO_NUM ; i++){   // HISTO_NUM = CSI_TDC_HISTO_NUM =25 
    // extractor set 
    if(  ( i / CHANNEL) * CHANNEL == i ) 
	++j;

    sprintf(pedtxt,"CSI_TDC_%d_%d_PED",j,i - ( j * CHANNEL ) );
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0;
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
    extractor[i]->setTarget( j ,  i - ( j * CHANNEL ) );
    extractor[i]->setIndex( 3, 1, 2 );
    extractor[i]->setPedestal( ped[i] );

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

  delete ext;

}

T473CsITDCHistoFiller::~T473CsITDCHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

KInt T473CsITDCHistoFiller::setPedestal(){
cout << "T473CsITDCHistoFiller::setPedestal()"<<endl;

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;

  KInt i;
  KInt j = -1;
  KChar pedtxt[256];

  for( i = 0 ; i < HISTO_NUM ; i++){   // HISTO_NUM = CSI_TDC_HISTO_NUM =25 

    if(  ( i / CHANNEL) * CHANNEL == i ) 
	++j;

    sprintf(pedtxt,"CSI_TDC_%d_%d_PED",j,i - ( j * CHANNEL ) );
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0; 
    cout << pedtxt << " = " << ped[i] << endl;
    extractor[i]->setPedestal( ped[i] );
 
  }

  delete ext;

  return (0);

}

