//=======================================================
/*
	T473GeneralHistoFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473GeneralHistoFiller.hh"
#include	"T473HistoInfo.hh"

T473GeneralHistoFiller::T473GeneralHistoFiller(
			KonoeDefaultSectionAnalyzer * pana ){

  KInt i;

  scale = new KonoeLinearDataScale( 0.0 , 5000.0 , 5000 );
  
  ana = pana ;

  for( i = 0 ; i < HISTO_NUM ; i++){
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
   
    if( i < SEG_0_ELEMENT )         // 0 -> 2
      extractor[i]->setTarget( 0, i );
    else if( i < SEG_1_ELEMENT + SEG_0_ELEMENT )   //   3
      extractor[i]->setTarget( 1, i - SEG_0_ELEMENT + 1 );
    else if( i < SEG_2_ELEMENT + SEG_1_ELEMENT + SEG_0_ELEMENT ) //  4
      extractor[i]->setTarget( 2, i - SEG_0_ELEMENT - SEG_1_ELEMENT + 1);
    else if( i < SEG_3_ELEMENT + SEG_2_ELEMENT + SEG_1_ELEMENT + SEG_0_ELEMENT ) // 5 
      extractor[i]->setTarget( 3, i - SEG_0_ELEMENT - SEG_1_ELEMENT - SEG_2_ELEMENT );
    else if( i < SEG_4_ELEMENT + SEG_3_ELEMENT + SEG_2_ELEMENT + SEG_1_ELEMENT 
               +  SEG_0_ELEMENT )                                                        // 6 
      extractor[i]->setTarget( 4, i - SEG_0_ELEMENT - SEG_1_ELEMENT - SEG_2_ELEMENT 
				    - SEG_3_ELEMENT );
    else if( i < SEG_5_ELEMENT + SEG_4_ELEMENT + SEG_3_ELEMENT + SEG_2_ELEMENT 
	       + SEG_1_ELEMENT + SEG_0_ELEMENT )                                         // 7 
      extractor[i]->setTarget( 5, i - SEG_0_ELEMENT - SEG_1_ELEMENT - SEG_2_ELEMENT 
				    - SEG_3_ELEMENT - SEG_4_ELEMENT );
    else if( i < SEG_6_ELEMENT + SEG_5_ELEMENT + SEG_4_ELEMENT + SEG_3_ELEMENT 
	       + SEG_2_ELEMENT + SEG_1_ELEMENT + SEG_0_ELEMENT )                         // 8 -> 9 
      extractor[i]->setTarget( 6, i - SEG_0_ELEMENT - SEG_1_ELEMENT - SEG_2_ELEMENT 
				    - SEG_3_ELEMENT - SEG_4_ELEMENT - SEG_5_ELEMENT );
    else if( i < SEG_7_ELEMENT + SEG_6_ELEMENT + SEG_5_ELEMENT + SEG_4_ELEMENT 
	       + SEG_3_ELEMENT + SEG_2_ELEMENT + SEG_1_ELEMENT + SEG_0_ELEMENT )          // 10 -> 12 
      extractor[i]->setTarget( 7, i - SEG_0_ELEMENT - SEG_1_ELEMENT - SEG_2_ELEMENT 
				    - SEG_3_ELEMENT - SEG_4_ELEMENT - SEG_5_ELEMENT 
                                    - SEG_6_ELEMENT );

    extractor[i]->setIndex( 3, 1, 2 );

    hist[i] = new Konoe1DHistogram( scale );
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

}

T473GeneralHistoFiller::~T473GeneralHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

