//=======================================================
/*
	T473GeneralHistoFiller.hh

	6-Oct-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473GENERALHISTOFILLER_HH
#define	__T473GENERALHISTOFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473SubAddressExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeGeneralSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473GeneralHistoFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::GENERAL_HISTO };
	enum { SEG_0_ELEMENT = T473HistoInfo::GENERAL_SEG0_ELEMENT };
	enum { SEG_1_ELEMENT = T473HistoInfo::GENERAL_SEG1_ELEMENT };
	enum { SEG_2_ELEMENT = T473HistoInfo::GENERAL_SEG2_ELEMENT };
	enum { SEG_3_ELEMENT = T473HistoInfo::GENERAL_SEG3_ELEMENT };
	enum { SEG_4_ELEMENT = T473HistoInfo::GENERAL_SEG4_ELEMENT };
	enum { SEG_5_ELEMENT = T473HistoInfo::GENERAL_SEG5_ELEMENT };
	enum { SEG_6_ELEMENT = T473HistoInfo::GENERAL_SEG6_ELEMENT };
	enum { SEG_7_ELEMENT = T473HistoInfo::GENERAL_SEG7_ELEMENT };
protected:
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473SubAddressExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473GeneralHistoFiller( KonoeDefaultSectionAnalyzer * pana );
	~T473GeneralHistoFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473SubAddressExtractor 	* getExt(KInt i){return extractor[i];}	
};

#endif
