//=================================================
/*
	T473HistoInfo.hh

	15-Nov-2000	Y. Shimizu
*/
//=================================================
#ifndef __T473HISTOINFO_HH
#define __T473HISTOINFO_HH

class T473HistoInfo {

public:
  enum { 	GENERAL_SECTION ,
		CSI_TDC_SECTION ,
		CSI_ADC_SECTION ,
		SCIN_TDC_SECTION ,
		SCIN_ADC_SECTION ,
		SCALER_SECTION ,
		N_SECTION 
  };

  enum { GENERAL_HISTO =  13 };
  enum { CSI_TDC_HISTO =  25 };
  enum { CSI_ADC_HISTO =  25 };
  enum { SCIN_TDC_HISTO =  16 };
  enum { SCIN_ADC_HISTO =  15 };
  enum { SCALER_HISTO =  16 };
  enum { TOF_HISTO =  1 };
  enum { CSIADCSUM_HISTO =  1 };
  
  enum { N_MULTIPLET  =  256 };
  
  enum { HISTO_TOTAL = CSI_ADC_HISTO + CSI_TDC_HISTO +
	 SCIN_ADC_HISTO + SCIN_TDC_HISTO +
	 SCALER_HISTO   + GENERAL_HISTO +
	 TOF_HISTO + CSIADCSUM_HISTO };
  
  enum { GENERAL_SEG0_ELEMENT = 3 };
  enum { GENERAL_SEG1_ELEMENT = 1 };
  enum { GENERAL_SEG2_ELEMENT = 1 };
  enum { GENERAL_SEG3_ELEMENT = 1 };
  enum { GENERAL_SEG4_ELEMENT = 1 };
  enum { GENERAL_SEG5_ELEMENT = 1 };
  enum { GENERAL_SEG6_ELEMENT = 2 };
  enum { GENERAL_SEG7_ELEMENT = 3 };
  
  enum { CSI_TDC_CHANNEL = 8 };
  enum { CSI_ADC_CHANNEL = 16 };
  
  enum { SCIN_TDC_SEG0  = 8 };
  enum { SCIN_TDC_SEG1  = 8 };
  
  enum { SCIN_ADC_CHANNEL = 15 };
  
  enum { SCALER_SEG0 = 12 };
  enum { SCALER_SEG1 = 4 };
  
  enum { EVENT_CYCLE  = 100 	};
  enum { WAIT_INTERVAL = 0	};
  
  enum { RUN_START_TYPE = 1000 };
  enum { RUN_END_TYPE   = 2000 };
  enum { NORMAL_REC_TYPE = 3000 };
  enum { SPILL_END_TYPE= 4000 };
  
};

#endif
