//===========================================================
/*
	T473Process1DHistogram.cc

	29-Nov-2000	Y. Shimizu
*/
//===========================================================
#include	"T473Process1DHistogram.hh"
#include	<math.h>

T473Process1DHistogram::T473Process1DHistogram( Konoe1DHistogram *phistogram )
{

	histogram = phistogram ;
}

T473Process1DHistogram::~T473Process1DHistogram( ){

//	delete histogram;
	
}

KFloat T473Process1DHistogram::getMax(KInt x_min, KInt x_max){

  KInt i;
  KFloat maxData = 0;
  if( !x_max )
    x_max = histogram->getBinCount();

  for( i = x_min; i < x_max ; i++){
    if( maxData < histogram->getOne(i))
      maxData = histogram->getOne(i);
  }
  
  return maxData;
}

KInt  T473Process1DHistogram::getMaxBinNumber(KInt x_min,KInt x_max){

  KInt i;
  KInt binCount;
  KInt maxIndex = 0;
  KFloat maxData = 0;
  if( !x_max )
    x_max = histogram->getBinCount();
  
  for(i = x_min; i < x_max ; i++){
    if( maxData < histogram->getOne(i) ){
      maxData = histogram->getOne(i);
      maxIndex = i;
    }
  }

  return maxIndex;
}


KFloat T473Process1DHistogram::getMean(KInt min, KInt max){

 KInt binCount ;
 KFloat mean = 0;
 KFloat binTotal = 0;
 KInt i;

 binCount = max - min ;

 for( i=0 ; i < binCount ; i++){
   mean += ( histogram->getScale()->getBinWidth( i + min ) 
	     * (min + i) ) * histogram->getOne( i + min );
   binTotal += histogram->getScale()->getBinWidth( i + min );
 }

 mean /= getTotalData(min , max);
 return mean;

}
KFloat T473Process1DHistogram::getTotalData(KInt xmin, KInt xmax ){
  
  KInt i;
  
  if( !xmax )
    xmax = histogram->getBinCount();

  KFloat totalData = 0;
  for( i= xmin ; i <xmax ; i++)
    totalData += histogram->getOne( i );

  return totalData;
}

KFloat T473Process1DHistogram::
getVariance( KInt x_min, KInt x_max ){
  
  KInt i;
  KFloat variance = 0;
  KFloat mean = this->getMean( x_min, x_max );
  
  for( i = x_min; i < x_max ; i++)
    variance += histogram->getOne(i) * 
      (histogram->getScale()->getBinWidth( i )*i - mean ) *
      (histogram->getScale()->getBinWidth( i )*i - mean );

  variance /= this->getTotalData();

  return variance;
}

KFloat T473Process1DHistogram::
getStandardDeviation( KInt x_min, KInt x_max ){

  return sqrt( this->getVariance( x_min , x_max) );

}

