//====================================================================
/*

        T473Scaler.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu

*/
//====================================================================


#include <analysis/KonoePhysicalValue.hh>
#include <analysis/KonoeFillData.hh>
#include <analysis/KonoeFillDataExtractor.hh>
#include "T473Scaler.hh"
#include <stdio.h>
#include <unistd.h>

T473Scaler::T473Scaler(KonoePhysicalValue * pvalue,
						 KChar * name1, 
						 KChar * name2, 
						 KChar * name3 )
{
  KonoeMultipletDescriptor	* d;
  KInt	i, j;
  
  for( i = 0; i < FILL_DATA_DIMENSION; i ++ )
    indices[ i ] = -1;
  physicalvalue = pvalue;
  d = pvalue -> getDescriptor( );
  if( name1 )
    indices[ 0 ] = d -> getIndex( name1 );
  if( name2 )
    indices[ 1 ] = d -> getIndex( name2 );
  if( name3 )
    indices[ 2 ] = d -> getIndex( name3 );
  j = 0;
  for( i = 0; i < FILL_DATA_DIMENSION; i ++ )
    if( indices[ i ] == -1 )
      indices[ i ] = j ++;
  
}

KInt T473Scaler::getCount( KInt segment , KInt address )
{
  
  KonoeDataMultiplet	* multiplet;
  KInt 			  return_value;

  multiplet = physicalvalue -> next( );
  if( multiplet == 0 )
    return 0;

  if(  ( multiplet->getValue( indices[ 1 ] )  == segment  )  && 
			 ( multiplet->getValue( indices[ 2 ] ) == address  )  ){
    
		return_value = (KInt)multiplet->getValue( indices[ 0 ] );
		return return_value ;

  }

  this->getCount( segment, address);

}

