//=======================================================
/*
	T473ScalerHistoFiller.cc

	26-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473ScalerHistoFiller.hh"
#include	"T473HistoInfo.hh"

T473ScalerHistoFiller::T473ScalerHistoFiller( KonoeDefaultSectionAnalyzer * pana){

  KInt i;

  scale = new KonoeLinearDataScale( 0.0 , 1.0 , 1 );
  
  ana = pana;

  for( i = 0 ; i < HISTO_NUM  ; i++){  // ------> number of Histogram
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
    if( i < SEG_0_ELEMENT )       	// 0 -> 11 
	extractor[i]->setTarget( 0, i );
    if( ( SEG_0_ELEMENT <= i ) && (i < ( SEG_1_ELEMENT + SEG_0_ELEMENT ) ) )  
	extractor[i]->setTarget( 1, i - SEG_0_ELEMENT );   // 12 -> 15 

    extractor[i]->setIndex( 3, 1 ,2);
    extractor[i]->setPedestal( 0 );

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

}

T473ScalerHistoFiller::~T473ScalerHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

