//=======================================================
/*
	T473ScalerHistoFiller.hh

	26-Nov-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473SCALERHISTOFILLER_HH
#define	__T473SCALERHISTOFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473SubAddressExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473ScalerHistoFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::SCALER_HISTO };
	enum { SEG_0_ELEMENT = T473HistoInfo::SCALER_SEG0 };
	enum { SEG_1_ELEMENT = T473HistoInfo::SCALER_SEG1 };
protected:
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473SubAddressExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473ScalerHistoFiller( KonoeDefaultSectionAnalyzer * pana);
	~T473ScalerHistoFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
    	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473SubAddressExtractor 	* getExt(KInt i){ return extractor[i];}	
};

#endif
