//=======================================================
/*
	T473ScinADCHistoFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473ScinADCHistoFiller.hh"
#include	"T473HistoInfo.hh"
#include	"../Namespace/T473NameSpaceExtractor.hh"
#include	<stdio.h>

T473ScinADCHistoFiller::T473ScinADCHistoFiller(KonoeDefaultSectionAnalyzer* pana ){

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i;
  KChar pedtxt[64];

  scale = new KonoeLinearDataScale( 0.0 , 4096 , 4096 );
 
  ana = pana;  

  KInt j = -1;                    //  j  ---> for section number

  for( i = 0 ; i < HISTO_NUM ; i++){      //   ---> Number of Histogram   16
    // extractro set 
    if( ( i / CHANNEL ) * CHANNEL == i )                  // CHANNEL 	15
	j++;

    sprintf(pedtxt,"SCIN_ADC_%d_%d_PED",j , i - ( j*CHANNEL ) );
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0;
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
    extractor[i]->setTarget( j,  i - ( j * CHANNEL ));
    extractor[i]->setIndex( 3, 1, 2);
    extractor[i]->setPedestal(ped[i]);

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

  delete ext;
}

T473ScinADCHistoFiller::~T473ScinADCHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

KInt T473ScinADCHistoFiller::setPedestal( ){
cout << "T473ScinADCHistoFiller::setPedestal( )"<<endl;

  T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
  KInt i;
  KChar pedtxt[64];
  KInt  j = -1;

  for( i = 0 ; i < HISTO_NUM ; i++){   //   ---> Number of Histogram   15

    if( ( i / CHANNEL ) * CHANNEL == i )                  // CHANNEL 	15
     j++;

    sprintf(pedtxt,"SCIN_ADC_%d_%d_PED",j , i - ( j*CHANNEL ) );
    ped[i] = ext->getKIntValue(pedtxt);
    if( ped[i] < 0 )
	ped[i] = 0;
    cout << pedtxt << " = " << ped[i] << endl;
    extractor[i]->setPedestal(ped[i]);
  }

  delete ext;

  return (0);

}
