//=======================================================
/*
	T473ScinADCHistoFiller.hh

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473SCINADCHISTOFILLER_HH
#define	__T473SCINADCHISTOFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473SubAddressExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473ScinADCHistoFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::SCIN_ADC_HISTO };
	enum { CHANNEL = T473HistoInfo::SCIN_ADC_CHANNEL };
protected:
	KInt 				  ped[ HISTO_NUM ];
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473SubAddressExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473ScinADCHistoFiller( KonoeDefaultSectionAnalyzer* pana);
	~T473ScinADCHistoFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473SubAddressExtractor 	* getExt(KInt i){return extractor[i];}	
	KInt 				  setPedestal( );
};

#endif
