//=======================================================
/*
	T473ScinTDCHistoFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473ScinTDCHistoFiller.hh"
#include	"T473HistoInfo.hh"

T473ScinTDCHistoFiller::T473ScinTDCHistoFiller( KonoeDefaultSectionAnalyzer * pana){

  KInt i;

  scale = new KonoeLinearDataScale( 0.0 , 4096 , 4096 );
 
  ana = pana ;  

  KInt j = -1;

  for( i = 0 ; i < HISTO_NUM  ; i++){
    extractor[i] = new T473SubAddressExtractor( ana->getPhysicalValue() );
    // extractro set 
    if( i < SEG_0_ELEMENT )         // 0 -> 7 
      extractor[i]->setTarget( 0 ,i );
    if( ( SEG_0_ELEMENT <= i ) && ( i < SEG_1_ELEMENT + SEG_0_ELEMENT ) )
      extractor[i]->setTarget( 1 ,i - SEG_0_ELEMENT );       // 8 -> 15

    extractor[i]->setIndex( 3,1,2);
    extractor[i]->setPedestal( 0 );

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

}

T473ScinTDCHistoFiller::~T473ScinTDCHistoFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

