//=======================================================
/*
	T473ScinTDCHistoFiller.hh

	6-Oct-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473SCINTDCHISTOFILLER_HH
#define __T473SCINTDCHISTOFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473SubAddressExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473ScinTDCHistoFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::SCIN_TDC_HISTO };
	enum { SEG_0_ELEMENT = T473HistoInfo::SCIN_TDC_SEG0 };
	enum { SEG_1_ELEMENT = T473HistoInfo::SCIN_TDC_SEG1 };
protected:
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473SubAddressExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473ScinTDCHistoFiller( KonoeDefaultSectionAnalyzer * pana);
	~T473ScinTDCHistoFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473SubAddressExtractor 	* getExt(KInt i){ return extractor[i];}	
};

#endif
