//====================================================================
/*

        T473SpillEndProcessor.hh

 	10-Dec-2000	Y. Shimizu
*/
//====================================================================

#ifndef __T473SPILLENDPROCESSOR_HH
#define __T473SPILLENDPROCESSOR_HH

#include	<analysis/KonoeDataRecord.hh>
#include	<analysis/KonoeDataAnalyzer.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeSectionAnalyzer.hh>
#include	<analysis/KonoePhysicalValue.hh>
#include	"T473HistoInfo.hh"
#include	"../Namespace/T473NameSpaceSetter.hh"

class T473SpillEndProcessor {
public:
	enum	{ 	SEG0_ELEMENTS 	= 12 	};
	enum	{ 	SEG1_ELEMENTS 	=  4 	};
protected:
	KInt 				  element0[ SEG0_ELEMENTS ];
	KInt 				  element1[ SEG1_ELEMENTS ];
	KonoeDefaultSectionAnalyzer 	* sec_ana;
	KonoePhysicalValue		* physicalvalue;
	KonoeDataAnalyzer		* ana;
	T473NameSpaceSetter 		* setter;
public:
	T473SpillEndProcessor( KonoeDataAnalyzer *ana ,KonoeDefaultSectionAnalyzer* secana);
	~T473SpillEndProcessor( );

	KInt  process( KonoeDataRecord * rec );
	KInt  clear( );
	KInt  getElement0( KInt index ) { return  element0[ index ];  } 
	KInt  getElement1( KInt index ) { return  element1[ index ];  } 
};

#endif
