//====================================================================
/*
        T473TOFExtractor.hh

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//====================================================================

#ifndef __T473TOFEXTRACTOR_HH
#define __T473TOFEXTRACTOR_HH

#include <analysis/KonoePhysicalValue.hh>
#include <analysis/KonoeFillDataExtractor.hh>
#include <analysis/KonoeFillData.hh>

class T473TOFExtractor : public KonoeFillDataExtractor  {
public:
	enum { S1_LEFT = 0 , S1_RIGHT = 1, S3 = 3 };
	enum { SEGMENT0 = 0 , SEGMENT1 = 1 };
	enum { S1PRIME  = 7 };
protected:
	KInt segment;

	KFloat s1right;
	KFloat s1left;
	KFloat s1prime;
	KFloat s3;

	KFloat s1rightped;
	KFloat s1leftped;
	KFloat s1primeped;
	KFloat s3ped;

	KFloat calculate();

public:
	T473TOFExtractor( KonoePhysicalValue * physicalvalue,
		KChar * name1 = 0, KChar * name2 = 0, KChar * name3 = 0 );

	KonoeFillData *next( );
	KInt setPedestal( );

};

#endif
