//=======================================================
/*
	T473TOFFiller.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu
*/
//=======================================================

#include	"T473TOFFiller.hh"
#include	"T473HistoInfo.hh"

T473TOFFiller::T473TOFFiller( KonoeDefaultSectionAnalyzer * pana){

  KInt i;

  scale = new KonoeLinearDataScale( 0.0 , 4096 , 4096 );
 
  ana = pana ;  

  KInt j = -1;

  for( i = 0 ; i < HISTO_NUM  ; i++){
    // extractro set 

    extractor[i] = new T473TOFExtractor( ana->getPhysicalValue() );
    extractor[i]->setIndex( 3,1,2);   // data, segment, subaddress

    // Histogram set 
    hist[i] = new Konoe1DHistogram( scale );
    // HistoFiller set 
    filler[i] = new KonoeHistogramFiller( extractor[i] , hist[i] );
  }

}

T473TOFFiller::~T473TOFFiller( ){

  delete [] hist;
  delete [] filler;
  delete scale;
  delete ana;

}

KInt T473TOFFiller::setPedestal(){
cout << "T473TOFFiller::setPedestal()"<<endl;
 
  KInt i;

  for( i = 0 ; i < HISTO_NUM  ; i++) 
	extractor[i]->setPedestal();

	return (0);
}
