//=======================================================
/*
	T473TOFFiller.hh 
	6-Oct-2000	Y. Shimizu
*/
//=======================================================

#ifndef __T473TOFFILLER_HH
#define __T473TOFFILLER_HH

#include	"T473HistoInfo.hh"
#include	"T473TOFExtractor.hh"

#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/Konoe1DHistogram.hh>

class T473TOFFiller {
public:
	enum { HISTO_NUM = T473HistoInfo::TOF_HISTO };
protected:
	KonoeHistogramFiller 		* filler[ HISTO_NUM ];
	KonoeDefaultSectionAnalyzer	* ana; 
	KonoeLinearDataScale 		* scale;
	Konoe1DHistogram     		* hist[ HISTO_NUM ];
	T473TOFExtractor 	* extractor[ HISTO_NUM ];	
public:
	T473TOFFiller( KonoeDefaultSectionAnalyzer * pana);
	~T473TOFFiller( );

	KonoeHistogramFiller * getFiller(KInt i ) { return filler[i] ; }
	Konoe1DHistogram * getHisto(KInt i ) { return hist[i] ; }
  	KonoeDefaultSectionAnalyzer	* getAna(){ return ana; }
	T473TOFExtractor 		* getExt(KInt i){return extractor[i];}	
	KInt setPedestal();

};

#endif
