//====================================================================
/*

        T473XenonChecker.cc

	 6-Oct-2000	Y. Shimizu
	15-Nov-2000	Y. Shimizu

*/
//====================================================================

#include <analysis/KonoeDataSegment.hh>
#include <analysis/KonoeDataElement.hh>
#include "T473XenonChecker.hh"
#include "T473CoincidenceRegister.hh"
#include "T473HistoInfo.hh"
#include <stdio.h>
#include <unistd.h>

const KInt T473XenonChecker::xenon_mask = 0x00007800;
T473XenonChecker::T473XenonChecker( KonoeDataAnalyzer * pana ,  KonoeDefaultSectionAnalyzer* psec_ana)
{
	ana     = pana;
	sec_ana = psec_ana; 
	
}

KBool T473XenonChecker::isXenonEvent( KonoeDataRecord* rec )
{
	rec->reset( );
	ana->reset( );
	ana->analyze( rec ); 

	physicalvalue = sec_ana->getPhysicalValue( );

	reg = new T473CoincidenceRegister( physicalvalue );
	reg->setIndex( 3 , 1 , 2 );
	reg->setTarget( 3 , 0 );

	if( reg->checkFlag( xenon_mask )){
	        delete reg;
		return KTrue;
	}
	else{
	        delete reg;
		return KFalse;
	}
}

