//====================================================================
/*

        T473XenonChecker.hh

 	 6-Oct-2000	Y. Shimizu
 	15-Nov-2000	Y. Shimizu
*/
//====================================================================

#ifndef __T473XENONCHECKER_HH
#define __T473XENONCHECKER_HH

#include	<analysis/KonoeDataRecord.hh>
#include	<analysis/KonoeDataAnalyzer.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<analysis/KonoeSectionAnalyzer.hh>
#include	<analysis/KonoePhysicalValue.hh>
#include	"T473HistoInfo.hh"
#include	"T473CoincidenceRegister.hh"

class T473XenonChecker {
public:
	enum {	SEGMENT = 3  	};
	enum {	ELEMENT = 0 	};   
	enum {  GENERAL	= T473HistoInfo::GENERAL_SECTION	};
	enum {  N_MULTIPLET = T473HistoInfo::N_MULTIPLET 	};
protected:
	KonoeDefaultSectionAnalyzer 	* sec_ana;
	static const KInt 	  	  xenon_mask;
	KonoePhysicalValue		* physicalvalue;
	T473CoincidenceRegister		* reg;
	KonoeDataAnalyzer		* ana;
public:
	T473XenonChecker( KonoeDataAnalyzer * ana , KonoeDefaultSectionAnalyzer* secana);

	KBool isXenonEvent( KonoeDataRecord * rec);
};

#endif
