//=====================================================================
/*

    T473TclHistogramDisplay.hh

    Version 0.0.1   05-Oct-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLHISTOGRAMDISPLAY_HH
#define __T473TCLHISTOGRAMDISPLAY_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclBalloon.hh>

class KonoeClientSocket;
class KonoeInputObjSocket;

class KonoeTclDrawPanel;
class KonoeTclDrawCanvas;
class KonoeTclDrawCanvasMouseListener;
class KonoeTcl2DrawPanel;
class KonoeTcl2DrawCanvas;
class KonoeTclDimension;
class KonoeClientSocket;
class KonoeInputObjSocket;
class Konoe1DHistogram;
class Konoe1DHistogramList;
class T4731DHistoCatcher;



class T473TclHistogramDisplay : public KonoeTclEventProcessor,
                                public KonoeTclWindowAction,
                                public KonoeTclMouseAction,
                                public KonoeTclMouseMotion,
                                public KonoeTclKeyAction,
                                public KonoeTclTimer {
  public:
    enum KTHistogramType { KT1DHistogram=0, KT2DHistogram };

  public:
    T473TclHistogramDisplay(KonoeTclWindow* kwin,
                            KChar* aHost, KInt aPort, KChar* histType="");
    ~T473TclHistogramDisplay();
    KInt draw1DHistogram();
    KInt draw2DHistogram();

    void setAutoVertical();
    void setDefault();

void selectHistogram();

  private:
    void create1DHistogramPanel(KonoeTclWindow* kwin);
    void create2DHistogramPanel(KonoeTclWindow* kwin);
    Konoe1DHistogram* get1DHistogramFromSocket();

    KonoeTclDimension getClickPoint(KInt x, KInt y);
    KFloat calcMean(KInt startX, KInt startY);
    KInt calcBinCount(KInt startX, KInt startY);

    void windowAction(KonoeTclCanvas* kcv, XEvent* xev);
    void keyAction(KonoeTclWindow* kcv, KInt type, KeySym keysym, KInt state);
    void timer();

  private:
    KonoeClientSocket* socket;
    KonoeInputObjSocket* in;

    KChar host[256];
    KInt  port;

    Konoe1DHistogram* hist1d;

    KInt  histCount;
    KChar histName[256];
    KInt  histNum;

    KonoeTclWindow* subWindow;
    KonoeTclDrawPanel* drawPanel;
    KonoeTclDrawCanvas* drawCanvas;
    KonoeTcl2DrawPanel* draw2DPanel;
    KonoeTcl2DrawCanvas* draw2DCanvas;
    Konoe1DHistogram* histogram[25];
    Konoe1DHistogramList* histogramList;

    KChar histType[32];
    KonoeTclBalloon* balloon;
    KonoeTclDrawCanvasMouseListener* mouseListener;
    T4731DHistoCatcher* catcher;

    KBool autoVertical;
    KBool repaint;
};

#endif
