//=====================================================================
/*

    T473TclHistogramDisplayController.hh

    Version 0.0.1   05-Oct-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLHISTOGRAMDISPLAYCONTROLLER_HH
#define __T473TCLHISTOGRAMDISPLAYCONTROLLER_HH

#include <Namespace/T473NameSpaceExtractor.hh>
#include <Namespace/T473NameSpaceSetter.hh>

#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseAction.hh>

class KonoeTclWindow;
class T473TclHistogramDisplayControllerAction;
#include <ui/KonoeTclWidget.hh>

class T473TclHistogramDisplayController : public KonoeTclEventProcessor,
                                          public KonoeTclMouseAction {

  public:
    T473TclHistogramDisplayController(KonoeTclWindow* kwin);
    ~T473TclHistogramDisplayController();

//    void mouseAction(KonoeTclButton* btn, KInt type, KInt button,
//                     Time time, KInt x, KInt y);
//    void mouseAction(KonoeTclRadioButton* btn, KInt type, KInt button,
//                     Time time, KInt x, KInt y);

    KInt getSelectedIndex();
    KonoeTclWindow* getWindow() { return controlWindow; }
    KChar* getHostName();
    KInt   getPortNumber();
    void   setConnect(KInt n);

  private:
    T473TclHistogramDisplayControllerAction* controllerAction;
    T473NameSpaceExtractor nsExtractor;
    T473NameSpaceSetter nsSetter;

    void initWidget();
    void insertItem();
    void requestButtonAction(KonoeTclButton* btn);
    void setEntry(KChar* h, KChar* p);

  private:
    KonoeTclWindow* controlWindow;

    KonoeTclFrame* selectFrame;
    KonoeTclRadioButton* connect0;
    KonoeTclRadioButton* connect1;
    KonoeTclRadioButton* connect2;

    KonoeTclLabel* hostLabel;
    KonoeTclEntry* hostEntry;
    KonoeTclLabel* portLabel;
    KonoeTclEntry* portEntry;

    KonoeTclFrame* listFrame;
    KonoeTclListBox* histList;
    KonoeTclButton* requestButton;

    KChar histHost[128];
    KChar histPort[3][64];
};

#endif
