//=====================================================================
/*

    T473TclHistogramDisplayControllerAction.cc

    Version 0.0.1   13-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclHistogramDisplayControllerAction.hh>
#include <T473TclHistogramDisplay.hh>
#include <T473TclHistogramDisplayCsI25.hh>
#include <T473TclHistogramDisplayScin.hh>
#include <ui/KonoeTclWindow.hh>

#include <stdlib.h>

T473TclHistogramDisplayControllerAction::T473TclHistogramDisplayControllerAction
                              (T473TclHistogramDisplayController* pController)
{
  controller = pController;
  controlWindow = controller->getWindow();

  port = 0;
}

T473TclHistogramDisplayControllerAction
                                  ::~T473TclHistogramDisplayControllerAction()
{ ; }

void T473TclHistogramDisplayControllerAction::mouseAction(KonoeTclButton* kbtn,
                             KInt type, KInt button, Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){
      if(strcmp(kbtn->getName(), "requestButton") == 0) requestAction();
    }
  }
}

void T473TclHistogramDisplayControllerAction::
                    mouseAction(KonoeTclRadioButton* btn, KInt type,
                                     KInt button, Time time, KInt x, KInt y)
{
  if(type == KMousePress && button == LButton){
    enum { CONNECT0, CONNECT1, CONNECT2 };
    if(strcmp(btn->getName(),"connect0")==0) controller->setConnect(CONNECT0);
    if(strcmp(btn->getName(),"connect1")==0) controller->setConnect(CONNECT1);
    if(strcmp(btn->getName(),"connect2")==0) controller->setConnect(CONNECT2);
  }
}

void T473TclHistogramDisplayControllerAction::requestAction()
{
  strcpy(host, controller->getHostName());
  port = controller->getPortNumber();

  KInt selectedIndex = controller->getSelectedIndex();


  T473TclHistogramDisplayCsI25* csi_tdc;
  T473TclHistogramDisplayCsI25* csi_adc;
  T473TclHistogramDisplayScin* scin_tdc;
  T473TclHistogramDisplayScin* scin_adc;

  KChar cmd[256];
  KChar histType[16];

  switch(selectedIndex){
    case CsI_TDC :
      strcpy(histType, "CsI_TDC");
      //csi_tdc = new
      //T473TclHistogramDisplayCsI25(controlWindow, host, port, "csi_tdc");
      break;

    case CsI_ADC:
      strcpy(histType, "CsI_ADC");
      //csi_adc = new
      //T473TclHistogramDisplayCsI25(controlWindow, host, port, "csi_adc");
      break;

    case Scin_TDC :
      strcpy(histType, "Scin_TDC");
      //scin_tdc = new
      //T473TclHistogramDisplayScin(controlWindow, host, port, "scin_tdc");
      break;

    case Scin_ADC :
      strcpy(histType, "Scin_ADC");
      //scin_adc = new
      //T473TclHistogramDisplayScin(controlWindow, host, port, "scin_adc");
      break;

    case TOF :
      strcpy(histType, "TOF");
      break;

    case CsI_ADC_SUM :
      strcpy(histType, "CsI_ADC_SUM");
      break;

    case Separator:
      break;

    case CsI_ADC_XENON:
      strcpy(histType, "CsI_ADC_XENON");
      break;

    case CsI_TDC_1 :
      strcpy(histType, "CsI_TDC1");
      break;
    case CsI_TDC_2 :
      strcpy(histType, "CsI_TDC2");
      break;
    case CsI_TDC_3 :
      strcpy(histType, "CsI_TDC3");
      break;
    case CsI_TDC_4 :
      strcpy(histType, "CsI_TDC4");
      break;
    case CsI_TDC_5 :
      strcpy(histType, "CsI_TDC5");
      break;
    case CsI_TDC_6 :
      strcpy(histType, "CsI_TDC6");
      break;
    case CsI_TDC_7 :
      strcpy(histType, "CsI_TDC7");
      break;
    case CsI_TDC_8 :
      strcpy(histType, "CsI_TDC8");
      break;
    case CsI_TDC_9 :
      strcpy(histType, "CsI_TDC9");
      break;
    case CsI_TDC_10 :
      strcpy(histType, "CsI_TDC10");
      break;
    case CsI_TDC_11 :
      strcpy(histType, "CsI_TDC11");
      break;
    case CsI_TDC_12 :
      strcpy(histType, "CsI_TDC12");
      break;
    case CsI_TDC_13 :
      strcpy(histType, "CsI_TDC13");
      break;
    case CsI_TDC_14 :
      strcpy(histType, "CsI_TDC14");
      break;
    case CsI_TDC_15 :
      strcpy(histType, "CsI_TDC15");
      break;
    case CsI_TDC_16 :
      strcpy(histType, "CsI_TDC16");
      break;
    case CsI_TDC_17 :
      strcpy(histType, "CsI_TDC17");
      break;
    case CsI_TDC_18 :
      strcpy(histType, "CsI_TDC18");
      break;
    case CsI_TDC_19 :
      strcpy(histType, "CsI_TDC19");
      break;
    case CsI_TDC_20 :
      strcpy(histType, "CsI_TDC20");
      break;
    case CsI_TDC_21 :
      strcpy(histType, "CsI_TDC21");
      break;
    case CsI_TDC_22 :
      strcpy(histType, "CsI_TDC22");
      break;
    case CsI_TDC_23 :
      strcpy(histType, "CsI_TDC23");
      break;
    case CsI_TDC_24 :
      strcpy(histType, "CsI_TDC24");
      break;
    case CsI_TDC_25 :
      strcpy(histType, "CsI_TDC25");
      break;
    case CsI_ADC_1 :
      strcpy(histType, "CsI_ADC1");
      break;
    case CsI_ADC_2 :
      strcpy(histType, "CsI_ADC2");
      break;
    case CsI_ADC_3 :
      strcpy(histType, "CsI_ADC3");
      break;
    case CsI_ADC_4 :
      strcpy(histType, "CsI_ADC4");
      break;
    case CsI_ADC_5 :
      strcpy(histType, "CsI_ADC5");
      break;
    case CsI_ADC_6 :
      strcpy(histType, "CsI_ADC6");
      break;
    case CsI_ADC_7 :
      strcpy(histType, "CsI_ADC7");
      break;
    case CsI_ADC_8 :
      strcpy(histType, "CsI_ADC8");
      break;
    case CsI_ADC_9 :
      strcpy(histType, "CsI_ADC9");
      break;
    case CsI_ADC_10 :
      strcpy(histType, "CsI_ADC10");
      break;
    case CsI_ADC_11 :
      strcpy(histType, "CsI_ADC11");
      break;
    case CsI_ADC_12 :
      strcpy(histType, "CsI_ADC12");
      break;
    case CsI_ADC_13 :
      strcpy(histType, "CsI_ADC13");
      break;
    case CsI_ADC_14 :
      strcpy(histType, "CsI_ADC14");
      break;
    case CsI_ADC_15 :
      strcpy(histType, "CsI_ADC15");
      break;
    case CsI_ADC_16 :
      strcpy(histType, "CsI_ADC16");
      break;
    case CsI_ADC_17 :
      strcpy(histType, "CsI_ADC17");
      break;
    case CsI_ADC_18 :
      strcpy(histType, "CsI_ADC18");
      break;
    case CsI_ADC_19 :
      strcpy(histType, "CsI_ADC19");
      break;
    case CsI_ADC_20 :
      strcpy(histType, "CsI_ADC20");
      break;
    case CsI_ADC_21 :
      strcpy(histType, "CsI_ADC21");
      break;
    case CsI_ADC_22 :
      strcpy(histType, "CsI_ADC22");
      break;
    case CsI_ADC_23 :
      strcpy(histType, "CsI_ADC23");
      break;
    case CsI_ADC_24 :
      strcpy(histType, "CsI_ADC24");
      break;
    case CsI_ADC_25 :
      strcpy(histType, "CsI_ADC25");
      break;
    case Scin_TDC_1L :
      strcpy(histType, "Scin_TDC1L");
      break;
    case Scin_TDC_1R :
      strcpy(histType, "Scin_TDC1R");
      break;
    case Scin_TDC_1P :
      strcpy(histType, "Scin_TDC1P");
      break;
    case Scin_TDC_2 :
      strcpy(histType, "Scin_TDC2");
      break;
    case Scin_TDC_3 :
      strcpy(histType, "Scin_TDC3");
      break;
    case Scin_TDC_4 :
      strcpy(histType, "Scin_TDC4");
      break;
    case Scin_TDC_5 :
      strcpy(histType, "Scin_TDC5");
      break;
    case Scin_TDC_6 :
      strcpy(histType, "Scin_TDC6");
      break;
    case Scin_TDC_7 :
      strcpy(histType, "Scin_TDC7");
      break;
    case Scin_ADC_1L :
      strcpy(histType, "Scin_ADCL1");
      break;
    case Scin_ADC_1R :
      strcpy(histType, "Scin_ADCR1");
      break;
    case Scin_ADC_1P :
      strcpy(histType, "Scin_ADC1P");
      break;
    case Scin_ADC_2 :
      strcpy(histType, "Scin_ADC2");
      break;
    case Scin_ADC_3 :
      strcpy(histType, "Scin_ADC3");
      break;
    case Scin_ADC_4 :
      strcpy(histType, "Scin_ADC4");
      break;
    case Scin_ADC_5 :
      strcpy(histType, "Scin_ADC5");
      break;
    case Scin_ADC_6 :
      strcpy(histType, "Scin_ADC6");
      break;
    case Scin_ADC_7 :
      strcpy(histType, "Scin_ADC7");
      break;
    case GC_TDC_1 :
      strcpy(histType, "GC_TDC1");
      break;
    case GC_TDC_2 :
      strcpy(histType, "GC_TDC2");
      break;
    case GC_ADT_1 :
      strcpy(histType, "GC_ADC1");
      break;
    case GC_ADC_2 :
      strcpy(histType, "GC_ADC2");
      break;
    case XENON_ADC_1 :
      strcpy(histType, "XENON_ADC1");
      break;
    case XENON_ADC_2 :
      strcpy(histType, "XENON_ADC2");
      break;
    case XENON_ADC_3 :
      strcpy(histType, "XENON_ADC3");
      break;
    case XENON_ADC_4 :
      strcpy(histType, "XENON_ADC4");
      break;
    case XENON_TDC_1 :
      strcpy(histType, "XENON_TDC1");
      break;
    case XENON_TDC_2 :
      strcpy(histType, "XENON_TDC2");
      break;
    case XENON_TDC_3 :
      strcpy(histType, "XENON_TDC3");
      break;
    case XENON_TDC_4 :
      strcpy(histType, "XENON_TDC4");
      break;
    default :
      ;
  }
  if(selectedIndex != 7){
    sprintf(cmd, "T473exechist %s %d %s &", host, port, histType);

    KInt value;
    value = system(cmd);

/***********************:
    if(value == 127 || value == -1 || value == 0){
      KChar t473path[256];
      strcpy( t473path, getenv("T473_PATH") );
      if( strlen(t473path) > 0 ){
        cerr << "T473_PATH is not defined." << endl;
      }
      else{
        sprintf(cmd, "%s/exechistT473 %s %d %s &",
                      t473path, host, port, histType);
        value = system(cmd);
        if( value == 127 || value == -1 || value == 0){
          cerr << "unknown error." << endl;
        }
      }
    }  // 1st system function error
****************************/
  }  // end of selectedIndex != 7
}
