//=====================================================================
/*

    T473TclHistogramDisplayControllerAction.hh

    Version 0.0.1   13-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLHISTOGRAMDISPLAYCONTROLLERACTION_HH
#define __T473TCLHISTOGRAMDISPLAYCONTROLLERACTION_HH

#include <T473TclHistogramDisplayController.hh>
#include <Namespace/T473NameSpaceExtractor.hh>
#include <Namespace/T473NameSpaceSetter.hh>
#include <ui/KonoeTclAction.hh>

class T473TclHistogramDisplayControllerAction : public KonoeTclEventProcessor,
                                                public KonoeTclMouseAction {

  public:
    T473TclHistogramDisplayControllerAction
                 (T473TclHistogramDisplayController* pController);
    ~T473TclHistogramDisplayControllerAction();

    void mouseAction(KonoeTclButton* btn, KInt type, KInt button,
                     Time time, KInt x, KInt y);
    void mouseAction(KonoeTclRadioButton* btn, KInt type, KInt button,
                     Time time, KInt x, KInt y);

  private:
    void requestAction();

  private:
    enum { CsI_TDC, CsI_ADC, Scin_TDC, Scin_ADC, TOF, CsI_ADC_SUM,
           CsI_ADC_XENON, Separator,
           CsI_TDC_1, CsI_TDC_2, CsI_TDC_3, CsI_TDC_4, CsI_TDC_5,
           CsI_TDC_6, CsI_TDC_7, CsI_TDC_8, CsI_TDC_9, CsI_TDC_10,
           CsI_TDC_11, CsI_TDC_12, CsI_TDC_13, CsI_TDC_14, CsI_TDC_15,
           CsI_TDC_16, CsI_TDC_17, CsI_TDC_18, CsI_TDC_19, CsI_TDC_20,
           CsI_TDC_21, CsI_TDC_22, CsI_TDC_23, CsI_TDC_24, CsI_TDC_25,
           CsI_ADC_1, CsI_ADC_2, CsI_ADC_3, CsI_ADC_4, CsI_ADC_5,
           CsI_ADC_6, CsI_ADC_7, CsI_ADC_8, CsI_ADC_9, CsI_ADC_10,
           CsI_ADC_11, CsI_ADC_12, CsI_ADC_13, CsI_ADC_14, CsI_ADC_15,
           CsI_ADC_16, CsI_ADC_17, CsI_ADC_18, CsI_ADC_19, CsI_ADC_20,
           CsI_ADC_21, CsI_ADC_22, CsI_ADC_23, CsI_ADC_24, CsI_ADC_25,
           Scin_TDC_1L, Scin_TDC_1R, Scin_TDC_1P, Scin_TDC_2, Scin_TDC_3,
           Scin_TDC_4, Scin_TDC_5, Scin_TDC_6, Scin_TDC_7,
           Scin_ADC_1L, Scin_ADC_1R, Scin_ADC_1P, Scin_ADC_2, Scin_ADC_3,
           Scin_ADC_4, Scin_ADC_5, Scin_ADC_6, Scin_ADC_7,
           GC_TDC_1, GC_TDC_2, GC_ADT_1, GC_ADC_2,
           XENON_ADC_1, XENON_ADC_2, XENON_ADC_3, XENON_ADC_4,
           XENON_TDC_1, XENON_TDC_2, XENON_TDC_3, XENON_TDC_4 };
    KonoeTclWindow* controlWindow;
    T473TclHistogramDisplayController* controller;
    T473NameSpaceExtractor nsExtractor;
    T473NameSpaceSetter nsSetter;

    KChar host[256];
    KInt port;
};

#endif
