//=====================================================================
/*

    T473TclHistogramDisplayCsI25.hh

    Version 0.0.1   21-Oct-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLHISTOGRAMDISPLAYCSI25_HH
#define __T473TCLHISTOGRAMDISPLAYCSI25_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseAction.hh>
#include <ui/KonoeTclWindowAction.hh>
#include <ui/KonoeTclAction.hh>

class KonoeClientSocket;
class KonoeInputObjSocket;
class KonoeHistogramCM;
class KonoePhysicalValueCM;

class KonoeTclSubWindow;
class KonoeTclDrawPanel;
class KonoeTclDrawCanvas;
class KonoeTclDrawCanvasMouseListener;
class KonoeTcl2DrawPanel;
class KonoeTcl2DrawCanvas;
class KonoeClientSocket;
class KonoeInputObjSocket;
class Konoe1DHistogram;
class Konoe1DHistogramList;
class T4731DHistoCatcher;
class T473TclHistogramDisplayOption;

class T473TclHistogramDisplayCsI25 : public KonoeTclEventProcessor,
                                     public KonoeTclWindowAction,
                                     public KonoeTclKeyAction,
                                     public KonoeTclTimer {

  public:
    T473TclHistogramDisplayCsI25(KonoeTclWindow* kwin,
                                 KChar* aHost, KInt aPort,
                                 KChar* phistType = "csi_adc");
    ~T473TclHistogramDisplayCsI25();

    void setAutoVertical();
    void setDefault();

    void setOption( KInt x, KInt y, KInt vmax, KInt hmin, KInt hmax, KInt hbin,                     KInt mark, KInt bigMark, KInt histType, KChar* histColor );
    KInt saveAsXWDButtonAction(KChar* pfName);
    void saveToFile(KChar* fName);

    
  public:
    enum { BOX, FILL, LINE };

  private:
    KInt drawHistogram();
    void setVerticalScale();
    void windowAction(KonoeTclWindow* kcv, XEvent* xev);
    void keyAction(KonoeTclWindow* kcv, KInt type, KeySym keysym, KInt state);
    void timer();

  private:
    KChar aHost[256];
    KInt  aPort;
    KChar histType[256];
    KChar backColor[256];
    KChar fullPath[256];
    KChar histTypeName[16];
    Konoe1DHistogram* dummyHisto[25];
    KonoeClientSocket* socket;
    KonoeInputObjSocket* in;

    //KonoeTclSubWindow* subWindow;
    KonoeTclWindow* subWindow;
    KonoeTclFrame** drawFrame;
    KonoeTclDrawPanel** drawPanel;
    KonoeTclDrawCanvas** drawCanvas;
    KonoeTclDrawCanvasMouseListener* cMouseListener;

    Konoe1DHistogram* histogram[25];
    Konoe1DHistogramList *histogramList;
    KonoeHistogramCM* histogramCM;
    KonoePhysicalValueCM* physicalValueCM;
    T4731DHistoCatcher* catcher;

    KBool autoVertical;

    T473TclHistogramDisplayOption* option;
};

#endif
