//=====================================================================
/*

    T473TclHistogramDisplayExec.cc

    Version 0.0.1   07-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclHistogramDisplayExec.hh>
#include <T473TclHistogramDisplay.hh>
#include <T473TclHistogramDisplayCsI25.hh>
#include <T473TclHistogramDisplayScin.hh>

#include <ui/KonoeTclMainWindow.hh>

T473TclHistogramDisplayExec::T473TclHistogramDisplayExec(KChar* host, KInt port,                                                         KChar* histType)
{
  KChar wtitle[256];
  //if( strcmp(histType, "csi_tdc" == 0 ) strcpy(histType, "CsI_TDC");
  //if( strcmp(histType, "csi_adc" == 0 ) strcpy(histType, "CsI_ADC");
  //if( strcmp(histType, "scin_tdc" == 0 ) strcpy(histType, "Scin_TDC");
  //if( strcmp(histType, "scin_adc" == 0 ) strcpy(histType, "Scin_ADC");

  sprintf(wtitle, "%s (%s : %d)", histType, host, port);
  m = new KonoeTclMainWindow(wtitle);

  if( strcmp(histType, "CsI_TDC") == 0){
    strcpy(histType, "csi_tdc");
    T473TclHistogramDisplayCsI25* csi25
        = new T473TclHistogramDisplayCsI25(m, host, port, histType);
  }
  else if( strcmp(histType, "CsI_ADC") == 0){
    strcpy(histType, "csi_adc");
    T473TclHistogramDisplayCsI25* csi25
        = new T473TclHistogramDisplayCsI25(m, host, port, histType);
  }
  else if( strcmp(histType, "Scin_TDC") == 0){
    strcpy(histType, "scin_tdc");
    T473TclHistogramDisplayScin* scin25
        = new T473TclHistogramDisplayScin(m, host, port, histType);
  }
  else if( strcmp(histType, "Scin_ADC") == 0){
    strcpy(histType, "scin_adc");
    T473TclHistogramDisplayScin* scin25
        = new T473TclHistogramDisplayScin(m, host, port, histType);
  }
  else if( strcmp(histType, "CsI_ADC_XENON") == 0){
    strcpy(histType, "csi_adc_xenon");
    T473TclHistogramDisplayCsI25* csi25
        = new T473TclHistogramDisplayCsI25(m, host, port, histType);
  }
  else{
    T473TclHistogramDisplay* hd
        = new T473TclHistogramDisplay(m, host, port, histType);
  }
}

T473TclHistogramDisplayExec::~T473TclHistogramDisplayExec()
{ ; }

void T473TclHistogramDisplayExec::go()
{
  m->mainLoop();
}
