//=====================================================================
/*

    T473TclHistogramDisplayOption.cc

    Version 0.0.1   12-Dec-2000 T. Hosoi

*/
//====================================================================

#include <T473TclHistogramDisplayOption.hh>
#include <stdlib.h>

T473TclHistogramDisplayOption::T473TclHistogramDisplayOption
                    (KonoeTclWindow* pwin, T473TclHistogramDisplayCsI25* pcsi)
                                   : KonoeTclDrawCanvasController(pwin)
{
  kwin = pwin;
  csi = pcsi;
  scin = 0;
  KonoeTclDrawCanvasController::setButton->setEventProcessor(this);
  addMouseAction(setButton);
  KonoeTclDrawCanvasController::saveAsXWDButton->setEventProcessor(this);
  addMouseAction(saveAsXWDButton);
  KonoeTclDrawCanvasController::saveAsDataButton->setEventProcessor(this);
  addMouseAction(saveAsDataButton);

  histCanvasSizeEntryX->setText("140");
  histCanvasSizeEntryY->setText("140");

  verticalScaleEntry->setText("100");

  horizontalMinEntry->setText("0");
  horizontalMaxEntry->setText("4096");
  horizontalBinCountEntry->setText("4096");

  horizontalMarkTotalEntry->setText("10");
  horizontalBigMarkTotalEntry->setText("2");

  drawTypeBoxRadio->setSelect();
  setHistColorEntry->setText("black");

  saveAsXWDEntry->setText("histogram.xwd");
  saveAsDataEntry->setText("histogram.obj");

  verticalMarkTotalLabel->setGridForget();
  verticalBigMarkTotalLabel->setGridForget();
  verticalMarkTotalEntry->setGridForget();
  verticalBigMarkTotalEntry->setGridForget();
  saveAsButton->setGridForget();
  saveAsEntry->setGridForget();
}

T473TclHistogramDisplayOption::T473TclHistogramDisplayOption
                    (KonoeTclWindow* pwin, T473TclHistogramDisplayScin* pscin)
                                   : KonoeTclDrawCanvasController(pwin)
{
  scin = pscin;
  csi = 0;
  KonoeTclDrawCanvasController::setButton->setEventProcessor(this);
  addMouseAction(setButton);


  histCanvasSizeEntryX->setText("140");
  histCanvasSizeEntryY->setText("140");

  verticalScaleEntry->setText("100");

  horizontalMinEntry->setText("0");
  horizontalMaxEntry->setText("4096");
  horizontalBinCountEntry->setText("4096");

  horizontalMarkTotalEntry->setText("10");
  horizontalBigMarkTotalEntry->setText("2");

  drawTypeBoxRadio->setSelect();
  setHistColorEntry->setText("black");

  saveAsXWDEntry->setText("histogram.xwd");
  saveAsDataEntry->setText("histogram.obj");

  verticalMarkTotalLabel->setGridForget();
  verticalBigMarkTotalLabel->setGridForget();
  verticalMarkTotalEntry->setGridForget();
  verticalBigMarkTotalEntry->setGridForget();
  saveAsButton->setGridForget();
  saveAsEntry->setGridForget();
}

T473TclHistogramDisplayOption::~T473TclHistogramDisplayOption()
{ ; }

void T473TclHistogramDisplayOption::mouseAction(KonoeTclButton* kbtn,
                           KInt type, KInt button, Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){

      if(strcmp(kbtn->getName(), "setButton") == 0 )
        setButtonAction();

      else if(strcmp(kbtn->getName(), "saveAsXWDButton") == 0){
        if(csi)
          csi->saveAsXWDButtonAction(saveAsXWDEntry->getText());
        else if(scin)
          scin->saveAsXWDButtonAction(saveAsXWDEntry->getText());
      }
      else if(strcmp(kbtn->getName(), "saveAsDataButton") == 0){
        if(csi)
          csi->saveToFile(saveAsDataEntry->getText());
        else if(scin)
          scin->saveToFile(saveAsDataEntry->getText());
      }

    }
  }
}

void T473TclHistogramDisplayOption::keyAction(KonoeTclEntry* kbt, KInt type,
                                                     KeySym keysym, KInt state)
{
  if(type == KKeyRelease){
    if(keysym == XK_KP_Enter || keysym == XK_Return){
    }
  }
}

KInt T473TclHistogramDisplayOption::setButtonAction()
{
  KInt x = atoi(histCanvasSizeEntryX->getText());
  KInt y = atoi(histCanvasSizeEntryY->getText());

  KFloat vmax = atoi(verticalScaleEntry->getText());

  KInt hmin = atoi(horizontalMinEntry->getText());
  KInt hmax = atoi(horizontalMaxEntry->getText());
  KInt hbin = atoi(horizontalBinCountEntry->getText());

  KInt mark = atoi(horizontalMarkTotalEntry->getText());
  KInt bigMark = atoi(horizontalBigMarkTotalEntry->getText());

  KInt histType = atoi(drawTypeBoxRadio->getValue());

  KChar histColor[32];
  strcpy(histColor, setHistColorEntry->getText());

  if(x < 1) x = 1;
  if(y < 1) y = 1;
  if(vmax < 1) vmax = 1;
  if(hmin < 0) hmin = 0;
  if(hmax < 1) hmax = 1;
  if(hbin < 1) hbin = 1;
  if(mark < 1) mark = 1;
  if(bigMark < 1) bigMark = 1;

  if(csi)
  csi->setOption(x, y, vmax, hmin, hmax, hbin, mark, bigMark, histType,
                 histColor);
  else if(scin)
  scin->setOption(x, y, vmax, hmin, hmax, hbin, mark, bigMark, histType,
                  histColor);

  return 0;
}
