//=====================================================================
/*

    T473TclHistogramDisplayScin.hh

    Version 0.0.1   15-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLHISTOGRAMDISPLAYSCIN_HH
#define __T473TCLHISTOGRAMDISPLAYSCIN_HH

#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclSubWindow.hh>

class T4731DHistoCatcher;

class KonoeTclDrawPanel;
class KonoeTclDrawCanvas;
class KonoeTclDrawCanvasMouseListener;
class Konoe1DHistogram;
class Konoe1DHistogramList;
class T473TclHistogramDisplayOption;

class T473TclHistogramDisplayScin : public KonoeTclEventProcessor,
                                    public KonoeTclWindowAction,
                                    public KonoeTclKeyAction,
                                    public KonoeTclTimer {

  public:
    T473TclHistogramDisplayScin(KonoeTclWindow* pwin,
                                KChar* pHost, KInt pPort,
                                KChar* phistType = "scin_adc");
    ~T473TclHistogramDisplayScin();

    void setAutoVertical();
    void setDefault();

    void setOption( KInt x, KInt y, KInt vmax, KInt hmin, KInt hmax, KInt hbin,
                    KInt mark, KInt bigMark, KInt histType, KChar* histColor );
    KInt saveAsXWDButtonAction(KChar* pfName);
    void saveToFile(KChar* fName);

  public:
    enum { BOX, FILL, LINE };

  private:
    KInt drawHistogram();
    void setVerticalScale();
    void windowAction(KonoeTclWindow* kcv, XEvent* xev);
    void keyAction(KonoeTclWindow* kcv, KInt type, KeySym keysym, KInt state);
    void timer();

  private:
    KChar aHost[256];
    KInt  aPort;
    KChar histType[256];
    KChar backColor[256];
    KChar fullPath[256];
    KChar histTypeName[16];
    Konoe1DHistogram* dummyHisto[11];

    //KonoeTclSubWindow* subWindow;
    KonoeTclWindow* subWindow;
    KonoeTclFrame** drawFrame;
    KonoeTclDrawPanel** drawPanel;
    KonoeTclDrawCanvas** drawCanvas;
    KonoeTclDrawCanvasMouseListener* cMouseListener;

    Konoe1DHistogram* histogram[25];
    Konoe1DHistogramList *histogramList;
    T4731DHistoCatcher* catcher;

    KBool autoVertical;

    T473TclHistogramDisplayOption* option;
};

#endif
