//==============================================================
/*
	T473LogSender.cc

  	 3-Oct-2000	Y. Shimizu
	15-Oct-2000	Y. Shimizu
*/
//==============================================================

#include	"T473LogSender.hh"
#include	"../Namespace/T473NameSpaceExtractor.hh"

T473LogSender::T473LogSender( ){

	T473NameSpaceExtractor *ext = new T473NameSpaceExtractor; 
	flag = 0;
	KChar* host = ext->getKCharValue("LOGGER_HOST");
	KInt port = ext->getKIntValue("LOGGER_PORT");

	if( host == (KChar*)-1 ){
		cerr <<"T473LogSender::LOGGER_HOST is not defined"<<endl;
		flag = 1;
	}
	if( port == -1 ){
		cerr <<"T473LogSender::LOGGER_PORT is not defined"<<endl;
		flag = 1;
	}
	messenger = new KonoeLogMessenger( host,port );
	delete ext;
	
}

T473LogSender::~T473LogSender( ){
	delete messenger;
}

KInt T473LogSender::send( KChar* text, KInt level ){

	KonoeLogMessage * msg = new KonoeLogMessage(text,level);
	if( flag == 0 ){
	    messenger->send( msg->getLogMsg(), 256 );	
	    delete msg;
	    msg = 0;
	    return 0;
	}
	else {
	    delete msg;
	    msg = 0;
	    return -1;
	}
}
