//======================================================
/*
	t473stdeToLog.cc

	25-Nov-2000	Y. Shimizu

	Standard-error-output converted to Log-Message
*/
//======================================================
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<signal.h>
#include<errno.h>
#include <system/KonoeHostSystem.hh>
#include"T473LogSender.hh"
#define R (0)
#define W (1)

static struct pid {
  struct pid *next;
  FILE* fp;

  pid_t pid;
} * pidlist;

FILE *popen_err( char* command ){

  struct pid *cur;
  int pipe_c2p_e[2];
  int pid;
  FILE *fp;
  
  if( (cur = (struct pid*)malloc(sizeof(struct pid ))) == NULL ){
    cerr << "popen_err():malloc error:return (NULL)" << endl;
    KonoeHostSystem::exit(0);
  }

  if( pipe( pipe_c2p_e) < 0 ){
    perror("pipe");
    return (NULL);
  }

  if( ( pid = fork() ) < 0  ){
    perror("fork");
    close(pipe_c2p_e[R]);
    close(pipe_c2p_e[W]);
    return (NULL);
  }
    
  if( pid == 0 ){
    close(pipe_c2p_e[R]);
    dup2(pipe_c2p_e[W],2);
    close(pipe_c2p_e[W]);
    execlp("sh","sh","-c",command,NULL);
    _exit(127);
  }

  close(pipe_c2p_e[W]);
  fp = fdopen(pipe_c2p_e[R],"r");
  
  cur->fp     = fp;
  cur->pid    = pid;
  cur->next   = pidlist;
  pidlist     = cur;

  return (fp);

}

int main(int argc, char** argv){

        if( argc != 2 ){
                cout << "./t473stdeToLog.cc <command> " << endl;
                KonoeHostSystem::exit(0);
        }

        T473LogSender * log = new T473LogSender;
        KChar   buffer[256];
        KChar   * ptr;
        KChar   * processname; 
        FILE    * fp;

        if( ( fp = popen_err(*(++argv)) ) == NULL ){
                cerr << "popen_err : error " << endl;
                KonoeHostSystem::exit(0);
        }
        processname = *argv;
        
        while(1){
                fgets(buffer,256,fp);

                if( feof( fp ) ){
                        break;
                }
                ptr = strchr(buffer,'\n');
                if( ptr != NULL ){
                        *ptr = '\0';
                }
                strcat(buffer,":");
                strcat(buffer,processname);
                log->send(buffer,1);
        }

        return (0);

}

