//======================================================================
/*
               InfoSetter.cc
                    set infomation for reconstruct
                              9-Nov-2000 Kirika Uchida
*/
//======================================================================
#include <system/KonoeNetworkNameSpaceManager.hh>
#include <system/KonoeMicroSleep.hh>
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include "T473.hh"
#include <unistd.h>
class InfoSetter{
private:
  KonoeNetworkNameSpaceManager   * ns_manager;
  KonoeMicroSleep                     m_sleep;
public:
  InfoSetter();
  ~InfoSetter(){}
  KInt go();

};

InfoSetter::InfoSetter() {
  KInt  id, seg, sa, k;
  KChar entry_name[256], value[256];
  ns_manager = new KonoeNetworkNameSpaceManager( );
  cout << "new name space manager " << endl;
  ns_manager -> setValue( "DATAHUB_HOST", "konoe3" );
  ns_manager -> setValue( "DATAHUB_OUTPUT_PORT", "11100" );
  ns_manager -> setValue( "REC_TO_GUI_PORT", "12500" );
  
  for( k = 0; k < 256; k ++ )
    value[k] = 0;
  //address  
  id = 1;
  for( seg = 0; seg < 4; seg ++ ) {
    for( sa = 0; sa < 8 && 8 * seg + sa < 25; sa ++ ) {
      sprintf( entry_name, "CSI_%d_TDC_SEG", id ); 
      sprintf( value, "%d", seg );
      ns_manager -> setValue( entry_name, value );
      sprintf( entry_name, "CSI_%d_TDC_SA", id ); 
      sprintf( value, "%d", sa );
      ns_manager -> setValue( entry_name, value );
      m_sleep.sleep( 1 );
      id ++;
    }
  }
  id = 1;
  for( seg = 0; seg < 2; seg ++ ) {
    for( sa = 0; sa < 16 && 16 * seg + sa < 25; sa ++ ) {
      sprintf( entry_name, "CSI_%d_ADC_SEG", id ); 
      sprintf( value, "%d", seg );
      ns_manager -> setValue( entry_name, value );
      sprintf( entry_name, "CSI_%d_ADC_SA", id ); 
      sprintf( value, "%d", sa );
      ns_manager -> setValue( entry_name, value );
      m_sleep.sleep( 1 );
      id ++;
    }
  }
  cout << "have set address" << endl;
  // geometry
  ns_manager -> setValue( "AD_X", "140" );
  ns_manager -> setValue( "AD_Y", "-140" );
  ns_manager -> setValue( "AD_Z", "0" );
  
  ns_manager -> setValue( "OA_X", "0" );
  ns_manager -> setValue( "OA_Y", "0" );
  ns_manager -> setValue( "OA_Z", "0" );
  
  ns_manager -> setValue( "THETA_X", "0" );
  ns_manager -> setValue( "THETA_Y", "0" );
  ns_manager -> setValue( "THETA_Z", "0" );
  //  cout << "have set geometry" << endl;
  //calibration info
  for( seg = 0; seg < 4; seg ++ ) {
    for( sa = 0; sa < 8 && 8 * seg + sa < 25; sa ++ ) {
      sprintf( entry_name, " CSI_TDC_%d_%d_PED",seg, sa );  
      ns_manager -> setValue( entry_name, "0" );
      sprintf( entry_name, "CSI_TDC_%d_%d_GAIN",seg, sa );  
      ns_manager -> setValue( entry_name, "1.0");
      m_sleep.sleep( 1 );
    }
  }
  for( seg = 0; seg < 2; seg ++ ) {
    for( sa = 0; sa < 16 && 16 * seg + sa < 25; sa ++ ) {
      sprintf( entry_name, "CSI_ADC_%d_%d_PED",seg, sa );  
      ns_manager -> setValue( entry_name, "0" );
      sprintf( entry_name, "CSI_ADC_%d_%d_GAIN",seg, sa );  
      ns_manager -> setValue( entry_name, "1.0");
      m_sleep.sleep( 1 );
    }
  }
  //  cout << "have set calibration info" << endl;
}

KInt InfoSetter::go(){
  int id, seg, sa, state, t;
  char  entry_name[256];
  char  value[256];
  char cmd1, cmd2;
  char cmd3[10], offset[10], gain[10];
  while( 1 ){
    //  cout << "reconstruct info file [rec_info]" << endl;
    cout << "a: to change address" << endl;
    cout << "g: to change geometry" << endl;
    cout << "i: to change cariblation infomation" << endl;
    cout << "e: to end this program" << endl;
    cin  >> cmd1 ;
    switch( cmd1 ) {
    case 'a' :
      state = 1;
      while( state ){
	cout << "t: to change CsI TDC address" << endl;
	cout << "a: to change CsI ADC address" << endl;
	cout << "q: to quit " << endl;
	cin >> cmd2;
	switch( cmd2 ) {
	case 't':
	  cout << "atttach CsI element to instrument TDC address" << endl;
	  cout << "change address of CsI ID   : ";          cin >> id; 
	  cout << "segment N  : "; cin >> seg; 
	  cout << "sub address: ";   cin >> sa; 
	  sprintf( entry_name, "CSI_%d_TDC_SEG", id );
	  sprintf( value, "%d", seg );
	  ns_manager -> setValue( entry_name, value );
	  sprintf( entry_name, "CSI_%d_TDC_SA", id );
	  sprintf( value, "%d", sa );
	  ns_manager -> setValue( entry_name, value );
	  break;
	case 'a' :
	  cout << "atttach CsI element to instrument ADC address" << endl;
	  cout << "change address of CsI ID: ";          cin >> id; 
	  cout << "segment N  : "; cin >> seg; 
	  cout << "sub address: ";   cin >> sa; 
	  sprintf( entry_name, "CSI_%d_ADC_SEG", id );
	  sprintf( value, "%d", seg );
	  ns_manager -> setValue( entry_name, value );
	  sprintf( entry_name, "CSI_%d_ADC_SA", id );
	  sprintf( value, "%d", sa );
	  ns_manager -> setValue( entry_name, value );
	  cout << endl << endl;
	  ns_manager -> dump( cout );
	  break;
	case 'q' :
	  ns_manager -> dump( cout );
	  state = 0;
	  break;
	default:
	  cout << "invalid value" << endl;
	
	}
      }
      break;
    case 'g':
      while(state){
	cout << "AD: to change AD" << endl;
	cout << "oa: to change oa" << endl;
	cout << "theta: to change theta" << endl;
	cout << "q: to quit" << endl;
	cin >> cmd3;
	if( !strcmp( cmd3, "AD" ) ){
	  cout << "AD.x: "; cin >> value;
	  ns_manager -> setValue( "AD_X", value );
	  cout << "AD.y: "; cin >> value;
	  ns_manager -> setValue( "AD_Y", value );
	  cout << "AD.z: "; cin >> value;
	  ns_manager -> setValue( "AD_Z", value );
	}
	else if( !strcmp( cmd3, "oa" ) ){
	  cout << "oa.x"; cin >> value;
	  ns_manager -> setValue( "OA_X", value );
	  cout << "oa.y"; cin >> value;
	  ns_manager -> setValue( "OA_Y", value );
	  cout << "oa.z"; cin >> value;
	  ns_manager -> setValue( "OA_Z", value );
	}
	else if( !strcmp( cmd3, "theta") ){
	  cout << "theta.x: "; cin >> value;
	  ns_manager -> setValue( "THETA_X", value );
	  cout << "theta.y: "; cin >> value;
	  ns_manager -> setValue( "THETA_Y", value );
	  cout << "theta.z: "; cin >> value;
	  ns_manager -> setValue( "THETA_Z", value );
	}
	else if( !strcmp( cmd3, "q" ) )
	  state = 0;
	else
	  cout << "invalid value" << endl;
      }
      break;
    case 'i':
      while( state ){
	cout << "t: to change CsI TDC Calibration Infomation" << endl;
	cout << "a: to change CsI ADC Calibration Infomation" << endl;
	cout << "q: to quit " << endl;
	cin >> cmd2;
	switch( cmd2 ) {
	case 't':
	  cout << "change CsI TDC Calibration Infomation" << endl;
	  cout << "segment N  : "; cin >> seg; 
	  cout << "sub address: "; cin >> sa; 
	  cout << "offset: "; cin >> offset;
	  cout << "gain: "; cin >> gain;
	  sprintf( entry_name, "CSI_TDC_%d_%d_PED",seg, sa );  	  
	  ns_manager -> setValue( entry_name, offset );
	  sprintf( entry_name, "CSI_TDC_%d_%d_GAIN",seg, sa ); 
	  ns_manager -> setValue( entry_name, gain );
	  break;
	case 'a' :
	  cout << "change CsI ADC Calbration Infomation" << endl;
	  cout << "segment N  : "; cin >> seg; 
	  cout << "sub address: ";   cin >> sa; 
	  cout << "offset: "; cin >> offset;
	  cout << "gain: "; cin >> gain;
	  sprintf( entry_name, "CSI_ADC_%d_%d_PED",seg, sa );    
	  ns_manager -> setValue( entry_name, offset );
	  sprintf( entry_name, "ADC SEG%2d SA%2d GAIN",seg, sa ); 
	  ns_manager -> setValue( entry_name, gain );
	  break;
	case 'q' :
	  ns_manager -> dump( cout );
	  state = 0;
	  break;
	default:
	  cout << "invalid value" << endl;
	}
      }
      break;
    case 'e':
      cout << "end this program" << endl;
      ns_manager -> dump( cout );
      return 0;
    default:
      cout << "invalid value" << endl;
      break;
    }
  }
  return 0;
}

int main( int argc, char **argv ){
  cout << "in main" << endl;
  InfoSetter setter;
  setter.go();
  return 0;
}


