//========================================================================
/*
          T473ADCCalibrator.cc
          20-Oct-2000   Kirika Uchida
*/
//========================================================================

#include "T473ADCCalibrator.hh"

T473ADCCalibrator::T473ADCCalibrator( KonoeList<T473CalibrationInfo> * plist ){
  list = plist;
}

KInt T473ADCCalibrator::convert( KonoeDetectorHit * hit,
				KonoeDataElement * element ){
  
  KInt k, offset;
  KFloat e,gain;
  KonoeDetectorElement * de;
  T473CalibrationInfo * info;
  k = * ( KInt * )element ->getStore();
  hit -> setADCValue( k );

  de = hit -> getDetectorElement();
  info = find( de );
  
  offset =  info -> getOffset();
 // cout << "adc calibrator bit offset: " << offset << endl;
  gain = info -> getGain();
  e = ( k - offset ) * gain;
  hit -> setHitEnergy( e );
    return 0;
}

T473CalibrationInfo * T473ADCCalibrator::find
                          ( KonoeDetectorElement * de ){
  T473CalibrationInfo * info;
  KonoeDataAddress    * address;
  KonoeDataAddress    * refaddress;
  int i = 0;
  list -> reset();
 /* while( info = list -> next() ){
    info -> reset();
    address = info -> next() ;
    cout << i << " : " << address << endl;
    i ++;
  }
  */
  //  cout << "ADC calibration Info count: " << list -> getCount() << endl;
  list -> reset();
  while( info = list -> next() ){
    info -> reset();
    while( address = info -> next()){
      de -> reset();
      while( refaddress = de -> next() ){
	//	refaddress -> dump( cout );
	if( address -> match( * refaddress )){
	  return info;
	}
      }
    }
  }
  return 0;
}
