//======================================================================
/*
               T473AnalyzerMaker.hh
	       23-Oct-2000  Kirika Uchida
*/
//======================================================================
#ifndef __T473ANALYZERMAKER_HH__
#define __T473ANALYZERMAKER_HH__

#include <analysis/KonoeDataAnalyzer.hh>
#include <T473GeneralSectionAnalyzer.hh>
#include <analysis/KonoeDetector.hh>
#include <analysis/KonoeHitSectionAnalyzer.hh>
#include "T473DummySectionAnalyzer.hh"
#include "T473TDCCalibrator.hh"
#include "T473ADCCalibrator.hh"
#include "T473.hh"
#include <analysis/KonoeHitDataset.hh>
#include <system/KonoeNameSpaceTable.hh>

class  T473AnalyzerMaker{
private:
  KonoeNameSpaceTable            * table;
  T473TDCCalibrator              * tdc_cal;
  T473ADCCalibrator              * adc_cal;
  T473GeneralData                * general_data;
  KonoeHitDataset                * hitset;
  KonoeDataAnalyzer              * analyzer;
  T473GeneralSectionAnalyzer     * general_analyzer;
  KonoeHitSectionAnalyzer        * csi_tdc_analyzer;
  KonoeHitSectionAnalyzer        * csi_adc_analyzer;
  T473DummySectionAnalyzer           * a_analyzer;
  T473DummySectionAnalyzer           * b_analyzer;
  T473DummySectionAnalyzer           * c_analyzer;
  KonoeList<T473CalibrationInfo> * tdc_info_list;
  KonoeList<T473CalibrationInfo> * adc_info_list;

public:
  T473AnalyzerMaker( KonoeDetector * detector, 
		     T473GeneralData * pgeneral_data,  
		     KonoeHitDataset * phitset,
                     KonoeList<T473CalibrationInfo> * ptdc_info_list,
		     KonoeList<T473CalibrationInfo> * padc_info_list,
		     KChar * preq_type, KonoeNameSpaceTable * table );
  ~T473AnalyzerMaker();
  KonoeDataAnalyzer * getAnalyzer(){ return analyzer; }
};

#endif


