//======================================================================
/*
               T473CalibrationInfo.cc
*/
//======================================================================

#include  "T473CalibrationInfo.hh"
#include  <analysis/KonoeDataAddress.hh>
#include  <KonoeList.hh>

T473CalibrationInfo::T473CalibrationInfo( KInt poffset, KFloat pgain, 
					 KInt ptablesize ){
  offset = poffset;
  gain = pgain;
  address_list = new KonoeList<KonoeDataAddress>(ptablesize);
}

T473CalibrationInfo::~T473CalibrationInfo(){
  delete address_list;
}

void  T473CalibrationInfo::reset(){
  address_list -> reset();
}

KonoeDataAddress *  T473CalibrationInfo::next(){
  return address_list -> next();
}

KInt  T473CalibrationInfo::add( KonoeDataAddress * address ){
  return address_list -> add( address );
 }

KInt  T473CalibrationInfo::getCount(){
  address_list -> reset();
  return address_list -> getCount();
}

