//=========================================================================
/*
              T473CsIdata.hh
                   K.Uchida
*/
//========================================================================

#ifndef __T473CSIDATA_HH__
#define __T473CSIDATA_HH__
#include  "T473ReconstructCM.hh"
#include  <analysis/KonoeDetectorHit.hh>
#include  <KonoeList.hh>
#include  <system/KonoeStreamableObject.hh>
#include  "T473.hh"

class  T473CsIdata : public KonoeStreamableObject {
  
public:
  enum  MEMBER_ID   { MID_HIT_LIST_N_ENTRIES, MID_HIT_LIST_ENTRIES,
		      MID_HITPOINT, MID_THETA,
		      N_MEMBERS };
  static  const  KChar         * className;
  
private:
  KonoeList<KonoeDetectorHit> * hitlist;
  Konoe3Vector  * hit_point;	       
  Konoe3Vector  * theta;
  KInt hitlist_tag;
  KInt hit_point_tag;
  KInt theta_tag;
public:
  T473CsIdata( KonoeList<KonoeDetectorHit> * phitlist, 
	       Konoe3Vector * p, Konoe3Vector * t );
  T473CsIdata();
  ~T473CsIdata();
  KonoeList<KonoeDetectorHit> * getHitList(){ return hitlist; };
  Konoe3Vector *  getHitPoint( ){ return hit_point; }	       
  Konoe3Vector *  getTheta( ) { return theta; }
  void dump( ostream & os );	       
  KInt put( KonoeOutputObjectStream * os, KChar level,
	    KInt memberid );
  KInt getStreamSize();
  KInt fillPrimitiveMember( KInt memberid, KInt datatype, 
			    KInt datacount, void * data );
  KInt fillObjectMember( KInt memberid,
			 KonoeStreamableObject * data );
};

#endif






