//======================================================================
/*
               T473DataMultiplet.cc
	       07-Dec-2000 Kirika Uchida
*/
//======================================================================

#include "T473DataMultiplet.hh"
#include <string.h>
T473DataMultiplet::T473DataMultiplet( KonoeMultipletDescriptor *plist,
				      KInt ptype ){
  type = ptype;
  list = plist;
  switch (ptype){
  case INT:
    KInt **int_data;
    int_data = new KInt * [datasize = list ->getCount()];
    data = (void **)int_data;
    break;
  case FLOAT:
    KFloat ** float_data;
    float_data = new KFloat * [datasize = list ->getCount()];    
    data = ( void **)float_data;
    break;
  case CHAR:
    KChar ** char_data;
    char_data = new KChar * [datasize = list -> getCount()];
    data = ( void ** ) char_data;
    break;
  default:
    return;
  }
}

T473DataMultiplet::~T473DataMultiplet(){
  delete *data;
  delete []data;
}

KInt    T473DataMultiplet::getIndex( const KChar * name ) {

        KonoeDataSpecifier      * p;
        KInt    i;

        i = 0;
        list -> reset( );
        while( p = list -> next( ) ) {
            if( strcmp( name, p -> getName( ) ) == 0 )
                return i;
            i ++;
        }
        return -1;      // not found.

}

void*  T473DataMultiplet::getValue( KInt index ) {

        if( index < 0 || index >= datasize )
            return 0;
        return  *( data + index );

}

KInt    T473DataMultiplet::setValue( KInt index, KInt value ) {
  KInt ** int_data;
  if( index < 0 || index >= datasize )
    return -1;
  *( int_data + index ) = new KInt[1];
  * (KInt*)( * ( data + index ) ) = value;
  return 0;
  
}
KInt    T473DataMultiplet::setValue( KInt index, KFloat value ) {
  KFloat * *float_data;
  if( index < 0 || index >= datasize )
    return -1;
  *( float_data + index ) = new KFloat [1];
  *( KFloat*)(* ( data + index ) ) = value;
  return 0;
  
}
KInt    T473DataMultiplet::setValue( KInt index, KChar* value ) {
  
  KChar ** char_data;
  char_data = (KChar **)data;

  if( index < 0 || index >= datasize )
    return -1;
  
  *( char_data + index ) = new KChar [256];
  strcpy( * ( char_data + index ) , value );
  return 0;
  
}

