//======================================================================
/*
               T473DetectorMaker.hh
	       20-Oct-2000   Kirika Uchida
*/
//======================================================================
#ifndef __T473DETECTORMAKER_HH__
#define __T473DETECTORMAKER_HH__

#include <system/KonoeNetworkNameSpaceManager.hh>
#include <analysis/KonoeDetector.hh>
#include "T473.hh"

class  T473DetectorMaker {
private:
  enum { CSI_WIDTH = 35, CSI_HEIGHT = 35, CSI_DEPTH = 175 };
  enum { CSI };
  KonoeNameSpaceTable * table;
  KFloat theta_x, theta_y, theta_z;
  Konoe3Vector AD, DI;
  Konoe3Vector oa, ai, theta;
  KonoeDetector                   * detector;
  KonoeTranslation                  translation;
public:
  T473DetectorMaker( KonoeNameSpaceTable * table );
  ~T473DetectorMaker();
  KInt getGeometryInfoFromTable( );
  Konoe3Vector setRotation( Konoe3Vector i );
  KInt makeDetector( );
  KInt setGeometry( );
  KInt setAddress();
  KonoeDetector * getDetector(){ return detector; }
  Konoe3Vector  getTheta();
};
#endif
