//======================================================================
/*
               T473GeneralData.hh
	       Kirika Uchida
*/
//======================================================================
#ifndef __T473GENERALDATA_HH__
#define __T473GENERALDATA_HH__

#include  <iostream.h>
#include  <system/KonoeStreamableObject.hh>
#include <KonoePrimitives.hh>
#include  "T473.hh"
#include <string.h>

static const KInt  RUNTYPE_LENGTH = 256;
static const KInt MAX_BIT = 16;
class T473GeneralData: public KonoeStreamableObject {
public:
  enum MEMBER_ID { MID_RUN_NUMBER, MID_EVENT_NUMBER, MID_RUN_TYPE,
                   MID_S1S4, MID_GC, MID_S5,MID_TIME, MID_CLOCK,
		   MID_COIN_REG_0, MID_COIN_REG_1, MID_COIN_REG_2,
		   N_MEMBERS };
  static const KChar                * className;

private:
  KInt RunNumber;
  KInt EventNumber;
  KChar RunType[RUNTYPE_LENGTH];
  KInt S1S4;
  KInt GC;
  KInt S5;
  KInt Time;
  KInt Clock;
  KChar CoinReg0[MAX_BIT + 1];
  KChar CoinReg1[MAX_BIT + 1];
  KChar CoinReg2[MAX_BIT + 1];
public:
  T473GeneralData();
  ~T473GeneralData(){}
  void setRunNumber( KInt  value ){ RunNumber =  value; }
  void setEventNumber( KInt  value ){ EventNumber =  value; }
  void setRunType( KChar * value ){ strcpy( RunType, value ); }
  void setS1S4( KInt value ){ S1S4 = value; }
  void setGC( KInt value ){ GC = value; }
  void setS5( KInt value ){ S5 = value; }
  void setTime( KInt value ){ Time = value; }
  void setClock( KInt value ){ Clock = value; }
  void setCoinReg0( KChar * reg ){ strcpy( CoinReg0, reg ); }
  void setCoinReg1( KChar * reg ){ strcpy( CoinReg1, reg ); }
  void setCoinReg2( KChar * reg ){ strcpy( CoinReg2, reg ); }
  KInt getRunNumber( ){ return RunNumber; }
  KInt getEventNumber( ){ return EventNumber; }
  KChar *  getRunType( ){ return RunType; }
  KInt getS1S4( ){ return S1S4; }
  KInt getGC( ){ return GC; }
  KInt getS5( ){ return S5; }
  KInt getTime( ){ return Time; }
  KInt getClock( ){ return Clock; }
  KChar * getCoinReg0( ){ return CoinReg0; }
  KChar * getCoinReg1( ){ return CoinReg1; }
  KChar * getCoinReg2( ){ return CoinReg2; }

  void dump( ostream & os );
  KInt put( KonoeOutputObjectStream * os, KChar level,
                  KInt memberid );
  KInt getStreamSize();
  KInt fillPrimitiveMember( KInt memberid, KInt datatype,
			    KInt datacount, void * data );
  KInt fillObjectMember( KInt memberid, KonoeStreamableObject * obj )
                      { return -1; }
};

#endif



