//======================================================================
/*
               T473HitPointMaker.hh
	       20-Oct-2000   Kirika Uchida
*/
//======================================================================
#include  "T473HitPointMaker.hh"
#include  "T473.hh"

T473HitPointMaker::T473HitPointMaker( ){}

Konoe3Vector & T473HitPointMaker::getHitPoint
( KonoeHitDataset * hitset, Konoe3Vector & p ) {
  KInt i;
  KFloat       energy[N_CSI], energy_sum = 0;
  KonoeList<KonoeDetectorHit> * hitlist;
  KonoeDetectorHit * hit;
  KonoeDetectorElement * element;
  KonoeBoxGeometry     * geometry;
  Konoe3Vector  displacement[N_CSI], d , a( 0, 0, -175 ); 

  // a: display hitpoint to surface of CsI        

  hitlist = hitset -> getHitList();
  hitlist -> reset();
  for( i = 0; i < N_CSI; i ++ ) {
    hit = hitlist -> next();
    element = hit -> getDetectorElement();
    energy[i] = hit -> getHitEnergy();
    geometry = ( KonoeBoxGeometry * )element -> getGeometry();
    displacement[i] = geometry -> getDisplacement();
    d += displacement[i] * energy[i];
    energy_sum +=energy[i];
  }
  p =  d / energy_sum;
  p += a;
  return p;
}
