//======================================================================
/*
               T473PhysicalValueForNameSpace.cc
               07-Dec-2000 Kirika Uchida
*/
//======================================================================

#include "T473PhysicalValueForNameSpace.hh"

T473PhysicalValueForNameSpace::T473PhysicalValueForNameSpace
( KInt ptablesize, KInt tag ):KonoePhysicalValue( tag ){
  
  list = new KonoeList<T473DataMultiplet>( ptablesize );
  specifier = new KonoeMultipletDescriptor( MULTIPLET_SIZE );
  specifier -> add( new KonoeDataSpecifier( "item" ) );
  specifier -> add( new KonoeDataSpecifier( "value" ) );
}

KInt    T473PhysicalValueForNameSpace::clear( ) {
  
  return list -> clear( );
  
}

KInt    T473PhysicalValueForNameSpace::reset( ) {

  list -> reset( );
  return 0;
}

KInt    T473PhysicalValueForNameSpace::getDataCount( ) {
  
  list -> reset( );
  return list -> getCount( );
  
}

T473DataMultiplet      * T473PhysicalValueForNameSpace::nextT473DataMultiplet
( ) {
  
  return list -> next( );
}

KInt T473PhysicalValueForNameSpace::add( KChar * item, KChar * value ){
  
  T473DataMultiplet  * multiplet;
  
  multiplet = new T473DataMultiplet( specifier, T473DataMultiplet::CHAR );
  multiplet -> setValue( ITEM, item );
  multiplet -> setValue( VALUE, value );
  return list -> add( multiplet );
}

KonoeDataMultiplet * T473PhysicalValueForNameSpace::next(){
  
  return new KonoeDataMultiplet( specifier );
}
