//=====================================================================
/*
             T473Reconstruct.hh
             12-Oct-2000   kirika Uchida
*/
//=====================================================================
#ifndef __T473RECONSTRUCT_HH__
#define __T473RECONSTRUCT_HH__

#include        <iostream.h>
#include        <stdio.h>
#include        <iomanip.h>
#include        <unistd.h>
#include        <stdlib.h>
#include        <string.h>

#include        <system/KonoeHostSystem.hh>
#include        <system/KonoeNetworkNameSpaceManager.hh>

#include        <system/KonoeObjectSocket.hh>
#include        <system/KonoeInputObjSocketBuffered.hh>
#include        <system/KonoeClientSocket.hh>
#include        <system/KonoeObjectServerSocket.hh>
//#incldue        <system/KonoeMicroSleep.hh>

#include        <analysis/KonoeDataRecordCM.hh>
#include        <analysis/KonoeHitDataset.hh>
#include        <analysis/Konoe3Vector.hh>

#include        "T473.hh"
#include        "T473CalibrationInfoMaker.hh"
#include        "T473DetectorMaker.hh"
#include        "T473AnalyzerMaker.hh"
#include        "T473HitPointMaker.hh"
#include        "T473CsIdata.hh"
#include        "T473ReconstructData.hh"
#include        "T473DyingMessage.hh"
#include        "T473SpillEndAnalyzer.hh"
#include        "T473PhysicalValueForNameSpace.hh"
#include        "T473LogSender.hh"


class  T473Reconstruct : T473DyingMessage {
public:
  enum STATUS { DEAD, WAIT_REQ_TYPE, REQUESTED_TO_CHANGE_INFO, 
		READY_TO_REC };
  
private:
  enum {TABLE_VALUE_SIZE = 256, MAX_LENGTH = 256 };
  
  enum receive_record_st { NO_RECORD, 
			   RUN_START_RECORD = 1000,
			   RUN_END_RECORD = 2000,
			   EVENT_RECORD = 3000,
			   SPILL_END_RECORD = 4000 }; 
			  

  KChar                                    *mode;
  KonoeHostSystem                    host_system;
  KonoeNetworkNameSpaceManager        ns_manager;
  KonoeNameSpaceTable                    * table;
  KonoeNameSpaceValue                 * ns_value;
  KChar                                 * pvalue;
  KChar                  value[TABLE_VALUE_SIZE]; 
  KChar               rec_host[TABLE_VALUE_SIZE];
  KChar                rec_pid[TABLE_VALUE_SIZE];
  KChar               hub_host[TABLE_VALUE_SIZE];
  KChar               req_type[TABLE_VALUE_SIZE];
  KInt                 hub_port, rec_to_gui_port;
  KBool                          analyzer_status;        
  KBool                          analysis_status;
  STATUS                                  status;
  KInt                                     rec;
  KInt                                    spill_number;
  KInt                               receive_n, send_n;
  T473LogSender                      log_sender;
  // socket to receive DataRecord
  KonoeClientSocket              * client_socket;
  KonoeInputObjSocketBuffered      * recv_socket;
  KonoeFDSet                       fd_set;
  KonoeFDClient                  * fd_client;
  KonoeDataRecordCM                rec_cm;
  //  KInt st3;
  // socket to send CsIdata
  KonoeObjectServerSocket        * server_socket;
  KonoeObjectSocket              * for_gui_socket;
  KonoeObjectSocket              ** for_gui_sockets;
  
  //  KonoeMicroSleep                 ms;
  
  KonoeDataRecord                * record;
  KonoeDetector                  * detector;
  KonoeList<T473CalibrationInfo> * cal_tdc_info_list;
  KonoeList<T473CalibrationInfo> * cal_adc_info_list;
  
  T473DetectorMaker              * detector_maker;
  T473AnalyzerMaker              * analyzer_maker;
  T473CalibrationInfoMaker       * cal_info_maker;
  KonoeDataAnalyzer              * analyzer;	
  T473SpillEndAnalyzer             spill_end_analyzer; 
  T473HitPointMaker                hit_point_maker;  
  
  T473PhysicalValueForNameSpace  * spill_end_data;
  T473DataMultiplet                  * multiplet;

  T473ReconstructData            * rec_data;
  T473GeneralData                  general_data; 
  T473CsIdata                    * csi_data;
  KonoeHitDataset                * hitset;
  KonoeList<KonoeDetectorHit>    * hitlist;       
  Konoe3Vector                     hit_point;
  Konoe3Vector                     theta;
  
  static KChar * PERMISSION;
  static const KChar * REC_REQUEST;
  static const KChar * CH_INFO_REQUEST;
  static const KChar * CH_TYPE_REQUEST;
  static const KChar * GUI_REQUEST;
  static KChar *  REC_STATUS;
  static KChar *  STAND_BY;
  static KChar *  BUSY;
  static KChar *  NONE;

public:

  T473Reconstruct( int argc, char ** argv );
  ~T473Reconstruct();
  KInt getStatus(){ return status; }
  KInt set_name_space();
  KInt set_socket_to_HUB();
  KInt set_socket_to_GUI();
  KInt go();
  KInt receive_request_type_from_GUI( );
  KInt set_analyzer( );
  KInt receive_request_from_GUI( );
  KInt request_and_receive_datarecord( );
  KInt spill_end_analysis();
  KInt analyze( KonoeDataRecord * record );
  KInt send_rec_data();
  void lastAction();

};
#endif
