//======================================================================
/*
               T473ReconstructData.hh
	       Kirika Uchida
*/
//======================================================================
#ifndef  __T473RECONSTRUCTDATA_HH__
#define  __T473RECONSTRUCTDATA_HH__

#include  <system/KonoeStreamableObject.hh>
#include  "T473GeneralData.hh"
#include   "T473CsIdata.hh"

class T473ReconstructData: public KonoeStreamableObject{
public:
  enum MEMBER_ID { MID_GENERAL_DATA, MID_CSI_DATA, N_MEMBERS };
  static const KChar  * className;
  
protected:
  T473GeneralData * general_data;
  T473CsIdata     * csi_data;
  KInt general_data_tag;
  KInt csi_data_tag;
public:
  T473ReconstructData();
  T473ReconstructData( T473GeneralData * pgeneral, T473CsIdata * pcsi );
  ~T473ReconstructData();
  T473GeneralData *     getGeneralData(){ return  general_data; }
  T473CsIdata     *     getCsIdata()    { return  csi_data; }
  void dump( ostream & os );
  
  KInt put( KonoeOutputObjectStream * os, KChar level,
	    KInt memberid );
  KInt    getStreamSize( );
  KInt    fillPrimitiveMember( KInt memberid, KInt datatype,
    KInt datacount, void * data ){ return -1; }
  KInt    fillObjectMember( KInt memberid,
			    KonoeStreamableObject * object );
};  
#endif
