//======================================================================
/*
               T473SpillEndAnalysisProcess.cc
	       07-Dec-2000   Kirika Uchida
*/
//======================================================================
#include "T473SpillEndAnalysisProcess.hh"
#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h> 
#include  <iostream.h>
#include  <string.h>

const KChar * T473SpillEndAnalysisProcess::REQUEST = "DATAHUB_REQ_CURRENT";

T473SpillEndAnalysisProcess::T473SpillEndAnalysisProcess(){
  cout << "(1)setting name space........................" << endl;
  set_name_space();
  cout << "---------------------------------------------" << endl;
  cout << "(2)setting client socket " << endl
       << "   for receive data record from HUB.........." << endl;
  set_socket_to_HUB();
  cout << "---------------------------------------------" << endl;
}

KInt T473SpillEndAnalysisProcess::set_name_space(){

  table = ns_manager.getTable();    
  
  // set spillendprocess host name ----------------------------------
  host_system.getHostName( this_host, TABLE_VALUE_SIZE ) ;
  ns_manager.setValue( "SPILLENDPROCESS_HOST", this_host );
  cout << "   spill end process host name: " << this_host << endl;

  // set reconstruct pid ----------------------------------------
  sprintf( this_pid, "%d", host_system.getPid() );
  ns_manager.setValue( "SPILLENDPROCESS_PID", this_pid );
  cout << "   spill end process pid: " << this_pid << endl;
  return 0;
}

KInt T473SpillEndAnalysisProcess::set_socket_to_HUB(){
  ns_value = table -> getValue( "DATAHUB_HOST" );
  pvalue = ( KChar * ) ns_value -> get();
  delete ns_value;
  strcpy( hub_host, pvalue );
  cout << "   hub host name: " << hub_host << endl;
  
  ns_value = table -> getValue( "DATAHUB_OUTPUT_PORT" );
  pvalue = ( KChar * ) ns_value -> get();
  delete ns_value;
  hub_port = atoi( pvalue );
  cout << "   hub output port: " << hub_port << endl;
  
  client_socket  = new KonoeClientSocket ( hub_host, hub_port ); 
  
  
  
  while( client_socket -> getStatus() != KonoeClientSocket::CONNECTED ) {
    cout << "Hub is down. Try to connect again after 1 second." << endl;
    sleep( 1 );
    client_socket -> connect();
  }
  cout << "   connected to hub output port." << endl;
  
  fd_set.install( client_socket );
  
  recv_socket    = new KonoeInputObjSocketBuffered( client_socket ); 
  recv_socket    -> installCM( & rec_cm );
  
  spill_end_analyzer = new T473SpillEndAnalyzer();
  return 0;
}

KInt T473SpillEndAnalysisProcess::go(){
  while(1){ 
    while (  ( client_socket -> getStatus( ) ) != KonoeSocketIO::CONNECTED ) {
      cout << "HUB is down. Try to connect after 1 minute. " << endl;
      sleep(60);
      client_socket -> connect();
    }
    
    KInt received = 0;
    while( received == 0 ){
      
      client_socket -> send( REQUEST, strlen( REQUEST ) + 1 );
      // Hub  data record ʤä⤦ Hub ˥ꥯȤ롣  
      if ( !( fd_client = fd_set.wait( 0 ) ) ){
	//cout << "Hub is busy. Try to request after 1 second" << endl;
	sleep(1);
	continue;
      }
      else {
	record = ( KonoeDataRecord * ) recv_socket -> get( 0 ) ; 	
	cout << record -> getType( ) << endl;
	received = 1;
	cout << "received datarecord from HUB " << endl;
      }
    }
    spill_end_analyzer -> analyze( record );
    data = spill_end_analyzer -> getData();
    
    data -> reset();
    while( multiplet = data -> nextT473DataMultiplet() ){
      cout << "efficiency" <<  (KChar *)multiplet -> getValue( 1 ) << endl;
      ns_manager.setValue
	( (KChar *)multiplet -> getValue( 0 ),
	  (KChar*)multiplet -> getValue( 1 ) );
    }
    data -> clear();
    delete record;
  }
  return 0;
}
