//======================================================================
/*
               T473SpillEndAnalysisProcess.hh
	       07-Dec-2000   Kirika Uchida
*/
//======================================================================
#ifndef __T473SPILLENDANALYSISPROCESS_HH__
#define __T473SPILLENDANALYSISPROCESS_HH__

#include        <system/KonoeHostSystem.hh>
#include        <system/KonoeNetworkNameSpaceManager.hh>

#include        <system/KonoeObjectSocket.hh>
#include        <system/KonoeInputObjSocketBuffered.hh>
#include        <system/KonoeClientSocket.hh>
#include        <system/KonoeObjectServerSocket.hh>

#include        <analysis/KonoeDataRecordCM.hh>
#include        <analysis/KonoeDataRecord.hh>
#include        "T473SpillEndAnalyzer.hh"

class T473SpillEndAnalysisProcess {
public:
  enum{ TABLE_VALUE_SIZE = 256 };
private:
  KonoeHostSystem                    host_system;
  KonoeNetworkNameSpaceManager        ns_manager;
  KonoeNameSpaceTable                    * table;
  KonoeNameSpaceValue                 * ns_value;
  KChar                                 * pvalue;
  KChar                  value[TABLE_VALUE_SIZE]; 
  KChar              this_host[TABLE_VALUE_SIZE];
  KChar               this_pid[TABLE_VALUE_SIZE];
  KChar               hub_host[TABLE_VALUE_SIZE];
  KInt                                  hub_port;
  KonoeClientSocket              * client_socket;
  KonoeInputObjSocketBuffered      * recv_socket;
  KonoeFDSet                              fd_set;
  KonoeFDClient                      * fd_client;
  static const KChar * REQUEST;
  KonoeDataRecordCM                       rec_cm;
  KonoeDataRecord                       * record;
  KonoeDataRecord * rec;  
  
  T473SpillEndAnalyzer       *spill_end_analyzer;
  T473PhysicalValueForNameSpace         *data;      
  T473DataMultiplet                  * multiplet;
public:
  T473SpillEndAnalysisProcess();
  ~T473SpillEndAnalysisProcess(){;}
  KInt set_name_space();
  KInt set_socket_to_HUB();
  KInt go();
};
#endif
