//======================================================================
/*
               T473SpillEndAnalyzer.hh
	       07-Dec-2000 Kirika Uchida
*/
//======================================================================

#ifndef __T473SPILLENDANALYZER_HH__
#define __T473SPILLENDANALYZER_HH__

#include <analysis/KonoeDataAnalyzer.hh>
#include <analysis/KonoeDefaultSectionAnalyzer.hh>
#include "T473DummySectionAnalyzer.hh"
#include "T473PhysicalValueForNameSpace.hh"
#include <analysis/KonoeDataRecord.hh>

class T473SpillEndAnalyzer {
public:
  enum{ SECTION_ID_INDEX, SEGMENT_ID_INDEX, SUBADDRESS_INDEX, DATA_INDEX };

private:
  KonoeDataAnalyzer * analyzer;
  KonoeDefaultSectionAnalyzer * general_analyzer;
  T473DummySectionAnalyzer    * d_1_analyzer;
  T473DummySectionAnalyzer    * d_2_analyzer;
  T473DummySectionAnalyzer    * d_3_analyzer;
  T473DummySectionAnalyzer    * d_4_analyzer;
  KonoeDefaultSectionAnalyzer * scaler_section_analyzer;
  T473PhysicalValueForNameSpace * data_for_nms;
  KonoeDataRecord            * record;
  KChar  efficiency [256];
public:
  T473SpillEndAnalyzer( );
  ~T473SpillEndAnalyzer();
  KInt analyze( KonoeDataRecord * precord );
  T473PhysicalValueForNameSpace * getData(){ return data_for_nms; }
};

#endif
