//========================================================================
/*
          T473TDCCalibrator.cc
          20-Oct-2000   Kirika Uchida
*/
//========================================================================

#include "T473TDCCalibrator.hh"

T473TDCCalibrator::T473TDCCalibrator
( KonoeList<T473CalibrationInfo> * plist ){
  list = plist;
  /*  cout << "   info list count in TDC calibrator: " 
       << list -> getCount() << endl;  */
}

KInt T473TDCCalibrator::convert( KonoeDetectorHit * hit,
				 KonoeDataElement * element ){
  KInt k, offset;
  KFloat t, gain;
  KonoeDetectorElement * de;
  T473CalibrationInfo * info;

  k = * ( KInt * )element ->getStore();
  hit -> setTDCValue( k );
  //  cout << "TDC value: " << k << endl;

  de = hit -> getDetectorElement();
  info = find( de );
  offset =  info -> getOffset();
  gain = info -> getGain();
  t = ( k - offset ) * gain;
  //  cout << "offset: " << offset << endl;
  //  cout << "gain: " << gain << endl;

  //  cout << "time: " << t << endl;
  hit -> setHitTime( t );
  return 0;
}

T473CalibrationInfo * T473TDCCalibrator::find
                          ( KonoeDetectorElement * de ){
  T473CalibrationInfo * info;
  KonoeDataAddress    * address;
  KonoeDataAddress    * refaddress;
  //  cout << "info list count: " << list -> getCount() << endl;
  //  cout << "info_list: " << list << endl;
  list -> reset();
  while( info = list -> next() ){
    info -> reset();
    while( address = info -> next() ){
      de -> reset();
      while( refaddress = de -> next() ){
	//	cout << "detector element address " << endl;
	//	refaddress -> dump( cout );
	if( address -> match( *refaddress )){
	  //  cout << "info address " << endl;
	  //	  address -> dump( cout );
	  //	  refaddress -> dump( cout );
	  return info;
    	}
      }
    }
  }
  return 0;
}
