//======================================================================
/*
               DemoDaq.cc
*/
//======================================================================
#include        <iostream.h>
#include         <unistd.h>
#include         <stdlib.h>
#include         <system/KonoeClientSocket.hh>
#include        <system/KonoeOutputObjFile.hh>
#include        <system/KonoeOutputObjSocket.hh>
#include        <system/KonoeInputObjFile.hh>
#include        <system/KonoeNameSpaceTable.hh>
#include        <analysis/KonoeDataRecordCM.hh>
#include        <analysis/KonoeDataRecord.hh>
#include        <system/KonoeMicroSleep.hh>
#include        <string.h>

const KChar *  request = "DATAHUB_REQ_CURRENT";

class DemoDaq {
private:
        KonoeNameSpaceTable      table;
        KChar                   *pvalue;
        KChar                   hub_host[256];
        KInt                    hub_port;
        KonoeInputObjFile       *input_file;
        KonoeClientSocket       *client_socket;
	KonoeOutputObjSocket    * o_obj_socket;
        KonoeMicroSleep          ms;
  //	RecordMaker             *record_maker;	
	KonoeDataRecord         *record;
	KonoeDataRecordCM        cm;
public:
	DemoDaq( int argc, char ** argv );
	~DemoDaq();
	int go();
};

DemoDaq::DemoDaq( int argc, char ** argv ){
  input_file = new KonoeInputObjFile( "674.dat" );
  input_file -> installCM( &cm );
  
  pvalue = ( KChar * )
    table.getValue( "DATAHUB_HOST" ) -> get();
  strcpy( hub_host, pvalue );
  cout << "   hub host name: " << hub_host << endl;
  
  pvalue = ( KChar * )
    table.getValue( "DATAHUB_INPUT_PORT" ) -> get();
  hub_port = atoi( pvalue );
  cout << "   hub output port: " << hub_port << endl;
  
  //  client_socket = new KonoeClientSocket( hub_host, hub_port );
  client_socket = new KonoeClientSocket( hub_host, hub_port );
  if( client_socket -> getStatus() != KonoeClientSocket::CONNECTED ){
    cout << "wait..........." << endl;
    sleep( 5 );
  }
  cout << "connected to DataHub." << endl;
  o_obj_socket  = new KonoeOutputObjSocket( client_socket );
       
//       while( client_socket -> connect() < 0 )
//	 sleep(1);
}
DemoDaq::~DemoDaq(){
}       

int  DemoDaq::go(){
  int i;
  while(1){
    //    record_maker = new RecordMaker();
    record = ( KonoeDataRecord * )input_file -> get( 0 );
    cout << "have gotten datarecord" << endl;
    //record -> dump( cout );
    ms.sleep(50); 
    o_obj_socket -> put( record );
    cout << "put daq record: " << i << endl;
    delete record;
  }
  return 0;
}

int main(int argc, char ** argv ){
  DemoDaq demo( argc, argv );
  return demo.go();
}
       

