//====================================================
/*
	T473DAQRunControl.cc

	 4-Oct-2000	Y. Shimizu
	13-Nov-2000	Y. Shimizu
*/
//====================================================

#include	<system/KonoeFDClient.hh>
#include	"T473DAQControl.hh"
#include	<stdlib.h>
#include	<string.h>

T473DAQControl::T473DAQControl(KInt port ) : T473RunControlBase(port) {

  host = ext->getKCharValue("DAQ_HOST");
  if( host == (KChar*)-1){
     cerr << "DAQ_HOST is not defined : "<<endl;
  }

}


KInt T473DAQControl::control( KChar* command ){

  KonoeFDClient	* cl = 0;

    if( !strcmp( command , "boot") ){
	return this->boot();
    }

    KInt pid = ext->getKIntValue("DAQ_PID");
    if( pid == -1){
      cerr << "DAQ_PID is not defined : "<<endl;
      return -1;
    }
    
    killer->kill( host , pid , SIGINT );
    
    KChar buffer[256];
	
    cl = fdset->wait( 1000 );
    if( cl ){
      cmd_sender->receive( buffer , 256 );
      cmd_sender->reply( command  , 256 );
    }
    cl = fdset->wait( 200 );
    if( cl ){
      cmd_sender->receive( buffer , 256 );
      cout << "\tT473DAQControl  cmd reply = " << buffer << endl;
      if(!strcmp(buffer,"true"));
	return (1);
      if(!strcmp(buffer,"false"));
	return (0);
    }
    return (0);
    
}	

KInt T473DAQControl::boot(void){

  KChar cmd[64];

  if( ext->getKIntValue("DAQ_PID") == -1 ) {
    KInt eport = ext->getKIntValue("EXE_PORT");
    if( eport == -1){
	cerr<<"EXE DAEMON_PORT is not defined : "<< endl;
	return -1;
    }

    exe = new KonoeExecutor(eport);

    if( getenv("T473_PATH") ){
	strcpy(cmd,getenv("T473_PATH"));
	strcat(cmd,"/");
	strcat(cmd,"T473daq &");
    	exe->exec(host,cmd);
    	delete exe;
    	return 1;
    }
    else {
    	exe->exec(host,"../bin/T473daq &");
    	delete exe;
    	return 1;
	
    }
 
  }
  return 0;

}
