//====================================================
/*
	T473DataHubControl.cc

	 4-Oct-2000	Y. Shimizu
	13-Nov-2000	Y. Shimizu
*/
//====================================================

#include	"T473DataHubControl.hh"
#include	"T473RunControl.hh"
#include	<unistd.h>
#include	<string.h>
#include	<stdlib.h>

T473DataHubControl::T473DataHubControl(KInt port){
cout << "!!!!!!!!!!!!!   T473DataHubControl new" << endl;

  setter = new T473NameSpaceSetter;

  host = ext->getKCharValue("DATAHUB_HOST");
  if( host == (KChar*)-1){
    cerr << "DATAHUB_HOST is not defined : "<<endl;
  }

  cmd_socket = new KonoeClientSocket( host , port );
}

KInt T473DataHubControl::control( KChar* command ){
cout << "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl;

	KChar buffer[256];

	if( !strcmp(command,"shutdown") ){
	
		KInt pid = ext->getKIntValue("DATAHUB_PID");
		if( pid == -1){
			cerr << "DATAHUB_PID is not defined : "<<endl;
			return -1;
		}
		killer->kill( host , pid , SIGKILL );
		setter->set("DATAHUB_PID",-1);
		setter->set("DATAHUB_STATUS","none");
		return 0;
	}
	else if( !strcmp(command,"new_file") ){

		strcpy(buffer,ext->getKCharValue("RUN_NUMBER"));
		strcat(buffer,".dat");
		setter->set("DATAHUB_STORAGE_FILE_NAME",buffer);
cout << "##########  received new_file command : " << buffer << endl;

		sleep(1);

cout << "##########  send to DATAHUB_CMD_NEW_FILE" << endl;
		cmd_socket->send("DATAHUB_CMD_NEW_FILE",256);
	}		
	else if( !strcmp(command,"file_close") ){
		cmd_socket->send("DATAHUB_CMD_FILE_CLOSE",256);
	}
	else if( !strcmp(command,"continue") ){
		return (0);
	}
	else if( !strcmp(command,"boot") ){
		return this->boot();
	}
	else {
		cout << "Sorry"<<endl;
	}
	return (0);

}	

KInt T473DataHubControl::boot(void){

  KChar cmd[64];
  if( ext->getKIntValue("DATAHUB_PID") == -1 ){
    KInt eport = ext->getKIntValue("EXE_PORT");
    if( eport == -1){
      cerr<<"EXE_PORT is not defined : "<< endl;
      return -1;
    }

    exe = new KonoeExecutor(eport);

    if( getenv("T473_PATH") ){
	strcpy(cmd,getenv("T473_PATH"));
	strcat(cmd,"/");
	strcat(cmd,"T473DataHubForPS &");	
        exe->exec(host,cmd);
        delete exe;
    	return 1;
    } else {
        exe->exec(host,"../DataHub/T473DataHubForPS &");
        delete exe;
    	return 1;
    } 

  }
  return 0;

}
