//====================================================
/*
	T473HistoControl.cc

	 4-Oct-2000	Y. Shimizu
	13-Nov-2000	Y. Shimizu
*/
//====================================================

#include	<system/KonoeFDClient.hh>
#include	"T473HistoControl.hh"
#include	"T473RunControl.hh"
#include	<stdlib.h>
#include	<string.h>

T473HistoControl::T473HistoControl(KInt port) : T473RunControlBase( port ) {

	host = ext->getKCharValue("HISTOGRAM_HOST");
	if( host == (KChar*)-1){
		cerr << "HISTOGRAM_HOST is not defined : "<<endl;
	}

}


KInt T473HistoControl::control( KChar* command ){

	KonoeFDClient * cl;

	if( !strcmp(command,"boot")){
		return this->boot();
        }

	KInt pid = ext->getKIntValue("HISTOGRAM_PID");
	if( pid == -1){
		cerr << "HISTOGRAM_PID is not defined : "<<endl;
		return -1;
	}

	killer->kill( host , pid , SIGINT );

	KChar buffer[256];

	cl = fdset->wait( 500 );
	if( cl )
	  cmd_sender->receive( buffer , 256 );
	cmd_sender->reply( command  , 256 );
	cl = fdset->wait( 500 );
	if( cl )
	  cmd_sender->receive( buffer , 256 );

	return (0);
}	

KInt T473HistoControl::boot( void ){

	KChar cmd[64];

	KInt eport = ext->getKIntValue("EXE_PORT");
	if( eport == -1){
	  cerr<<"EXEDAEMON_PORT is not defined : "<< endl;
	  return -1;
	}
	
	exe = new KonoeExecutor(eport);

	if( ext->getKIntValue("HISTOGRAM_PID") == -1 ){

	  if( getenv("T473_PATH") ){
		strcpy(cmd,getenv("T473_PATH"));
		strcat(cmd,"/");
		strcat(cmd,"T473histogram &");
		exe->exec(host,cmd);
		delete exe;
		return 1;
	  } else {
		exe->exec(host,"../Histogram/T473histogram &");
		delete exe;
		return 1;
	  }
	
 	}
	return 0;
}


