//====================================================
/*
	T473LoggerControl.cc

	20-Nov-2000	Y. Shimizu
*/
//====================================================

#include	"T473LoggerControl.hh"
#include	"T473RunControl.hh"
#include	<stdlib.h>
#include	<string.h>

T473LoggerControl::T473LoggerControl(KInt port):T473RunControlBase( port ) {

  host = ext->getKCharValue("LOGGER_HOST");
  if( host == (KChar*)-1){
    cerr << "LOGGER_HOST is not defined : "<<endl;
  }
  
}


KInt T473LoggerControl::control( KChar* command ){

	KonoeFDClient	* cl;

	if( !strcmp(command,"boot")){
		return this->boot();
        }

	KInt pid = ext->getKIntValue("LOGGER_PID");
	if( pid == -1){
		cerr << "LOGGER_PID is not defined : "<<endl;
		return -1;
	}

	killer->kill( host , pid , SIGINT );

	KChar buffer[256];

	cl = fdset->wait( 1000 );
	if( cl )
	  cmd_sender->receive( buffer , 256 );
	cmd_sender->reply( command  , 256 );
	cl = fdset->wait( 1000 );
	if( cl )
	  cmd_sender->receive( buffer , 256 );

	return (0);
}	

KInt T473LoggerControl::boot(void){

  KChar	cmd[64];

  KInt eport = ext->getKIntValue("EXE_PORT");
  if( eport == -1){
    cerr<<"EXE_PORT is not defined : "<< endl;
    return -1;
  }
  
  if( ext->getKIntValue("LOGGER_PID") == -1 ){
    exe = new KonoeExecutor(eport);

    if( getenv("T473_PATH") ){
	strcpy(cmd,getenv("T473_PATH"));
	strcat(cmd,"/");
	strcat(cmd,"T473logger &");
        exe->exec(host,cmd);
        delete exe;
        return 1;
    }
    else {
    	exe->exec(host,"../Logger/t473_logger &");
    	delete exe;
    	return 1;
    }
  }

  return 0;

}
