//==========================================================
/*
	T473Process.cc

	 4-Oct-2000 	Y. Shimizu
	13-Nov-2000 	Y. Shimizu
*/
//==========================================================
#include	"T473Process.hh"
#include        <system/KonoeHostSystem.hh>
#include        <string.h>

T473Process::T473Process(KInt port ): cmd_port(port){
//T473Process::T473Process() {

	ext = new T473NameSpaceExtractor;
	KChar* master_host = ext->getKCharValue("MASTER_HOST");
	if( master_host ==(KChar*)-1){
		cerr <<"MASTER_HOST is not defined : abort " << endl;
		KonoeHostSystem::exit(0);
	}

	cmd_process = new KonoeUDPClientSocket( master_host ,cmd_port );

	handler = new KonoeSignalHandler( SIGINT , this );
	handler->enable( );

}

T473Process::~T473Process( ){

	delete ext;
	delete cmd_process;
	delete handler;

}

KInt T473Process::begin( ){
	return (0);
}

KInt T473Process::pause( ){
	return (0);
}

KInt T473Process::resume( ){
	return (0);
}

KInt T473Process::end( ){
	return (0);
}

KInt T473Process::shutdown( ){
	return (0);
}

void T473Process::catchSignal( KInt signal ){
//      in this function , cannot accept  Signal !!

//	cout <<"T473Process::catchSignal( KInt signal )"<<endl;
	KChar cmd[256];
	
	cmd_process->send("ready",256);
	cmd_process->receive(cmd,256);

	if(strcmp( cmd , "begin") == 0 )
		mode = READY;
	else if( strcmp( cmd , "resume") == 0)
		mode = READY;
	else if( strcmp( cmd , "pause") == 0)
		mode = IDLE;
	else if( strcmp( cmd , "end") == 0)
		mode = STANDBY;
	else if( strcmp( cmd , "shutdown") == 0)
		mode = NONE;
	else 
		mode = UNKNOWN;

	cmd_process->send("done",256);

}	
