//====================================================
/*
	T473ReconsturctControl.cc

	 4-Oct-2000	Y. Shimizu
	13-Nov-2000	Y. Shimizu
*/
//====================================================

#include	"T473ReconstructControl.hh"
#include	"T473RunControl.hh"
#include	<unistd.h>
#include	<stdlib.h>
#include	<string.h>

T473ReconstructControl::T473ReconstructControl(KInt port ){

  setter = new T473NameSpaceSetter;

  host = ext->getKCharValue("RECONSTRUCT_HOST");
  if( host == (KChar*)-1){
    cerr << "RECONSTRUCT_HOST is not defined : "<<endl;
  }
  
  cmd_socket = new KonoeClientSocket( host , port );
 
}

KInt T473ReconstructControl::control( KChar* command ){

	KChar buffer[256];
 
        if( !strcmp(command,"boot")){
		return this->boot();
	}

	if( !strcmp(command,"shutdown") ){
	
		KInt pid = ext->getKIntValue("RECONSTRUCT_PID");
		if( pid == -1){
			cerr << "RECONSTRUCT_PID is not defined : "<<endl;
			return -1;
		}
		killer->kill( host , pid , SIGTERM );
	}
	else {
		cout << "Sorry"<<endl;
	}
	return (0);

}	

KInt T473ReconstructControl::boot(void){

  KChar cmd[64];
  if( ext->getKIntValue("RECONSTRUCT_PID") == -1){
    KInt eport = ext->getKIntValue("EXE_PORT");
    if( eport == -1){
      cerr<<"EXE_PORT is not defined : "<< endl;
      return -1;
    }

    exe = new KonoeExecutor(eport);

    if( getenv("T473_PATH") ){
	strcpy(cmd,getenv("T473_PATH"));
	strcat(cmd,"/");
	strcat(cmd,"T473reconstruct &");
    	exe->exec(host,cmd);
    	delete exe;
    	return 1;
    }
    else {
    	exe->exec(host,"../Reconstruct/reconstruct &");
    	delete exe;
    	return 1;
    }
  }
  return (0);

}

