//====================================================
/*
	T473RunControl.hh

	26-Nov-2000	Y. Shimizu
	08-Dec-2000	Y. Shimizu

*/
//====================================================

#ifndef __T473RUNCONTROL_HH
#define __T473RUNCONTROL_HH

#include<system/KonoeTime.hh>
#include"../Namespace/T473NameSpaceSetter.hh"
#include"../Namespace/T473NameSpaceExtractor.hh"
#include"../Histogram/T473Process1DHistogram.hh"
#include"T473DAQControl.hh"      
#include"T473HistoControl.hh"      
#include"T473DataHubControl.hh"      
#include"T473LoggerControl.hh"      
#include"T473TimeoutHandler.hh"

class T473RunControl {
public:
  enum { IGNORE = -2 , UNKNOWN = -1, NONE , STANDBY, READY , IDLE };
protected:

  KInt status;
  KInt daq_status;
  KInt histo_status;
  KInt logger_status;
  KInt answer;

  T473TimeoutHandler     * timeout;
  T473StatusChecker      * histo_checker;
  T473StatusChecker      * logger_checker;

  T473NameSpaceSetter    * setter;
  T473NameSpaceExtractor * ext;
  T473DAQControl         * daq_control;
  T473HistoControl       * histo_control;
  T473DataHubControl     * hub_control;
  T473LoggerControl      * logger_control;

  KonoeTime		 * time;

  KInt  nsCheck(KChar* item);
  KBool isGeneralInfo();
  KBool isDataHubStrageName();
  KBool isCsIADCPedestalInfo();
  KBool isCsITDCPedestalInfo();
  KBool isScinTDCPedestalInfo();

  KInt  setADCPedestal_auto( );
  KInt  setTDCPedestal_auto( );
public:
  T473RunControl();
  ~T473RunControl();

  KInt setGeneralInfo();  
  KInt setDataHubStrageName();
  KInt setCsIADCPedestalInfo();
  KInt setCsITDCPedestalInfo();
  KInt setScinTDCPedestalInfo();
  KInt askGo();

  KInt getStatus() { return status ; }

  KInt begin();
  KInt pause();
  KInt resume();
  KInt end();
  KInt shutdown();
};
#endif
