//====================================================
/*
	T473RunControlBase.cc

	26-Nov-2000	Y. Shimizu
*/
//====================================================

#include	"T473RunControlBase.hh"
#include        <system/KonoeHostSystem.hh>

T473RunControlBase::T473RunControlBase(KInt port ) : cmd_port(port){
	
  	ext = new T473NameSpaceExtractor();
  	cmd_sender = 
          new KonoeUDPServerSocket( cmd_port );

	fdset = new KonoeFDSet;
	fdset->install( cmd_sender );
	killer = new KonoeSignalSender( ext->getKIntValue("SIGNAL_PORT"));

	if( ext->getKIntValue("SIGNAL_PORT") == -1){
		cerr<<"SIGNAL_PORT is not defined : exit"<< endl;
		KonoeHostSystem::exit(0);
	}

}

T473RunControlBase::~T473RunControlBase(){
	
	delete ext;
	delete killer ;
	
}
