//=========================================================
/*
	daq_controler.cc (CUI)
	
	13-Nov-2000	Y. Shimizu

*/
//=========================================================
#include	<system/KonoeIntervalTimer.hh>
#include	<system/KonoeSignalHandler.hh>
#include	"T473DAQControl.hh"
#include	"T473TimeoutHandler.hh"
#include        <system/KonoeHostSystem.hh>
#include        <string.h>

int main(int argc,char** argv)
{
	enum { UNKNOWN = -1, NONE , STANDBY, READY , IDLE };
	KInt status;
	KInt answer = 0;
	
	T473TimeoutHandler * timeout;
	timeout = new T473TimeoutHandler;

	KChar com[256];

	T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
        KInt cmd_port = ext->getKIntValue("DAQ_CMD_PORT");
	if( cmd_port == -1){
		cerr<<"DAQ_CMD_PORT is not defined : exit(0)"<<endl;
		KonoeHostSystem::exit(0);
	}

	cout << "DAQ_CMD_PORT = " << cmd_port << endl;
	T473DAQControl * control = new T473DAQControl(cmd_port);

	status = STANDBY;

	while(1){
	  answer = 0;
	  cout << "DAQ:CMD>";
	  cin.getline(com,256);
	  if( !strcmp(com,"bye"))
	    KonoeHostSystem::exit(0);
	  else if( (status == STANDBY || status == NONE) && !strcmp(com,"begin")){
	  	timeout->setTime(2000);
	  	answer = control->control(com);
	  	timeout->setTime(0);
		if(answer)
			status = READY;
		else {
			cout << "\tCMD not REACED! \t TRY AGAIN." << endl;
		}
	  }
	  else if( status == STANDBY && !strcmp(com,"shutdown")){
	  	timeout->setTime(2000);
	  	answer = control->control(com);
	  	timeout->setTime(0);
		if(answer)
			status = NONE;
		else {
			cout << "\tCMD not REACED! \t TRY AGAIN." << endl;
		}
	  }
	  else if( status == READY && !strcmp(com,"pause")){
	  	timeout->setTime(2000);
	  	answer = control->control(com);
	  	timeout->setTime(0);
		if(answer)
			status = IDLE;
		else {
			cout << "\tCMD not REACED! \t TRY AGAIN." << endl;
		}
	  }
	  else if( status == IDLE && !strcmp(com,"end")){
	  	timeout->setTime(2000);
	  	answer = control->control(com);
	  	timeout->setTime(0);
		if(answer)
			status = STANDBY;
		else {
			cout << "\tCMD not REACED! \t TRY AGAIN." << endl;
		}
	  }
	  else if( status == IDLE && !strcmp(com,"resume")){
	  	timeout->setTime(2000);
	  	answer = control->control(com);
	  	timeout->setTime(0);
		if(answer)
			status = READY;
		else {
			cout << "CMD not REACED! \t TRY AGAIN." << endl;
		}
	  }
	  else {
		cout << "invalid CMD  try again" << endl;
		cout << "Now status = " << status << endl;
		cout << "You should type " ;
		if( status == STANDBY )
			cout << " \"shutdown\" or \"begin\" " << endl;
		if( status == NONE )
			cout << " \"begin\" " << endl;
		if( status == READY )
			cout << " \"pause\" " << endl;
		if( status == IDLE )
			cout << " \"end\" or \"resume\" " << endl;
		
	  }

	}

	delete control;
	
	return (0);
}
