//=============================================================
/*
	histo_controler.cc

	13-Nov-2000	Y. Shimizu
*/
//=============================================================

#include	<system/KonoeIntervalTimer.hh>
#include	<system/KonoeSignalHandler.hh>
#include	"T473StatusChecker.hh"
#include	"T473HistoControl.hh"
#include	"T473TimeoutHandler.hh"
#include        <system/KonoeHostSystem.hh>
#include        <string.h>

int main(int argc,char** argv)
{
	static KInt count = 0;

	T473StatusChecker * checker;
	checker = new T473StatusChecker("HISTOGRAM");

	T473TimeoutHandler * timeout;
	timeout = new T473TimeoutHandler;

	KChar com[256];

	T473NameSpaceExtractor * ext = new T473NameSpaceExtractor;
	KInt cmd_port = ext->getKIntValue("HISTO_CMD_PORT");
	if( cmd_port == -1 ){
		cerr << "HISTO_CMD_PORT is not defined : exit"<<endl;
		KonoeHostSystem::exit(0);
	}

	cout << "HISTO_CMD_PORT = " <<cmd_port << endl;
	T473HistoControl * control = new T473HistoControl(cmd_port);
	
	checker->init();

	while(1){
	cout << "HISTO:CMD>";
	  cin.getline(com,256);
	  if( !strcmp(com, "bye"))
	    KonoeHostSystem::exit(0);
	  timeout->setTime( 1000 );
	  control->control(com);
	  timeout->setTime( 0 );
	  while( checker->check() ) {
		
                if( count == 20000 ){
		  cout <<"\tHISTO:\tCMD NOT REACHED\n" ;
			break;
		}
		count++;
	  }
	  count = 0;
	  checker->init();
		
	}

	delete control;
	delete checker;
	
	return (0);
}
