//=============================================================
/*
	kill_all.cc

	13-Nov-2000	Y. Shimizu

*/
//=============================================================
#include	"../Namespace/T473NameSpaceExtractor.hh"
#include	<system/KonoeSignalSender.hh>
#include        <string.h>

int main(){

	KonoeSignalSender	* killer;
	T473NameSpaceExtractor	* ext;
	ext = new T473NameSpaceExtractor;
	
	KInt daq_pid;
	KInt histo_pid;
	KInt datahub_pid;
	KInt recons_pid;
	KInt logger_pid;

	KChar daq_host[10];
	KChar histo_host[10];
	KChar datahub_host[10];
	KChar recons_host[10];
	KChar logger_host[10];

	killer = new KonoeSignalSender( ext->getKIntValue("SIGNAL_PORT"));

	daq_pid = ext->getKIntValue("DAQ_PID");
	histo_pid = ext->getKIntValue("HISTOGRAM_PID");
	datahub_pid = ext->getKIntValue("DATAHUB_PID");
	recons_pid = ext->getKIntValue("RECONSTRUCT_PID");
	logger_pid = ext->getKIntValue("LOGGER_PID");
	
	strcpy(daq_host,ext->getKCharValue("DAQ_HOST"));
	strcpy(histo_host,ext->getKCharValue("HISTOGRAM_HOST"));
	strcpy(datahub_host, ext->getKCharValue("DATAHUB_HOST"));
	strcpy(recons_host ,ext->getKCharValue("RECONSTRUCT_HOST"));
	strcpy(logger_host,ext->getKCharValue("LOGGER_HOST"));

	if( daq_pid != -1 ){
		cout << "DAQ_PID = "<< daq_pid << endl;
	        daq_pid = ext->getKIntValue("DAQ_PID");
		cout<<"killer->kill("<<daq_host<<","<<daq_pid<<","<<
				SIGKILL<<")"<<endl;
		killer->kill(daq_host,daq_pid,SIGKILL);
	}
	else {
		cout <<"DAQ_PID is not defined"<<endl;
	}

	if( histo_pid != -1 ){
		cout << "HISTOGRAM_PID = "<< histo_pid << endl;
		cout<<"killer->kill("<<histo_host<<","<<histo_pid<<","<<
				SIGKILL<<")"<<endl;
		killer->kill(histo_host,histo_pid,SIGKILL);
	}
	else {
		cout <<"HISTOGRAM_PID is not defined"<<endl;
	}


	if( datahub_pid != -1 ){
		cout << "DATAHUB_PID = "<< datahub_pid << endl;
		cout<<"killer->kill("<<datahub_host<<","<<datahub_pid<<","<<
				SIGKILL<<")"<<endl;
		killer->kill(datahub_host,datahub_pid,SIGKILL);
	}
	else {
		cout <<"DATAHUB_PID is not defined"<<endl;
	}

	if( recons_pid != -1 ){
		cout << "RECONSTRUCT_PID = "<< recons_pid << endl;
		cout<<"killer->kill("<<recons_host<<","<<recons_pid<<","<<
				SIGKILL<<")"<<endl;
		killer->kill(recons_host,recons_pid,SIGKILL);
	}
	else {
		cout <<"RECONSTRUTCT_PID is not defined"<<endl;
	}

	if( logger_pid != -1 ){
		cout << "LOGGER_PID = "<< logger_pid << endl;
		cout<<"killer->kill("<<logger_host<<","<<logger_pid<<","<<
				SIGKILL<<")"<<endl;
		killer->kill(logger_host,logger_pid,SIGKILL);
	}
	else {
		cout <<"LOGGER_PID is not defined"<<endl;
	}

	delete killer;

	return (0);
}


	
