#include"T473RunControl.hh"
#include <system/KonoeHostSystem.hh>
#include <string.h>

int main(int argc, char** argv){

  enum { IGNORE = -2 , UNKNOWN = -1, NONE , STANDBY , READY, IDLE };
  KChar com[256];
  KInt 	go_answer;  

  T473RunControl	* controler;
	
  controler = new T473RunControl;

  go_answer = 1;
  
  while(1){
    cout << "\n\tT473control::CMD(begin,pause,resume,end,shutdown)\n";
    cout << "\tT473control::CMD>";
    cin.getline(com,256);
    cout << "\n";
    if( !strcmp(com,"bye"))
      KonoeHostSystem::exit(0);
    else if( (controler->getStatus() == STANDBY  || 
		controler->getStatus() == NONE || 
			controler->getStatus() == IGNORE) && 
	       !strcmp(com,"begin") ){ 
      while( go_answer ){
        controler->setGeneralInfo();
        controler->setCsITDCPedestalInfo();
        controler->setCsIADCPedestalInfo();
        controler->setScinTDCPedestalInfo();
        controler->setDataHubStrageName();
        go_answer = controler->askGo();
      }
      go_answer = 1;
      controler->begin();
    }
    else if( ( controler->getStatus() == STANDBY 
			|| controler->getStatus() == IGNORE ) 
				&& !strcmp(com,"shutdown")){
      controler->shutdown();
    }
    else if( ( controler->getStatus() == IDLE || 
		controler->getStatus() == IGNORE ) && !strcmp(com,"end")){
      controler->end();
    }
    else if( ( controler->getStatus() == IDLE  || 
		controler->getStatus() == IGNORE ) && !strcmp(com,"resume")){
      controler->resume();
    }
    else if( ( controler->getStatus() == READY || 
		controler->getStatus() == IGNORE ) && !strcmp(com,"pause")){
      controler->pause();
    }
    else {
      cout << "invalid CMD  try again" << endl;
      cout << "Now status = " << controler->getStatus() << endl;
      cout << "You should type " ;
      if( controler->getStatus() == STANDBY )
	cout << " \"shutdown\" or \"begin\" " << endl;
      if( controler->getStatus() == NONE )
	cout << " \"begin\" " << endl;
      if( controler->getStatus() == READY )
	cout << " \"pause\" " << endl;
      if( controler->getStatus() == IDLE )
	cout << " \"end\" or \"resume\" " << endl;
    }	
    
  }
  
  return (0);
  
}
