//=====================================================================
/*

    T473TclProcessControlAction.hh

    Version 0.0.1   13-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLPROCESSCONTROLACTION_HH
#define __T473TCLPROCESSCONTROLACTION_HH

#include <ui/KonoeTclAction.hh>
#include <T473TclProcessControlPanel.hh>
#include <RunControl/T473RunControlBase.hh>
#include <RunControl/T473DAQControl.hh>
#include <RunControl/T473DataHubControl.hh>
#include <RunControl/T473HistoControl.hh>
#include <RunControl/T473ReconstructControl.hh>
#include <RunControl/T473LoggerControl.hh>

class T473TclProcessControlAction : public KonoeTclEventProcessor,
                                    public KonoeTclMouseAction {

  public:
    T473TclProcessControlAction(
               T473TclProcessControlPanel* pPanel);
    ~T473TclProcessControlAction();

    void setSelectedProcess(KInt pProcess){ selectedProcess = pProcess; }

  private:
    void mouseAction(KonoeTclButton*, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void mouseAction(KonoeTclRadioButton*, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void mouseAction(KonoeTclCheckButton*, KInt type, KInt button,
                                  Time time, KInt x, KInt y);

    void initProcessController();
    void changeProcessControl(KInt pProcess);
    void forgetProcessControl();

    void kBegin();
    void kEnd();
    void kPause();
    void kResume();
    void kShutdown();
    void kBoot();
    void kNewFile();
    void kFileClose();
    void kContinue();

    enum { KDAQ, KDATAHUB, KHISTOGRAM, KRECONSTRUCT, KLOGGER };

    T473TclProcessControlPanel* processControlPanel;

    T473RunControlBase* processController;

    T473DAQControl* daqControl;
    T473DataHubControl* dataHubControl;
    T473HistoControl* histControl;
    T473ReconstructControl* reconstructControl;
    T473LoggerControl* loggerControl;

    KInt selectedProcess;
};

#endif
