//=====================================================================
/*

    T473TclRunControlAction.hh

    Version 0.0.1   12-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLRUNCONTROLACTION_HH
#define __T473TCLRUNCONTROLACTION_HH

#include <ui/KonoeTclAction.hh>
#include <T473TclRunControlPanel.hh>
#include <RunControl/T473DAQControl.hh>
#include <RunControl/T473DataHubControl.hh>
#include <RunControl/T473HistoControl.hh>
#include <RunControl/T473ReconstructControl.hh>
#include <RunControl/T473LoggerControl.hh>

class T473TclRunControlAction : public KonoeTclEventProcessor,
                                public KonoeTclMouseAction,
                                public KonoeTclKeyAction {

  public:
    T473TclRunControlAction(T473TclRunControlPanel* prunControl);
    ~T473TclRunControlAction();

    void mouseAction(KonoeTclButton* kbtn, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void mouseAction(KonoeTclLabel* klbl, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void mouseAction(KonoeTclCheckButton* kbtn, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void mouseAction(KonoeTclCanvas* kbtn, KInt type, KInt button,
                                  Time time, KInt x, KInt y);
    void keyAction(KonoeTclCheckButton* kcv, KInt type, KeySym keysym,
                                                              KInt state);

    T473DAQControl* getDAQControl() { return daqControl; }
    T473DataHubControl* getDataHubControl() { return dataHubControl; }
    T473HistoControl* getHistControl() { return histControl; }
    T473ReconstructControl* getReconstructControl()
                                     { return reconstructControl; }
    T473LoggerControl* getLoggerControl() { return loggerControl; }
    

  private:
    void initProcessController();
    void kBegin();
    void kEnd();
    void kPause();
    void kResume();
    void kShutdown();

    T473TclRunControlPanel* runControlPanel;

    T473DAQControl* daqControl;
    T473DataHubControl* dataHubControl;
    T473HistoControl* histControl;
    T473ReconstructControl* reconstructControl;
    T473LoggerControl* loggerControl;
};

#endif
