//=====================================================================
/*

    T473TclRunSummaryAction.cc

    Version 0.0.1   13-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclRunSummaryAction.hh>
#include <RunSummary/T473RunSummary.hh>

#include <Namespace/T473NameSpaceSetter.hh>

#include <stdlib.h>

T473TclRunSummaryAction::T473TclRunSummaryAction
                           (T473TclRunSummaryPanel* pPanel)
{
  runSummaryPanel = pPanel;
}

T473TclRunSummaryAction::~T473TclRunSummaryAction()
{ ; }

void T473TclRunSummaryAction::createButtonAction()
{
  T473RunSummary summary;
  summary.putRunInfo();
  summary.putDataInfo();
  summary.putHistoInfo();
  summary.putNameInfo();
  summary.putPedestalInfo();
  summary.putLogInfo();
  summary.putComment( runSummaryPanel->getComment() );

  if( !getenv("NONAMESPACE") ){
    T473NameSpaceSetter nsSetter;
    nsSetter.set("EVENT_NUMBER", "0");
  }

  runSummaryPanel->hide();
}

void T473TclRunSummaryAction::mouseAction(KonoeTclButton* kbtn, KInt type,
                                     KInt button, Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){
      if(strcmp(kbtn->getName(), "runSummaryButton")==0) createButtonAction();
    }
  }
}
