//=====================================================================
/*

    T473TclRunSummaryPanel.cc

    Version 0.0.1   12-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclRunSummaryPanel.hh>
#include <T473TclRunControlPanel.hh>
#include <T473TclRunSummaryAction.hh>
#include <ui/KonoeTclSubWindow.hh>

T473TclRunSummaryPanel::T473TclRunSummaryPanel(T473TclRunControlPanel* pinfo)
{
  info = pinfo;
  strcpy(fontName, "courier");
  fontSize = 18;
  strcpy(backColor, "#EBFFF2");

  kwin = info->getWindow();

  runSummaryWindow = 0;
}

T473TclRunSummaryPanel::~T473TclRunSummaryPanel()
{
  this->destroyWindow();
}

void T473TclRunSummaryPanel::destroyWindow()
{
    runNumberLabel->setForget();
    runNumberDrawLabel->setForget();
    eventNumberLabel->setForget();
    eventNumberDrawLabel->setForget();
    runTypeLabel->setForget();
    runTypeDrawLabel->setForget();
    particleLabel->setForget();
    particleDrawLabel->setForget();
    runBeginLabel->setForget();
    runBeginDrawLabel->setForget();
    runEndLabel->setForget();
    runEndDrawLabel->setForget();
    cherenkovLabel->setForget();
    cherenkovDrawLabel->setForget();
    csiTempLabel->setForget();
    csiTempDrawLabel->setForget();
    positionLabel->setForget();
    positionDrawLabel->setForget();
    angleLabel->setForget();
    angleDrawLabel->setForget();
    shutterLabel->setForget();
    shutterLLabel->setForget();
    shutterLeftFrame->setForget();
    shutterRLabel->setForget();
    shutterLDrawLabel->setForget();
    shutterRDrawLabel->setForget();
    shutterRightFrame->setForget();
    shiftLabel->setForget();
    shiftEntry1->setForget();
    shiftEntry2->setForget();
    commentLabel->setForget();
    commentText->setForget();
    //fileNameLabel->setForget();
    //fileNameEntry->setForget();

    KInt i;
    for(i=0; i<15; i++){
      scalerLabel[i]->setForget();
      scalerValueLabel[i]->setForget();
    }

    scalerFrame->setForget();

    runSummaryButton->setForget();
    buttonFrame->setForget();

    delete runNumberLabel;
    delete runNumberDrawLabel;
    delete eventNumberLabel;
    delete eventNumberDrawLabel;
    delete runTypeLabel;
    delete runTypeDrawLabel;
    delete particleLabel;
    delete particleDrawLabel;
    delete runBeginLabel;
    delete runBeginDrawLabel;
    delete runEndLabel;
    delete runEndDrawLabel;
    delete cherenkovLabel;
    delete cherenkovDrawLabel;
    delete csiTempLabel;
    delete csiTempDrawLabel;
    delete positionLabel;
    delete positionDrawLabel;
    delete angleLabel;
    delete angleDrawLabel;
    delete shutterLabel;
    delete shutterLLabel;
    delete shutterLDrawLabel;
    delete shutterLeftFrame;
    delete shutterRLabel;
    delete shutterRDrawLabel;
    delete shutterRightFrame;
    delete shiftLabel;
    delete shiftEntry1;
    delete shiftEntry2;
    delete commentLabel;
    delete commentText;
    //delete fileNameLabel;
    //delete fileNameEntry;

    for(i=0; i<15; i++){
      delete scalerLabel[i];
      delete scalerValueLabel[i];
    }

    delete scalerFrame;

    delete runSummaryButton;

    delete buttonFrame;

    delete runSummaryAction;

    runSummaryWindow->destroy();
    delete runSummaryWindow;
    runSummaryWindow = 0;
}

void T473TclRunSummaryPanel::initAction()
{
  runSummaryAction = new T473TclRunSummaryAction(this);

  runSummaryButton->setEventProcessor( runSummaryAction );
  runSummaryAction->addMouseAction( runSummaryButton );

  runSummaryWindow->setEventProcessor(this);
  addWindowAction(runSummaryWindow);
}

void T473TclRunSummaryPanel::view()
{
  if(!runSummaryWindow){
    initRunSummaryFrame();
    initScalerFrame();
    initButtonFrame();
    initAction();
  }
  else{
    runSummaryWindow->show();
  }
  runSummaryWindow->show();
  setItem();
  commentText->clear();
}

void T473TclRunSummaryPanel::hide()
{
  runSummaryWindow->hide();
  //this->~T473TclRunSummaryPanel();
}

void T473TclRunSummaryPanel::initRunSummaryFrame()
{
  runSummaryWindow = new KonoeTclSubWindow(kwin, "runSummaryWindow",
                                           "Run Summary");

  KInt yNum = 0;

  runSummaryFrame = new KonoeTclFrame(runSummaryWindow, "runSummaryFrame", 0,0);
  runSummaryFrame->setBackGround(backColor);
  
  runNumberLabel = new KonoeTclLabel(runSummaryFrame, "runNumberLabel",
                                     "Run Number", 0,yNum);
  runNumberDrawLabel = new KonoeTclLabel(runSummaryFrame, "runNumberDrawLabel",
                                     "", 1,yNum);
  yNum++;
  eventNumberLabel = new KonoeTclLabel(runSummaryFrame, "eventNumberLabel",
                                     "Event Number", 0,yNum);
  eventNumberDrawLabel = new KonoeTclLabel(runSummaryFrame,
                                     "eventNumberDrawLabel", "", 1,yNum);
  yNum++;
  runTypeLabel  = new KonoeTclLabel(runSummaryFrame, "runTypeLabel",
                                     "Run Type", 0,yNum);
  runTypeDrawLabel  = new KonoeTclLabel(runSummaryFrame, "runTypeDrawLabel",
                                     "", 1,yNum);
  yNum++;
  particleLabel  = new KonoeTclLabel(runSummaryFrame, "particleLabel",
                                     "Particle Energy", 0,yNum);
  particleDrawLabel = new KonoeTclLabel(runSummaryFrame, "particleDrawLabel",
                                     "",1,yNum);
  yNum++;
  runBeginLabel = new KonoeTclLabel(runSummaryFrame, "runBeginLabel",
                                     "Start Time", 0,yNum);
  runBeginDrawLabel = new KonoeTclLabel(runSummaryFrame, "runBeginDrawLabel",
                                     "", 1,yNum);
  yNum++;
  runEndLabel = new KonoeTclLabel(runSummaryFrame, "runEndLabel",
                                     "End Time", 0,yNum);
  runEndDrawLabel = new KonoeTclLabel(runSummaryFrame, "runEndDrawLabel",
                                     "", 1,yNum);
  yNum++;
  cherenkovLabel = new KonoeTclLabel(runSummaryFrame, "cherenkovLabel",
                                     "Cherenkov Pressure",0,yNum);
  cherenkovDrawLabel = new KonoeTclLabel(runSummaryFrame, "cherenkovDrawLabel",
                                     "",1,yNum);
  yNum++;
  csiTempLabel = new KonoeTclLabel(runSummaryFrame, "csiTempLabel",
                                     "Temperature",0,yNum);
  csiTempDrawLabel = new KonoeTclLabel(runSummaryFrame, "csiTempDrawLabel",
                                     "",1,yNum);
  yNum++;
  positionLabel = new KonoeTclLabel(runSummaryFrame, "positionLabel",
                                     "Position",0,yNum);
  positionDrawLabel = new KonoeTclLabel(runSummaryFrame, "positionDrawLabel",
                                     "",1,yNum);
  yNum++;
  angleLabel = new KonoeTclLabel(runSummaryFrame, "angleLabel",
                                     "Angle",0,yNum);
  angleDrawLabel = new KonoeTclLabel(runSummaryFrame, "angleDrawLabel",
                                     "",1,yNum);
  yNum++;
  shutterLeftFrame = new KonoeTclFrame(runSummaryFrame, "shutterLeftFrame",
                                     0,yNum);
  shutterLabel = new KonoeTclLabel(shutterLeftFrame, "shutterLabel",
                                     "Shutter",0,0);
  shutterLLabel = new KonoeTclLabel(shutterLeftFrame, "shutterLLabel",
                                     "Left",1,0);
  shutterRLabel = new KonoeTclLabel(shutterLeftFrame, "shutterRLabel",
                                     "Right",1,1);
  shutterRightFrame = new KonoeTclFrame(runSummaryFrame, "shutterRightFrame",
                                     1,yNum);
  shutterLDrawLabel = new KonoeTclLabel(shutterRightFrame, "shutterLDrawLabel",
                                     "",0,0);
  shutterRDrawLabel = new KonoeTclLabel(shutterRightFrame, "shutterRDrawLabel",
                                     "",0,1);
  yNum++;
  shiftLabel = new KonoeTclLabel(runSummaryFrame, "shiftLabel",
                                     "Shift", 0,yNum);
  shiftEntry1 = new KonoeTclEntry(runSummaryFrame, "shiftEntry1",
                                     1,yNum);
  yNum++;
  shiftEntry2 = new KonoeTclEntry(runSummaryFrame, "shiftEntry2",
                                     1,yNum);
  yNum++;
  commentLabel = new KonoeTclLabel(runSummaryFrame, "commentLabel",
                                     "Any comment", 0,yNum);
  commentText = new KonoeTclText(runSummaryFrame, "commentText",
                                     1,yNum);
  yNum++;
  //fileNameLabel = new KonoeTclLabel(runSummaryFrame, "fileNameLabel",
  //                                   "File Name", 0,9);
  //fileNameEntry = new KonoeTclEntry(runSummaryFrame, "fileNameEntry",
  //                                   1,9);

  runNumberLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runNumberDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  eventNumberLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  eventNumberDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runTypeLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runTypeDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  particleLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  particleDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runBeginLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runBeginDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runEndLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  runEndDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  cherenkovLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  cherenkovDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  csiTempLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  csiTempDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  positionLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  positionDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  angleLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  angleDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shutterLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shutterLLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shutterRLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shutterLDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shutterRDrawLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shiftLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  shiftEntry1->setFont(fontName, fontSize, 1, 0, 0, 0);
  shiftEntry2->setFont(fontName, fontSize, 1, 0, 0, 0);
  commentLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  commentText->setFont(fontName, fontSize, 1, 0, 0, 0);
  //fileNameLabel->setFont(fontName, fontSize, 1, 0, 0, 0);
  //fileNameEntry->setFont(fontName, fontSize, 1, 0, 0, 0);

  runNumberLabel->setBackGround(backColor);
  runNumberDrawLabel->setBackGround(backColor);
  eventNumberLabel->setBackGround(backColor);
  eventNumberDrawLabel->setBackGround(backColor);
  runTypeLabel->setBackGround(backColor);
  runTypeDrawLabel->setBackGround(backColor);
  particleLabel->setBackGround(backColor);
  particleDrawLabel->setBackGround(backColor);
  runBeginLabel->setBackGround(backColor);
  runBeginDrawLabel->setBackGround(backColor);
  runEndLabel->setBackGround(backColor);
  runEndDrawLabel->setBackGround(backColor);
  shiftLabel->setBackGround(backColor);
  cherenkovLabel->setBackGround(backColor);
  cherenkovDrawLabel->setBackGround(backColor);
  csiTempLabel->setBackGround(backColor);
  csiTempDrawLabel->setBackGround(backColor);
  positionLabel->setBackGround(backColor);
  positionDrawLabel->setBackGround(backColor);
  angleLabel->setBackGround(backColor);
  angleDrawLabel->setBackGround(backColor);
  shutterLabel->setBackGround(backColor);
  shutterLeftFrame->setBackGround(backColor);
  shutterLLabel->setBackGround(backColor);
  shutterLDrawLabel->setBackGround(backColor);
  shutterRightFrame->setBackGround(backColor);
  shutterRLabel->setBackGround(backColor);
  shutterRDrawLabel->setBackGround(backColor);
//  shiftEntry1->setBackGround(backColor);
//  shiftEntry2->setBackGround(backColor);
  commentLabel->setBackGround(backColor);
//  commentText->setBackGround(backColor);
  //fileNameLabel->setBackGround(backColor);
//  fileNameEntry->setBackGround(backColor);
//  runSummaryButton->setBackGround(backColor);

  shiftEntry1->setBackGround("white");
  shiftEntry2->setBackGround("white");
  commentText->setBackGround("white");
  //fileNameEntry->setBackGround("white");

  runNumberLabel->setGridSticky("w");
  eventNumberLabel->setGridSticky("w");
  runTypeLabel->setGridSticky("w");
  particleLabel->setGridSticky("w");
  runBeginLabel->setGridSticky("w");
  runEndLabel->setGridSticky("w");
  cherenkovLabel->setGridSticky("w");
  csiTempLabel->setGridSticky("w");
  positionLabel->setGridSticky("w");
  angleLabel->setGridSticky("w");
  shutterLabel->setGridSticky("w");
  shutterLeftFrame->setGridSticky("w");
  shutterLLabel->setGridSticky("w");
  shutterRLabel->setGridSticky("w");
  shiftLabel->setGridSticky("w");
  commentLabel->setGridSticky("w");
  //fileNameLabel->setGridSticky("w");

  runNumberDrawLabel->setGridSticky("e");
  eventNumberDrawLabel->setGridSticky("e");
  runTypeDrawLabel->setGridSticky("e");
  particleDrawLabel->setGridSticky("e");
  cherenkovDrawLabel->setGridSticky("e");
  csiTempDrawLabel->setGridSticky("e");
  positionDrawLabel->setGridSticky("e");
  angleDrawLabel->setGridSticky("e");
  shutterRightFrame->setGridSticky("e");
  shutterLDrawLabel->setGridSticky("e");
  shutterRDrawLabel->setGridSticky("e");
  shiftEntry1->setGridSticky("we");
  shiftEntry2->setGridSticky("we");
  //fileNameEntry->setGridSticky("we");
  runBeginDrawLabel->setGridSticky("e");
  runEndDrawLabel->setGridSticky("e");

  shiftLabel->setGridRowspan(2);
  shutterLabel->setGridRowspan(2);

  runNumberLabel->setGridPadx(20);
  eventNumberLabel->setGridPadx(20);
  runTypeLabel->setGridPadx(20);
  particleLabel->setGridPadx(20);
  runBeginLabel->setGridPadx(20);
  runEndLabel->setGridPadx(20);
  cherenkovLabel->setGridPadx(20);
  csiTempLabel->setGridPadx(20);
  positionLabel->setGridPadx(20);
  angleLabel->setGridPadx(20);
  shutterLabel->setGridPadx(20);
  shiftLabel->setGridPadx(20);
  commentLabel->setGridPadx(20);
  //fileNameLabel->setGridPadx(20);

  commentText->setSize(30, 5);
  commentText->setGridSticky("news");

}

void T473TclRunSummaryPanel::initScalerFrame() {
  scalerFrame = new KonoeTclFrame(runSummaryWindow, "scalerFrame", 1,0);
  scalerFrame->setBackGround(backColor);
  scalerFrame->setGridSticky("news");

  KChar lblName[256];
  KChar* lblValue[15] = {"S1L*S1R", "S1L*S1R*S2", "S1L*S1R*S2*S3",
                      "S1L*S1R*S2*S3 * S4 ",
                      "S1L*S1R*S2*S3\\(Delay\\)*S4",
                      "S1L*S1R*S2*S3*S4*S5 ",
                      "S1L*S1R*S2*S3*S4*S5*S6 ",
                      "S1L*S1R*S2*S3*S4*S5*S6*S7 ",
                      "GC1*GC2",
                      "S1L*S1R*S2*S3*S4*GC1*GC2 ",
                      "Trigger \\(NO VETO\\)",
                      "Trigger \\(VETO\\)",
                      "CLK 1", "CLK 2", "Xenon 1"};
  KInt i;
  for(i=0; i<15; i++){
    sprintf(lblName, "scalerLabel%d", i);

    scalerLabel[i] = new KonoeTclLabel(scalerFrame, lblName, lblValue[i], 0, i);

    scalerLabel[i]->setFont(fontName, fontSize-4, 1, 0, 0, 0);
    scalerLabel[i]->setBackGround(backColor);
    scalerLabel[i]->setGridSticky("w");
    scalerLabel[i]->setGridPadx(20);
  }

  for(i=0; i<15; i++){
    sprintf(lblName, "scalerValueLabel%d", i);

    scalerValueLabel[i] = new KonoeTclLabel(scalerFrame, lblName, "", 1, i);

    scalerValueLabel[i]->setFont(fontName, fontSize, 1, 0, 0, 0);
    scalerValueLabel[i]->setBackGround(backColor);
    scalerValueLabel[i]->setGridSticky("e");
    scalerValueLabel[i]->setGridPadx(20);
  }

}

void T473TclRunSummaryPanel::initButtonFrame()
{
  buttonFrame = new KonoeTclFrame(runSummaryWindow, "buttonFrame", 0,1);
  buttonFrame->setBackGround(backColor);
  buttonFrame->setGridSticky("news");
  buttonFrame->setGridColumnspan(2);

  runSummaryButton = new KonoeTclButton(buttonFrame, "runSummaryButton",
                                     "Create Run Summary", 0,0);
  runSummaryButton->setFont(fontName, fontSize, 1, 0, 0, 0);
  runSummaryButton->setGridPady(20);
  runSummaryButton->setBackGround("#d9d9d9");
} 

void T473TclRunSummaryPanel::setItem()
{
  KChar value[256];

  T473NameSpaceExtractor ext;

  strcpy(value, ext.getKCharValue("RUN_NUMBER"));
  runNumberDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("RUN_TYPE"));
  runTypeDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("EVENT_NUMBER"));
  eventNumberDrawLabel->setCaption(value);

  sprintf(value, "%s \\[GeV/c\\]", ext.getKCharValue("PARTICLE_ENERGY"));
  particleDrawLabel->setCaption(value);

  sprintf(value, "%s \\[atm\\]", ext.getKCharValue("CHERENKOV_P"));
  cherenkovDrawLabel->setCaption(value);

  sprintf(value, "%s ", ext.getKCharValue("CSI_TEMP"));
  csiTempDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("CSI_POSITION"));
  positionDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("ANGLE"));
  angleDrawLabel->setCaption(value);

  sprintf(value, "%s \\[mm\\]", ext.getKCharValue("SHUTTER_LEFT"));
  shutterLDrawLabel->setCaption(value);

  sprintf(value, "%s \\[mm\\]", ext.getKCharValue("SHUTTER_RIGHT"));
  shutterRDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("PLAYER1"));
  shiftEntry1->setText(value);

  strcpy(value, ext.getKCharValue("PLAYER2"));
  shiftEntry2->setText(value);

  strcpy(value, ext.getKCharValue("RUN_BEGIN_TIME"));
  runBeginDrawLabel->setCaption(value);

  strcpy(value, ext.getKCharValue("RUN_END_TIME"));
  runEndDrawLabel->setCaption(value);

  KInt i;
  KChar scalerNum[32];
  for(i=0; i<12; i++){ 
    sprintf(scalerNum, "SINGLE_COUNTS_0_%d", i);
    strcpy(value, ext.getKCharValue( scalerNum ));
    scalerValueLabel[i]->setCaption(value);
  }

  for(i=0; i<3; i++){
    sprintf(scalerNum, "SINGLE_COUNTS_1_%d", i);
    strcpy(value, ext.getKCharValue( scalerNum ));
    scalerValueLabel[i+12]->setCaption(value);
  }
  

/************************************
  runNumberDrawLabel->setCaption(info->getRunNumber());

  eventNumberDrawLabel->setCaption(info->getEventNumber());

  runTypeDrawLabel->setCaption(info->getRunType());

  sprintf(value, "%s \\[GeV/c\\]", info->getParticleEnergy());
  particleDrawLabel->setCaption(value);

  sprintf(value, "%s \\[atm\\]", info->getPressure());
  cherenkovDrawLabel->setCaption(value);

  sprintf(value, "%s ", info->getTemperature());
  csiTempDrawLabel->setCaption(value);

  positionDrawLabel->setCaption(info->getPosition());

  angleDrawLabel->setCaption(info->getAngle());

  sprintf(value, "%s \\[mm\\]", info->getLeftShutter());
  shutterLDrawLabel->setCaption(value);

  sprintf(value, "%s \\[mm\\]", info->getRightShutter());
  shutterRDrawLabel->setCaption(value);

  shiftEntry1->setText(info->getShift1());
  shiftEntry2->setText(info->getShift2());

  runBeginDrawLabel->setCaption(info->getBeginTime());

  runEndDrawLabel->setCaption(info->getEndTime());
**********************************/
}

void T473TclRunSummaryPanel::windowAction(KonoeTclWindow* pwin, XEvent* xev)
{
  if(xev->type == KDestroyWindow){
    this->destroyWindow();
  }
}
