//=====================================================================
/*

    T473TclRunSummaryPanel.hh

    Version 0.0.1   12-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLRUNSUMMARYPANEL_HH
#define __T473TCLRUNSUMMARYPANEL_HH

#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
class T473TclRunControlPanel;
class T473TclRunSummaryAction;
class KonoeTclSubWindow;

class T473TclRunSummaryPanel : public KonoeTclEventProcessor,
                               public KonoeTclWindowAction {

  public:
    T473TclRunSummaryPanel(T473TclRunControlPanel* pinfo);
    ~T473TclRunSummaryPanel();

    void view();
    void hide();
    KChar* getComment() { commentText->getText(); }

  private:
    void initRunSummaryFrame();
    void initScalerFrame();
    void initButtonFrame();
    void initAction();
    void setItem();
    void destroyWindow();
    void windowAction(KonoeTclWindow* kwin, XEvent* xev);

    KChar fontName[256];
    KChar fontSize;
    KChar backColor[256];

    T473TclRunControlPanel* info;

    KonoeTclWindow* kwin;
    KonoeTclSubWindow* runSummaryWindow;
    KonoeTclFrame* runSummaryFrame;

//Run summary action
    T473TclRunSummaryAction* runSummaryAction;

// Run summary frame
    KonoeTclLabel* runNumberLabel;
    KonoeTclLabel* runNumberDrawLabel;

    KonoeTclLabel* eventNumberLabel;
    KonoeTclLabel* eventNumberDrawLabel;

    KonoeTclLabel* runTypeLabel;
    KonoeTclLabel* runTypeDrawLabel;

    KonoeTclLabel* particleLabel;
    KonoeTclLabel* particleDrawLabel;

    KonoeTclLabel* runBeginLabel;
    KonoeTclLabel* runBeginDrawLabel;

    KonoeTclLabel* runEndLabel;
    KonoeTclLabel* runEndDrawLabel;

    KonoeTclLabel* cherenkovLabel;
    KonoeTclLabel* cherenkovDrawLabel;

    KonoeTclLabel* csiTempLabel;
    KonoeTclLabel* csiTempDrawLabel;

    KonoeTclLabel* positionLabel;
    KonoeTclLabel* positionDrawLabel;

    KonoeTclLabel* angleLabel;
    KonoeTclLabel* angleDrawLabel;

    KonoeTclLabel* shutterLabel;
    KonoeTclFrame* shutterLeftFrame;
    KonoeTclLabel* shutterLLabel;
    KonoeTclLabel* shutterLDrawLabel;
    KonoeTclFrame* shutterRightFrame;
    KonoeTclLabel* shutterRLabel;
    KonoeTclLabel* shutterRDrawLabel;

    KonoeTclLabel* shiftLabel;
    KonoeTclEntry* shiftEntry1;
    KonoeTclEntry* shiftEntry2;

    KonoeTclLabel* commentLabel;
    KonoeTclText*  commentText;

    //KonoeTclLabel* fileNameLabel;
    //KonoeTclEntry* fileNameEntry;

    KonoeTclFrame* scalerFrame;
    KonoeTclLabel* scalerLabel[15];
    KonoeTclLabel* scalerValueLabel[15];

    KonoeTclFrame*  buttonFrame;
    KonoeTclButton* runSummaryButton;
};

#endif
