//=============================================================
/*
	T473RunSummary.cc
	
	11-Nov-2000	Y. Shimizu

*/
//=============================================================

#include<string.h>
#include<stdio.h>
#include<unistd.h>
#include<stdlib.h>
#include<system/KonoeOutputFile.hh>
#include<system/KonoeInputObjFile.hh>
#include<system/KonoeTime.hh>
#include"../Namespace/T473NameSpaceExtractor.hh"
#include"T473RunSummary.hh"
#include<system/KonoeInputFile.hh>

T473RunSummary::T473RunSummary( ){

  KonoeTime * time = new KonoeTime;
  KChar filename[256];
  strcpy(filename,"");

  ext = new T473NameSpaceExtractor ;

  if( getenv("T473_RUNSUMMARY_DIR") ){
	strcpy(filename,getenv("T473_RUNSUMMARY_DIR"));
	strcat(filename,"/");
  }

  if( ext->getKCharValue("RUN_NUMBER") == (KChar*)-1){
	cout << "\t\nRUN_NUMBER not defined : use default " << endl;
	strcat(filename,"default");
  }
 	
  strcat(filename,ext->getKCharValue("RUN_NUMBER"));
  strcat(filename,".html");
  
  file = new KonoeOutputFile( filename );
  putText("<html>");
  putText("\n");
  putText("<title>");
  putText(filename);
  putText("</title>");
  putText("\n");
  putText("<body bgcolor =\"#ffffff\">");
  putText("\n");
  putText("<h1>");
  putText(filename);
  putText("</h1>");
  putText(time->getTimeInfo());

  delete time;
}

T473RunSummary::~T473RunSummary( ){
  
  putText("\n");
  putText("</body>");
  putText("</html>");

  delete ext;
  delete file;

}

KInt T473RunSummary::putRunInfo( ){
  putText("<font color =\"green\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Run Information");
  putText("</h2>");

  putText("<table border = 4>");
  putText("<font size = 4>");
  putTable2("RUN_NUMBER","RUN_NUMBER");
  putText("</font>");
  putText("</table>");

  putText("<br>");

  putText("<table border = 1><tr><td width = 300>");

  putText("<table>");
  putText("<font size = 3>");
  putTable2("RUN_TYPE","RUN_TYPE");
  putTable2("PARTICLE_ENERGY","PARTICLE_ENERGY");
  putTable2("PLAYER1","PLAYER1");
  putTable2("PLAYER2","PLAYER2");
  putText("</table>");
  putText("</td><td width = 300>");

  putText("<table ><tr><width = 300>");
  putTable2("CsI position","CSI_POSITION");
  putTable2("Angle","ANGLE");
  putTable2("CsI Temperature","CSI_TEMP");
  putTable2("Cherenkov P","CHERENKOV_P");
  putTable2("Shutter left","SHUTTER_LEFT");
  putTable2("Shutter right","SHUTTER_RIGHT");
  putText("</table>");
  putText("</td></tr>");
  putText("</table>");

  putText("<table border = 1 >");
  putTable2("RUN_BEGIN_TIME","RUN_BEGIN_TIME");
  putTable2("RUN_END_TIME","RUN_END_TIME");
  putTable2("counts ","EVENT_NUMBER");
  putText("</font>");
  putText("</table>");
  putText("</font>");

  return (0);
}

KInt T473RunSummary::putNameInfo( ){
  putText("\n");
  putText("<font color =\"gray\" size = 3>");
  putText("<hr>");
  putText("<h2>");
  putText("Name Information");
  putText("</h2>");
  putText("<table>");
  putText("<font size = 3>");

  putTable2("DATAHUB_STORAGE_FILE_NAME","DATAHUB_STORAGE_FILE_NAME");

  /*
  putTable2("CSI_TDC_HISTONAME","CSI_TDC_HISTONAME");
  putTable2("CSI_ADC_HISTONAME","CSI_ADC_HISTONAME");
  putTable2("SCIN_ADC_HISTONAME","SCIN_ADC_HISTONAME");
  putTable2("SCIN_TDC_HISTONAME","SCIN_TDC_HISTONAME");
  putTable2("TOF_HISTONAME","TOF_HISTONAME");
  */
  putTable2("LOGFILE_NAME","LOGFILE_NAME");
  putText("</font>");
  putText("</table>");

  putText("</font>");
  return (0);
  
}
KInt T473RunSummary::putKonoeInfo( ){

  putText("<font color =\"purple\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Konoe Information");
  putText("</h2>");
  putText("<table>");
  putText("<font size = 3>");
  putTable2("MASTER_HOST","MASTER_HOST");
  putTable2("DAQ_HOST","DAQ_HOST");
  putTable2("DATAHUB_HOST","DATAHUB_HOST");
  putTable2("HISTOGRAM_HOST","HISTOGRAM_HOST");
  putTable2("RECONSTRUCT_HOST","RECONSTRUCT_HOST");
  putTable2("LOGGER_HOST","LOGGER_HOST");
  putText("</font>");
  putText("</table>");
  putText("</font>");
  return (0);
}

KInt T473RunSummary::putDataInfo( ){
  KChar buff[256];
  KInt i;
  putText("<font color =\"purple\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Scaler Information");
  putText("</h2>");

  putText("<table width = 400 border = 1>");
  putText("<font size = 3>");
  putTable2("S<sub>1</sub>",
	    "SINGLE_COUNTS_0_0");
  putTable2("S<sub>1</sub>*S<sub>2","SINGLE_COUNTS_0_1");
  putTable2("S<sub>1</sub>*S<sub>2</sub>*S<sub>3</sub>"
	    ,"SINGLE_COUNTS_0_2");
  putTable2("BEAM(=S<sub>1</sub>*S<sub>2</sub>*S<sub>3</sub>*S<sub>4</sub>)","SINGLE_COUNTS_0_3");
  putTable2("S<sub>1</sub>*S<sub>2</sub>*S<sub>3</sub>(Delay)*S<sub>4</sub>","SINGLE_COUNTS_0_4");

  putTable2("BEAM * S<sub>5</sub>","SINGLE_COUNTS_0_5");
  putTable2("BEAM * S<sub>6</sub>","SINGLE_COUNTS_0_6");
  putTable2("BEAM * S<sub>7</sub>","SINGLE_COUNTS_0_7");
  putTable2("GC<sub>1</sub> * GC<sub>2</sub>","SINGLE_COUNTS_0_8");
  putTable2("BEAM * GC<sub>1</sub> * GC<sub>2</sub>","SINGLE_COUNTS_0_9");

  putTable2("Trigger (NO VETO)","SINGLE_COUNTS_0_10");
  putTable2("Trigger (VETO)","SINGLE_COUNTS_0_11");
  putTable2("CLK 1","SINGLE_COUNTS_1_0");
  putTable2("CLK 2","SINGLE_COUNTS_1_1");
  putTable2("CLK 2(NO VETO)","SINGLE_COUNTS_1_2");
  putTable2("Xenon","SINGLE_COUNTS_1_3");

  putText("</table></td></tr>");
  putText("</font>");

  putText("</font>");

  return (0);

}


KInt T473RunSummary::putHistoInfo( ){

  putText("<font color =\"darkred\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Histogram Information");
  putText("</h2>");
  //  CsI ADC 

  putText("<table><tr><td>");

  putText("<table border = 5 >");
  putText("<td>");
  putText("<table border = 5 >");
  putText("<caption>CsI ADC</caption>");
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
  putText("<td>");
  putText("21<br>");
  putValue("CSI_ADC_NO:21_PEAK");  putText("<br>");
  putValue("CSI_ADC_NO:21_MEAN");  putText("<br>");
  putValue("CSI_ADC_NO:21_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:21_STAN");  putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("22<br>");
  putValue("CSI_ADC_NO:22_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:22_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:22_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:22_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("23<br>");
  putValue("CSI_ADC_NO:23_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:23_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:23_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:23_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("24<br>");
  putValue("CSI_ADC_NO:24_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:24_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:24_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:24_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("25<br>");
  putValue("CSI_ADC_NO:25_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:25_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:25_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:25_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 2
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
putText("\n");
  putText("</td>");
  putText("<td>");
  putText("16<br>");
  putValue("CSI_ADC_NO:16_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:16_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:16_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:16_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("17<br>");
  putValue("CSI_ADC_NO:17_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:17_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:17_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:17_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("18<br>");
  putValue("CSI_ADC_NO:18_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:18_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:18_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:18_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("19<br>");
  putValue("CSI_ADC_NO:19_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:19_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:19_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:19_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("20<br>");
  putValue("CSI_ADC_NO:20_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:20_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:20_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:20_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 3
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("\n");
  putText("</td>");
  putText("<td>");
  putText("11<br>");
  putValue("CSI_ADC_NO:11_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:11_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:11_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:11_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("12<br>");
  putValue("CSI_ADC_NO:12_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:12_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:12_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:12_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("13<br>");
  putValue("CSI_ADC_NO:13_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:13_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:13_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:13_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("14<br>");
  putValue("CSI_ADC_NO:14_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:14_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:14_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:14_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("15<br>");
  putValue("CSI_ADC_NO:15_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:15_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:15_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:15_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 4
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("\n");
  putText("</td>");
  putText("<td>");
  putText("6<br>");
  putValue("CSI_ADC_NO:6_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:6_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:6_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:6_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("7<br>");
  putValue("CSI_ADC_NO:7_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:7_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:7_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:7_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("8<br>");
  putValue("CSI_ADC_NO:8_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:8_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:8_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:8_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("9<br>");
  putValue("CSI_ADC_NO:9_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:9_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:9_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:9_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("10<br>");
  putValue("CSI_ADC_NO:10_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:10_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:10_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:10_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 5
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
putText("\n");
  putText("</td>");
  putText("<td>");
  putText("1<br>");
  putValue("CSI_ADC_NO:1_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:1_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:1_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:1_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("2<br>");
  putValue("CSI_ADC_NO:2_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:2_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:2_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:2_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("3<br>");
  putValue("CSI_ADC_NO:3_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:3_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:3_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:3_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("4<br>");
  putValue("CSI_ADC_NO:4_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:4_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:4_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:4_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("5<br>");
  putValue("CSI_ADC_NO:6_PEAK");putText("<br>");
  putValue("CSI_ADC_NO:6_MEAN");putText("<br>");
  putValue("CSI_ADC_NO:6_VARI");  putText("<br>");
  putValue("CSI_ADC_NO:6_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 6
  putText("</table></td></table>");

  putText("</td><td>");
  //  CsI ADC  xenon

  putText("<table border = 5 >");
  putText("<td>");
  putText("<table border = 5 >");
  putText("<caption>CsI ADC Xenon Trigger</caption>");
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
putText("\n");
  putText("</td>");
  putText("<td>");
  putText("21<br>");
  putValue("CSI_ADC_XENON_NO:21_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:21_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:21_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:21_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("22<br>");
  putValue("CSI_ADC_XENON_NO:22_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:22_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:22_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:22_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("23<br>");
  putValue("CSI_ADC_XENON_NO:23_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:23_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:23_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:23_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("24<br>");
  putValue("CSI_ADC_XENON_NO:24_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:24_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:24_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:24_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("25<br>");
  putValue("CSI_ADC_XENON_NO:25_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:25_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:25_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:25_STAN");putText("<br>");

  putText("</td>");
  putText("</tr>");        // 2
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
  putText("\n");
  putText("<td>");
  putText("16<br>");
  putValue("CSI_ADC_XENON_NO:16_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:16_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:16_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:16_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("17<br>");
  putValue("CSI_ADC_XENON_NO:17_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:17_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:17_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:17_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("18<br>");
  putValue("CSI_ADC_XENON_NO:18_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:18_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:18_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:18_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("19<br>");
  putValue("CSI_ADC_XENON_NO:19_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:19_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:19_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:19_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("20<br>");
  putValue("CSI_ADC_XENON_NO:20_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:20_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:20_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:20_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 3
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
  putText("\n");
  putText("<td>");
  putText("11<br>");
  putValue("CSI_ADC_XENON_NO:11_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:11_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:11_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:11_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("12<br>");
  putValue("CSI_ADC_XENON_NO:12_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:12_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:12_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:12_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("13<br>");
  putValue("CSI_ADC_XENON_NO:13_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:13_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:13_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:13_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("14<br>");
  putValue("CSI_ADC_XENON_NO:14_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:14_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:14_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:14_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("15<br>");
  putValue("CSI_ADC_XENON_NO:15_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:15_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:15_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:15_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 4
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
putText("\n");
  putText("<td>");
  putText("6<br>");
  putValue("CSI_ADC_XENON_NO:6_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:6_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:6_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:6_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("7<br>");
  putValue("CSI_ADC_XENON_NO:7_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:7_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:7_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:7_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("8<br>");
  putValue("CSI_ADC_XENON_NO:8_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:8_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:8_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:8_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("9<br>");
  putValue("CSI_ADC_XENON_NO:9_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:9_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:9_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:9_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("10<br>");
  putValue("CSI_ADC_XENON_NO:10_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:10_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:10_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:10_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 5
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
putText("\n");
  putText("</td>");
  putText("<td>");
  putText("1<br>");
  putValue("CSI_ADC_XENON_NO:1_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:1_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:1_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:1_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("2<br>");
  putValue("CSI_ADC_XENON_NO:2_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:2_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:2_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:2_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("3<br>");
  putValue("CSI_ADC_XENON_NO:3_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:3_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:3_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:3_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("4<br>");
  putValue("CSI_ADC_XENON_NO:4_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:4_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:4_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:4_STAN");putText("<br>");
  putText("</td>");
  putText("<td>");
  putText("5<br>");
  putValue("CSI_ADC_XENON_NO:5_PEAK");putText("<br>");
  putValue("CSI_ADC_XENON_NO:5_MEAN");putText("<br>");
  putValue("CSI_ADC_XENON_NO:5_VARI");  putText("<br>");
  putValue("CSI_ADC_XENON_NO:5_STAN");putText("<br>");
  putText("</td>");
  putText("</tr>");        // 6
  putText("</table></td></table>");

  putText("</td></tr></table>");
  //////////////////////////////////
  // Scin 
  //////////////////////////////////
  putText("<br>");

  putText("<table border = 5 >");
  putText("<td>");
  putText("<table border = 5 >");
  putText("<caption>Scintillator and Gas Cherenkov ADC </caption>");
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
putText("\n");
  putText("</td>");
  putText("<td>");
  putText("S<sub>1</sub>L<br>");
  putValue("SCIN_ADC_NO:0_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:0_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:0_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:0_STAN");putText("<br>");


  putText("</td>");
  putText("<td>");
  putText("S<sub>1</sub>R<br>");
  putValue("SCIN_ADC_NO:1_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:1_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:1_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:1_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("S<sub>2</sub><br>");
  putValue("SCIN_ADC_NO:2_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:2_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:2_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:2_STAN");putText("<br>");


  putText("</td>");
  putText("<td>");
  putText("S<sub>3<br>");
  putValue("SCIN_ADC_NO:3_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:3_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:3_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:3_STAN");putText("<br>");

  putText("</td>");
  putText("<td>");
  putText("S<sub>4</sub><br>");
  putValue("SCIN_ADC_NO:4_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:4_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:4_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:4_STAN");putText("<br>");
  putText("</td>");

  putText("</td>");
  putText("</tr>");        // 2
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
  putText("\n");

  putText("<td>");
  putText("S<sub>5</sub><br>");
  putValue("SCIN_ADC_NO:5_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:5_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:5_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:5_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("S<sub>6<br>");
  putValue("SCIN_ADC_NO:6_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:6_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:6_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:6_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("S<sub>7<br>");
  putValue("SCIN_ADC_NO:7_PEAK");putText("<br>");
  putValue("SCIN_ADC_NO:7_MEAN");putText("<br>");
  putValue("SCIN_ADC_NO:7_VARI");putText("<br>");
  putValue("SCIN_ADC_NO:7_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("GC<sub>1</sub><br>");
  putValue("CHERENKOV_ADC_NO:1_PEAK");putText("<br>");
  putValue("CHERENKOV_ADC_NO:1_MEAN");putText("<br>");
  putValue("CHERENKOV_ADC_NO:1_VARI");putText("<br>");
  putValue("CHERENKOV_ADC_NO:1_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("GC<sub>1</sub><br>");
  putValue("CHERENKOV_ADC_NO:2_PEAK");putText("<br>");
  putValue("CHERENKOV_ADC_NO:2_MEAN");putText("<br>");
  putValue("CHERENKOV_ADC_NO:2_VARI");putText("<br>");
  putValue("CHERENKOV_ADC_NO:2_STAN");putText("<br>");
  putText("</td>");

  putText("</tr>");        // 3
  putText("<tr>");                   // start 1 
  putText("<td>");
  putText("number<br>Peak<br>Mean<br>Variance<br>StandardDeviation<br>");
  putText("</td>");
  putText("\n");

  putText("<td>");
  putText("Xenon 1<br>");
  putValue("XENON_SCIN_ADC_NO:1_PEAK");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:1_MEAN");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:1_VARI");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:1_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("Xenon 2<br>");
  putValue("XENON_SCIN_ADC_NO:2_PEAK");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:2_MEAN");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:2_VARI");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:2_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("Xenon 3<br>");
  putValue("XENON_SCIN_ADC_NO:3_PEAK");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:3_MEAN");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:3_VARI");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:3_STAN");putText("<br>");
  putText("</td>");

  putText("<td>");
  putText("Xenon 4<br>");
  putValue("XENON_SCIN_ADC_NO:4_PEAK");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:4_MEAN");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:4_VARI");putText("<br>");
  putValue("XENON_SCIN_ADC_NO:4_STAN");putText("<br>");
  putText("</td>");

  putText("</table></td></table>");




  putText("</td>");
  putText("</tr>");
  putText("</table>");

  putText("</center>");
  return (0);

}

KInt T473RunSummary::putPedestalInfo( ){

  putText("<font color =\"brown\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Pedestal Information");
  putText("</h2>");

  putText("<table border = 1><tr><td>");

  putText("<table border = 1>");
  putText("<font size = 3>");
  putText("\n");  putText("\n");
  putText("<tr>");
  putText("<th>");
  putText("<font size = 4>");
  putText("Number of CsI");
  putText("</th>");
  putText("<th>");
  putText("ADC pedestal");
  putText("</th>");
  putText("<th>");
  putText("TDC pedestal");
  putText("</th>");
  putText("</font>");
  putText("</tr>");
  putTable3("CsI No1","CSI_ADC_0_0_PED","CSI_TDC_0_0_PED");
  putTable3("CsI No2","CSI_ADC_0_1_PED","CSI_TDC_0_1_PED");
  putTable3("CsI No3","CSI_ADC_0_2_PED","CSI_TDC_0_2_PED");
  putTable3("CsI No4","CSI_ADC_0_3_PED","CSI_TDC_0_3_PED");
  putTable3("CsI No5","CSI_ADC_0_4_PED","CSI_TDC_0_4_PED");
  putTable3("CsI No6","CSI_ADC_0_5_PED","CSI_TDC_0_5_PED");
  putTable3("CsI No7","CSI_ADC_0_6_PED","CSI_TDC_0_6_PED");
  putTable3("CsI No8","CSI_ADC_0_7_PED","CSI_TDC_0_7_PED");
  putTable3("CsI No9","CSI_ADC_0_8_PED","CSI_TDC_1_0_PED");
  putTable3("CsI No10","CSI_ADC_0_9_PED","CSI_TDC_1_1_PED");
  putText("</table>");


  putText("</td><td>");

  putText("<table border = 1>");
  putText("<font size = 3>");
  putText("\n");  putText("\n");
  putText("<tr>");
  putText("<th>");
  putText("<font size = 4>");
  putText("Number of CsI");
  putText("</th>");
  putText("<th>");
  putText("ADC pedestal");
  putText("</th>");
  putText("<th>");
  putText("TDC pedestal");
  putText("</th>");
  putText("</font>");
  putText("</tr>");

  putTable3("CsI No11","CSI_ADC_0_10_PED","CSI_TDC_1_2_PED");
  putTable3("CsI No12","CSI_ADC_0_11_PED","CSI_TDC_1_3_PED");
  putTable3("CsI No13","CSI_ADC_0_12_PED","CSI_TDC_1_4_PED");
  putTable3("CsI No14","CSI_ADC_0_13_PED","CSI_TDC_1_5_PED");
  putTable3("CsI No15","CSI_ADC_0_14_PED","CSI_TDC_1_6_PED");
  putTable3("CsI No16","CSI_ADC_0_15_PED","CSI_TDC_1_7_PED");
  putTable3("CsI No17","CSI_ADC_1_0_PED","CSI_TDC_2_0_PED");
  putTable3("CsI No18","CSI_ADC_1_1_PED","CSI_TDC_2_1_PED");
  putTable3("CsI No19","CSI_ADC_1_2_PED","CSI_TDC_2_2_PED");
  putTable3("CsI No20","CSI_ADC_1_3_PED","CSI_TDC_2_3_PED");
  putText("</table>");


  putText("</td><td>");

  putText("<table border = 1>");
  putText("<font size = 3>");
  putText("\n");  putText("\n");
  putText("<tr>");
  putText("<th>");
  putText("<font size = 4>");
  putText("Number of CsI");
  putText("</th>");
  putText("<th>");
  putText("ADC pedestal");
  putText("</th>");
  putText("<th>");
  putText("TDC pedestal");
  putText("</th>");
  putText("</font>");
  putText("</tr>");

  putTable3("CsI No21","CSI_ADC_1_4_PED","CSI_TDC_2_4_PED");
  putTable3("CsI No22","CSI_ADC_1_5_PED","CSI_TDC_2_5_PED");
  putTable3("CsI No23","CSI_ADC_1_6_PED","CSI_TDC_2_6_PED");
  putTable3("CsI No24","CSI_ADC_1_7_PED","CSI_TDC_2_7_PED");
  putTable3("CsI No25","CSI_ADC_1_8_PED","CSI_TDC_3_0_PED");
  for( KInt i = 0 ; i < 5 ; i++){
    putText("\n");
    putText("<tr>");
    putText("<th>");
    putText("*");
    putText("</th>");
    putText("<th>");
    putText("*");
    putText("</th>");
    putText("<th>");
    putText("*");
    putText("</th>");
    putText("</tr>");
  }


  putText("</table>");
  putText("</font>");
  putText("</font>");
  
  putText("</td></tr></table>");

}

KInt T473RunSummary::putLogInfo( ){

  KChar buffer[65535];
  KChar filename[256];
  KChar * ptr;

  if( !(ext->getKCharValue("LOGFILE_NAME") == (KChar*)-1) ){
	if( getenv("T473_LOGGER_DIR") ){
  		strcpy(filename,getenv("T473_LOGGER_DIR"));
		strcat(filename,"/");
		strcat(filename,ext->getKCharValue("LOGFILE_NAME"));
	}
	else{
		strcpy(filename,ext->getKCharValue("LOGFILE_NAME"));
		
	}

  } else {
	return -1;
  }

  KonoeInputFile	*ifile = new KonoeInputFile( filename ) ;  

  putText("<font color =\"orange\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Process Logger Information");
  putText("</h2>");
  putText("<font size = 3 color = \"black\">");

  ifile->get(buffer,65535);
  putText("<pre>");
  putText(buffer);
  putText("</pre>");
  putText("</font>");

  delete ifile ;
  ifile = 0;

  return (0);
}

KInt T473RunSummary::putComment(KChar* comment ){

  putText("<font color =\"darkgreen\" size = 3>");
  putText("\n");
  putText("<hr>");
  putText("<h2>");
  putText("Comment");
  putText("</h2>");
  putText("<font size = 3 color = \"black\">");
  putText("<pre>");
  putText(comment);
  putText("</pre>");
  putText("</font>");
  return (0);
}

KInt T473RunSummary::putValue(KChar* itemname){
  putText("<font color =\"blue\" size = 3>");
  KChar * text;
  text = ext->getKCharValue(itemname);
  if( text ==(KChar*)-1)
    file->writeToStream("not define",strlen("not define"));
  else
    file->writeToStream(text,strlen(text));
  putText("</font>");
  return (0);
}

KInt T473RunSummary::putText(KChar* text){
  file->writeToStream(text,strlen(text));
  return (0);
}

KInt T473RunSummary::putTable2(KChar* text,KChar* itemname){
  putText("\n");
  putText("<tr>");
  putText("<th width = 300>");
  putText(text);
  putText("</th>");
  putText("<th width = 300>");
  putValue(itemname);
  putText("</th>");
  putText("</tr>");
    
  return (0);
}

KInt T473RunSummary::putTable3(KChar* text,KChar* itemname, KChar* itemname2){
  putText("\n");
  putText("<tr>");
  putText("<th>");
  putText(text);
  putText("</th>");
  putText("<th>");
  putValue(itemname);
  putText("</th>");
  putText("<th>");
  putValue(itemname2);
  putText("</th>");
  putText("</tr>");
    
  return (0);
}




