//=====================================================================
/*

    T473Boot.hh

    Version 0.0.1   07-Dec-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473BOOT_HH
#define __T473BOOT_HH

#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>

class KonoeTclWindow;
class KonoeTclSubWindow;
class T473MsgBox;
class T473Progress;
class T473ConfirmDialog;

class T473Boot : public KonoeTclEventProcessor,
                 public KonoeTclMouseAction,
                 public KonoeTclTimer {

  public:
    T473Boot(KonoeTclWindow* pwin);
    ~T473Boot();

    KInt loggerBoot();
    KInt dataHubBoot();
    KInt daqBoot();
    KInt histogramBoot();
    KInt reconstructBoot();

  private:
    void execute();
    void shutdown();

    void mouseAction(KonoeTclButton* kbtn, KInt type, KInt button,
                                           Time time, KInt x, KInt y);
    void timer();

    KonoeTclWindow* kwin;
    KonoeTclSubWindow* sub;
    KonoeTclButton* bootButton;
    KonoeTclButton* stopButton;

    T473Progress* bar;
    T473MsgBox*   msgBox;

    KChar* value;
    KInt   percent;
    KInt   cmd_port;
};

#endif
