//=====================================================================
/*

    T473Kill.cc

    Version 0.0.1   10-Dec-2000 T. Hosoi

*/
//====================================================================

#include <T473Kill.hh>
#include <system/KonoeSignalSender.hh>

#include <stdio.h>
#include <string.h>

T473Kill::T473Kill()
{
  killer = new KonoeSignalSender(nsExtractor.getKIntValue("SIGNAL_PORT"));
}

T473Kill::~T473Kill()
{
  delete killer;
}

KInt T473Kill::killDAQ()
{
  KInt daq_pid;
  KChar* daq_host;
  KChar cpid[16];

  daq_pid = nsExtractor.getKIntValue("DAQ_PID");
  daq_host = nsExtractor.getKCharValue("DAQ_HOST");

  if( daq_pid != -1 ){
    cout << "DAQ_PID = "<< daq_pid << endl;

    daq_pid = nsExtractor.getKIntValue("DAQ_PID");
    sprintf(cpid, "%d", daq_pid);

    cout << "killer->kill(" << daq_host << "," << daq_pid
         << "," << SIGKILL << ")" << endl;

    killer->kill(daq_host,daq_pid,SIGKILL);

    FILE* ofile;
    KChar cmd[256];

    sprintf(cmd, "ssh %s ps auwx | grep T473daq", daq_host);
    if((ofile = popen(cmd, "r")) != NULL){
      while(fgets(cmd, 256, ofile) != NULL){
        if(strstr(cmd, "T473daq") != NULL && 
           strstr(cmd, cpid) != NULL && strstr(cmd, "grep") == NULL){
          pclose(ofile);
          return 0;
        }
      }
    }
    pclose(ofile);

    nsSetter.set("DAQ_PID", "-1");
    nsSetter.set("DAQ_STATUS", "none");

    return 1;
  }
  else {
    cout <<"DAQ_PID is not defined"<<endl;
    return 0;
  }
}

KInt T473Kill::killDataHub()
{
  KInt datahub_pid;
  KChar* datahub_host;
  KChar cpid[16];

  datahub_pid = nsExtractor.getKIntValue("DATAHUB_PID");
  datahub_host = nsExtractor.getKCharValue("DATAHUB_HOST");

  if( datahub_pid != -1 ){
    cout << "DATAHUB_PID = "<< datahub_pid << endl;

    datahub_pid = nsExtractor.getKIntValue("DATAHUB_PID");
    sprintf(cpid, "%d", datahub_pid);

    cout << "killer->kill(" << datahub_host << "," << datahub_pid
         << "," << SIGKILL << ")" << endl;

    killer->kill(datahub_host,datahub_pid,SIGKILL);

    FILE* ofile;
    KChar cmd[256];

    sprintf(cmd, "ssh %s ps auwx | grep T473DataHub", datahub_host);
    if((ofile = popen(cmd, "r")) != NULL){
      while(fgets(cmd, 256, ofile) != NULL){
        if(strstr(cmd, "T473DataHub") != NULL &&
           strstr(cmd, cpid) != NULL && strstr(cmd, "grep") == NULL){
          pclose(ofile);
          return 0;
        }
      }
    }
    pclose(ofile);

    nsSetter.set("DATAHUB_PID", "-1");
    nsSetter.set("DATAHUB_STATUS", "none");

    return 1;
  }
  else {
    cout <<"DATAHUB_PID is not defined"<<endl;
    return 0;
  }
}

KInt T473Kill::killHistogram()
{
  KInt histo_pid;
  KChar* histo_host;
  KChar cpid[16];

  histo_pid = nsExtractor.getKIntValue("HISTOGRAM_PID");
  histo_host= nsExtractor.getKCharValue("HISTOGRAM_HOST");

  if( histo_pid != -1 ){
    cout << "HISTOGRAM_PID = "<< histo_pid << endl;

    histo_pid= nsExtractor.getKIntValue("HISTOGRAM_PID");
    sprintf(cpid, "%d", histo_pid);

    cout << "killer->kill(" << histo_host << "," << histo_pid
         << "," << SIGKILL << ")" << endl;

    killer->kill(histo_host,histo_pid,SIGKILL);

    FILE* ofile;
    KChar cmd[256];

    sprintf(cmd, "ssh %s ps auwx | grep T473histogram", histo_host);
    if((ofile = popen(cmd, "r")) != NULL){
      while(fgets(cmd, 256, ofile) != NULL){
        if(strstr(cmd, "T473histogram") != NULL &&
           strstr(cmd, cpid) != NULL &&  strstr(cmd, "grep") == NULL){
          pclose(ofile);
          return 0;
        }
      }
    }
    pclose(ofile);

    nsSetter.set("HISTOGRAM_PID", "-1");
    nsSetter.set("HISTOGRAM_STATUS", "none");

    return 1;
  }
  else {
    cout <<"HISTOGRAM_PID is not defined"<<endl;
    return 0;
  }
}

KInt T473Kill::killReconstruct()
{
  KInt recons_pid;
  KChar* recons_host;
  KChar cpid[16];

  recons_pid = nsExtractor.getKIntValue("RECONSTRUCT_PID");
  recons_host = nsExtractor.getKCharValue("RECONSTRUCT_HOST");

  if( recons_pid != -1 ){
    cout << "RECONSTRUCT_PID = "<< recons_pid << endl;

    recons_pid = nsExtractor.getKIntValue("RECONSTRUCT_PID");
    sprintf(cpid, "%d", recons_pid);

    cout << "killer->kill(" << recons_host << "," << recons_pid
         << "," << SIGKILL << ")" << endl;
    killer->kill(recons_host,recons_pid,SIGKILL);

    FILE* ofile;
    KChar cmd[256];

    sprintf(cmd, "ssh %s ps auwx | grep T473reconstruct", recons_host);
    if((ofile = popen(cmd, "r")) != NULL){
      while(fgets(cmd, 256, ofile) != NULL){
        if(strstr(cmd, "T473reconstruct") != NULL &&
           strstr(cmd, cpid) != NULL && strstr(cmd, "grep") == NULL){
          pclose(ofile);
          return 0;
        }
      }
    }
    pclose(ofile);

    nsSetter.set("RECONSTRUCT_PID", "-1");
    nsSetter.set("RECONSTRUCT_STATUS", "none");

    return 1;
  }
  else {
    cout <<"RECONSTRUTCT_PID is not defined"<<endl;
    return 0;
  }
}

KInt T473Kill::killLogger()
{
  KInt logger_pid;
  KChar* logger_host;
  KChar cpid[16];

  logger_pid = nsExtractor.getKIntValue("LOGGER_PID");
  logger_host= nsExtractor.getKCharValue("LOGGER_HOST");

  if( logger_pid != -1 ){
    cout << "LOGGER_PID = "<< logger_pid << endl;

    logger_pid = nsExtractor.getKIntValue("LOGGER_PID");
    sprintf(cpid, "%d", logger_pid);

    cout << "killer->kill(" << logger_host << "," << logger_pid
         << "," << SIGKILL<<")"<<endl;

    killer->kill(logger_host,logger_pid,SIGKILL);

    FILE* ofile;
    KChar cmd[256];

    sprintf(cmd, "ssh %s ps auwx | grep T473logger", logger_host);
    if((ofile = popen(cmd, "r")) != NULL){
      while(fgets(cmd, 256, ofile) != NULL){
        if(strstr(cmd, "T473logger") != NULL &&
           strstr(cmd, cpid) != NULL && strstr(cmd, "grep") == NULL){
          pclose(ofile);
          return 0;
        }
      }
    }
    pclose(ofile);

    nsSetter.set("LOGGER_PID", "-1");
    nsSetter.set("LOGGER_STATUS", "none");

    return 1;
  }
  else {
    cout <<"LOGGER_PID is not defined"<<endl;
    return 0;
  }
}
