//=====================================================================
/*

    T473TclNameSpaceViewer.hh

    Version 0.0.1   19-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __T473TCLNAMESPACEVIEWER_HH
#define __T473TCLNAMESPACEVIEWER_HH

#include <Namespace/T473NameSpaceExtractor.hh>
#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclWindow.hh>

class T473TclNameSpaceViewerAction;

enum {ItemCount = 173};

class T473TclNameSpaceViewer : public KonoeTclEventProcessor,
                                public KonoeTclTimer {

  public:
    T473TclNameSpaceViewer(KonoeTclWindow* pwin);
    ~T473TclNameSpaceViewer();

    void insertNameSpaceItem();
    void timer();

    KonoeTclEntry* getItemNameEntry() {return itemNameEntry; }
    KonoeTclEntry* getValueEntry() { return valueEntry; }
    KonoeTclText*  getNameSpaceList() { return nameSpaceList; }
    KChar*         getItem(KInt i);
    KChar*         getValue(KInt i);
  private:
    void initWidget();
    void initNameSpaceItem();


    T473NameSpaceExtractor* nsExtractor;
    T473TclNameSpaceViewerAction* nsViewAction;

    KChar fontName[64];
    KInt  fontSize;
    KonoeTclWindow* kwin;

    KonoeTclText* nameSpaceList;

    KonoeTclFrame* buttonFrame;
    KonoeTclLabel* itemNameLabel;
    KonoeTclLabel* valueLabel;
    KonoeTclEntry* itemNameEntry;
    KonoeTclEntry* valueEntry;
    KonoeTclButton* setButton;

    KChar* nsItem[ItemCount];
    KChar nsValue[ItemCount][128];
};

#endif
