//=====================================================================
/*

    T473TclNameSpaceViewerAction.cc

    Version 0.0.1   19-Nov-2000 T. Hosoi

*/
//====================================================================

#include <T473TclNameSpaceViewerAction.hh>

T473TclNameSpaceViewerAction::T473TclNameSpaceViewerAction
                              (T473TclNameSpaceViewer* pnsViewer)
{
  nsViewer = pnsViewer;
  nameSpaceList = nsViewer->getNameSpaceList();
  nsSetter = new T473NameSpaceSetter;
  itemNameEntry = nsViewer->getItemNameEntry();
  valueEntry = nsViewer->getValueEntry();
  selectedItemIndex = 0;
}

T473TclNameSpaceViewerAction::~T473TclNameSpaceViewerAction()
{
  delete nsSetter;
}

void T473TclNameSpaceViewerAction::mouseAction(KonoeTclButton* kbtn, KInt type,
                                        KInt button, Time time, KInt x, KInt y)
{
  KChar* itemName = itemNameEntry->getText();
  KChar* value = valueEntry->getText();

  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){
      if( strlen( itemName ) &&  strlen( value ) )
        nsSetter->set(itemName, value);
        //nsViewer->insertNameSpaceItem();
    }
  }
}

void T473TclNameSpaceViewerAction::mouseAction(KonoeTclEntry* kbtn, KInt type,
                                        KInt button, Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){
      kbtn->selectAll();
    }
  }
}

void T473TclNameSpaceViewerAction::mouseAction(KonoeTclText* bt, KInt type,
                                       KInt button, Time time, KInt x, KInt y)
{
  static KInt t = 0;
  if(type == KMousePress && button == LButton){
    t = time;
  }
  if(type == KMouseRelease && button == LButton){
  if( 0<=x && x<bt->getWidth() && 0<=y && y<=bt->getHeight()){
  if( time - t < 300){
    selectedItemIndex =  (KInt)nameSpaceList->index("insert");
    KInt i = selectedItemIndex;
    //cout << "Item : " << nsViewer->getItem(i) << " , " 
    //     << "Value : " << nsViewer->getValue(i) << endl;
    itemNameEntry->setText( nsViewer->getItem(i) );
    valueEntry->setText( nsViewer->getValue(i) );
  }
  }
  }
}

void T473TclNameSpaceViewerAction::keyAction(KonoeTclEntry* kbt, KInt type,
                                                    KeySym keysym, KInt state)
{
  if(type == KKeyRelease){
    if(keysym == XK_KP_Enter || keysym == XK_Return){
        KChar* itemName = itemNameEntry->getText();
        KChar* value = valueEntry->getText();
 
        nsSetter->set(itemName, value);
      if(state == KeyShift){
        selectedItemIndex -= 1;
        if(selectedItemIndex < 0) selectedItemIndex = 0;

        KInt i = selectedItemIndex;

        itemNameEntry->setText( nsViewer->getItem(i) );
        valueEntry->setText( nsViewer->getValue(i) );

        valueEntry->selectAll();

        nameSpaceList->scrollOneUnitToTop();
        nsViewer->timer();
      }
      else if( state == 0){
        selectedItemIndex += 1;

        KInt i = selectedItemIndex;

        itemNameEntry->setText( nsViewer->getItem(i) );
        valueEntry->setText( nsViewer->getValue(i) );

        valueEntry->selectAll();

        nameSpaceList->scrollOneUnitToBottom();
        nsViewer->timer();
      }
    }
  }
}
