//====================================================================
/*

	KonoeCategories.hh

	Version 0.1.1	16-Oct-1997	H. Sakamoto
	Version 0.1.2	30-Oct-1997	H. Sakamoto
		histogram added.
	Version 0.1.3	11-Dec-1997	H. Sakamoto
		namespace added.
	Version 0.2.0	15-Apr-1998	H. Kamata
		message category added.
	Version 0.2.1	 6-Jun-1998	H. Sakamoto
		systemlogger added
	Version 0.4.0	 7-Sep-1998	S. Enomoto

	Table of KONOE class category IDs

*/
//====================================================================

#ifndef	__KONOECATEGORIES_HH
#define	__KONOECATEGORIES_HH

class	KonoeCategories	{

public :
	enum	{	PRIMITIVE_TYPE_BASE	= 0x00000000,
			SYSTEM_CATEGORY_BASE	= 0x00200000,
			DAQ_CATEGORY_BASE	= 0x00400000,
			ANALYSIS_CATEGORY_BASE	= 0x00600000,
			UI_CATEGORY_BASE	= 0x00800000,
			USER_CATEGORY_BASE	= 0x00a00000	};

// primitive type codes

	enum	{	PRIMITIVE	= 0x00000000,
			OBJECTARRAY	= 0x00010000	};

// system package category codes

	enum	{	OBJECTSTREAM	= 0x00210000,
			OBJECTFILE	= 0x00220000,
			OBJECTSOCKET	= 0x00230000,
			SYSTEMSERVICE	= 0x00240000,
			NAMESPACE	= 0x00250000,
			MESSAGESYSTEM	= 0x00260000,
			SYSTEMLOGGER	= 0x00270000,
			FILEMANAGER	= 0x00280000,	
			PROCESSMANAGER	= 0x00290000	};
			

// daq package category codes

	enum	{	DATASOURCE	= 0x00410000,
			DATALIST	= 0x00420000,
			XACTION		= 0x00430000,
			DAQPROCESS	= 0x00440000	};

// analysis package category codes

	enum	{	DATARECORD	= 0x00610000,
			PHYSICALVALUE	= 0x00620000,
			HISTOGRAM	= 0x00630000,
			GEOMETRY	= 0x00640000	};

// ui package category codes

	enum	{	CLI		= 0x00810000	};

};

#endif
