//===================================================================
/*

	Konoe2DHistogramOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Enomoto and S. Nishida
	Version 0.4.0	 5-Sep-1998	S. Nishida
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOE2DHISTOGRAMORDERLY_HH
#define	__KONOE2DHISTOGRAMORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/Konoe2DHistogram.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	Konoe2DHistogramOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::HISTOGRAM +
			KonoeHistogramCM::CID_2DHISTOGRAM	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_CLEAR,
			CMD_FILL,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_XSCALE,
			ARG_CREATE_YSCALE,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	N_ARG_CLEAR	};
	enum	{	ARG_FILL_OBJECT,
			N_ARG_FILL	};

protected :
	static const KChar	* classname;

	Konoe2DHistogram	* target;

	class	ClearUnit	: public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	FillUnit	: public KonoeCommandProcessor {
	public :
		FillUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	Konoe2DHistogramOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{ return ( void * ) target; }
	KInt    showTarget( KonoeCommand * command );

};


#endif
