//===================================================================
/*

	Konoe3VectorOrderly.cc

	Version 0.0.1	 6-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#include	<analysis/Konoe3VectorOrderly.hh>
#include	<ui/KonoeOfficer.hh>
#include	<ui/KonoeHelpCommand.hh>
#include	<ui/KonoeShowCommand.hh>
#include	<ui/KonoeCreateCommand.hh>

const KChar	* Konoe3VectorOrderly::classname = "3Vector";


Konoe3VectorOrderly::Konoe3VectorOrderly( const KChar * objname ) :
	KonoeOrderly( N_COMMANDS, objname ) {

	setClassID( CLASS_ID );

	KonoeCommandDescriptor	* cmd_descripter;
	cmd_descripter = new KonoeCommandDescriptor( "create", N_ARG_CREATE );
	cmd_descripter-> add(
		new KonoeArgumentDescriptor( "object", STRING, NECESSARY ) );
        cmd_descripter -> add(
                new KonoeArgumentDescriptor( "x", FLOATING, NECESSARY ) );
        cmd_descripter -> add(
                new KonoeArgumentDescriptor( "y", FLOATING, NECESSARY ) );
        cmd_descripter -> add(
                new KonoeArgumentDescriptor( "z", FLOATING, NECESSARY ) );
        addCommand( new KonoeCreateCommand( cmd_descripter, this ) );

	addCommand( new KonoeShowCommand( 0 , this ) );

	addCommand( new KonoeHelpCommand( 0, this ) );

}

KInt	Konoe3VectorOrderly::isOrderlyOf( void * address ) {

	return address == ( void * ) target;
}



KInt	Konoe3VectorOrderly::createObject( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

        KInt n_arg = cmd -> getArgumentCount( );

        KFloat x = cmd -> getArgument( ARG_CREATE_X ) -> toFloating( );
        KFloat y = cmd -> getArgument( ARG_CREATE_Y ) -> toFloating( );
        KFloat z = cmd -> getArgument( ARG_CREATE_Z ) -> toFloating( );
        target = new Konoe3Vector( x , y , z );

	return 0;

}

KInt	Konoe3VectorOrderly::deleteObject( KonoeCommand * ) {

	delete target;

	return 0;

}

KInt    Konoe3VectorOrderly::showTarget( KonoeCommand * cmd ){

	ostream & os = cmd -> getOutputStream( );
	target -> dump( os );
	return 0;
}


KonoeOrderly	* Konoe3VectorOrderly::clone( const KChar * name ) {

	return new Konoe3VectorOrderly( name );

}
