//===================================================================
/*

	Konoe3VectorOrderly.hh

	Version 0.0.1	 6-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida 

*/
//===================================================================

#ifndef	__KONOE3VECTORORDERLY_HH
#define	__KONOE3VECTORORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<analysis/Konoe3Vector.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeGeometryCM.hh>

class	Konoe3VectorOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::GEOMETRY +
			KonoeGeometryCM::CID_3VECTOR	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_FILL,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_X,
                        ARG_CREATE_Y,
			ARG_CREATE_Z,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	N_ARG_CLEAR	};

protected :
	static const KChar	* classname;

	Konoe3Vector	* target;

public :
	Konoe3VectorOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};

#endif








