//===================================================================
/*

	KonoeBoxGeometryOrderly.hh

	Version 0.0.1	 6-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEBOXGEOMETRYORDERLY_HH
#define	__KONOEBOXGEOMETRYORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<analysis/KonoeBoxGeometry.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeGeometryCM.hh>

class	KonoeBoxGeometryOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::GEOMETRY +
			KonoeGeometryCM::CID_BOXGEOMETRY	};

	enum	{	CMD_CREATE,
			CMD_TRANSLATE,
			CMD_SHOW,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_WIDTH,
                        ARG_CREATE_HEIGHT,
			ARG_CREATE_DEPTH,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{ 	ARG_TRANSLATE_OBJECT,
			ARG_TRANSLATE_TRANSLATION,
			N_ARG_TRANSLATE	};
	enum	{	N_ARG_CLEAR	};

protected :
	static const KChar	* classname;

	KonoeBoxGeometry	* target;
	class TranslateUnit : public KonoeCommandProcessor {
		public:
		TranslateUnit(KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt execute(KonoeCommand * command );
	};
public :
	KonoeBoxGeometryOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};

#endif








