//===================================================================
/*

	KonoeDataAnalyzerOrderly.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida
	Version 0.4.0	 5-Sep-1998
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDATAANALYZERORDERLY_HH
#define	__KONOEDATAANALYZERORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeDataAnalyzer.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoePhysicalValueCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeDataAnalyzerOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::PHYSICALVALUE +
			KonoePhysicalValueCM::CID_DATAANALYZER	};

	enum	{	CMD_CREATE,
			CMD_INSTALL,
			CMD_ANALYZE,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_MAXSECTION,
			N_ARG_CREATE	};
  enum	{	ARG_INSTALL_SECANA,
			N_ARG_INSTALL	};
	enum	{	ARG_ANALYZE_RECORD,
			N_ARG_ANALYZE	};

protected :
	static const KChar	* classname;

	KonoeDataAnalyzer	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	InstallUnit	: public KonoeCommandProcessor {
	public :
		InstallUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	AnalyzeUnit	: public KonoeCommandProcessor {
	public :
		AnalyzeUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeDataAnalyzerOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif








