//===================================================================
/*

	KonoeDataRecordOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Enomoto and S. Nishida
	Version 0.4.0	 5-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDATARECORDORDERLY_HH
#define	__KONOEDATARECORDORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeDataRecord.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeDataRecordCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeDataRecordOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::DATARECORD +
			KonoeDataRecordCM::CID_DATARECORD	};
	enum	{	CMD_CREATE,
			CMD_DELETE,
			CMD_SHOW,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_TABLESIZE,
			ARG_CREATE_TYPE,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_DELETE	};
	enum	{ 	N_ARG_SHOW	};

protected :
	static const KChar	* classname;

	KonoeDataRecord	* target;

	class	DeleteUnit	: public KonoeCommandProcessor {
	public :
		DeleteUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeDataRecordOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt	showTarget( KonoeCommand * cmd );
};


#endif
