//===================================================================
/*

	KonoeDefaultSectionAnalyzerOrderly.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida
	Version 0.4.0	 5-Sep-1998
	Version 0.5.0	21-Sep-1999	Y. Kouno
		analyze is not implemented !!
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDEFAULTSECTIONANALYZERORDERLY_HH
#define	__KONOEDEFAULTSECTIONANALYZERORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeDefaultSectionAnalyzer.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoePhysicalValueCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeDefaultSectionAnalyzerOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::HISTOGRAM +
			KonoePhysicalValueCM::CID_DEFAULTSECTIONANALYZER };

	enum	{	CMD_CREATE,
			CMD_CLEAR,
			//	CMD_ANALYSE,
			CMD_GETPHYSICALVALUE,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_SECTION,
			ARG_CREATE_TABLESIZE,
			ARG_CREATE_TAG,
			N_ARG_CREATE	};
	enum	{	N_ARG_CLEAR	};
//	enum	{	ARG_ANALIZE_SECTION,
//			N_ARG_ANALIZE	};
	enum	{	ARG_GETPHYSICALVALUE_VALUE,
			N_ARG_GETPHYSICALVALUE	};

protected :
	static const KChar	* classname;

	KonoeDefaultSectionAnalyzer	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ClearUnit	: public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

#if 0
	class	AnalizeUnit	: public KonoeCommandProcessor {
	public :
		AnalizeUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};
#endif
	class	GetPhysicalValueUnit	: public KonoeCommandProcessor {
	public :
		GetPhysicalValueUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};


public :
	KonoeDefaultSectionAnalyzerOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
