//===================================================================
/*

	KonoeDetectorElementOrderly.hh

	Version 0.0.1	 7-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDETECTORELEMENTORDERLY_HH
#define	__KONOEDETECTORELEMENTORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<analysis/KonoeDetectorElement.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeGeometryCM.hh>

class	KonoeDetectorElementOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::GEOMETRY +
			KonoeGeometryCM::CID_DETECTORELEMENT	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_INTERACT,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_CLASSID,
			N_ARG_CREATE	};
	enum 	{	ARG_CREATE2_OBJECT,
			ARG_CREATE2_GEOMETRY,
			ARG_CREATE2_DETECTOR,
			ARG_CREATE2_IDENTIFIER,
			N_ARG_CREATE2 };
	enum	{ 	N_ARG_SHOW	};
	enum 	{	ARG_INTERACT_OBJECT,
			ARG_INTERACT_SEGMENT,
			N_ARG_INTERACT};
	enum	{	N_ARG_CLEAR	};

protected :
	static const KChar	* classname;

	KonoeDetectorElement	* target;
	
	class InteractUnit		: public KonoeCommandProcessor {
	public:
		InteractUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner);
		KInt execute(KonoeCommand * cmd );
	};
public :
	KonoeDetectorElementOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};

#endif








