//===================================================================
/*

	KonoeDetectorOrderly.hh

	Version 0.0.1	 7-Jun-2001	T. Matuo
	Version 0.7.0	26-Ayg-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDETECTORORDERLY_HH
#define	__KONOEDETECTORORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<analysis/KonoeDetector.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeGeometryCM.hh>

class	KonoeDetectorOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::GEOMETRY +
			KonoeGeometryCM::CID_DETECTOR	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_FIND,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_FIRST,
			ARG_CREATE_SECOND,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum 	{	ARG_FIND_OBJECT,
			ARG_FIND_SECTION,
			ARG_FIND_SEGMENT,
			ARG_FIND_SUBADDRESS,
			N_ARG_FIND};
	enum	{	N_ARG_CLEAR	};

protected :
	static const KChar	* classname;

	KonoeDetector	* target;
	
	class FindUnit		: public KonoeCommandProcessor {
	public:
		FindUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner);
		KInt execute(KonoeCommand * cmd );
	};
public :
	KonoeDetectorOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};

#endif








