//===================================================================
/*

	KonoeFillDataExtractorOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 5-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEFILLDATAEXTRACTORORDERLY_HH
#define	__KONOEFILLDATAEXTRACTORORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeFillDataExtractor.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeFillDataExtractorOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::HISTOGRAM +
			KonoeHistogramCM::CID_FILLDATAEXTRACTOR	};

	enum	{	CMD_CREATE,
			CMD_SETINDEX,
			CMD_SHOW,
			CMD_RESET,
	     //		CMD_GETDATACOUNT,
	     //		CMD_NEXT,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
	  		ARG_CREATE_VALUE,
			ARG_CREATE_NAME1,
			ARG_CREATE_NAME2,
			ARG_CREATE_NAME3,
			N_ARG_CREATE	};
	enum	{	ARG_SETINDEX_INDEX1,
			ARG_SETINDEX_INDEX2,
			ARG_SETINDEX_INDEX3,
			N_ARG_SETINDEX	};
	enum	{ 	N_ARG_SHOW	};
  	enum	{ 	N_ARG_RESET	};
  //	enum	{	N_ARG_GETDATACOUNT	};
  //	enum	{	ARG_NEXT_FILLDATA,
  //			N_ARG_NEXT	};

protected :
	static const KChar	* classname;

	KonoeFillDataExtractor	* target;

	class	SetIndexUnit	: public KonoeCommandProcessor {
	public :
		SetIndexUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ResetUnit	: public KonoeCommandProcessor {
	public :
		ResetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};
  /*
	class	GetDataCountUnit	: public KonoeCommandProcessor {
	public :
	        GetDataCountUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	NextUnit	: public KonoeCommandProcessor {
	public :
	        NextUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};
  */

public :
	KonoeFillDataExtractorOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};


#endif
