//===================================================================
/*

	KonoeFillDataOrderly.cc

	Version 0.0.1	 2-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 5-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#include	<analysis/KonoeFillDataOrderly.hh>
#include	<analysis/KonoeLinearDataScaleOrderly.hh>
#include	<ui/KonoeOfficer.hh>
#include	<ui/KonoeHelpCommand.hh>
#include	<ui/KonoeCreateCommand.hh>
#include	<ui/KonoeShowCommand.hh>

const KChar	* KonoeFillDataOrderly::classname = "FillData";


KonoeFillDataOrderly::KonoeFillDataOrderly( const KChar * objname ) :
	KonoeOrderly( N_COMMANDS, objname ) {

	setClassID( CLASS_ID );

	KonoeCommandDescriptor	* cmd_descripter;

	cmd_descripter = new KonoeCommandDescriptor( "create", N_ARG_CREATE );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "object", STRING, NECESSARY ) );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "x", FLOATING, NECESSARY ) );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "y", FLOATING, OPTIONAL ) );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "z", FLOATING, OPTIONAL ) );
	addCommand( new KonoeCreateCommand( cmd_descripter, this ) );

	addCommand( new KonoeShowCommand( 0, this ) );
	addCommand( new KonoeHelpCommand( 0, this ) );

}

KInt	KonoeFillDataOrderly::isOrderlyOf( void * address ) {

	return address == ( void * ) target;

}

KInt	KonoeFillDataOrderly::createObject( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

	KInt n_arg = cmd -> getArgumentCount( );

	KFloat x = cmd -> getArgument( ARG_CREATE_X ) -> toFloating( );
	if( n_arg == ARG_CREATE_X + 1 ){
	  target = new KonoeFillData( x );
	  return 0;
	}

	KFloat y = cmd -> getArgument( ARG_CREATE_Y ) -> toFloating( );
	if( n_arg == ARG_CREATE_Y + 1 ){
	  target = new KonoeFillData( x , y );
	  return 0;
	}

	KFloat z = cmd -> getArgument( ARG_CREATE_Z ) -> toFloating( );
	target = new KonoeFillData( x , y , z );
	return 0;

}

KInt	KonoeFillDataOrderly::deleteObject( KonoeCommand * ) {

	delete target;
	return 0;

}

KInt	KonoeFillDataOrderly::showTarget( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );
	target -> dump( os );
	return 0;
}

KonoeOrderly	* KonoeFillDataOrderly::clone( const KChar * name ) {

	return new KonoeFillDataOrderly( name );

}

