//===================================================================
/*

	KonoeFillDataOrderly.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida
	Version 0.4.0	 7-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEFILLDATAORDERLY_HH
#define	__KONOEFILLDATAORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeFillData.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeFillDataOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::HISTOGRAM +
			KonoeHistogramCM::CID_FILLDATA	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_X,
			ARG_CREATE_Y,
			ARG_CREATE_Z,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};

protected :
	static const KChar	* classname;

	KonoeFillData	* target;

	class	ClearUnit	: public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeFillDataOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	};
	void	setTarget( void * ptarget ){
			target = (KonoeFillData *) ptarget;	}
	KInt	showTarget( KonoeCommand * cmd );

};


#endif


