//===================================================================
/*

	KonoeHistogramFillerOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 5-Sep-1998
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEHISTOGRAMFILLERORDERLY_HH
#define	__KONOEHISTOGRAMFILLERORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeHistogramFiller.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeHistogramFillerOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::HISTOGRAM +
			KonoeHistogramCM::CID_HISTOGRAMFILLER	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_FILL,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_EXTRACTOR,
			ARG_CREATE_HISTOGRAM,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	N_ARG_FILL	};

protected :
	static const KChar	* classname;

	KonoeHistogramFiller	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ClearUnit	: public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	FillUnit	: public KonoeCommandProcessor {
	public :
	        FillUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeHistogramFillerOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif








