//=====================================================================
/*

	KonoeHistogramOfficer.cc

	Version 0.0.1	 2-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 5-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//=====================================================================

#include	<analysis/KonoeHistogramOfficer.hh>
#include	<analysis/Konoe1DHistogramOrderly.hh>
#include	<analysis/Konoe2DHistogramOrderly.hh>
#include	<analysis/KonoeFillDataOrderly.hh>
#include	<analysis/KonoeFillDataExtractorOrderly.hh>
#include	<analysis/KonoeHistogramFillerOrderly.hh>

const KChar	* KonoeHistogramOfficer::classname = "HistogramOfficer";

KonoeHistogramOfficer::KonoeHistogramOfficer( KInt norderly,
		const KChar * name )
		: KonoeOfficer( norderly, 0, name, N_CLASSES ) {

	registerOrderly( new Konoe1DHistogramOrderly( 0 ) );
	registerOrderly( new Konoe2DHistogramOrderly( 0 ) );
	registerOrderly( new KonoeFillDataOrderly( 0 ) );
	registerOrderly( new KonoeFillDataExtractorOrderly( 0 ) );
	registerOrderly( new KonoeHistogramFillerOrderly( 0 ) );

}

KInt	KonoeHistogramOfficer::execute( KonoeCommand * cmd ) {

	return 0;

}
