//===================================================================
/*

	KonoeLinearDataScaleOrderly.hh

	Version 0.0.1	 1-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 5-Sep-1998
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOELINEARDATASCALEORDERLY_HH
#define	__KONOELINEARDATASCALEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoePhysicalValueCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeLinearDataScaleOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::PHYSICALVALUE +
			KonoePhysicalValueCM::CID_LINEARDATASCALE	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_MINIMUM,
			ARG_CREATE_MAXIMUM,
			ARG_CREATE_BINCOUNT,
			N_ARG_CREATE	};
	enum	{	N_ARG_SHOW	};

protected :
	static const KChar	* classname;

	KonoeLinearDataScale	* target;

	KonoeCommandDescriptor	* createcommand;
	KonoeCommandDescriptor	* showcommand;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	CreateUnit	* createunit;
	ShowUnit	* showunit;

public :
	KonoeLinearDataScaleOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
