//===================================================================
/*

	KonoeTrackSegmentOrderly.cc

	Version 0.0.1	 9-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#include	<analysis/KonoeTrackSegmentOrderly.hh>
#include	<ui/KonoeOfficer.hh>
#include	<ui/KonoeHelpCommand.hh>
#include	<ui/KonoeShowCommand.hh>
#include	<ui/KonoeCreateCommand.hh>

const KChar	* KonoeTrackSegmentOrderly::classname = "TrackSegment";


KonoeTrackSegmentOrderly::KonoeTrackSegmentOrderly( const KChar * objname ) :
	KonoeOrderly( N_COMMANDS, objname ) {

	setClassID( CLASS_ID );

	KonoeCommandDescriptor	* cmd_descripter;
	cmd_descripter = new KonoeCommandDescriptor( "create", N_ARG_CREATE );
	cmd_descripter-> add(
		new KonoeArgumentDescriptor( "object", STRING, NECESSARY ) );
        cmd_descripter -> add(
                new KonoeArgumentDescriptor( "start", STRING, NECESSARY ) );
        cmd_descripter -> add(
                new KonoeArgumentDescriptor( "end", STRING, NECESSARY ) );
        addCommand( new KonoeCreateCommand( cmd_descripter, this ) );

	addCommand( new KonoeShowCommand( 0 , this ) );

	addCommand( new KonoeHelpCommand( 0, this ) );

}

KInt	KonoeTrackSegmentOrderly::isOrderlyOf( void * address ) {

	return address == ( void * ) target;
}



KInt	KonoeTrackSegmentOrderly::createObject( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

        KInt n_arg = cmd -> getArgumentCount( );

	KonoeCommandArgument    * arg = cmd -> getArgument( ARG_CREATE_START );
        const KChar *objectname = arg -> getValue( );

        KonoeCommander * commander = getOfficer( ) -> getCommander( );
        KonoeOrderly * orderly = commander -> findObject(objectname);

        if( orderly == 0 ){
          os << "3Vector object " << objectname << " doesn't exist."
             << endl;
          return 0;
        }
        Konoe3Vector * start
                = (Konoe3Vector * ) orderly -> getTarget( );

        arg = cmd -> getArgument( ARG_CREATE_END );
        objectname = arg -> getValue( );

        commander = getOfficer( ) -> getCommander( );
        orderly = commander -> findObject(objectname);

        if( orderly == 0 ){
          os << "3Vector object " << objectname << " doesn't exist."
             << endl;
          return 0;
        }
        Konoe3Vector * end
                = (Konoe3Vector * ) orderly -> getTarget( );

        target = new KonoeTrackSegment( *start , *end  );

	return 0;

}

KInt	KonoeTrackSegmentOrderly::deleteObject( KonoeCommand * ) {

	delete target;

	return 0;

}

KInt    KonoeTrackSegmentOrderly::showTarget( KonoeCommand * cmd ){

	ostream & os = cmd -> getOutputStream( );
	//target -> dump( os );
	return 0;
}


KonoeOrderly	* KonoeTrackSegmentOrderly::clone( const KChar * name ) {

	return new KonoeTrackSegmentOrderly( name );

}
