//===================================================================
/*

	KonoeTrackSegmentOrderly.hh

	Version 0.0.1	 9-Jun-2001	T. Matuo
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOETRACKSEGMENTORDERLY_HH
#define	__KONOETRACKSEGMENTORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<analysis/KonoeTrackSegment.hh>
#include	<KonoeCategories.hh>
#include	<analysis/KonoeGeometryCM.hh>

class	KonoeTrackSegmentOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::GEOMETRY +
			KonoeGeometryCM::CID_TRACKSEGMENT	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_START,
			ARG_CREATE_END,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	N_ARG_CLEAR	};

protected :
	static const KChar	* classname;

	KonoeTrackSegment	* target;

public :
	KonoeTrackSegmentOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KInt    showTarget( KonoeCommand * command );

};

#endif








