//====================================================================
/*

	demo.cc at src/analysis/analysisprocess

	Version 0.0.1	 1-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 7-Sep-1998	S. Nishida
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeAnalysisCommander.hh>
#include	<ui/KonoeCommandInterpreter.hh>
#include        <iostream.h>
#include	<string.h>

class Demo	{

public :
	enum { NORMAL, INTERPRETER };


protected :
	KonoeAnalysisCommander	* commander;
	KonoeCommandInterpreter * interpreter;
	KInt mode;

public :
	Demo( int argc, char ** argv );
	int	go( );

};

Demo::Demo( int argc, char ** argv ) {

	commander = new KonoeAnalysisCommander( "commander" );
	if( argc>1 && strncmp(argv[1],"-i",2)==0 ) {
	  mode = INTERPRETER;
	  interpreter = new KonoeCommandInterpreter( commander ); 
	} else mode = NORMAL;
}

int	Demo::go( ) {

	if( mode == NORMAL ) {
	  KChar buffer[ 256 ];

	  while( 1 ) {
	    cout << "CMD> ";
	    cin.getline( buffer, 256 );
	    if( commander -> dispatch( buffer, cout ) < 0 )
	      break;
	  }
	} else if( mode == INTERPRETER ) {
	  interpreter -> go( cin, cout, "CMD:ip>" );
	}
	return 0;
}

int	main( int argc, char ** argv ) {

	Demo	demo( argc, argv );
	return demo.go( );
}
