//==================================================================
/*

	KonoeDataElement.hh

	Version 0.1	18-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	16-Oct-1997	H. Sakamoto
		objectstream changed

	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEDATAELEMENT_HH
#define	__KONOEDATAELEMENT_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<iostream.h>
#include	<analysis/KonoeDataRecordCM.hh>

class	KonoeDataElement : public KonoeStreamableObject {

public :
	enum	{	INT,	FLOAT,	CHAR	};

	enum	MEMBER_ID	{
			MID_TYPE, MID_ADDRESS, MID_DATASIZE, MID_STORE,
			N_MEMBERS	};

	static const KChar	* className;

protected :
	KInt	type;
	KInt	address;
	KInt	datasize;
	void	* store;
public :
	KonoeDataElement( );
	KonoeDataElement( KInt ptype, KInt pdatasize );
	KonoeDataElement( KInt ptype, KInt paddress, KInt pvalue );
	~KonoeDataElement( );
	void	dump( ostream & os );
	KInt	fill( KInt * pbuf, KInt psize );
	KInt	getAddress( ) { return address; }
	void	* getStore( ) { return store;	}

// KonoeStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os,
			KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt, KonoeStreamableObject * ) { return -1; }
};

#endif
