//==================================================================
/*

	KonoeDataRecord.hh

	Version 0.1	18-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	16-Oct-1997	H. Sakamoto
		object I/O modified

	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno

	A data record is defined in this file. A data record
	is categorized by the type.

	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEDATARECORD_HH
#define	__KONOEDATARECORD_HH

#include	<analysis/KonoeDataSection.hh>
#include	<KonoeList.hh>

class	KonoeDataRecord : public KonoeList<KonoeDataSection>,
		public KonoeStreamableObject {

public :
	enum { UNDEFINED = -1, DATARECORDBASE = 0,
		CONTROLRECORDBASE = 128 };
	enum	MEMBER_ID	{
		MID_TYPE, MID_N_ENTRIES, MID_ENTRIES,
		N_MEMBERS };
	static const KChar	* className;

protected :
	KInt	type;
public :
	KonoeDataRecord( );
	KonoeDataRecord( KInt ptablesize, KInt ptype );
	~KonoeDataRecord( );
	KInt getType( ){ return type ;}
	void	dump( ostream & os );

// KonoeVStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar level,
			KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

};

#endif
