//====================================================================
/*

	KonoeDataRecordCM.cc

	Version 0.1	04-Aug-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	16-Oct-1997	H. Sakamoto
		category manager definition changed

        Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeDataRecordCM.hh>
#include	<analysis/KonoeDataElement.hh>
#include	<analysis/KonoeDataSegment.hh>
#include	<analysis/KonoeDataSection.hh>
#include	<analysis/KonoeDataRecord.hh>
#include	<KonoeCategories.hh>

KonoeDataRecordCM::KonoeDataRecordCM( ) :
	KonoeCategoryManager( KonoeCategories::DATARECORD, "datarecord" ) {
}

KonoeStreamableObject	* KonoeDataRecordCM::create( KInt classid ) {

	switch( classid ) {
	case CID_DATAELEMENT :
		return new KonoeDataElement;
	case CID_DATASEGMENT :
		return new KonoeDataSegment;
	case CID_DATASECTION :
		return new KonoeDataSection;
	case CID_DATARECORD :
		return new KonoeDataRecord;
	}
	return 0;
}

const KChar	* KonoeDataRecordCM::getClassName( KInt classid ) {

	switch( classid ) {
	case CID_DATAELEMENT :
		return KonoeDataElement::className;
	case CID_DATASEGMENT :
		return KonoeDataSegment::className;
	case CID_DATASECTION :
		return KonoeDataSection::className;
	case CID_DATARECORD :
		return KonoeDataRecord::className;
	}
	return 0;
}
