//==================================================================
/*

	KonoeDataSection.hh

	Version 0.1	18-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	23-Oct-1997	H. Sakamoto
	Version 0.4	12-Dec-1997	H. Sakamoto
		streamable object changed

        Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEDATASECTION_HH
#define	__KONOEDATASECTION_HH

#include	<analysis/KonoeDataSegment.hh>
#include	<KonoeList.hh>

class	KonoeDataSection : public KonoeList<KonoeDataSegment>,
		public KonoeStreamableObject {

public :
	enum	DataSectionID	{	GENERAL_SECTION = 0,
			USER_SECTION_HEAD = 128		};
	enum	{	DETECTOR_ID_MASK = 0xff00,
			SUBSECTION_ID_MASK = 0xff	};
	enum	MEMBER_ID	{
		MID_TYPE, MID_N_ENTRIES, MID_ENTRIES,
		N_MEMBERS };

	static const KChar	* className;

protected :
	KInt	type;

public :
	KonoeDataSection( );
	KonoeDataSection( KInt ptablesize, KInt ptype );
	~KonoeDataSection( );
	void	dump( ostream & os );
	KInt	getID( ) {	return type;	}

// KonoeVStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar level,
			KInt memberid );
	KInt	getStreamSize( );

	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

};

#endif
