//==================================================================
/*

	KonoeDataSegment.hh

	Version 0.1	18-Jul-1997	H. Sakamoto
	Version 0.3	23-Oct-1997	H. Sakamoto
	Version 0.4	12-Dec-1997	H. Sakamoto
		streamable object changed

        Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEDATASEGMENT_HH
#define	__KONOEDATASEGMENT_HH

#include	<analysis/KonoeDataElement.hh>
#include	<KonoeList.hh>

class	KonoeDataSegment : public KonoeList<KonoeDataElement>,
		public KonoeStreamableObject {

public :
	enum	MEMBER_ID	{
		MID_TYPE, MID_N_ENTRIES, MID_ENTRIES,
		N_MEMBERS };

	static const KChar	* className;

protected :
	KInt	type;
public :
	KonoeDataSegment( );
	KonoeDataSegment( KInt ptablesize, KInt type );
	~KonoeDataSegment( );
	void	dump( ostream & os );
	KInt	getID( )	{	return type;	}

// KonoeVStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar plevel,
			KInt memberid );
	KInt	getStreamSize( );

	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * obj );
};

#endif
