//====================================================================
/*

	krd.cc		Konoe Data Record Dump Utility

	Version 0.2.0	18-May-1998	H. Sakamoto
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeDataRecord.hh>
#include	<analysis/KonoeDataRecordCM.hh>
#include	<system/KonoeInputObjFile.hh>
#include	<iostream.h>
extern "C"	int	exit( int );

class	KonoeDataRecordDumpUtility	{

protected :
	KonoeInputObjFile	* file;
	KonoeDataRecordCM	* recordcm;
	void	print_usage( ostream & os );
public :
	KonoeDataRecordDumpUtility( KInt argc, KChar ** argv );
	KInt	go( );
};

KonoeDataRecordDumpUtility::KonoeDataRecordDumpUtility(
		KInt argc, KChar ** argv ) {

	if( argc < 2 ) {
	    print_usage( cout );
	    exit( 0 );
	}
	argv ++;
	file = new KonoeInputObjFile( * argv );
	recordcm = new KonoeDataRecordCM( );
	file -> installCM( recordcm );

}

void	KonoeDataRecordDumpUtility::print_usage( ostream & os ) {

	os << "krd : Konoe Data Record Dump Utility. Version 0.2.0" << endl;

}


KInt	KonoeDataRecordDumpUtility::go( ) {

	KonoeDataRecord	* record;

	while( record = ( KonoeDataRecord * ) file -> get( ) ) {
	    record -> dump( cout );
	    delete record;
	}
	return 0;
}

int	main( int argc, char ** argv ) {

	KonoeDataRecordDumpUtility	krd( argc, argv );
	return krd.go( );

}
