//===================================================================
/*

	Konoe3Vector.hh

	Version 0.2.0	27-Apr-1998	H. Sakamoto
	Version 0.4.0	31-Jul-1998	S. Inaba
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOE3VECTOR_HH
#define	__KONOE3VECTOR_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<iostream.h>

class	Konoe3Vector : public KonoeStreamableObject {
public :
	enum	MEMBER_ID	{	MID_X,	MID_Y, 	MID_Z,
			N_MEMBERS	};
	static const KChar	* className;

protected :

public :
	KFloat	x;
	KFloat	y;
	KFloat	z;
	Konoe3Vector( );
        ~Konoe3Vector(){}
	Konoe3Vector( KFloat px, KFloat py, KFloat pz );
	Konoe3Vector( const Konoe3Vector & v );
	Konoe3Vector & set( KFloat x, KFloat y, KFloat z );
	Konoe3Vector &	operator = ( const Konoe3Vector & v );
	Konoe3Vector	operator + ( const Konoe3Vector & v ) const;
	Konoe3Vector	operator - ( const Konoe3Vector & v ) const;
	Konoe3Vector	operator * ( KFloat f ) const;
	Konoe3Vector	operator / ( KFloat f ) const;
	Konoe3Vector	operator * ( const Konoe3Vector & v ) const;
	KFloat		operator & ( const Konoe3Vector & v ) const;
	Konoe3Vector &	operator += ( const Konoe3Vector & v );
	Konoe3Vector &	operator -= ( const Konoe3Vector & v );
	Konoe3Vector &	operator *= ( KFloat f );
	Konoe3Vector &	operator /= ( KFloat f );
	operator	KFloat( );
	Konoe3Vector &	normalize( );
	void		dump( ostream & os );
	KInt		put( KonoeOutputObjectStream *outstream,
				KChar level, KInt memberid );
	KInt		getStreamSize( );
	KInt		fillPrimitiveMember( KInt memberid, KInt datatype,
					KInt datacount, void * data );
	KInt		fillObjectMember( KInt memberid,
					KonoeStreamableObject * obj ) { return -1; }
};

Konoe3Vector	operator * ( KFloat f, Konoe3Vector & v );
ostream &	operator << ( ostream & os, Konoe3Vector & v );

#endif
