//===================================================================
/*

	KonoeBoxGeometry.hh

	Version 0.2.0	30-Apr-1998	H. Sakamoto
	Version 0.4.0	 1-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0   18-Aug-2000     K. Uchida
	Version 0.7.0   26-Aug-2001     T. Sumida
*/
//===================================================================

#ifndef	__KONOEBOXGEOMETRY_HH
#define	__KONOEBOXGEOMETRY_HH

#include	<analysis/KonoeGeometry.hh>
#include	<system/KonoeStreamableObject.hh>

class	KonoeBoxGeometry	: public KonoeGeometry {

public :
	enum 	MEMBER_ID{	MID_WIDTH,	MID_HEIGHT,	MID_DEPTH,
			MID_WAXIS,	MID_HAXIS,	MID_DAXIS,	
			MID_DISPLACEMENT,	N_MEMBERS	};
	static const KChar	* className;

private :
	KFloat	entrance_f;
	KFloat	exit_f;
	KFloat	ffx;
	KInt	check_fx( KFloat fx );
	void	set_points( KonoeTrajectory * t, Konoe3Vector & p1,
			Konoe3Vector & p2 );

protected :
	KFloat	width;		// size in x
	KFloat	height;		// size in y
	KFloat	depth;		// size in z
	Konoe3Vector	 waxis;
	Konoe3Vector	 haxis;
	Konoe3Vector	 daxis;
	Konoe3Vector	 displacement;

public :
	KonoeBoxGeometry( );
	KonoeBoxGeometry( KFloat width, KFloat height, KFloat depth );

	void	translate( KonoeTranslation * translation );
	KInt	isCrossing( KonoeTrajectory * trajectory,
			Konoe3Vector & entrypoint, Konoe3Vector & exitpoint );

	void	dump( ostream & os );

	KInt	put( KonoeOutputObjectStream * os, KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * obj );

        Konoe3Vector  getDisplacement(){ return  displacement; }
        Konoe3Vector   getWaxis(){ return   waxis; }
        Konoe3Vector   getHaxis(){ return   haxis; }
        Konoe3Vector   getDaxis(){ return   daxis; }
        KFloat         getWidth(){ return   width; }
        KFloat         getHeight(){ return  height; }
        KFloat         getDepth(){ return   depth; }

};


#endif
