//=================================================================
/*

	KonoeDetector.hh

	Version 0.2.0	28-Apr-1998	H. Sakamoto
	Version 0.4.0	06-Aug-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//=================================================================

#ifndef	__KONOEDETECTOR_HH
#define	__KONOEDETECTOR_HH

#include	<KonoeList.hh>
#include	<analysis/KonoeDetectorElement.hh>

class	KonoeDetector	: public KonoeList<KonoeDetectorElement>,
                public KonoeStreamableObject {

public :
        enum MEMBER_ID {
		MID_IDENTIFIER, MID_N_ENTRIES, MID_ENTRIES, 
	    	N_MEMBERS };
        static const KChar 	* className;

protected :
	KInt	identifier;

public :
	KonoeDetector( );
	KonoeDetector( KInt classid );
	KonoeDetector( KInt ptablesizer, KInt pidentifier );

	KonoeDetectorElement	* find(
		KInt section, KInt segment, KInt subaddress );
	KInt	getID( )	{	return identifier;	}

        void    dump( ostream & os );
// KonoeStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar level,
			KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

};

#endif
