//===================================================================
/*

	KonoeDetectorHit.hh

	Version 0.2.0	29-Apr-1998	H. Sakamoto

	Version 0.4.0	31-Jul-1998	S. Inaba
	Version 0.5.0	21-Sep-1999	Y. Kouno

        16-Oct-2000   Kirika Uchida 
          KonoeSimDetectorHit::energy -> KonoeDetectorHit::hitenergy
	  add KonoeDetectorHit::KonoeDetectorHit( KInt classid )
	25-Nov-2000 K.Uchida
	  add ADCValue, TDCValue

	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEDETECTORHIT_HH
#define	__KONOEDETECTORHIT_HH

#include	<analysis/KonoeDetectorElement.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<iostream.h>
#include        <analysis/KonoeDetectorHit.hh>
 
class	KonoeDetectorHit : public KonoeStreamableObject	{

public :
	enum	MEMBER_ID{	MID_DETECTOR_ELEMENT,	
				MID_HITTIME, MID_TDC_VALUE, 
				MID_HITENERGY,MID_ADC_VALUE,  N_MEMBERS	};
	static const KChar	* className;

protected : 
	KonoeDetectorElement	* detectorelement;
        KFloat		hittime;
        KInt            TDCValue; 
        KFloat          hitenergy;
        KInt            ADCValue;
	KInt             detectorelement_tag;	  

public :
	KonoeDetectorHit();
        KonoeDetectorHit( KInt classid );
        KonoeDetectorHit( KInt categoryid, KInt classid );
	KonoeDetectorHit( KonoeDetectorElement * element ); 
        ~KonoeDetectorHit();
        void    dump( ostream & os );
	KonoeDetectorElement	* getDetectorElement( ) { 
	    	          return detectorelement; }
	void	setHitTime( KFloat t )	{ hittime = t; }
        void    setTDCValue( KInt tdc ) { TDCValue = tdc; }
	void	setHitEnergy( KFloat e ){ hitenergy = e; }
	void    setADCValue( KInt adc ) { ADCValue = adc; }
        KFloat	getHitTime( ) {	return hittime;	}
	KFloat	getHitEnergy( ) { return hitenergy; }
        KInt    getTDCValue(){ return TDCValue; }
        KInt    getADCValue(){ return ADCValue; }
        KInt	put( KonoeOutputObjectStream * os, 
		KChar lavel, KInt memberid );

	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data ); 
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * obj );	
};

#endif
