//==================================================================
/*

	KonoeDetectorList.hh

	Version 0.2.0	29-Apr-1998	H. Sakamoto
	Version 0.4.0	06-Aug-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEDETECTORLIST_HH
#define	__KONOEDETECTORLIST_HH

#include	<analysis/KonoeDetector.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<KonoeList.hh>

class	KonoeDetectorList	: public KonoeList<KonoeDetector>,
		public KonoeStreamableObject {

public:
	enum MEMBER_ID {
		MID_N_ENTRIES, MID_ENTRIES, 
	    	N_MEMBERS };
        static const KChar 	* className;

public :
	KonoeDetectorList( );
	KonoeDetectorList( KInt ptablesize );

// KonoeStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar level,
			KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

};

#endif
