//=================================================================
/*

	KonoeGeometry.hh

	Version 0.2.0	30-Apr-1998	H. Sakamoto
	Version 0.4.0	 1-Aug-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno

	need to introduce "rotation" of shape

	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//=================================================================

#ifndef	__KONOEGEOMETRY_HH
#define	__KONOEGEOMETRY_HH

#include	<analysis/KonoeTrajectory.hh>
#include	<analysis/KonoeTranslation.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<iostream.h>

class	KonoeGeometry : public KonoeStreamableObject {

protected :
	Konoe3Vector displacement;

public :
	KonoeGeometry( );
	KonoeGeometry( KInt classid );
        virtual ~KonoeGeometry(){}
	virtual void	translate( KonoeTranslation * translation ) = 0;
	virtual KInt	isCrossing( KonoeTrajectory * trajectory,
		Konoe3Vector & entrypoint, Konoe3Vector & exitpoint ) = 0;
        virtual Konoe3Vector getDisplacement() { return displacement; }
	virtual void	dump( ostream & os ) = 0;
};

#endif
