//====================================================================
/*

	KonoeGeometryCM.cc

	Version 0.4.0	06-Aug-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include        <analysis/Konoe3Vector.hh>
#include	<analysis/KonoeGeometryCM.hh>
#include        <analysis/KonoeDetector.hh>
#include        <analysis/KonoeDetectorElement.hh>
#include 	<analysis/KonoeDetectorHit.hh>
#include        <analysis/KonoeGeometry.hh>
#include        <analysis/KonoeBoxGeometry.hh>
#include	<KonoeCategories.hh>

KonoeGeometryCM::KonoeGeometryCM( ) :
	KonoeCategoryManager( KonoeCategories::GEOMETRY, "Geometry" ) {
}

KonoeStreamableObject	* KonoeGeometryCM::create( KInt classid ) {

	switch( classid ) {
	case CID_3VECTOR :
		return new Konoe3Vector( );
	case CID_DETECTOR :
		return new KonoeDetector( );
	case CID_DETECTORELEMENT :
		return new KonoeDetectorElement( );
	case CID_DETECTORHIT :
		return new KonoeDetectorHit( );
	case CID_BOXGEOMETRY :
		return new KonoeBoxGeometry( );
	}
	return 0;
}

const KChar	* KonoeGeometryCM::getClassName( KInt classid ) {

	switch( classid ) {
	case CID_3VECTOR :
		return Konoe3Vector::className;
	case CID_DETECTOR :
		return KonoeDetector::className;
	case CID_DETECTORELEMENT :
		return KonoeDetectorElement::className;
	case CID_DETECTORHIT :
		return KonoeDetectorHit::className;
	case CID_BOXGEOMETRY :
		return KonoeBoxGeometry::className;
	}
	return 0;
}
