//==================================================================
/*

	KonoeHitDataset.hh

	Version 0.2.0	13-May-1998	H. Sakamoto
	Version 0.2.1	01-Jun-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#ifndef	__KONOEHITDATASET_HH
#define	__KONOEHITDATASET_HH
#include        <iostream.h>
#include	<KonoeList.hh>
#include	<analysis/KonoeDetectorHit.hh>
#include	<analysis/KonoePhysicalValue.hh>
#include	<analysis/KonoeMultipletDescriptor.hh>

class	KonoeHitDataset	: public KonoePhysicalValue {

public :
	enum	{	DETECTOR_ID_INDEX,
			HIT_TIME_INDEX,
			HIT_ENERGY_INDEX,
			MULTIPLET_SIZE	};

protected :
	KonoeList<KonoeDetectorHit>	* hitlist;
	KonoeList<KonoeDataMultiplet>	* multipletlist;
	KonoeMultipletDescriptor		* specifier;

	KInt	detector_id_index;
	KInt	hit_time_index;
        KInt    hit_energy_index;
public :
        KonoeHitDataset( KInt tablesize,
		KonoeMultipletDescriptor * specifier, KInt tag );
	~KonoeHitDataset( );
	KInt	clear( );
	KInt	reset( );
	KInt	getDataCount( );
	KonoeDataMultiplet	* next( );
	KInt	add( KonoeDetectorHit * hit );
	void MakeMultipletList( );
	KonoeMultipletDescriptor	* getDescriptor( ) {
			return specifier;	}
        KonoeList<KonoeDetectorHit> * getHitList(){ return hitlist; }
        void dump(ostream& os);
	static KChar	* dataNameList[ MULTIPLET_SIZE ];

};


#endif
