//===================================================================
/*

	KonoeHitSectionAnalyzer.cc

	Version 0.2.0	12-May-1998	H. Sakamoto
	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida
        
*/
//===================================================================

#include	<analysis/KonoeHitSectionAnalyzer.hh>
#include	<analysis/KonoeDetectorHit.hh>
#include        <iostream.h>
KonoeHitSectionAnalyzer::KonoeHitSectionAnalyzer( KInt psection,
	KonoeDetector * pdetector, KonoeDataCalibrator * pcal,
        KonoeHitDataset * phitset )
	: KonoeSectionAnalyzer( psection ) {
	  //  cout << "hit section analyzer constructor" << endl;
	detector = pdetector;
	calibrator = pcal;
        hitset = phitset; 
	//cout << "hitset: " << hitset << endl;
	hitlist = hitset -> getHitList();	
	//cout << "hitlist: " << hitlist << endl;
}

KInt	KonoeHitSectionAnalyzer::analyze( KonoeDataSection * section ) {
  
        KonoeDataSegment	* segment;
	KonoeDataElement	* element;
	KInt	secid, segid, sa;
	KonoeDetectorElement	* de;
        KonoeDetectorHit        * hit;
	//	cout << "   in hit section analyzer" << endl;

	//	cout << "hit section analyzer -> analyze, hitlist: " 
	//	     << hitlist << endl;
	hitlist -> reset();	
	section -> reset( );
	secid = section -> getID( );
	while( segment = section -> next( ) ) {
	  segid = segment -> getID( );
	  segment -> reset( );
	  while( element = segment -> next( ) ) {
	    sa = element -> getAddress( );
	    de = detector -> find( secid, segid, sa );
	    if( de ) {
	      if( hit = hitlist -> next() ) {
		calibrator -> convert( hit, element );	      
		//cout << "converted" << endl;
	      }
	      else{
		hit = new KonoeDetectorHit( de ); 
		//		cout << "new hit" << endl;
		calibrator -> convert( hit, element );
		hitset -> add(hit);
		hitlist -> next();
	      }
	    }
	    else {
	      cout << "No detector element for = " << endl;
              return -1;
	    }	      
	  }
	}
	//	cout << "hit sectin analyzer analyzed" << endl;
	return 0;
      }

KonoePhysicalValue	* KonoeHitSectionAnalyzer::getPhysicalValue( ) {
 //       hitset -> MakeMultipletList();
	return ( KonoePhysicalValue * ) hitset;

}
