//===================================================================
/*

	KonoeHitSectionAnalyzer.hh

	Version 0.2.0	12-May-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOEHITSECTIONANALYZER_HH
#define	__KONOEHITSECTIONANALYZER_HH

#include	<analysis/KonoeSectionAnalyzer.hh>
#include	<analysis/KonoeDetector.hh>
#include	<analysis/KonoeDataCalibrator.hh>
#include	<analysis/KonoeHitDataset.hh>

class	KonoeHitSectionAnalyzer	: public KonoeSectionAnalyzer {

protected :
	KonoeDetector	* detector;
	KonoeDataCalibrator	* calibrator;
        KonoeHitDataset * hitset;
	KonoeList<KonoeDetectorHit> * hitlist;
public :
	KonoeHitSectionAnalyzer( KInt psectionid,
		KonoeDetector * detector, KonoeDataCalibrator * cal,
                KonoeHitDataset * hitset );
		
	KInt	analyze( KonoeDataSection * section );
	KonoePhysicalValue	* getPhysicalValue( );
};

#endif
