//===================================================================
/*

	KonoeSimDetectorHit.hh

	Version 0.2.0	29-Apr-1998	H. Sakamoto

	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
        16-Oct-2000         Kirika Uchida 
          KonoeSimDetectorHit::energy -> KonoeDetectorHit::hitenergy

	Version 0.7.0	26-Aug-2001	T. Sumida
*/
//===================================================================

#ifndef	__KONOESIMDETECTORHIT_HH
#define	__KONOESIMDETECTORHIT_HH

#include	<analysis/KonoeDetectorHit.hh>
#include	<iostream.h>

class	KonoeSimDetectorHit	: public KonoeDetectorHit {

protected :
	Konoe3Vector	entrypoint;
	Konoe3Vector	exitpoint;
	KFloat		entrytime;
	KFloat		exittime;

public :
	KonoeSimDetectorHit( KonoeDetectorElement * element,
		Konoe3Vector & entryp, Konoe3Vector & exitp );
	KonoeSimDetectorHit( KonoeDetectorElement * element );
	void	dump( ostream & os );
	KFloat	getEntryTime( )	{	return entrytime;	}
	KFloat	getExitTime( )	{	return exittime;	}
	void	setEntryTime( KFloat t )	{	entrytime = t;	}
	void	setExitTime( KFloat t )		{	exittime = t;	}
        Konoe3Vector * getEntryPoint( )  {     return & entrypoint;     }
        Konoe3Vector * getExitPoint( )   {     return & exitpoint;      }
};

#endif
