//==================================================================
/*

	KonoeSimulator.cc

	Version 0.2.0	29-Apr-1998	H. Sakamoto
	Version 0.4.0	06-Aug-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//==================================================================

#include	<analysis/KonoeSimulator.hh>
#include	<analysis/KonoeSimEvent.hh>

KonoeSimulator::KonoeSimulator( KonoeDetectorList * pdetectorlist,
			KonoeEventGenerator * pgenerator ) {

	detectorlist = pdetectorlist;
	generator = pgenerator;

}

KInt	KonoeSimulator::simulate( ) {

	KonoeSimEvent	* event;
	KonoeDetector	* detector;
	KonoeDetectorElement	* element;
	KonoeTrack	* track;
	KonoeTrackSegment	* segment;
	KonoeSimDetectorHit	* hit;

	event = generator -> generate( );
	if( ! event ) return -1;

	event -> reset( );
	while( track = event -> next( ) ) {
	    track -> reset( );
	    while( segment = track -> next( ) ) {

		detectorlist -> reset( );
		while( detector = detectorlist -> next( ) ) {
		    detector -> reset( );
		    while( element = detector -> next( ) ) {
			if( hit = element -> interact( segment ) ) {
			    processHit( hit );
			}
		    }
		}
	    }
	}
}

KInt	KonoeSimulator::processHit( KonoeSimDetectorHit * hit ) {

	// dummy function for hit processing.
	return 0;

}
