//====================================================================
/*

	Konoe1DHistogram.hh

	Version 0.1	30-Oct-1997	H. Sakamoto
	Version 0.2	12-Dec-1997	H. Sakamoto
		streamable object changed
	Version 0.1.2	12-Jan-1998	K. Ohta
		add fillUseElement function
	Version 0.2.0	 9-Mar-1998	Sanshiro Enomoto
                modified for HistogramFiller
	Version 0.2.1	27-Apr-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#ifndef	__KONOE1DHISTOGRAM_HH
#define	__KONOE1DHISTOGRAM_HH

#include	<analysis/KonoeHistogramBase.hh>
#include	<analysis/KonoeDataScale.hh>
#include	<analysis/KonoeHistogramStorage.hh>
#include	<analysis/KonoeFillData.hh>
#include	<iostream.h>

class	Konoe1DHistogram : public KonoeHistogramBase {

public :	// streamable

	enum	MEMBER_ID {	MID_SCALE,	MID_STORAGE,
				N_MEMBERS	};

	static const KChar	* className;

protected :
	KonoeDataScale	* scale;
	KonoeHistogramStorage	* storage;

public :
	Konoe1DHistogram( KonoeDataScale * scale );
	Konoe1DHistogram( );
	~Konoe1DHistogram( );

	void	clear( );
	KInt	fill( KonoeFillData *fill_data );

	virtual void	dump( ostream & os );

// to be streamable...

	KInt	put( KonoeOutputObjectStream * os,
			KChar lavel, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data ) { return -1; }
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

	virtual KInt    getBinCount( );
	virtual KFloat  getOne( KInt pindex );
	virtual KonoeDataScale* getScale( );

};

#endif
