//====================================================================
/*

	Konoe2DHistogram.hh

	Version 0.1.1	18-Dec-1997	Sanshiro Enomoto
                based Konoe1DHistogram.hh Version 0.2
	Version 0.2.0	27-Apr-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#ifndef	__KONOE2DHISTOGRAM_HH
#define	__KONOE2DHISTOGRAM_HH

#include	<analysis/KonoeHistogramBase.hh>
#include	<analysis/KonoeDataScale.hh>
#include	<analysis/KonoeHistogramStorage.hh>
#include        <analysis/KonoeFillData.hh>
#include	<iostream.h>

class	Konoe2DHistogram : public KonoeHistogramBase {

public :	// streamable

	enum	MEMBER_ID {	MID_XSCALE,	MID_YSCALE,     MID_STORAGE,
				N_MEMBERS	};

	static const KChar	* className;

protected :
	KonoeDataScale	* xscale;
	KonoeDataScale	* yscale;
	KonoeHistogramStorage	* storage;

public :
	Konoe2DHistogram( KonoeDataScale * xscale, KonoeDataScale * yscale );
	Konoe2DHistogram( );
	~Konoe2DHistogram( );

	void	clear( );
	KInt	fill( KonoeFillData * fill_data );

	void	dump( ostream & os );

    KInt    getXscale();
    KInt    getYscale();
    KInt    getBinCountx();
    KInt    getBinCounty();
    KFloat  getOne( KInt pxindex, KInt pyindex );

// to be streamable...

	KInt	put( KonoeOutputObjectStream * os,
			KChar lavel, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data ) { return -1; }
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );

};

#endif
