//====================================================================
/*

        KonoeFillDataExtractor.cc

	Version 0.2.0	28-Mar-1998	H. Sakamoto
	Version 0.2.1	15-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================


#include <analysis/KonoePhysicalValue.hh>
#include <analysis/KonoeFillData.hh>
#include <analysis/KonoeFillDataExtractor.hh>

KonoeFillDataExtractor::KonoeFillDataExtractor(KonoePhysicalValue * pvalue,
	KChar * name1, KChar * name2, KChar * name3 )
{
	KonoeMultipletDescriptor	* d;
	KInt	i, j;

	for( i = 0; i < FILL_DATA_DIMENSION; i ++ )
	    indices[ i ] = -1;
	physicalvalue = pvalue;
	d = pvalue -> getDescriptor( );
	if( name1 )
	    indices[ 0 ] = d -> getIndex( name1 );
	if( name2 )
	    indices[ 1 ] = d -> getIndex( name2 );
	if( name3 )
	    indices[ 2 ] = d -> getIndex( name3 );
	j = 0;
	for( i = 0; i < FILL_DATA_DIMENSION; i ++ )
	    if( indices[ i ] == -1 )
		indices[ i ] = j ++;

}

void	KonoeFillDataExtractor::setIndex( KInt i1, KInt i2, KInt i3 ) {

	if( i1 > -1 )
	    indices[ 0 ] = i1;
	if( i2 > -1 )
	    indices[ 1 ] = i2;
	if( i3 > -1 )
	    indices[ 2 ] = i3;

}

KInt	KonoeFillDataExtractor::reset( ) {

	return physicalvalue -> reset( );

}

KInt KonoeFillDataExtractor::getDataCount( )
{
    return physicalvalue->getDataCount();
}

KonoeFillData *KonoeFillDataExtractor::next( )
{
	KonoeDataMultiplet	* multiplet;

	multiplet = physicalvalue -> next( );
	if( multiplet == 0 )
	    return 0;
    
    return new KonoeFillData( multiplet -> getValue( indices[ 0 ] ),
		multiplet -> getValue( indices[ 1 ] ),
		multiplet -> getValue( indices[ 2 ] ) );
}
