//====================================================================
/*

	KonoeHistogramCM.cc

	Version 0.1	30-Oct-1997	H. Sakamoto
	Version 0.1.0A	05-Feb-1998	H. Sakamoto
		2DHistogram added.
	Version 0.2.0	27-Apr-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	25-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeHistogramCM.hh>
#include	<analysis/KonoeHistogramStorage.hh>
#include	<analysis/Konoe1DHistogram.hh>
#include	<analysis/Konoe2DHistogram.hh>
#include	<analysis/KonoeFillData.hh>
#include	<analysis/KonoeFillDataExtractor.hh>
#include	<analysis/KonoeHistogramFiller.hh>
#include	<analysis/Konoe1DHistogramList.hh>
#include	<KonoeCategories.hh>

KonoeHistogramCM::KonoeHistogramCM( ) :
	KonoeCategoryManager( KonoeCategories::HISTOGRAM, "histogram" ) {
}

KonoeStreamableObject	* KonoeHistogramCM::create( KInt classid ) {

	switch( classid ) {
	case CID_HISTOGRAMSTORAGE :
		return new KonoeHistogramStorage;
	case CID_1DHISTOGRAM :
		return new Konoe1DHistogram;
	case CID_2DHISTOGRAM :
		return new Konoe2DHistogram;
	case CID_1DHISTOGRAMLIST :
		return new Konoe1DHistogramList;
	}
	return 0;
}

const KChar	* KonoeHistogramCM::getClassName( KInt classid ) {

	switch( classid ) {
	case CID_HISTOGRAMSTORAGE :
		return KonoeHistogramStorage::className;
	case CID_1DHISTOGRAM :
		return Konoe1DHistogram::className;
	case CID_2DHISTOGRAM :
		return Konoe2DHistogram::className;
	case CID_1DHISTOGRAMLIST :
		return Konoe1DHistogramList::className;
	}
	return 0;
}
