//====================================================================
/*

        KonoeHistogramFiller.cc

	Version 0.2.0	10-Mar-1997	S. Enomoto
	Version 0.4.0	10-Sep-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.6.0	10-Nov-2000	Y. Shimizu
		delete fill_data;
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include        <analysis/KonoeHistogramFiller.hh>

#include	<iostream.h>

KonoeHistogramFiller::KonoeHistogramFiller(KonoeFillDataExtractor *pextractor, KonoeHistogramBase *phistogram)
: extractor(pextractor), histogram(phistogram)
{ 
}

KonoeHistogramFiller::~KonoeHistogramFiller( )
{
    delete extractor;
    delete histogram;
}

KInt KonoeHistogramFiller::fill( ){
    KInt result = 0;

    KonoeFillData *fill_data; 
	extractor -> reset( );
    while( (fill_data = extractor->next( )) != 0 ){
	if ((result = histogram->fill(fill_data)) != 0){
	    delete fill_data;
	    break;
	}
    }
    
    return result;
}
