//=====================================================================
/*

	KonoeHistogramStorage.hh

	Version 0.1	30-Oct-1997	H. Sakamoto
	Version 0.2	12-Dec-1997	H. Sakamoto
		streamable object changed.
	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi	(Check only)
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//=====================================================================

#ifndef	__KONOEHISTOGRAMSTORAGE_HH
#define	__KONOEHISTOGRAMSTORAGE_HH

#include	<analysis/KonoeHistoStorageBase.hh>
#include	<iostream.h>

class	KonoeHistogramStorage : public KonoeHistoStorageBase {

public :	// to be streamable
	enum	MEMBER_ID	{	MID_TYPE,	MID_X_SIZE,
			MID_Y_SIZE,	MID_Z_SIZE,
			MID_STORAGE_SIZE,	MID_STORE,
			N_MEMBERS	};

	static const KChar	* className;

protected :
	KInt	type;
	KInt	x_bincount;
	KInt	y_bincount;
	KInt	z_bincount;
	KInt	x_size;
	KInt	y_size;
	KInt	z_size;
	KInt	storage_size;
	KInt	* store;

	KInt	get_index( KInt xindex, KInt yindex, KInt zindex );

public :
	KonoeHistogramStorage( KInt xsize, KInt ysize = 0, KInt zsize = 0 );
	KonoeHistogramStorage( );	// to be streamable
	~KonoeHistogramStorage( );
	KInt	set( KFloat value,
		KInt xindex, KInt yindex = 0, KInt zindex = 0 );
	KInt	addOne( KInt xindex, KInt yindex = 0, KInt zindex = 0 );
	KFloat	get( KInt xindex, KInt yindex = 0, KInt zindex =0 );
	void	clear( );
	void	dump( ostream & os );

// to be streamable ...

	KInt	put( KonoeOutputObjectStream * outstream,
			KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt, KonoeStreamableObject * ) { return -1; }

// needs methods to obtain overflows and underflows.

// more... say, getSlice, getBand...
};

#endif
