//=================================================================================
/*

	objtest.cc

	supporting for objectstream of 1DHistogram 

	17-Aug-2000	Y. Shimizu

*/
//=================================================================================
#include	<system/KonoeInputObjFile.hh>
#include	<analysis/KonoeHistogramCM.hh>
#include	<analysis/KonoePhysicalValueCM.hh>
#include	<analysis/Konoe1DHistogram.hh>
#include	<analysis/KonoeLinearDataScale.hh>

int main( int argc, char** argv){
	if( argc != 2 ){
		cerr << " ./test_in <objfile> " << endl;
		exit(8);
	}

	argv++;

	KonoeInputObjFile * ofile;
	Konoe1DHistogram  * hist;

	ofile = new KonoeInputObjFile(*argv);
	
	KonoeHistogramCM     * h_cm;
	KonoePhysicalValueCM * p_cm;

	h_cm = new KonoeHistogramCM;
	p_cm = new KonoePhysicalValueCM;
	
	ofile->installCM( h_cm );
	ofile->installCM( p_cm );

	hist = ( Konoe1DHistogram *) ofile->get( );

	if( hist == 0 ){
		cerr << " ofile->get( ) error "  <<  endl;
		exit(8);
	}

	hist->dump(cout);

	KonoeLinearDataScale * new_scale;
	new_scale = new KonoeLinearDataScale( 0, 400, 40 );
	hist->refill( new_scale );
	hist->dump( cout );

	KonoeLinearDataScale * new_scale2;
	new_scale2 = new KonoeLinearDataScale( 0, 800, 80 );
	hist->refill( new_scale2 );
	hist->dump( cout );

	KonoeLinearDataScale * new_scale3;
	new_scale3 = new KonoeLinearDataScale( 0, 400, 100 );
	hist->refill( new_scale3 );
	hist->dump( cout );


	return (0);

}
		
	
