//=========================================================================
/*
	demo for histgram 

	Version 0.1 	16-March-2000	Y. Shimizu
	Version 0.6	30-Jul-2000	Y. Shimizu
		test for refill method
	Version 0.6.1	17-Aug-2000	Y. Shimizu
		test for objctstream
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//========================================================================
	
#include	<iostream.h>
#include	<analysis/Konoe1DHistogram.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<system/KonoeOutputObjFile.hh>
#include	<analysis/KonoeInfiniteArray.hh>
#include	<analysis/KonoeFileEnumerate.hh>
#include	<analysis/KonoeFillData.hh>
#include	<analysis/KonoeLinearDataScale.hh>


class DEMO {
public:
	enum { OVERFLOW = -1, UNDERFLOW = -2 };

public:
	Konoe1DHistogram	* a_hist;
	KonoeLinearDataScale	* a_scale;
	KonoeLinearDataScale	* new_scale;
	KonoeFillData		* a_fill;
	KonoeFileEnumerate	* file_data;

	KonoeOutputObjFile	* ofile;
	
	DEMO(char * filename);
	~DEMO();
	void go(void);
	void reScale(void);

};

DEMO::DEMO(char * filename)
{
	a_scale     = new KonoeLinearDataScale( 0.0 , 400.0 , 400 );
	a_hist      = new Konoe1DHistogram(a_scale);
	file_data = new KonoeFileEnumerate(filename);

	ofile 	    = new KonoeOutputObjFile("objhistfile");
}

DEMO::~DEMO()
{
	delete a_scale;
	delete file_data;
//	delete new_scale;
}

void DEMO::go(void)
{
	int i;
	for( i = 0; i < file_data->data_items; ++i) {
		float data = 0;
		data = file_data->data_array[ i ];
		a_fill = new KonoeFillData( data );
		a_hist->fill( a_fill );
//		delete a_fill;
	}
	a_hist->dump(cout);
	ofile->put( a_hist );
}

void DEMO::reScale(void){

	KInt min,max,count;
	cout << "data-scale : min ? " ;
	cin >> min;
	cout << "data-scale : max ? " ;
	cin >> max;
	cout << "data-scale : count ? " ;
	cin >> count;
	
	new_scale = new KonoeLinearDataScale( min, max, count );
//	a_hist->refill( new_scale );
	a_hist->dump(cout);
//	delete new_scale;

}

int main(int argc , char **argv)
{
	DEMO demo("test.dat");
	demo.go();
	
/*
    while(1){
		demo.reScale( );
	}
*/
	return 0;
}
