//=================================================================
/*

	KonoeDataAddress.hh

	Version 0.2.0	30-Apr-1998	H. Sakamoto
	Version 0.2.1   31-Jul-1998     D. Takagi
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida
*/
//=================================================================

#ifndef	__KONOEDATAADDRESS_HH
#define	__KONOEDATAADDRESS_HH

#include	<system/KonoeStreamableObject.hh>
#include	<KonoePrimitives.hh>
#include	<iostream.h>

class KonoeDetectorElement;

class	KonoeDataAddress : public KonoeStreamableObject	{

public :
	enum	{	NORMAL,	BITMAP		};
	enum	MEMBER_ID	{
		MID_ADDRESS_TYPE, MID_SECTION_ID, MID_SEGMENT_ID, 
		MID_SUBADDRESS, MID_BIT_OFFSET, N_MEMBERS	};
	
	static const KChar	* className;

protected :
	KInt	address_type;
	KInt	section_id;
	KInt	segment_id;
	KInt	subaddress;
	KInt	bit_offset;
public :
	KonoeDataAddress( );
	KonoeDataAddress( KInt classid );
	KonoeDataAddress( KInt psectionid, KInt psegmentid,
			 KInt psubaddress, 
			 KInt ptype = NORMAL, 
			 KInt pbit = 0  );
        KInt	match( KonoeDataAddress & ref );
	void	dump( ostream & os );
	KInt	getSectionID( )	{	return section_id;	}
	KInt	getSegmentID( ) {	return segment_id;	}
	KInt	getSubaddress( )	{	return subaddress;	}
        KInt    getBitOffset(){    return bit_offset;    }
// KonoeStreamableObject members.

	KInt	put( KonoeOutputObjectStream * os, KChar level,
			KInt memberid );
	KInt	getStreamSize( );

	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data );
	
};

#endif
