//====================================================================
/*

	KonoeDataAnalyzer.hh

	Version 0.1	02-Aug-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	13-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#ifndef	__KONOEDATAANALYZER_HH
#define	__KONOEDATAANALYZER_HH

#include	<analysis/KonoePhysicalValue.hh>
#include	<analysis/KonoeSectionAnalyzer.hh>
#include	<analysis/KonoeDataRecord.hh>
#include	<iostream.h>

class	KonoeDataAnalyzer {

protected :

	KonoeDataRecord		* record;
	KonoeList<KonoeSectionAnalyzer>	* section_analyzer_list;

	KInt	process_section( KonoeDataSection * section );
	KonoeSectionAnalyzer	* find_analyzer( KInt tag );

public :
	KonoeDataAnalyzer( KInt pn_sections );
	KInt	reset( );
	KInt	analyze( KonoeDataRecord * precord );
	KInt	install( KonoeSectionAnalyzer * section_analyzer );
};


#endif
