//====================================================================
/*

	KonoeDataMultiplet.cc

	Version 0.2.0	14-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeDataMultiplet.hh>
#include	<string.h>

KonoeDataMultiplet::KonoeDataMultiplet( KonoeMultipletDescriptor * plist ) {

	list = plist;
	data = new KFloat[ datasize = list -> getCount( ) ];

}

KonoeDataMultiplet::~KonoeDataMultiplet( ) {

	delete [] data;

}

KInt	KonoeDataMultiplet::getIndex( const KChar * name ) {

	KonoeDataSpecifier	* p;
	KInt	i;

	i = 0;
	list -> reset( );
	while( p = list -> next( ) ) {
	    if( strcmp( name, p -> getName( ) ) == 0 )
		return i;
	    i ++;
	}
	return -1;	// not found.

}

KFloat	KonoeDataMultiplet::getValue( KInt index ) {

	if( index < 0 || index >= datasize )
	    return 0;
	return * ( data + index );

}

KInt	KonoeDataMultiplet::setValue( KInt index, KFloat value ) {

	if( index < 0 || index >= datasize )
	    return -1;
	* ( data + index ) = value;
	return 0;

}
