//====================================================================
/*

	KonoeDefaultSectionAnalyzer.cc

	Version 0.2.0	14-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoeDefaultSectionAnalyzer.hh>

KonoeDefaultSectionAnalyzer::KonoeDefaultSectionAnalyzer(KInt psection,
		KInt ptablesize, KInt ptag )
	: KonoeSectionAnalyzer( psection ) {

	rawdatavalue = new KonoeRawDataset( ptablesize, ptag );

}

KInt	KonoeDefaultSectionAnalyzer::clear( ) {

	return rawdatavalue -> clear( );

}

KInt	KonoeDefaultSectionAnalyzer::analyze( KonoeDataSection * section ) {

	KonoeDataSegment	* segment;
	KonoeDataElement	* element;

	section -> reset( );
	while( segment = section -> next( ) ) {
	    segment -> reset( );
	    while( element = segment -> next( ) ) {
		rawdatavalue -> add( section -> getID( ),
			segment -> getID( ), element );
	    }
	}
	return 0;
}

KonoePhysicalValue	* KonoeDefaultSectionAnalyzer::getPhysicalValue( ) {

	return ( KonoePhysicalValue * ) rawdatavalue;

}
