//====================================================================
/*

	KonoeLinearDataScale.hh

	Version 0.1	30-Oct-1997	H. Sakamoto
	Version 0.2	12-Dec-1997	H. Sakamoto

	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	27-Apr-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#ifndef	__KONOELINEARDATASCALE_HH
#define	__KONOELINEARDATASCALE_HH

#include	<analysis/KonoeDataScale.hh>

class	KonoeLinearDataScale : public KonoeDataScale {

public :
	enum	MEMBER_ID	{	MID_MINIMUM,	MID_MAXIMUM,
			MID_BINWIDTH,	MID_BINCOUNT,
			N_MEMBERS	};

	static const KChar	* className;

protected :
	KFloat	minimum;
	KFloat	maximum;
	KFloat	binwidth;
	KInt	bincount;

public :
	KonoeLinearDataScale( KFloat minimum, KFloat maximum, KInt bincount );
	KonoeLinearDataScale( );	// to be streamable.

	KInt	getBinIndex( KFloat value );
	KFloat	getBinWidth( KInt /* binnumber */ ) { return binwidth; }
	KFloat	getBinLower( KInt binnumber );
	KInt	getBinCount( ) { return bincount; }
	KFloat	getMinimum( ) { return minimum; }
	KFloat	getMaximum( ) { return maximum; }

	void	dump( ostream & os );

// to be streamable

	KInt	put( KonoeOutputObjectStream * os, KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * data ) { return -1; }
};

#endif
