//====================================================================
/*

	KonoePhysicalValueCM.cc

	Version 0.1	30-Oct-1997	H. Sakamoto

	Version 0.1.0                   H. Sakamoto
	Version 0.2.0	15-May-1998	H. Sakamoto
	Version 0.2.1   31-Jul-1998	D. Takagi
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//====================================================================

#include	<analysis/KonoePhysicalValueCM.hh>

#include	<KonoeCategories.hh>
#include	<analysis/KonoeLinearDataScale.hh>
#include	<analysis/KonoeDataAddress.hh>
#include 	<analysis/KonoeDataAnalyzer.hh>
#include 	<analysis/KonoeDefaultSectionAnalyzer.hh>

KonoePhysicalValueCM::KonoePhysicalValueCM( )
	: KonoeCategoryManager( KonoeCategories::PHYSICALVALUE,
			"physicalvalue" ) {

}

KonoeStreamableObject	* KonoePhysicalValueCM::create( KInt classid ) {

	switch( classid ) {
	case CID_LINEARDATASCALE :
		return new KonoeLinearDataScale();
	case CID_DATAADDRESS :
		return new KonoeDataAddress();
	}
	return 0;
}

const KChar	* KonoePhysicalValueCM::getClassName( KInt classid ) {

	switch( classid ) {
	case CID_LINEARDATASCALE :
		return KonoeLinearDataScale::className;
	case CID_DATAADDRESS :
		return KonoeDataAddress::className;
	}
	return 0;
}
