//===================================================================
/*

	KonoeRawDataset.cc

	Version 0.2.0	14-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#include	<analysis/KonoeRawDataset.hh>

const KChar	* KonoeRawDataset::dataNameList[ ] = {
	"Section ID", "Segment ID", "Subaddress", "Data" };

KonoeRawDataset::KonoeRawDataset( KInt ptablesize, KInt ptag )
	: KonoePhysicalValue( ptag ) {

	list = new KonoeList<KonoeDataMultiplet>( ptablesize );
//!!! In this implementation, this order is very important.
	specifier = new KonoeMultipletDescriptor( MULTIPLET_SIZE );

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SECTION_ID_INDEX ] ) );
	section_id_index = SECTION_ID_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SEGMENT_ID_INDEX ] ) );
	segment_id_index = SEGMENT_ID_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ SUBADDRESS_INDEX ] ) );
	subaddress_index = SUBADDRESS_INDEX;

	specifier -> add( new KonoeDataSpecifier(
			dataNameList[ DATA_INDEX ] ) );
	data_index = DATA_INDEX;


}

KInt	KonoeRawDataset::clear( ) {

	return list -> clear( );

}

KInt	KonoeRawDataset::reset( ) {

	list -> reset( );
	return 0;
}

KInt	KonoeRawDataset::getDataCount( ) {

	list -> reset( );
	return list -> getCount( );

}

KonoeDataMultiplet	* KonoeRawDataset::next( ) {

	return list -> next( );

}

KInt	KonoeRawDataset::add( KInt sectionid, KInt segmentid,
		KonoeDataElement * element ) {

	KonoeDataMultiplet	* multiplet;

	multiplet = new KonoeDataMultiplet( specifier );
	multiplet -> setValue( section_id_index, sectionid );
	multiplet -> setValue( segment_id_index, segmentid );
	multiplet -> setValue( subaddress_index, element -> getAddress( ) );
	multiplet -> setValue( data_index,
			KFloat( * ( KInt * ) element -> getStore( ) ) );
	return list -> add( multiplet );

}
