//===================================================================
/*

	KonoeRawDataset.hh

	Version 0.2.0	14-May-1998	H. Sakamoto
	Version 0.4.0	10-Sep-1998	D. Takagi
	Version 0.5.0	21-Sep-1999	Y. Kouno
	Version 0.7.0	26-Aug-2001	T. Sumida

*/
//===================================================================

#ifndef	__KONOERAWDATASET_HH
#define	__KONOERAWDATASET_HH

#include	<analysis/KonoePhysicalValue.hh>
#include	<analysis/KonoeDataElement.hh>
#include	<analysis/KonoeMultipletDescriptor.hh>

class	KonoeRawDataset	: public KonoePhysicalValue {

public :
	enum	{	MAX_MULTIPLETS = 1024	};
	enum	DATA_INDEX_	{
			SECTION_ID_INDEX,
			SEGMENT_ID_INDEX,
			SUBADDRESS_INDEX,
			DATA_INDEX,
			MULTIPLET_SIZE		};

protected :
	KonoeList<KonoeDataMultiplet>	* list;
	KonoeMultipletDescriptor	* specifier;
	KInt	section_id_index;
	KInt	segment_id_index;
	KInt	subaddress_index;
	KInt	data_index;
public :
	KonoeRawDataset( KInt ptablesize, KInt tag );
	KInt	clear( );
	KInt	reset( );
	KInt	getDataCount( );
	KonoeDataMultiplet	* next( );
	KonoeMultipletDescriptor	* getDescriptor( )
		{	return specifier;	}
	KInt	add( KInt sectionid, KInt segmentid, KonoeDataElement * e );
	static	const KChar	* dataNameList[ MULTIPLET_SIZE ];
};

#endif
