// $Id: KonoeCrateListOrderly.hh,v 1.6 2002/03/16 08:11:34 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeCrateListOrderly.hh

	Version 0.0.1	24-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   04-Aug-2000     G. Iwai
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//====================================================================
#ifndef	__KONOECRATELISTORDERLY_HH
#define	__KONOECRATELISTORDERLY_HH

#include <ui/KonoeOrderly.hh>
#include <KonoeCategories.hh>
#include <daq/KonoeDataSourceCM.hh>
#include <daq/KonoeCrateList.hh>
#include <ui/KonoeCommandProcessor.hh>

class KonoeCrateListOrderly : public KonoeOrderly {

public:
  enum { CLASS_ID = KonoeCategories::DATASOURCE 
	 + KonoeDataSourceCM::CID_CRATELIST };

  enum { CMD_CREATE, 
	 CMD_SHOW,
	 CMD_ADD,
	 CMD_GET,
	 CMD_HELP,
		CMD_INITIALIZE,
		CMD_CLEAR,
		CMD_UPDATE,
	 N_COMMANDS };

  enum { ARG_CREATE_OBJECT,
	 ARG_CREATE_SIZE,
	 N_ARG_CREATE };

  enum { ARG_SHOW_CRATE,
	 N_ARG_SHOW };

  enum { ARG_ADD_CRATE,
	 N_ARG_ADD };

  enum { ARG_GET_INDEX,
	 ARG_GET_OBJECT,
	 N_ARG_GET };

	enum	{	N_ARG_INITIALIZE	};
	enum	{	N_ARG_CLEAR		};
	enum	{	N_ARG_UPDATE		};

protected:
  static const KChar* classname;

  KonoeCrateList* target;

  KonoeCommandDescriptor* createcommand;
  KonoeCommandDescriptor* showcommand;
  KonoeCommandDescriptor* addcommand;
  KonoeCommandDescriptor* getcommand;
	KonoeCommandDescriptor	* initializecommand;
	KonoeCommandDescriptor	* clearcommand;
	KonoeCommandDescriptor	* updatecommand;

  class	CreateUnit: public KonoeCommandProcessor {
  public:
    CreateUnit(KonoeCommandDescriptor* cd, KonoeOrderly* owner);
    KInt execute(KonoeCommand* cmd);
  };

  class	ShowUnit : public KonoeCommandProcessor {
  public:
    ShowUnit(KonoeCommandDescriptor* cd, KonoeOrderly* owner);
    KInt execute(KonoeCommand* cmd);
  };

  class	AddUnit	: public KonoeCommandProcessor {
  public:
    AddUnit(KonoeCommandDescriptor* cd, KonoeOrderly* owner);
    KInt execute(KonoeCommand* cmd);
  };

  class	GetUnit	: public KonoeCommandProcessor {
  public:
    GetUnit(KonoeCommandDescriptor* cd, KonoeOrderly* owner);
    KInt execute(KonoeCommand* cmd);
  };

	class InitializeUnit : public KonoeCommandProcessor {
	public :
		InitializeUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class ClearUnit : public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class UpdateUnit : public KonoeCommandProcessor {
	public :
		UpdateUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

  CreateUnit* createunit;
  ShowUnit* showunit;
  AddUnit* addunit;
  GetUnit* getunit;
	InitializeUnit	* initializeunit;
	ClearUnit	* clearunit;
	UpdateUnit	* updateunit;

public:
  KonoeCrateListOrderly( const KChar* objname );

  inline const KChar* getClassName(){ return classname;	}

  KInt createObject(KonoeCommand* cmd);
  KInt deleteObject(KonoeCommand* cmd);
  KInt isOrderlyOf(void* address);
  KonoeOrderly* clone( const KChar* name );
  inline void* getTarget() { return (void*) target; }
};

#endif
