// $Id: KonoePT3ChipOrderly.hh,v 1.3 2002/03/16 08:11:36 iwai Exp $
// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT3ChipOrderly.hh

	Version 0.0.1	21-May-2001	H. Sakamoto

*/
//=================================================================

#ifndef	__KONOEPT3CHIPORDERLY_HH
#define	__KONOEPT3CHIPORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<daq/KonoePT3Chip.hh>
#include	<ui/KonoeCreateCommand.hh>

class	KonoePT3ChipOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::DATASOURCE +
			KonoeDataSourceCM::CID_PT3CHIP		};
	enum	{	CMD_CREATE,
			CMD_HELP,
			CMD_SHOW,
			CMD_CONFIGURE,
			N_COMMANDS	};

	enum	{	ARG_CREATE_NAME,
			N_ARG_CREATE	};

	enum	{	N_ARG_SHOW	};

	enum	{	ARG_CONFIGURE_FILE,
			N_ARG_CONFIGURE	};

protected :

	static const KChar	* classname;
	KonoePT3Chip		* target;
	KonoeCreateCommand	* createunit;

	class	ShowUnit	: public KonoeCommandProcessor {

	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ConfigureUnit	: public KonoeCommandProcessor {

	public :
		ConfigureUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoePT3ChipOrderly( const KChar * objname );
	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}
	void	setTarget( void * target );


};

#endif
