// $Id: KonoePT3ModuleOrderly.hh,v 1.4 2002/03/16 08:11:36 iwai Exp $
// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT3ModuleOrderly.hh

	Version 0.0.1	21-May-2001	H. Sakamoto
	Version 0.0.2	25-Jun-2001	H. Sakamoto

*/
//=================================================================

#ifndef	__KONOEPT3MODULEORDERLY_HH
#define	__KONOEPT3MODULEORDERLY_HH

#include	<daq/KonoeVMEModuleOrderly.hh>
#include	<daq/KonoePT3Module.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<ui/KonoeCreateCommand.hh>
#include	<ui/KonoeHelpCommand.hh>

class KonoePT3ModuleOrderly	: public KonoeVMEModuleOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::DATASOURCE +
			KonoeDataSourceCM::CID_PT3MODULE		};

	enum	{	CMD_CREATE = KonoeVMEModuleOrderly::N_COMMANDS,
			CMD_SET,
			CMD_GET,
			N_COMMANDS	};

	enum	{	ARG_CREATE_NAME,
			ARG_CREATE_ADDRESS,
			N_ARG_CREATE	};

	enum	{	ARG_SET_ITEM,
			ARG_SET_VALUE,
			N_ARG_SET		};

	enum	{	ARG_GET_INDEX,
			ARG_GET_NAME,
			N_ARG_GET		};

protected :

	static const KChar	* classname;
	KonoePT3Module		* target;
	KonoeCreateCommand	* createunit;

	class SetUnit	: public KonoeCommandProcessor {

	public :
		SetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

	class GetUnit	: public KonoeCommandProcessor {

	public :
		GetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

public :
	KonoePT3ModuleOrderly( const KChar * objname );
	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	void	* getTarget( )	{
			return ( void * ) target;	}
	KonoeOrderly	* clone( const KChar * name );

};

#endif
