// $Id: KonoePT4ModuleOrderly.hh,v 1.5 2002/03/16 08:11:37 iwai Exp $
// $Name: KONOE-0-09-02 $
//==================================================================
/*

	KonoePT4ModuleOrderly.hh

	Version 0.0.1	18-May-2001	H. Sakamoto
	Version 0.0.2	23-May-2001	H. Sakamoto

*/
//==================================================================

#ifndef	__KONOEPT4MODULEORDERLY_HH
#define	__KONOEPT4MODULEORDERLY_HH

#include	<daq/KonoeVMEModuleOrderly.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<ui/KonoeCreateCommand.hh>

class	KonoePT4Module;

class	KonoePT4ModuleOrderly	: public KonoeVMEModuleOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::DATASOURCE +
			KonoeDataSourceCM::CID_PT4MODULE		};

	enum	{	CMD_CREATE = KonoeVMEModuleOrderly::N_COMMANDS,
			CMD_SHOW,
			CMD_GET,
			N_COMMANDS	};

	enum	{	ARG_CREATE_NAME,
			ARG_CREATE_OFFSET,
			N_ARG_CREATE	};

	enum	{	ARG_SHOW_ITEM,
			N_ARG_SHOW	};

	enum	{	ARG_GET_CHIP,
			ARG_GET_NAME,
			N_ARG_GET	};


protected :

	static const KChar	* classname;
	KonoeCreateCommand	* createunit;

	class	ShowUnit	: public KonoeCommandProcessor {

	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

	class	GetUnit		: public KonoeCommandProcessor {

	public :
		GetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};


public :
	KonoePT4ModuleOrderly( const KChar * objname );
	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( ) {
			return ( void * ) target;	}

};

#endif
