// $Id: KonoeReadoutItemOrderly.hh,v 1.5 2002/03/16 08:11:37 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeReadoutItemOrderly.hh

	Version 0.0.1	11-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   04-Aug-2000     G. Iwai
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOEREADOUTITEMORDERLY_HH
#define	__KONOEREADOUTITEMORDERLY_HH

#include <ui/KonoeOrderly.hh>
#include <daq/KonoeReadoutItem.hh>
#include <KonoeCategories.hh>
#include <daq/KonoeDataListCM.hh>

class KonoeReadoutItemOrderly : public KonoeOrderly {

public:
  enum { CLASS_ID = 
	 KonoeCategories::DATALIST + KonoeDataListCM::CID_READOUTITEM };

  enum { CMD_SET,
	 CMD_SHOW,
	 CMD_GET,
	 N_COMMANDS };

  enum { ARG_SET_ITEM,
	 ARG_SET_OBJECT,
	 N_ARG_SET };

  enum { ARG_SHOW_SEGMENT,
	 N_ARG_SHOW };

  enum { ARG_GET_ITEM,
	 ARG_GET_OBJECT,
	 N_ARG_GET };

protected:
  static const KChar* classname;

  KonoeReadoutItem* target;

  KonoeCommandDescriptor* setcommand;
  KonoeCommandDescriptor* showcommand;
  KonoeCommandDescriptor* getcommand;

  class	SetUnit : public KonoeCommandProcessor {
  public:
    SetUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand* cmd);
  };

  class	ShowUnit : public KonoeCommandProcessor {
  public:
    ShowUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand* cmd);
  };

  class	GetUnit : public KonoeCommandProcessor {
  public:
    GetUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand* cmd);
  };

  SetUnit* setunit;
  ShowUnit* showunit;
  GetUnit* getunit;

public:
  KonoeReadoutItemOrderly( const KChar* name );
  inline const KChar* getClassName() const { return classname; }
};


#endif
