// $Id: KonoeReadoutSectionOrderly.hh,v 1.6 2002/03/16 08:11:38 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeReadoutSectionOrderly.hh

	Version 0.0.1	12-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   04-Aug-2000     G. Iwai
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOEREADOUTSECTIONORDERLY_HH
#define	__KONOEREADOUTSECTIONORDERLY_HH

#include <ui/KonoeOrderly.hh>
#include <daq/KonoeReadoutSection.hh>
#include <KonoeCategories.hh>
#include <daq/KonoeDataListCM.hh>

class KonoeReadoutSectionOrderly : public KonoeOrderly {

public:
  enum { CLASS_ID = 
	 KonoeCategories::DATALIST + KonoeDataListCM::CID_READOUTSECTION };

  enum { CMD_CREATE,
	 CMD_SHOW,
	 CMD_ADD,
	 CMD_GET,
	 CMD_HELP,
	 N_COMMANDS };

  enum { ARG_CREATE_OBJECT,
	 ARG_CREATE_SIZE,
	 ARG_CREATE_SECTIONTYPE,
	 N_ARG_CREATE };

  enum { ARG_SHOW_SECTION,
	 N_ARG_SHOW };

  enum { ARG_ADD_SECTION,
	 N_ARG_ADD };

  enum { ARG_GET_INDEX,
	 ARG_GET_OBJECT,
	 N_ARG_GET };

protected:
  static const KChar* classname;

  KonoeReadoutSection* target;

  KonoeCommandDescriptor* createcommand;
  KonoeCommandDescriptor* showcommand;
  KonoeCommandDescriptor* addcommand;
  KonoeCommandDescriptor* getcommand;

  class CreateUnit : public KonoeCommandProcessor {
  public:
    CreateUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand*);
  };

  class ShowUnit : public KonoeCommandProcessor {
  public:
    ShowUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand*);
  };

  class AddUnit : public KonoeCommandProcessor {
  public:
    AddUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand*);
  };

  class GetUnit : public KonoeCommandProcessor {
  public:
    GetUnit(KonoeCommandDescriptor*, KonoeOrderly*);
    KInt execute(KonoeCommand*);
  };

  CreateUnit* createunit;
  ShowUnit* showunit;
  AddUnit* addunit;
  GetUnit* getunit;

public:
  KonoeReadoutSectionOrderly(const KChar* name);
  const KChar* getClassName() { return classname; }

  KInt createObject(KonoeCommand* cmd);
  KInt deleteObject(KonoeCommand* cmd);
  KInt isOrderlyOf(void* address);
  KonoeOrderly* clone( const KChar* name);
  inline void* getTarget() { return (void*) target; }
};

#endif
