// $Id: KonoeSoftCounterOrderly.cc,v 1.5 2002/03/16 08:11:39 iwai Exp $
// $Name: KONOE-0-09-02 $
//================================================================
/*

	KonoeSoftCounterOrderly.cc

	Version 0.0.1	25-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//===================================================================

#include	<daq/KonoeSoftCounterOrderly.hh>

const KChar	* KonoeSoftCounterOrderly::classname = "SoftCounter";

KonoeSoftCounterOrderly::KonoeSoftCounterOrderly( const KChar * objname )
	: KonoeOrderly( N_COMMANDS, objname ) {

	setClassID( CLASS_ID );

	KonoeArgumentDescriptor	* ad;

	createcommand = new KonoeCommandDescriptor( "create", N_ARG_CREATE );
	createcommand -> add( ad = new KonoeArgumentDescriptor( "object",
			STRING, NECESSARY ) );
	ad -> setDescription( "Name to be assigned to the create counter" );
	createcommand -> setDescription(
		"Create a software counter" );

	createunit = new KonoeCreateCommand( createcommand, this );
	addCommand( createunit );

	helpunit = new KonoeHelpCommand( 0, this );
	addCommand( helpunit );

	showcommand = new KonoeCommandDescriptor( "show", N_ARG_SHOW );
	showcommand -> setDescription( "Show present counter value" );
	showunit = new ShowUnit( showcommand, this );
	addCommand( showunit );

}

KInt	KonoeSoftCounterOrderly::createObject( KonoeCommand * cmd ) {

	target = new KonoeSoftCounter( );

	return 0;

}

KInt	KonoeSoftCounterOrderly::deleteObject( KonoeCommand * cmd ) {

	delete target;

	return 0;

}

KInt	KonoeSoftCounterOrderly::isOrderlyOf( void * address ) {

	return address == ( void * ) target;

}

KonoeOrderly	* KonoeSoftCounterOrderly::clone( const KChar * name ) {

	return new KonoeSoftCounterOrderly( name );

}

KonoeSoftCounterOrderly::ShowUnit::ShowUnit( KonoeCommandDescriptor * cd,
		KonoeOrderly * ow ) : KonoeCommandProcessor( cd, ow ) {
}

KInt	KonoeSoftCounterOrderly::ShowUnit::execute( KonoeCommand * cmd ) {

	KonoeSoftCounter	* counter;
	ostream & os = cmd -> getOutputStream( );

	counter = ( KonoeSoftCounter * ) owner -> getTarget( );
	if( counter == 0 ) {

	    os << "KonoeSoftCounterOrderly::ShowUnit::execute"
			<< "  Null object" << endl;
	    return 0;
	}

	os << dec << counter -> getCounter( ) << " ( "
		<< hex << counter -> getCounter( ) << " )" << endl;
	return 0;

}
