// $Id: KonoeSoftCounterOrderly.hh,v 1.7 2002/03/16 08:11:39 iwai Exp $
// $Name: KONOE-0-09-02 $
//===================================================================
/*

	KonoeSoftCounterOrderly.hh

	Version 0.0.1	25-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   04-Aug-2000     G. Iwai
	Version 0.6.1	24-Nov-2000	H. Sakamoto
	Version 0.6.2	12-May-2001	H. Sakamoto
	Version 0.6.3	21-May-2001	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOESOFTCOUNTERORDERLY_HH
#define	__KONOESOFTCOUNTERORDERLY_HH

#include <ui/KonoeOrderly.hh>
#include <KonoeCategories.hh>
#include <daq/KonoeDataSourceCM.hh>
#include <daq/KonoeSoftCounter.hh>
#include <ui/KonoeCreateCommand.hh>
#include <ui/KonoeHelpCommand.hh>
#include	<ui/KonoeCommandProcessor.hh>

class KonoeSoftCounterOrderly : public KonoeOrderly {

public:
  enum { CLASS_ID = 
	 KonoeCategories::DATASOURCE + KonoeDataSourceCM::CID_SOFTCOUNTER };
  
  enum { CMD_CREATE,
	 CMD_HELP,
		CMD_SHOW,
	 N_COMMANDS };

  enum { ARG_CREATE_OBJECT,
	 N_ARG_CREATE };
	enum	{	N_ARG_SHOW	};

protected:
  static const KChar* classname;

  KonoeSoftCounter* target;

  KonoeCommandDescriptor* createcommand;
	KonoeCommandDescriptor	* showcommand;

	class ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

  KonoeCreateCommand* createunit;
  KonoeHelpCommand* helpunit;
	ShowUnit	* showunit;

public:
  KonoeSoftCounterOrderly( const KChar* objname);
  const KChar* getClassName() { return classname; }

  KInt createObject(KonoeCommand* cmd);
  KInt deleteObject(KonoeCommand* cmd);
  KInt isOrderlyOf(void* address);
  KonoeOrderly* clone( const KChar* name);
	void	* getTarget( )	{	return ( void * ) target;	}
};


#endif
