// $Id: KonoeSoftwareCrateOrderly.hh,v 1.5 2002/03/16 08:11:39 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeSoftwareCrateOrderly.hh

	Version 0.0.1	25-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//====================================================================


#ifndef	__KONOESOFTWARECRATEORDERLY_HH
#define	__KONOESOFTWARECRATEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<ui/KonoeCreateCommand.hh>
#include	<daq/KonoeSoftwareCrate.hh>


class	KonoeSoftwareCrateOrderly	: public KonoeOrderly	{

public :
	enum	{	CLASS_ID = KonoeCategories::DATASOURCE +
			KonoeDataSourceCM::CID_SOFTWARECRATE	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_ADD,
			CMD_GET,
			CMD_HELP,
			CMD_INITIALIZE,
			CMD_CLEAR,
			CMD_UPDATE,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_SIZE,
			N_ARG_CREATE	};
	enum	{	N_ARG_SHOW	};
	enum	{	ARG_ADD_MODULE,
			N_ARG_ADD	};
	enum	{	N_ARG_INITIALIZE	};
	enum	{	N_ARG_CLEAR		};
	enum	{	N_ARG_UPDATE		};

protected :

	static const KChar	* classname;

	KonoeSoftwareCrate	* target;

	KonoeCommandDescriptor	* createcommand;
	KonoeCommandDescriptor	* showcommand;
	KonoeCommandDescriptor	* addcommand;
	KonoeCommandDescriptor	* initializecommand;
	KonoeCommandDescriptor	* clearcommand;
	KonoeCommandDescriptor	* updatecommand;

	class	ShowUnit	: public KonoeCommandProcessor	{
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	AddUnit		: public KonoeCommandProcessor	{
	public :
		AddUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class InitializeUnit : public KonoeCommandProcessor {
	public :
		InitializeUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class ClearUnit : public KonoeCommandProcessor {
	public :
		ClearUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class UpdateUnit : public KonoeCommandProcessor {
	public :
		UpdateUnit( KonoeCommandDescriptor * cd,
			KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};


	KonoeCreateCommand	* createunit;
	ShowUnit	* showunit;
	AddUnit		* addunit;
	InitializeUnit	* initializeunit;
	ClearUnit	* clearunit;
	UpdateUnit	* updateunit;

public :

	KonoeSoftwareCrateOrderly( const KChar * objname );
	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{	return ( void * ) target;	}

};


#endif
