// $Id: KonoeVMECrateOrderly.hh,v 1.5 2002/03/16 08:11:40 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeVMECrateOrderly.hh

	Version 0.0.1	24-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//====================================================================

#ifndef	__KONOEVMECRATEORDERLY_HH
#define	__KONOEVMECRATEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<daq/KonoeVMECrate.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<ui/KonoeCreateCommand.hh>


class	KonoeVMECrateOrderly	: public KonoeOrderly	{

public :
	enum	{	CLASS_ID = KonoeCategories::DATASOURCE +
			KonoeDataSourceCM::CID_VMECRATE		};
	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_ADD,
			CMD_GET,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_MODE,
			ARG_CREATE_BASE,
			ARG_CREATE_WINDOW,
			ARG_CREATE_SLOTS,
			N_ARG_CREATE	};
	enum	{	ARG_SHOW_MODULE,
			N_ARG_SHOW	};
	enum	{	ARG_ADD_MODULE,
			N_ARG_ADD	};
	enum	{	ARG_GET_INDEX,
			ARG_GET_OBJECT,
			N_ARG_GET	};
	enum	{	DEFAULT_SLOT_COUNT = 20		};

protected :

	static const KChar	* classname;

	KonoeVMECrate	* target;

	KonoeCommandDescriptor	* createcommand;
	KonoeCommandDescriptor	* showcommand;
	KonoeCommandDescriptor	* addcommand;
	KonoeCommandDescriptor	* getcommand;

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	AddUnit	: public KonoeCommandProcessor {
	public :
		AddUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	GetUnit	: public KonoeCommandProcessor {
	public :
		GetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	KonoeCreateCommand	* createunit;
	ShowUnit	* showunit;
	AddUnit		* addunit;
	GetUnit		* getunit;

public :

	KonoeVMECrateOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( ) {
			return ( void * ) target;	}


};


#endif
