// $Id: KonoeVMEModuleOrderly.hh,v 1.3 2002/03/16 08:11:40 iwai Exp $
// $Name: KONOE-0-09-02 $
//==================================================================
/*

	KonoeVMEModuleOrderly.hh

	Version 0.0.1	18-May-2001	H. Sakamoto
	Version 0.0.2	25-May-2001	H. Sakamoto

*/
//==================================================================

#ifndef	__KONOEVMEMODULEORDERLY_HH
#define	__KONOEVMEMODULEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<KonoeCategories.hh>
#include	<daq/KonoeDataSourceCM.hh>
#include	<ui/KonoeCreateCommand.hh>
#include	<ui/KonoeSymbolResolverList.hh>

class	KonoeVMEModule;

class	KonoeVMEModuleOrderly	: public KonoeOrderly {

public :

	enum	{	CMD_HELP,
			CMD_DUMP,
			CMD_WRITE,
			CMD_READ,
			N_COMMANDS	};

	enum	{	ARG_DUMP_OFFSET,
			ARG_DUMP_SIZE,
			N_ARG_DUMP	};

	enum	{	ARG_WRITE_OFFSET,
			ARG_WRITE_PATTERN,
			N_ARG_WRITE	};

	enum	{	ARG_READ_OFFSET,
			ARG_READ_SYMBOL,
			N_ARG_READ	};


protected :

	KonoeSymbolResolverList	* resolverlist;

	KonoeVMEModule	* target;

	class	DumpUnit	: public KonoeCommandProcessor {

	public :
		DumpUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	WriteUnit	: public KonoeCommandProcessor {

	public :
		WriteUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ReadUnit	: public KonoeCommandProcessor {

	public :
		ReadUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );
		void	setResolverList( KonoeSymbolResolverList * list );
	};


public :
	KonoeVMEModuleOrderly( const KChar * objname, KInt ncommandds );
	void	setTarget( void * target );
	KInt	isOrderlyOf( void * address );
	void	setResolverList( KonoeSymbolResolverList * list );
	KonoeSymbolResolverList	* getResolverList( )	{
			return resolverlist;		}

};

#endif
