// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutItem.cc,v 1.7 2002/03/16 08:11:42 iwai Exp $
//===================================================================
/*

	KonoeReadoutItem.cc

	Version 0.1	22-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	 5-Nov-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================

#include <daq/KonoeReadoutItem.hh>

KonoeReadoutItem::KonoeReadoutItem( KonoeDAQModuleBase* pmodule,
				    KInt ptag, KInt pmode, KInt ptype )
{
  module = pmodule;
  subaddress = 0;
  tag = ptag;
  mode = pmode;
  type = ptype;
}

KonoeReadoutItem::KonoeReadoutItem( KonoeDAQModuleBase* pmodule,
				    KonoeModuleSubaddress* psubaddress, 
				    KInt pmode, KInt ptype ) 
{
  module = pmodule;
  subaddress = psubaddress;
  tag = subaddress -> getOffset( );
  mode = pmode;
  type = ptype;
}

KonoeDataElement* KonoeReadoutItem::read()
{
  KonoeDataElement* r;
  if ( subaddress == 0 ) {
    r = new KonoeDataElement( type, tag, module -> getDataSize() );
    // temporary subaddress object
    subaddress = new KonoeModuleSubaddress( 0, tag, 0 );
    module -> fillData( r, subaddress );
    // revised by G. Iwai
    // r = new KonoeDataElement( type, tag, module -> getDataSize() );
    // module -> fillData( r, 0 );
  } else {
    r = new KonoeDataElement( type, tag, subaddress -> getSize() );
    module -> fillData( r, subaddress );
  }
  return r;
}

void KonoeReadoutItem::dump( ostream& os )
{
  os << "Readout Item. Mode = " << mode
     << "  Type = " << type << "  Tag = " << tag << endl;
  module -> dump( os );
  return;
}
