// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutItem.hh,v 1.6 2002/03/16 08:11:42 iwai Exp $
// $Id: KonoeReadoutItem.hh,v 1.6 2002/03/16 08:11:42 iwai Exp $
//===================================================================
/*

	KonoeReadoutItem.hh

	Version 0.1	22-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	 5-Nov-1997	H. Sakamoto
	Version 0.0.1	10-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================
#ifndef	__KONOEREADOUTITEM_HH
#define	__KONOEREADOUTITEM_HH
#include <daq/KonoeDAQModuleBase.hh>
#include <analysis/KonoeDataElement.hh>
#include <daq/KonoeModuleSubaddress.hh>

class KonoeReadoutItem {

public:
  enum { FIXED_SIZE, VARIABLE_LENGTH };

protected:
  KonoeDAQModuleBase* module;
  KonoeModuleSubaddress* subaddress;
  KInt mode;
  KInt tag;
  KInt type;	// KonoeDataElement::INT/FLOAT/CHAR

public:
  KonoeReadoutItem( KonoeDAQModuleBase* pmodule,
		    KInt ptag,
		    KInt pmode = FIXED_SIZE,
		    KInt ptype = KonoeDataElement::INT );
  KonoeReadoutItem( KonoeDAQModuleBase* module,
		    KonoeModuleSubaddress* subaddress,
		    KInt mode = FIXED_SIZE,
		    KInt type = KonoeDataElement::INT );

  KonoeDataElement* read();
  void dump( ostream& os );

};

#endif
