// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutList.cc,v 1.4 2002/03/16 08:11:42 iwai Exp $
//===================================================================
/*

	KonoeReadoutList.cc

	Version 0.1	23-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================

#include <daq/KonoeReadoutList.hh>

KonoeReadoutList::KonoeReadoutList( KInt ptablesize, KInt precordtype )
  : KonoeList<KonoeReadoutSection>( ptablesize ) 
{
  recordtype = precordtype;
}

KonoeReadoutList::~KonoeReadoutList()
{;}

KonoeDataRecord* KonoeReadoutList::read()
{
  KonoeReadoutSection* p;
  KonoeDataRecord* r;

  r = new KonoeDataRecord( n_entries, recordtype );
  reset();
  while ( p = next() )
    r -> add( p -> read() );
  return r;
}


void KonoeReadoutList::dump( ostream& os )
{
  KonoeReadoutSection* p;

  os << "Readout Record type = " << recordtype
     << "  # entries = " << n_entries << endl;
  reset();
  while ( p = next() )
    p -> dump( os );
  return;
}
