// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutSection.cc,v 1.5 2002/03/16 08:11:42 iwai Exp $
//=================================================================
/*

	KonoeReadoutSection.cc

	Version 0.1	23-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//=================================================================

#include <daq/KonoeReadoutSection.hh>

KonoeReadoutSection::KonoeReadoutSection( KInt ptablesize, KInt psectiontype )
  : KonoeList<KonoeReadoutSegment>( ptablesize ) 
{
  sectiontype = psectiontype;
}

KonoeReadoutSection::~KonoeReadoutSection()
{;}

KonoeDataSection* KonoeReadoutSection::read()
{
  KonoeReadoutSegment* p;
  KonoeDataSection* r;
  r = new KonoeDataSection( n_entries, sectiontype );
  reset();
  while ( p = next() )
    r -> add( p -> read() );
  return r;
}

void KonoeReadoutSection::dump( ostream& os )
{
  KonoeReadoutSegment* p;

  os << "Section type = " << sectiontype
     << "  # segments = " << n_entries << endl;
  reset();
  while ( p = next() )
    p -> dump( os );
  return;
}
