// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutSegment.cc,v 1.7 2002/03/16 08:11:43 iwai Exp $
//==================================================================
/*

	KonoeReadoutSegment.cc

	Version 0.1	23-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================
#include <daq/KonoeReadoutSegment.hh>

KonoeReadoutSegment::KonoeReadoutSegment( KInt ptablesize, KInt psegmenttag )
  : KonoeList<KonoeReadoutItem>( ptablesize )
{
  module = 0;
  segmenttag = psegmenttag;
  segmenttype = READ_ELEMENT;
}

KonoeReadoutSegment::KonoeReadoutSegment( KonoeDAQModuleBase* pmodule, 
					  KInt psegmenttag )
  : KonoeList<KonoeReadoutItem>(0)
{
  module = pmodule;
  if ( psegmenttag == -1 )
    psegmenttag = module -> getSegmentID();
  else
    segmenttag = psegmenttag;
  segmenttype = READ_MODULE;
}

KonoeReadoutSegment::~KonoeReadoutSegment()
{;}

KonoeDataSegment* KonoeReadoutSegment::read()
{
  KonoeReadoutItem* p;
  KonoeDataSegment* r;

  if ( segmenttype == READ_ELEMENT ) {
    r = new KonoeDataSegment( n_entries, segmenttag );
    reset();
    while ( p = next() )
      r -> add( p -> read() );
    return r;
  } else {
    return module -> getDataSegment( segmenttag );
  }
}

void KonoeReadoutSegment::dump( ostream& os )
{
  KonoeReadoutItem* p;

  os << "Segment type = " << segmenttype
     << "  Segment tag = " << segmenttag;

  if ( segmenttype == READ_ELEMENT ) {
    os << "  # items = " << n_entries << endl;
    reset();
    while ( p = next() )
      p -> dump( os );
  } else {
    module -> dump( os );
  }

  return;
}
