// $Name: KONOE-0-09-02 $
// $Id: KonoeReadoutSegment.hh,v 1.5 2002/03/16 08:11:43 iwai Exp $
//==================================================================
/*

	KonoeReadoutSegment.hh

	Version 0.1	23-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================
#ifndef	__KONOEREADOUTSEGMENT_HH
#define	__KONOEREADOUTSEGMENT_HH

#include <daq/KonoeReadoutItem.hh>
#include <analysis/KonoeDataSegment.hh>
#include <KonoeList.hh>

// ======================================================================
// There are two kinds of ReadoutSegments. One is those who have their
// substructure consisting from ReadoutItems. The other reads directory a
// module which returns a data segment directly.
//
// They are identified by their constructors.
// ======================================================================

class KonoeReadoutSegment : public KonoeList<KonoeReadoutItem> {

public:
  enum { READ_ELEMENT, READ_MODULE };

protected:
  KInt segmenttype;
  KInt segmenttag;
  KonoeDAQModuleBase* module;

public:
  KonoeReadoutSegment( KInt ptablesize, KInt psegmenttag );
  KonoeReadoutSegment( KonoeDAQModuleBase* pmodule, KInt psegmenttag = -1 );
  ~KonoeReadoutSegment();

  KonoeDataSegment* read();
  void dump( ostream& os );
};

#endif
