// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACADC.cc,v 1.9 2002/03/16 08:11:45 iwai Exp $
//==================================================================
/*

	KonoeCAMACADC.cc

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACADC.hh>

KonoeCAMACADC::KonoeCAMACADC(const KonoeCAMACCrate* crate, 
			     KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC16bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACADC::fillData(KonoeDataElement* anElement, 
			     KonoeModuleSubaddress* subAddress)
{
  this -> read( subAddress -> getA() );
  KInt data = (KInt)( getData() );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACADC::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );
  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    this -> read(i);
    KInt data = (KInt)( getData() );
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i, data) );
  }
  return segment;
}

void KonoeCAMACADC::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACADC::clear()
{
  execute(0,9);
  this -> disableLAM();
  return;
}

void KonoeCAMACADC::update()
{
  this -> clear();
  return;
}
