// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACCoincidenceRegister.cc,v 1.6 2002/03/16 08:11:46 iwai Exp $
//==================================================================
/*

	KonoeCAMACCoincidenceRegister.cc

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACCoincidenceRegister.hh>

KonoeCAMACCoincidenceRegister::
KonoeCAMACCoincidenceRegister( const KonoeCAMACCrate* crate, 
			       KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC16bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACCoincidenceRegister::
fillData( KonoeDataElement* anElement, KonoeModuleSubaddress* subAddress )
{
  // Channels of Coincidence Register are for example 1 to 16.
  // Not 0 to 15 !
  this -> read();
  KUShort tmp = getData();
  KInt address = subAddress -> getA();
  tmp = tmp >> ( address - 1 );
  KInt data = (KInt)( tmp & 1 );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACCoincidenceRegister::
getDataSegment( KInt segmentTag )
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );
  this -> read();
  KUShort tmp = getData();
  KInt data;

  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    tmp = tmp >> i;
    data = (KInt)( tmp & 1);
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i, data) );
  }

  return segment;
}

void KonoeCAMACCoincidenceRegister::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACCoincidenceRegister::update()
{
  this -> clear();
  return;
}
