// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACInterruptRegister.cc,v 1.10 2002/03/16 08:11:47 iwai Exp $
//==================================================================
/*

	KonoeCAMACInterruptRegister.cc

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACInterruptRegister.hh>

KonoeCAMACInterruptRegister::
KonoeCAMACInterruptRegister(const KonoeCAMACCrate* crate, 
			    KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC16bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACInterruptRegister::fillData(KonoeDataElement* anElement, 
					   KonoeModuleSubaddress* subAddress)
{
   this -> read();
   KInt lam = (KInt)( getData() );
   this -> readMask();
   KInt mask = (KInt)( getData() );
   mask = ~mask;
   KInt address = subAddress -> getA();
  
   KInt data = lam & mask;
   data = data >> (address - 1);
   data = data & 1;

   anElement -> fill( &data, 1 );
   return data;
}

KonoeDataSegment* KonoeCAMACInterruptRegister::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );

  this -> read();
  KInt lam = (KInt)( getData() );
  this -> readMask();
  KInt mask = (KInt)( getData() );
  KInt data = lam ^ mask;
  
  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    KInt tmp = data >> i;
    tmp = tmp & 1;
    // Channels of Interrupt Register are for example 1 to 8.
    // Not 0 to 7 !
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i+1, tmp) );
  }
  return segment;
}

void KonoeCAMACInterruptRegister::initialize()
{
  this -> clearLAM();
  this -> clearMask();
  return;
}

void KonoeCAMACInterruptRegister::clear()
{
  this -> clearLAM();
  return;
}

void KonoeCAMACInterruptRegister::update()
{
  this -> clear();
  return;
}

KInt KonoeCAMACInterruptRegister::read(KInt subAddress)
{
  this -> read();
  KInt lam = (KInt)( getData() );
  this -> readMask();
  KInt mask = (KInt)( getData() );
  KInt data = lam ^ mask;
  data = data >> (subAddress - 1);
  data = data & 1;
  return (data);
}
