// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACInterruptRegister.hh,v 1.10 2002/03/16 08:11:47 iwai Exp $
//==================================================================
/*

	KonoeCAMACInterruptRegister.hh

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#ifndef __KONOECAMACINTERRUPTREGISTER_HH
#define __KONOECAMACINTERRUPTREGISTER_HH

#include <daq/KonoeCAMAC16bitModule.hh>

class KonoeCAMACInterruptRegister : public KonoeCAMAC16bitModule {

public:
  KonoeCAMACInterruptRegister(const KonoeCAMACCrate* crate, 
			      KInt aStationNumber, KInt aChannel = 8);
  ~KonoeCAMACInterruptRegister(){;}

  // read LAM pattern and disable LAM
  inline void readPattern() { execute(0,0); }
  // read LAM register
  inline void read() { execute(1,0); }
  // read LAM mask register
  inline void readMask() { execute(0,1); }

  //clear LAM register
  inline void clearLAM() { execute(0,9); }
  //clear LAM mask register
  inline void clearMask() { execute(0,11); }
  //clear LAM register and enable LAM
  inline void clearEnable() { execute(0,21); }

  // write LAM mask register
  inline void writeMask(KUShort aData) { setData(aData); execute(0,17); }

  inline void testLAM() { execute(0,8); }
  inline void disableLAM() { execute(0,24); }
  inline void enableLAM() { execute(0,26); }
  inline void disableLAMoutput() { execute(1,24); }
  inline void enableLAMoutput() { execute(1,26); }
  
  KonoeDataSegment* getDataSegment(KInt segmentTag);
  KInt fillData( KonoeDataElement* pelement, 
		 KonoeModuleSubaddress* subAddress = 0 ); 
  KInt read(KInt subAddress);
  void initialize();
  void update();
  void clear();

};

#endif
