// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACScaler.cc,v 1.6 2002/03/16 08:11:48 iwai Exp $
//==================================================================
/*

	KonoeCAMACScaler.cc

	Version 0.6.0	24-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACScaler.hh>

KonoeCAMACScaler::KonoeCAMACScaler(const KonoeCAMACCrate* crate,
				   KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC24bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACScaler::fillData(KonoeDataElement* anElement, 
				KonoeModuleSubaddress* subAddress)
{
  this -> read( subAddress -> getA() );
  KInt data = (KInt)( getData() );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACScaler::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );
  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    this -> read(i);
    KInt data = (KInt)( getData() );
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i, data) );
  }
  return segment;  
}

void KonoeCAMACScaler::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACScaler::clear()
{
  execute(0,9);
  this -> clearOverflow();
  return;
}

void KonoeCAMACScaler::update()
{
  this -> increase();
  return;
}
