// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACScaler.hh,v 1.6 2002/03/16 08:11:48 iwai Exp $
//==================================================================
/*

	KonoeCAMACScaler.hh

	Version 0.6.0	24-Mar-2000	G. Iwai

*/
//==================================================================
#ifndef __KONOECAMACSCALER_HH
#define __KONOECAMACSCALER_HH

#include <daq/KonoeCAMAC24bitModule.hh>

class KonoeCAMACScaler : public KonoeCAMAC24bitModule {

public:
  KonoeCAMACScaler(const KonoeCAMACCrate* crate, 
		   KInt aStationNumber, KInt aChannel = 12 );
  ~KonoeCAMACScaler() {;}

  inline void read(KInt subAddress) { execute(subAddress,0); }
  // reading overflow channel
  inline void readOverflow() { execute(0,1); }
  // clear overflow
  inline void clearOverflow() { this -> execute(0,10); }
  inline void increase() { this -> execute(0,25); }

  KonoeDataSegment* getDataSegment(KInt segmentTag);
  KInt fillData( KonoeDataElement* pelement, 
		 KonoeModuleSubaddress* subAddress = 0 ); 
  void initialize();
  void update();
  void clear();
};

#endif
