// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACSlowADC.cc,v 1.4 2002/03/16 08:11:48 iwai Exp $
//==================================================================
/*

	KonoeCAMACSlowADC.cc

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACSlowADC.hh>

KonoeCAMACSlowADC::KonoeCAMACSlowADC(const KonoeCAMACCrate* crate, 
				     KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC16bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACSlowADC::fillData(KonoeDataElement* anElement, 
				 KonoeModuleSubaddress* subAddress)
{
  this -> read( subAddress -> getA() );
  KInt data = (KInt)( getData() );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACSlowADC::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );
  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    this -> read(i);
    KInt data = (KInt)( getData() );
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i, data) );
  }
  return segment;
}

void KonoeCAMACSlowADC::read( KInt subAddress )
{
  if ( ( subAddress > 0 ) && ( subAddress < 16 ) ) 
    execute( subAddress, 0 );
  else if ( ( subAddress > 15 ) && ( subAddress < 32 ) )
    execute( ( subAddress - 16 ), 1 );
  return;
}

void KonoeCAMACSlowADC::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACSlowADC::clear()
{
  execute(0,9);
  return;
}

void KonoeCAMACSlowADC::update()
{
  this -> clear();
  return;
}
