// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACSwitchRegister.cc,v 1.13 2002/07/30 19:14:28 iwai Exp $
//==================================================================
/*

	KonoeCAMACSwitchRegister.cc

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACSwitchRegister.hh>

KonoeCAMACSwitchRegister::
KonoeCAMACSwitchRegister(const KonoeCAMACCrate* crate, 
			 KInt aStationNumber, KInt aChannel )
  : KonoeCAMAC24bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACSwitchRegister::fillData(KonoeDataElement* anElement, 
					KonoeModuleSubaddress* subAddress)
{
  this -> readSwitch();
  KInt data = (KInt)( getData() );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACSwitchRegister::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( 1, segmentTag );
  this -> readSwitch();
  KInt data = (KInt)( getData() );
  segment -> add( new KonoeDataElement(KonoeDataElement::INT, 0, data) );
  return segment;
}

void KonoeCAMACSwitchRegister::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACSwitchRegister::clear()
{
  this -> clearLAM();
  this -> disableLAM();
  return;
}

void KonoeCAMACSwitchRegister::update()
{
  this -> clear();
  return;
}
