// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACSwitchRegister.hh,v 1.11 2002/03/16 08:11:49 iwai Exp $
//==================================================================
/*

	KonoeCAMACSwitchRegister.hh

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#ifndef __KONOECAMACSWITCHREGISTER_HH
#define __KONOECAMACSWITCHREGISTER_HH

#include <daq/KonoeCAMAC24bitModule.hh>

class KonoeCAMACSwitchRegister : public KonoeCAMAC24bitModule {

public:
  KonoeCAMACSwitchRegister(const KonoeCAMACCrate* crate, 
			   KInt aStationNumber, KInt aChannel = 1);
  ~KonoeCAMACSwitchRegister() {;}

  inline void read() { execute(0,0); }
  inline void readSwitch() { this -> execute(1,0); }
  inline void write(KUInt aData) { setData(aData); execute(0,16); }
  inline void testLAM() { execute(0,8); }
  inline void clearLAM() { execute(0,10); }
  inline void disableLAM() { execute(0,24); }
  inline void enableLAM() { execute(0,26); }

  KonoeDataSegment* getDataSegment( KInt segmentTag );
  KInt fillData( KonoeDataElement* pelement, 
		 KonoeModuleSubaddress* subAddress = 0 ); 
  void initialize();
  void clear();
  void update();
};

#endif

