// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACTDC.cc,v 1.7 2002/03/16 08:11:49 iwai Exp $
//==================================================================
/*

	KonoeCAMACTDC.hh

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#include <daq/KonoeCAMACTDC.hh>

KonoeCAMACTDC::KonoeCAMACTDC(const KonoeCAMACCrate* crate, 
			     KInt aStationNumber, KInt aChannel)
  : KonoeCAMAC16bitModule(crate, aStationNumber, aChannel)
{;}

KInt KonoeCAMACTDC::fillData(KonoeDataElement* anElement, 
			     KonoeModuleSubaddress* subAddress)
{
  KInt data = (KInt)( getData() );
  anElement -> fill( &data, 1 );
  return data;
}

KonoeDataSegment* KonoeCAMACTDC::getDataSegment(KInt segmentTag)
{
  KonoeDataSegment* segment 
    = new KonoeDataSegment( numberOfChannel, segmentTag );
  for ( KInt i = 0; i < numberOfChannel; i++ ) {
    this -> read(i);
    KInt data = (KInt)( getData() );
    segment -> add( new KonoeDataElement(KonoeDataElement::INT, i, data) );
  }
  return segment;
}

void KonoeCAMACTDC::initialize()
{
  this -> clear();
  return;
}

void KonoeCAMACTDC::clear()
{
  execute(0,9);
  this -> disableLAM();
  return;
}

void KonoeCAMACTDC::update()
{
  this -> clear();
  return;
}
