// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACTDC.hh,v 1.8 2002/03/16 08:11:49 iwai Exp $
//==================================================================
/*

	KonoeCAMACTDC.hh

	Version 0.6.0	06-Mar-2000	G. Iwai

*/
//==================================================================
#ifndef __KONOECAMACTDC_HH
#define __KONOECAMACTDC_HH

#include <daq/KonoeCAMAC16bitModule.hh>

class KonoeCAMACTDC : public KonoeCAMAC16bitModule {

public:
  KonoeCAMACTDC(const KonoeCAMACCrate* crate, KInt aStationNumber,
		KInt aChannel = 8);
  ~KonoeCAMACTDC() {;}

  inline void read(KInt subAddress) { execute(subAddress,0); }
  inline void testLAM(KInt subAddress) { execute(subAddress,8); }
  inline void clearLAM() { execute(0,10); }
  inline void test() { execute(0,25); }
  inline void disableLAM() { execute(0,24); }
  inline void enableLAM() { execute(0,26); }

  KonoeDataSegment* getDataSegment(KInt segmentTag);
  KInt fillData( KonoeDataElement* pelement, 
		 KonoeModuleSubaddress* subAddress = 0 ); 
  void initialize();
  void clear();
  void update();
};

#endif
