// $Name: KONOE-0-09-02 $
// $Id: KonoeClockModule.cc,v 1.3 2002/04/09 22:48:08 iwai Exp $
//====================================================================
/*

	KonoeClockModule.cc

        Version 0.6.0   09-Nov-2000     G. Iwai

*/
//====================================================================
#include <iostream.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <daq/KonoeClockModule.hh>

static const KChar* dateformat = "%Y/%m/%d";
static const KChar* timeformat = "%H:%M:%S";

KonoeClockModule::KonoeClockModule()
  : KonoeSoftwareModule( KonoeClockModule::MODULE_TYPE ),
    theLocalTime( NULL ), theLocalDate( NULL ), thePastTime( 0 )
{
  theLocalTime = new KChar[ size_t( TIME_LENGTH ) ];
  theLocalDate = new KChar[ size_t( DATE_LENGTH ) ];
  setCurrent();
}

KonoeClockModule::~KonoeClockModule()
{
  delete [] theLocalTime;
  delete [] theLocalDate;
}

KonoeDataSegment* KonoeClockModule::getDataSegment( KInt segmentTag )
{
  return( 0 );
}

KInt KonoeClockModule::fillData( KonoeDataElement* anElement,
 				 KonoeModuleSubaddress* subAddress ) 
{
  // We must implement KonoeDataElement::fillPrimitiveMember()
  // member function for KCHAR_TYPE.
  // Now, this function has only facility fill KINT_TYPE.

  anElement -> fill( &thePastTime, 1 );
  return( 1 );
}

void KonoeClockModule::initialize()
{
  thePastTime = 0;
  strcpy( theLocalTime, "" );
  strcpy( theLocalDate, "" );

  return;
}

void KonoeClockModule::clear()
{
  thePastTime = 0;
  strcpy( theLocalTime, "" );
  strcpy( theLocalDate, "" );

  return;
}

void KonoeClockModule::update()
{
  setCurrent();
  return;
}

void KonoeClockModule::dump( ostream& os ) const
{
  os << "  KonoeClockModule" << endl;
  os << "    past time " << thePastTime << " [sec],";
  os << "  clock " << theLocalDate << " " << theLocalTime << endl;
  return;
}

void KonoeClockModule::setCurrent()
{
  time_t time_now;
  thePastTime = ( KInt )time( &time_now );
  struct tm* tm_now = localtime( &time_now );
  strftime( theLocalTime, (size_t)TIME_LENGTH, timeformat, tm_now );
  strftime( theLocalDate, (size_t)DATE_LENGTH, dateformat, tm_now );
  return;
}
