// $Id: KonoeClockModule.hh,v 1.4 2002/04/09 22:47:57 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeClockModule.hh
	
        Version 0.6.0   09-Nov-2000     G. Iwai

*/
//====================================================================
#ifndef	__KONOECLOCKMODULE_HH
#define	__KONOECLOCKMODULE_HH

#include <daq/KonoeSoftwareModule.hh>

class ostream;

class KonoeClockModule : public KonoeSoftwareModule {

private:
  enum { DATE_LENGTH = 11, TIME_LENGTH = 9 };
  enum { MODULE_TYPE = 1 };

private:
  // The unit of this member is second from 1970/1/1.
  KInt thePastTime;
  KChar* theLocalDate;
  KChar* theLocalTime;

private:
  void setCurrent();
  
public:
  KonoeClockModule();
  ~KonoeClockModule();

  // utilities
  KInt fillData( KonoeDataElement* anElement, 
 		 KonoeModuleSubaddress* subAddress = 0 );
  KonoeDataSegment* getDataSegment(KInt segmentTag);

  inline KInt getDataSize() { return( 1 ); }

  void initialize();
  void clear();
  void update();


  inline KInt getPastTime() const { return( thePastTime ); }
  inline KChar* getLocalTime() const { return( theLocalTime ); }
  inline KChar* getLocalDate() const { return( theLocalDate ); }
  void dump( ostream& os = cout ) const;

};

#endif
