// $Name: KONOE-0-09-02 $
// $Id: KonoeDAQModuleBase.hh,v 1.7 2002/03/16 08:11:51 iwai Exp $
//==================================================================
/*

	KonoeDAQModuleBase.hh

	Version 0.1	15-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.2.0	12-May-1998	H. Sakamoto
	Version 0.2.1	09-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   06-Mar-2000     G. Iwai

*/
//==================================================================
#ifndef	__KONOEDAQMODULEBASE_HH
#define	__KONOEDAQMODULEBASE_HH

#include <KonoePrimitives.hh>
#include <analysis/KonoeDataSegment.hh>
#include <daq/KonoeModuleSubaddress.hh>

class KonoeDAQModuleBase {

protected:
  KInt id;
  KInt section_id;
  KInt segment_id;

public:
  KonoeDAQModuleBase();
  KonoeDAQModuleBase(const KInt pid);
  KonoeDAQModuleBase(KInt psectionid, KInt psegmentid, KInt pid=0);
  inline KInt getID() const { return id; }
  inline void setID(const KInt pid) { id=pid; }

  inline KInt getSectionID() const { return section_id; }
  inline KInt getSegmentID() const { return segment_id; }

  virtual void initialize() = 0;
  virtual void clear() = 0;
  virtual void update() = 0;

  virtual KInt getDataSize() = 0;
  virtual KInt fillData(KonoeDataElement* pelement, 
			KonoeModuleSubaddress* subaddress) = 0;
  virtual void dump(ostream& os) 
  { os << "  Module ID = " << id << endl; }
  virtual KonoeDataSegment* getDataSegment(KInt) { return 0; }
};

#endif
