// $Name: KONOE-0-09-02 $
// $Id: KonoeHardwareModule.hh,v 1.9 2002/03/16 08:11:52 iwai Exp $
//====================================================================
/*

	KonoeHardwareModule.hh

	Version 0.1	15-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   06-Mar-2000     G. Iwai

*/
//====================================================================
#ifndef	__KONOEHARDWAREMODULE_HH
#define	__KONOEHARDWAREMODULE_HH

#include <daq/KonoeDAQModuleBase.hh>

class KonoeHardwareModule : public KonoeDAQModuleBase {

public:
  enum { OFFLINE, ONLINE };

protected:
  KInt status;
  KonoeDAQModuleBase* alternate;

public:
  KonoeHardwareModule();
  ~KonoeHardwareModule();
  
  inline void setOnline(KInt flag) 
  { status = flag; }
  inline void setAlternate(KonoeDAQModuleBase* palternate) 
  { alternate = palternate; }
  inline KonoeDAQModuleBase* getAlternate() const
  { return alternate; }

  virtual void initialize();
  virtual void clear();
  virtual void update();

};

#endif
