// $Name: KONOE-0-09-02 $
// $Id: KonoeOptionalNumberModule.hh,v 1.2 2002/03/16 08:11:53 iwai Exp $
//====================================================================
/*

	KonoeOptionalNumberModule.hh

        Version 0.6.0   09-Nov-2000     G. Iwai

*/
//====================================================================
#ifndef	__KONOEOPTIONALNUMBERMODULE_HH
#define	__KONOEOPTIONALNUMBERMODULE_HH

#include <daq/KonoeSoftwareModule.hh>

class KonoeOptionalNumberModule : public KonoeSoftwareModule {

public:
  enum { MODULE_TYPE = 1 };

private:
  KInt theNumber;
  KInt theUpdateValue;

public:
  KonoeOptionalNumberModule();
  KonoeOptionalNumberModule( KInt aNumber );
  KonoeOptionalNumberModule( KInt aNumber, KInt aUpdateValue );
  ~KonoeOptionalNumberModule() {;}

  // utilities
  KInt fillData( KonoeDataElement* aElement, 
		 KonoeModuleSubaddress* subAddress = 0 );

  inline KInt getDataSize() { return (1); }
  inline void initialize() { this -> theNumber = 0; }
  inline void clear() { this -> theNumber = 0; }
  inline void update() { this -> theNumber += (this->theUpdateValue); }

  // set/get member functions
  inline KInt getNumber() const { return ( this -> theNumber ); }
  inline void setNumber( KInt value ) { this -> theNumber = value; }
  inline KInt getUpdateValue() const { return ( this -> theUpdateValue ); }
  inline void setUpdateValue( KInt value ) { this -> theUpdateValue = value; }

};

#endif
