// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT3Chip.hh

	Version 0.0.1	14-Apr-2001	H. Sakamoto

	-------------------------------------------

	Spartan chip class for PT3 module

*/
//=================================================================

#ifndef	__KONOEPT3CHIP_HH
#define	__KONOEPT3CHIP_HH

#include	<iostream.h>

#include	<daq/KonoePT3Module.hh>

class	KonoePT3Chip	{

public :
	enum	{	PIN_PROGRAM,	PIN_INIT,	PIN_HDC,
			PIN_DONE	};
	enum	{	CHECK_INTERVAL	= 1024		};
	enum	{	CLK_INTERNAL		= 0,
			CLK_HALF_INTERNAL	= 1,
			CLK_QUARTER_INTERNAL	= 2,
			CLK_EXTERNAL_1		= 4,
			CLK_EXTERNAL_2		= 5,
			CLK_VME_ACCESS		= 6	};

protected :

	KonoePT3Module	* module;
	KInt	chip_number;
	KInt	address_offset;
	KInt	bit_mask;

public :
	KonoePT3Chip( KonoePT3Module * module, KInt chip );
	void	showStatus( ostream & os );
	void	erase( );
	KInt	configure( const KChar * rbtfile );
	KInt	getPinState( KInt pin_id );
	void	setPinState( KInt pin_id, KInt stat );
	void	setPCLKMode( KInt clockmode );
	KInt	getPCLKMode( );
	void	setSCLKMode( KInt clockmode );
	KInt	getSCLKMode( );

};


#endif
