// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT3Module.hh

	Version 0.0.1	13-Apr-2001	H. Sakamoto

	-------------------------------------------

	PT3 FPGA module class

*/
//=================================================================

#ifndef	__KONOEPT3MODULE_HH
#define	__KONOEPT3MODULE_HH

#include	<daq/KonoeVMEModule.hh>

class KonoePT3Chip;

class KonoePT3Module	: public KonoeVMEModule {

public :
	enum	{
		S_RESET		= 0x00,
		S_PROGRAM	= 0x02,
		S_INIT		= 0x04,
		S_DONE_HDC	= 0x06,
		S_IRQ_LEVEL	= 0x08,
		S_LED_TEST	= 0x0a,
		S_VME_CLOCK	= 0x0e,
		S_JTAG_SRC	= 0x10,
		S_VME_JTAG	= 0x12,
		S_CLOCK_OUT	= 0x18,
		S_CFG_DATA	= 0x40,
		S_PCLK_SELECT	= 0x50,
		S_SCLK_SELECT	= 0x58,
		S_FPGA0_BASE	= 0x80,
		S_FPGA1_BASE	= 0xa0,
		S_FPGA2_BASE	= 0xc0,
		S_FPGA3_BASE	= 0xe0,
		W_FPGA_ADDRESS	= 0x20,
		N_FPGA		= 4,
		MEMORY_SIZE	= 0x100
	};

protected :

	KonoePT3Chip	* chip[ N_FPGA ];

public :

	KonoePT3Module( KInt vmeaddress );

	KInt	getDataSize( )	{	return 0;	}
	KInt	fillData( KonoeDataElement *, KonoeModuleSubaddress * )
				{	return 0;	}
	void	setLED( KInt flag );
	KonoePT3Chip	* getChip( KInt index ) {
				return chip[ index ];	}

};

#endif
