// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT4Chip.hh

	Version 0.0.1	20-Apr-2001	H. Sakamoto
	Version 0.0.2	05-Jul-2001	H. Sakamoto
	Version 0.0.3	10-Jul-2001	H. Sakamoto

	-------------------------------------------

	PT4 FPGA chip class

*/
//=================================================================

#ifndef	__KONOEPT4CHIP_HH
#define	__KONOEPT4CHIP_HH

#include	<daq/KonoeVMEModule.hh>
#include	<iostream.h>

class	KonoePT4Module;

class KonoePT4Chip	{

public :
	enum	{	B_CFGCS		= 0x01,
			B_CFGWRITE	= 0x02,
			B_CFGPRG	= 0x04,
			B_CFGDONE	= 0x08,
			B_CFGINIT	= 0x10,
			B_CFGBUSY	= 0x20		};
	enum	{	CLOCK_INTERNAL	= 0x00,
			CLOCK_EXTERNAL1	= 0x01,
			CLOCK_EXTERNAL2	= 0x02,
			CLOCK_NONE	= 0x03		};
	enum	{	JTAG_EXTEST	= 0x00,
			JTAG_SAMPLE	= 0x01,
			JTAG_USER1	= 0x02,
			JTAG_USER2	= 0x03,
			JTAG_CFG_OUT	= 0x04,
			JTAG_CFG_IN	= 0x05,
			JTAG_INTEST	= 0x07,
			JTAG_USERCODE	= 0x08,
			JTAG_IDCODE	= 0x09,
			JTAG_HIGHZ	= 0x0a,
			JTAG_JSTART	= 0x0c,
			JTAG_BYPASS	= 0x1f		};
	enum	{	B_JTAG_TCK	= 0x01,
			B_JTAG_TMS	= 0x02,
			B_JTAG_TDI	= 0x04,
			B_JTAG_TDO	= 0x08		};
	enum	{	JTAG_IR_LENGTH	= 5		};
	enum	{	S_JTAG_TEST_LOGIC_RESET,
			S_JTAG_RUN_TEST_IDLE,
			S_JTAG_SELECT_DR_SCAN,
			S_JTAG_SELECT_IR_SCAN,
			S_JTAG_CAPTURE_DR,
			S_JTAG_CAPTURE_IR,
			S_JTAG_SHIFT_DR,
			S_JTAG_SHIFT_IR,
			S_JTAG_EXIT1_DR,
			S_JTAG_EXIT1_IR,
			S_JTAG_PAUSE_DR,
			S_JTAG_PAUSE_IR,
			S_JTAG_EXIT2_DR,
			S_JTAG_EXIT2_IR,
			S_JTAG_UPDATE_DR,
			S_JTAG_UPDATE_IR		};

protected :

	KonoePT4Module	* module;
	KInt		chip_number;
	KInt		address_offset;
	KInt		* config_port;
	KInt		* data_port;
	KInt		* base_port;
	KInt		* clock_port;
	KInt		* jtag_port;
	KInt		jtag_state;

	void	set_address( );
	void	goto_capture_ir( );
	void	goto_capture_dr( );
	void	set_instruction( KInt instruction );

public :
	KonoePT4Chip( KonoePT4Module * module, KInt index );
	KInt	configure( const KChar * filename );
	KInt	verify( const KChar * filename );
	void	showStatus( ostream & os );
	KInt	setClockMode( KInt clockline, KInt clockmode );
	void	resetTestLogic( );
	KInt	getIDCode( );
	void	bypass( );
	void	setInstruction( KInt instruction );
	void	shiftDR( const KChar * input, KChar * output, KInt bits );
};

#endif
