// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT4Module.cc

	Version 0.0.1	20-Apr-2001	H. Sakamoto

	-------------------------------------------

	PT4 FPGA module class

*/
//=================================================================

#include	<daq/KonoePT4Module.hh>
#include	<daq/KonoePT4Chip.hh>

KonoePT4Module::KonoePT4Module( KInt pvmeaddress )
		: KonoeVMEModule( pvmeaddress, MEMORY_SIZE ) {

	for( KInt i = 0; i < N_FPGA; i ++ )
	    chip[ i ] = new KonoePT4Chip( this, i );

}

void	KonoePT4Module::showStatus( ostream & os ) {

	KShort	d, * base;
	base = ( KShort * ) baseaddress;

	os << hex;
// CSR
	d = * ( base + S_RESET ) & 0xff;
	os << "Control ans Status Register       [ 0x00 ] = " << d << endl;
	d = * ( base + S_BPBUS ) & 0xff;
	os << "Backplane Data Register           [ 0x04 ] = " << d << endl;
	d = * ( base + S_INTR ) & 0xff;
	os << "Interrupt Service Register        [ 0x08 ] = " << d << endl;
	d = * ( base + S_BPDIR ) & 0xff;
	os << "Backplane Direction Register      [ 0x0c ] = " << d << endl;
	d = * ( base + S_CFG0 ) & 0xff;
	os << "Configuration Control Register #0 [ 0x10 ] = " << d << endl;
	d = * ( base + S_CFG1 ) & 0xff;
	os << "Configuration Control Register #1 [ 0x14 ] = " << d << endl;
	d = * ( base + S_CFG2 ) & 0xff;
	os << "Configuration Control Register #2 [ 0x18 ] = " << d << endl;
	d = * ( base + S_CFGDATA ) & 0xff;
	os << "Configuration Data Register       [ 0x1c ] = " << d << endl;
	d = * ( base + S_JTAGIN ) & 0xff;
	os << "JTAG Input Register               [ 0x20 ] = " << d << endl;
	d = * ( base + S_JTAG0 ) & 0xff;
	os << "FPGA JTAG Control Register #0     [ 0x24 ] = " << d << endl;
	d = * ( base + S_JTAG1 ) & 0xff;
	os << "FPGA JTAG Control Register #1     [ 0x28 ] = " << d << endl;
	d = * ( base + S_JTAG2 ) & 0xff;
	os << "FPGA JTAG Control Register #2     [ 0x2c ] = " << d << endl;
	d = * ( base + S_CLK0 ) & 0xff;
	os << "Clock Control Register #0         [ 0x30 ] = " << d << endl;
	d = * ( base + S_CLK1 ) & 0xff;
	os << "Clock Control Register #1         [ 0x34 ] = " << d << endl;
	d = * ( base + S_CLK2 ) & 0xff;
	os << "Clock Control Register #2         [ 0x38 ] = " << d << endl;
	d = * ( base + S_STEP ) & 0xff;
	os << "Single Step Register              [ 0x3c ] = " << d << endl;
	
}

KonoePT4Chip	* KonoePT4Module::getChip( KInt index ) {

	if( index < 0 || index >= N_FPGA )
	    return 0;
	return chip[ index ];

}
