// $Name: KONOE-0-09-02 $
//=================================================================
/*

	KonoePT4Module.hh

	Version 0.0.1	20-Apr-2001	H. Sakamoto

	-------------------------------------------

	PT4 FPGA module class

*/
//=================================================================

#ifndef	__KONOEPT4MODULE_HH
#define	__KONOEPT4MODULE_HH

#include	<daq/KonoeVMEModule.hh>

#include	<iostream.h>

class KonoePT4Chip;

class KonoePT4Module	: public KonoeVMEModule {

public :

	enum	{	L_RESET		= 0x00,
			L_BPBUS		= 0x01,
			L_INTR		= 0x02,
			L_BPDIR		= 0x03,
			L_CFG0		= 0x04,
			L_CFG1		= 0x05,
			L_CFG2		= 0x06,
			L_CFGDATA	= 0x07,
			L_JTAGIN	= 0x08,
			L_JTAG0		= 0x09,
			L_JTAG1		= 0x0a,
			L_JTAG2		= 0x0b,
			L_CLK0		= 0x0c,
			L_CLK1		= 0x0d,
			L_CLK2		= 0x0e,
			L_STEP		= 0x0f,
			L_FPGA0		= 0x10,
			L_FPGA1		= 0x20,
			L_FPGA2		= 0x30,
			WL_FPGA		= 0x10,
			S_RESET		= 0x00,
			S_BPBUS		= 0x02,
			S_INTR		= 0x04,
			S_BPDIR		= 0x06,
			S_CFG0		= 0x08,
			S_CFG1		= 0x0a,
			S_CFG2		= 0x0c,
			S_CFGDATA	= 0x0e,
			S_JTAGIN	= 0x10,
			S_JTAG0		= 0x12,
			S_JTAG1		= 0x14,
			S_JTAG2		= 0x16,
			S_CLK0		= 0x18,
			S_CLK1		= 0x1a,
			S_CLK2		= 0x1c,
			S_STEP		= 0x1e,
			S_FPGA0		= 0x20,
			S_FPGA1		= 0x40,
			S_FPGA2		= 0x60,
			WS_FPGA		= 0x20,
			N_FPGA		= 3		};
	enum	{	MEMORY_SIZE = 0x100		};


protected :

	KonoePT4Chip	* chip[ N_FPGA ];

public :
	KonoePT4Module( KInt vmeaddress );
	void	showStatus( ostream & os );
	KonoePT4Chip	* getChip( KInt index );

	KInt getDataSize()	{	return 0;	}
	KInt fillData(KonoeDataElement* pelement, 
			KonoeModuleSubaddress* subaddress) {
				return 0;			}

};

#endif
