// $Name: KONOE-0-09-02 $
// $Id: KonoeSimADCModule.hh,v 1.5 2002/03/16 08:11:55 iwai Exp $
//======================================================================
/*

	KonoeSimADCModule.hh

	Version 0.1	09-Feb-1998     K. Ohnishi
	Version 0.2.1	10-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//======================================================================
#ifndef	__KONOESIMADCMODULE_HH
#define	__KONOESIMADCMODULE_HH

#include <daq/KonoeSoftwareModule.hh>
#include <analysis/KonoeDataSegment.hh>

class KonoeSimADCModule : public KonoeSoftwareModule {
public:
  enum { SIM_ADC_MODULE = 4, DEF_FULLSCALE = 4096 };

protected:
  KInt fullscale;
  KInt n_channels;
  KInt n_average_hits;
  KInt* mean;
  KInt* sigma;
  
public:
  KonoeSimADCModule(KInt pnchannels, KInt pnaveragehits,
		    KInt pfullscale = DEF_FULLSCALE);
  KonoeSimADCModule(KInt pnchannels, KInt pnaveragehits,
		    KInt * pmean, KInt * psigma,
		    KInt pfullscale = DEF_FULLSCALE);
  ~KonoeSimADCModule();

  KInt getDataSize();
  KInt fillData(KonoeDataElement* pelement, KonoeModuleSubaddress* );
  void dump(ostream& os);
  KonoeDataSegment* getDataSegment(KInt psegmenttag);
  void initialize();
  void clear();
  void update();
  KFloat gaussDev();
  
};

#endif
