// $Name: KONOE-0-09-02 $
// $Id: KonoeSimCrate.cc,v 1.6 2002/03/16 08:11:56 iwai Exp $
//==================================================================
/*

	KonoeSimCrate.cc

	Version 0.2.0	28-Apr-1998	H. Sakamoto
	Version	0.4.1	 8-AUG-1999	S. Nishida
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================

#include <daq/KonoeSimCrate.hh>

KonoeSimCrate::KonoeSimCrate( KInt ptablesize, KonoeDetectorList* l,
			      KonoeEventGenerator* g, KInt digitizercount ) 
  : KonoeSimulator( l, g ), KonoeList<KonoeSimModule>( ptablesize ) 
{
  digitizerlist = new KonoeDigitizerList( digitizercount );
}

KInt KonoeSimCrate::processHit( KonoeSimDetectorHit* hit )
{
  KInt naddress;
  KonoeDetectorElement* e;
  KonoeDataAddress* a;
  KonoeSimDigitizer* d;

  e = hit -> getDetectorElement( );
  e -> reset( );
  while ( a = e -> next( ) ) {
    d = digitizerlist -> find( a -> getSectionID( ) );
    if ( d ) {
      d -> digitize( hit, a, getModule( a ) );
    } else {
      cout << "no digitizer found" << endl;
    }
  }
  return 0;
}

void KonoeSimCrate::initialize( ) {;}

void KonoeSimCrate::clear( ) 
{
  KonoeSimModule* m;
  reset( );
  while( m = next( ) ) m -> clear();
  return;
}

void KonoeSimCrate::update( ) 
{
  simulate( );
  return;
}

KonoeSimModule* KonoeSimCrate::getModule( KonoeDataAddress* address ) 
{
  KonoeSimModule* m;

  reset( );
  while ( m = next( ) ) {
    // changed by Nishida 990805
    if ( m -> getSegmentID( ) == address -> getSegmentID( ) &&
	 m -> getSectionID( ) == address -> getSectionID( ) )
      return m;
  }
  return (0);
}
