// $Name: KONOE-0-09-02 $
// $Id: KonoeSimCrate.hh,v 1.6 2002/03/16 08:11:56 iwai Exp $
//==================================================================
/*

	KonoeSimCrate.hh

	Version 0.2.0	28-Apr-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================
#ifndef	__KONOESIMCRATE_HH
#define	__KONOESIMCRATE_HH

#include <KonoeList.hh>
#include <daq/KonoeDAQCrateBase.hh>
#include <analysis/KonoeSimulator.hh>
#include <daq/KonoeSimModule.hh>
#include <daq/KonoeDigitizerList.hh>

class KonoeSimCrate : public KonoeDAQCrateBase,	
		      public KonoeSimulator, 
		      public KonoeList<KonoeSimModule> {
protected:
  KonoeDigitizerList* digitizerlist;

public:
  KonoeSimCrate( KInt ptablesize, KonoeDetectorList* dl, 
		 KonoeEventGenerator* g, KInt digitizercount );
  ~KonoeSimCrate() {;}
  KInt processHit( KonoeSimDetectorHit* hit );

  void initialize();
  void clear();
  void update();

  KonoeSimModule* getModule( KonoeDataAddress* );
  inline KInt addDigitizer( KonoeSimDigitizer* d ) 
  { return ( digitizerlist -> add(d) );	}
};

#endif
