// $Name: KONOE-0-09-02 $
// $Id: KonoeSimModule.cc,v 1.6 2002/03/16 08:11:57 iwai Exp $
//==================================================================
/*

	KonoeSimModule.cc

	Version 0.2.0	28-Apr-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================
#include <daq/KonoeSimModule.hh>

KonoeSimModule::KonoeSimModule( KInt sectionid, KInt segmentid, KInt psize )
  : KonoeDAQModuleBase( sectionid, segmentid ) 
{
  storagesize = psize;
  storage = new KInt[ psize ];
}

KonoeSimModule::~KonoeSimModule() 
{
  delete [] storage;
}

void KonoeSimModule::initialize()
{
  return;
}

void KonoeSimModule::update()
{
  return;
}


void KonoeSimModule::clear()
{
  KInt* p = storage;
  for ( KInt i = 0; i < storagesize; i ++ )
    *p++ = 0;
  return;
}

KInt KonoeSimModule::set( KInt address, KInt data )
{
  if ( address < 0 || address >= storagesize )
    return -1;
  *( storage + address ) = data;
  return 0;
}

KInt KonoeSimModule::getDataSize()
{
  KInt k = 0; 
  KInt i; 
  KInt* p = storage;

  for ( i = 0; i < storagesize; i ++ )
    if ( *p++ )
      k++;
  return k;
}

KInt KonoeSimModule::fillData( KonoeDataElement *, KonoeModuleSubaddress * ) 
{
  return -1;
}

KonoeDataSegment* KonoeSimModule::getDataSegment( KInt segid )
{
  KInt k;
  KInt* p;
  KonoeDataSegment* s;
  KonoeDataElement* e;

  k = getDataSize();
  s = new KonoeDataSegment( k, segid );
  p = storage;
  for ( KInt i = 0; i < storagesize; i ++ ) {
    if ( *p ) {
      e = new KonoeDataElement( KonoeDataElement::INT, i, *p );
      s -> add(e);
    }
    p++;
  }
  return s;
}
