// $Name: KONOE-0-09-02 $
// $Id: KonoeSimTDCModule.cc,v 1.8 2002/03/16 08:11:57 iwai Exp $
//======================================================================
/*

	KonoeSimTDCModule.cc

	Version 0.1	02-Aug-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//======================================================================
#include <daq/KonoeSimTDCModule.hh>
#include <stdlib.h>

KonoeSimTDCModule::KonoeSimTDCModule( KInt pnchannels, KInt pnaverage, KInt pfullscale )
  : KonoeSoftwareModule( MODULE_ID ) 
{
  n_channels = pnchannels;
  n_average_hits = pnaverage;
  fullscale = pfullscale;
}

KInt KonoeSimTDCModule::getDataSize() 
{
  return n_channels;
}

KInt KonoeSimTDCModule::fillData( KonoeDataElement* pelement,
				  KonoeModuleSubaddress* ) 
{
  KInt data = 1024;
  pelement -> fill( &data, 1 );
  return (data);
}

void KonoeSimTDCModule::initialize() 
{
  return;
}

void KonoeSimTDCModule::clear() 
{
  return;
}

void KonoeSimTDCModule::update()
{
  // generate new data.
  return;
}

KonoeDataSegment* KonoeSimTDCModule::getDataSegment(KInt psegmenttag) 
{
  KonoeDataSegment* r;
  KonoeDataElement* e;
  KInt s, t, u;

  t = 0x10000 * n_average_hits / n_channels;
  r = new KonoeDataSegment( n_channels, psegmenttag );
  for ( KInt i = 0; i < n_channels; i ++ ) {
    u = lrand48( ) & 0xffff;
    if ( u < t ) {
      s = lrand48( ) % fullscale;
      r -> add( new KonoeDataElement( KonoeDataElement::INT, i, s ) );
    }
  }
  return r;
}
