// $Name: KONOE-0-09-02 $
// $Id: KonoeSoftwareCrate.cc,v 1.7 2002/03/16 08:11:59 iwai Exp $
//===================================================================
/*

	KonoeSoftwareCrate.cc

	Version 0.1	25-Jul-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	12-May-2001	H. Sakamoto

*/
//===================================================================

#include <daq/KonoeSoftwareCrate.hh>

KonoeSoftwareCrate::KonoeSoftwareCrate( KInt ptablesize ) 
{
  modules = new KonoeSoftwareModule* [ ptablesize ];
  tablesize = ptablesize;
  n_modules = 0;
}

KInt KonoeSoftwareCrate::install( KonoeSoftwareModule* pmodule ) 
{
  if ( n_modules >= tablesize )
    return -1;
  *( modules + n_modules ) = pmodule;
  n_modules ++;
  return n_modules;
}

void KonoeSoftwareCrate::initialize() 
{
  KonoeSoftwareModule** pp;
  KonoeSoftwareModule* p;
  pp = modules;
  for ( int i = 0; i < n_modules; i ++ ) {
    p = *pp ++;
    p -> initialize();
  }
  return;
}

void KonoeSoftwareCrate::clear()
{
  KonoeSoftwareModule** pp;
  KonoeSoftwareModule* p;
  pp = modules;
  for ( int i = 0; i < n_modules; i ++ ) {
    p = *pp ++;
    p -> clear( );
  }
  return;
}

void KonoeSoftwareCrate::update() 
{
  KonoeSoftwareModule** pp;
  KonoeSoftwareModule* p;
  pp = modules;
  for ( int i = 0; i < n_modules; i ++ ) {
    p = *pp ++;
    p -> update();
  }
  return;
}

KonoeSoftwareModule	* KonoeSoftwareCrate::getModule( KInt index ) {

	if( index < 0 || index >= n_modules )
	    return 0;

	return * ( modules + index );

}
