// $Name: KONOE-0-09-02 $
//=====================================================================
/*

	KonoeSuehiroChip.hh

	Version 0.0.1	31-Aug-1998	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOESUEHIROCHIP_HH
#define	__KONOESUEHIROCHIP_HH

#include	<KonoePrimitives.hh>
#include	<iostream.h>

class	KonoeSuehiroChip	{

public :

	// following offset values are in short words

	enum	{	OFS_RESET = 0,
			OFS_PROGRAM = 1,
			OFS_HDC = 0x20,
			OFS_LDC = 0x21,
			OFS_BUSY = 0x22,
			OFS_INIT = 0x23,
			OFS_CLKMASK = 0x28,
			OFS_CLKVME = 0x2e,
			OFS_CLKENABLE = 0x2f		};
	enum	{	OFS_CHIP0 = 0x40,
			SIZE_CHIP = 0x10,
			OFS_PRGBYTE = 0x02	};
	enum	{	MASK_INTERNAL = 0x99,
			MASK_EXTERNAL = 0xee	};
			

protected :
	KInt	id;	// must be 0 through 3
	KInt	mask;
	KInt	address;

	KShort	* modulebase;
	KShort	* chipbase;

	KShort	* lca_reset;
	KShort	* lca_program;
	KShort	* lca_hdc;
	KShort	* lca_ldc;
	KShort	* lca_busy;
	KShort	* lca_init;

	KShort	* clock_mask;
	KShort	* clock_strobe;
	KShort	* clock_enable;

	KShort	* lca_prgbyte;

private :
	KInt	ishift;
	KInt	ibyte;

	void	put_frame( KChar * p );

public :
	KonoeSuehiroChip( KInt id );
	KInt	download( KChar * filename );
	KInt	initialize( );
	void	setBase( void * base );
	void	dumpCSR( ostream & os );
	void	dump( ostream & os );

	void	setClockMode( KInt mode );
	void	enableClock( KInt flag );
	void	strobeClock( );
};


#endif
