// $Name: KONOE-0-09-02 $
//==================================================================
/*

	KonoeSuehiroModule.cc

	Version 0.0.1	10-Aug-1998	H. Sakamoto
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//==================================================================

#include	<daq/KonoeSuehiroModule.hh>

KonoeSuehiroModule::KonoeSuehiroModule( KInt poffset )
	: KonoeVMEModule( poffset, MEMORY_SIZE ) {

	for( KInt i = 0; i < N_CHIP; i ++ )
	  chips[ i ] = new KonoeSuehiroChip( i );

}

KonoeSuehiroModule::~KonoeSuehiroModule( ) {

	for( KInt i = 0; i < N_CHIP; i ++ )
	  delete chips[ i ];

}

KInt	KonoeSuehiroModule::download( KChar * filename, KInt chip ) {

	if( chip < 0 || chip > 3 ) {
	  cout << "Invalid chip ID = " << chip << endl;
	  return -1;
	}

	return chips[ chip ] -> download( filename );

}

void	KonoeSuehiroModule::setCrate( KonoeVMECrate * pcrate ) {

	KonoeVMEModule::setCrate( pcrate );
	for( KInt i = 0; i < N_CHIP; i ++ )
	  chips[ i ] -> setBase( baseaddress );
}

KInt	KonoeSuehiroModule::getDataSize( ) {

	return 0;

}

KInt	KonoeSuehiroModule::fillData( KonoeDataElement *, KonoeModuleSubaddress * ) {

	return 0;

}

void	KonoeSuehiroModule::dump( ostream & os ) {

	KShort	* p;
	KInt	i;

	os << hex;
	p = ( KShort * ) baseaddress;
	for( i = 0; i < 0x80; i ++ ) {
	  if( i % 8 == 0 )
	    os << i << " : ";
	  os.width( 4 );
	  os << ( ( * p ++ ) & 0xffff );
	  if( i % 8 == 7 )
	    os << endl;
	  else
	    os << " ";
	}
}
