// $Id: KonoeTimerModule.hh,v 1.5 2002/04/09 22:47:42 iwai Exp $
// $Name: KONOE-0-09-02 $
//====================================================================
/*

	KonoeTimerModule.hh
	
        Version 0.6.0   09-Nov-2000     G. Iwai

*/
//====================================================================
#ifndef	__KONOETIMERMODULE_HH
#define	__KONOETIMERMODULE_HH

#include <daq/KonoeSoftwareModule.hh>

class ostream;

class KonoeTimerModule : public KonoeSoftwareModule {

private:
  enum { MODULE_TYPE = 1 };

public:
  enum KUnit_t { kSecond, kMilliSecond, kMicroSecond };

private:
  KUnit_t theUnit;

  KULong theInterval;
  KULong thePrevious;
  KULong theCurrent;

private:
  void setCurrent();

public:
  KonoeTimerModule( KUnit_t unit = kSecond );
  ~KonoeTimerModule() {;}

  // utilities
  KInt fillData( KonoeDataElement* anElement, 
		 KonoeModuleSubaddress* subAddress = 0 );
  inline KInt getDataSize() { return( 1 ); }

  void initialize();
  void clear();
  void update();

  // set/get member functions
  inline void setUnit( KUnit_t unit ) { theUnit = unit; }
  inline KUnit_t getUnit() const { return( theUnit ); }
  inline KULong getInterval() const { return( theInterval ); }
  inline KULong getPrevious() const { return( thePrevious ); }
  inline KULong getCurrent() const { return( theCurrent ); }

  void dump( ostream& os = cout ) const;
};

#endif
