// $Name: KONOE-0-09-02 $
// $Id: KonoeVMECrate.hh,v 1.7 2002/03/16 08:12:01 iwai Exp $
//====================================================================
/*

	KonoeVMECrate.hh

	Version 0.0.1	09-Jul-1998	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	19-May-2001	H. Sakamoto

	symbols

	KONOE_FORCE_CPU5CE
	KONOE_SBS_617_KINOKO

*/
//====================================================================

#ifndef	__KONOEVMECRATE_HH
#define	__KONOEVMECRATE_HH

#include <daq/KonoeDAQCrateBase.hh>
#include <daq/KonoeVMEModule.hh>
#include <KonoeList.hh>
#include <sys/types.h>
#include	<iostream.h>

class KonoeVMECrate : public KonoeDAQCrateBase,	public KonoeList<KonoeVMEModule> {
public:
  enum { VME_A16D16, VME_A16D32, VME_A24D16, VME_A24D32,
	 VME_A32D16, VME_A32D32, N_VME_MODES };
  enum { OFFLINE, ONLINE };

protected:
  int filed;
  unsigned long	size;
  unsigned long offset;
  caddr_t pointer;
  static KChar* device[ N_VME_MODES ];

  KInt status;
  KInt mode;

public:
	KonoeVMECrate( KInt mode, KInt msize, KInt offset, KInt tablesize );
	void* getBase() { return pointer; }
	KInt install( KonoeVMEModule* module );
	void	showStatus( ostream & os );
	KInt	getOffset( )	{	return offset;		}
	KInt	getSize( )	{	return size;		}

  // virtuals

	void initialize( );
	void clear( );
	void update( );
};




#endif
