// $Name: KONOE-0-09-02 $
// $Id: KonoeVMEModule.cc,v 1.8 2002/03/16 08:12:01 iwai Exp $
//===================================================================
/*

	KonoeVMEModule.cc

	Version 0.1	15-Jul-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	14-Apr-2001	H. Sakamoto
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//===================================================================

#include <daq/KonoeVMEModule.hh>
#include <daq/KonoeVMECrate.hh>

#include	<iostream.h>

KonoeVMEModule::KonoeVMEModule( KInt pvmeaddress, KInt pmemorysize ) 
{
	vmeaddress = pvmeaddress;
	memorysize = pmemorysize;
}

void KonoeVMEModule::setCrate( KonoeVMECrate* pcrate ) 
{

	crate = pcrate;

	offset = vmeaddress - crate -> getOffset( );

	if( offset >= crate -> getSize( ) ) {
	    cerr << "KonoeVMEModule::setCrate."
		" Module address not in the crate memory." << endl;
	    baseaddress = 0;
	    return;
	}

	baseaddress =  ( (KChar*) crate -> getBase() + offset );

}

KShort	KonoeVMEModule::read16( KInt address ) {

	return * ( KShort * ) ( ( KChar * ) baseaddress + address );

}

KInt	KonoeVMEModule::read32( KInt address ) {

	return * ( KInt * ) ( ( KChar * ) baseaddress + address );

}

void	KonoeVMEModule::write16( KInt address, KShort data ) {

	* ( KShort * ) ( ( KChar * ) baseaddress + address ) = data;

}

void	KonoeVMEModule::write32( KInt address, KInt data ) {

	* ( KInt * ) ( ( KChar * ) baseaddress + address ) = data;

}

void	KonoeVMEModule::dump( ostream & os, KInt poffset, KInt psize ) {

	os << "VME address = " << hex << vmeaddress
		<< " memory size = " << memorysize << endl;

	KShort	* p = ( KShort * ) baseaddress;
	KInt	i, pfrom, pto;
	pfrom = poffset;
	pto = memorysize;
	if( psize ) {
	    pto = pfrom + psize;
	    if( pto > memorysize )
		pto = memorysize;
	}

	for( i = pfrom; i < pto; i += sizeof( KShort ) ) {
	    if( i % ( sizeof( KShort ) * 8 ) == 0 ) {
		os.width( 4 );
		os << '+' << i <<": ";
	    }
	    else
		os << ' ';
	    os.width( 4 );
	    os << ( 0xffffL & * p ++ );
	    if( i % ( sizeof( KShort ) * 8 ) == ( sizeof( KShort ) * 7 ) )
		os << endl;
	}
	if( i % ( sizeof( KShort ) * 8 ) != 0 )
	    os << endl;

}
