// $Name: KONOE-0-09-02 $
// $Id: cc7x00.h,v 1.4 2002/03/16 08:12:02 iwai Exp $
//==================================================================
/*

  	cc7x00.h

	Version 0.6.0	25-Dec-2000	G. Iwai

*/
//==================================================================
#ifndef cc7x00_h
#define cc7x00_h 1

#ifdef LINUX
  #include <linux/ioctl.h>
#endif

struct CamacData {
  unsigned naf;
  short q, x;
  union DataPartOfCamacData {
    unsigned short d16;
    unsigned d24;
  } data;
};

#define DRV_NAME_LENGTH 16
struct CamacCardDescriptor {
  unsigned drv_ver;
  int minor;
  char name[DRV_NAME_LENGTH];
  int flag;		/* default = 0; */
  int fd;		/* default = -1 */
  int base;		/* default = -1 */
  int size;		/* ISA70 = 0x08 , ISA77 = 0x0c , PCI77 = 0x10 */
  int irq;		/* default = -1 */
  int irq_mask;
  int CN;               /* CrateNumber */
};

#ifdef CAMAC_CC7x00_USE_IOCTL

struct IOmapCC7000ISA {
  struct CamacCardDescriptor cd;
  unsigned CSR;	        /* 0x0006 */
  unsigned CCR;	        /* 0x0001 */
  unsigned NAFLR;       /* 0x0004 */
  unsigned NAFHR;       /* 0x0006 */
  unsigned LAMLR;	/* 0x0004 */
  unsigned LAMHR;	/* 0x0006 */
  unsigned DLR;	        /* 0x0000 */
  unsigned DHR;	        /* 0x0002 */
  unsigned EXER;	/* 0x0007 */
};

struct IOmapCC7700ISA {
  struct CamacCardDescriptor cd;
  unsigned CSR;	        /* 0x0000 */
  unsigned CCR;	        /* 0x0002 */
  unsigned NAFR;        /* 0x0004 */
  unsigned LAMLR;	/* 0x0002 */
  unsigned LAMHR;	/* 0x0004 */
  unsigned DLR;	        /* 0x0006 */
  unsigned DHR;	        /* 0x0008 */
  unsigned EXER;	/* 0x000a */
};

struct IOmapCC7700PCI {
  struct CamacCardDescriptor cd;
  unsigned CSR;	        /* 0x0000 */
  unsigned CCR;	        /* 0x0004 */
  unsigned NAFR;	/* 0x0004 */   
  unsigned LAMR;	/* 0x0004 */  
  unsigned DR;	        /* 0x0008 */    
  unsigned EXER;	/* 0x000c */
};

union IOmapCC7x00 {
  struct CamacCardDescriptor cd;
  struct IOmapCC7000ISA ISA70;
  struct IOmapCC7700ISA ISA77;
  struct IOmapCC7700PCI PCI77;
};

#define IOC_MAX_CMDS		0x11
#define CC7x00_IOC_MAGIC	0xcc

#define IOC_GET_VERSION _IOR(CC7x00_IOC_MAGIC,  0x00, unsigned*)
#define IOC_GET_CONFIG	_IOR(CC7x00_IOC_MAGIC,  0x01, union IOmapCC7x00)
#define IOC_TEST_ONLINE _IO(CC7x00_IOC_MAGIC,   0x02)
#define IOC_RESET_CRATE	_IO(CC7x00_IOC_MAGIC,	0x03)
#define IOC_SET_Z	_IO(CC7x00_IOC_MAGIC,	0x04)
#define IOC_SET_C	_IO(CC7x00_IOC_MAGIC,	0x05)
#define IOC_SET_I	_IO(CC7x00_IOC_MAGIC,	0x06)
#define IOC_RESET_I	_IO(CC7x00_IOC_MAGIC,	0x07)
#define IOC_SET_EI	_IO(CC7x00_IOC_MAGIC,	0x08)
#define IOC_RESET_EI	_IO(CC7x00_IOC_MAGIC,	0x09)
#define IOC_SET_LI	_IO(CC7x00_IOC_MAGIC,	0x0a)
#define IOC_RESET_LI	_IO(CC7x00_IOC_MAGIC,	0x0b)
#define IOC_SET_CN	_IOW(CC7x00_IOC_MAGIC,	0x0c, unsigned)
#define IOC_WAIT_LAM	_IOW(CC7x00_IOC_MAGIC,	0x0d, unsigned**)
#define IOC_GET_LAM	_IOR(CC7x00_IOC_MAGIC,	0x0e, unsigned*)
#define IOC_CAM16       _IOR(CC7x00_IOC_MAGIC,  0x0f, struct CamacData)
#define IOC_CAM24       _IOR(CC7x00_IOC_MAGIC,  0x10, struct CamacData)

/* some useful macro related minor number */
#define isISA70(minor) (!((minor) & 0xfffc))
#define isISA77(minor) ((minor) & 0x0004)
#define isPCI77(minor) (!isISA70((minor)) && !isISA77((minor)))
#define CARD_NUMBER(minor) (((minor) % MULTI_CARDS) + 1)

#endif

#endif

