// $Name: KONOE-0-09-02 $
//=================================================================
/*

	pt3demo.cc

	Version 0.0.1	13-Apr-2001	H. Sakamoto

	-------------------------------------------

	pt3 module manipulator program

*/
//=================================================================

#include	<daq/KonoeVMECrate.hh>
#include	<daq/KonoePT3Module.hh>
#include	<daq/KonoePT3Chip.hh>

#include	<iostream.h>
#include	<unistd.h>

class	PT3Demo	{

protected :

	KonoeVMECrate	* crate;
	KonoePT3Module	* module;

public :
	PT3Demo( int argc, char ** argv );
	int	go( );

};

PT3Demo::PT3Demo( int argc, char ** argv ) {

	crate = new KonoeVMECrate( KonoeVMECrate::VME_A24D16,
			0x1000, 0x00800000, 16 );
	module = new KonoePT3Module( 0 );
	module -> setCrate( crate );

}

int	PT3Demo::go( ) {

	KInt	i, f;
	KShort	* p, * q;
	KonoePT3Chip	* chip;

	p = ( KShort * ) module -> getPointer( );
	cout << hex << "Base = " << p << endl;
	q = p;

	for( i = 0; i < 256; i ++ ) {
	if( i % 16 == 0 ) cout << i << ": ";
	cout << ( ( * p ++ ) & 0xff ) << " ";
	if( i % 16 == 15 ) cout << endl;
	}

	for( i =0; i < KonoePT3Module::N_FPGA; i ++ )
	    module -> getChip( i ) -> showStatus( cout );

	f = 0;
	for( i = 0; i < 10; i ++ ) {

	module -> setLED( f );
//	sleep( 1 );
	f ^= 1;

	}

	for( i = 0; i < KonoePT3Module::N_FPGA; i ++ ) {
	    chip = module -> getChip( i );
	    chip -> erase( );
	    chip -> configure( "a2d.rbt" );
	    chip -> showStatus( cout );
	}
	
	return 0;

}


int	main( int argc, char ** argv ) {

	PT3Demo	demo( argc, argv );
	return demo.go( );

}
