// $Name: KONOE-0-09-02 $
// $Id: KonoeCAMACXaction.hh,v 1.4 2002/03/16 08:12:03 iwai Exp $
//====================================================================
/*

        KonoeCAMACXaction.hh

        Version 0.6.0   09-Nov-2000     G. Iwai

*/
//====================================================================
#ifndef __KONOECAMACXACTION_HH
#define __KONOECAMACXACTION_HH

#include <daq/KonoeHardwareXaction.hh>
#include <analysis/KonoeDataRecord.hh>
#include <daq/KonoeCAMACCrate.hh>
#include <daq/KonoeCAMACInterruptRegister.hh>

class KonoeCAMACXaction : KonoeHardwareXaction {

private:
  enum { WAIT_ONE_IR, WAIT_TWO_IR, WAIT_BIT_PATTERN };

  KonoeCAMACCrate* crate;
  KonoeCAMACInterruptRegister* interruptRegister;
  KonoeCAMACInterruptRegister* interruptRegister2;  
  KUInt time;
  KUShort mode;


public:
  KonoeCAMACXaction( KonoeReadoutList* aList, 
		     KonoeCAMACCrate* aCrate,
		     KonoeCAMACInterruptRegister* aIR, 
		     KUInt milliSec = 0 );

  KonoeCAMACXaction( KonoeReadoutList* aList, 
		     KonoeCAMACCrate* aCrate,
		     KonoeCAMACInterruptRegister* aIR1,
		     KonoeCAMACInterruptRegister* aIR2,
		     KUInt milliSec = 0 );

  KonoeCAMACXaction( KonoeReadoutList* aList, 
		     KonoeCAMACCrate* aCrate,
		     KUInt bit, KUInt milliSec = 0 );


  ~KonoeCAMACXaction( ) {;}

  KInt enable();
  KInt disable();
  KonoeDataRecord* read();

  inline KUInt getTime() const { return ( this -> time ); }
  inline void setTime(KUInt value) { this -> time = value; }

};

#endif
