// $Name: KONOE-0-09-02 $
// $Id: KonoeSignalXaction.cc,v 1.5 2002/03/16 08:12:03 iwai Exp $
//===================================================================
/*

	KonoeSignalXaction.cc

	Version 0.1	 1-Aug-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.3	29-Oct-1997	H. Sakamoto
	Version	0.4.0	11-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
		signal handler

*/
//===================================================================

#include <daq/KonoeSignalXaction.hh>
#include <iostream.h>

KonoeSignalXaction::KonoeSignalXaction(KonoeReadoutList* plist, KInt psignalid)
  : KonoeSoftwareXaction(plist)
{
  handler = new KonoeSignalHandler(psignalid, this);
}

KInt KonoeSignalXaction::enable()
{
  handler -> enable();
  return 0;
}

KInt KonoeSignalXaction::disable()
{
  handler -> disable( );
  return 0;
}

KonoeDataRecord* KonoeSignalXaction::read() 
{
  last_read = 0;
  handler -> wait();
  return last_read;
}

void KonoeSignalXaction::catchSignal(KInt) 
{
  if(last_read) {
    cout << "Record buffer not empty." << endl;
    return;
  }
  last_read = list -> read( );
}

void KonoeSignalXaction::initialize() 
{
  KonoeSignalHandler::initialize();
}
