//==================================================================
/*

	KonoeDirectory.cc

	Version 0.1.0	05-Feb-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka
*/
//==================================================================

#ifndef	__KONOEDIRECTORY_CC
#define	__KONOEDIRECTORY_CC

#include	<string.h>

template<class T> KonoeDirectory<T>::KonoeDirectory(
	KonoeDirectory<T> * parent, KChar * name, KInt maxcontents,
	KInt maxsubdirectories ) {

	superdirectory = parent;
	contents = new KonoeList<T>( maxcontents );
	subdirectories = new KonoeDirectory<T> * [ maxsubdirectories ];
	n_subdirectories = 0;
	tablesize = maxsubdirectories;
	directoryname = new KChar( strlen( name ) + 1 );
	strcpy( directoryname, name );
}

template<class T>	KInt	 KonoeDirectory<T>::addEntry( T * content ) {

	return contents -> add( content );

}

template<class T>	KInt	 KonoeDirectory<T>::addSubDirectory(
		KonoeDirectory<T> * subdir ) {

	if( n_subdirectories == tablesize )
		return -1;
	* ( subdirectories + n_subdirectories ) = subdir;
	n_subdirectories ++;
	return 0;
}

#endif
