//==================================================================
/*

	KonoeDirectory.hh

	Version 0.1.0	05-Feb-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version	0.7.0	27-Aug-2001	S. Morinaka
*/
//==================================================================

#ifndef	__KONOEDIRECTORY_HH
#define	__KONOEDIRECTORY_HH

#include	<KonoePrimitives.hh>
#include	<KonoeList.hh>

template<class T> class KonoeDirectory {

protected :
	KonoeDirectory<T>		** subdirectories;
	KInt				n_subdirectories;
	KInt				tablesize;
	KonoeDirectory<T>		* superdirectory;
	KonoeList<T>			* contents;
	KChar	* directoryname;
public :
	KonoeDirectory( KonoeDirectory<T> * parent,
		KChar * name,
		KInt maxcontents, KInt maxsubdirectories );
	KonoeList<T>	* getContents( ) { return contents; }
	KInt	addEntry( T * content );
	KInt	getEntryCount( ) { return contents -> getCount( ); }
	KInt	addSubDirectory( KonoeDirectory<T> * subdir );
	KInt	getSubDirectoryCount( ) {
			return n_subdirectories;	}
	KonoeDirectory<T>	* getSubDirectory( KInt index ) {
			return * ( subdirectories + n_subdirectories );
	}

};

#include	<KonoeDirectory.cc>

#endif
