//==================================================================
/*

	KonoeList.cc

	Version 0.1	25-Jul-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0   27-Aug-2001     S. Morinaka
*/
//==================================================================

#include	<KonoeList.hh>
#ifndef	__KONOELIST_CC
#define	__KONOELIST_CC

template<class T> KonoeList<T>::KonoeList( KInt ptablesize ) {

	if( ptablesize )
	    entries = new T * [ ptablesize ];
	else
	    entries = 0;
	tablesize = ptablesize;
	n_entries = 0;
}

template<class T> KonoeList<T>::~KonoeList( ) {

	for( KInt i = 0; i < n_entries; i ++ )
	    delete * ( entries + i );
	delete [] entries;
}

template<class T> KInt KonoeList<T>::allocate( KInt ptablesize ) {

	if( entries ) {
	    for( KInt i = 0; i < n_entries; i ++ )
		delete * ( entries + i );
	    delete [] entries;
	}
	if( ptablesize )
	    entries = new T * [ ptablesize ];
	else
	    entries = 0;
	tablesize = ptablesize;
	n_entries = 0;
	return ptablesize;
}

template<class T> KInt KonoeList<T>::add( T * pentry ) {

	if( n_entries >= tablesize )
	    return -1;
	* ( entries + n_entries ) = pentry;
	n_entries ++;
	return n_entries - 1;
}

template<class T> KInt KonoeList<T>::clear( ) {

	for( KInt i = 0; i < n_entries; i ++ )
	    delete * ( entries + i );
	n_entries = 0;
	counter = 0;
	pointer = entries;
	return 0;
}

template<class T> void KonoeList<T>::reset( ) {

	counter = 0;
	pointer = entries;

}

template<class T> T * KonoeList<T>::next( ) {

	if( counter >= n_entries )
	    return 0;
	counter ++;
	return * pointer ++;

}

template<class T> T * KonoeList<T>::get( KInt pindex ) {

	if( pindex < 0 || pindex >= n_entries )
	    return 0;
	return * ( entries + pindex );

}
#endif

