//==================================================================
/*

	KonoeList.hh

	Version 0.1	25-Jul-1997	H. Sakamoto
	Version 0.2.0	13-May-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	                26-Nov-2000     K. Uchida
	Version 0.7.0   27-Aug-2001     S. Morinaka
*/
//==================================================================

#ifndef	__KONOELIST_HH
#define	__KONOELIST_HH

#include	<KonoePrimitives.hh>

template<class T> class KonoeList {

protected :
	KInt	n_entries;
	KInt	tablesize;
	T	** entries;

	KInt	counter;
	T	** pointer;

public :
	KonoeList( KInt ptablesize );
        virtual ~KonoeList( );
	KInt	add( T * pentry );
	KInt	allocate( KInt ptablesize );
	KInt	clear( );

	void	reset( );
	T	* next( );

	T	* get( KInt pindex );
	KInt	getCount( ) { return n_entries; }
	KInt	getTableSize( ) { return tablesize; }
};

#include	<KonoeList.cc>

#endif
