//==================================================================
/*

	KonoeRing.hh

	Version 0.0.1	14-Aug-1998	S. Nishida
	Version 0.4.0	29-Sep-1998	S. Nishida
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0 	27-Aug-2001	S.Morinaka

*/
//==================================================================

#ifndef __KONOERING_HH
#define __KONOERING_HH

#include	<KonoePrimitives.hh>

template<class T> class KonoeRing {

protected :
	KInt n_entries;
	KInt tail;
	KInt tablesize;
	T ** entries;

	KInt counter;

public :
	KonoeRing( KInt ptablesize );
	~KonoeRing( );
	KInt    add( T * pentry );
	KInt    clear( );

	void    reset( );
	T       * next( );

	T	* get( KInt pindex );
	KInt    getCount( ) { return n_entries; }
	KInt    getTableSize( ) { return tablesize; }
};

#include	<KonoeRing.cc>

#endif
