//=====================================================================
/*

	KonoeTree.hh

	Version 0.1	02-Aug-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	27-Aug-2001	S. Morinaka
*/
//=====================================================================

#ifndef	__KONOETREE_HH
#define	__KONOETREE_HH

#include	<KonoePrimitives.hh>

template<class T> class KonoeTree {

protected :
	KonoeTree<T>	* foreward;
	KonoeTree<T>	* backward;
	KonoeTree<T>	* downward;
	KonoeTree<T>	* upward;
	T		* entry;
public :
	KonoeTree( );
	KonoeTree<T>	* addDown( KonoeTree<T> * item );
	KonoeTree<T>	* addDown( T * item );
	KonoeTree<T>	* addNext( KonoeTree<T> * item );
	KonoeTree<T>	* addNext( T * item );
	KonoeTree<T>	* goDown( )		{
			return downward;	}
	KonoeTree<T>	* goUp( )		{
			return upward;		}
	KonoeTree<T>	* goNext( )		{
			return foreward;	}
	KonoeTree<T>	* goPrevious( )		{
			return backward;	}
	void		set( T * pentry )	{
			entry = pentry;		}
	T		* get( ) 		{
			return entry;	}
	KonoeTree<T>	* goFirst( );
	KonoeTree<T>	* goLast( );
};


#include	<KonoeTree.cc>

#endif
