//===============================================================
/*
	KonoeVector.hh

	Originally coded by Tomoaki
	Version 0.1	15-Oct-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

	This file is included in KonoeVector.hh

	Notice: operator[] returns 0 if the index is out of boundary
		: This is modified from the original program
*/
//===============================================================



#ifndef __KONOEVECTOR_CC
#define __KONOEVECTOR_CC

template<class T> KonoeVector<T>::KonoeVector( KInt pmaxelements ) {
	max_elements = pmaxelements;
	buffer = new T [max_elements];
	elements = 0;
}

template<class T> KonoeVector<T>::~KonoeVector() {
	delete [] buffer;
}

template<class T> T* KonoeVector<T>::operator[](KInt pindex) {

    if( pindex < elements && pindex >=0 )
	return buffer + pindex;
    else
	return 0;
}

template<class T> void KonoeVector<T>::add( T& Ob) {
    if( elements < max_elements) {
      *( buffer + elements ) = Ob;
      elements++;
    }
}

#endif
