//===============================================================
/*
	KonoeVector.hh

	Originally coded by Tomoaki
	Version 0.1	15-Oct-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0   27-Aug-2001	S. Morinaka

*/
//===============================================================

#ifndef __KONOEVECTOR_HH
#define __KONOEVECTOR_HH

#include <KonoePrimitives.hh>

template<class T>
class KonoeVector {
  T* buffer;
  KInt max_elements;
  KInt elements;

public:
  KonoeVector(KInt pmaxelements = 0x1000);
  ~KonoeVector();

  T* begin() { return buffer; }
  T* end() { return buffer + elements - 1; }
  T* operator[](KInt index);

  KInt size()	{ return elements; }
  void add(T& Ob);
};

#include	<KonoeVector.cc>
#endif
