//=============================================================
/*
	KonoeCDCommand.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	26-Jan-2000	H. Sakamoto

*/
//=============================================================

#include        <system/KonoeDirectoryFile.hh>
#include        <system/KonoeCDCommand.hh>
#include	<KonoeCategories.hh>
#include	<system/KonoeFileManagerCM.hh>
#include	<system/KonoeFileManageAnswer.hh>
#include	<system/KonoePath.hh>
#include	<string.h>
#include	<unistd.h>

const KChar	* KonoeCDCommand::className = "KonoeCDCommand";

KonoeCDCommand::KonoeCDCommand( ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_CDCOMMAND ){

	path = 0;

}

KonoeCDCommand::KonoeCDCommand( KonoePath *ppath  ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_CDCOMMAND ){

	path = new KonoePath( ppath -> getPath( ) );
}

KonoeCDCommand::~KonoeCDCommand( ){

	delete path;
}

KInt	KonoeCDCommand::execute( KonoeFileManageServer * server ) {
	
	KonoeFileManageAnswer * answer;

	if ( access( path -> getUnixPath(  ), X_OK ) == 0 ){ //permitted

	    answer = new KonoeFileManageAnswer( 
				KonoeFileManageAnswer::SUCCESS );
	} else { // 
	    answer = new KonoeFileManageAnswer( 
				KonoeFileManageAnswer::ERROR );
	}
	server -> sendObject( answer );
	delete answer;

	return 0;

}

KInt	KonoeCDCommand::request( KonoeFileManageServer * server ) {

	return 0;

}

KInt KonoeCDCommand::put( KonoeOutputObjectStream * os,
		KChar level, KInt memberid ) {
	
	KChar	l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	path -> put( os, l, MID_PATH );

	return 0;
}

KInt KonoeCDCommand::getStreamSize( ){
	
	return HEADER_SIZE + path -> getStreamSize( );
}

KInt	KonoeCDCommand::fillObjectMember( KInt memberid, 
                                               KonoeStreamableObject * obj){
	if( memberid != MID_PATH ){
          delete obj;
          return -1;
        }

	path = ( KonoePath * ) obj;

	return 0;
}
