//=================================================================
/*

	KonoeDirectoryFile.cc

	Version 0.4.0   01-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//=================================================================

#include	<system/KonoeDirectoryFile.hh>
#include	<string.h>
#include	<errno.h>

KonoeDirectoryFile::KonoeDirectoryFile( KChar * ppath ){

	errno = 0;
	dirp = opendir( ppath );
	if( dirp == NULL ){
	    if( errno == EACCES ){
		status = E_PERMISSINDENIED;
	    }else if( errno == ENOENT ){
		status = E_NOTEXIST;
	    }else if( errno == ENOTDIR ){
		status = E_NOTDIRECTORY;
	    }else {
		status = E_OTHER;
	    cerr << "KonoeDirectory::KonoeDirectory. Open Error" << endl;
	    //exit( );
	    }
	}
	else{
	    status = NORMAL;
	}
}

KonoeDirectoryFile::~KonoeDirectoryFile( ){

	if( dirp != NULL ){
	    closedir( dirp );  
	}
}

KChar * KonoeDirectoryFile::getFileName( ){

	if( status == NORMAL ){
	    dp = readdir( dirp );
	    if( dp ){
	    	return dp -> d_name ; 
	    }else{
	    	return 0;
	    }
	}else{
		return 0;
	}
}

void	KonoeDirectoryFile::reset( ){

	rewinddir( dirp );

}
