//=================================================================
/*

	KonoeDirectoryInfomation.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//=================================================================

#include	<system/KonoeDirectoryInfomation.hh>
#include	<system/KonoeFileInfomation.hh>
#include	<system/KonoeDirectoryFile.hh>
#include	<system/KonoeDirectoryFile.hh>
#include	<system/KonoeFileManagerCM.hh>
#include	<KonoeCategories.hh>
#include	<string.h>
#include	<stdio.h>

const KChar	* KonoeDirectoryInfomation::className = 
					"KonoeDirectoryInfomation";

KonoeDirectoryInfomation::KonoeDirectoryInfomation( KChar * ppath ):
			KonoeStreamableObject( KonoeCategories::FILEMANAGER,
				KonoeFileManagerCM::CID_DIRECTORYINFOMATION ) {

	directoryname = new KChar[ strlen( ppath ) + 1];
	strcpy( directoryname, ppath );

	KChar *filename;
	KChar * filepath;
	KonoeDirectoryFile * dir = new KonoeDirectoryFile( ppath );
	KonoeFileInfomation * file;
	KInt	n = 0;

	if( dir -> isNormal( ) ){
	    status = NORMAL;
//cout<<"nonrmal" << endl;
	    while( dir -> getFileName( ) ){
		n++;
	    }
	    filelist = new KonoeList<KonoeFileInfomation>( n ); 
	    dir -> reset( );
	    while( filename = dir -> getFileName( ) ){
		filepath = new KChar[ strlen( ppath ) + 1 + strlen( filename ) + 1 ];
		sprintf( filepath, "%s%s%s%s", ppath,"/", filename,"\0");
		file = new KonoeFileInfomation( filepath );
		filelist -> add( file );
		delete filepath;
	    }
	}
	else{
//cout<<"error" << endl;
	    status = dir -> getStatus();
	    filelist = 0;
	}

	delete dir;
}

KonoeDirectoryInfomation::KonoeDirectoryInfomation(  ) :
		KonoeStreamableObject( KonoeCategories::FILEMANAGER,
                           KonoeFileManagerCM::CID_DIRECTORYINFOMATION ) {
	filelist = 0;
	status = E_OTHER;
}

KonoeDirectoryInfomation::~KonoeDirectoryInfomation( ){

	if( filelist ){
	    delete filelist;
	}
}

KInt	KonoeDirectoryInfomation::getStreamSize( ){

        KInt    s, n, i;
	KonoeFileInfomation * fileinfo;

	s = 0;
	s += HEADER_SIZE + 1; // status
	s += HEADER_SIZE + strlen( directoryname ) / sizeof( KInt ) + 1;
	if( filelist ){
//cout<<"list is exist" << endl;
	    n = filelist -> getCount( );
	    s += HEADER_SIZE + 1; // nfiles
	    filelist -> reset( );
	    for( i=0; i<n ; i++ ){
                s += HEADER_SIZE + filelist -> next() -> getStreamSize( );
	    }
	}
//cout<<"get Streamsize ="<< s << endl;
        return s;
}

KInt	KonoeDirectoryInfomation::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

KInt temp;
        KChar   l = level + 1;
	KInt	i, n_members, n;

	n_members = 2;
	if( filelist ){
	    n_members += 1 + filelist -> getCount( );
	}

        os -> putHeader( this, level, memberid, n_members );
	os -> put( l, MID_DIRNAME, directoryname );
	os -> put( l, MID_STATUS, status );

	if( filelist ){
	    filelist-> reset( );
	    n = filelist -> getCount( );
	    os -> put( l, MID_NFILES, n );
	    for( i = 0; i < n; i++){
            	filelist -> next() -> put( os, l, MID_FILEINFO );
for( temp = 0; temp < 100000; temp++ );
	    }
	}

        return 0;
}

KInt    KonoeDirectoryInfomation::fillPrimitiveMember( KInt memberid, 
			KInt datatype, KInt datacount, void * data ){

//cout<<"debug DirectoryInfomation::fillPrimitiveMember. called<< endl;

        switch( datatype ) {
        case KCHAR_TYPE :
            switch( memberid ){
            case MID_DIRNAME :
		directoryname = (KChar*)data;
		return 0;
            default :
                delete [] data;
                return -1;
            }
            return 0;
        case KINT_TYPE :
	    switch( memberid ){
	    case MID_NFILES :
	    	filelist = new KonoeList<KonoeFileInfomation>( *(KInt*)data );
	    	delete [] data;
	    	return 0;
	    case MID_STATUS :
		status = *(KInt*) data;
		delete [] data;
		return 0;
	    default :
		delete [] data;
		return -1;
	    }
        default :
            delete [] data;
            return -1;
        }
}

KInt    KonoeDirectoryInfomation::fillObjectMember( KInt memberid, 
					       KonoeStreamableObject * obj){

	KInt st;

        if( memberid != MID_FILEINFO ){
	  delete obj;
	  return -1;
	}

	if( filelist == 0 ){
	  cerr<<"KonoeDirectoryInfomation::fillObjectMember. Error. "
	    "filelist == 0 " << endl;
	  delete obj;
	  return -1;
	}

	filelist -> add( (KonoeFileInfomation*)obj );
	return 0;
}

