//====================================================================
/*

	KonoeDirectoryInfomation.hh

	Version 0.4.0   01-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//====================================================================

#ifndef __KONOEDIRECTORYINFOMATION_HH
#define __KONOEDIRECTORYINFOMATION_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<system/KonoeFileInfomation.hh>
#include	<KonoeList.hh>

class KonoeDirectoryInfomation : public KonoeStreamableObject {

public :
	const static KChar	* className;
	enum	{ MID_DIRNAME, MID_NFILES, MID_FILEINFO,
		MID_STATUS, N_MEMBERS };
	enum    {       NORMAL,
                        E_NOTEXIST, E_PERMISSINDENIED,
                        E_NOTDIRECTORY, E_OTHER };

protected :
	KonoeList<KonoeFileInfomation> * filelist;
	KChar	* directoryname;
	KInt	status;

public :

	KonoeDirectoryInfomation( KChar * ppath );
	KonoeDirectoryInfomation( );
	~KonoeDirectoryInfomation( );

	KBool	isNormal( ){ return status == NORMAL; }
	KInt	getStatus( ){ return status; }
	KChar *	getDirectoryName( ){ return directoryname; }
	KonoeFileInfomation * next( ){	return filelist -> next( );}
	void	reset( ){	filelist -> reset( ); }
	KInt	getCount( ){	return filelist -> getCount( ); }

	// to be streamable

        KInt    put(    KonoeOutputObjectStream * outstream,
                        KChar level, KInt memberid );
        KInt    getStreamSize( );
        KInt    fillPrimitiveMember( KInt memberid, KInt datatype,
                                KInt datacount, void * data );
        KInt    fillObjectMember( KInt memberid, KonoeStreamableObject * );

};

#endif
