//===================================================================
/*

	KonoeDirectoryRequest.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================

#include	<system/KonoeDirectoryRequest.hh>
#include	<system/KonoeFileManagerCM.hh>
#include	<system/KonoeFileManageServer.hh>
#include	<system/KonoeDirectoryInfomation.hh>
#include	<system/KonoeFileInfomation.hh>
#include	<string.h>

const	KChar	* KonoeDirectoryRequest::className = "KonoeDirectoryResuest";

KonoeDirectoryRequest::KonoeDirectoryRequest( KonoePath * ppath ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_DIRECTORYREQUEST ){

	path = ppath;
}

KonoeDirectoryRequest::KonoeDirectoryRequest( ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_DIRECTORYREQUEST ){

	path = 0;
}

KonoeDirectoryRequest::~KonoeDirectoryRequest( ) {

	delete path;
}

KInt KonoeDirectoryRequest::request( KonoeFileManageServer * server ){

cout<< "debug:DirectoryRequest:request: path " << path -> getPath( ) << endl;
cout<< "debug:DirectoryRequest:request: unixpath " << path -> getUnixPath( ) << endl;

	KonoeDirectoryInfomation * dir;;
	dir = server -> getDirectoryInfomation( path );
//cout<< "debug:FileRequest:request: filename " <<  endl;
	return server -> sendObject( dir );
	
}


KInt	KonoeDirectoryRequest::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

	KChar   l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	path -> put( os, l, MID_PATH );

	return 0;
}

KInt 	KonoeDirectoryRequest::getStreamSize( ){

	KInt	s;

	s = HEADER_SIZE + path -> getStreamSize( );
	return s;
}

KInt	KonoeDirectoryRequest::fillObjectMember( KInt memberid, 
                                        KonoeStreamableObject * obj ){

	if( memberid != MID_PATH ){
		delete obj;
		return -1;
	}
	path = ( KonoePath * ) obj;
	return 0;
}
