//===================================================================
/*

	KonoeFileIORequest.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno


*/
//===================================================================

#include	<system/KonoeFileIORequest.hh>
//#include	<system/KonoeNetworkFileCM.hh>
#include	<system/KonoeFileManagerCM.hh>
#include	<system/KonoeNetworkFileIOManager.hh>
#include	<system/KonoeFileManageServer.hh>
#include	<system/KonoeNetworkInputFileManager.hh>
#include	<system/KonoeInputFile.hh>
#include	<string.h>

const	KChar	* KonoeFileIORequest::className = 
					"KonoeFileIOResuest";

KonoeFileIORequest::KonoeFileIORequest( KChar * pfilename, KInt pmode ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_FILEIOREQUEST ){

	filename = new KChar[ strlen( pfilename ) + 1 ];
	strcpy( filename, pfilename );

	mode = pmode;
}

KonoeFileIORequest::KonoeFileIORequest( ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_FILEIOREQUEST ){

	filename = 0;
	mode = UNDEFINED;
}

KInt KonoeFileIORequest::request( KonoeFileManageServer * server ){

cout<< "debug:FileIORequest:request: called " << endl;
cout<< "debug:FileIORequest:request: filename " << filename << endl;
	//KonoeNetworkFileIOManager * manager;
	return server -> doFileIOManage( filename, mode );

/*
	KonoeSocketConnection * c;
	c = server -> getSocketConnection( );
	KonoeNetworkFileIOManager * manager;

	switch( mode ){
	    case READ :
		//KonoeNetworkInputFileManager * manager;
		manager = new KonoeNetworkInputFileManager( filename, c );
		break;

	    case WRITE :
	    default :
		return -1;
	}

	//manager -> go( );
	return 0;
*/
}

KInt	KonoeFileIORequest::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

	KChar   l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_MODE, mode );
	os -> put( l, MID_FILENAME, filename );

	return 0;
}

KInt 	KonoeFileIORequest::getStreamSize( ){

	KInt	s;

	s = HEADER_SIZE + 1;
	s += HEADER_SIZE + strlen( filename )/sizeof(KInt) + 1;
	return s;
}

KInt	KonoeFileIORequest::fillPrimitiveMember( KInt memberid, 
				KInt datatype, KInt datacount, void * data ){

        switch( datatype ) {
        case KINT_TYPE :
		switch( memberid ){
		case MID_MODE :
			mode = * ( KInt * ) data;
			delete [] data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
        case KCHAR_TYPE :
		switch( memberid ){
		case MID_FILENAME :
			filename = ( KChar * ) data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
	defalut :
		delete [] data;
		return -1;
	}

}

