//=================================================================
/*

        KonoeFileInfomation.cc

	Version 0.4.0   05-Aug-1999     N. Tanimoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
*/
//=================================================================

#include	<system/KonoeFileInfomation.hh>
#include	<KonoeCategories.hh>
#include        <system/KonoeFileManagerCM.hh>
#include        <system/KonoeFileStatus.hh>
#include        <iostream.h>

const KChar     * KonoeFileInfomation::className = "KonoeFileInfomation";

KonoeFileInfomation::KonoeFileInfomation( KChar * pfilename ) :
		KonoeStreamableObject( KonoeCategories::FILEMANAGER,
                               KonoeFileManagerCM::CID_FILEINFOMATION ){

	filestatus = new KonoeFileStatus( pfilename );
	if( filestatus -> isNormal( ) ){
	    status = NORMAL;
	}else{
	    status = filestatus -> getStatus( );
	}
}

KonoeFileInfomation::KonoeFileInfomation( ) : 
	KonoeStreamableObject( KonoeCategories::FILEMANAGER,
                               KonoeFileManagerCM::CID_FILEINFOMATION ){
	filestatus = 0;
	status = E_OTHER;
}

KonoeFileInfomation::~KonoeFileInfomation( ){

	delete filestatus;
}

KInt    KonoeFileInfomation::getStreamSize( ){

        KInt    s;
        s += HEADER_SIZE + 1; // status
	s = HEADER_SIZE + filestatus -> getStreamSize( );
        s += HEADER_SIZE + 1; // headerword
        return s;
}

KInt	KonoeFileInfomation::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

	KChar   l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_HEADER, headerword );
	os -> put( l, MID_STATUS, status );
	filestatus -> put( os, l, MID_FILESTATUS );

	return 0;
}

KInt	KonoeFileInfomation::fillPrimitiveMember( KInt memberid, KInt datatype,
                                KInt datacount, void * data ){

        switch( datatype ) {
        case KINT_TYPE :
	    switch( memberid ){
	    case MID_HEADER :
		headerword = *(KInt*)data;
		delete [] data;
		return 0;
	    case MID_STATUS :
		status = *(KInt*)data;
		delete [] data;
		return 0;
	    default :
		delete [] data;
		return -1;
	    }
	default :
	    delete [] data;
	    return -1;
        }
}

KInt	KonoeFileInfomation::fillObjectMember(  KInt memberid,
						KonoeStreamableObject * obj ){

	if( memberid != MID_FILESTATUS ){
		delete obj;
		return -1;
	}
	filestatus = ( KonoeFileStatus * ) obj;

	return 0;
}
