//===================================================================
/*

	KonoeFileInfomation.hh
	
	Version 0.4.0   0$-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================

#ifndef __KONOEFILEINFOMATION_HH
#define __KONOEFILEINFOMATION_HH

#include        <system/KonoeFileStatus.hh>
#include        <system/KonoeStreamableObject.hh>

class	KonoeFileInfomation : public KonoeStreamableObject {

public :
	static const KChar	* className;

	enum	MEMBER_ID { MID_HEADER, MID_FILESTATUS,
			    MID_STATUS, N_MEMBERS };
	enum    {       NORMAL,
                        E_NOTEXIST, E_PERMISSINDENIED,
                        E_OTHER };

protected :
	KInt	headerword;
	KonoeFileStatus * filestatus;
	KInt	status;

public :
        KonoeFileInfomation( KChar * pfilename );
        KonoeFileInfomation( );
        ~KonoeFileInfomation( );

	KInt	getStatus( ){ return status; }
	KonoeFileStatus * getFileStatus( ){ return filestatus; }

	// to be streamable

        KInt    put(    KonoeOutputObjectStream * outstream,
                        KChar level, KInt memberid );
        KInt    getStreamSize( );
        KInt    fillPrimitiveMember( KInt memberid, KInt datatype,
                                KInt datacount, void * data );
        KInt    fillObjectMember( KInt memberid, KonoeStreamableObject * );

};

#endif
