//==========================================================
/*

	KonoeFileManageAnswer.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==========================================================

#include <system/KonoeFileManageAnswer.hh>
#include <system/KonoeFileManagerCM.hh>
#include <KonoeCategories.hh>

const	KChar	* KonoeFileManageAnswer::className ="KonoeFileManageAnswer";

KonoeFileManageAnswer::KonoeFileManageAnswer( KInt pstatus, KInt classid ) :
	KonoeStreamableObject( KonoeCategories::FILEMANAGER, classid ){

	status = pstatus;
}
KonoeFileManageAnswer::KonoeFileManageAnswer( ) :
	KonoeStreamableObject( KonoeCategories::FILEMANAGER,
				KonoeFileManagerCM::CID_FILEMANAGEANSWER ){

}

KInt    KonoeFileManageAnswer::getStreamSize( ){

        KInt    s;

        s = HEADER_SIZE + 1;
        return s;
}


KInt	KonoeFileManageAnswer::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

        KChar   l = level + 1;

        os -> putHeader( this, level, memberid, N_MEMBERS );
        os -> put( l, MID_STATUS, status );

        return 0;
}

KInt    KonoeFileManageAnswer::fillPrimitiveMember( KInt memberid, 
                                KInt datatype, KInt datacount, void * data ){

        switch( datatype ) {
        case KINT_TYPE :
                switch( memberid ){
                case MID_STATUS :
                        status = * ( KInt * ) data;
                        delete [] data;
                        return 0;
                default :
                        delete [] data;
                        return -1;
                }
	default :
	        delete [] data;
                return -1;
        }

}

