//========================================================
/*

	KonoeFileManageAnswer.hh
	
	Version 0.0.1  03-Sep-1999  Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//========================================================

#ifndef __KONOEFILEMANAGEANSWER_HH
#define __KONOEFILEMANAGEANSWER_HH

#include	<system/KonoeStreamableObject.hh>
#include	<system/KonoeFileManageServer.hh>
#include	<system/KonoeFileManageAnswer.hh>
#include	<system/KonoeFileManagerCM.hh>

class KonoeFileManageAnswer : public KonoeStreamableObject {

public :
	static const KChar	* className;
	enum	{ MID_STATUS, N_MEMBERS	};
	enum	{ ERROR, SUCCESS };

protected :
	KInt	status;

public :
	KonoeFileManageAnswer( KInt pstatus, KInt classid
				= KonoeFileManagerCM::CID_FILEMANAGEANSWER );
	KonoeFileManageAnswer( );

	KInt	getStatus( ){ return status; }
	KBool	status_is_Success( ){ return status == SUCCESS; }

	// to be streamable

	KInt    put(    KonoeOutputObjectStream * outstream,
                        KChar level, KInt memberid );
        KInt    getStreamSize( );
        KInt    fillPrimitiveMember( KInt memberid, KInt datatype,
                        KInt datacount, void * data );
        KInt    fillObjectMember( KInt, KonoeStreamableObject * ) {
                        return -1;      }

};

#endif
