//==========================================================
/*

   KonoeFileManageServer.cc

        Version 0.0.1   03-Aug-1999     S.Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	26-Jan-2000	H. Sakamoto


*/
//==========================================================

#include "KonoeFileManageServer.hh"
//#include "KonoeUNIXCommand.hh"
//#include <system/KonoeFileManageServer.hh>
//#include <system/KonoeFileManagerCM.hh>
#include <system/KonoeFileManagerCM.hh>
#include <system/KonoeNetworkFileIOManager.hh>
#include <system/KonoeNetworkInputFileManager.hh>
#include <system/KonoeNetworkOutputFileManager.hh>
#include <system/KonoeNetworkFileIO.hh>
#include <system/KonoeFileManageRequest.hh>
#include <system/KonoeHostSystem.hh>
#include <KonoeCategories.hh>

#include	<sys/types.h>
#include	<unistd.h>
#include	<stdlib.h>

KonoeFileManageServer::KonoeFileManageServer( ){
  
	readfds = new KonoeFDSet( );

	serverSocket = new KonoeServerSocket( FILEMANAGERPORT, readfds );

	socket = new KonoeObjectSocket( serverSocket );

	KonoeFileManagerCM * cm = new KonoeFileManagerCM( );
	socket -> installCM( cm );
  
}

KInt KonoeFileManageServer::go( ){
  
	KInt st,k;
//	KChar buffer[ BUFFERSIZE ];
	KChar buffer[ 256 ];
	KonoeFDClient  *cl;
	KonoeSocketConnection *ch;
	//KonoeFileCommand * command; 
	//KonoeUNIXCommand * command; 
	KonoeFileManageRequest * request;

cout<< "started" << endl; // for debag
  
	while( 1 ){

	    cl =readfds -> wait( 1000 );
	    if( cl ) {

cout<< "Server : cl exist" << endl; // for debag
		ch = serverSocket -> processReceiveAction( cl );

		if( ch == ( KonoeSocketConnection * ) -1 ){
		    cerr <<"Connection fault! " <<endl;
	    	}
	    	else if ( ch ){
cout<< "Server : ch exist" << endl; // for debag
		 //   socket -> read( buffer, 256 );
		//command = ( KonoeFileCommand * ) socket -> get( );
		//    command = ( KonoeUNIXCommand * ) socket -> get( );
		request = ( KonoeFileManageRequest * ) socket -> get( );
		    //if( command ){
		    if( request ){
cout<< "degug : Server : request exist " << endl;
			request -> execute( this );
		    	//executeCommand( command );
		    }	
	    	}

	    }
	}
	return 0;
}

KonoeFileInfomation * KonoeFileManageServer::getFileInfomation
						( KonoePath * path ){
cout<<"fileinfo::getFileInfo. called" << endl;

	KonoeFileInfomation * file;
	file = new KonoeFileInfomation( path -> getUnixPath( ) );
	return file;
}

KonoeDirectoryInfomation * KonoeFileManageServer::getDirectoryInfomation( KonoePath * path ){

        KonoeDirectoryInfomation * dir;
        dir = new KonoeDirectoryInfomation( path -> getUnixPath( ) );
        return dir;
}

KInt	KonoeFileManageServer::sendObject( KonoeStreamableObject * obj ){


//	KonoeServerSocket * s;
//	s =  (KonoeServerSocket * )socket -> getSocket( );
//	s -> setSendMode( KonoeServerSocket::SEND_TO_LAST );
	
	//((KonoeServerSocket *)( socket -> getSocket ))
	//	-> setSendMode( KonoeServerSocket::SEND_TO_LAST );
	serverSocket -> setSendMode( KonoeServerSocket::SEND_TO_LAST );

	//((KonoeDirectoryFile *) obj) -> reset( );
	//cout << ((KonoeDirectoryFile*)obj) -> getFileName( ) << endl;

	return socket -> put( obj );
}


KInt KonoeFileManageServer::doFileIOManage( KChar * filename, KInt mode ){

//cout<< "degug:Server:doFileIOManage: called " << endl;

	KonoeNetworkFileIOManager * manager;
	KonoeSocketConnection * connection;

	connection = (( KonoeServerSocket* ) socket -> getSocket( ) )
						 -> getLastReceived( );

	switch( mode ){
	    case KonoeNetworkFileIO::READ :
cout<< "degug:Server:doFileIOManage: create infilemanager " << endl;
		manager = new KonoeNetworkInputFileManager( filename, connection );
		break;
	    case KonoeNetworkFileIO::WRITE :
		manager = new KonoeNetworkOutputFileManager( filename, connection );
		break;
	    default :
		return -1;
	}

	if( fork( ) == 0 ){ //child process
		manager -> go( );
		KonoeHostSystem::exit( 0 );
	}

	(( KonoeServerSocket* ) socket -> getSocket( ) )
		-> close( connection );

	return 0;
}


/*
KInt KonoeFileManageServer::executeCommand( KonoeUNIXCommand * command ){
//KInt KonoeFileManageServer::executeCommand( KonoeFileCommand * command ){
//KInt KonoeFileManageServer::executeCommand(  ){

	command -> execute( );
	return 0;
}

*/
