//==========================================================
/*


   KonoeFileManagerCM.cc

        Version 0.0.1   03-Aug-1999     S.Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno


*/
//==========================================================

#include	<system/KonoeFileManagerCM.hh>
#include	<KonoeCategories.hh>
#include	<system/KonoeFileIORequest.hh>
#include	<system/KonoeFileRequest.hh>
#include	<system/KonoeFileManageAnswer.hh>
#include	<system/KonoeDirectoryRequest.hh>
#include	<system/KonoeFileInfomation.hh>
#include	<system/KonoeDirectoryInfomation.hh>
#include	<system/KonoePath.hh>
//#include	<system/KonoeLSCommand.hh>
#include	<system/KonoeCDCommand.hh>
#include	<system/KonoeCPCommand.hh>

KonoeFileManagerCM::KonoeFileManagerCM( ) :
	 KonoeCategoryManager( KonoeCategories::FILEMANAGER, "filemanager" ){
}


KonoeStreamableObject   * KonoeFileManagerCM::create( KInt classid ) {

	switch( classid ) {
		case CID_LSCOMMAND :
//			return new KonoeLSCommand;
		case CID_FILEIOREQUEST :
			return new KonoeFileIORequest;
		case CID_CDCOMMAND :
			return new KonoeCDCommand;
		case CID_FILEINFOMATION :
			return new KonoeFileInfomation;
		case CID_DIRECTORYINFOMATION :
			return new KonoeDirectoryInfomation;
		case CID_PATH :
			return new KonoePath;
		case CID_FILEREQUEST :
			return new KonoeFileRequest;
		case CID_DIRECTORYREQUEST :
			return new KonoeDirectoryRequest;
		case CID_FILEMANAGEANSWER :
			return new KonoeFileManageAnswer;
        case CID_CPCOMMAND :
            return new KonoeCPCommand;
	}
	return 0;
}

const KChar   *KonoeFileManagerCM::getClassName( KInt classid ) {

	switch( classid ) {
		case CID_LSCOMMAND :
//			return KonoeLSCommand::className;
		
		case CID_FILEIOREQUEST :
			return KonoeFileIORequest::className;
		case CID_CDCOMMAND :
			return KonoeCDCommand::className;
		case CID_FILEINFOMATION :
			return KonoeFileInfomation::className;
		case CID_DIRECTORYINFOMATION :
			return KonoeDirectoryInfomation::className;
		case CID_PATH :
			return KonoePath::className;
		case CID_FILEREQUEST :
			return KonoeFileRequest::className;
		case CID_DIRECTORYREQUEST :
			return KonoeDirectoryRequest::className;
		case CID_FILEMANAGEANSWER :
			return KonoeFileManageAnswer::className;
        case CID_CPCOMMAND :
            return KonoeCPCommand::className;
	}
	return 0;
}
