//===================================================================
/*

	KonoeFileRequest.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//===================================================================

#include	<system/KonoeFileRequest.hh>
#include	<system/KonoeFileManagerCM.hh>
#include	<system/KonoeSystemServiceCM.hh>
#include	<system/KonoeFileManageServer.hh>
#include	<system/KonoeFileInfomation.hh>
#include	<string.h>

const	KChar	* KonoeFileRequest::className = "KonoeFileResuest";

KonoeFileRequest::KonoeFileRequest( KonoePath * ppath ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_FILEREQUEST ){

	path = ppath;
}

KonoeFileRequest::KonoeFileRequest( ) :
	KonoeFileManageRequest( KonoeFileManagerCM::CID_FILEREQUEST ){

	path = 0;
}

KonoeFileRequest::~KonoeFileRequest( ) {

	delete path;
}

KInt KonoeFileRequest::request( KonoeFileManageServer * server ){

cout<< "debug:FileRequest:request: path " << path -> getPath( ) << endl;
cout<< "debug:FileRequest:request: unixpath " << path -> getUnixPath( ) << endl;

	KonoeFileInfomation * file;
	file = server -> getFileInfomation( path );
cout<< "debug:FileRequest:request: filename " 
		<< file ->getFileStatus()-> getFileName( )<< endl;
	return server -> sendObject( file );
	
}


KInt	KonoeFileRequest::put( KonoeOutputObjectStream * os,
                        KChar level, KInt memberid ){

	KChar   l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	path -> put( os, l, MID_PATH );

	return 0;
}

KInt 	KonoeFileRequest::getStreamSize( ){

	KInt	s;

	s = HEADER_SIZE + path -> getStreamSize( );
	return s;
}

KInt	KonoeFileRequest::fillObjectMember( KInt memberid, 
                                        KonoeStreamableObject * obj ){

	if( memberid != MID_PATH ){
		delete obj;
		return -1;
	}
	path = ( KonoePath * ) obj;
	return 0;
}
