//==================================================================
/*

	KonoeNetworkFileManager.cc

        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================

#include	<system/KonoeNetworkFileManager.hh>
#include	<system/KonoeFileManageServer.hh>
//#include	"KonoeUNIXCommand.hh"
#include	<system/KonoeFileManagerCM.hh>
#include	<system/KonoeSystemServiceCM.hh>
#include	<system/KonoeFileRequest.hh>
#include	<system/KonoeDirectoryRequest.hh>
#include	<system/KonoeFileManageAnswer.hh>
#include	<system/KonoeCDCommand.hh>
#include	<system/KonoeCPCommand.hh>
//#include	<system/KonoeFileCommand.hh>
//#include	<system/KonoeLSCommand.hh>

//KonoeNetworkFileManager::KonoeNetworkFileManager( KChar * host ) : 
//				KonoeFileManager( ) {

KonoeNetworkFileManager::KonoeNetworkFileManager( KChar * host ) {

	KInt port;
	port = KonoeFileManageServer::FILEMANAGERPORT;
	clientSocket = new KonoeClientSocket( host ,port );
	socket = new KonoeObjectSocket( clientSocket );

	socket -> installCM( new KonoeFileManagerCM );
	socket -> installCM( new KonoeSystemServiceCM );

	pwd = new KonoePath("/", host );
}

KonoeNetworkFileManager::~KonoeNetworkFileManager( ) {

	delete socket;
	delete pwd;
}

KonoeFileInfomation * KonoeNetworkFileManager::getFileInfomation(
						 KonoePath * path ){

	KonoePath * p = new KonoePath( pwd -> getPath( ) );
        p -> changePath( path );

	KonoeFileRequest * request;
	request = new KonoeFileRequest( p );

//cout<<"put" << endl;
        socket -> put( request );
//cout<<"get" << endl;

        KonoeFileInfomation * file =  (KonoeFileInfomation*)socket -> get( );
        return file;
}

KonoeDirectoryInfomation * KonoeNetworkFileManager::getDirectoryInfomation
						( KonoePath * path ){

	KonoePath * p = new KonoePath( pwd -> getPath( ) );
	if( path ){
	    p -> changePath( path );
	}

	KonoeDirectoryRequest * request;
        request = new KonoeDirectoryRequest( p );

//cout<<"NetworkFileManager::getDirectoryInfomation. put request" << endl;
        socket -> put( request );
//cout<<"NetworkFileManager::getDirectoryInfomation. get dirInfo" << endl;
	KonoeDirectoryInfomation * dir;
	dir =  (KonoeDirectoryInfomation*)socket -> get( );
	delete p;
	return dir;
}
	
KInt	KonoeNetworkFileManager::ls( ){

	//KonoeFileCommand * ls = new KonoeLSCommand;
	//KonoeUNIXCommand * ls = new KonoeUNIXCommand("ls");

	//socket -> put( ls );

	return 0;
}

KInt	KonoeNetworkFileManager::cd( KonoePath * path ){

	KonoeCDCommand * cd;
	KonoeFileManageAnswer * answer;
	KonoePath * p;
	KInt	st;

	p = new KonoePath( pwd -> getPath( ) );
	p -> changePath( path );
	cd = new KonoeCDCommand( p );
	socket -> put( cd );
	answer = ( KonoeFileManageAnswer * ) socket -> get( );

	if ( answer ){
	    if( answer -> status_is_Success( ) ){
		pwd -> changePath( path );
		st = 0;
	    } else {
		st = -1;
	    }
	} else {
	    cerr<<"KonoeNetworkFileManager. cd error"
		 << "answer get error " << endl;
	    st = -1;
	}

	delete p;
	delete cd;
	delete answer;

	return st;
}

/*
KInt	KonoeNetworkFileManager::executeCommand( KonoeUNIXCommand * command ){

	socket -> put( command );
}
*/

KInt KonoeNetworkFileManager::cp( KChar* fromHost, KChar* filename1,
                            KChar* toHost, KChar* filename2, KInt bufferSize){
  KonoeCPCommand* cp;
  KonoeFileManageAnswer* answer;
  KInt	st;

cout << "KonoeNetworkFileManager::cp" << endl;
  cp = new KonoeCPCommand;
//  socket->put( cp );
//  answer = (KonoeFileManageAnswer *) socket->get();

      cp->copy(fromHost, filename1, toHost, filename2, bufferSize);
/*
  if( answer ){
    if( answer->status_is_Success() ){
      cp->copy(fromHost, filename1, toHost, filename2, bufferSize);
      st = 0;
    }
    else st = -1;
  }
  else{
    cerr << "KonoeNetworkFileManager. cp error : answer get error" << endl;
    st = -1;
  }
*/
  delete cp;
  return st;
//  delete answer;
}
