//====================================================================
/*

	KonoePath.hh

	Version 0.0.1   03-Aug-1999   Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//====================================================================

#ifndef __KONOEPATH_HH
#define __KONOEPATH_HH

#include        <KonoePrimitives.hh>
#include        <system/KonoeStreamableObject.hh>
#include	<iostream.h>

class KonoePath : public KonoeStreamableObject {

public :
	static const KChar * className;
	enum	{ MID_PATH, MID_HOST, N_MEMBERS };

private :
	KChar * path;
	KChar * host;
	static KChar * root;
	static KonoePath pwd; // parent working directory

	KInt checkPath( KChar * ppath, KChar * buffer );

public :
	KonoePath( const KChar * ppath, const KChar * phost = 0 );
	KonoePath( );
	~KonoePath( );

	KChar * getPath( ){ return path; }
	KChar * getHost( ){ return host; }
	KChar * getUnixPath( );
	KInt changePath( KonoePath * ppath );
	KInt changePath( KChar * ppath );

	KChar * getPwd( ){ return pwd.getPath( );}
	KInt changePwd( char * ppath );
	KInt changePwd( KonoePath * ppath );

	KChar *  getUpDir( );

	// to be streamable

	KInt    put(    KonoeOutputObjectStream * outstream,
                        KChar level, KInt memberid );
        KInt    getStreamSize( );
        KInt    fillPrimitiveMember( KInt memberid, KInt datatype,
                                KInt datacount, void * data );
        KInt    fillObjectMember( KInt memberid, KonoeStreamableObject * ){
					return -1; }

};

#endif
