//====================================================================
/*
	FileManager Demo : 

	Version 0.5.0   21-Sep-1999     Y. Kouno
*/
//====================================================================

#include	<string.h>
#include	<iostream.h>
#include	<KonoeList.hh>
#include        <system/KonoeFileManagerCM.hh>
#include        <system/KonoeFileManageServer.hh>
#include	<system/KonoeFileRequest.hh>
#include	<system/KonoeDirectoryRequest.hh>
#include	<system/KonoePath.hh>
#include	<system/KonoeNetworkFileManager.hh>
#include	<system/KonoeHostSystem.hh>

int main( KInt argc, KChar ** argv ) {

	KChar * host1 = "konoe.kek.jp";
	KChar * host2 = "okadell.hep.okayama-u.ac.jp";

	KonoeList<KonoeNetworkFileManager> * mgrlist;
	mgrlist = new KonoeList<KonoeNetworkFileManager>(10);

	KonoeNetworkFileManager * manager, * pmanager;

	manager = new KonoeNetworkFileManager( host1 );
	mgrlist -> add( manager );

	manager = new KonoeNetworkFileManager( host2 );
	mgrlist -> add( manager );

	KonoeDirectoryInfomation * dir;
	KonoeFileInfomation * file;
	KonoeFileStatus * filestatus;
	KonoePath	* path;

	KChar buffer[256];

	while( 1 ){

	cout << "input command ( ch or cd or ls or pwd or exit ) >> ";
	cin >> buffer;
// ls
	if( strcmp( buffer, "ls" ) == 0 ){
	    cout << "input path >> ";
	    cin >> buffer;

	    path = new KonoePath(buffer);
	    dir = manager -> getDirectoryInfomation( path );
	    delete path;

	    if( dir == 0 ){
                cout<< "DirectoryInfo get error" << endl;
            }
            else if( !dir -> isNormal( ) ){
		KInt st;
		st = dir -> getStatus( );
		if( st == KonoeDirectoryInfomation::E_NOTEXIST ){
		    cout<<"not exist" << endl;
		}else if( st == KonoeDirectoryInfomation::E_PERMISSINDENIED ){
		    cout<<"permission denied" << endl;
		}else if( st == KonoeDirectoryInfomation::E_NOTDIRECTORY ){
		    cout<<"not directory" << endl;
		}
	    }
	    else{
                cout<< "Input Success!" << endl;

		KInt n;
		dir -> reset( );
		cout <<"dirname = " << dir -> getDirectoryName() << endl;
		cout<<"filecount = " << dir -> getCount() << endl;
		KInt i;
		for( i = 0; i< dir->getCount(); i++ ){
		    file = dir -> next();
		    filestatus = file -> getFileStatus();
		    cout << filestatus -> getFileName() << endl;
		} 
	    }
	}
// cd
	else if( strcmp( buffer, "cd" ) == 0 ){
	    cout << "Input Path >> ";
	    cin >> buffer;

	    path = new KonoePath(buffer);
            if( manager -> cd( path ) != 0 ){
		cout << "Change Dir Error" << endl;
	    }
            delete path;
	}
// ch change host
	else if( strcmp( buffer, "ch" ) == 0 ){
	    cout<<"Input Host>>";
	    cin >> buffer;

	    mgrlist -> reset( );
	    while( pmanager = mgrlist -> next( ) ){
		if( strcmp( pmanager -> getHostName( ), buffer ) == 0 ){
		    manager = pmanager;
		    break;
		}
	    }
	    if( pmanager == 0 ){
		cout<<"No such host" << endl;
	    }
	}
// pwd 
	else if( strcmp( buffer, "pwd" ) == 0 ){
	    cout<< manager -> getHostName( ) ;
	    cout<< manager -> getPWD( ) << endl;
	}
	else if( strcmp( buffer, "exit" ) == 0 ){
	    KonoeHostSystem::exit( 0 );
	}
	else {
	    cout << "No such command." << endl;
	}

	}// while loop

}
