//==================================================================
/*
	KonoeLogMessage.hh

	Version 0.1.0   05-Mar-1998     H. Sakamoto
        Version 0.4.0   27-Aug-1998     S. Inaba
        Version 0.4.1   03-Aug-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	22-Jul-2000	Y. Shimizu
	Version 0.6.1	15-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : logger
*/
//==================================================================

#ifndef	__KONOELOGMESSAGE_HH
#define	__KONOELOGMESSAGE_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeStreamableObject.hh>
#include	<system/KonoeTime.hh>
#include	<iostream.h>

class	KonoeLogMessage	: public KonoeStreamableObject {

public :
	static const KChar	* className;

	enum	MEMBER_ID  { MID_LEVEL , MID_MESSAGE, MID_TIME, MID_HOST, 
				MID_PID , N_MEMBERS }; 
	enum	ERRORLEVEL { SUCCESS, INFO, WARNING, ERROR, FATAL }; 
	enum    {	HOSTNAMELENGTH	= 50	};
	enum	{ 	LOGMSGLENGTH = 256 	};
protected :
	KonoeTime	* time;
	KChar		* message;
	KInt              level;
	KChar		* hostname;
	KInt		  pid;
public :
	KonoeLogMessage( KChar * message, KInt level );
	KonoeLogMessage( );
	~KonoeLogMessage( );

	KChar 	* getLogMsg( ); 

	KChar * getMessage( ){ return message; }
	KInt    getLevel( ) { return level; } 
	KChar * getLevelMsg( );
	KChar * getTimeInfo( ) { return time->getTimeInfo() ; }
	KChar * getHostName( ) { return hostname ; }
	KInt 	getPID( ) { return pid ; }
	KChar * getPIDMsg( ) ;
	void	dump( ostream & os );

	// to be streamable

	KInt	put(	KonoeOutputObjectStream * outstream,
			KChar plevel, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid, KonoeStreamableObject * );

};

#endif
