//====================================================================
/*

	KonoeLogMessenger.cc

	Version 0.6.0	22-Jul-2000	Y. Shimizu
	Version 0.6.1	15-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//====================================================================


#include <system/KonoeLogMessenger.hh>
#include <system/KonoeUDPClientSocket.hh>
#include <system/KonoeLogMessage.hh>
#include <system/KonoeLogger.hh>
#include <system/KonoeLoggerCM.hh>

KonoeLogMessenger::KonoeLogMessenger( KChar * hostname , KInt pport ) 
	: KonoeUDPClientSocket( hostname , pport ) 
{
	logserver = hostname;
	port = KonoeLogger::KONOELOGGERPORT;
	osocket = new KonoeOutputObjSocket( this  );
	
	cm = new KonoeLoggerCM;
	osocket->installCM( cm );
}


KonoeLogMessenger::~KonoeLogMessenger(  ){

	delete cm;

}

 
KInt KonoeLogMessenger::send( KonoeLogMessage * log ) 
{

	return ( osocket->put( log ) );

}

KInt KonoeLogMessenger::send( KChar * message , KInt nbyte ) 
{
	return ( KonoeUDPClientSocket::send( message , 256 ) );
}

KInt KonoeLogMessenger::receive( KChar * reply , KInt nbyte ) 
{
	return ( KonoeUDPClientSocket::receive( reply , 256 ) );
}
