//====================================================================
/*

	KonoeLogMessenger.hh

	Version 0.6.0	22-Jul-2000	Y. Shimizu
	Version 0.6.1	15-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

	You should select < object mode > or < text mode >

*/
//====================================================================

#ifndef __KONOELOGMESSENGER_HH
#define __KONOELOGMESSENGER_HH

#include <KonoePrimitives.hh>
#include <system/KonoeUDPClientSocket.hh>
#include <system/KonoeOutputObjSocket.hh>
#include <system/KonoeLogMessage.hh>
#include <system/KonoeLogger.hh>
#include <system/KonoeLoggerCM.hh>

class KonoeLogMessenger : public KonoeUDPClientSocket {

protected:
	KonoeLoggerCM *  cm;
	KChar * logserver;
	KonoeLogMessage * logMessage;
	KonoeOutputObjSocket * osocket;
	KChar * reply;
	KInt port;

public:
	KonoeLogMessenger( KChar * hostname ,
				KInt pport = KonoeLogger::KONOELOGGERPORT );
	~KonoeLogMessenger(  );
	KInt send( KonoeLogMessage * log  );            // object mode 
	KInt send( KChar * message , KInt nbyte );      // text mode 
	KInt receive( KChar * reply , KInt nbyte );
	KonoeLogMessage * getLogMessage( ) { return logMessage ; }
	KChar * getLogServer( ) { return logserver ; }

};

#endif 

