//==================================================================
/*

	KonoeLogger.cc

	Version 0.0.1   03-Aug-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0 	22-Jul-2000	Y. Shimizu
	Version 0.6.1 	15-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : logger

*/
//==================================================================

#include <system/KonoeLogger.hh>
#include <system/KonoeLogMessage.hh>
#include <system/KonoeHostSystem.hh>
#include <system/KonoeLoggerCM.hh>
#include <KonoeCategories.hh>
#include <string.h>
#include <signal.h>

KonoeLogger::KonoeLogger( KChar * pfilename , KInt pport ) 	
	: KonoeUDPServerSocket( pport ) {

	filename = pfilename;


	osocket = new KonoeInputObjSocket( this );
	cm = new KonoeLoggerCM;
	osocket->installCM( cm );
	
}


KonoeLogger::~KonoeLogger( ) {

	delete file;
	delete osocket;
	delete ofile;
	delete cm;
}


KInt	KonoeLogger::go( ){

	KonoeLogMessage * log;

	ofile = new KonoeOutputObjFile(filename);

	log = (KonoeLogMessage*)osocket->get( );

	ofile->put(log);

	delete log;

	reply((void*)"I got it",BUFFERSIZE);
	
	return (1);
	
}

KChar*  KonoeLogger::go_text_mode( ) {

	KChar message[BUFFERSIZE];

	file = new KonoeOutputFile(filename); 

	receive( message, BUFFERSIZE );
	file->writeToStream( message, strlen(message) );
	reply((void*)"I got it",BUFFERSIZE);
	
	return message;
		
}
