//==================================================================
/*

	KonoeLogger.hh

	Version 0.0.1 03-Aug-1999 Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0 	22-Jul-2000	Y. Shimizu
	Version 0.6.1 	15-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : logger

	You should select < object mode > or < text mode >

*/
//==================================================================

#ifndef __KONOELOGGER_HH
#define __KONOELOGGER_HH

#include <KonoePrimitives.hh>
#include <system/KonoeLoggerCM.hh>
#include <system/KonoeLogMessage.hh>
#include <system/KonoeUDPServerSocket.hh>
#include <system/KonoeOutputFile.hh>
#include <system/KonoeOutputObjFile.hh>
#include <system/KonoeInputObjSocket.hh>

class KonoeLogger : public KonoeUDPServerSocket { 
		

public:
	enum { KONOELOGGERPORT = 10700 };
	enum { KONOETOGUIPORT = 10777 };
	enum { BUFFERSIZE = 256 };

protected:
	KonoeOutputFile	    *  file;
	KonoeOutputObjFile  * ofile;       
	KonoeInputObjSocket * osocket;
	KonoeLoggerCM	    * cm;

	KChar		    * filename;
public :
	KonoeLogger( KChar * filename = "objlogfile" , 
				KInt pport = KONOELOGGERPORT );
	~KonoeLogger( );

	KInt go( );
	KChar * go_text_mode( );

};

#endif
