//===================================================================
/*

	KonoeLoggerCM.cc

	Version 0.2.0	06-Jun-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	03-Aug-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeLoggerCM.hh>
#include	<KonoeCategories.hh>
#include	<system/KonoeTime.hh>
#include	<system/KonoeLogMessage.hh>

KonoeLoggerCM::KonoeLoggerCM( ) :
  KonoeCategoryManager( KonoeCategories::SYSTEMLOGGER, "logger" ) {

}

KonoeStreamableObject	* KonoeLoggerCM::create( KInt classid ) {

  switch( classid ) {
  case CID_TIME :
    return new KonoeTime;
  case CID_LOGMESSAGE :
    return new KonoeLogMessage;
  }
  return 0;

}

const KChar	* KonoeLoggerCM::getClassName( KInt classid ) {

  switch( classid ) {
  case CID_TIME :
    return KonoeTime::className;
  case CID_LOGMESSAGE :
    return KonoeLogMessage::className;
  }

}
