//=================================================================
/*

	KonoeTime.cc

	Version 0.2.0	06-Jun-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	22-Jul-2000	Y. Shimizu
	Version 0.6.1	15-Nov-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//=================================================================

#include	<system/KonoeTime.hh>
#include	<KonoeCategories.hh>
#include	<system/KonoeLoggerCM.hh>
#include	<string.h>
#include	<stdio.h>

const KChar	* KonoeTime::className = "KonoeTime";

KonoeTime::KonoeTime( ) : KonoeTimeData( ),
  KonoeStreamableObject( KonoeCategories::SYSTEMLOGGER,
			 KonoeLoggerCM::CID_TIME ) {

	timeInfo = 0;

}

KonoeTime::~KonoeTime( ){

 	if(timeInfo)
		delete[] timeInfo;

}

KChar * KonoeTime::getTimeInfo( ){

	timeInfo = new KChar[30];
	sprintf(timeInfo,"%02d:%02d.%02d,%02d-%02d-%d"
		,hour,minute,second,month,day,year);
	return (timeInfo);

}

void	KonoeTime::dump( ostream & os ){

	os << "KonoeTime" << endl;
	os << " second = " <<  second ;
	os << " minute = " << minute ;
	os << " hour = " << hour ;
	os << " day = " << day ;
	os << " month = " << month ;
	os << " year = " << year ;
	os << " dayofweek = " << dayofweek ;
	os << endl;
}


KInt	KonoeTime::put( KonoeOutputObjectStream * os,
			KChar level, KInt memberid ) {

	KChar	l = level + 1;
	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_SECOND, second );
	os -> put( l, MID_MINUTE, minute );
	os -> put( l, MID_HOUR, hour );
	os -> put( l, MID_DAY, day );
	os -> put( l, MID_MONTH, month );
	os -> put( l, MID_YEAR, year );
	os -> put( l, MID_DAYOFWEEK, dayofweek );
	return 0;

}

KInt	KonoeTime::getStreamSize( ) {

	return N_MEMBERS * ( HEADER_SIZE + 1 );

}

KInt	KonoeTime::fillPrimitiveMember( KInt memberid, KInt datatype,
					KInt datacount, void * data ) {

	KInt	i;
	switch( datatype ) {
	case KINT_TYPE :
	    i = * ( KInt * ) data;
	    delete [] data;
		switch( memberid ) {
		case MID_SECOND :
		    second = i;
	 	    break;
		case MID_MINUTE :
		    minute = i;
		    break;
		case MID_HOUR :
		    hour = i;
		    break;
		case MID_DAY :
		    day = i;
		    break;
		case MID_MONTH :
		    month = i;
		    break;
		case MID_YEAR :
		    year = i;
		    break;
		case MID_DAYOFWEEK :
		    dayofweek = i;
		    break;
		default :
		    return -1;
		}
		break;
	    default :
		delete [] data;
		return -1;
	}
	return 0;
}
