//===================================================================
/*

	KonoeMessage.hh

	Version 0.1	02-Mar-1998	H. Kamata
        Version 0.2.0   26-Mar-1998     H. Kamata
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka
*/
//===================================================================

#ifndef	__KONOEMESSAGE_HH
#define	__KONOEMESSAGE_HH

#include <KonoePrimitives.hh>
#include <system/KonoeStreamableObject.hh>
#include <system/KonoeMessageCM.hh>
#include <KonoeCategories.hh>
#include <iostream.h>
#include <stdlib.h>

class KonoeMessage : public KonoeStreamableObject {

public :

	static const KChar	* className;

protected:
    // message object format : 
    //     (hostname, processname, message, option)
    KChar *hostname;
    KInt hostnamelength;
    KChar *processname;
    KInt processnamelength;
    KChar *message;
    KInt messagelength;
    KChar *option;
    KInt optionlength;

    enum MEMBER_ID {MID_HOSTNAME, MID_HOSTNAMELENGTH, \
		    MID_PROCESSNAME, MID_PROCESSNAMELENGTH, \
		    MID_MESSAGE, MID_MESSAGELENGTH, \
		    MID_OPTION, MID_OPTIONLENGTH, N_MEMBERS};
  
public:
    KonoeMessage(void);
    ~KonoeMessage(void);
    
    // to be streamable
    KInt put( KonoeOutputObjectStream *outstream,
	      KChar level, KInt memberid );
    KInt getStreamSize(void);
    KInt fillPrimitiveMember( KInt memberid, KInt datatype,
			      KInt datacount, void *data );
    KInt fillObjectMember( KInt, KonoeStreamableObject * ) { return(-1); }

    // set message object
    KInt setMessage( KChar *phost, KChar *pprocess, KChar *pmessage );
    // set message object (add option)
    KInt setMessage( KChar *phost, KChar *pprocess, \
		     KChar *pmessage, KChar *poption );
    
    // dump message object
    void dump( ostream &os );

    // get host name
    KChar *getHostName( void );

    // get process name
    KChar *getProcessName( void );

    // get message
    KChar *getMessage( void );

    // get option
    KChar *getOption( void );
};
#endif
