//==================================================================
/*

	democ.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

	message exchange demo ( client side )

*/
//==================================================================

#include	<iostream.h>
#include	<stdlib.h>
#include	<string.h>
#include	<stdio.h>
#include	<system/KonoeClientSocket.hh>
#include	<system/KonoeObjectSocket.hh>
#include	<system/KonoeMessageCM.hh>
#include	<system/KonoeMessage.hh>
#include	<system/KonoeHostSystem.hh>


class	MessageDemoClient	{
public :
	enum	{	DEFAULT_PORT = 10001	};

protected :
	KonoeClientSocket	* csocket;
	KonoeObjectSocket	* osocket;

	KonoeMessageCM	* message_cm;

	KInt	port;
	KChar	* host;
	KChar	* image;
	KChar	* text;
	KChar	hostname[ 256 ];

public :
	MessageDemoClient( int argc, char ** argv );
	KInt	go( );

};

MessageDemoClient::MessageDemoClient( int argc, char ** argv ) {

	KChar	* p, * phost, * ptext;
	KChar	* default_host = "konoe2";
	KChar	* default_text = "Hello! How are you?";

	phost = default_host;
	port = DEFAULT_PORT;
	ptext = default_text;

	image = * argv;

	for( KInt i = 1; i < argc; i ++ ) {
	    argv ++;
	    p = * argv;
	    if( * p == '-' ) {
		p ++;
		switch( * p ) {
		case 'm':
		    if( i >= argc - 1 ) {
			cerr << "Message missing" << endl;
			break;
		    }
		    argv ++;
		    i ++;
		    ptext = * argv;
		    break;
		case 'p':
		    if( i >= argc - 1 ) {
			cerr << "Port number missing" << endl;
			break;
		    }
		    argv ++;
		    i ++;
		    port = atoi( * argv );
		    break;
		case 's':
		    if( i >= argc -1 ) {
			cerr << "Host name missing" << endl;
			break;
		    }
		    argv ++;
		    i ++;
		    phost = * argv;
		    break;
		default :
		    cerr << "Unknown option = -" << p << endl;
		    break;
		}
	    }
	}

	host = new KChar[ strlen( phost ) + 1 ];
	strcpy( host, phost );
	cout << "Host = " << host << "  Port = " << port << endl;

	csocket = new KonoeClientSocket( phost, port );
	osocket = new KonoeObjectSocket( csocket );

	message_cm = new KonoeMessageCM;
	osocket -> installCM( message_cm );

	KonoeHostSystem::getHostName( hostname, 256 );

	text = new KChar[ strlen( ptext ) + 1 ];
	strcpy( text, ptext );

}

KInt	MessageDemoClient::go( ) {

	KonoeMessage	* message;

	message = new KonoeMessage( );
	message -> setMessage( hostname, image, text );
	message -> dump( cout );
	osocket -> put( message );

	return 0;

}

int	main( int argc, char ** argv ) {

	MessageDemoClient	client( argc, argv );

	return client.go( );

}
