//================================================================
/*

	demos.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

--
	message exchange demo ( server side )

*/
//================================================================

#include	<iostream.h>
#include	<stdlib.h>
#include	<system/KonoeServerSocket.hh>
#include	<system/KonoeObjectSocket.hh>
#include	<system/KonoeMessageCM.hh>
#include	<system/KonoeMessage.hh>

class	MessageDemoServer	{
public :
	enum	{	DEFAULT_PORT = 10001	};

protected :
	KonoeServerSocket	* ssocket;
	KonoeObjectSocket	* osocket;
	KonoeMessageCM		* message_cm;

	KInt	port;
public :
	MessageDemoServer( int argc, char ** argv );
	KInt	go( );

};

MessageDemoServer::MessageDemoServer( int argc, char ** argv ) {

	KChar	* p;

	port = DEFAULT_PORT;
	for( KInt i = 1; i < argc; i ++ ) {
	    argv ++;
	    p = * argv;
	    if( * p == '-' ) {
		p ++;
		switch( * p ) {
		case 'p':
		    if( i >= argc - 1 ) {
			cerr << "Port number missing" << endl;
			break;
		    }
		    argv ++;
		    i ++;
		    port = atoi( * argv );
		    break;
		default :
		    cerr << "Unknown option = -" << p << endl;
		    break;
		}
	    }
	}

	ssocket = new KonoeServerSocket( port );
	osocket = new KonoeObjectSocket( ssocket );

	message_cm = new KonoeMessageCM;

	osocket -> installCM( message_cm );

}

KInt	MessageDemoServer::go( ) {

	KonoeMessage	* message;

	while( 1 ) {
	    message = ( KonoeMessage * ) osocket -> get( );
	    if( message ) {
		message -> dump( cout );
	    }
	}

	return 0;

}

int	main( int argc, char ** argv ) {

	MessageDemoServer	server( argc, argv );

	return server.go( );

}
