//================================================================
/*

	Version 0.0.1	13-Jun-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	18-Jan-2000	H. Sakamoto

*/
//=================================================================

#include	<system/KonoeGetTableMessage.hh>
#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<system/KonoeNameSpaceMaster.hh>
#include	<system/KonoeNameSpaceSlave.hh>
#include	<system/KonoeServerSocket.hh>
#include	<system/KonoeSocketConnection.hh>
#include	<system/KonoeHostSystem.hh>
#include	<KonoeCategories.hh>
#include	<netdb.h>
#include	<string.h>


const KChar	* KonoeGetTableMessage::className = "KonoeGetTableMessage";

KonoeGetTableMessage::KonoeGetTableMessage( ):
	KonoeNameSpaceMessage( KonoeNameSpaceCM::CID_GETTABLEMESSAGE ) {

	KChar buffer[256];
	KonoeHostSystem::getHostName( buffer, 256 );

	struct  hostent *hp;

	hp = KonoeHostSystem::getHostByName( buffer );
	if( hp ){
	    hostname = new KChar[ strlen( hp->h_name ) + 1 ];
	    strcpy( hostname, hp->h_name );
cout<< "KonoeGetTableMessage::get table from " << hostname << endl;
	} else {
	    cerr<<"get hostname error" << endl;
	    hostname = 0;
	}
}

KonoeGetTableMessage::~KonoeGetTableMessage( ){

	delete[] hostname;

}

KInt	KonoeGetTableMessage::exec( KonoeNameSpaceMaster * master ){ 
				   
	KonoeObjectServerSocket * socket;
	KonoeObjectSocket * connection;
	KonoeNameSpaceTable * table;

	socket = master -> getObjectSendSocket( );
	connection = socket -> getConnection( hostname );

	if( connection ){
	    table = master -> getTable( );
	    connection -> put( table ); 
	} else {
cout<<" conn noet " << endl;
	}

	return 0;
}

KInt	KonoeGetTableMessage::exec( KonoeNameSpaceSlave * slave ){ 
cout<<"Need something to do"<<endl;
	return -1;
}

KInt	KonoeGetTableMessage::put( KonoeOutputObjectStream * os,
			KChar level, KInt memberid ) {

	KChar   l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_HOSTNAME, hostname );
	return 0;
}

KInt    KonoeGetTableMessage::getStreamSize( ) {

        KInt    s;

        s = HEADER_SIZE + ( strlen( hostname ) / sizeof( KInt ) ) + 1; 
        return s;

}

KInt    KonoeGetTableMessage::fillPrimitiveMember( KInt memberid,
                        KInt datatype, KInt datacount, void * data ) {

        switch( datatype ) {
        case KCHAR_TYPE :
                switch( memberid ) {
                case MID_HOSTNAME :
			//strcpy( hostname, (KChar*)data );
			if( hostname ){
			    delete [] hostname;
			}
			hostname = (KChar*)data;
                        return 0;
                default :
                        delete [] data;
                        return -1;
                }
	default :
            delete [] data;
            return -1;

        }
}


