//====================================================================
/*

	KonoeNameSpaceCM.cc

	Version 0.1	12-Dec-1997	H. Sakamoto
	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//====================================================================

#include	<system/KonoeNameSpaceCM.hh>
#include	<system/KonoeNameSpaceItem.hh>
#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeSetValueMessage.hh>
#include	<system/KonoeGetTableMessage.hh>
#include	<KonoeCategories.hh>

KonoeNameSpaceCM::KonoeNameSpaceCM( ) :
	KonoeCategoryManager( KonoeCategories::NAMESPACE, "namespace" ) {
}

KonoeStreamableObject	* KonoeNameSpaceCM::create( KInt classid ) {

	switch( classid ) {
	case CID_NAMESPACEITEM :
		return new KonoeNameSpaceItem;
	case CID_NAMESPACEVALUE :
		return new KonoeNameSpaceValue;
	case CID_NAMESPACETABLE :
		return new KonoeNameSpaceTable;
	case CID_SETVALUEMESSAGE :
		return new KonoeSetValueMessage;
	case CID_GETTABLEMESSAGE :
		return new KonoeGetTableMessage;
	}
	return 0;
}

const KChar	* KonoeNameSpaceCM::getClassName( KInt classid ) {

	switch( classid ) {
	case CID_NAMESPACEITEM :
		return KonoeNameSpaceItem::className;
	case CID_NAMESPACEVALUE :
		return KonoeNameSpaceValue::className;
	case CID_NAMESPACETABLE :
		return KonoeNameSpaceTable::className;
	case CID_SETVALUEMESSAGE :
		return KonoeSetValueMessage::className;
	case CID_GETTABLEMESSAGE :
		return KonoeGetTableMessage::className;
	}
	return 0;
}
