//==================================================================
/*

	KonoeNameSpaceItem.hh

	Version 0.1	11-Dec-1997	H. Sakamoto
	Version 0.2.0	25-Apr-1998	H. Sakamtoo
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================

#ifndef	__KONOENAMESPACEITEM_HH
#define	__KONOENAMESPACEITEM_HH

#include	<system/KonoeStreamableObject.hh>
#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeNameSpaceCM.hh>

class	KonoeNameSpaceItem	: public KonoeStreamableObject {

public :
	static const KChar	* className;

protected :
	KChar	* name;
	KInt	namelength;
	KInt	valuecount;
	KonoeNameSpaceValue	** values;

	KInt	fillcount;

	enum	MEMBER_ID	{
		MID_NAME, MID_NAMELENGTH, MID_VALUECOUNT,
		MID_VALUES,
		N_MEMBERS	};

public :
	KonoeNameSpaceItem( );
	~KonoeNameSpaceItem( );
	KInt	setName( const KChar * name );
	KInt	allocate( KInt valuecount = 1 );
	KInt	setValue( KChar * value, KInt index = 0 );
	KInt	setValue( KInt value, KInt index = 0 );

	KChar	* getName( )	{	return name;	}
	KInt	getValueCount( )	{	return valuecount;	}
	KonoeNameSpaceValue	* getValue( KInt i )
				{	return values[ i ];	}

	// to be streamable

	KInt	put(	KonoeOutputObjectStream * outstream,
			KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datacount, void * data );
	KInt	fillObjectMember( KInt memberid, KonoeStreamableObject * );

};

#endif
