//==================================================================
/*

	KonoeNameSpaceManager.hh

	Version 0.0.1	11-Nov-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   17-Aug-2000	Y. Shimizu

*/
//==================================================================

#ifndef	__KONOENAMESPACEMANAGER_HH
#define	__KONOENAMESPACEMANAGER_HH

#include	<system/KonoeNameSpaceTable.hh>

class	KonoeNameSpaceManager	{

protected :
	KonoeNameSpaceTable	* table;

public :
	KonoeNameSpaceManager( 
		KInt tablesize = KonoeNameSpaceTable::DEFAULT_TABLE_SIZE,
		KInt key = KonoeNameSpaceTable::MEMORY_KEY );
	~KonoeNameSpaceManager( );

        KonoeNameSpaceValue * getValue( KChar * entryname , KInt index = 0 );
        KonoeNameSpaceItem      * getItem( KChar * entryname );

        virtual KInt    addValue( KChar * entryname, KChar * value ) = 0;
        virtual KInt    addValue( KChar * entryname, KInt value ) = 0;
        virtual KInt	addValue( KChar * entryname, 
					KonoeNameSpaceValue * value ) = 0;

        virtual KInt    setValue( KChar * entryname, KChar * value, 
						KInt index = 0 ) = 0;
        virtual KInt    setValue( KChar * entryname, KInt value, 
						KInt index = 0 ) = 0;
        virtual KInt    setValue( KChar * entryname, 
			KonoeNameSpaceValue * value, KInt index = 0 ) = 0;

	KonoeNameSpaceTable	* getTable( ){	return table;	}

        KInt    showEntry( ostream & os, KChar * entryname );
        KInt    show( ostream & os );
        void    dump( ostream & os );
        KInt    getValueCount( KChar * entryname );

};

#endif
