//==================================================================
/*

	KonoeNameSpaceMaster.hh

	Version 0.0.1	11-Nov-1998	H. Sakamoto
	Version 0.0.2	10-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================

#ifndef	__KONOENAMESPACEMASTER_HH
#define	__KONOENAMESPACEMASTER_HH

#include	<system/KonoeFDSet.hh>
#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeServerSocket.hh>
#include	<system/KonoeInputObjSocket.hh>
#include	<system/KonoeOutputObjSocket.hh>
#include	<system/KonoeObjectServerSocket.hh>
#include        <system/KonoeNameSpaceMessage.hh>
#include        <system/KonoeNameSpaceDaemon.hh>

class	KonoeNameSpaceMaster : public KonoeNameSpaceDaemon {

public :
	enum	{	NAMESPACESTRINGSERVERPORT  = 9700,
			NAMESPACESTRINGREQUESTPORT = 9701,
			NAMESPACEOBJECTSERVERPORT  = 9702,
			NAMESPACEOBJECTREQUESTPORT = 9703	};
	enum	{	BUFFERSIZE = 512		};

protected :
	KonoeNameSpaceTable	* table;
	KonoeFDSet		* readfds;

	KonoeServerSocket	* stringServerSocket;
	KonoeServerSocket	* stringRequestSocket;
	KonoeObjectServerSocket	* requestReceiveSocket;
	KonoeObjectServerSocket	* objectSendSocket;

        KInt    execMessage( KonoeNameSpaceMessage * message );
	KInt	readStringServerSocket( KonoeSocketConnection * );  
	KInt	readStringRequestSocket( KonoeSocketConnection *);
	KInt	readObjectSendSocket( KonoeObjectSocket * );
	KInt	readRequestReceiveSocket( KonoeObjectSocket * );

public :
	KonoeNameSpaceMaster( );
	KInt	go( );

	KonoeNameSpaceTable	* getTable( ){	return table; }

	KonoeServerSocket	* getStringServerSocket( )
					{ return stringServerSocket; }
	KonoeServerSocket	* getStringRequestSocket( )
					{ return stringRequestSocket; }
	KonoeObjectServerSocket	* getObjectSendSocket( )
					{ return objectSendSocket; }
	KonoeObjectServerSocket	* getRequestReceiveSocket( )
					{ return requestReceiveSocket; }
};

#endif
