//====================================================================
/*

	KonoeNameSpacePacket.hh

	Version 0.1	12-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//====================================================================

#ifndef	__KONOENAMESPACEPACKET_HH
#define	__KONOENAMESPACEPACKET_HH

#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeSocketIO.hh>

class	KonoeNameSpacePacket {

	/* format
                datasize    KInt ( byte )  
                valuetype   KInt ( KInt or KChar or .. )
                index       KInt
                entryname   KChar*
                value       void *
        */

public :
	enum {  MINIMUM_DATA_SIZE =  15 };
		// 3 * sizeof( KInt )
		// +  1 * KChar + '\0'     entryname
		// +  1                    value

	enum {	TYPE_INT = KonoeNameSpaceValue::TYPE_INT,
		TYPE_CHAR = KonoeNameSpaceValue::TYPE_CHAR };

	enum {	READ_SUCCESS = 1,
		READ_ERROR = -1,
		ZEROBYTE_READ = 0 };

protected :

	KInt	datasize;
	KChar	* entryname;
	KInt	valuetype;
	KInt	index;
	void	* value;

	KChar	* buffer;
	//KInt	status;
	void init( const KChar * pentryname, const void * pvalue,
                                KInt pindex, KInt pvalutype );

public :
	KonoeNameSpacePacket( );
	KonoeNameSpacePacket( const KChar * pentryname, const KChar * pvalue,
				KInt pindex );
	KonoeNameSpacePacket( const KChar * pentryname, KInt pvalue,
				KInt pindex );

	KonoeNameSpacePacket( const KChar * pentryname, const void * pvalue,
					KInt pindex, KInt pvalutype );
	~KonoeNameSpacePacket( );

	KChar * getEntryName( ){	return entryname;  }
	KInt	getIndex( ){	return index; }
	void * getValue( ){ return value;	}
	KInt	getValueType( ){  return valuetype;  }

	KInt	read( KonoeSocketIO * socket );
	KInt	write( KonoeSocketIO * socket );

};

#endif
