//==================================================================
/*

	KonoeNameSpaceSlave.cc

	Version 0.0.1	11-Nov-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0    2-Oct-2000     Y. Shimizu
		comment out setValue( ... ) methods

*/
//==================================================================

#include	<system/KonoeNameSpaceSlave.hh>
#include	<system/KonoeNameSpaceMaster.hh>
#include	<system/KonoeNameSpacePacket.hh>
#include	<system/KonoeNameSpaceMessage.hh>
#include	<system/KonoeGetTableMessage.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<KonoeCategories.hh>

#include	<stdio.h>

KonoeNameSpaceSlave::KonoeNameSpaceSlave( KChar * master ) :
					KonoeNameSpaceDaemon( ) {

	KChar	porttext[ 16 ];
	KInt	iport;
	KonoeGetTableMessage * tablemsg = new KonoeGetTableMessage;

	table = new KonoeNameSpaceTable( );
	table -> init( );

	table -> setValue( "NAMESPACE_MASTER_HOST", master );

	iport = KonoeNameSpaceMaster::NAMESPACESTRINGREQUESTPORT;

        iport = KonoeNameSpaceMaster::NAMESPACEOBJECTREQUESTPORT;

	readfds = new KonoeFDSet();

// create socket
	stringsocket = new KonoeClientSocket( master,
		KonoeNameSpaceMaster::NAMESPACESTRINGSERVERPORT );
	readfds -> install( stringsocket );

	inputobjectsocket = new KonoeClientSocket( master,
		KonoeNameSpaceMaster::NAMESPACEOBJECTSERVERPORT );
	inputsocket = new KonoeInputObjSocket( inputobjectsocket );

	KonoeNameSpaceCM * cm = new KonoeNameSpaceCM();
	inputsocket -> installCM( cm ); 

	outputobjectsocket = new KonoeClientSocket( master,
		KonoeNameSpaceMaster::NAMESPACEOBJECTREQUESTPORT );
	outputsocket = new KonoeOutputObjSocket( outputobjectsocket );
	
// download table entry
	KonoeNameSpaceTable * ptable;
	outputsocket -> put( tablemsg );
	ptable =  (KonoeNameSpaceTable * ) inputsocket -> get( );
//cout<< "KonoeNameSpaceSlave::constructor. get table."<< endl;
	if( ptable == 0 ){
	    cerr<< "KonoeNameSpaceSlave::constructor."
	    	<< "download table error" << endl;
    	}
	else {
//cerr<< "KonoeNameSpaceSlave::constructor. constructed. delete";
//	    delete ptable;
//cerr<< "KonoeNameSpaceSlave::constructor. constructed.";
	}

	delete tablemsg;
cerr<< "KonoeNameSpaceSlave::constructor. constructed.";

}

KInt	KonoeNameSpaceSlave::go( ) {

	KInt	st;
	KonoeFDClient	* cl;
	KonoeNameSpaceMessage * message;
	KonoeNameSpacePacket * pa = new KonoeNameSpacePacket;

	while(1){

	    cl = readfds -> wait( 1000 );  
		if( cl ){	// client exitsts.

		    if( cl == stringsocket ){

//cout<< "NameSpaceSlave::go read stringsocket " << endl;
			st = pa -> read( stringsocket );
			if( st == KonoeNameSpacePacket::READ_SUCCESS ){
//cout<< "NameSpaceSlave::go read stringsocket success" << endl;
			    table -> setValue( pa -> getEntryName( ),
			 	  pa -> getValue( ), pa -> getValueType( ),
						pa -> getIndex( ) );
//cout<< "NameSpaceSlave::go table setvalue success" << endl;
        		}
	   		else if( st == KonoeNameSpacePacket::READ_ERROR ){
			    cerr<< "NameSpaceSlave::go. "
				<< "stringsocket receive error " << endl;
			    break;
	   		} else if( st == KonoeNameSpacePacket::ZEROBYTE_READ ){
			    cerr<< "NameSpaceSlave::go stringsocket"
				<<" zero byte read" << endl;
			}

		    }
		    else if( cl == inputobjectsocket ){
			message = ( KonoeNameSpaceMessage * ) 
						inputsocket -> get( );
			if( message ){
			    execMessage( message );
			} else {
			    cerr<<"KonoeNameSpaceSlave. "
					<< "get message error"<< endl;
			}
		    }
		}
	    }
	return 0;

}

KInt KonoeNameSpaceSlave::execMessage( KonoeNameSpaceMessage * message ){

        message -> exec( this );  
	return 0;
}
