//==================================================================
/*

	KonoeNameSpaceSlave.hh

	Version 0.0.1	11-Nov-1998	H. Sakamoto
	Version 0.0.2	03-Aug-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//==================================================================

#ifndef	__KONOENAMESPACESLAVE_HH
#define	__KONOENAMESPACESLAVE_HH

#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeNameSpaceMessage.hh>
#include	<system/KonoeNameSpaceDaemon.hh>
#include	<system/KonoeClientSocket.hh>
#include	<system/KonoeInputObjSocket.hh>
#include	<system/KonoeOutputObjSocket.hh>
#include	<system/KonoeFDSet.hh>

class	KonoeNameSpaceSlave : public KonoeNameSpaceDaemon {

protected :
	KonoeNameSpaceTable	* table;
	KonoeClientSocket	* stringsocket;
	KonoeClientSocket	* inputobjectsocket;
	KonoeInputObjSocket	* inputsocket;

	KonoeClientSocket	* outputobjectsocket;
	KonoeOutputObjSocket	* outputsocket;

	KonoeFDSet		* readfds;

	KInt    execMessage( KonoeNameSpaceMessage * message );

public :
	KonoeNameSpaceSlave( KChar * master );
	KInt	go( );

	KonoeNameSpaceTable * getTable( ){ return table; }

	KonoeClientSocket	* getStringSocket( )
					{ return stringsocket;}
	KonoeClientSocket	* getInputObjectSocket( )
					{ return inputobjectsocket;}
	KonoeInputObjSocket	* getInputSocket( )
					{ return inputsocket; }
	KonoeClientSocket	* getOutputObjectSocket( )
					{ return outputobjectsocket; }
	KonoeOutputObjSocket	* getOutputSocket( )
					{ return outputsocket; }
};

#endif
