//=================================================================
/*

	KonoeNameSpaceValue.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version	0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0    5-Sep-2000     Y. Shimizu

*/
//=================================================================

#include	<string.h>

#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<KonoeCategories.hh>

const KChar	* KonoeNameSpaceValue::className = "KonoeNameSpaceValue";

KonoeNameSpaceValue::KonoeNameSpaceValue( ) :
	KonoeStreamableObject( KonoeCategories::NAMESPACE,
		KonoeNameSpaceCM::CID_NAMESPACEVALUE ) {

	valuelength = 0;
	valuetype = -1;
	value = 0;

}

KonoeNameSpaceValue::KonoeNameSpaceValue( const KChar * val ) :
        KonoeStreamableObject( KonoeCategories::NAMESPACE,
                KonoeNameSpaceCM::CID_NAMESPACEVALUE ) {

	set( val );
}

KonoeNameSpaceValue::KonoeNameSpaceValue( KInt val) :
        KonoeStreamableObject( KonoeCategories::NAMESPACE,
                KonoeNameSpaceCM::CID_NAMESPACEVALUE ) {

	set( val );
}



KonoeNameSpaceValue::~KonoeNameSpaceValue( ) {

	delete [] value;

}

KInt	KonoeNameSpaceValue::set( const KChar * v ) {

	KInt	l;

	if( ( valuelength != 0 ) ) {
//	    delete [] value;
	    value = 0;
	}
	l = strlen( v );
	value = new KChar[ l + 1 ];
	strcpy( (KChar*)value, v );
	valuelength = l;
	valuetype = TYPE_CHAR;
	return l;
}

KInt	KonoeNameSpaceValue::set( KInt v ) {

	if( valuelength != 0 ){
//            delete [] value;
	      value = 0;
	}	
	value = new KInt(v); 
	valuelength = sizeof(KInt);
	valuetype = TYPE_INT;
	return 0;
}


KInt	KonoeNameSpaceValue::put( KonoeOutputObjectStream * os,
			KChar level, KInt memberid ) {

	KChar	l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_VALUELENGTH, valuelength );
	os -> put( l, MID_VALUETYPE, valuetype );
	switch( valuetype ){
	case TYPE_INT :
		os -> put( l, MID_VALUE, *(KInt*)value );
		break;
	case TYPE_CHAR :
		os -> put( l, MID_VALUE, (KChar*)value );
		break;
	}
	return 0;

}

KInt	KonoeNameSpaceValue::getStreamSize( ) {

	KInt	s;

	s = N_MEMBERS * HEADER_SIZE;
	s += 1;
	s += 1;
	s += ( valuelength / sizeof( KInt ) ) + 1;
	return s;

}

KInt	KonoeNameSpaceValue::fillPrimitiveMember( KInt memberid,
			KInt datatype, KInt datacount, void * data ) {

	switch( datatype ) {
	case KINT_TYPE :
		switch( memberid ) {
		case MID_VALUELENGTH :
			valuelength = * ( KInt * ) data;
			delete [] data;
			return 0;
		case MID_VALUETYPE :
			valuetype = * ( KInt * ) data;
			delete [] data;
			return 0;
		case MID_VALUE :
			//(KInt*)value = ( KInt * ) data;
			value = data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
	case KCHAR_TYPE :
		switch( memberid ) {
		case MID_VALUE :
			//(KChar*)value = ( KChar * ) data;
			value = data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
	}
}

