//=================================================================
/*

	KonoeNameSpaceValue.hh

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version	0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno

*/
//=================================================================

#ifndef	__KONOENAMESPACEVALUE_HH
#define	__KONOENAMESPACEVALUE_HH

#include	<system/KonoeStreamableObject.hh>
#include	<iostream.h>

class	KonoeNameSpaceValue	: public KonoeStreamableObject {

public :
	static const KChar *	className;
	// value type
        enum    {  TYPE_INT, TYPE_CHAR  };

protected :
	KInt	valuelength;
	KInt	valuetype;
	void	* value;

	enum	MEMBER_ID	{
		MID_VALUELENGTH,	MID_VALUE,
		MID_VALUETYPE, 		N_MEMBERS	};

public :
	KonoeNameSpaceValue( );
	KonoeNameSpaceValue( const KChar * val );
	KonoeNameSpaceValue( KInt val );
	~KonoeNameSpaceValue( );

	KInt	set( const KChar * val );
	KInt	set( KInt val );
	KInt	getValueType()  {	return valuetype; }
	void	* get( )	{	return value;	}

	operator KChar* ( ){	return (KChar*)value;	}
	operator KInt( ){	return *(KInt*)value;	}

	// to be streamable

	KInt	put(	KonoeOutputObjectStream * outstream,
			KChar level, KInt memberid );
	KInt	getStreamSize( );
	KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
			KInt datacount, void * data );
	KInt	fillObjectMember( KInt, KonoeStreamableObject * ) {
			return -1;	}

};

#endif
