//=================================================================
/*

	KonoeNetworkNameSpaceManager.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version	0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	18-Jan-2000	H. Sakamoto
	Version 0.6.1	10-Nov-2000	H. Sakamoto

*/
//=================================================================

#include	<system/KonoeNetworkNameSpaceManager.hh>
#include	<system/KonoeNameSpaceMaster.hh>
#include	<system/KonoeNameSpacePacket.hh>
#include	<system/KonoeSetValueMessage.hh>
#include	<system/KonoeSignalHandler.hh>
#include	<system/KonoeHostSystem.hh>
#include        <stdlib.h>
#include	<string.h>

extern "C"	int	fork( );

KonoeNetworkNameSpaceManager::KonoeNetworkNameSpaceManager( KChar * master ) :
	KonoeNameSpaceManager( KonoeNameSpaceTable:: DEFAULT_TABLE_SIZE,
				NAMESPACETABLEKEY ){

	KInt    iport, iport_value;
        KChar   * aport;
	KonoeNameSpaceValue * value;

        if( master == 0 ) {
            value = table->getValue("NAMESPACE_MASTER_HOST");
            if( value == 0 ) {
                cerr <<
        "KonoeNetworkNameSpaceManager::constructor. Host not specified" << endl;
                return;
            }
	    masterhost = (KChar*)*value;
        }    
        else{
            masterhost = master;
        }    

        iport = KonoeNameSpaceMaster::NAMESPACESTRINGREQUESTPORT;
        value = getValue("NAMESPACE_MASTER_STRINGPORT");
        if( value ) {
            iport = atol( (KChar*)*value );
        } 

	stringsocket = new KonoeClientSocket( masterhost, iport );

}

KonoeNetworkNameSpaceManager::~KonoeNetworkNameSpaceManager( ) {

	delete stringsocket;
}


KInt KonoeNetworkNameSpaceManager::addValue(  KChar * entryname, KChar * value ){
	return addValue( entryname, new KonoeNameSpaceValue( value ) );
}

KInt KonoeNetworkNameSpaceManager::addValue(  KChar * entryname, KInt value ){

	return addValue( entryname, new KonoeNameSpaceValue( value ) );

}

KInt KonoeNetworkNameSpaceManager::addValue(  KChar * entryname, 
					KonoeNameSpaceValue * value ){
	KInt index, st;
	index = table -> getValueCount( entryname );

	st = setValue( entryname, value, index );
	delete value;

	return st;

}

KInt KonoeNetworkNameSpaceManager::setValue( KChar * entryname, KChar * value,
						KInt index ){
	return sendPacket( entryname, value, index, 
			   (KInt)KonoeNameSpaceValue::TYPE_CHAR );
}

KInt KonoeNetworkNameSpaceManager::setValue( KChar * entryname, KInt value,
                                                KInt index ){
        return sendPacket( entryname, &value, index,
			   (KInt)KonoeNameSpaceValue::TYPE_INT );

}

KInt KonoeNetworkNameSpaceManager::setValue( KChar * entryname, 
			KonoeNameSpaceValue * value, KInt index ){

	cerr << "KonoeNetworkNameSpaceManager::setValue. Not implemented." << endl;
	return -1;

}

KInt KonoeNetworkNameSpaceManager::sendPacket( const KChar * entryname,
		const void * value, KInt index, KInt valuetype ){

	KInt	i,iport;
	KonoeNameSpacePacket * pa;

	pa = new KonoeNameSpacePacket( entryname, value, index, valuetype );
	i = pa -> write( stringsocket );

	delete pa;
	return i;
}

