//=================================================================
/*

	KonoeNetworkNameSpaceManager.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
	Version	0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.1	08-Nov-2000	H. Sakamoto

*/
//=================================================================

#include	<system/KonoeNetworkNameSpaceManagerChild.hh>
#include	<system/KonoeNameSpaceMaster.hh>
#include	<system/KonoeSetValueMessage.hh>
#include	<system/KonoeSignalHandler.hh>
#include        <stdlib.h>

//+ return value must be specified : 08-Nov-2000 H.S.

extern "C"	int	pause( );

//-

KonoeNetworkNameSpaceManagerChild::KonoeNetworkNameSpaceManagerChild 
		(KChar * pentryname, KInt time, KChar * master )
				: KonoeSignalClient( ){

	table = new KonoeNameSpaceTable( );

	entryname = pentryname;

	KInt    iport;
        KChar   * host, * aport;
	KonoeNameSpaceValue * value;

        if( master == 0 ) {
            value = table -> getValue("NAMESPACE_MASTER_HOST");
            if( value == 0 ) {
                cerr <<
        "KonoeNetworkNameSpaceManagerChild::constructor. Host not specified"
		 << endl;
                return;
            }
	    host = (KChar*)*value;
        }    
        else{
            host = master;
        }    

        iport = KonoeNameSpaceMaster::NAMESPACESTRINGREQUESTPORT;
        value = table -> getValue("NAMESPACE_MASTER_STRINGPORT");
        if( value ) {
            iport = atol( (KChar*)*value );
        } 

	stringsocket = new KonoeClientSocket( host, iport );

	iport = KonoeNameSpaceMaster::NAMESPACEOBJECTREQUESTPORT;
        value = table -> getValue("NAMESPACE_MASTER_OBJECTPORT");
	if( value ){
            iport = atol( (KChar*)*value );
        }

	objectsocket = new KonoeClientSocket( host, iport );
	socket = new KonoeOutputObjSocket( objectsocket );

	handler = new KonoeSignalHandler( SIGALRM, this );

        timer = new KonoeIntervalTimer( );
	timer -> setInterval( time );

}

KonoeNetworkNameSpaceManagerChild::~KonoeNetworkNameSpaceManagerChild( ) {

	delete socket;
	delete stringsocket;
	delete objectsocket;
}

KInt	KonoeNetworkNameSpaceManagerChild::go( ){

	handler -> enable( );

	while( 1 ){
	    pause( );
	}

	return 0;
}


void	KonoeNetworkNameSpaceManagerChild::catchSignal( KInt signal ){

	KInt i, j, n, m;
	KonoeNameSpaceValue * v;
	KonoeNameSpaceItem * item;
        KonoeSetValueMessage * message;

	item = table -> getItem( entryname );

	if( item == 0 ){ 
			return ;
	}

	m = item -> getValueCount( ); 

	for( j = 0 ; j < m ; j++ ){ 
            message = new KonoeSetValueMessage( );
            message -> setEntryname( item -> getName( ) );
            message -> setIndex( j );
	    v = item -> getValue( j );
            message -> setValue( v );
            socket -> put( message );
	    delete message;
        }

}

KInt	KonoeNetworkNameSpaceManagerChild::setInterval( KInt sec ){

	timer -> setInterval( sec );
	return 0;
}
