//================================================================
/*

	KonoeSetValueMessage.cc

	Version 0.0.1	13-Jun-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	18-Jan-2000	H. Sakamoto

*/
//=================================================================

#include	<system/KonoeSetValueMessage.hh>
#include	<system/KonoeNameSpaceValue.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<system/KonoeNameSpaceMaster.hh>
#include	<system/KonoeNameSpaceSlave.hh>
#include	<KonoeCategories.hh>
#include	<string.h>

const KChar	* KonoeSetValueMessage::className = "KonoeSetValueMessage";

KonoeSetValueMessage::KonoeSetValueMessage( ) : 
	KonoeNameSpaceMessage( KonoeNameSpaceCM::CID_SETVALUEMESSAGE ) {

	index = 0;
	entryname = 0;
	value = 0;

}

KonoeSetValueMessage::~KonoeSetValueMessage( ){

}

KInt	KonoeSetValueMessage::exec( KonoeNameSpaceMaster * master ){ 
				   
	KonoeNameSpaceTable * table;
	table = master -> getTable( );
	table -> setValue( entryname, value, index );

	//KonoeOutputObjSocket * socket;
	KonoeObjectServerSocket * socket;
	socket = master -> getObjectSendSocket( );

	if( socket ){
	    socket -> put( this );
	}

	return 0;
}

KInt	KonoeSetValueMessage::exec( KonoeNameSpaceSlave * slave ){ 

	KonoeNameSpaceTable * table;
	table = slave -> getTable( );
	table -> setValue( entryname, value, index );

	return 0;
}

KInt	KonoeSetValueMessage::put( KonoeOutputObjectStream * os,
			KChar level, KInt memberid ) {

	KChar	l = level + 1;

	os -> putHeader( this, level, memberid, N_MEMBERS );
	os -> put( l, MID_INDEX, index );
	os -> put( l, MID_ENTRYNAME, entryname );
	os -> put( value, l, MID_VALUE);
	return 0;
}

KInt	KonoeSetValueMessage::getStreamSize( ) {

	KInt	s;

	s =  HEADER_SIZE + 1;
	s += HEADER_SIZE + ( strlen( entryname ) / sizeof( KInt ) ) + 1; 
	s += HEADER_SIZE + value -> getStreamSize( );
	return s;

}

KInt	KonoeSetValueMessage::fillPrimitiveMember( KInt memberid,
			KInt datatype, KInt datacount, void * data ) {

	switch( datatype ) {
	case KINT_TYPE :
		switch( memberid ) {
		case MID_INDEX :
			index = * ( KInt * ) data;
			delete [] data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
	case KCHAR_TYPE :
		switch( memberid ) {
		case MID_ENTRYNAME :
			entryname = ( KChar * ) data;
			return 0;
		default :
			delete [] data;
			return -1;
		}
	}
}

KInt	KonoeSetValueMessage::fillObjectMember( KInt memberid,
				KonoeStreamableObject * data ){

	if( memberid != MID_VALUE ) {
                delete data;
                return -1;
        }
        value = ( KonoeNameSpaceValue * ) data;
        return 0;
}

