//=================================================================
/*

	knsload.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno

--
	load name space from file

*/
//=================================================================

#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeInputObjFile.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<system/KonoeHostSystem.hh>

class	KonoeLoadNameSpace	{

protected :
	KonoeNameSpaceTable	* table;
	KonoeNameSpaceCM	* cm;
	KChar	* filename;
	KonoeInputObjFile	* file;

public :
	KonoeLoadNameSpace( KInt argc, KChar ** argv );
	~KonoeLoadNameSpace( );
	KInt	go( );

};

KonoeLoadNameSpace::KonoeLoadNameSpace( KInt argc, KChar ** argv ) {

	if( argc < 2 ) {
	    cout << "knsload : load KONOE name space" << endl << endl;
	    cout << "	Usage % knsload <filename>" << endl << endl;
	    KonoeHostSystem::exit( 0 );
	}
	argv ++;
	filename = * argv;
	file = new KonoeInputObjFile( filename );
	cm = new KonoeNameSpaceCM;
	file -> installCM( cm );
//	table = new KonoeNameSpaceTable;

}

KonoeLoadNameSpace::~KonoeLoadNameSpace( ) {

	delete file;
	delete cm;
	delete table;
}

KInt	KonoeLoadNameSpace::go( ) {

table = (KonoeNameSpaceTable * ) file -> get( );
/*
	KInt	offset;
	KonoeNameSpaceItem	* item;

	while( item = ( KonoeNameSpaceItem * ) file -> get( ) ) {
	    if( table -> setEntry( item ) == -1 ) {
		cout << "Error" << endl;
		break;
	    }
	}
*/
	return 0;

}

int	main( int argc, char ** argv ) {

	KonoeLoadNameSpace	knsload( argc, argv );
	return knsload.go( );
}
