//=================================================================
/*

	knssave.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno

--
	save name space into file

*/
//=================================================================

#include	<system/KonoeNameSpaceTable.hh>
#include	<system/KonoeOutputObjFile.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<system/KonoeHostSystem.hh>

class	KonoeSaveNameSpace	{

protected :
	KonoeNameSpaceTable	* table;
	KonoeNameSpaceCM	* cm;
	KChar	* filename;
	KonoeOutputObjFile	* file;

public :
	KonoeSaveNameSpace( KInt argc, KChar ** argv );
	~KonoeSaveNameSpace( );
	KInt	go( );

};

KonoeSaveNameSpace::KonoeSaveNameSpace( KInt argc, KChar ** argv ) {

	if( argc < 2 ) {
	    cout << "knssave : save KONOE name space" << endl << endl;
	    cout << "	Usage % knssave <filename>" << endl << endl;
	    KonoeHostSystem::exit( 0 );
	}
	argv ++;
	filename = * argv;
	file = new KonoeOutputObjFile( filename );
	cm = new KonoeNameSpaceCM;
	file -> installCM( cm );
//	table = new KonoeNameSpaceTable();
	table = new KonoeNameSpaceTable(1000,10001);
	table -> init();
	table -> setValue("testname", "testvalue");
}

KonoeSaveNameSpace::~KonoeSaveNameSpace( ) {

	delete file;
	delete cm;
	delete table;
}

KInt	KonoeSaveNameSpace::go( ) {

file -> put(table);
return 0;

/*
	KInt	offset;
	KonoeNameSpaceItem	* item;

	offset = table -> getFirstEntry( );
	while( offset > 0 ) {
	    item = table -> getItem( offset );
	    if( item == 0 )
		break;
	    file -> put( item );
	    offset = table -> getNextEntry( offset );
	}
	return 0;
*/

}

int	main( int argc, char ** argv ) {

	KonoeSaveNameSpace	knssave( argc, argv );
	return knssave.go( );
}
