//===================================================================
/*

	KonoeInputObjFileBuffered.cc

	Version 0.1	22-Oct-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	09-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	02-Dec-2000	H. Sakamoto

*/
//===================================================================

#include	<system/KonoeInputObjFileBuffered.hh>
#include	<string.h>

KonoeInputObjFileBuffered::KonoeInputObjFileBuffered( )
		: KonoeInputObjectStream( ),
		KonoeObjectFileBase( ) {

	initialize( );

}

KonoeInputObjFileBuffered::KonoeInputObjFileBuffered( KChar * pfilename )
		: KonoeInputObjectStream( ),
		KonoeObjectFileBase( ) {

	inputfile = new KonoeInputFile( pfilename );

	initialize( );

}

void	KonoeInputObjFileBuffered::initialize( ) {

	read_buffer_size = READ_BUFFER_SIZE;
	read_buffer_pointer = read_buffer_size;
	read_buffer_bytecount = read_buffer_size;

}

KonoeInputObjFileBuffered::~KonoeInputObjFileBuffered( ) {
}


KInt	KonoeInputObjFileBuffered::readFromStream( KChar * pbuffer, KInt buffersize ) {

	KInt	i, j, st;

	i = read_buffer_bytecount - read_buffer_pointer;
	if( i >= buffersize ) {
	    memcpy( pbuffer,
		& read_buffer[ read_buffer_pointer ], buffersize );
	    read_buffer_pointer += buffersize;
	    return buffersize;
	}
	else {
	    if( i > 0 ) {
		memcpy( pbuffer,
			& read_buffer[ read_buffer_pointer ], i );
	    }
	    st = inputfile -> readFromStream( read_buffer, read_buffer_size );
	    if( st <= 0 ) {
		return st;	// read error or end of file
	    }
	    read_buffer_bytecount = st;	// may be less than buffer_size.
	    j = buffersize - i;
	    if( j > st ) {
		memcpy( pbuffer + i, read_buffer, st );
		read_buffer_pointer = st;
		return i + st;
	    }
	    else {
		memcpy( pbuffer + i, read_buffer, j );
		read_buffer_pointer = j;
		return buffersize;
	    }
	}
}
