//=====================================================================
/*

	KonoeOutputObjFileBuffered.cc

	Version 0.1	16-Oct-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	02-Dec-2000	H. Sakamoto

*/
//=====================================================================

#include	<system/KonoeOutputObjFileBuffered.hh>
#include	<string.h>

KonoeOutputObjFileBuffered::KonoeOutputObjFileBuffered( ) :
	KonoeObjectFileBase( ),
	KonoeOutputObjectStream( ) {

	outputfile = 0;
	initialize( );

}

KonoeOutputObjFileBuffered::KonoeOutputObjFileBuffered( KChar * pfilename ) :
	KonoeObjectFileBase( ),
	KonoeOutputObjectStream( ) {

	outputfile = new KonoeOutputFile( pfilename );
	initialize( );

}

void	KonoeOutputObjFileBuffered::initialize( ) {

	write_buffer_size = WRITE_BUFFER_SIZE;
	write_buffer_pointer = 0;

}

KonoeOutputObjFileBuffered::~KonoeOutputObjFileBuffered( ) {

	if( write_buffer_pointer > 0 )
	    outputfile -> writeToStream( write_buffer, write_buffer_pointer );
	delete outputfile;

}

KInt	KonoeOutputObjFileBuffered::writeToStream( const KChar * pbuffer, KInt nbytes ) {

	if( ! outputfile ) return -1;	// not opened

	KInt	i, j, st;

	i = write_buffer_size - write_buffer_pointer;
	if( i >= nbytes ) {
	    memcpy( & write_buffer[ write_buffer_pointer ], pbuffer, nbytes );
	    write_buffer_pointer += nbytes;
	    return nbytes;
	}
	else {
	    if( i > 0 ) {
		memcpy( & write_buffer[ write_buffer_pointer ], pbuffer, i );
	    }
	    st = outputfile -> writeToStream( write_buffer, write_buffer_size );
	    if( st < 0 )
		return st;
	    j = nbytes - i;
	    if( j > 0 ) {	// j may be more than buffer_size.
		while( j >= write_buffer_size ) {
		    memcpy( write_buffer, pbuffer + i, write_buffer_size );
		    st = outputfile -> writeToStream( write_buffer,
				write_buffer_size );
		    if( st < 0 )
			return st;
		    j -= write_buffer_size;
		    i += write_buffer_size;
		}
		if( j > 0 )
		    memcpy( write_buffer, pbuffer + i, j );
	    }
	    write_buffer_pointer = j;
	    return nbytes;
	}

}
