//==================================================================
/*

	kofa.cc

	Version 0.2.0	25-Apr-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno

--

	Konoe Object File Analyzer program

*/
//===================================================================

#include	<system/KonoeInputObjFile.hh>
#include	<system/KonoeHostSystem.hh>


class	KonoeObjectFileAnalyzer	{

protected :
	KChar	* filename;
	KonoeInputObjFile	* file;

public :
	KonoeObjectFileAnalyzer( KInt argc, KChar ** argv );
	KInt	go( );

};

KonoeObjectFileAnalyzer::KonoeObjectFileAnalyzer( KInt argc, KChar ** argv ) {

	if( argc < 2 ) {
	    cout << "kofa : Konoe Object File Analyzer." << endl << endl;
	    cout << "	Usage : % kofa <objectfilename>" << endl;
	    KonoeHostSystem::exit( 0 );
	}
	argv ++;
	filename = * argv;
	file = new KonoeInputObjFile( filename );

}

KInt	KonoeObjectFileAnalyzer::go( ) {

	while( file -> analyze( cout ) == 0 );
	return 0;

}

int	main( int argc, char ** argv ) {

	KonoeObjectFileAnalyzer	kofa( argc, argv );

	return kofa.go( );

}
