//====================================================================
/*

	KonoeInputObjSocketBuffered.cc

	Version 0.1	25-Oct-1997	H. Sakamoto
	Version 0.2	24-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	03-Dec-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka


*/
//====================================================================

#include	<system/KonoeInputObjSocketBuffered.hh>
#include	<system/KonoeClientSocket.hh>
#include	<system/KonoeServerSocket.hh>
#include	<string.h>

KonoeInputObjSocketBuffered::KonoeInputObjSocketBuffered( KChar * host, KInt port )
		: KonoeObjectSocketBase( ),
		KonoeInputObjectStream( ) {

	socket = new KonoeClientSocket( host, port );
	initialize( );

}

KonoeInputObjSocketBuffered::KonoeInputObjSocketBuffered( KInt port )
		: KonoeObjectSocketBase( ),
		KonoeInputObjectStream( ) {

	socket = new KonoeServerSocket( port );
	initialize( );

}

KonoeInputObjSocketBuffered::KonoeInputObjSocketBuffered( KonoeSocketIO * s )
		: KonoeObjectSocketBase( ),
		KonoeInputObjectStream( ) {

	socket = s;
	initialize( );

}

void	KonoeInputObjSocketBuffered::initialize( ) {

	receive_buffer_size = RECEIVE_BUFFER_SIZE;
	receive_buffer_pointer = receive_buffer_size;
	receive_buffer_bytecount = receive_buffer_size;

}

KonoeInputObjSocketBuffered::~KonoeInputObjSocketBuffered( ) {

	delete socket;

}

KInt	KonoeInputObjSocketBuffered::readFromStream( KChar * buffer, KInt buffersize ) {

	KInt	i, j, st;

	i = receive_buffer_bytecount - receive_buffer_pointer;
	if( i >= buffersize ) {
	    memcpy( buffer, & receive_buffer[ receive_buffer_pointer ], buffersize );
	    receive_buffer_pointer += buffersize;
	    return buffersize;
	}
	else {
	    if( i > 0 ) {
		memcpy( buffer, & receive_buffer[ receive_buffer_pointer ], i );
	    }
	    st = socket -> receive( receive_buffer, receive_buffer_size );
	    if( st < 0 )
		return st;
	    receive_buffer_bytecount = st;
	    j = buffersize - i;
	    if( j > st ) {
		memcpy( buffer + i, receive_buffer, st );
		receive_buffer_pointer = st;
		return i + st;
	    }
	    else {
		memcpy( buffer + i, receive_buffer, j );
		receive_buffer_pointer = j;
		return buffersize;
	    }
	}

}
