//===================================================================
/*

	KonoeObjectServerSocketBuffered.hh

	Version 0.0.1	10-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   14-Sep-2000     Y. Shimizu 
	Version 0.6.1	02-Dec-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#ifndef	__KONOEOBJECTSERVERSOCKETBUFFERED_HH
#define	__KONOEOBJECTSERVERSOCKETBUFFERED_HH

#include	<system/KonoeObjectSocketBuffered.hh>
#include        <system/KonoeServerSocket.hh>
#include	<system/KonoeFDClient.hh>
#include	<system/KonoeFDSet.hh>
#include	<sys/types.h>
#include	<errno.h>

class	KonoeObjectServerSocketBuffered : public KonoeObjectStreamBase,
					public KonoeFDClient {

public :
	enum	{	MAX_CLIENTS = 32	};
	enum	{	WAIT_INTERVAL = 1000	};
	enum	{	SEND_TO_LAST,	SEND_TO_OTHERS,	SEND_TO_ALL	};
	enum	{	E_TABLEFULL = -1,
			E_SOCKETNOTMATCH = -2,
			E_DISCONNECTED = -3,
			E_CONNECTED = -4	};

protected :
	KonoeServerSocket	* socket;
	KInt	port;	// port number to which clients call on
	KInt	errornumber;	// error number set by last I/O.
	KInt	send_mode;
	KonoeFDSet	* readfds;

	KonoeObjectSocketBuffered	* clients[ MAX_CLIENTS ];
	KonoeObjectSocketBuffered	* last_received;

	KInt	send_to_client( KonoeObjectSocketBuffered * , KChar *, KInt );
	KInt	put_to_client( KonoeObjectSocketBuffered * , KonoeStreamableObject * );

public :
	KonoeObjectServerSocketBuffered( KInt pport, KonoeFDSet * fds = 0 );
	~KonoeObjectServerSocketBuffered( );

	KInt	waitConnection( );	// for SC implementation
	KonoeObjectSocketBuffered	* wait( KInt milisec );

	KInt	closeConnection( );
	KInt	close( KonoeObjectSocketBuffered * s );

	KInt	send( KChar * buffer, KInt nbytes );
	KInt    put( KonoeStreamableObject * pobject );

	KInt	receive( KChar * buffer, KInt buffersize );
	KonoeStreamableObject	* get( );

	KonoeObjectSocketBuffered	* getConnection( const KChar * hostname );
	KonoeObjectSocketBuffered	* getLastReceived( ) {
			return last_received;	}
	void	setSendMode( KInt pmode )
			{	send_mode = pmode;	}
	KInt	getSendMode( )	{	return send_mode;	}
	KInt	getError( )	{	return errornumber;	}
	KInt	getFD( )	{	return socket -> getFD( ); }
	KonoeObjectSocketBuffered	** getClients( )
				{	return clients;		} 

	KonoeObjectSocketBuffered	* processReceiveAction(
					KonoeFDClient * client );
	KInt	receiveFromConnection( KonoeObjectSocketBuffered * ch,
	              KChar * buffer, KInt buffersize );
	KonoeStreamableObject * getFromConnection( KonoeObjectSocketBuffered * ch );
        KonoeServerSocket	* getSocket( ){ return  socket; }
};

#endif
