//==================================================================
/*

	KonoeObjectSocket.cc

	Version 0.2.0	24-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//==================================================================

#include	<system/KonoeObjectSocket.hh>
#include	<system/KonoeClientSocket.hh>
#include	<system/KonoeServerSocket.hh>

KonoeObjectSocket::KonoeObjectSocket( KChar * host, KInt port ) :
	KonoeObjectSocketBase( ), KonoeInputObjectStream( ),
	KonoeOutputObjectStream( ) {

	socket = new KonoeClientSocket( host, port );

}

KonoeObjectSocket::KonoeObjectSocket( KInt port ) :
	KonoeObjectSocketBase( ), KonoeInputObjectStream( ),
	KonoeOutputObjectStream( ) {

	socket = new KonoeServerSocket( port );

}

KonoeObjectSocket::KonoeObjectSocket( KonoeSocketIO * s ) :
	KonoeObjectSocketBase( ), KonoeInputObjectStream( ),
	KonoeOutputObjectStream( ) {

	socket = s;

}

KonoeObjectSocket::~KonoeObjectSocket( ) {

	delete socket;

}

KInt	KonoeObjectSocket::writeToStream( const KChar * buffer, KInt nbytes ) {

	return socket -> send( buffer, nbytes );

}

KInt	KonoeObjectSocket::readFromStream( KChar * buffer, KInt buffersize ) {

	return socket -> receive( buffer, buffersize );

}


