//==================================================================
/*

	KonoeObjectSocketBuffered.hh

	Version 0.2.0	24-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	02-Dec-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//==================================================================

#ifndef	__KONOEOBJECTSOCKETBUFFERED_HH
#define	__KONOEOBJECTSOCKETBUFFERED_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeObjectSocketBase.hh>
#include	<system/KonoeInputObjectStream.hh>
#include	<system/KonoeOutputObjectStream.hh>
#include	<system/KonoeSocketIO.hh>

class	KonoeObjectSocketBuffered	: public KonoeObjectSocketBase,
			virtual public KonoeInputObjectStream,
			virtual public KonoeOutputObjectStream {
public :
	enum	{	SEND_BUFFER_SIZE = 1448,
			RECEIVE_BUFFER_SIZE = 1448	};

protected :
	KChar	send_buffer[ SEND_BUFFER_SIZE ];
	KChar	receive_buffer[ RECEIVE_BUFFER_SIZE ];
	KInt	send_buffer_size;
	KInt	send_buffer_pointer;
	KInt	receive_buffer_size;
	KInt	receive_buffer_pointer;
	KInt	receive_buffer_bytecount;

public :
	KonoeObjectSocketBuffered( KChar * host, KInt port );
	KonoeObjectSocketBuffered( KInt port );
	KonoeObjectSocketBuffered( KonoeSocketIO * s );
	~KonoeObjectSocketBuffered( );

	KInt	readFromStream( KChar * buffer, KInt buffersize );
	KInt	writeToStream( const KChar * buffer, KInt nbytes );
	KInt	flush( );

protected :
	void	initialize( );

};

#endif
