//===================================================================
/*

	KonoeOutputObjSocketBuffered.cc

	Version 0.1	25-Oct-1997	H. Sakamoto
	Version 0.1.1	09-Mar-1998	H. Sakamoto
	Version 0.2.0	24-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	02-Dec-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeOutputObjSocketBuffered.hh>
#include	<system/KonoeClientSocket.hh>
#include	<system/KonoeServerSocket.hh>

#include	<string.h>
#include	<iostream.h>

KonoeOutputObjSocketBuffered::KonoeOutputObjSocketBuffered( KChar * host, KInt port )
		: KonoeObjectSocketBase( ),
		KonoeOutputObjectStream( ) {

	socket = new KonoeClientSocket( host, port );
	send_buffer_size = SEND_BUFFER_SIZE;
	send_buffer_pointer = 0;

}

KonoeOutputObjSocketBuffered::KonoeOutputObjSocketBuffered( KInt port )
		: KonoeObjectSocketBase( ),
		KonoeOutputObjectStream( ) {

	socket = new KonoeServerSocket( port );
	send_buffer_size = SEND_BUFFER_SIZE;
	send_buffer_pointer = 0;


}

KonoeOutputObjSocketBuffered::KonoeOutputObjSocketBuffered( KonoeSocketIO * s )
		: KonoeObjectSocketBase( ),
		KonoeOutputObjectStream( ) {

	socket = s;
	send_buffer_size = SEND_BUFFER_SIZE;
	send_buffer_pointer = 0;


}

KonoeOutputObjSocketBuffered::~KonoeOutputObjSocketBuffered( ) {

	if( send_buffer_pointer > 0 ) {
	    socket -> send( send_buffer, send_buffer_pointer );
	}
	delete socket;

}

KInt	KonoeOutputObjSocketBuffered::writeToStream( const KChar * buffer, KInt nbytes ) {

	KInt	i, j, st;

	if( nbytes < send_buffer_size - send_buffer_pointer ) {
	    memcpy( & send_buffer[ send_buffer_pointer ], buffer, nbytes );
	    send_buffer_pointer += nbytes;
	    return nbytes;
	}
	else {
	    i = send_buffer_size - send_buffer_pointer;
	    if( i > 0 )
		memcpy( & send_buffer[ send_buffer_pointer ], buffer, i );
	    st = socket -> send( send_buffer, send_buffer_size );
	    if( st < 0 )
		return st;
	    j = nbytes - i;
	    if( j > 0 ) {
		while( j >= send_buffer_size ) {
		    memcpy( send_buffer, buffer + i, send_buffer_size );
		    st = socket -> send( send_buffer, send_buffer_size );
		    if( st < 0 )
			return st;
		    i += send_buffer_size;
		    j -= send_buffer_size;
		}
		memcpy( send_buffer, buffer + i, j );
	    }
	    send_buffer_pointer = j;
	    return nbytes;
	}

}

KInt	KonoeOutputObjSocketBuffered::flush( ) {

	KInt	st;

	if( send_buffer_pointer == 0 )
	    return 0;
	st = socket -> send( send_buffer, send_buffer_pointer );
	if( st < 0 )
	    return st;
	send_buffer_pointer = 0;
	return st;

}

