//==================================================================
/*

	KonoeObjectStreamBase.hh

	Version 0.1	16-Oct-1997	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	18-Jan-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka
*/
//==================================================================

#ifndef	__KONOEOBJECTSTREAMBASE_HH
#define	__KONOEOBJECTSTREAMBASE_HH

#include	<KonoePrimitives.hh>
#include	<KonoeList.hh>
#include	<system/KonoeCategoryManager.hh>

/*

	KONOE object stream format ( Version 0.1 )

	1st word	level_id | category_id | class_id | class_version
	2nd word	member_id | data_count/storage type
	3rd word	record size in 4byte words
	4th word	1st word of data

*/
class	KonoeObjectStreamBase {

public :
	enum	{	MAX_CATEGORY = 256	};

protected :
	KonoeList<KonoeCategoryManager>	* cm_list;

public :
	enum	{	RELATION_MASK = (KInt)0xff000000,
			CATEGORY_MASK = 0x00ff0000,
			CLASS_MASK    = 0x0000ff00,
			VERSION_MASK  = 0x000000ff	};

	enum	{	TOP_LEVEL = 0x41		};

	enum	{	MEMBER_ID_MASK	= (KInt)0xff000000,
			DATA_COUNT_MASK	= 0x00ffffff	};

	enum	{	VOID_CLASS	= 0x00000000,
			KINT_CLASS	= 0x00000100,
			KSHORT_CLASS	= 0x00000200,
			KLONG_CLASS	= 0x00000300,
			KCHAR_CLASS	= 0x00000400,
			KFLOAT_CLASS	= 0x00000500,
			KHALF_CLASS	= 0x00000600,
			KDOUBLE_CLASS	= 0x00000700	};

	KonoeObjectStreamBase( );
	virtual KInt installCM( KonoeCategoryManager * pcategorymanager );
	KonoeCategoryManager * getCM( KInt pheaderword );
	KBool	isPrimitive( KInt pheaderword ){ return 0;} // not yet dene

};

#endif
