//===================================================================
/*

	KonoeOutputObjectStream.hh

	Version 0.1	15-Oct-1997	H. Sakamoto
	Version 0.2	03-Dec-1997	H. Sakamoto
	Version 0.3	11-Dec-1997	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
	Version 0.4.1	09-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#ifndef	__KONOEOUTPUTOBJECTSTREAM_HH
#define	__KONOEOUTPUTOBJECTSTREAM_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeObjectStreamBase.hh>
#include	<system/KonoeOutputStream.hh>

class	KonoeStreamableObject;

class	KonoeOutputObjectStream : public virtual KonoeObjectStreamBase,
				  public virtual KonoeOutputStream {

public :
	enum	{	CURRENT_VERSION = 1	};

protected :
	static const KInt	version;
public :
	KonoeOutputObjectStream( );
	virtual KInt	put( KonoeStreamableObject * pobject,
		KChar level = KChar ( TOP_LEVEL ), KInt pmemberid = 0 );

	KInt	putHeader( KonoeStreamableObject * pobject,
			 KChar plevel, KInt pmemberid, KInt pdatacount );
	KInt	put( KChar level, KInt memberid, KInt ivalue );
	KInt	put( KChar level, KInt memberid,
			KInt * ibuffer, KInt datacount );
	KInt	put( KChar level, KInt memberid, KFloat value );
	KInt	put( KChar level, KInt memberid,
			KFloat * buffer, KInt datacount );
	KInt	put( KChar level, KInt memberid, KChar * string );
	KInt	put( KChar level, KInt memberid, void * buffer, KInt datacount);

	KInt	putIntegerHeader(
			KChar level, KInt memberid, KInt datacount );
	KInt	putFloatHeader(
			KChar level, KInt memberid, KInt datacount );
	KInt	putStringHeader(
			KChar level, KInt memberid, KInt datacount );
	KInt	putVoidHeader(
			KChar level, KInt memberid, KInt datacount );
	KInt	putObjectArrayHeader(
			KChar level, KInt memberid,
			KInt datacount, KInt datasize );
};

#endif
