//====================================================================
/*

	KonoeStreamableObject.hh

	Version 0.1	15-Oct-1997	H. Sakamoto
	Version 0.2	12-Dec-1997	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	20-Nov-2000                     K. Uchida
	Version 0.7.0	28-Aug-2001	S. Morinaka
	add virtual destructor
*/
//====================================================================
#ifndef __KONOESTREAMABLEOBJECT_HH
#define __KONOESTREAMABLEOBJECT_HH

#include        <KonoePrimitives.hh>
#include        <system/KonoeOutputObjectStream.hh>

class	KonoeStreamableObject {

public :
	enum	{	KINT_TYPE,	KFLOAT_TYPE,
			KCHAR_TYPE,	OBJECT_TYPE,
			VOID_TYPE	};
protected :
	enum	{	HEADER_SIZE = 3		};

protected :
	const KInt	category_id;
	const KInt	class_id;
	const KInt	class_version;
	KInt	stream_header;
public :
	KonoeStreamableObject(
		KInt categoryid, KInt classid, KInt classversion = 0 );
        virtual ~KonoeStreamableObject(){;}
	KInt	getCategoryID( ) { return category_id; }
	KInt	getClassID( )	{ return class_id;	}
	KInt	getClassVersion( )	{	return class_version;	}
	KInt	getStreamHeader( KChar level );

	virtual KInt	put(
		KonoeOutputObjectStream * outstream,
		KChar level,	KInt memberid ) = 0;
	virtual KInt	getStreamSize( ) = 0;

	virtual KInt	fillPrimitiveMember( KInt memberid, KInt datatype,
				KInt datasize, void * data ) = 0;
	virtual KInt	fillObjectMember( KInt memberid,
				KonoeStreamableObject * object ) = 0;

};

#endif
