//==========================================================================
/*

 	 KonoeSignalDaemon.cc
	
	Version	0.6 	09-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===========================================================================

#include<system/KonoeSignalDaemon.hh>
#include<system/KonoeSignalSender.hh>
#include<sys/types.h>
#include<signal.h>
#include<stdlib.h>
#include<string.h>
#include<stdio.h>
#include<iostream.h>


KonoeSignalDaemon::KonoeSignalDaemon( )
  :KonoeUDPServerSocket( KonoeSignalSender::KONOESIGNALPORT ){

  port   = KonoeSignalSender::KONOESIGNALPORT; 
  signal = 0;
  pid    = 0;
  
}

KonoeSignalDaemon::KonoeSignalDaemon( KInt pport )
  :KonoeUDPServerSocket( pport ){

  port   = pport ; 
  signal = 0;
  pid    = 0;
  
}

KonoeSignalDaemon::~KonoeSignalDaemon( ){

}

KInt KonoeSignalDaemon::go( ){

  while( 1 ){
    KInt st = 0;

    receive( buffer, BUFFERSIZE );
  
    if(  stringAnalyze( buffer )  == 0 ){

      if( kill( pid, signal ) != 0 ){

      cerr << " kill failed " << pid << " " << signal << endl;
      st = -1;
      }
    }
    else {
      st = -1;
    }
  
    if( st == 0 )
      reply((void*)"I got it",BUFFERSIZE);
    else
      reply((void*)" kill failed!",BUFFERSIZE);

  }
 
  return (0);

}
    
KInt KonoeSignalDaemon::stringAnalyze( KChar * buffer ){

  KChar *line;
  line = new KChar[30];
  strcpy( line, buffer);

  KChar * pid_ptr;
  KChar * signal_ptr;

  pid_ptr = buffer;
    
  signal_ptr = strchr( buffer,'/');

  if( signal_ptr == NULL){
    cerr << " something wrong " << endl;
    return -1;
  }
  *signal_ptr = '\0';
  ++signal_ptr;

  pid = atol( pid_ptr );
  signal = atoi( signal_ptr );

  delete[] line;

  return (0);

}
