//===================================================================
/*

	KonoeNameSpaceTableOrderly.hh

	Version 0.0.1	04-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	15-Nov-2000	H. Sakamoto
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOENAMESPACETABLEORDERLY_HH
#define	__KONOENAMESPACETABLEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<system/KonoeNameSpaceTable.hh>
#include	<KonoeCategories.hh>
#include	<system/KonoeNameSpaceCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeNameSpaceTableOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::NAMESPACE
			+ KonoeNameSpaceCM::CID_NAMESPACETABLE };

	enum	{	CMD_SHOW,
			CMD_GET,
			CMD_HELP,
			N_COMMANDS	};
	enum	{ 	ARG_SHOW_NAME,
			N_ARG_SHOW	};
	enum	{	ARG_GET_NAME,
			N_ARG_GET	};

protected :
	static const KChar	* classname;

	KonoeNameSpaceTable	* target;

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	GetUnit	: public KonoeCommandProcessor {
	public :
	        GetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeNameSpaceTableOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
