//===================================================================
/*

	KonoeNetworkNameSpaceManagerOrderly.cc

	Version 0.0.1	04-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.5.1	18-Jan-2000	H. Sakamoto
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//===================================================================

#include	<system/KonoeNetworkNameSpaceManagerOrderly.hh>
#include	<ui/KonoeOfficer.hh>
#include	<ui/KonoeHelpCommand.hh>
#include	<string.h>

const KChar	* KonoeNetworkNameSpaceManagerOrderly::classname = "NetworkNameSpaceManager";


KonoeNetworkNameSpaceManagerOrderly::KonoeNetworkNameSpaceManagerOrderly(
	const KChar * objname ) :
	KonoeOrderly( N_COMMANDS, objname ) {

	setClassID( CLASS_ID );

	KonoeCommandDescriptor	* cmd_descripter;

	cmd_descripter = new KonoeCommandDescriptor( "show", N_ARG_SHOW );
	addCommand( new ShowUnit( cmd_descripter, this ) );

	cmd_descripter = new KonoeCommandDescriptor( "get", N_ARG_GET );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "io_object", STRING, NECESSARY ) );
        addCommand( new GetUnit( cmd_descripter, this ) );

	cmd_descripter = new KonoeCommandDescriptor( "set", N_ARG_SET );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "name", STRING, NECESSARY ) );
	cmd_descripter -> add(
		new KonoeArgumentDescriptor( "value", STRING, NECESSARY ) );
        addCommand( new SetUnit( cmd_descripter, this ) );

	addCommand( new KonoeHelpCommand( 0, this ) );

}

KInt	KonoeNetworkNameSpaceManagerOrderly::isOrderlyOf( void * address ) {

	return address == ( void * ) target;

}

KonoeNetworkNameSpaceManagerOrderly::ShowUnit::ShowUnit( KonoeCommandDescriptor * cd,
		KonoeOrderly * ow ) : KonoeCommandProcessor( cd, ow ) {
}

KInt	KonoeNetworkNameSpaceManagerOrderly::ShowUnit::execute( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );
	KonoeNetworkNameSpaceManager	* target;

	if( ! checkArgument( cmd ) ) return 0;

	os << "KonoeNetworkNameSpaceManagerOrderly" << endl;

	return 0;
}

KonoeNetworkNameSpaceManagerOrderly::GetUnit::GetUnit( KonoeCommandDescriptor * cd,
		KonoeOrderly * ow ) : KonoeCommandProcessor( cd, ow ) {
}

KInt	KonoeNetworkNameSpaceManagerOrderly::GetUnit::execute( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

	if( ! checkArgument( cmd ) ) return 0;

	KonoeCommandArgument	* arg = cmd -> getArgument( ARG_GET_TABLE );
        const KChar * obj_name = arg -> getValue( );

	return 0;
}

KonoeNetworkNameSpaceManagerOrderly::SetUnit::SetUnit( KonoeCommandDescriptor * cd,
		KonoeOrderly * ow ) : KonoeCommandProcessor( cd, ow ) {
}

KInt	KonoeNetworkNameSpaceManagerOrderly::SetUnit::execute( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

	if( ! checkArgument( cmd ) ) return 0;

	KonoeCommandArgument	* arg = cmd -> getArgument( ARG_SET_NAME );
        KChar * name = ( KChar * ) arg -> getValue( );
	arg = cmd -> getArgument( ARG_SET_VALUE );
	KChar * value = ( KChar * ) arg -> getValue( );

	KonoeNetworkNameSpaceManager	* target =
		( KonoeNetworkNameSpaceManager * ) owner -> getTarget( );
 
	target -> setValue( name, value );

	return 0;
}



KInt	KonoeNetworkNameSpaceManagerOrderly::createObject( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

	os << "KonoeNetworkNameSpaceManager cannot be created" << endl;

	return 0;

}

KInt	KonoeNetworkNameSpaceManagerOrderly::deleteObject( KonoeCommand * cmd ) {

	ostream & os = cmd -> getOutputStream( );

	os << "KonoeNetworkNameSpaceManager cannot be deleted" << endl;


	return 0;

}

KonoeOrderly	* KonoeNetworkNameSpaceManagerOrderly::clone(
	const KChar * name ) {

	return new KonoeNetworkNameSpaceManagerOrderly( name );

}
