//===================================================================
/*

	KonoeNetworkNameSpaceManagerOrderly.hh

	Version 0.0.1	04-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	15-Nov-2000	H. Sakamoto
	Version 0.6.1	21-May-2001	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOENETWORKNAMESPACEMANAGERORDERLY_HH
#define	__KONOENETWORKNAMESPACEMANAGERORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<system/KonoeNetworkNameSpaceManager.hh>
#include	<KonoeCategories.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeNetworkNameSpaceManagerOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::NAMESPACE + 
			KonoeNameSpaceCM::CID_NETWORKNAMESPACEMANAGER	};

	enum	{	CMD_SHOW,
			CMD_GET,
			CMD_SET,
			CMD_HELP,
			N_COMMANDS	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	ARG_SET_NAME,
			ARG_SET_VALUE,
			N_ARG_SET	};
	enum	{	ARG_GET_TABLE,
			N_ARG_GET	};

protected :
	static const KChar	* classname;

	KonoeNetworkNameSpaceManager	* target;

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	GetUnit	: public KonoeCommandProcessor {
	public :
	        GetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	SetUnit	: public KonoeCommandProcessor {
	public :
	        SetUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};



public :
	KonoeNetworkNameSpaceManagerOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
