//===================================================================
/*

	KonoeOutputObjFileOrderly.hh

	Version 0.0.1	04-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOEOUTPUTONJFILEORDERLY_HH
#define	__KONOEOUTPUTOBJFILEORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<system/KonoeOutputObjFile.hh>
#include	<KonoeCategories.hh>
//#include	<system/KonoeFileStreamCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeOutputObjFileOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::OBJECTFILE + 0x200 };
//			KonoeObjectFileCM::CID_OUTPUTOBJFILE	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_PUT,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_FILE,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{	ARG_PUT_IOOBJECT,
			N_ARG_PUT	};

protected :
	static const KChar	* classname;

	KonoeOutputObjFile	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	PutUnit	: public KonoeCommandProcessor {
	public :
	        PutUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeOutputObjFileOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
