//===================================================================
/*

	KonoeServerSocketOrderly.hh

	Version 0.0.1	04-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	21-May-2001	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOEOUTPUTONJSOCKETORDERLY_HH
#define	__KONOESERVERSOCKETORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<system/KonoeServerSocket.hh>
#include	<KonoeCategories.hh>
//#include	<system/KonoeSocketStreamCM.hh>
#include	<ui/KonoeCommandProcessor.hh>

class	KonoeServerSocketOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID = KonoeCategories::SYSTEMSERVICE + 0x100 };
//			KonoeSystemServiceCM::CID_SERVERSOCKET	};

	enum	{	CMD_CREATE,
			CMD_SHOW,
			CMD_WAITCONNECTION,
			CMD_CLOSECONNECTION,
			CMD_HELP,
			N_COMMANDS	};
	enum	{	ARG_CREATE_OBJECT,
			ARG_CREATE_PORT,
			N_ARG_CREATE	};
	enum	{ 	N_ARG_SHOW	};
	enum	{ 	N_ARG_WAITCONNECTION	};
	enum	{ 	N_ARG_CLOSECONNECTION	};

protected :
	static const KChar	* classname;

	KonoeServerSocket	* target;

	class	CreateUnit	: public KonoeCommandProcessor {
	public :
		CreateUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	ShowUnit	: public KonoeCommandProcessor {
	public :
		ShowUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	WaitConnectionUnit	: public KonoeCommandProcessor {
	public :
	        WaitConnectionUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

	class	CloseConnectionUnit	: public KonoeCommandProcessor {
	public :
	        CloseConnectionUnit( KonoeCommandDescriptor * cd, KonoeOrderly * owner );
		KInt	execute( KonoeCommand * cmd );
	};

public :
	KonoeServerSocketOrderly( const KChar * objname );

	const KChar	* getClassName( )	{
				return classname;	}

	KInt	createObject( KonoeCommand * cmd );
	KInt	deleteObject( KonoeCommand * cmd );
	KInt	isOrderlyOf( void * address );
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{
			return ( void * ) target;	}

};


#endif
