//===================================================================
/*

	KonoeClientSocket.cc

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.2	05-Nov-1997	H. Sakamoto
	Version 0.2A	06-Nov-1997	H. Sakamoto
	Version 0.3	06-Jan-1998	H. Sakamoto
	Version 0.1.0A	03-Mar-1998	H. Sakamoto
	Version 0.2.0	23-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka


note: bzero requires strings.h instead of string.h on Solaris

note: errno detected
	146 = Connection refused

*/
//===================================================================

#include	<system/KonoeClientSocket.hh>
#include	<stdio.h>
#include	<string.h>
#include	<strings.h>
#include	<iostream.h>
#include	<unistd.h>
#include	<signal.h>
#include	<errno.h>

/*
#ifndef	socket
extern "C"	{
	int	socket( int, int, int );
	int	connect( int, struct sockaddr *, int );
	void	bzero( char *, int );
	int	recv( int, char *, int, int );
       	int	send( int, char *, int, int );
	int	shutdown( int, int );
	};
#endif
*/

KonoeClientSocket::KonoeClientSocket( KChar * phostname, KInt pport )
		: KonoeSocketIO( ) {
	status = CLOSED;
	port = 0;
	hostname = 0;
	errornumber = 0;
// invalid address
	if( set_sockaddr( pport, phostname ) == -1 ) return;
	port = pport;
	hostname = new KChar[ strlen( phostname ) + 1 ];
	strcpy( hostname, phostname );
	fd = socket( PF_INET, SOCK_STREAM, 0 );
// resource problem ?
	if( fd == -1 ) {
	    errornumber = errno;
	    perror( 0 );
	    return;
	}
	status = OPENED;

// server is down.
	if( ::connect( fd, ( struct sockaddr * ) & socket_address,
		sizeof( socket_address ) ) == -1 ) {
	    errornumber = errno;
	    perror( 0 );
	    return;
	}
	status = CONNECTED;
}

KonoeClientSocket::~KonoeClientSocket( ) {

	if( status == CONNECTED )
	    shutdown( fd, 2 );	// 2 = complete?
	if( status != CLOSED )
	    close( fd );
	delete[] hostname;

}

KInt	KonoeClientSocket::connect( ) {

	KInt	st;

	switch( status ) {
	case CLOSED :
	    cerr << "KonoeClientSocket::connect. Socket is not open" << endl;
	    errornumber = E_SOCKETCLOSED;
	    return -1;
	case OPENED :
	    close( fd );
	    fd = socket( PF_INET, SOCK_STREAM, 0 );
	    st = ::connect( fd, ( struct sockaddr * ) & socket_address,
		sizeof( socket_address ) );
	    if( st == -1 ) {	// sever down
		errornumber = errno;
		perror( 0 );
		cout << "KonoeClientSocket::connect. errno = " << errno << endl;
		cerr << "KonoeClientSocket::connect. Server is down" << endl;
		return -1;
	    }
	    status = CONNECTED;
	    return 0;
	case CONNECTED :
	    return 0;	// already connected. nothing done.
	default :
	    return 0;
	}
}

KInt	KonoeClientSocket::send( const KChar * buffer, KInt nbytes ) {

	KInt	st;

	if( status != CONNECTED ) {
	    cerr << "KonoeClientSocket::send. Socket not connected." << endl;
	    errno = E_NOTCONNECTED;
	    return -1;	// error.
	}
	st = ::send( fd, buffer, nbytes, 0 );
	if( st < 0 ) {
	    errornumber = errno;
	    cerr << "KonoeClientSocket::send Error = " << errno << " ";
		perror( 0 );
	}
	return st;

}

KInt	KonoeClientSocket::receive( KChar * buffer, KInt buffersize ) {

	KInt	st;
	if( status != CONNECTED ) {
	    cerr << "KonoeClientSocket::receive. Socket not connected." << endl;
	    errornumber = E_NOTCONNECTED;
	    return -1;	// error.
	}
	bzero( buffer, buffersize );
	st = ::recv( fd, buffer, buffersize, 0 );
	if( st < 0 ) {
	    errornumber = errno;
	    cerr << "KonoeClientSocket::receive Error = " << errno << " ";
	    perror( 0 );
	}
	else if( st == 0 ) {
	    // usualy, this indicates a broken connection.
	    cerr << "KonoeClientSocket::receive. Zero bytes received." << endl;
	    status = OPENED;
	    return st;
	}
	return st;
}

