//===================================================================
/*

	KonoeClientSocket.hh

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.2.0	23-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	03-Aug-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka
		inheritanced KonoeFDClient

*/
//===================================================================

#ifndef	__KONOECLIENTSOCKET_HH
#define	__KONOECLIENTSOCKET_HH

#include	<system/KonoeSocketIO.hh>
#include	<system/KonoeFDClient.hh>
#include	<system/KonoeFDSet.hh>

class	KonoeClientSocket : public KonoeSocketIO {

public :
	enum	{	E_SOCKETCLOSED = -1,
			E_NOTCONNECTED = -2	};

protected :
	KInt	port;
	KChar	* hostname;
	KInt	errornumber;
	KonoeFDSet	* readfds;

public :
	KonoeClientSocket( KChar * hostname, KInt port );
	~KonoeClientSocket( );
	KInt	connect( );
	KInt	send( const KChar * buffer, KInt nbytes );
	KInt	receive( KChar * buffer, KInt buffersize );
	KInt	getStatus( )	{	return status;	}
	KInt	getFD( )	{	return fd;	}
};

#endif
