//===================================================================
/*

	KonoeFDSet.cc

	Version 0.0.1	12-Nov-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeFDSet.hh>
#include	<system/KonoeFDClient.hh>
#include	<iostream.h>
#include	<stdio.h>
#include	<string.h>
#include	<errno.h>

/*
#ifndef	bzero
extern "C"	{
	void	bzero( char *, int );
	int	select( int, fd_set *, fd_set *, fd_set *,
			struct timeval * );
};
#endif
*/

KonoeFDSet::KonoeFDSet( ) {

	for( KInt i = 0; i < FD_SETSIZE; i ++ )
	    clients[ i ] = 0;
	clientcount = 0;
}

KInt	KonoeFDSet::install( KonoeFDClient * client ) {

	KInt	i;

	if( clientcount >= FD_SETSIZE ) {
	    cerr << "KonoeFDSet::install. Client table full." << endl;
	    return -1;
	}

	for( i = 0; i < FD_SETSIZE; i ++ )
	    if( clients[ i ] == 0 ) {
		clients[ i ] = client;
		clientcount ++;
		return clientcount;
	    }

	cerr << "KonoeFDSet::install. Inconsistent implementation." << endl;
	return -1;

}

KInt	KonoeFDSet::remove( KonoeFDClient * client ) {

	KInt	i;

	for( i = 0; i < FD_SETSIZE; i ++ )
	    if( clients[ i ] == client ) {
		clients[ i ] = 0;
		clientcount --;
		return clientcount;
	    }

	cerr << "KonoeFDSet::remove. No match." << endl;
	return -1;

}

KonoeFDClient	* KonoeFDSet::wait( KInt milisec ) {

	KInt	i, fd, st, k;	// k for debug. fd counter.

	FD_ZERO( & readfds );
	k = 0;
	for( i = 0; i < FD_SETSIZE; i ++ )
	    if( clients[ i ] ) {
		fd = clients[ i ] -> getFD( );
		if( fd >= 0 ) {
		    FD_SET( fd, & readfds );
		    k ++;
		}
	    }
	timeout.tv_sec = milisec / 1000;
	timeout.tv_usec = ( milisec % 1000 ) * 1000;

//cout<<"KonoeFDSet::wait. call select with fd = "<<k<<endl;
	st = select( FD_SETSIZE, & readfds, 0, 0, & timeout );
	if( st > 0 ) {
	    for( i = 0; i < FD_SETSIZE; i ++ )
		if( clients[ i ] ) {
		    fd = clients[ i ] -> getFD( );
		    if( fd >= 0 ) {
			if( FD_ISSET( fd, & readfds ) )
			    return clients[ i ];
		    }
		}
	    cerr << "KonoeFDSet::wait. Unknown FD." << endl;
	    return 0;
	}
	else if( st < 0 ) {
	    cerr << "KonoeFDSet::wait. Select error = " << errno << endl;
	    perror( 0 );
	    return 0;
	}
	return 0;
}

