//===================================================================
/*

	KonoeFileIO.cc

	Version 0.1	16-Jul-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeFileIO.hh>
#include	<iostream.h>
#include	<unistd.h>
#include	<stdio.h>
#include	<fcntl.h>
#include	<string.h>

KonoeFileIO::KonoeFileIO( ) {
	fd = -1;
	filename = 0;
	status = CLOSED;
	mode = UNDEFINED;
}

KonoeFileIO::KonoeFileIO( KChar * pfilename, KInt pmode ) {
	filename = 0;
	status = CLOSED;
	mode = UNDEFINED;
	if( pmode == READ ) {
	    fd = open( pfilename, O_RDONLY );
	    if( fd == -1 ) {
		cerr << "KonoeFileIO::KonoeFileIO. Error. File open failure"
			" for read. ";
		perror( NULL );
		return;
	    }
	}
	else if( pmode == WRITE ) {
	    fd = open( pfilename, O_WRONLY | O_CREAT, DEFAULT_MODE );
	    if( fd == -1 ) {
		cerr << "KonoeFileIO::KonoeFileIO. Error. File open failure"
			" for write. ";
		perror( NULL );
		return;
	    }
	}
	else {	// Error : invalid mode
	    cerr << "KonoeFileIO::KonoeFileIO. Error. Invalid mode = "
		<< pmode << endl;
	    return;
	}
	status = OPENED;
	mode = pmode;
	filename = new char[ strlen( pfilename ) + 1 ];
	strcpy( filename, pfilename );
}

KonoeFileIO::~KonoeFileIO( ) {
	if( status == CLOSED )
	    return;
	close( fd );
	delete[] filename;
}
