//===================================================================
/*

	KonoeInputStream.cc

	Version 0.1     02-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeInputStream.hh>
#include	<iostream.h>

void    KonoeInputStream::netToHost( KInt * value, KInt datacount ){

#if     defined(__i386) || defined(__i386__)
	KInt i;
	for( i = 0; i < datacount; i++ ){
            byteSwap( (KChar*)&value[i], sizeof(KInt) );
	}
#endif
}

void    KonoeInputStream::netToHost( KFloat * value, KInt datacount ){

#if     defined(__i386) || defined(__i386__)
	KInt i;
        for( i = 0; i < datacount; i++ ){
            byteSwap( (KChar*)&value[i], sizeof(KFloat) );
	}
#endif
}

void	KonoeInputStream::netToHost( const KInt * from, KInt * to,
                                        KInt datacount  ){
	KInt i;
        for( i = 0; i < datacount; i++ ){
#if     defined(__i386) || defined(__i386__)
            byteSwap( (KChar*)&from[i], (KChar*)&to[i], sizeof(KInt));
#else
            to[i] = from[i];
#endif
        }
}

void	KonoeInputStream::netToHost( const KFloat * from, KFloat * to,
                                        KInt datacount  ){

	KInt i;
        for( i = 0; i < datacount; i++ ){
#if     defined(__i386) || defined(__i386__)
            byteSwap( (KChar*)&from[i], (KChar*)&to[i], sizeof(KFloat));
#else
            to[i] = from[i];
#endif
        }
}

KInt	KonoeInputStream::read( KInt * buffer, KInt datacount ){

	KInt	st, ist, readsize = datacount * sizeof( KInt );
	KChar	* pbuf = (KChar*)buffer;

	//checking readcount
	ist = 0;
        while( ist < readsize ) {
        if( ( st = readFromStream( &pbuf[ ist ], readsize - ist   ) ) <= 0 ) {
//cout<< "debug. inputstream read int.  st = " << st << endl;
            return st;
        }
            ist += st;
        }
	netToHost( buffer, datacount );

	return ist;
}

KInt	KonoeInputStream::read( KFloat * buffer, KInt datacount ){

        KInt	st, ist, readsize = datacount * sizeof( KFloat );
	KChar   * pbuf = (KChar*)buffer;

	//checking readcount
	ist = 0;
        while( ist < readsize ) {
        if( ( st = readFromStream( &pbuf[ ist ], readsize - ist   ) ) <= 0 ) {
//cout<< "debug. inputstream read flaot.  st = " << st << endl;
            return st;
        }
            ist += st;
        }
	netToHost( buffer, datacount );

        return ist;
}

KInt	KonoeInputStream::read( KChar * buffer, KInt datacount ){

        KInt	st, ist, readsize = datacount;
	KChar   * pbuf = buffer;
	//checking readcount
	ist = 0;
        while( ist < readsize ) {
        if( ( st = readFromStream( &pbuf[ ist ], readsize - ist   ) ) <= 0 ) {
//cout<< "debug. inputstream read char. st = " << st << endl;
            return st;
        }
	    ist += st;
	}

	return ist;
}
