//============================================================================
/*
	KonoeLock.cc

	Version 0.6	31-Jan-2000	Y. Shimizu
	Version	0.6.1	29-Jul-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//============================================================================

#include<system/KonoeLock.hh>
#include<system/KonoeHostSystem.hh>
#include<stdlib.h>
#include<iostream.h>


KonoeLock::KonoeLock(char *pathname ) {
	lockfile = pathname;
}

void KonoeLock::lock(void){
	fd = open( lockfile, O_RDWR, 0644);
	if (fd == -1)
		cerr << " could't open " << lockfile << endl;
	
	key.l_type = F_WRLCK;
	key.l_whence = SEEK_SET;
	key.l_start = 0;
	key.l_len = 0;

	st = fcntl(fd , F_SETLKW , &key);
	if (st == -1 ) 
		cerr << "failed fcntl " << endl;
}

void KonoeLock::guLock(void){
	fd = open( lockfile, O_RDWR, 0644);
	if (fd == -1)
		cerr << " could't open " << lockfile << endl;
	
	key.l_type = F_WRLCK;
	key.l_whence = SEEK_SET;
	key.l_start = 0;
	key.l_len = 0;

	st = fcntl(fd , F_SETLK , &key);
	if (st == -1 ) { 
		cerr << "failed fcntl " << endl;
		cerr << "Lock busy " << endl;
		KonoeHostSystem::exit(0);
	}
}
void KonoeLock::unLock(void){
	st = close(fd);
	if ( st == -1)
		cerr << " failed to close " << endl;
}

KonoeLock::~KonoeLock(void){

	st = close(fd);
	if ( st == -1)
		cerr << " failed to close " << endl;
}
