//===================================================================
/*

	KonoeOutputStream.cc

	Version 0.1     02-Sep-1999     Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeOutputStream.hh>
#include	<iostream.h>

void    KonoeOutputStream::hostToNet( KInt * value, KInt datacount ){

#if     defined(__i386) || defined(__i386__)
	KInt i;
        for( i = 0; i < datacount; i++ ){
            byteSwap( (KChar*)&value[i], sizeof(KInt) );
	}
#endif
}

void    KonoeOutputStream::hostToNet( KFloat * value, KInt datacount ){

#if     defined(__i386) || defined(__i386__)
	KInt i;
	for( i = 0; i < datacount; i++ ){
            byteSwap( (KChar*)&value[i], sizeof(KFloat) );
	}
#endif
}

void	KonoeOutputStream::hostToNet( const KInt * from, KInt * to,
                                        KInt datacount  ){
	KInt i;
	for( i = 0; i < datacount; i++ ){
#if     defined(__i386) || defined(__i386__)
	    byteSwap( (KChar*)&from[i], (KChar*)&to[i], sizeof(KInt));
#else
	    to[i] = from[i];
#endif
	}
}

void	KonoeOutputStream::hostToNet( const KFloat * from, KFloat * to,
                                        KInt datacount ){

	KInt i;
        for( i = 0; i < datacount; i++ ){
#if     defined(__i386) || defined(__i386__)
            byteSwap( (KChar*)&from[i], (KChar*)&to[i], sizeof(KFloat));
#else
            to[i] = from[i];
#endif
        }
}

KInt 	KonoeOutputStream::write( const KInt * buffer, KInt datacount ){

        KInt	st, ist, writesize = datacount * sizeof( KInt );
	KChar	* buf = new KChar[ writesize ];

	hostToNet( buffer, (KInt*)buf, datacount );

	//checking writecount
	ist = 0;
        while( ist < writesize ) {
        if( ( st = writeToStream( &buf[ ist ], writesize - ist   ) ) <= 0 ) {
	    delete [] buf;
            return st;
        }
            ist += st;
        }        
	delete [] buf;
	return ist;
}

KInt	KonoeOutputStream::write( const KFloat * buffer, KInt datacount ){

        KInt	st, ist, writesize = datacount * sizeof( KFloat );
	KChar	* buf = new KChar[ writesize ];

	hostToNet( buffer, (KFloat*)buf, datacount );

	//checking writecount
	ist = 0;
        while( ist < writesize ) {
        if( ( st = writeToStream( &buf[ ist ], writesize - ist   ) ) <= 0 ) {
	    delete [] buf;
            return st;
        }
            ist += st;
        }    
	delete [] buf;
        return ist;
}

KInt    KonoeOutputStream::write( const KChar * buffer, KInt datacount ){

        KInt    st, ist, writesize = datacount;

        //checking writecount
        ist = 0;
        while( ist < writesize ) {
        if( ( st = writeToStream( &buffer[ ist ], writesize - ist ) ) <= 0 ) {
	    return st;
	}
        ist += st;
	}
        return ist;
}

