//===================================================================
/*

	KonoeOutputStream.hh

	Version 0.1	02-Sep-1999	Y. Kouno
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#ifndef	__KONOEOUTPUTSTREAM_HH
#define	__KONOEOUTPUTSTREAM_HH

#include	<KonoePrimitives.hh>
#include	<system/KonoeStreamBase.hh>

class	KonoeOutputStream : public virtual KonoeStreamBase {

public :

        virtual KInt    writeToStream( const KChar * buffer, KInt nbytes ) = 0;

	KInt	write( KInt value ){ return write( &value, 1 ); }
	KInt	write( const KInt * buffer, KInt datacount );

	KInt	write( KFloat value ){ return write( &value, 1 ); }
	KInt	write( const KFloat * buffer, KInt datacount );

	KInt	write( KChar value ){ return write( &value, 1 ); }
	KInt	write( const KChar * buffer, KInt datacount );

	static void	hostToNet( KInt	* buffer, KInt datacount = 1);
	static void	hostToNet( KFloat * buffer, KInt datacount = 1 );
	static void	hostToNet( const KInt * frombuffer, KInt * tobuffer,
					KInt datacount = 1  );
	static void	hostToNet( const KFloat * frombuffer, KFloat * tobuffer,
					KInt datacount = 1 );

};

#endif
