//===================================================================
/*

	KonoeSCServerSocket.cc

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.2	05-Nov-1997	H. Sakamoto
	Version 0.3	06-Jan-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.1	08-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

	!!! Single Connection type Server !!!
*/
//===================================================================

#include	<system/KonoeSCServerSocket.hh>

#include	<iostream.h>
#include	<unistd.h>

//+ socklen_t : 08-Nov-2000 H.S.
#ifndef	__BITS_SOCKET_H
typedef	int	socklen_t;
#endif
//-

KonoeSCServerSocket::KonoeSCServerSocket( KInt pport ) {
	status = CLOSED;
	afd = socket( PF_INET, SOCK_STREAM, 0 );
	if( afd == -1 )
	    return;
	status = OPENED;
	port = pport;
	set_sockaddr( pport );
	if( bind( afd, ( struct sockaddr * ) & socket_address,
		sizeof( socket_address ) ) == -1 )
	    return;
	status = BOUND;
	if( listen( afd, 5 ) == -1 )
	    return;
	status = LISTENING;
	cfd = -1;
}

KonoeSCServerSocket::~KonoeSCServerSocket( ) {

	if( cfd != -1 )
	    close( cfd );
	if( status != CLOSED )
	    close( afd );

}

KInt	KonoeSCServerSocket::waitConnection( ) {
	KInt	lsa = sizeof( remote_address );

	cfd = accept( afd, ( struct sockaddr * ) & remote_address,
		( socklen_t * ) & lsa );
	return cfd;

}

KInt	KonoeSCServerSocket::closeConnection( ) {

	if( cfd < 0 ) return -1;
	shutdown( cfd, 2 );
	close( cfd );
	cfd = -1;
	return 0;
}

KInt	KonoeSCServerSocket::send( const KChar * buffer, KInt nbytes ) {

	if( cfd == -1 )
	    return -1;
	return ::send( cfd, buffer, nbytes, 0 );

}

KInt	KonoeSCServerSocket::receive( KChar * buffer, KInt buffersize ) {

	KInt	st;
	if( cfd == -1 )
	    return -1;
	st = ::recv( cfd, buffer, buffersize, 0 );

	return st;

}
