//===================================================================
/*

	KonoeServerSocket.hh

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.3	08-Dec-1997	H. Sakamoto
	Version 0.1.5	09-Mar-1998	H. Sakamoto
	Version 0.2.0	16-Apr-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	12-Nov-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
        Version 0.6.0   21-Sep-2000     Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka
*/
//===================================================================

#ifndef	__KONOESERVERSOCKET_HH
#define	__KONOESERVERSOCKET_HH

#include	<system/KonoeSocketIO.hh>
#include	<system/KonoeSocketConnection.hh>
#include	<system/KonoeFDClient.hh>
#include	<system/KonoeFDSet.hh>
#include	<sys/types.h>
#include	<errno.h>

class	KonoeServerSocket : public KonoeSocketIO {

public :
	enum	{	CLOSED, OPENED, BOUND, LISTENING	};
	enum	{	MAX_CLIENTS = 32	};
	enum	{	WAIT_INTERVAL = 1000	};
	enum	{	SEND_TO_LAST,	SEND_TO_OTHERS,	SEND_TO_ALL	};
	enum	{	E_TABLEFULL = -1,
			E_SOCKETNOTMATCH = -2,
			E_DISCONNECTED = -3,
			E_CONNECTED = -4	};

protected :
	KInt 	wait_interval;
	int	afd;	// accept file descriptor
	KInt	port;	// port number to which clients call on
	KInt	errornumber;	// error number set by last I/O.
	KInt	send_mode;
//	fd_set	readfds;	// read file descriptor set
	KonoeFDSet	* readfds;

	KonoeSocketConnection	* clients[ MAX_CLIENTS ];
	KonoeSocketConnection	* last_received;

//	void	set_fdset( );
	KInt	send_to_client( KonoeSocketConnection * , const KChar *, KInt );

public :
	KonoeServerSocket( KInt pport, KonoeFDSet * fds = 0 );
	~KonoeServerSocket( );

	KInt	waitConnection( );	// for SC implementation
	KInt	closeConnection( );
	KInt	send( const KChar * buffer, KInt nbytes );
	KonoeSocketConnection	* wait( KInt milisec );
	KInt	close( KonoeSocketConnection * s );
	KInt	receive( KChar * buffer, KInt buffersize );
	KonoeSocketConnection	* getLastReceived( ) {
			return last_received;	}
	void	setSendMode( KInt pmode )
			{	send_mode = pmode;	}
	void 	setWaitInterval( KInt pmillisec )
			{ 	wait_interval = pmillisec ; 	}
	KInt	getSendMode( )	{	return send_mode;	}
	KInt	getError( )	{	return errornumber;	}
	KInt	getFD( )	{	return afd;		}
	KonoeSocketConnection	* processReceiveAction(
					KonoeFDClient * client );
	KInt	receiveFromConnection( KonoeSocketConnection * ch,
			KChar * buffer, KInt buffersize );
	
};


#endif
