//===================================================================
/*

	KonoeSharedMemory.cc

	Version 0.1	03-Dec-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeSharedMemory.hh>
#include	<sys/types.h>
#include	<sys/ipc.h>
#include	<sys/shm.h>
#include	<stdio.h>
#include	<iostream.h>

KonoeSharedMemory::KonoeSharedMemory( KInt pkey, KInt psize, KInt paccess ) {

	shmid = shmget( pkey, psize, IPC_CREAT | paccess );
	if( shmid == -1 ) {
	    base = 0;
	    return;
	}
	base = ( void * ) shmat( shmid, 0, 0 );
	if( (int)base == -1 ) {
	    perror( "KonoeSharedMemory::constructer. shmat" );
	    base = 0;
	    return;
	}
	key = pkey;
	size = psize;
	access = paccess;

}

KonoeSharedMemory::~KonoeSharedMemory( ) {

	if( shmid == -1 ) return;
	shmdt( ( char * ) base );
//	shmctl( shmid, IPC_RMID, 0 );

}

void	KonoeSharedMemory::remove( ) {

	if( shmid == -1 ) return;
	shmdt( ( char * ) base );
	shmctl( shmid, IPC_RMID, 0 );

}
