//===================================================================
/*

	KonoeSignalhandler.cc

	Version 0.1	01-Aug-1997	H. Sakamoto
	Version 0.2	16-Sep-1997	H. Sakamoto
	Version 0.2A	06-Nov-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeSignalHandler.hh>
#include	<iostream.h>
#include	<stdlib.h>
#include	<unistd.h>

#if	KCC_HAS_SIG_PF
#else
typedef	void	SIG_FUNC_TYP	(int);
typedef	SIG_FUNC_TYP*	SIG_PF;
#endif

KonoeSignalHandler::KonoeSignalHandler( KInt psignalid,
		KonoeSignalClient * pclient )
{
	signal_id = psignalid;
	if( psignalid < MAX_SIGNAL_ENTRY && psignalid >= 0 )
		handler_list[ psignalid ] = this;
	client = pclient;
}

KInt	KonoeSignalHandler::enable( ) {

	signal( signal_id, ( SIG_PF ) KonoeSignalHandler::signal_handler );
	return 0;
}

KInt	KonoeSignalHandler::disable( ) {

	signal( signal_id, SIG_DFL );
	return 0;
}

void	KonoeSignalHandler::signal_handler( int sig, int code,
		struct sigcontext * scp, char * addr ) {

	if( handler_list[ sig ] ) {
	    handler_list[ sig ] -> signal_ucr( sig );
	}
	signal( sig, ( SIG_PF ) signal_handler );
}

KonoeSignalHandler * KonoeSignalHandler::handler_list[ KonoeSignalHandler::MAX_SIGNAL_ENTRY ];

void	KonoeSignalHandler::initialize( ) {

	for( KInt i = 0; i < MAX_SIGNAL_ENTRY; i ++ )
		handler_list[ i ] = 0;
}

void	KonoeSignalHandler::signal_ucr( KInt sig ) {

	if( client )
	    client -> catchSignal( sig );
}

KInt	KonoeSignalHandler::wait( ) {

	return pause( );
}
