//===================================================================
/*

	KonoeSocketConnection.cc

	Version 0.1	08-Dec-1997	H. Sakamoto
	Version 0.2	05-Jan-1998	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	12-Nov-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.1	08-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#include	<system/KonoeSocketConnection.hh>
#include	<system/KonoeSocketIO.hh>
#include	<unistd.h>
#include	<strings.h>
#include	<stdio.h>
#include	<errno.h>

//+ socklen_t : 08-Nov-2000 H.S.
#ifndef	__BITS_SOCKET_H
typedef	int	socklen_t;
#endif
//-

KonoeSocketConnection::KonoeSocketConnection( ) {

	fd = -1;
}

KonoeSocketConnection::~KonoeSocketConnection( ) {

	if( fd != -1 ) {
	    shutdown( fd, 2 );
	    close( fd );
	}
}

KInt	KonoeSocketConnection::accept( KInt afd ) {

	l_address = sizeof( socket_address );
	error = 0;
	fd = ::accept( afd, ( struct sockaddr * ) & socket_address,
		( socklen_t * ) & l_address );
	if( fd < 0 ) {
	    error = errno;
	    perror( 0 );
	}
	status = CONNECTED;
	return fd;
}

KInt	KonoeSocketConnection::send( const KChar * buffer, KInt nbytes ) {

	KInt	st;

	error = 0;
	st = ::send( fd, buffer, nbytes, 0 );
	if( st < 0 ) {
	    error = errno;
	    perror( 0 );
	}
	return st;
}

KInt	KonoeSocketConnection::receive( KChar * buffer, KInt buffersize ) {

	KInt	st;

	error = 0;
	if( fd == -1 ) {
	    error = E_SOCKETNOTOPEN;
	    return -1;
	}
	bzero( buffer, buffersize );
	st = ::recv( fd, buffer, buffersize, 0 );
	if( st < 0 ) {
	    error = errno;
	    perror( 0 );
	}
	return st;

}

KInt	KonoeSocketConnection::getClientAddress( ) {

	return socket_address.sin_addr.s_addr;

}

KChar	* KonoeSocketConnection::getClientName( ) {

	struct hostent	* hp;

	hp = gethostbyaddr( ( char * ) & socket_address.sin_addr.s_addr,
		4, AF_INET );
	if( hp )
	    return hp -> h_name;
	else
	    return 0;
}
