//===================================================================
/*

	KonoeSocketConnection.hh

	Version 0.1	08-Dec-1997	H. Sakamoto
	Version 0.4.0	27-Aug-1998	S. Inaba
	Version 0.4.1	12-Nov-1998	H. Sakamoto
		add getClientAddress/Name
	Version 0.4.2	03-Aug-1999	Y. Kouno
		inheritanced KonoeSocktIO
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

*/
//===================================================================

#ifndef	__KONOESOCKETCONNECTION
#define	__KONOESOCKETCONNECTION

#include	<KonoePrimitives.hh>
#include	<system/KonoeFDClient.hh>
#include	<system/KonoeSocketIO.hh>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netdb.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>

class	KonoeSocketConnection	: public KonoeSocketIO {

public :
	enum	{	E_SOCKETNOTOPEN = -1		};
protected :
	KInt	l_address;
	KInt	error;
public :
	KonoeSocketConnection( );
	~KonoeSocketConnection( );
	KInt	accept( KInt afd );
	KInt	getFD( )	{	return ( KInt ) fd;	}
	KInt	send( const KChar * buffer, KInt nbytes );
	KInt	receive( KChar * buffer, KInt buffersize );
	KInt	getClientAddress( );
	KChar	* getClientName( );
	KInt	getError( )	{	return error;	}
};

#endif
