//===================================================================
/*

	KonoeSocketIO.cc

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.1.0	06-Nov-1997	H. Kamata/H. Sakamoto
	Version 0.2.0	23-Apr-1998	H. Sakamoto
	Version 0.2.1	20-May-1998	H. Sakamoto
	Version 0.4.0 	01-Sep-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
		SIG_PF definition added.
	Version 0.6.0	09-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka
		virtual destructor

*/
//===================================================================

#include	<system/KonoeSocketIO.hh>

#if	KCC_HAS_SIG_PF
#else
typedef	void	SIG_FUNC_TYP	(int);
typedef	SIG_FUNC_TYP*	SIG_PF;
#endif

KInt	KonoeSocketIO::signal_status = 0;

KonoeSocketIO::KonoeSocketIO( ) {

	if( ! signal_status ) {
	    signal( SIGPIPE, ( SIG_PF ) KonoeSocketIO::catch_signal );
	    signal_status = 1;
	}
}

KonoeSocketIO::~KonoeSocketIO( ) {

}

KInt	KonoeSocketIO::set_sockaddr( KInt pport, KChar * phost ) {

	unsigned long	address;
	if( phost ) {
	    address = hostname_to_address( phost );
	    if( address == -1 )
		return -1;
	}
	else
	    address = INADDR_ANY;
	socket_address.sin_family = AF_INET;
	socket_address.sin_port = htons( pport );
	socket_address.sin_addr.s_addr = address;
	return address;
}

unsigned long	KonoeSocketIO::hostname_to_address( KChar * phost ) {

	unsigned long	address;
	struct hostent	* hp;

	hp = gethostbyname( phost );
	if( ! hp ) {
	    address = inet_addr( phost );
	    if( address == -1 )
		return 0;
	    hp = gethostbyaddr( ( char * ) & address, 4, AF_INET );
	}
	return * ( unsigned long * ) ( * hp -> h_addr_list );
}

void	KonoeSocketIO::catch_signal( int, int, struct sigcontext *, char * ) {

	signal( SIGPIPE, ( SIG_PF ) catch_signal );

}
