//===================================================================
/*

	KonoeSocketIO.hh

	Version 0.1	17-Jul-1997	H. Sakamoto
	Version 0.1.0	06-Nov-1997	H. Kamata/H. Sakamoto
	Version 0.2.0	23-Apr-1998	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
	Version 0.4.1	09-Sep-1999	Y. Kouno
		inheritanced InputStream and OutputStream
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	09-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka
		virtual destructor

*/
//===================================================================

#ifndef	__KONOESOCKETIO_HH
#define	__KONOESOCKETIO_HH

#include	<KonoePrimitives.hh>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netdb.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<signal.h>
#include	<system/KonoeInputStream.hh>
#include	<system/KonoeOutputStream.hh>
#include	<system/KonoeFDClient.hh>

class	KonoeSocketIO : virtual public KonoeInputStream,
			virtual public KonoeOutputStream,
			public KonoeFDClient  {

public :
	enum	{ CLOSED, OPENED, CONNECTED };

protected :
	int	fd;
	struct	hostent		* host_entry;
	struct	sockaddr_in	socket_address;

	KInt	status;	//socket status
	static KInt	signal_status;

	KInt	set_sockaddr( KInt pport, KChar * phost = 0 );
	static unsigned long	hostname_to_address( KChar * phost );
	static void	catch_signal( int, int, struct sigcontext *, char * );

public :
	KonoeSocketIO( );
	virtual	~KonoeSocketIO( );

	KInt	getStatus( )	{	return status;	}

	virtual KInt    send( const KChar * buffer, KInt nbytes ) = 0;
        virtual KInt    receive( KChar * buffer, KInt buffersize ) = 0;

	KInt	readFromStream( KChar * buffer, KInt nbytes ){
				return receive( buffer, nbytes ); }
	KInt    writeToStream( const KChar * buffer, KInt nbytes ){
				return send( buffer, nbytes ); }
};

#endif
