//==================================================================
/*

	KonoeTimeData.hh

	Version 0.1	05-Mar-1998	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
        Version 0.4.1   05-Aug-1999     N. Tanimoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6	10-Aug-2000	Y. Shimizu
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : systemservice

*/
//==================================================================

#ifndef	__KONOETIMEDATA_HH
#define	__KONOETIMEDATA_HH

#include	<KonoePrimitives.hh>
#include        <time.h>

class	KonoeTimeData	{

protected :

  enum MEMBER_ID {
    MID_SECOND,
    MID_MINUTE,
    MID_HOUR,
    MID_DAY,
    MID_MONTH,
    MID_YEAR,
    MID_DAYOFWEEK,
    N_MEMBERS };

        KInt	second;
	KInt	minute;
	KInt	hour;
	KInt	day;
	KInt	month;
	KInt	year;
	KInt	dayofweek;
public :
        KonoeTimeData( );
        KonoeTimeData( time_t t );
	void	set( );
        void    set( time_t t );
        KInt    getSecond( );
        KInt    getMinute( );
        KInt    getHour( );
        KInt    getDay( );
        KInt    getMonth( );
        KInt    getYear( );
        KInt    getDayofweek( );
};

#endif
