//=================================================================
/*

	KonoeUDPClientSocket.cc

	Version 0.1.0	05-Mar-1998	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version	0.6.0	17-Jul-2000	Y. Shimizu
	Version 0.6.1	08-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : systemservice

*/
//=================================================================

#include	<system/KonoeUDPClientSocket.hh>
#include	<unistd.h>

//+ socklen_t 08-Nov-2000 H.S.
#ifndef	__BITS_SOCKET_H
typedef	int	socklen_t;
#endif
//-

KonoeUDPClientSocket::KonoeUDPClientSocket( KChar * host, KInt pport )
		: KonoeSocketIO( ) {

	fd = socket( PF_INET, SOCK_DGRAM, 0 );
	if( fd == -1 )
		return;	// something wrong

	port = pport;
	set_sockaddr( port, host );
}

KonoeUDPClientSocket::~KonoeUDPClientSocket( ) {

	if( fd != -1 )
		close( fd );

}


KInt 	KonoeUDPClientSocket::send( const KChar * buffer , KInt nbytes ){

	return sendto( fd, ( char * ) buffer, nbytes, 0,
		( struct sockaddr * ) & socket_address,
		sizeof( socket_address ) );
}

KInt	KonoeUDPClientSocket::receive( KChar * buffer, KInt nbytes ) {

	sasize = sizeof( sa );
	return recvfrom( fd, ( char * ) buffer, nbytes, 0,
		( struct sockaddr * ) & sa, ( socklen_t * ) & sasize );

}
