//=================================================================
/*

	KonoeUDPServerSocket.cc

	Version 0.1.0	05-Mar-1998	H. Sakamoto
	Version 0.4.0	01-Sep-1998	S. Inaba
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.6.0	17-Jul-2000	Y. Shimizu
	Version 0.6.1	08-Nov-2000	H. Sakamoto
	Version 0.7.0	28-Aug-2001	S. Morinaka

	Package : system
	Category : systemservice

*/
//=================================================================

#include	<system/KonoeUDPServerSocket.hh>
#include	<unistd.h>

//+socklen_t : 08-Nov-2000 H.S.
#ifndef	__BITS_SOCKET_H
typedef	int	socklen_t;
#endif
//-

KonoeUDPServerSocket::KonoeUDPServerSocket( KInt pport )
	: KonoeSocketIO( ) {

	KInt	st;

	fd = socket( PF_INET, SOCK_DGRAM, 0 );
	if( fd == -1 )
		return;	// something wrong
	port = pport;
	socket_address.sin_family = AF_INET;
	socket_address.sin_port = htons( port );
	socket_address.sin_addr.s_addr = INADDR_ANY;
	st = bind( fd, ( struct sockaddr * ) & socket_address,
		sizeof( socket_address ) );

}

KonoeUDPServerSocket::~KonoeUDPServerSocket( ) {

	if( fd != -1 )
		close( fd );

}


KInt	KonoeUDPServerSocket::reply( void * buffer, KInt nbytes ) {

	return sendto( fd, ( char * ) buffer, nbytes, 0,
		( struct sockaddr * ) & sa, sasize );
}

KInt	KonoeUDPServerSocket::receive( KChar * buffer, KInt nbytes ) {

	sasize = sizeof( sa );
	return recvfrom( fd, ( char * ) buffer, nbytes, 0,
		( struct sockaddr * ) & sa, ( socklen_t * )  & sasize );

}

KInt 	KonoeUDPServerSocket::send( const KChar * buffer , KInt nbytes ) {

	return ( 	reply(	( void* )buffer, nbytes )	);

}
