//==================================================================
/*

	demomcc.cc

	Version 0.1	11-Dec-1997	H. Sakamoto
	Version 0.2.0	24-Apr-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

	multi-client server test program ( client side )

*/
//==================================================================

#include	<system/KonoeClientSocket.hh>
#include	<iostream.h>
#include	<string.h>
#include	<strings.h>
#include	<stdlib.h>
#include	<unistd.h>

void	print_usage( ) {

	cout << "demomcc : usage" << endl;
	cout << "	% demomcc [options...]" << endl << endl;
	cout << "options :	-s servername	: set server host" << endl;
	cout << "		-p portnumber	: set port number" << endl;
	cout << "		-e		: echo test ( default )" << endl;
	cout << "		-b		: broadcast test" << endl;
	cout << "		-r		: receiver test" << endl;
	cout << "		-h		: print help ( this )" << endl;
}

int	main( int argc, char ** argv ) {

	KInt	port = 10000;
	KChar	* default_host = "konoe2";
	KChar	* host = default_host;
	KChar	* p;
	KChar	test_mode = 'e';

	for( KInt i = 1; i < argc; i ++ ) {
	    argv ++;
	    p = * argv;
	    switch( * p ) {
	    case '-':	// switch
		p ++;
		switch( * p ) {
		case 's':	// server
		    if( i >= argc - 1 ) {
			cout << "Argument missing for option -s" << endl;
			break;
		    }
		    i ++;
		    argv ++;
		    host = * argv;	// next argument
		    break;
		case 'p':
		    if( i >= argc - 1 ) {
			cout << "Argument missing for option -p" << endl;
			break;
		    }
		    i ++;
		    argv ++;
		    port = atol( * argv );	// next argument
		    break;
		case 'b':
		case 'e':
		case 'r':
		    test_mode = * p;
		    break;
		case 'h':
		    print_usage( );
		    return 0;
		default :
		    cout << "Unknown option = " << * p << endl;
		    break;
		}
		break;
	    default :
		cout << "Invalid syntax arround = " << p << endl;
		break;
	    }
	}

	cout << "demomcc : host = " << host
		<< " : port = " << port
		<< " : test mode = " << test_mode << endl;
	KonoeClientSocket	socket( host, port );

	KChar	* message = "Hellow, how are you ?";
	KChar	reply[ 256 ];
	KInt	st;

	if( socket.getStatus( ) == KonoeSocketIO::CLOSED ) {
	    cout << "Error opening socket. Exit" << endl;
	    return 1;
	}

	if( test_mode == 'e' ) {
	while( socket.getStatus( ) != KonoeSocketIO::CLOSED ) {
	    if( socket.getStatus( ) != KonoeSocketIO::CONNECTED )
		socket.connect( );
	    if( socket.getStatus( ) == KonoeSocketIO::CONNECTED ) {
		st = socket.send( message, strlen( message ) );
		cout << "send st = " << st << endl;
		if( st < 0 ) break;
		st = socket.receive( reply, sizeof( reply ) );
		cout << "receive st = " << st << " Reply is = " << reply << endl;
		if( st < 0 ) break;
	    }
	    sleep( 5 );
	}
	}
	else if( test_mode == 'b' ) {
	    while( socket.getStatus( ) != KonoeSocketIO::CLOSED ) {
		if( socket.getStatus( ) != KonoeSocketIO::CONNECTED ) {
		    socket.connect( );
		    sleep( 1 );
		}
		else
		{
		    st = socket.receive( reply, sizeof( reply ) );
		    cout << "receive st = " << st
			<< " Reply is = " << reply << endl;
		    if( st < 0 ) break;
		}
	    }
	}
	else if( test_mode == 'r' ) {
	    while( socket.getStatus( ) != KonoeSocketIO::CLOSED ) {
		if( socket.getStatus( ) != KonoeSocketIO::CONNECTED ) {
		    socket.connect( );
		    sleep( 1 );
		}
		else
		{
		    st = socket.send( message, strlen( message ) );
		    cout << "send st = " << st << endl;
		    if( st < 0 ) break;
		    sleep( 5 );
		}
	    }
	}
	return 0;
}

