//==================================================================
/*

	demomcs.cc

	Version 0.1	11-Dec-1997	H. Sakamoto
	Version 0.2.0	24-Apr-1998	H. Sakamoto
        Version 0.5.0   21-Sep-1999     Y. Kouno
	Version 0.7.0	28-Aug-2001	S. Morinaka

	multi-client server test program ( server side )

*/
//==================================================================

#include	<system/KonoeServerSocket.hh>
#include	<iostream.h>
#include	<string.h>
#include	<stdlib.h>
#include	<unistd.h>

void	print_usage( ) {

	cout << "demomcs : usage" << endl;
	cout << "	% demomcs [options...]" << endl << endl;
	cout << "options :	-p portnumber	: set port number" << endl;
	cout << "		-e		: echo test ( default )" << endl;
	cout << "		-b		: broadcast test" << endl;
	cout << "		-r		: receiver test" << endl;
	cout << "		-h		: print help ( this )" << endl;

}

int	main( int argc, char ** argv ) {

	KInt	port = 10000;
	KChar	* p;
	KChar	test_mode = 'e';
	KChar	* b_message = "Broadcasting this message";

	for( KInt i = 1; i < argc; i ++ ) {
	    argv ++;	// next to the image name
	    p = * argv;
	    switch( * p ) {
	    case '-':	// switch
		p ++;
		switch( * p ) {
		case 'p':
		    if( i >= argc - 1 ) {
			cout << "Argument missing for option -p" << endl;
			break;
		    }
		    i ++;
		    argv ++;
		    port = atol( * argv );	// next argument
		    break;
		case 'h':
		    print_usage( );
		    return 0;
		case 'e':
		case 'b':
		case 'r':
		    test_mode = * p;
		    break;
		default :
		    cout << "Unknown option = " << * p << endl;
		    break;
		}
		break;
	    default :
		cout << "Invalid syntax arrount = " << p << endl;
		break;
	    }
	}

	cout << "demomcs : port = " << port
		<< " : test mode = " << test_mode << endl;
	KonoeServerSocket	socket( port );
	KChar	message[ 256 ];
	KInt	st;


	if( test_mode == 'e' ) {
	    socket.setSendMode( KonoeServerSocket::SEND_TO_LAST );
	while( 1 ) {
	    st = socket.receive( message, sizeof( message ) );
	    if( st > 0 ) {
		cout << "Received. st = " << st << " : " << message << endl;
		socket.send( message, strlen( message ) );
	    }
	}
	}
	else if( test_mode == 'b' ) {
	    while( 1 ) {
		st = socket.send( b_message, strlen( b_message ) );
		socket.wait( 5000 );
	    }
	}
	else if( test_mode = 'r' ) {
	    while( 1 ) {
		st = socket.receive( message, sizeof( message ) );
		if( st != 0 ) {
		    cout << "Received. st = " << st;
		    if( st > 0 )
			cout << " : " << message;
		    cout << endl;
		}
	    }
	}
	return 0;
}
