//==================================================================
/*

	KonoeGdkDrawable.hh

	Version 0.0.1	04-Apr-2001	H. Sakamoto

	-------------------------------------------

	GDK Drawable class

*/
//==================================================================

#include	<ui/KonoeGdkDrawable.hh>
#include	<ui/KonoeGdkGC.hh>
#include	<ui/KonoeGdkFont.hh>

KonoeGdkDrawable::KonoeGdkDrawable( KonoeGtkWidget * widget ) {

	GtkWidget	* gwidget;

	gwidget = widget -> get_gtk_widget( );
	drawable = gwidget -> window;
	gc = gwidget -> style -> black_gc;

}

void	KonoeGdkDrawable::drawPoint( KInt x, KInt y ) {

	gdk_draw_point( drawable, gc, x, y );

}

void	KonoeGdkDrawable::drawLine( KInt xs, KInt ys, KInt xe, KInt ye ) {

	gdk_draw_line( drawable, gc, xs, ys, xe, ye );

}

void	KonoeGdkDrawable::drawRectangle( KInt x, KInt y, KInt w, KInt h ) {

	gdk_draw_rectangle( drawable, gc, KFalse, x, y, w, h );

}

void	KonoeGdkDrawable::fillRectangle( KInt x, KInt y, KInt w, KInt h ) {

	gdk_draw_rectangle( drawable, gc, KTrue, x, y, w, h );

}

void	KonoeGdkDrawable::setGC( KonoeGdkGC * pgc ) {

	gc = pgc -> get_gdk_gc( );

}

void	KonoeGdkDrawable::drawArc(
		KInt x, KInt y, KInt w, KInt h, KInt s, KInt e ) {

	gdk_draw_arc( drawable, gc, KFalse, x, y, w, h, s, e );

}

void	KonoeGdkDrawable::fillArc(
		KInt x, KInt y, KInt w, KInt h, KInt s, KInt e ) {

	gdk_draw_arc( drawable, gc, KTrue, x, y, w, h, s, e );

}

void	KonoeGdkDrawable::drawPolygon( GdkPoint * points, KInt npoints ) {

	gdk_draw_polygon( drawable, gc, KFalse, points, npoints );

}

void	KonoeGdkDrawable::fillPolygon( GdkPoint * points, KInt npoints ) {

	gdk_draw_polygon( drawable, gc, KTrue, points, npoints );

}

void	KonoeGdkDrawable::drawString( KInt x, KInt y, const KChar * string ) {

	GdkGCValues	v;

	gdk_gc_get_values( gc, & v );
	gdk_draw_string( drawable, v.font, gc, x, y, string );

}

void	KonoeGdkDrawable::drawString( KonoeGdkFont * font,
			KInt x, KInt y, const KChar * string ) {

	gdk_draw_string( drawable, font -> get_gdk_font( ), gc, x, y, string );

}

void	KonoeGdkDrawable::drawPixmap( KonoeGtkWidget * src,
			KInt xsrc, KInt ysrc,
			KInt xdst, KInt ydst, KInt w, KInt h ) {

	GdkDrawable	* d;

	d = src -> get_gtk_widget( ) -> window;
	gdk_draw_pixmap( drawable, gc, d, xsrc, ysrc, xdst, ydst, w, h );


}
