//==================================================================
/*

	KonoeGdkDrawable.hh

	Version 0.0.1	04-Apr-2001	H. Sakamoto

	-------------------------------------------

	GDK Drawable class

*/
//==================================================================

#ifndef	__KONOEGDKDRAWABLE_HH
#define	__KONOEGDKDRAWABLE_HH

#include	<ui/KonoeGtkWidget.hh>

class	KonoeGdkGC;
class	KonoeGdkFont;

class	KonoeGdkDrawable	{

protected :
	GdkDrawable	* drawable;
	GdkGC		* gc;

public :
	KonoeGdkDrawable( KonoeGtkWidget * widget );

	void	setGC( KonoeGdkGC * gc );
	void	drawPoint( KInt x, KInt y );
	void	drawLine( KInt xs, KInt ys, KInt xe, KInt ye );
	void	drawRectangle( KInt x, KInt y, KInt w, KInt h );
	void	fillRectangle( KInt x, KInt y, KInt w, KInt h );
	void	drawArc( KInt x, KInt y, KInt w, KInt h, KInt s, KInt e );
	void	fillArc( KInt x, KInt y, KInt w, KInt h, KInt s, KInt e );
	void	drawPolygon( GdkPoint * points, KInt npoints );
	void	fillPolygon( GdkPoint * points, KInt npoints );
	void	drawString( KInt x, KInt y, const KChar * string );
	void	drawString( KonoeGdkFont * font,
			KInt x, KInt y, const KChar * string );
	void	drawPixmap( KonoeGtkWidget * src, KInt xsrc, KInt ysrc,
			KInt xdst, KInt ydst, KInt w, KInt h );

	GdkWindow	* get_gdk_window( )
			{	return drawable;	}

};

#endif
