//==================================================================
/*

	KonoeGtkEvent.cc

	Version 0.0.1	04-Apr-2001	H. Sakamoto

	-------------------------------------------

	GTK Event class

*/
//=================================================================

#include	<ui/KonoeGtkEvent.hh>
#include	<ui/KonoeGtkEventReceiver.hh>


KonoeGtkEvent::KonoeGtkEvent( KChar * evname, KonoeGtkEventReceiver * rec ) {

	target = 0;
	receiver = rec;
	eventname = evname;
	descriptor = new KonoeGtkEventDescriptor( );

}

void	KonoeGtkEvent::setTarget( KonoeGtkObject * pwidget ) {

	target = pwidget;

	identifier = gtk_signal_connect(
		GTK_OBJECT( target -> get_gtk_object( ) ),
		eventname, GTK_SIGNAL_FUNC( callback ),
		( gpointer ) this );

}

void	KonoeGtkEvent::callback( GtkWidget * gwidget,
		GdkEvent * gevent, gpointer pointer ) {

	if( pointer == 0 )
		return;
	KonoeGtkEvent	* event = ( KonoeGtkEvent * ) pointer;
	event -> descriptor -> setEvent( gevent );
	event -> receiver -> processEvent( event -> target, event -> descriptor );

}
