//==================================================================
/*

	KonoeGtkSelection.cc

	Version 0.0.1	10-Apr-2001	H. Sakamoto

	-------------------------------------------

	Gtk+ child selection signal handling

*/
//==================================================================

#include	<ui/KonoeGtkSelection.hh>
#include	<ui/KonoeGtkSelectionReceiver.hh>


KonoeGtkSelection::KonoeGtkSelection( KChar * signame,
			KonoeGtkSelectionReceiver * recv ) {

	target = 0;
	receiver = recv;
	signalname = signame;
}

void	KonoeGtkSelection::setTarget( KonoeGtkObject * pwidget ) {

	target = pwidget;

	identifier = gtk_signal_connect( target -> get_gtk_object( ),
		signalname, GTK_SIGNAL_FUNC( callback ),
		( gpointer ) this );
}

gint	KonoeGtkSelection::callback( GtkObject * pwidget,
		GtkWidget * child, gpointer pointer ) {

	if( pointer == 0 )
	    return 0;

	// find an object containing 'child' widget.

	return ( ( KonoeGtkSelection * ) pointer ) -> receiver ->
		processSelection(
			( ( KonoeGtkSelection * ) pointer ) -> target,
			( ( KonoeGtkSelection * ) pointer ) -> signalname,
			child );

}
