//===============================================================
/*

	demo.cc at ui_gtk3/widget

	Version 0.0.1	04-Apr-2001	H. Sakamoto

*/
//===============================================================

#include	<ui/KonoeGtkMainWindow.hh>
#include	<ui/KonoeGtkButton.hh>
#include	<ui/KonoeGtkSignal.hh>
#include	<ui/KonoeGtkSignalReceiver.hh>
#include	<ui/KonoeGtkDrawingArea.hh>
#include	<ui/KonoeGtkVBox.hh>
#include	<ui/KonoeGtkEventBox.hh>
#include	<ui/KonoeGtkEvent.hh>
#include	<ui/KonoeGtkEventReceiver.hh>
#include	<ui/KonoeGdkDrawable.hh>
#include	<ui/KonoeGtkLabel.hh>
#include	<ui/KonoeGtkEntry.hh>
#include	<ui/KonoeGtkMenuBar.hh>
#include	<ui/KonoeGtkMenu.hh>
#include	<ui/KonoeGtkMenuItem.hh>
#include	<ui/KonoeGtkAccelGroup.hh>
#include	<ui/KonoeGtkDialog.hh>
#include	<ui/KonoeGtkPixmap.hh>
#include	<ui/KonoeGtkAdjustment.hh>
#include	<ui/KonoeGtkHScale.hh>
#include	<ui/KonoeGtkTooltips.hh>
#include	<ui/KonoeGtkHSeparator.hh>
#include	<ui/KonoeGtkFrame.hh>
#include	<ui/KonoeGtkCombo.hh>
#include	<ui/KonoeGtkToggleButton.hh>
#include	<ui/KonoeGtkCheckButton.hh>
#include	<ui/KonoeGtkList.hh>
#include	<ui/KonoeGtkListItem.hh>
#include	<ui/KonoeGtkTree.hh>
#include	<ui/KonoeGtkTreeItem.hh>
#include	<ui/KonoeGtkScrolledWindow.hh>
#include	<ui/KonoeGtkSelection.hh>
#include	<ui/KonoeGtkSelectionReceiver.hh>
#include	<ui/KonoeGtkCList.hh>

#include	<iostream.h>
#include	<string.h>

class GtkDemo	: public KonoeGtkMainWindow,
		public KonoeGtkSignalReceiver,
		public KonoeGtkEventReceiver,
		public KonoeGtkSelectionReceiver	{

protected:
	KonoeGtkButton		* button;
	KonoeGtkDrawingArea	* darea;
	KonoeGtkVBox		* vbox;
	KonoeGtkEventBox	* ebox;
	KonoeGdkDrawable	* canvas;
	KonoeGtkLabel		* label;
	KonoeGtkEntry		* entry;
	KonoeGtkMenuBar		* menubar;
	KonoeGtkMenuItem	* filemenuitem;
	KonoeGtkMenu		* filemenu;
	KonoeGtkMenuItem	* openmenuitem;
	KonoeGtkMenuItem	* exitmenuitem;
	KonoeGtkAccelGroup	* accelgroup;
	KonoeGtkDialog		* dialog;
	KonoeGtkButton		* okbutton;
	KonoeGtkPixmap		* pixmap;
	KonoeGtkHScale		* hscale;
	KonoeGtkAdjustment	* adjustment;
	KonoeGtkTooltips	* tooltips;
	KonoeGtkFrame		* frame;
	KonoeGtkCombo		* combo;
	KonoeGtkEntry		* comboentry;
	KonoeGtkToggleButton	* togglebutton;
	KonoeGtkCheckButton	* checkbutton;
	KonoeGtkList		* list;
	KonoeGtkScrolledWindow	* scrolledwindow;
	KonoeGtkTree		* tree;
	KonoeGtkTreeItem	* firstitem;
	KonoeGtkTreeItem	* seconditem;
	KonoeGtkTree		* firstsubtree;
	KonoeGtkTree		* secondsubtree;
	KonoeGtkCList		* clist;
	KonoeGtkScrolledWindow	* swindow;

public :
	GtkDemo( int argc, char ** argv );
	KInt	processSignal( KonoeGtkObject * widget, KChar * signame );
	void	processEvent( KonoeGtkObject * widget,
			KonoeGtkEventDescriptor * event );
	KInt	processSelection( KonoeGtkObject * obj, KChar * signame,
			GtkWidget * child );

};

GtkDemo::GtkDemo( int argc, char ** argv )
	: KonoeGtkMainWindow( argc, argv ) {

//	connectEvent( new KonoeGtkEvent( "enter_notify_event", this ) );
	connectSignal( new KonoeGtkSignal( "destroy", this ) );

	accelgroup = new KonoeGtkAccelGroup( );
	addAccelGroup( accelgroup );

	vbox = new KonoeGtkVBox( 0, 0 );
	add( vbox );

	menubar = new KonoeGtkMenuBar( );
	menubar -> show( );
	vbox -> packStart( menubar );

	filemenuitem = new KonoeGtkMenuItem( "File" );
	filemenuitem -> show( );
	menubar -> append( filemenuitem );

	filemenu = new KonoeGtkMenu( );
	filemenu -> show( );
	openmenuitem = new KonoeGtkMenuItem( "Open..." );
	openmenuitem -> show( );
	openmenuitem -> connectSignal( new KonoeGtkSignal( "activate", this ) );
	filemenu -> append( openmenuitem );
	exitmenuitem = new KonoeGtkMenuItem( "Exit" );
	exitmenuitem -> show( );
	exitmenuitem -> connectSignal( new KonoeGtkSignal( "activate", this ) );
	exitmenuitem -> addAccelerator( "activate", accelgroup,
			'Q', KonoeGtkAccelGroup::CONTROL_MASK, 1 );

	filemenu -> append( exitmenuitem );
	filemenuitem -> setSubMenu( filemenu );

	ebox = new KonoeGtkEventBox(  );
	darea = new KonoeGtkDrawingArea( );
	darea -> setSize( 200, 200 );
	ebox -> add( darea );
	ebox -> connectEvent(
		new KonoeGtkEvent( "button_press_event", this ) );
	darea -> show( );
	ebox -> show( );
	vbox -> add( ebox );

	vbox -> add( new KonoeGtkHSeparator( ) );

	vbox -> add( label = new KonoeGtkLabel( "Test program" ) );
	label -> show( );
	entry = new KonoeGtkEntry( );
	vbox -> add( entry );
	entry -> connectSignal( new KonoeGtkSignal( "changed", this ) );
	entry -> show( );

	hscale = new KonoeGtkHScale( adjustment = new
			KonoeGtkAdjustment( 0, 0, 100, 1, 10, 0 ) );
	hscale -> show( );
	vbox -> add( hscale );
	adjustment -> connectSignal( new KonoeGtkSignal( "value_changed", this ) );

	combo = new KonoeGtkCombo( );
	combo -> append( "winter" );
	combo -> append( "spring" );
	combo -> append( "summer" );
	combo -> append( "autumn" );
	combo -> setPopdownStrings( );
	combo -> show( );
	vbox -> add( combo );
	comboentry = combo -> getEntry( );
	comboentry -> connectSignal( new KonoeGtkSignal( "activate", this ) );

	vbox -> add( new KonoeGtkHSeparator( ) );

	scrolledwindow = new KonoeGtkScrolledWindow(
		new KonoeGtkAdjustment( 0, 0, 100, 1, 10, 0 ),
		new KonoeGtkAdjustment( 0, 0, 100, 1, 10, 0 ) );

	tree = new KonoeGtkTree( );
	firstitem = new KonoeGtkTreeItem( "first" );
	tree -> append( firstitem );
	firstsubtree = new KonoeGtkTree( );
	firstitem -> setSubtree( firstsubtree );
	firstsubtree -> append( new KonoeGtkTreeItem( "sub1-item1" ) );
	firstsubtree -> append( new KonoeGtkTreeItem( "sub1-item2" ) );
	seconditem = new KonoeGtkTreeItem( "second" );
	tree -> append( seconditem );
	tree -> show( );
	scrolledwindow -> addWithViewport( tree );
	scrolledwindow -> show( );
	vbox -> add( scrolledwindow );

	togglebutton = new KonoeGtkToggleButton( "Toggle" );
	togglebutton -> show( );
	togglebutton -> connectSignal( new KonoeGtkSignal( "toggled", this ) );
	vbox -> add( togglebutton );

	checkbutton = new KonoeGtkCheckButton( "Check" );
	checkbutton -> show( );
	checkbutton -> connectSignal( new KonoeGtkSignal( "toggled", this ) );
	vbox -> add( checkbutton );
	list = new KonoeGtkList( );
	list -> append( new KonoeGtkListItem( "Monday" ) );
	list -> append( new KonoeGtkListItem( "Tuesday" ) );
	list -> append( new KonoeGtkListItem( "Wednesday" ) );
	list -> append( new KonoeGtkListItem( "Thursday" ) );
	list -> append( new KonoeGtkListItem( "Friday" ) );
	list -> setItems( );
	list -> showAll( );
	list -> connectSelection( new KonoeGtkSelection( "select-child", this ) );
	vbox -> add( list );
	vbox -> add( new KonoeGtkHSeparator( ) );

	swindow = new KonoeGtkScrolledWindow(
		new KonoeGtkAdjustment( 0, 0, 100, 1, 10, 0 ),
		new KonoeGtkAdjustment( 0, 0, 100, 1, 10, 0 ) );
	clist = new KonoeGtkCList( 3 );
	clist -> setColumnTitle( 0, "Name" );
	clist -> setColumnTitle( 1, "Address" );
	clist -> setColumnTitle( 2, "Age" );
	clist -> showColumnTitles( );
	clist -> setText( 0, 0, "Yamada Hanako" );
	clist -> setText( 0, 1, "Kyoto" );
	clist -> setText( 0, 2, "19" );
	clist -> show( );
	swindow ->addWithViewport( clist );
	swindow -> show( );
	vbox -> add( swindow );

	vbox -> add( new KonoeGtkHSeparator( ) );

	vbox -> packEnd( button = new KonoeGtkButton( "Quit" ) );
	button -> connectSignal( new KonoeGtkSignal( "clicked", this ) );
	button -> show( );
	tooltips = new KonoeGtkTooltips( button, "end execution", "stop" );
	tooltips -> setDelay( 3000 );

	vbox -> show( );
	show( );

	frame = new KonoeGtkFrame( "Frame" );
	pixmap = new KonoeGtkPixmap( this, "misc_icon.xpm" );
	pixmap -> show( );
	frame -> add( pixmap );
	frame -> show( );
	vbox -> add( frame );


	dialog = new KonoeGtkDialog( );
	dialog -> addToVBox( new KonoeGtkLabel( "Hello ! Dialog" ) );
	okbutton = new KonoeGtkButton( "OK" );
	okbutton -> connectSignal( new KonoeGtkSignal( "clicked", this ) );
	dialog -> addToActionArea( okbutton );

	canvas = new KonoeGdkDrawable( darea );
//	canvas -> drawLine( 10, 10, 190, 190 );


}

KInt	GtkDemo::processSignal( KonoeGtkObject * pwidget, KChar * signame ) {

	cout << "Signal = " << signame << endl;

	if( strcmp( signame, "clicked" ) == 0 ) {
	    if( pwidget == button )
		return quit( );
	    else if( pwidget == okbutton )
		dialog -> hideAll( );
	}
	else if( strcmp( signame, "changed" ) == 0 ) {
	    cout << "Entry = " << entry -> getText( ) << endl;
	}
	else if( strcmp( signame, "value_changed" ) == 0 ) {
	    cout << "Value = " << adjustment -> getValue( ) << endl;
	}
	else if( strcmp( signame, "activate" ) == 0 ) {
	    if( pwidget == exitmenuitem )
		return quit( );
	    else if( pwidget == openmenuitem )
		dialog -> showAll( );
	    else if( pwidget == comboentry )
		cout << "Combo entry = " << comboentry -> getText( ) << endl;
	}
	else if( strcmp( signame, "toggled" ) == 0 ) {
	    cout << "Toggled." << endl;
	}
	return 0;

}

KInt	GtkDemo::processSelection( KonoeGtkObject * pwidget,
		KChar * signame, GtkWidget * child ) {

	cout << "processSelection called with " << signame;
	cout << " on " << gtk_widget_get_name( child ) << endl;

	KonoeGtkItem	item;
	item.set_gtk_widget( child );
	cout << " = " << item.getLabel( ) << endl;
	return 0;
}

void	GtkDemo::processEvent( KonoeGtkObject * pwidget,
		KonoeGtkEventDescriptor * eventd ) {

	KInt	ix, iy;

	cout << "Event type = " << eventd -> getType( ) << endl;

	switch( eventd -> getType( ) ) {
	case BUTTON_PRESS :
		ix = eventd -> getX( );
		iy = eventd -> getY( );
		canvas -> drawLine( ix - 5, iy, ix + 5, iy );
		canvas -> drawLine( ix, iy - 5, ix, iy + 5 );
		cout << "X = " << eventd -> getX( )
			<< " Y = " << eventd -> getY( ) << endl;
		break;
	default :
		break;
	}
}

int	main( int argc, char ** argv ) {

	GtkDemo	demo( argc, argv );
	return demo.go( );

}
