/********************\
  KonoeGtkText.cc

  composed by nishida
  $Id: KonoeGtkText.cc,v 1.1 2002/03/16 09:16:05 iwai Exp $

\********************/

#include <stdio.h>
#include "KonoeGtkText.hh"

KonoeGtkText::KonoeGtkText() {
  widget = gtk_text_new( NULL, NULL );
  v_adjustment = new KonoeGtkAdjustment( GTK_TEXT(widget)->vadj );
  h_adjustment = new KonoeGtkAdjustment( GTK_TEXT(widget)->hadj );
}

void KonoeGtkText::setPoint( guint index ) {
  gtk_text_set_point( GTK_TEXT(widget), index );
}

guint KonoeGtkText::getPoint() {
  return gtk_text_get_point( GTK_TEXT(widget) );
}

guint KonoeGtkText::getLength() {
  return gtk_text_get_length( GTK_TEXT(widget) );
}

void KonoeGtkText::insert( GdkFont *font, GdkColor *fore, GdkColor *back,
			const char *text, gint length ) {
  insert( text, font, fore, back, length );
}

void KonoeGtkText::insert( const char *text, GdkFont *font, GdkColor *fore,
			GdkColor *back, gint length ) {
  gtk_text_insert( GTK_TEXT(widget), font, fore, back, text, length );
}

void KonoeGtkText::freeze() {
  gtk_text_freeze( GTK_TEXT(widget) );
}

void KonoeGtkText::thaw() {
  gtk_text_thaw( GTK_TEXT(widget) );
}

char KonoeGtkText::getCharAt( guint index ) {
  return GTK_TEXT_INDEX( GTK_TEXT(widget), index );
}

gint KonoeGtkText::backwardDelete( guint nchars ) {
  return gtk_text_backward_delete( GTK_TEXT(widget), nchars );
}

gint KonoeGtkText::forwardDelete( guint nchars ) {
  return gtk_text_forward_delete( GTK_TEXT(widget), nchars );
}

void KonoeGtkText::clear() {
  setPoint( 0 );
  forwardDelete( getLength() );
}

void KonoeGtkText::setText( const char *text, GdkFont *font, GdkColor *fore,
			 GdkColor *back, gint length ) {
  clear();
  insert( text, font, fore, back, length );
}
