/********************\
  KonoeGtkWidget.cc

  composed by nishida
  $Id: KonoeGtkWidget.cc,v 1.1 2002/03/16 09:16:07 iwai Exp $

\********************/

#include "KonoeGtkWidget.hh"

KonoeGtkWidget::~KonoeGtkWidget() { gtk_widget_destroy( widget ); }

void KonoeGtkWidget::setName( const gchar *name ) {
  gtk_widget_set_name( widget, name );
}

gchar *KonoeGtkWidget::getName() { return gtk_widget_get_name(widget); }
void KonoeGtkWidget::show() { gtk_widget_show(widget); }
void KonoeGtkWidget::showNow() { gtk_widget_show_now(widget); }
void KonoeGtkWidget::showAll() { gtk_widget_show_all(widget); }
void KonoeGtkWidget::hide() { gtk_widget_hide(widget); }
gboolean KonoeGtkWidget::isVisible() { return GTK_WIDGET_VISIBLE(widget); }

void KonoeGtkWidget::setSensitive( gboolean sensitive ) {
  gtk_widget_set_sensitive( widget, sensitive );
}

void KonoeGtkWidget::setUsize( gint width, gint height ) {
  gtk_widget_set_usize( widget, width, height );
}

guint KonoeGtkWidget::signalConnect( KonoeGtkSignal *signal ) {
  signal->setSource( this );
  return gtk_signal_connect( GTK_OBJECT(widget), signal->getName(),
	     GTK_SIGNAL_FUNC(KonoeGtkSignal::callback), (gpointer) signal );
}

guint KonoeGtkWidget::signalConnect( KonoeGtkEventSignal *signal ) {
  signal->setSource( this );
  return gtk_signal_connect( GTK_OBJECT(widget), signal->getName(),
	     GTK_SIGNAL_FUNC(KonoeGtkEventSignal::callback), (gpointer)signal );
}

guint KonoeGtkWidget::signalConnect( const gchar *name,
	void (*func)( GtkWidget *widget, gpointer p ), KonoeGtkWidget *w ) {
  return gtk_signal_connect( GTK_OBJECT(widget), name,
			     GTK_SIGNAL_FUNC(func), (gpointer)w );
}
