/********************\
  demo.cc

  composed by nishida
  $Id: demo.1.cc,v 1.1 2002/03/16 09:16:09 iwai Exp $

\********************/

#include <stdio.h>

#include "KonoeGtkSignalClient.hh"
#include "KonoeGtkButton.hh"
#include "KonoeGtkWindow.hh"

class Demo : public KonoeGtkSignalClient {
  KonoeGtkWindow *window;
  KonoeGtkButton *button;
public:
  Demo(int argc, char *argv[]);
  ~Demo() {}
  int go();
  void action( KonoeGtkSignal *s );
  void action( KonoeGtkEventSignal *s, GdkEvent *event );
};

Demo::Demo(int argc, char *argv[]) {
  gtk_init(&argc, &argv);

  window = new KonoeGtkWindow( GTK_WINDOW_TOPLEVEL );
  window->signalConnect( new KonoeGtkEventSignal("delete_event",this,NULL) );
  button = new KonoeGtkButton( "Hello" );
  button->signalConnect( new KonoeGtkSignal("clicked",this,NULL) );
  window->add(button);
  button->show();
  window->show();
}

int Demo::go(){
  gtk_main();
  return 0;
}

void Demo::action( KonoeGtkSignal *s ) {
  KonoeGtkButton * b = (KonoeGtkButton *) s->getSource();
  if( b == button ) puts( b->getLabel() );
}

void Demo::action( KonoeGtkEventSignal *s, GdkEvent *event ) {
  puts( "quit" );
  gtk_main_quit();
  return;
}

int main(int argc, char *argv[]) {
  Demo demo(argc, argv);
  demo.go();
}
