/********************\
  demo.cc

  composed by nishida
  $Id: demo.2.cc,v 1.1 2002/03/16 09:16:09 iwai Exp $

\********************/

#include <stdio.h>

#include "KonoeGtkSignalClient.hh"
#include "KonoeGtkButton.hh"
#include "KonoeGtkWindow.hh"
#include "KonoeGtkTable.hh"
#include "KonoeGtkLabel.hh"

class Demo : public KonoeGtkSignalClient {
  KonoeGtkWindow *window;
  KonoeGtkTable *table;
  KonoeGtkButton *button;
  KonoeGtkLabel **label;
public:
  Demo(int argc, char *argv[]);
  ~Demo() {}
  int go();
  void action( KonoeGtkSignal *s );
  void action( KonoeGtkEventSignal *s, GdkEvent *event );
};

Demo::Demo(int argc, char *argv[]) {
  gtk_set_locale();
  gtk_init(&argc, &argv);
  gtk_rc_parse("./gtkrc");

  // make window
  window = new KonoeGtkWindow( GTK_WINDOW_TOPLEVEL );
  window->signalConnect( new KonoeGtkEventSignal("delete_event",this,NULL) );
  window->signalConnect( new KonoeGtkSignal("destroy",this,NULL) );
  // make table
  table = new KonoeGtkTable( 2, 3, TRUE );
  table->show();
  window->add( table );
  // make button
  button = new KonoeGtkButton( "Update" );
  button->setName( "update" );
  button->signalConnect( new KonoeGtkSignal("clicked",this,NULL) );
  button->show();
  table->attach( button, 0, 3, 0, 1 );
  // make label
  label = new KonoeGtkLabel*[3];
  for( int j=0; j<3; j++ ) {
    char cs[8];
    label[j] = new KonoeGtkLabel( "0" );
    sprintf( cs, "label%d", j+1 );
    label[j]->setName( cs );
    table->attach( label[j], j, j+1, 1, 2 );
    label[j]->show();
  }
  window->show();
}

int Demo::go(){
  gtk_main();
  return 0;
}

void Demo::action( KonoeGtkSignal *s ) {
  static int cnt = 0;
  char cs[8];
  if( s->getSource() == window && strcmp(s->getName(),"destroy")==0 ) {
    gtk_main_quit();
    return;
  }
  /*  KonoeGtkButton * b = (KonoeGtkButton *) s->getSource();
      if( b == button ) puts( b->getLabel() ); */
  for( int j=0; j<3; j++ ) {
    sprintf( cs, "%02d", cnt++ );
    label[j]->setName( cs );
    label[j]->setText(cs);
  }
}

void Demo::action( KonoeGtkEventSignal *s, GdkEvent *event ) {
  puts( "quit" );
  gtk_main_quit();
  return;
}

int main(int argc, char *argv[]) {
  Demo demo(argc, argv);
  demo.go();
}
