/********************\
  demo.cc

  composed by nishida
  $Id: demo.cc,v 1.1 2002/03/16 09:16:09 iwai Exp $

\********************/

#include <stdio.h>
#include	<string.h>

#include "KonoeGtk.hh"

class Demo : public KonoeGtkSignalClient, KonoeGtkMainHandler {
  KonoeGtkWindow *window;
  KonoeGtkTable *table;
  KonoeGtkButton *button;
  KonoeGtkLabel **label;
  KonoeGtkMenu *menu;
  KonoeGtkOptionMenu *choice;
  KonoeGtkMenuItem *mi1, *mi2;
public:
  Demo(int argc, char *argv[]);
  ~Demo() {}
  int go();
  void timerAction();
  void action( KonoeGtkSignal *s );
  void action( KonoeGtkEventSignal *s, GdkEvent *event );
};

Demo::Demo(int argc, char *argv[]) {
  gtk_set_locale();
  gtk_init(&argc, &argv);
  gtk_rc_parse("./gtkrc");

  KonoeGtkMain::timeoutAdd( 1500, this );

  // make window
  window = new KonoeGtkWindow( GTK_WINDOW_TOPLEVEL );
  window->signalConnect( new KonoeGtkEventSignal("delete_event",this,NULL) );
  window->signalConnect( new KonoeGtkSignal("destroy",this,NULL) );
  // make table
  table = new KonoeGtkTable( 3, 3, TRUE );
  table->show();
  window->add( table );
  // make button
  button = new KonoeGtkButton( "Update" );
  button->setName( "blue" );
  button->signalConnect( new KonoeGtkSignal("clicked",this,NULL) );
  button->show();
  table->attach( button, 0, 3, 0, 1 );
  // make label
  label = new KonoeGtkLabel*[3];
  for( int j=0; j<3; j++ ) {
    char cs[8];
    label[j] = new KonoeGtkLabel( "0" );
    sprintf( cs, "label%d", j+1 );
    label[j]->setName( cs );
    table->attach( label[j], j, j+1, 1, 2 );
    label[j]->show();
  }
  // make menu
  menu = new KonoeGtkMenu();
  menu->append( mi1 = new KonoeGtkMenuItem( "first" ) );
  menu->append( mi2 = new KonoeGtkMenuItem( "second" ) );
  menu->show();
  menu->signalConnect( new KonoeGtkSignal("selection-done",this,NULL) );
  choice = new KonoeGtkOptionMenu();
  choice->setMenu( menu );
  choice->show();
  table->attach( choice, 0, 3, 2, 3 );
  window->show();
}

int Demo::go(){
  gtk_main();
  return 0;
}

void Demo::timerAction( ) {
  static int cnt = 0;
  if( cnt%2==0 ) {
    button->setName( "blue" );
    button->getLabel()->setName( "blue" );
  } else {
    button->setName( "red" );
    button->getLabel()->setName( "red" );
  }
  //  printf( "%d\n", cnt );
  cnt ++;
}

void Demo::action( KonoeGtkSignal *s ) {
  static int cnt = 0;
  char cs[8];
  if( s->getSource() == window && strcmp(s->getName(),"destroy")==0 ) {
    gtk_main_quit();
    return;
  }
  if( s->getSource() == button ) {
    for( int j=0; j<3; j++ ) {
      sprintf( cs, "%02d", cnt++ );
      label[j]->setName( cs );
      label[j]->setText(cs);
    }
    return;
  }
  if( s->getSource() == menu ) {
    GtkWidget *w = menu->getActiveWidget();
    if( w == mi1->getWidget() ) puts( "1st" );
    else if( w == mi2->getWidget() ) puts( "2nd" );
  }

}

void Demo::action( KonoeGtkEventSignal *s, GdkEvent *event ) {
  puts( "quit" );
  gtk_main_quit();
  return;
}

int main(int argc, char *argv[]) {
  Demo demo(argc, argv);
  demo.go();
}
