//=============================================================
/*

	Konoe1DHistogram.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	04-Aug-1998	S. Inaba
        Version 0.6.0   01-Feb-2000     T.Hosoi
        Version 0.6.1   02-Dec-2000     A.Izumoto 
*/
//=============================================================

package	konoe.ui.analysis;

//
//	1 Dimension Histogram
//

import java.lang.*;
import java.io.*;
import konoe.ui.system.*;

public class Konoe1DHistogram implements KonoeStreamableObject,
							KonoeObject, Serializable{

  public static final String className = "Konoe1DHistogram";

  protected KonoeDataScale scale;
  protected KonoeHistogramStorage storage;
  private String histName = null;
  private int max = 0;

  public Konoe1DHistogram( KonoeDataScale pscale ){

    scale = pscale;
    storage = new KonoeHistogramStorage( scale.getBinCount() ); 

  }

  public Konoe1DHistogram() {

    scale = null;
    storage = null;
  
  }
  
  public int getBinCount () {

    return scale.getBinCount();

  }

  public int getMax(){

    for(int i=0;i<getBinCount();i++){
      if(max<getOne(i)){
        max = (int)getOne(i);
      }
    }
    return max;

  }

  public void clear() {

    if( storage != null )
        storage.clear();
    //else.... should be implemented.

  }

  public void dump() {

    System.out.println ( "1D Histogram " );
    scale.dump();
    storage.dump();

  }

  public int fill( KonoeFillData fill_data ) {

    storage.addOne( scale.getBinIndex( fill_data.getX() ) );
    return 0;

  }

  public double getOne( int pindex ) {

    return storage.get ( pindex ); 

  }

  public KonoeDataScale getScale() {

    return scale;

  }

  public void setName(String name){

    histName = name;

  }

  public String  getName(){

    return histName;

  }

//  to create me from stremable object

public void read( KonoeInputObjectStream in, KonoeStreamHeader header )
	throws IOException {
        int i = header.getMemberID();
        int h = header.getCategoryID();
	switch( i ){
                case 0:
		  scale = ( KonoeDataScale )(in.readObject( header ));
                  break;
		case 1: storage = (KonoeHistogramStorage )
				(in.readObject( header ));
		break;
                  
		}
}

public void write( KonoeOutputObjectStream out )throws IOException {
	}

}

