//=================================================
/*
	Konoe1DHistogramList.java

	Version 0.6.0 12-Nob  A.Izumoto
*/
//=================================================
package konoe.ui.analysis;

import java.io.*;
import konoe.ui.system.*;
import konoe.ui.analysis.*;

public class Konoe1DHistogramList implements KonoeStreamableObject , KonoeObject {

  public static final String className = "Konoe1DHistogramList";
  private KonoeList histograms = new KonoeList(0);

  public Konoe1DHistogramList(){

  }

  public Konoe1DHistogramList(int ptableSize){

  }

  public void dump(){
  
    Konoe1DHistogram hist = new Konoe1DHistogram();

    System.out.println("Konoe1DHistogramList");
    System.out.println("entries:" + histograms.getCount());
    histograms.reset();
    while((hist =(Konoe1DHistogram)histograms.next()) != null){
      hist.dump();
    }

  }

  public Konoe1DHistogram[] getHist(){
    
    Konoe1DHistogram[] hist = new Konoe1DHistogram[histograms.getCount()];
    histograms.reset();
    for(int i=0;i<histograms.getCount();i++){
      hist[i] = (Konoe1DHistogram)histograms.next();
    }
    return hist;

  }

  public int getHistCount(){

    return histograms.getCount();
 
  }

  public Konoe1DHistogram get(int index){

    return (Konoe1DHistogram)histograms.get(index);

  }

  public Konoe1DHistogram next(){
    return (Konoe1DHistogram)histograms.next();
  }

  public void setEntries(Object[] array){

    histograms.setEntries(array);

  }

  public void reset(){

    histograms.reset();

  }

  public void read( KonoeInputObjectStream in, KonoeStreamHeader header ) throws IOException {

    int i = header.getMemberID();
    switch (i) {
      case 0: 
        int j = in.readInt();
        histograms.allocate(j); 
        break;
      case 1: 
        Object[] array = in.readObjectArray(header);
        histograms.setEntries(array);
        break;
    }

  }

  public void write( KonoeOutputObjectStream out )throws IOException {
	
  }

}
