//=============================================================
/*

        KonoeBoxGeometry.java

        Version 0.0.1   03-Aug-1998     D. Takagi
        Version 0.4.0   18-Aug-1998     D. Takagi
        Version 0.5.0   28-Sep-1999     T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//=============================================================
package konoe.ui.analysis;

import konoe.ui.system.*;
import java.io.*;

public class KonoeBoxGeometry extends KonoeGeometry {
    protected double width;
    protected double height;
    protected double depth;
    protected Konoe3Vector waxis;
    protected Konoe3Vector haxis;
    protected Konoe3Vector daxis;
    protected Konoe3Vector displacement;
    
    public double getWidth() { return width; }
    public double getHeight() { return height; }
    public double getDepth() { return depth; }
    public Konoe3Vector getDisplacement() { return displacement; }

    public String toString() {
	return "KonoeBoxGeometry:"  + "\n" +
	       "width  = " + width  + "\n" +
	       "height = " + height + "\n" +
               "depth  = " + depth  + "\n";
    }

    public void dump() {
	System.out.println(toString());
	waxis.dump();
	haxis.dump();
	daxis.dump();
	displacement.dump();
    }	

    public void read(KonoeInputObjectStream in, KonoeStreamHeader header) throws IOException {
	switch (header.getMemberID()) {
	  case 0: width  = in.readDouble(); break;
	  case 1: height = in.readDouble(); break;
	  case 2: depth  = in.readDouble(); break;
	  case 3: waxis = (Konoe3Vector)(in.readObject(header)); break;
	  case 4: haxis = (Konoe3Vector)(in.readObject(header)); break;
	  case 5: daxis = (Konoe3Vector)(in.readObject(header)); break;
	  case 6: displacement = (Konoe3Vector)(in.readObject(header)); break;
        }
    }

    public void write(KonoeOutputObjectStream out) throws IOException {
    }
}
