//=============================================================
/*

        KonoeDataAddress.java

        Version 0.0.1   03-Aug-1998     D. Takagi
        Version 0.4.0   18-Aug-1998     D. Takagi
        Version 0.5.0   28-Sep-1999     T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================
package konoe.ui.analysis;

import konoe.ui.system.*;
import java.io.*;

public class KonoeDataAddress implements KonoeStreamableObject, KonoeObject {

    protected int address_type;
    protected int section_id;
    protected int segment_id;
    protected int subaddress;
    protected int bit_offset;

    public KonoeDataAddress() {}
    public KonoeDataAddress(int sectionID, int segmentID, int subAddress) {
	section_id = sectionID;
	segment_id = segmentID;
	subaddress = subAddress;
    }

    int getSectionID() { return section_id; }
    int getSegmentID() { return segment_id; }
    int getSubaddress() { return subaddress; }

    // -- dump ---
    public String toString() {
	return "address_type = " + address_type + "\n" +
	       "section_id   = " + section_id   + "\n" +
	       "segment_id   = " + segment_id   + "\n" +	 
               "subaddress   = " + subaddress   + "\n" +
               "bit_offset   = " + bit_offset   + "\n";
    }

    public void dump() {
	System.out.println(toString());
    }

    // --- for Streamable ---
    public void read(KonoeInputObjectStream in, KonoeStreamHeader header) throws IOException {
	switch (header.getMemberID()) {
	  case 0: 
	    address_type = in.readInt(); 
	    break;

          case 1: 
	    section_id   = in.readInt(); 
	    break;

	  case 2: 
	    segment_id   = in.readInt(); 
	    break;

	  case 3: 
	    subaddress   = in.readInt(); 
	    break;

	  case 4: 
	    bit_offset   = in.readInt(); 
	    break;
        }
    }

    public void write(KonoeOutputObjectStream out) throws IOException {
/*
        out.writeHeader(
	out.write(0, address_type);
	...
*/
    }
}
