//=============================================================
/*

        KonoeDetector.java

        Version 0.1.1   03-Aug-1998     D. Takagi
        Version 0.4.0   18-Aug-1998     D. Takagi
        Version 0.5.0   28-Sep-1999     T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================
package konoe.ui.analysis;

import konoe.ui.system.*;
import java.io.*;

public class KonoeDetector implements KonoeStreamableObject, KonoeObject {
    protected int identifier;
    protected KonoeList elements = new KonoeList(0);

    public int getID() { return identifier; }
    
    public int getCount() { return elements.getCount(); }
    public KonoeDetectorElement get(int id) { 
	return (KonoeDetectorElement)elements.get(id); 
    }

    public String toString() {
	return "KonoeDetector:" + "\n" +
	       "identifier = " + "\n";
    }

    public void dump() {
	System.out.println(toString());
	System.out.println(elements.toString());
    }

    public void read(KonoeInputObjectStream in, KonoeStreamHeader header) throws IOException {
	switch (header.getMemberID()) {
	  case 0: 
	    identifier = in.readInt(); 
	    break;

	  case 1: 
	    elements.allocate(in.readInt()); 
	    break;

	  case 2: 
	    Object[] array = in.readObjectArray(header);
	    elements.setEntries(array);
	    
	    for (int i = 0; i < elements.getCount(); i++) {
		((KonoeDetectorElement)elements.get(i)).setDetector(this);
	    }
	    break;	  
        }
    }

    public void write(KonoeOutputObjectStream out) throws IOException {
    }
}
