//=============================================================
/*

        KonoeDetectorList.java

        Version 0.0.1   03-Aug-1998     D. Takagi
        Version 0.4.0   18-Aug-1998     D. Takagi
        Version 0.5.0   28-Sep-1999     T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================
package konoe.ui.analysis;

import konoe.ui.system.*;
import java.io.*;

public class KonoeDetectorList implements KonoeStreamableObject, KonoeObject {
    protected KonoeList detectors = new KonoeList(0);

    public int getCount() { return detectors.getCount(); }
    public KonoeDetector get(int id) { 
	return (KonoeDetector)detectors.get(id); 
    }

    public String toString() {
	return "KonoeDetectorList:" + "\n";
    }
	       
    public void dump() {
	System.out.println(toString());
	System.out.println(detectors.toString());
    }

    public void read(KonoeInputObjectStream in, KonoeStreamHeader header) throws IOException {
	switch (header.getMemberID()) {
	  case 0: 
	    detectors.allocate(in.readInt()); 
	    break;
	  case 1: 
	    Object[] array = in.readObjectArray(header);
	    detectors.setEntries(array);
	    break;
        }
    }

    public void write(KonoeOutputObjectStream out) throws IOException {
    }
}
