//===================================================================
/*

	KonoeArgumentDescriptor.java

	Version 0.0.1	03-Jul-1998	H. Sakamoto
	Version 0.0.2	17-Aug-1998	S. Nishida
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//===================================================================

package	konoe.ui.command;

import	java.io.*;

public class KonoeArgumentDescriptor {

  public static final int INTEGER = 0;
  public static final int FLOATING = 1;
  public static final int STRING = 2;
  public static final int KEYWORD = 3;

  public static final int OPTIONAL = 0;
  public static final int NECESSARY = 1;

  String	name;
  String	description;
  int		type;
  int		appearance;

  public KonoeArgumentDescriptor( String name, int type, int appearance ) {

    this.name = name;
    this.type = type;
    this.appearance = appearance;

  }

  public String getName( ) {

    return name;

  }

  public int getType( ) {

    return type;

  }

  public int getAppearance( ) {

    return appearance;

  }

  public void setDescription( String description ) {

    this.description = description;

  }

  public void printHelp( PrintWriter writer ) {

	writer.print( name + " : " + description );
	switch( type ) {
	case INTEGER :
	  writer.print( "  (Integer)" );
	  break;
	case FLOATING :
	  writer.print( "  (Floating)" );
	  break;
	case STRING :
	  writer.print( "  (String)" );
	  break;
	case KEYWORD :
	  writer.print( "  (Keyword)" );
	  break;
	}
	if( appearance == OPTIONAL )
	  writer.print( "  [ optional ]" );
	writer.println( );
  }

  public boolean isNecessary( ) {

    return appearance == NECESSARY;
  }

}
