//====================================================================
/*

	KonoeCommand.java

	Version 0.0.1	 6-Jul-1998	H. Sakamoto
	Version 0.0.2	17-Jul-1998	S. Nishida
	Version 0.4.0	29-Sep-1998	S. Nishida
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//====================================================================

package	konoe.ui.command;

import	java.util.*;
import	java.io.*;
import	konoe.ui.command.*;
import	konoe.ui.system.*;

public class KonoeCommand {

  public static final int MAX_ARGUMENTS = 256;

  KonoeList	argumentlist;  // members must be KonoeCommandArgument
  String	objectname;
  String	processname;
  String	hostname;
  String	methodname;

  public KonoeCommand( ) {

    argumentlist = new KonoeList( MAX_ARGUMENTS );
  }

  public int	getArgumentCount( ) {

    return argumentlist.getCount( );
  }

  public void	addArgument( KonoeCommandArgument argument ) {

    argumentlist.add( argument );
  }

  public KonoeCommandArgument	getArgument( int i ) {

    return ( KonoeCommandArgument ) argumentlist.get( i );
  }

  public String getMethodName( ) {

    return methodname;
  }

  public void setMethodName( String methodname ) {

    this.methodname = methodname;

  }

  public String getObjectName( ) {

    return objectname;

  }

  public void setObjectName( String objectname ) {

    this.objectname = objectname;

  }

  public String getProcessName( ) {

    return processname;

  }

  public void setProcessName( String processname ) {

    this.processname = processname;
  }

  public String getHostName( ) {

    return hostname;
  }

  public void setHostName( String hostname ) {

    this.hostname = hostname;
  }

  public void dump( PrintWriter writer ) {

    int	argumentcount = argumentlist.getCount( );
    KonoeCommandArgument	arg;

    writer.print( "Method = " + methodname );
    if( objectname != null )
      writer.print( "  Object = " + objectname );
    if( processname != null )
      writer.print( "  Process = " + processname );
    if( hostname != null )
      writer.print( "  Host = " + hostname );
    writer.println( );
    argumentlist.reset( );
    for( int i = 0; i < argumentcount; i ++ ) {
      writer.print( "Argument " + i + " = " );
      ( ( KonoeCommandArgument ) argumentlist.next( ) ).dump( writer );
    }
  }
 

}

