//====================================================================
/*

	KonoeCommandArgument.java

	Version 0.0.1	06-Jul-1998	H. Sakamoto
	Version 0.0.2	17-Aug-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//====================================================================

package	konoe.ui.command;

import	java.io.*;

public class KonoeCommandArgument {

  public static final int POSITIONAL = 0;
  public static final int ASSIGNMENT = 1;
  public static final int PLUS_KEYWORD = 2;
  public static final int MINUS_KEYWORD = 3;

  public static final int INTEGER = 0;
  public static final int FLOATING = 1;
  public static final int STRING = 2;
  public static final int QUOTED_STARING = 3;

  String	name;
  String	value;
  int		appearance;
  int		type;
  int		position;

  public KonoeCommandArgument( String name, String value ) {

    this.name = name;
    this.value = value;
    appearance = ASSIGNMENT;
  }

  public KonoeCommandArgument( int position, String value ) {

    this.position = position;
    this.value = value;
    appearance = POSITIONAL;
  }

  public KonoeCommandArgument( String name, int appearance ) {

    this.name = name;
    this.appearance = appearance;
  }

  public String	getName( ) {

    return name;
  }

  public String	getValue( ) {

    return value;
  }

  public int getAppearance( ) {

    return appearance;
  }

  public int getType( ) {

    return type;
  }

  public void dump( PrintWriter writer ) {

    switch( appearance ) {
    case POSITIONAL :
      writer.print( "Positional at " + position + " : Value = " + value );
      break;
    case ASSIGNMENT :
      writer.print( "Assignment " + name + " = " + value );
      break;
    case PLUS_KEYWORD :
      writer.print( "Keyword +" + name );
      break;
    case MINUS_KEYWORD :
      writer.print( "Keyword -" + name );
      break;
    }
    writer.println( );
  }

  public boolean checkInteger( ) {

    return true; //dummy
  }

  public int toInteger( ) {

    return ( Integer.valueOf( value ) ).intValue( );
  }

  public boolean checkFloating( ) {

    return true; //dummy
  }

  public double toFloating( ) {

    return ( Double.valueOf( value ) ).doubleValue( );
  }

}

