//===================================================================
/*

	KonoeCommandDescriptor.java

	Version 0.0.1	 3-Jul-1998	H. Sakamoto
	Version 0.0.2	17-Aug-1998	S. Nishida
	Version 0.4.0	29-Sep-1998	S. Nishida
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//==================================================================

package	konoe.ui.command;

import	java.util.*;
import	java.io.*;
import	konoe.ui.command.*;
import	konoe.ui.system.*;

public class KonoeCommandDescriptor {

  String	name;
  KonoeList	argumentlist;
  int		identifier;
  String	description;

  public KonoeCommandDescriptor( String name, int tablesize ) {

    this.name = name;
    argumentlist = new KonoeList( tablesize );
    //this.identifier = identifier;

  }

  public void add( KonoeArgumentDescriptor argument ) {

    argumentlist.add( argument );
  }

  public String getName( ) { return name; }
  //  public int getID( ) { return identifier; }

  public void setDescription( String description ) {

    this.description = description;
  }

  public void printHelp( PrintWriter writer, boolean flag ) {

    writer.println( name + "  :  " + description );
    if( flag ) {
      KonoeArgumentDescriptor	argd;
      writer.println(  "    Arguments available ..." );
      argumentlist.reset( );
      while( ( argd = (KonoeArgumentDescriptor)argumentlist.next( ) )!= null ){
	writer.print( "\t" );
	argd.printHelp( writer );
      }
    }
  }

  public int getArgumentCount( ) {

        return argumentlist.getCount( );
  }

  public KonoeArgumentDescriptor getArgument( int index ) {

        return (KonoeArgumentDescriptor) argumentlist.get( index );
  }

}
