//===================================================================
/*

	KonoeOfficer.java

	Version 0.0.1	 2-Jul-1998	H. Sakamoto
	Version 0.0.2	15-Aug-1998	S. Nishida
	Version 0.4.0	29-Sep-1998	S. Nishida
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//===================================================================

package konoe.ui.command;

import java.io.*;
import java.util.*;
import konoe.ui.command.*;
import konoe.ui.system.*;

abstract public class KonoeOfficer extends KonoeOrderly {

  public KonoeList orderlylist;  // KonoeOrderly
  protected KonoeList registeredorderly;
  Object commander;

  public KonoeOfficer( int ptablesize, int ncommands, String name,
                int nclasses )  {

    super( ncommands, name );
    orderlylist = new KonoeList( ptablesize );
    registeredorderly = new KonoeList( nclasses );
  }

  public int registerOrderly( KonoeOrderly orderly ) {

    orderly.setOfficer( this );
    return registeredorderly.add( orderly );
  }

  public int addOrderly( KonoeOrderly orderly ) {

    orderly.setOfficer( this );
    return orderlylist.add( orderly );
  }

  public KonoeOrderly findObject( String name ) {

    KonoeOrderly target;
    orderlylist.reset( );
    while( ( target = (KonoeOrderly) orderlylist.next( ) ) != null )
      if( name.equals( target.getObjectName( ) ) ) return target;
    return null;
  }

  public void printObjectList( PrintWriter writer ) {

    KonoeOrderly object;
    orderlylist.reset( );
    while( ( object = (KonoeOrderly) orderlylist.next( ) ) != null )
      writer.println( "\t" + object.getObjectName( ) );
  }

  public KonoeOrderly hasClass( String classnm ) {

    KonoeOrderly object;
    registeredorderly.reset( );
    while( ( object = (KonoeOrderly) registeredorderly.next( ) ) != null )
       if( classnm.equals( object.getClassName( ) ) ) return object;
    return null;
  }

  public int addObject( KonoeOrderly orderly, String name, KonoeCommand cmd ) {

    KonoeOrderly neworderly;
    neworderly = orderly.clone( name );
    if( neworderly == null ) {
      System.out.println("Error in cloning. No orderly generated");
      return -1;
    }
    neworderly.createObject( cmd );
    return orderlylist.add( neworderly );
  }

  public void printClassList( PrintWriter writer ) {

    KonoeOrderly object;
    registeredorderly.reset( );
    while( ( object = (KonoeOrderly) registeredorderly.next( ) ) != null )
      writer.println( "\t" + object.getClassName( ) );
  }

  public void setCommander( Object pcommander ) {
    commander = pcommander;
  }
  public Object getCommander( ) { return commander; }
}
