//=========================================================
/*
        Konoe2DrawCanvas.java

        Version 0.0.1   03-Jul-1998     K.Ohta
        Version 0.4.0   18-Jul-1998     D. Takagi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package konoe.ui.graphics;

/**
        a simple Canvas for drawing data

*/

import  java.awt.*;
import  konoe.ui.analysis.*;

public class Konoe2DrawCanvas extends Canvas {

    public final String className = "2D Draw Filed";

    Konoe2DHistogram histogram;
    KonoeDimension dim;
    int drawObjTotalx;
    int drawObjTotaly;
    String myName;
    KonoeScale xScale;
    KonoeScale yScale;
    KonoeDataScale yDataScale;
    KonoePhysPlacement[] myPhys;
    KonoePhysPlacement myXLine;
    KonoePhysPlacement myYLine;
    KonoePhysPlacement myZLine;
    int barwidthx;
    int barwidthy;
    double magnification;
    double magnificationX;
    double magnificationY;
    KonoeSpaceManager spMan;
	Color line;
	int lr=0;
	int lg=255;
	int lb=0;
	int gr=100;
	int gg=100;
	int gb=100;
	

public void init() {

   }

  public Konoe2DrawCanvas () {
  }

  public Konoe2DrawCanvas
         ( Konoe2DHistogram pHisto, KonoeDimension dimension, 
                                                    String pName) {
   dim = dimension;
   histogram = pHisto;
   myName = pName;
   drawObjTotalx =  histogram.getBinCountx();
   drawObjTotaly =  histogram.getBinCounty();
   myPhys = new KonoePhysPlacement[drawObjTotalx*drawObjTotaly +1];
   barwidthx = dimension.getHeight()/pHisto.getBinCountx();
   barwidthy = dimension.getWidth()/pHisto.getBinCounty();
   setVerticalScale(  new KonoeLinearDataScale(0.0F,100.0F,100) );
   createDrawParts();

  }

    
  public Konoe2DrawCanvas
         ( Konoe2DHistogram pHisto, KonoeDimension dimension, 
                                    String pName, KonoeDataScale pScale) {
   dim = dimension;
   histogram = pHisto;
   myName = pName;
   spMan = new KonoeSpaceManager();
   drawObjTotalx =  histogram.getBinCountx();
   drawObjTotaly =  histogram.getBinCounty();
   myPhys = new KonoePhysPlacement[drawObjTotalx*drawObjTotaly +1];
   barwidthx = dimension.getHeight()/pHisto.getBinCountx();
   barwidthy = dimension.getWidth()/pHisto.getBinCounty();
   setVerticalScale( pScale );
   myXLine = new KonoePhysPlacement();
   myYLine = new KonoePhysPlacement();
   myZLine = new KonoePhysPlacement();

   createDrawParts();

  }

  public void setSpaceManager( KonoeSpaceManager pSpace ) {

    spMan = pSpace;
    createDrawParts();

  }

  public void paint ( Graphics g ) {

    for(int a=drawObjTotalx*drawObjTotaly; a >=1; a--)
    myPhys[a].draw(g);
    setBackground ( Color.black );

    drawScale( g );
  }

public void drawScale ( Graphics g ) {

    KonoeRotationMatrix rm = new KonoeRotationMatrix( );
    KonoeDrawableHorizonLine aLine1 = 
                    new KonoeDrawableHorizonLine( "aHorizonLine", histogram.getYscale()*magnificationX/2 );
    KonoeDrawableXLine aLine2 =
                    new KonoeDrawableXLine( "aXLine", histogram.getXscale()*magnificationY/2);
    KonoeDrawableVerticalLine  aLine3 =
                    new KonoeDrawableVerticalLine( "aVerticalLine", yDataScale.getMaximum()*magnification/2 );
    Konoe3DVector aVector1 =
                    new Konoe3DVector ( histogram.getYscale()*magnificationX/2-(double)barwidthy/2, 0, -(double)barwidthx/2  ); 
    Konoe3DVector aVector2 =
                    new Konoe3DVector ( -(double)barwidthy/2, 0, histogram.getXscale()*magnificationY/2-(double)barwidthy/2);
    Konoe3DVector aVector3 =
                    new Konoe3DVector ( -(double)barwidthx/2, yDataScale.getMaximum()*magnification/2, -(double)barwidthy/2 );
    myXLine =
           new KonoePhysPlacement ( new KonoeTransform ( rm, aVector1), aLine1, spMan );
    myYLine =
           new KonoePhysPlacement ( new KonoeTransform ( rm, aVector2), aLine2, spMan);
   myZLine =
           new KonoePhysPlacement ( new KonoeTransform ( rm, aVector3), aLine3, spMan);
    myXLine.replace ( new Konoe2Dimension ( ) );
        myXLine.setVisAtt( lr, lg, lb );
    myYLine.replace ( new Konoe2Dimension ( ) );
        myYLine.setVisAtt( lr, lg, lb );
    myZLine.replace ( new Konoe2Dimension ( ) );
        myZLine.setVisAtt( lr, lg, lb );
    
    myXLine.draw(g);
    myYLine.draw(g);
    myZLine.draw(g); 
    Dimension nowDim;
    nowDim =  spMan.reLocation ( new Konoe3DVector
                        ( 0 ,0, 0 ) );
    g.drawString("0", nowDim.width-barwidthy ,nowDim.height+barwidthx);

    nowDim =  spMan.reLocation ( new Konoe3DVector
                        ( histogram.getYscale()*magnificationX ,0, 0 ) );
    String XMaxValueStr;
    XMaxValueStr =( new Double (histogram.getYscale()) ). toString() ;
    g.drawString(XMaxValueStr, nowDim.width-barwidthy ,nowDim.height+barwidthx);

    nowDim =  spMan.reLocation ( new Konoe3DVector
                        ( 0 , 0, histogram.getXscale()*magnificationY ) );
    String YMaxValueStr;
    YMaxValueStr =( new Double (histogram.getXscale()) ). toString() ;
    g.drawString(YMaxValueStr, nowDim.width-barwidthy ,nowDim.height+barwidthx);

    nowDim =  spMan.reLocation ( new Konoe3DVector
                        ( 0 , yDataScale.getMaximum()*magnification, 1 ) );
    String ZMaxValueStr;
    ZMaxValueStr =( new Double (yDataScale.getMaximum()) ). toString() ;
    g.drawString(ZMaxValueStr, nowDim.width-barwidthy ,nowDim.height+barwidthx);
    
 //  draw scale 

    for ( int i  = 1; i <= 4; i ++){
    Konoe3DVector  xGuideVec4 =
         new Konoe3DVector ( -(double)barwidthx/2, 
                            0,
                        -(double)barwidthy/2+histogram.getXscale()*1/4*i*magnificationY );
    KonoeDrawableVerticalLine  xGuideLine4 =
                    new KonoeDrawableVerticalLine( "x GuideLine4", 3);
    KonoePhysPlacement xGuideLinePhys4 =
           new KonoePhysPlacement ( new KonoeTransform ( rm, xGuideVec4), xGuideLine4, spMan);
    xGuideLinePhys4.replace ( new Konoe2Dimension ( ) );
    xGuideLinePhys4.setVisAtt( lr, lg, lb );
    xGuideLinePhys4.draw(g); 
  }   
    for ( int i  = 1; i <= 4; i ++){
    Konoe3DVector  yGuideVec5 =
         new Konoe3DVector ( -(double)barwidthx/2+histogram.getXscale()*1/4*i*magnificationX,
                            0,
                        -(double)barwidthy/2 );
    KonoeDrawableVerticalLine  yGuideLine5 =
                    new KonoeDrawableVerticalLine( "y GuideLine5", 3);
    KonoePhysPlacement yGuideLinePhys5 =
           new KonoePhysPlacement ( new KonoeTransform ( rm, yGuideVec5), yGuideLine5, spMan);
    yGuideLinePhys5.replace ( new Konoe2Dimension ( ) );
    yGuideLinePhys5.setVisAtt( lr, lg, lb );
    yGuideLinePhys5.draw(g); 
  }
     for ( int i  = 1; i <= 4; i ++){
    Konoe3DVector  zyGuideVec6 =
         new Konoe3DVector ( -(double)barwidthy/2, yDataScale.getMaximum()*1/4*i*magnification, -(double)barwidthx/2  );
    KonoeDrawableHorizonLine  zyGuideLine6 =
                    new KonoeDrawableHorizonLine( "zy GuideLine6", 3);
    KonoeDrawableXLine  zxGuideLine6 =
                    new KonoeDrawableXLine( "zx GuideLine6", 3);
    KonoePhysPlacement zyGuideLinePhys6 =
           new KonoePhysPlacement ( new KonoeTransform ( rm, zyGuideVec6), zyGuideLine6, spMan);
    KonoePhysPlacement zxGuideLinePhys6 =
           new KonoePhysPlacement ( new KonoeTransform ( rm, zyGuideVec6), zxGuideLine6, spMan);
    zyGuideLinePhys6.replace ( new Konoe2Dimension ( ) );
    zyGuideLinePhys6.setVisAtt( lr, lg, lb );
    zyGuideLinePhys6.draw(g);
/*
    zxGuideLinePhys6.replace ( new Konoe2Dimension ( ) );
    zxGuideLinePhys6.setVisAtt( 0, 255, 0 );
    zxGuideLinePhys6.draw(g);
  */
  }
    
  }


  public void setVerticalScale ( KonoeDataScale pScale ) {

   yDataScale = pScale;
   magnification = (double)dim.getHeight()/pScale.getMaximum();
   magnificationX = (double)dim.getHeight()/histogram.getYscale();
   magnificationY = (double)dim.getWidth()/histogram.getXscale();
   System.out.println(magnification + " " + magnificationX + " " + magnificationY);
  }

  public void createDrawParts() {
    
    KonoeRotationMatrix rm = new KonoeRotationMatrix( );
    int c = 1;
    for(int i = 0; i < drawObjTotalx; i++){
        for(int j = 0; j < drawObjTotaly ; j++){
    KonoeDrawableBox aBox = new KonoeDrawableBox ( "aBox", barwidthx/2, histogram.getOne(i,j)*magnification/2 , barwidthy/2);
    Konoe3DVector aVector4 = new Konoe3DVector (i*barwidthx, histogram.getOne(i,j)*magnification/2, j*barwidthy);
    myPhys[c] =
           new KonoePhysPlacement ( new KonoeTransform ( rm, aVector4), aBox, spMan);
     myPhys[c].replace ( new Konoe2Dimension ( ) );
//
     int RR = (int)(  255*histogram.getOne(i,j)/yDataScale.getMaximum() ); 
//
	int GR = gr+RR;
	int GG = gg+RR;
	int GB = gb+RR;
     if ( GR >= 255 ) GR = 255;
     if ( GR <= 0   ) GR = 0;
	if(GG>=255)GG=255;
	if(GG<=0)GG=0;
	if(GB>=255)GB=255;
	if(GB<=0)GB=0;
  //   int BB = 255-RR;
     myPhys[c].setVisAtt ( GR, GG, GB  );


     c = c + 1;
      }
     }
   }

	public void setline(int[] c){
		for(int i=0;i<3;i++){
			System.out.println(String.valueOf(c[i]));
			}

		lr=c[0];
		lg=c[1];
		lb=c[2];
  }
	
	public void setgraph(int[] c){
		gr=c[0];
		gg=c[1];
		gb=c[2];
	}
}
