//=============================================================
/*

        KonoeDrawPanel.java

        Version 0.0.1   03-Jul-1998     K.Ohta
        Version 0.4.0   18-Aug-1998     K.Ohta
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//=============================================================

package konoe.ui.graphics;

/**


*/

import java.awt.*;
import java.awt.event.*;

public class Konoe2DrawPanel extends Panel implements MouseListener,MouseMotionListener
{
        private Konoe2DrawCanvas world;
        private KonoeSpaceManager spMan;

	private Image    backBuff;
	private Graphics backGC;
	private boolean changed;

	private int prevx;
	private int prevy;
        

	public Konoe2DrawPanel( Konoe2DrawCanvas world, String titleName ) {
		this.world = world;
		changed = true;
                spMan = new KonoeSpaceManager();
                world.setSpaceManager( spMan );
                setBackground( new Color( 0, 0, 0 ));
                addMouseListener(this);
                addMouseMotionListener(this);
                
	}

	public void paint(Graphics g) {
		if ( backBuff == null ) {
			backBuff = createImage( getSize().width, getSize().height );
			backGC = backBuff.getGraphics();
		}
		if ( changed == true ) {
			backGC.clearRect(0, 0, getSize().width, getSize().height);
			world.paint(backGC);
			changed = false;
		}
		g.drawImage( backBuff, 0, 0, this );
	}

	public void update() {
		changed = true;
		repaint();
	}

	public void update( Graphics g ) {
		paint( g );
	}
	
	public void mouseEntered( MouseEvent me ) {
		prevx = me.getX();
		prevy = me.getY();
		
	}

	public void mouseDragged( MouseEvent me ) {
                double rx = (Math.PI * ( prevy - me.getY() ) / 360);
                double ry = (Math.PI * ( prevx - me.getX() ) / 360);

                spMan.setViewLotation( ry );
                spMan.setViewAngle( rx );

		world.setSpaceManager( spMan );

          System.out.println( "rx = " + (int)rx +  "    ry = " +  (int)ry );
		update();

		prevx = me.getX();
		prevy = me.getY();
	
	}

        public void setBagcolor(int[] c){
                this.setBackground(new Color(c[0], c[1], c[2]));
                update();
        }

	public void setline(int[] c){
		System.out.println("RRR");
		world.setline(c);
		world.setSpaceManager( spMan );
		update();
	}

	public void setgraph(int[] c){
		world.setgraph(c);
		world.setSpaceManager(spMan);
		update();
	}
	
	public void mouseMoved(MouseEvent me){}
	public void mouseClicked(MouseEvent me){}
	public void mouseExited(MouseEvent me){}
	public void mousePressed(MouseEvent me){}
	public void mouseReleased(MouseEvent me){}
	
        

        public KonoeSpaceManager getSpaceManager() {
               
                return spMan;
        }
}

