//=============================================================
/*

    KonoeColorControl.java

        Version 0.6.0   01-Feb-2000     M. Okamura

*/
//=============================================================

package konoe.ui.graphics;

import java.lang.*; 
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;


public class KonoeColorControl extends Panel implements AdjustmentListener
{

	
	String		s;
	Panel		pnl,pr,pg,pb;
	Scrollbar	Redbar,Greenbar,Bluebar;
	TextField	RedTF,GreenTF,BlueTF;
	Color           bgColor;
	int[]           color;

			
	public KonoeColorControl() 
	{
		int initialValue = 125;

                color=new int[3];
	        color[0]=125;
	        color[1]=125;
	        color[2]=125;

  		setLayout(new BorderLayout());

		pnl = new Panel();
		pnl.setLayout(new GridLayout(3,1));
	
		add(pnl);

		pr = new Panel();
		pg = new Panel();
		pb = new Panel();

            Redbar = new Scrollbar(Scrollbar.HORIZONTAL,initialValue,1,0,255);
            Redbar.addAdjustmentListener(this);

            Greenbar = new Scrollbar(Scrollbar.HORIZONTAL,initialValue,1,0,255);
            Greenbar.addAdjustmentListener(this);

            Bluebar = new Scrollbar(Scrollbar.HORIZONTAL,initialValue,1,0,255); 
            Bluebar.addAdjustmentListener(this);
		
		pr.setLayout(new BorderLayout());
		pr.add( "West"  , new Label(" field R:" , Label.LEFT));
		pr.add( "Center", Redbar ); 
		pr.add( "East"  , RedTF  = new TextField(
                 String.valueOf(initialValue)+" ("+
                 toHexString(initialValue)+") "));
		
		pg.setLayout(new BorderLayout());
		pg.add( "West" , new Label(" field G:" , Label.LEFT));
		pg.add( "Center", Greenbar ); 
		pg.add( "East"  , GreenTF  = new TextField(
                 String.valueOf(initialValue)+" ("+
                 toHexString(initialValue)+") "));
		
		pb.setLayout(new BorderLayout());
		pb.add( "West" , new Label(" field B:" , Label.LEFT));
		pb.add( "Center", Bluebar );  
		pb.add( "East"  , BlueTF  = new TextField(
                 String.valueOf(initialValue)+" ("+
                 toHexString(initialValue)+") "));
		
		pnl.add(pr);
		pnl.add(pg);
		pnl.add(pb);
		
		bgColor = new Color( initialValue, initialValue, initialValue );

	     setBackground( bgColor );
	}

	String toHexString( int val )
	{
	    String s1="0";
	    String s2="0";
	    int i1;
	    int i2;
	    
	    i1 = val / 16;
	    i2 = val % 16;
	    if( i1 < 10 ) { s1 = String.valueOf( i1 ); }
	    if( i1 == 10 ) { s1 = "A"; }
	    if( i1 == 11 ) { s1 = "B"; }
	    if( i1 == 12 ) { s1 = "C"; }
	    if( i1 == 13 ) { s1 = "D"; }
	    if( i1 == 14 ) { s1 = "E"; }
	    if( i1 == 15 ) { s1 = "F"; }
	    if( i2 < 10 ) { s2 = String.valueOf( i2 ); }
	    if( i2 == 10 ) { s2 = "A"; }
	    if( i2 == 11 ) { s2 = "B"; }
	    if( i2 == 12 ) { s2 = "C"; }
	    if( i2 == 13 ) { s2 = "D"; }
	    if( i2 == 14 ) { s2 = "E"; }
	    if( i2 == 15 ) { s2 = "F"; }
	    return s1+s2;
	}
	
	
	public void adjustmentValueChanged(AdjustmentEvent ae) 
        {
		bgColor = 
		  new Color(Redbar.getValue(),Greenbar.getValue(),Bluebar.getValue());
		  color[0]=Redbar.getValue();
		  color[1]=Greenbar.getValue();
		  color[2]=Bluebar.getValue();

		RedTF.setText(
                 String.valueOf(Redbar.getValue())+" ("+
                 toHexString(Redbar.getValue())+") ");
		GreenTF.setText(
                 String.valueOf(Greenbar.getValue())+" ("+
                 toHexString(Greenbar.getValue())+") ");
		BlueTF.setText(
                 String.valueOf(Bluebar.getValue())+" ("+
                 toHexString(Bluebar.getValue())+") ");
	    setBackground( bgColor );

           repaint();
      }
	
      public int[] getcolor(){
		return color;
      }


}
