//=============================================================
/*

	KonoeDrawCanvas.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	18-Jul-1998	D. Takagi
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package	konoe.ui.graphics;

/**
	a simple Canvas for drawing data

*/

import	java.awt.*;
import java.awt.event.*;
import	konoe.ui.analysis.*;

//import analysis.*;

public class KonoeDrawCanvas extends Canvas {

    public final String className = "Draw Filed";

    Konoe1DHistogram histogram;
    KonoeDimension dim;
    KonoeDrawableRect[] drawRect;
    int drawObjTotal;
    String myName;
    KonoeScale xScale;
    KonoeScale yScale;
    KonoeDataScale yDataScale;
    Image offImage;
    Graphics offScreen;
    Dimension offDimension;


  public KonoeDrawCanvas () {
  }

  public KonoeDrawCanvas
         ( Konoe1DHistogram pHisto, KonoeDimension dimension, String pName) {

   dim = dimension;
   histogram = pHisto;
   myName = pName;

   drawObjTotal = histogram.getBinCount();

   drawRect = new KonoeDrawableRect[drawObjTotal];

   for ( int i = 0; i < drawObjTotal; i++) {
    drawRect[i] = new KonoeDrawableRect();
   }
   
//   createDrawParts();

  }

  public KonoeDrawCanvas
         ( Konoe1DHistogram pHisto, KonoeDimension dimension,
           String pName, KonoeDataScale pScale ) {

   dim = dimension;
   histogram = pHisto;
   myName = pName;

   drawObjTotal = histogram.getBinCount();
  
   drawRect = new KonoeDrawableRect[drawObjTotal];

   yDataScale =  pScale;

   for ( int i = 0; i < drawObjTotal; i++) {
    drawRect[i] = new KonoeDrawableRect();
   }
   
   createDrawParts();

  }


  public void setDimension( KonoeDimension dimension ) {

   dim = dimension;

  }

  public void setDataSource ( Konoe1DHistogram pHisto ) {

    histogram = pHisto;

    drawObjTotal = histogram.getBinCount();

    if ( drawRect != null )  {
      drawRect = null;
    }
    drawRect = new KonoeDrawableRect[drawObjTotal];
      for ( int i = 0; i < drawObjTotal; i++) {
      drawRect[i] = new KonoeDrawableRect();
    }

   createDrawParts();

  }

  public void paint ( Graphics g ) {
/*
     Dimension d = getSize();
     if((offScreen == null) || (d.width != offDimension.width) ||
        (d.height != offDimension.height)){
          offDimension = d;
          offImage=createImage(d.width , d.height);
          offScreen = offImage.getGraphics();
     }
*/
     offScreen = g;
     offScreen.drawRect( dim.getOrigX(),dim.getOrigY(),
                 dim.getWidth(),dim.getHeight() );
     offScreen.setFont(new Font("Helvetica",Font.PLAIN,10));
     offScreen.drawString( myName, dim.getWidth()/2 + dim.getOrigX(),
                           dim.getHeight()  + dim.getOrigY() + 30  );

     for ( int i = 0; i < drawObjTotal; i++ ) {
     drawRect[i].drawMe( offScreen );
     }

     xScale.drawMe( offScreen );
     yScale.drawMe( offScreen );
//     g.drawImage(offImage,0,0,this);
  }

  public void update(Graphics g){
     paint(g);
  }

  public void update(){
    paint(this.getGraphics());
  }

  public void setVerticalScale ( KonoeDataScale pScale ) {

    yDataScale = pScale;
    createDrawParts();

  }

  public void setVerticalScale(){

    double max = 0.0;
    for(int i=0;i<drawObjTotal;i++){
      if(max < histogram.getOne(i)){
        max = histogram.getOne(i);
      }
    }
    int pmax = (int)(max/10);
    pmax++;
    pmax *= 10;
//    System.out.println(pmax);
    yDataScale = new KonoeLinearDataScale(0.0,(double)pmax,pmax);
    createDrawParts();

  }

  public KonoeDataScale getVerticalScale(){

    return yDataScale;

  }
  public void createDrawParts() {

   xScale = new KonoeScale(histogram.getScale(), dim);
// KonoeDataScale yDataScale = new  KonoeLinearDataScale(0.0F,200.0F,100);
   yScale = new KonoeScaleVertical(yDataScale, dim);

   for ( int i = 0; i < drawObjTotal; i++ ) {
     drawRect[i].setInfo( yScale.getCoordinate(histogram.getOne(i)));
     drawRect[i].setPlacement( dim.getOrigX()+i*dim.getWidth()/drawObjTotal,
                               dim.getHeight() + dim.getOrigY(),
                               dim.getWidth()/drawObjTotal);
   }

  }
}
