//=============================================================
/*

	KonoeDrawavleBox.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
        Version 0.4.0   18-Aug-1998     K.Ohta
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//=============================================================

package	konoe.ui.graphics;

/**


*/

import java.awt.*;
import java.lang.Math.*;
 

public class KonoeDrawableBox extends KonoeSolid {

    public final String className = "KonoeBox";
    public double fDx = 0;
    public double fDy = 0;
    public double fDz = 0;
    public String myName;

    public double myOrigX = 0;
    public double myOrigY = 0;
    public double myOrigZ = 0;

    public double nowAngle = 30;
    public double nowRotation = 60;

    private boolean wireFrame = false;
    private boolean surf2 = true;

    private KonoeSpaceManager spMan;

    private int  setThin = 0;
  
  public KonoeDrawableBox () {

  }

  public KonoeDrawableBox (String pStr, double pDx, double pDy, double pDz ) {

    spMan = new KonoeSpaceManager();
    fDx = pDx;
    fDy = pDy;
    fDz = pDz;

    myName = pStr;

  }

  public void setSpaceManager( KonoeSpaceManager pManage ) {

     spMan = pManage;

  }

  public void setThinGap( ) {
  
    if ( setThin == 0 ) {
    fDx -= 1;
    fDy -= 1;
    setThin = 1;
    }

  }
 
    

  public void realDrawReplace  ( Konoe2Dimension  myView ) {

    nowAngle = myView.getAngle();  
    nowRotation  = myView.getRotation();  

  }

  public void dump ( ) {

    System.out.println ( "Name = " + myName + 
                         "  W =  " + fDx  +
                         "  H =  " + fDy +
                         "  D =  " + fDz );

  }

  public void setWire () {

    wireFrame = true;

  }
 
  public void setSurf2() {

    surf2  = false;

  }

  public void draw ( KonoeTransform myTrans, Graphics g , int RR, int GG, int BB) {


    if ( wireFrame ) 
    {

    myOrigX = myTrans.getX();  
    myOrigY = myTrans.getY();  
    myOrigZ = myTrans.getZ();  


     int[] PolygonArayX = new int[4];
     int[] PolygonArayY = new int[4];

     g.setColor ( new Color( RR, GG, BB) );
     Dimension nowDim;

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[2] =  nowDim.width;
     PolygonArayY[2] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[3] =  nowDim.width;
     PolygonArayY[3] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 4);

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ + fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY - fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[2] =  nowDim.width;
     PolygonArayY[2] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[3] =  nowDim.width;
     PolygonArayY[3] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 4);

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 2);

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX + fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY - fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 2);

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 2);

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 2);

     }
  }


  public void draw2 ( KonoeTransform myTrans, Graphics g, int RR, int GG, int BB ) {


    if ( !wireFrame ) 

    {

    myOrigX = myTrans.getX();  
    myOrigY = myTrans.getY();  
    myOrigZ = myTrans.getZ();  

     int[] PolygonArayX = new int[4];
     int[] PolygonArayY = new int[4];

     Dimension nowDim;

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[2] =  nowDim.width;
     PolygonArayY[2] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[3] =  nowDim.width;
     PolygonArayY[3] =  nowDim.height;
     
     g.setColor ( new Color(RR*3/5, GG*3/5, BB*3/5 ) );
     g.fillPolygon (PolygonArayX, PolygonArayY, 4);
     g.setColor ( new Color(0, 0, 0 ) );
     if ( surf2 ) { 
     g.drawPolygon (PolygonArayX, PolygonArayY, 4);
     }

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[2] =  nowDim.width;
     PolygonArayY[2] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[3] =  nowDim.width;
     PolygonArayY[3] =  nowDim.height;
     
     g.setColor ( new Color(RR, GG, BB ) );
     g.fillPolygon (PolygonArayX, PolygonArayY, 4);

     if ( surf2 ) { 
     g.setColor ( new Color(0, 0, 0 ) );
     g.drawPolygon (PolygonArayX, PolygonArayY, 4);
     }

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ - fDz ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ - fDz ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY + fDy, myOrigZ + fDz ) );
     PolygonArayX[2] =  nowDim.width;
     PolygonArayY[2] =  nowDim.height;
     
     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX - fDx, myOrigY - fDy, myOrigZ + fDz ) );
     PolygonArayX[3] =  nowDim.width;
     PolygonArayY[3] =  nowDim.height;
     
     g.setColor ( new Color(RR*4/5, GG*4/5, BB*4/5 ) );
     g.fillPolygon (PolygonArayX, PolygonArayY, 4);
     if ( surf2 ) { 
     g.setColor ( new Color(0, 0, 0 ) );
     g.drawPolygon (PolygonArayX, PolygonArayY, 4);
     }


     }

  }

}
