//=============================================================
/*

	KonoeDrawavleLine.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
        Version 0.4.0   18-Aug-1998     K.Ohta
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//=============================================================

package	konoe.ui.graphics;

/**


*/

import java.awt.*;
import java.lang.Math.*;
 

public class KonoeDrawableLine extends KonoeSolid {

    public final String className = "KonoeDrawableLine";
    public double fDx = 0;
    public String myName;

    public double myOrigX = 0;
    public double myOrigY = 0;
    public double myOrigZ = 0;

    public double nowAngle = 30;
    public double nowRotation = 60;

    private boolean wireFrame = false;
    private boolean surf2 = true;

  public KonoeDrawableLine () {

  }

  public KonoeDrawableLine (String pStr, double pD ) {

    fDx = pD;

    myName = pStr;

  }

  public void realDrawReplace  ( Konoe2Dimension  myView ) {

    nowAngle = myView.getAngle();  
    nowRotation  = myView.getRotation();  

  }

  public void dump ( ) {

    System.out.println ( "Name = " + myName + 
                         "  Length  =  " + fDx );

  }

  public void setWire () {

    wireFrame = true;

  }
 
  public void setSurf2() {

    surf2  = false;

  }

  public void draw ( KonoeTransform myTrans, Graphics g , int RR, int GG, int BB) {


    myOrigX = myTrans.getX();  
    myOrigY = myTrans.getY();  
    myOrigZ = myTrans.getZ();  

    KonoeSpaceManager spMan = new KonoeSpaceManager();

     int[] PolygonArayX = new int[2];
     int[] PolygonArayY = new int[2];

     g.setColor ( new Color( RR, GG, BB) );
     Dimension nowDim;

     nowDim =  spMan.reLocation ( new Konoe3DVector 
                        ( myOrigX - fDx, myOrigY, myOrigZ) );
     PolygonArayX[0] =  nowDim.width;
     PolygonArayY[0] =  nowDim.height;

     nowDim =  spMan.reLocation  ( new Konoe3DVector
                        ( myOrigX + fDx, myOrigY, myOrigZ ) );
     PolygonArayX[1] =  nowDim.width;
     PolygonArayY[1] =  nowDim.height;
     
     g.drawPolygon( PolygonArayX, PolygonArayY, 1);
  }


  public void draw2 ( KonoeTransform myTrans, Graphics g, int RR, int GG, int BB ) {

  }

  public void setThinGap(){

  }

}
