//====================================================
/*

	KonoeEventViewCanvas.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	18-Aug-1998	D. Takagi
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package	konoe.ui.graphics;

/**
	a simple Canvas for Event Display

*/

import	java.awt.*;

public class KonoeEventViewCanvas extends Canvas {
    
    Image offscreen;

    public final String className = "KonoeEventViewCanvas";

    KonoePhysPlacement[] myPhysicalVolume;
    int totalOfPhys = 0;
    KonoeDimension dim;
    String myName;

  public KonoeEventViewCanvas () {
  }

  public KonoeEventViewCanvas
         ( KonoeDimension dimension, String pName) {

   dim = dimension;
   myName = pName;

  }

  public KonoeEventViewCanvas
         ( KonoeDimension dimension, String pName, int pTotal ) {

   dim = dimension;
   myName = pName;
   
   totalOfPhys = pTotal;

   myPhysicalVolume = new KonoePhysPlacement[ totalOfPhys ]; 

  }

  public void setTotalOfPhys ( int pTotal ) {

    totalOfPhys = pTotal; 

    myPhysicalVolume = null;

    myPhysicalVolume = new KonoePhysPlacement[ totalOfPhys ];

  }

  public void setPhysicalVolume ( KonoePhysPlacement[] pPhys,
                                  int startID, int endID ) {

    int copyNo = 0;
    for ( int i = startID; i < endID; i++ ) {

    myPhysicalVolume[i] = pPhys [ copyNo ];
    copyNo++;

    }

  }
  
  public void locateGenerator ( ) {

    KonoePhysPlacement tmpPhys;

    for ( int i = 0; i < totalOfPhys - 1; i++ ) {
       for ( int j = i + 1; j < totalOfPhys; j++) {
          if ( myPhysicalVolume[i].distanceToEye <=
                              myPhysicalVolume[j].distanceToEye ) {
             tmpPhys = myPhysicalVolume[i];
             myPhysicalVolume[i] = myPhysicalVolume[j];
             myPhysicalVolume[j] = tmpPhys; 
          }

       }

    }


  }

  public void setDimension( KonoeDimension dimension ) {

   dim = dimension;

  }

  public void paint ( Graphics g ) {

       locateGenerator();

      if (offscreen == null) {
	  offscreen = createImage(getSize().width, getSize().height);
      }

      Graphics gg = offscreen.getGraphics();

      gg.setColor ( Color.black );
      gg.fillRect( dim.getOrigX(),dim.getOrigY(),
		  dim.getWidth(),dim.getHeight() );
      gg.setFont(new Font("Helvetica",Font.PLAIN,18));
      gg.drawString( myName, dim.getWidth()/2 + dim.getOrigX()/2,
		    dim.getHeight()  + dim.getOrigY() + 30  );


      for ( int i = 0; i < totalOfPhys; i++ ) {

	  myPhysicalVolume[i].draw( gg );
	  
      }

      g.drawImage(offscreen, 0, 0, this);
  }

  public void update(Graphics g) {
      paint(g);
  }
}
