//=============================================================
/*

	KonoePhysPlacement.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	18-Aug-1998	D. Takagi
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package	konoe.ui.graphics;

/**


*/

import java.awt.*;

public class KonoePhysPlacement {

  public final String className = "KonoePhysPlacement";

  private KonoeTransform myTrans;
  private KonoeSolid mySolid;
  private KonoePhysPlacement myPlace;

  private int RR = 0;
  private int GG = 0;
  private int BB = 255;

  public double distanceToEye;


  public KonoePhysPlacement ( ) {

  }

  public KonoePhysPlacement ( KonoeTransform trans, KonoeSolid solid ) {

    mySolid = solid;
    myTrans = trans;

    distanceToEye = myTrans.distanceToPoint( new Konoe3DVector ( 0, 0, 0 ) ); 

  }

  public KonoePhysPlacement ( KonoeTransform trans, KonoeSolid solid, 
                                                  KonoeSpaceManager pMan ) {

    mySolid = solid;
    myTrans = trans;
    mySolid.setSpaceManager( pMan );

    distanceToEye = myTrans.distanceToPoint( new Konoe3DVector ( 0, 0, 0 ) ); 

  }

  public void setForceWireFrame ( ) {

    mySolid.setWire();

  }

  public void setSurf2Mode ( ) {

    mySolid.setSurf2();

  }

  public void setThinGap ( ) {

    mySolid.setThinGap();

  }


  public void setVisAtt ( int aa, int bb, int cc ) {

    RR = aa;
    GG = bb;
    BB = cc;

  }

  public void replace ( Konoe2Dimension nowView ) {

    mySolid.realDrawReplace( nowView );


  }

  public void dump () {

   mySolid.dump();
   myTrans.dump();

  }

  public void draw ( Graphics g ) {

   mySolid.draw2( myTrans, g, RR, GG, BB );
   mySolid.draw( myTrans, g, RR, GG, BB );

  }

}
