//=============================================================
/*

	KonoeScale.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	18-Aug-1998	D. Takagi
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package	konoe.ui.graphics;

/**
	 a simple scale which has point.

*/

import java.awt.*;
import konoe.ui.analysis.*;

public class KonoeScale {

    double posiFrom = 0.0F;
    double posiTo = 100.0F;
    int markTotal;
    KonoeDimension dim;
    int markWidth;
    int bigMarkWidth;

  public KonoeScale () {

    markTotal = 20;
    dim = null;
    markWidth = 5;
    bigMarkWidth = 10;

  }

  public KonoeScale (KonoeDataScale pScale, KonoeDimension pDim ) {

    posiFrom = pScale.getMinimum();
    posiTo = pScale.getMaximum();
    markTotal = 20;
    dim = pDim;
    markWidth = 5;
    bigMarkWidth = 10;

  }

  public void setDimension ( KonoeDimension pDim ) {

    dim = pDim;

  }

  public void placement(){
  } 

  public int getCoordinate( double value ) {

    int i ;

    i = (int)(( value - posiFrom )
                *(double)(dim.getHeight())/( posiTo - posiFrom));
    return i;

  }

    
  public void drawMe ( Graphics g ) {

//    for ( int i = 1; i < (int)(posiTo-posiFrom)/5; i++) {
/*
      for ( int i = 1; i < 10; i++) {
    g.drawLine( dim.getOrigX()+i*dim.getWidth()/10,
                dim.getHeight()+dim.getOrigY()-markWidth,
                dim.getOrigX()+i*dim.getWidth()/10,
                dim.getHeight()+dim.getOrigY() );
    }
*/
    for ( int i = 0; i <= 2; i++) {
      int nowValue = dim.getOrigX()+i*dim.getWidth()/2;
      int nowLavel = i*(int)(posiTo-posiFrom)/2;
      g.drawLine( nowValue,dim.getHeight()+dim.getOrigY()-bigMarkWidth,
                  nowValue,dim.getHeight()+dim.getOrigY() );
      g.setFont(new Font("Helvetica",Font.PLAIN,10) ); 
      g.drawString( Integer.toString(nowLavel),
                    nowValue  - 10,dim.getHeight()+dim.getOrigY() + 15 );
    }

  }

}
