//=============================================================
/*

        KonoeSpaceManager.java

        Version 0.4.0   18-Aug-1998     K.Ohta
	    Version 0.5.0	28-Sep-1999		T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//=============================================================

package konoe.ui.graphics;

import java.lang.Math.*;
import java.awt.*;

public class KonoeSpaceManager {

	double viewLotation = 30;
	double viewAngle   = 20;
	int originXX = 350;
        int originYY = 400;
        int axisLengthReal = 800;
	int centerPositionX = axisLengthReal/2;
	int centerPositionY = axisLengthReal/2;
	int centerEyeX = 100;
	int centerEyeY = 300;

	int offsetX, offsetY;

	int reTargetX = 0;
	int reTargetY = 0;

public KonoeSpaceManager ( )  {

	viewLotation = viewLotation * Math.PI / 540.0;
	viewAngle    = viewAngle    * Math.PI / 540.0;

        offsetScale();

}

public void setViewLotation( double diff ) {

        viewLotation = viewLotation + diff;
        if ( viewLotation > 1.57 ) viewLotation = 1.57;
        if ( viewLotation <  0 ) viewLotation = 0;
        System.out.println( "Lotation = " + viewLotation );
}

public void setViewAngle( double diff ) {

        viewAngle = viewAngle + diff;
        if ( viewAngle > 1.57 ) viewAngle = 1.57;
        if ( viewAngle <  0 ) viewAngle =  0;
        System.out.println( " viewAngle = " +  viewAngle );

}

public Dimension reLocation( Konoe3DVector pVec ) {
 
	double targetX = ( double )pVec.mZ;
	double targetY = ( double )pVec.mX;
	double targetZ = ( double )pVec.mY;

	double X, Y, X1, Y1, X2, Y2;
	double originX, originY, axisLength;

	originX = (double)originXX;
	originY = (double)originYY;
	axisLength = (double)axisLengthReal;

	X1 = originX + axisLength - (originX + axisLength*Math.cos(viewLotation));
	Y1 = originY - (originY - axisLength*Math.sin(viewLotation)*Math.sin(viewAngle));
	X2 = originX - (originX - axisLength*Math.sin(viewLotation));
	Y2 = (originY - axisLength*Math.cos(viewLotation)*Math.sin(viewAngle)) - (originY - axisLength);

	double replaceRateX = X1*(targetX/axisLength);
	double replaceRateY = Y1*(targetX/axisLength);

	double replaceRateX2 = X2*(targetY/axisLength);
	double replaceRateY2 = Y2*(targetY/axisLength);

	double drawableX = (targetX + originX) - replaceRateX - replaceRateX2;
	double drawableY = (originY - targetY) - replaceRateY + replaceRateY2;
	double tmpTargetZ = targetZ*Math.cos(viewAngle);

	reTargetX = (int)(Math.round(drawableX));
	reTargetY = (int)(Math.round(drawableY));
	if( pVec.mZ != 0 )  reTargetY = (int)(Math.round((drawableY - tmpTargetZ)));

        Dimension target = new Dimension ( reTargetX - offsetX ,
                                           reTargetY - offsetY );

        return target;
}

public void offsetScale() {
 
	reLocation( new Konoe3DVector (centerPositionX, centerPositionY, 0) );
	offsetX = reTargetX - centerEyeX;
	offsetY = reTargetY - centerEyeY;
}


}  // end of class
