//=============================================================
/*

	KonoeTransform.java
	
	Version 0.0.1	03-Jul-1998	K.Ohta
	Version 0.4.0	18-Aug-1998	D. Takagi
	Version 0.5.0	28-Sep-1999	T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================

package	konoe.ui.graphics;

/**


*/


public class KonoeTransform {

  public final String className = "KonoeTransform3D";

  protected double myRoteX, myRoteY, myRoteZ;
  protected double myPosiX, myPosiY, myPosiZ;

  public KonoeTransform () {

  }


  public KonoeTransform ( KonoeRotationMatrix pRote, Konoe3DVector pVec ) {

    myRoteX = pRote.getRX();
    myRoteY = pRote.getRY();
    myRoteZ = pRote.getRZ();

    myPosiX = pVec.mX;
    myPosiY = pVec.mY;
    myPosiZ = pVec.mZ;

  }

  public double getX() { return myPosiX; }
  public double getY() { return myPosiY; }
  public double getZ() { return myPosiZ; }

  public double getRX() { return myRoteX; }
  public double getRY() { return myRoteY; }
  public double getRZ() { return myRoteZ; }

  public void dump() {
  
    System.out.println ( "Rotation = " + 
                          myRoteX + " " + myRoteY + " " + myRoteZ );
    System.out.println ( "Position = " + 
                          myPosiX + " " + myPosiY + " " + myPosiZ );

  }

  public double distanceToPoint ( Konoe3DVector pVec ) {

    double distance = (myPosiX - pVec.mX)*(myPosiX - pVec.mX) +
                     (myPosiY - pVec.mY)*(myPosiY - pVec.mY) +
                     (myPosiZ - pVec.mZ)*(myPosiZ - pVec.mZ)*
                     (myPosiZ - pVec.mZ)*(myPosiZ - pVec.mZ)*
                     (myPosiZ - pVec.mZ)*(myPosiZ - pVec.mZ);
    return distance;

     
  }
}
