//=======================================================
/*

	KonoeKonoeTrendCanvas.java

	Version 0.0.1	19-Jun-1998	H. Sakamoto
        Version 0.4.0   18-Aug-1998     K.Ohta
    Version 0.5.0   28-Sep-1999 T. Hosoi
*/
//=======================================================

package	konoe.ui.trend;

/**

	Describes a canvas on which a trend graph is
	drawn.

 */

import	java.awt.*;
import	konoe.ui.trend.*;

public class KonoeTrendCanvas extends Canvas {

  int	xgridinterval;
  int	ygridinterval;
  KonoeTrendData	itemlist;
  Color [] colorlist;
  int	n_colors;
  
  public KonoeTrendCanvas( KonoeTrendData itemlist ) {
  
    xgridinterval = 10;
    ygridinterval = 10;
    this.itemlist = itemlist;
    n_colors = 7;
    colorlist = new Color[ n_colors ];
    colorlist[ 0 ] = Color.red;
    colorlist[ 1 ] = Color.green;
    colorlist[ 2 ] = Color.blue;
    colorlist[ 3 ] = Color.yellow;
    colorlist[ 4 ] = Color.magenta;
    colorlist[ 5 ] = Color.cyan;
    colorlist[ 6 ] = Color.white;
  }

  public void paint( Graphics g ) {
  
    int xe, ye, x, y;
    xe = getSize( ).width;
    ye = getSize( ).height;
    g.clearRect( 0, 0, xe, ye );
    x = 0;
    while( x < xe ) {
      g.drawLine( x, 0, x, ye - 1 );
      x += xgridinterval;
    }
    y = 0;
    while( y < ye ) {
      g.drawLine( 0, y, xe - 1, y );
      y += ygridinterval;
    }
    
    int n = itemlist.getItemCount( );
    int m = itemlist.getCurrentIndex( );
    KonoeTrendItem	item;
    int	pen;
    for( int i = 0; i < n; i ++ ) {
      item = itemlist.getItem( i );
      pen = item.getPenIndex( );
      if( pen >= 0 ) {
        g.setColor( getColor( pen ) );
        for( int j = 0; j <= m; j ++ )
          plot( item, g, i, j, ye );
      }
    }
  }
  
  public void update( Graphics g ) {
  
    int x, y, n, h;

    n = itemlist.getItemCount( );
    x = itemlist.getCurrentIndex( );
    h = getSize( ).height;
    KonoeTrendItem item;
    int pen;
    for( int i = 0; i < n; i ++ ) {
      item = itemlist.getItem( i );
      pen = item.getPenIndex( );
      if( pen >= 0 ) {
        g.setColor( getColor( pen ) );
        plot( item, g, i, x, h );
      }
    }
    
  }

  void plot( KonoeTrendItem item, Graphics g, int i, int x, int h ) {
  
    int ys, ye;
    ye = ( int )( ( double ) h
      * item.getFraction( x ) );
    if( x == 0 )
      ys = ye;
    else
      ys = ( int ) ( ( double ) h
        * item.getFraction( x - 1 ) );
    g.drawLine( x, h - 1 - ys, x, h - 1 - ye );
   
  }
  
  public Color getColor( int pen ) {
  
    return colorlist[ pen % n_colors ];

  }
  

}
