//==============================================================
/*

	KonoeKonoeTrendView.java
	
	Version 0.0.1	19-Jun-1998	H. Sakamoto
        Version 0.4.0   18-Aug-1998     K.Ohta
    Version 0.5.0   28-Sep-1999 T. Hosoi
*/
//==============================================================

package	konoe.ui.trend;

/**

	Trend data display including time information and
	scale data.

 */

import	java.applet.*;
import	java.awt.*;
import	java.util.*;
import	konoe.ui.trend.*;

public class KonoeTrendView extends Panel {

  ScrollPane	scrollpane;
  KonoeTrendCanvas	canvas;
  KonoeTrendData	itemlist;
  KonoeTrendItem	currentitem;
  Label		minimum;
  Label		maximum;
  Label		starttime;
  Label		presenttime;
  boolean	catchup;
  boolean	setup;
  
  int	canvaswidth;
  int	canvasheight;
  int	panewidth;
  int	paneheight;

// overrided methods

  public KonoeTrendView( int canvaswidth, int canvasheight,
    int panewidth, KonoeTrendData itemlist ) {
    
    super( null );	// no layout manager.

    this.canvaswidth = canvaswidth;
    this.canvasheight = canvasheight;
    this.panewidth = panewidth;
    paneheight = canvasheight + 19;  // 19 = scrollbar width
    this.itemlist = itemlist;

    scrollpane = new ScrollPane( );
    canvas = new KonoeTrendCanvas( itemlist );
    canvas.setSize( canvaswidth, canvasheight );
    scrollpane.setSize( panewidth, paneheight );
    scrollpane.add( canvas );

    Date now = new Date( );
    minimum = new Label( "0.0000" );
    maximum = new Label( "0.0000" );
    starttime = new Label( now.toString( ).substring( 0, 19 ) );
    presenttime = new Label( now.toString( ).substring( 0, 19 ) );
    add( minimum );
    add( maximum );
    add( starttime );
    add( presenttime );
    add( scrollpane );
    validate( );
    catchup = true;
    setup = true;
    currentitem = null;

  }
  
  void setupLayout( ) {
  
    int	x, y, w, h, ch, tw;
    Font	font = getFont( );
    FontMetrics	fontmetrics = getFontMetrics( font );
    
    x = fontmetrics.stringWidth( maximum.getText( ) ) + 5;
    ch = fontmetrics.getHeight( );
    maximum.setSize( x, ch );
    maximum.setLocation( 0, 0 );
    y = scrollpane.getSize( ).height;
    minimum.setSize( x, ch );
    minimum.setLocation( 0, y - ch );
    x += 5;
    scrollpane.setLocation( x, 0 );
    tw = fontmetrics.stringWidth( starttime.getText( ) ) + 5;
    starttime.setSize( tw, ch );
    starttime.setLocation( x, y );
    w = x + scrollpane.getSize( ).width;
    presenttime.setSize( tw, ch );
    presenttime.setLocation(
    	w - presenttime.getSize( ).width, y + ch );
    h = y + presenttime.getSize( ).height + ch + 10;
    setSize( w, h );
    
  }
  
  public KonoeTrendData getItemList( ) {
  
    return itemlist;
  }
  
  public void setCatchup( boolean flag ) {
  
    catchup = flag;
    
  }
  
  public void setCurrentItem( int index ) {
  
    currentitem = itemlist.getItem( index );
    
  }
  
  public KonoeTrendItem getCurrentItem( ) {
  
    return currentitem;
    
  }
  
  public void updateDisplay( ) {
  
    int	xv, xe, wv, xi, xs;
    boolean	f;
    
    if( setup ) {
      setupLayout( );
      setup = false;
    }
    
    xv = scrollpane.getScrollPosition( ).x;
    wv = scrollpane.getViewportSize( ).width;
    xe = xv + wv;
    xi = itemlist.getCurrentIndex( );
    if( catchup ) {
      if( xi >= xe ) {
        xs = xe;
        if( ( xe + wv ) >= canvas.getSize( ).width )
          xs = canvas.getSize( ).width - wv;
        scrollpane.setScrollPosition( xs, 0 );
        xv = xs;
        xe = xv + wv;
      }
      else if( xi < xv ) {
        xs = xv - wv;
        if( xs < 0 )
          xs = 0;
        scrollpane.setScrollPosition( xs, 0 );
        xv = xs;
        xe = xv + wv;
      }
    }
    f = ( xi >= xv ) && ( xi < xe );
  
    if( itemlist.fill( ) )
      redraw( );
    else
      canvas.repaint( );
    
    Date d;
    d = itemlist.getTime( xv );
    if( d != null )
      starttime.setText( d.toString( ).substring( 0, 19 ) );
    if( f ) {
      d = itemlist.getTime( xi );
      if( d != null )
        presenttime.setText( d.toString( ).substring( 0, 19 ) );
    }
    else {
      d = itemlist.getTime( xe - 1 );
      if( d != null )
        presenttime.setText( d.toString( ).substring( 0, 19 ) );
    }
    

  }
  
  public void redraw( ) {
      canvas.paint( canvas.getGraphics( ) );
      drawScale( );
  }
  
  public void drawScale( ) {
      if( currentitem != null ) {
        int pen = currentitem.getPenIndex( );
        if( pen < 0 )
          pen = - 1 - pen;
        minimum.setForeground( canvas.getColor( pen ) );
        maximum.setForeground( canvas.getColor( pen ) );
        minimum.setText( Double.toString( currentitem.getLower( ) ) );
        maximum.setText( Double.toString( currentitem.getUpper( ) ) );
      } 
  }
}
