//============================================================
/*

	TrendDemo.java
	
	Version 0.0.1	19-Jun-1998	H. Sakamoto

*/
//============================================================
/**
 */

import	java.applet.*;
import	java.awt.*;
import	java.util.*;
import	konoe.ui.trend.*;

public class TrendDemo extends Applet implements Runnable,
	KonoeTrendDataSource {

  Frame		controlframe;
  Panel		thepanel;
  KonoeTrendView	viewpanel;
  KonoeTrendControlPanel	viewcontrol;
  KonoeTrendData	itemlist;
  
  static int	canvaswidth = 1000;
  static int	canvasheight = 262;
  static int	panewidth = 400;
  static int	n_items = 4;
  Thread	thread;
  int		delay;
  double [] values = new double[ n_items ];

// overrided methods

  public void init( ) {

    thepanel = new Panel( );
    itemlist = new KonoeTrendData( n_items, canvaswidth, this );
    itemlist.setWindow( 0.0, ( double ) canvasheight );
    for( int i = 0; i < n_items; i ++ )
      itemlist.addItem( new KonoeTrendItem(
        "Example"+Integer.toString( i ),
        canvaswidth, 0, ( double ) canvasheight ) );
    viewpanel = new KonoeTrendView( canvaswidth, canvasheight,
    	panewidth, itemlist );
    thepanel.add( viewpanel );
    add( thepanel );
    repaint( );
    
    controlframe = new Frame( "Trend View Control" );
    viewcontrol = new KonoeTrendControlPanel( viewpanel );
    controlframe.add( viewcontrol );

    delay = 200;	// 200 milliseconds
    for( int i =0; i < n_items; i ++ )
      values[ i ] = ( double ) i * 20;
      
    viewpanel.setCurrentItem( 0 );	// first item.

  }
  
  public void start( ) {
    
    thepanel.setSize( 300, 500 );
    thepanel.validate( );
    viewcontrol.setup( );
    controlframe.setSize( 200, 200 );
    controlframe.show( );
    repaint( );
    if( thread == null ) {
      thread = new Thread( this );
    }
    thread.start( );
    
  }
  
  public void stop( ) {
  
    thread = null;
    controlframe.dispose( );
    
  }
  
  public void run( ) {
  
    Thread.currentThread( ).setPriority( Thread.MIN_PRIORITY );
    long	starttime = System.currentTimeMillis( );
    while( Thread.currentThread( ) == thread ) {
      viewpanel.updateDisplay( );  // do something here
      viewcontrol.update( );
      try {
        starttime += delay;
        Thread.sleep( Math.max( 0,
          starttime - System.currentTimeMillis( ) ) );
      }
      catch( InterruptedException e ) {
        break;
      }
    }
  }
  
  public double getTrendData( int index ) {
  
    double v;
    
    v = values[ index ] + Math.random( ) * 10.0 - 5.0;
    if( v < 0 )
      v = -v;
    if( v > 100 )
      v = 200 - v;
    values[ index ] = v;
    return v;
    
  }
  
}
