//===========================================================
/*

	KonoeAlarmMeterPanel.java
	
	Version 0.0.1	20-Jun-1998	H. Sakamoto
	Version 0.0.2	02-Jul-1998	H. Sakamoto
        Version 0.4.0   18-Aug-1998     K.Ohta
    Version 0.5.0   28-Sep-1999 T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//===========================================================

package	konoe.ui.parts;

/**

	An alarm meter with its value and label display.

 */

import	java.awt.*;
import	konoe.ui.parts.*;


public class KonoeAlarmMeterPanel extends Panel {

  KonoeAlarmMeter	meter;
  Label		label;
  Label		valuelabel;
  int		valuefieldlength;
	
  public KonoeAlarmMeterPanel( String label,
		int length, int width, double fullscale,
		int valuefieldlength ) {
		
    meter = new KonoeAlarmMeter( length, width, fullscale );
    meter.setColor( Color.cyan, Color.blue );
    meter.setLimitMode( KonoeAlarmMeter.WINDOW_LIMIT );
    meter.setAlartColor( Color.yellow, Color.red );
    if( label != null ) {
      this.label = new Label( label );
      add( this.label );
    }
    add( meter );
    String s;
    s = " ";
    for( int i = 1; i < valuefieldlength; i ++ )
      s += " ";
    add( valuelabel = new Label( s ) );
    this.valuefieldlength = valuefieldlength;
  }

  public KonoeAlarmMeter getAlarmMeter( ) {
  
    return meter;
    
  }
  
  public void setLimit( double ll, double ul ) {
  
    meter.setLimit( ll, ul );
    
  }
  
  public void setValue( double value ) {
  
    String valuetext = Double.toString( value );
    if( valuetext.length( ) > valuefieldlength )
      valuetext = valuetext.substring( 0, valuefieldlength );
    meter.setValue( value );
    meter.repaint( );
    valuelabel.setText( valuetext );
  }
}
