//========================================================
//
//	KonoeIcon.java
//
//	Version 0.0.1	30-Jun-1998	H. Sakamoto
//      Version 0.4.0   18-Aug-1998     K.Ohta
//  Version 0.5.0   28-Sep-1999     T.Hosoi
//  Version 0.5.0   01-Feb-2000     T.Hosoi
//========================================================

package	konoe.ui.parts;

import	java.awt.*;

public class KonoeIcon extends Component {

  public static final int ICON_WIDTH = 100;
  public static final int ICON_HEIGHT = 100;
  
  int	width;
  int	height;
  int	imageheight;
  int	imagewidth;
  int	labelxoffset;
  int	labelyoffset;
  String	labelstring;
  
  public KonoeIcon( String labelstring ) {
  
    width = ICON_WIDTH;
    height = ICON_HEIGHT;
    this.labelstring = labelstring;
    setSize( width, height );
    imageheight = 0;
    
  }
  
  public void paint( Graphics g ) {
  
    int x, y;
    
    if( imageheight == 0 ) {
      
      y = g.getFontMetrics( ).getHeight( );
      imageheight = height - y - 20;
      labelyoffset = imageheight + 20;
      x = g.getFontMetrics( ).stringWidth( labelstring );
      imagewidth = width;
      labelxoffset = ( width - x ) / 2;
    }
    g.setColor( getBackground( ) );
    g.fill3DRect( 0, 0, imagewidth, imageheight, true );
    g.setColor( getForeground( ) );
    g.drawString( labelstring, labelxoffset, labelyoffset );

  }
  
  public void update( Graphics g ) {
  
    paint( g );
    
  }
}
