//==========================================================
/*

	KonoeMeter.java
	
	Version 0.0.1	20-Jun-1998	H. Sakamoto
	Version 0.0.2	02-Jul-1998	H. Sakamoto
        Version 0.4.0   18-Aug-1998     K.Ohta
    Version 0.5.0   28-Sep-1999 T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi
*/
//==========================================================

package	konoe.ui.parts;

/**
 *
 *	A linear meter indicator
 *
 *	@author Hiroshi Sakamoto
 *	@version	0.0.1	15-Jun-1998
 */
 
import	java.awt.*;
 
public class KonoeMeter extends Canvas {
 
// private data
 
  int	width;
  int	length;
  double	fullscale;
  double	offset;
  
  double	value;
  double	lastvalue;

  Color		foreground;
  Color		background;
  
// constructor

  public KonoeMeter( int plength, int pwidth, double pfullscale ) {
  
    length = plength;
    width = pwidth;
    fullscale = pfullscale;
    offset = 0.0;
    setSize( length, width );
    lastvalue = 0.0;
    foreground = getForeground( );
    background = getBackground( );
    
  }

// bublic methods

  public void paint( Graphics g ) {
    int x;
    g.drawRect( 0, 0, length - 1, width - 1 );
    x = valueToSize( value );
    g.setColor( foreground );
    g.fillRect( 1, 1, x - 1, width - 2 );
    g.setColor( background );
    g.fillRect( x, 1, length - x - 1, width - 2 );
    lastvalue = value;
  }
  
  public void update( Graphics g ) {
    int xs;
    int xe;
    xs = valueToSize( lastvalue );
    xe = valueToSize( value );
    if( xe > xs ) {
      g.setColor( foreground );
      g.fillRect( 1, 1, xe - 1, width - 2 );
    }
    else if( xe < xs ) {
      g.setColor( background );
      g.fillRect( xe + 1, 1, length - xe - 2, width - 2 );
    }
    lastvalue = value;
  }
  
  public void setValue( double pvalue ) {
    value = pvalue;
  }
  
  public void setForeground( Color f ) {
    foreground = f;
  }
  
  public void setBackground( Color g ) {
    background = g;
  }
  
  public void setColor( Color fg, Color bg ) {
    foreground = fg;
    background = bg;
  }
  
  public double getFullscale( ) {
    return fullscale;
  }
  
  public double getOffset( ) {
    return offset;
  }
 
// private methods

  int valueToSize( double v ) {
  
    int x;
    
    x = ( int ) ( ( double ) length * ( v - offset )
    		/ ( fullscale - offset ) );
    if( x < 1 )
      x = 1;
    else if( x >= length - 1 )
      x = length - 2;
    return x;
  }
}
