//=============================================================
/*

        KonoeCategoryManager.java

        Version 0.0.1   03-Aug-1998     D. Takagi
        Version 0.5.0   28-Sep-1999     T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================
package konoe.ui.system;

import java.lang.reflect.*;
import java.util.*;

public class KonoeCategoryManager implements KonoeObject {
    private Hashtable nameTable = new Hashtable();
    private Hashtable idTable = new Hashtable();

    public void installClass(int categoryID, int classID, String name) {
	Key key = new Key(categoryID, classID);
	nameTable.put(key, name);
	idTable.put(name, key);
    }

    public String getClassName(int categoryID, int classID) {
    	return (String)(nameTable.get(new Key(categoryID, classID)));
    }
    
    public int getCategoryID(String name) {
	return ((Key)(idTable.get(name))).categoryID;
    }

    public int getClassID(String name) {
	return ((Key)(idTable.get(name))).classID;
    }

    public Object create(int categoryID, int classID) {
	try {
	    Class c = Class.forName(getClassName(categoryID, classID));
	    Constructor constructor = c.getConstructor(null);
	    return constructor.newInstance(null);
	} catch (ClassNotFoundException e) {
	    System.err.println("classname: " + getClassName(categoryID, classID) + " not found.");
	    return null;
	} catch (Exception e) {
	    System.err.println("categoryID: " + categoryID + ", " + "classID: " + classID + " not found in the konoe class table.");
	    return null;
	}
    }

    public void dump() {
	System.out.println(toString());
    }
}

class Key {
    public int categoryID;
    public int classID;

    public Key(int categoryID, int classID) {
	this.categoryID = categoryID;
	this.classID = classID;
    }

    public boolean equals(Object key) {
	return ((categoryID == ((Key)key).categoryID) && (classID == ((Key)key).classID));
    }

    public int hashCode() {
	return categoryID * 10000 + classID;
    }

    public void dump() {
	System.out.println(categoryID + " " + classID);
    }
}
