//=============================================================
/*

	KonoeList.java

	Version 0.0.1	02-Aug-1998	D. Takagi
    Version 0.5.0   28-Sep-1999 T. Hosoi
        Version 0.6.0   01-Feb-2000     T. Hosoi

*/
//=============================================================
package konoe.ui.system;

import java.io.*;

public class KonoeList implements KonoeObject {
    protected int n_entries;
    protected int tablesize;
    protected Object[] entries;
    
    protected int counter;
    protected Object pointer;

    public KonoeList(int tableSize) {
	if (tableSize > 0) {
	    entries = new Object[tableSize];
	} else {
	    entries = null;
	}
	tablesize = tableSize;
	n_entries = 0;
    }

    public int add(Object entry) {
	if (n_entries >= tablesize) {
	    return -1;
	}
	entries[n_entries++] = entry;
	return n_entries - 1;
    }

    public int allocate(int tableSize) {
	if (tableSize > 0) {
	    for (int i = 0; i < n_entries; i++) {
		entries[i] = null;
	    }
	    entries = new Object[tableSize];
	} else {
	    entries = null;
	}
	tablesize = tableSize;
	n_entries = 0;
	return tableSize;	    
    }

    public void clear() {
	for (int i = 0; i < n_entries; i++) {
	    entries[i] = null;
	}
	n_entries = 0;
	counter = 0;
	pointer = null;
    }

    public void reset() {
	counter = 0;
	if (entries != null) {
	    if (entries.length > 0) {
		pointer = entries[0];
	    }
	}
    }

    public Object next() {
	if (counter >= n_entries) {
	    return null;
	}
	pointer = entries[counter++];
	return pointer;
    }

    public Object get(int index) {
	if (index < 0 || index >= n_entries) {
	    return null;
	}
	return entries[index];
    }

    public int getCount() {
	return n_entries;
    }

    public int getTableSize() {
	return tablesize;
    }

    public void setEntries(Object[] entries) {
	this.entries = entries;
	n_entries = entries.length;
    }

    public void dump() {
	System.out.println(toString());
    }
}
    
