//========================================================
/*

	KonoeTCPClient.java

          Version 0.6.0 24-Aug-2000  A. Izumoto

*/
//========================================================
package konoe.ui.system;

import java.net.*;
import java.io.*;

public class KonoeTCPClient {

  String host;
  int port;
  Socket socket;
  DataOutputStream outS;
  DataInputStream inS;
  PrintStream out;

  public KonoeTCPClient(String host, int port) throws IOException,UnknownHostException {
    this.host = host;
    this.port = port;
    socket = new Socket(host,port);
    out = new PrintStream(socket.getOutputStream());
  }

  public KonoeTCPClient(Socket s) throws IOException{
    socket = s;
    out = new PrintStream(socket.getOutputStream());
  }

  public void send(String message) throws IOException{
    System.out.println(message);
    out.print(message);
//    out.close();
//    socket.close();
  }

  public String receive() throws Exception{
    socket = new Socket(host,port);
    inS = new DataInputStream(socket.getInputStream());
    System.out.println(String.valueOf(socket.getPort()));
    String message = readLine(inS);
    inS.close();
    socket.close();
    return message;
  }

  public void close() throws IOException {
    socket.close();
  }

  protected String readLine(DataInputStream dis) throws Exception {
    try{
      StringBuffer buffer = new StringBuffer();
      for(int i=0;;){
        int c = dis.readUnsignedByte();
        buffer.append(new Character((char)c));
        if(c=='\n'){
          break;
        }
      }
    return buffer.toString();
    }catch(EOFException e){
      return null;
    }
  }
}

    
