//============================================================
/*

	KonoeTCPServer.java

	Version 0.6.0 10-Aug-2000    A.Izumoto

*/
//============================================================
package konoe.ui.system;

import java.net.*;
import java.io.*;

public class KonoeTCPServer {

  int port;
  ServerSocket server;

  public KonoeTCPServer(int port){
    this.port = port;
    try{
      server = new ServerSocket(port);
    }catch(Exception e){
      System.out.println(e);
      return;
    }
  }

  public String getData(){
    String r;
    try{
      Socket socket = server.accept();
      DataInputStream dis = new DataInputStream(socket.getInputStream());
      r = readLine(dis);
      if(r == null){
        dis.close();
        socket.close();
        return null;
      }
      return r;
    }catch(Exception e){
        System.out.println(e);
        return null;
    }
  }

  protected String readLine(DataInputStream dis) throws Exception {
    try{
      StringBuffer buffer = new StringBuffer();
      for(int i=0;;){
        int c = dis.readUnsignedByte();
        buffer.append(new Character((char)c));
        if(c=='\n'){
          break;
        }
      }
    return buffer.toString();
    }catch(EOFException e){
      return null;
    }
  }
}

   
