//=========================================================
//
//      HistoDrawDemo.java
//
//	Version 0.0.1	03-Jul-1998	K.Ohta
//
//=========================================================

import	java.applet.*;
import	java.awt.*;
import  konoe.ui.parts.*;
import  konoe.ui.analysis.*;
import  konoe.ui.graphics.*;

public class HistoDrawDemo extends Applet {

    KonoeDrawCanvas testCanvas1;
    KonoeDrawCanvas testCanvas2;
    KonoeDrawCanvas testCanvas3;
    KonoeDrawCanvas testCanvas4;
    KonoeDrawPanel  testPanel1;
    KonoeDrawPanel  testPanel2;
    KonoeDrawPanel  testPanel3;
    KonoeDrawPanel  testPanel4;
    Konoe1DHistogram testHisto1;
    Konoe1DHistogram testHisto2;

  public void init() {

//----- 1 dimension Histogram test ------------

    testHisto1 = 
     new Konoe1DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 40 ) );

    testHisto1.getScale().dump();

    for(int i = 0; i < 20; i++ ) 
    testHisto1.fill( new KonoeFillData( 50.0 ) );
    for(int i = 0; i < 10; i++ ) 
    testHisto1.fill( new KonoeFillData( 12.0 ) );
    for(int i = 0; i < 5; i++ ) 
    testHisto1.fill( new KonoeFillData( 48.0 ) );
    for(int i = 0; i < 40; i++ ) 
    testHisto1.fill( new KonoeFillData( 90.0 ) );
    for(int i = 0; i < 90; i++ ) 
    testHisto1.fill( new KonoeFillData( 9.0 ) );
    testHisto1.dump();

//----- 1 dimension Histogram test2 ------------

    testHisto2 = 
      new Konoe1DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 40 ) );

    for(int i = 0; i < 20; i++ ) 
    testHisto2.fill( new KonoeFillData( 90.0 ) );
    for(int i = 0; i < 10; i++ ) 
    testHisto2.fill( new KonoeFillData( 80.0 ) );
    for(int i = 0; i < 5; i++ ) 
    testHisto2.fill( new KonoeFillData( 60.0 ) );
    for(int i = 0; i < 90; i++ ) 
    testHisto2.fill( new KonoeFillData( 10.0 ) );
    for(int i = 0; i < 70; i++ ) 
    testHisto2.fill( new KonoeFillData( 19.0 ) );
    testHisto2.dump();

// ------------- DRAW ---------------------------

    testCanvas1 =
         new KonoeDrawCanvas( testHisto1,
                              new KonoeDimension(200, 200),
                              "test 1",
                              new KonoeLinearDataScale(0.0,200.0,100));

    testCanvas2 =
         new KonoeDrawCanvas( testHisto2,
                              new KonoeDimension(100, 200),
                              "test 2",
                              new KonoeLinearDataScale(0.0,100.0,100));

    testCanvas3=
         new KonoeDrawCanvas( testHisto1,
                              new KonoeDimension(200, 200),
                              "test 3",
                              new KonoeLinearDataScale(0.0,400.0,100));

    testCanvas4 =
         new KonoeDrawCanvas( testHisto2,
                              new KonoeDimension(250, 100),
                              "test 4",
                              new KonoeLinearDataScale(0.0,150.0,100));

    testPanel1  = new KonoeDrawPanel( testCanvas1, "TEST DATA1" );
    testPanel2  = new KonoeDrawPanel( testCanvas2, "TEST DATA2" );
    testPanel3  = new KonoeDrawPanel( testCanvas3, "TEST DATA1" );
    testPanel4  = new KonoeDrawPanel( testCanvas4, "TEST DATA2" );

    setLayout(new GridLayout(2,2));
    add(testPanel1);
    add(testPanel2);
    add(testPanel3);
    add(testPanel4);
  }
	
// ----------------------------------------------

  public void start( ) {
  
    testCanvas1.paint ( testCanvas1.getGraphics() );
    testCanvas2.paint ( testCanvas2.getGraphics() );
    testCanvas3.paint ( testCanvas3.getGraphics() );
    testCanvas4.paint ( testCanvas4.getGraphics() );
    System.out.println( "Applet "+getSize( ).toString( ) );

  }

  public void stop( ) {

  }

}
