//=========================================================
//
//      StatusViewer.java
//
//	Version 0.4.1	03-Nov-1998	K.Ohta
//	Version 0.6.0	01-Feb-2000	T.Hosoi
//
//=========================================================

import	java.applet.*;
import	java.awt.*;
import	java.io.*;
import	java.awt.event.*;
import  konoe.ui.parts.*;
import  konoe.ui.analysis.*;
import  konoe.ui.graphics.*;

public class StatusViewer extends Applet implements Runnable {

    Thread mainThread = null;
    Thread networkThread1 = null;
    demoreceive receiver1;

    KonoeDrawCanvas testCanvas1;
    KonoeDrawPanel  testPanel1;
    Konoe1DHistogram testHisto1;

    Button startButton;
    Button stopButton;
    Button connectButton;
    Button disConnectButton;

    public TextField ttx; 
    public TextField ttx2;

    String connectSite;
    int connectPort;

  public void init() {
//----- 1 dimension Histogram test ------------

    testHisto1 = 
     new Konoe1DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 100 ) );

//--------------- BUTTON SET ---------------------
		setLayout(null);
		setSize(900,600);

                MyMouseAction aMouseAction = new  MyMouseAction();

		connectButton = new Button( "CONNECT" );
		connectButton.setActionCommand("button");
		connectButton.setBounds(12,12,160,30);
		connectButton.setBackground(Color.lightGray);
		connectButton.addMouseListener(aMouseAction);
		add(connectButton);

		disConnectButton = new Button( "DISCONNECT" );
		disConnectButton.setActionCommand("button");
		disConnectButton.setBounds(12,42,160,30);
		disConnectButton.setBackground(Color.lightGray);
		disConnectButton.addMouseListener(aMouseAction);
		add(disConnectButton);

		startButton = new Button( "START READING" );
		startButton.setActionCommand("button");
		startButton.setBounds(12,72,80,30);
		startButton.setBackground(Color.lightGray);
		startButton.addMouseListener(aMouseAction);
		add(startButton);

		stopButton = new Button( "STOP READING" );
		stopButton.setActionCommand("button");
		stopButton.setBounds(95,72,80,30);
		stopButton.setBackground(Color.lightGray);
		stopButton.addMouseListener(aMouseAction);
		add(stopButton);

                ttx = new TextField("sunee.cc.it-hiroshima.ac.jp");
                ttx.setBounds(12,102,160,30);
                add(ttx); 

                Label  la1  = new Label("Port No :");
                la1.setBounds(12,132,80,30);
                add(la1);

                ttx2 = new TextField( "12000");
                ttx2.setBounds(95,132,80,30);
                add(ttx2);

                Button bt1  = new Button( "NetWork Configuration" );
                bt1.setBounds(12,162,160,30);
                add(bt1);

                Button bt2  = new Button( "Display Configuration" );
                bt2.setBounds(12,192,160,30);
                add(bt2);

// ------------- DRAW ---------------------------

    testCanvas1 =
         new KonoeDrawCanvas( testHisto1,
                              new KonoeDimension(200, 200),
                              "Login Users Number Monitor",
                              new KonoeLinearDataScale(0.0,50.0,100));

    testPanel1  = new KonoeDrawPanel( testCanvas1, "" );

    Panel tempPanel = new Panel( new GridLayout(2,2) );

    tempPanel.add(testPanel1);
    
    tempPanel.setBounds(200,10,700,600);
    tempPanel.setBackground(java.awt.Color.lightGray);
    add(tempPanel);

  }
	
// ----------------------------------------------

  public void start( ) {


  }

  public void run() {

      while( mainThread.isAlive() ) {

        if ( networkThread1 != null && networkThread1.isAlive() ) {
           testHisto1 = (Konoe1DHistogram)(receiver1.commingObject);
           testHisto1.dump();

          if ( testHisto1  != null ) {
             testCanvas1.setDataSource( testHisto1 );
             testCanvas1.repaint( );
          }

        }

          try {
               Thread.sleep(500);
              } catch 
                (InterruptedException e){}

          System.gc();
      }
    
  }

  public void stop( ) {

       if( mainThread != null ) {
           mainThread.stop();
           mainThread = null;
       }

  }

  public class MyMouseAction extends MouseAdapter {
     public void mouseReleased( MouseEvent event ) {
      Object object = event.getSource();
      if ( object == connectButton    ) connectButtonAction();
      if ( object == disConnectButton ) disConnectButtonAction();
      if ( object == startButton      ) startButtonAction();
      if ( object == stopButton       ) stopButtonAction();
     }

  }
 
  void connectButtonAction () {


    connectSite = ttx.getText();
    String connectPortText = ttx2.getText();
    connectPort = (new Integer( connectPortText )).intValue();

    System.out.println( "Connecting to " + connectSite + ":" + connectPort);

    try {

    receiver1 = new demoreceive( connectPort    ,  connectSite);
    networkThread1 = new Thread( receiver1 );

    } catch ( IOException  e) {
      System.out.println("Connect faild");
    }


  }

  void disConnectButtonAction () {
    if (networkThread1 != null ) {
       networkThread1.stop();
       networkThread1 = null;
    }
  }
  
  void startButtonAction () {
    if ( mainThread == null ) {
         networkThread1.start(); 
         mainThread = new Thread( this );
         mainThread.start();
    }
  }

  void stopButtonAction () {
    if (networkThread1 != null && networkThread1.isAlive() ) {
       networkThread1.suspend();
    }
  }
     
}
