#include <system/KonoeServerSocket.hh>
#include <system/KonoeClientSocket.hh>
#include <system/KonoeOutputObjSocket.hh>
#include <system/KonoeInputObjSocket.hh>
#include <system/KonoeOutputObjFile.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeLinearDataScale.hh>
#include <analysis/KonoeFillData.hh>

#include        <analysis/KonoeHistogramCM.hh>
#include        <analysis/KonoePhysicalValueCM.hh>

#include <iostream.h>
#include <stdlib.h>

int main(int argc, KChar* argv[])
{
  KInt port = 10000;
  KChar * host = "sunee.cc.it-hiroshima.ac.jp";

  if(argc > 1) port = atoi( argv[1] );

  KonoeInputObjectStream* in1;

  KonoeClientSocket* socket1 = new KonoeClientSocket( host, port );
  in1 = new KonoeInputObjSocket( socket1 );
  in1 -> installCM( new KonoeHistogramCM() );
  in1 -> installCM( new KonoePhysicalValueCM() );

  KInt n = 0;

  while (1) {
    cout << "--- No. " << ++n << " ---" << endl;

    Konoe1DHistogram * histogram1;

    histogram1 = (Konoe1DHistogram*) in1-> get(  );
    if( histogram1 == 0 ){ cout<< "error" << endl; }

    histogram1 -> dump( cout );

    delete histogram1;

  }

  return 0;
}
