//===================================================================
/*

	KonoeArgumentDescriptor.cc

	Version 0.0.1	03-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//===================================================================

#include	<ui/KonoeArgumentDescriptor.hh>
#include	<string.h>

KonoeArgumentDescriptor::KonoeArgumentDescriptor(
	const KChar * pname, const KInt ptype, const KInt pappearance ) :
	type( ptype ),
	appearance( pappearance )

{

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );

}

KonoeArgumentDescriptor::~KonoeArgumentDescriptor( ) {

	delete [] name;
	delete [] description;

}

void	KonoeArgumentDescriptor::setDescription( KChar * string ) {

	description = new KChar[ strlen( string ) + 1 ];
	strcpy( description, string );

}

void	KonoeArgumentDescriptor::printHelp( ostream & os ) {

	os << name << " : " << description;
	switch( type ) {
	case INTEGER :
	  os << "  (Integer)";
	  break;
	case FLOATING :
	  os << "  (Floating)";
	  break;
	case STRING :
	  os << "  (String)";
	  break;
	case KEYWORD :
	  os << "  (Keyword)";
	  break;
	}
	if( appearance == OPTIONAL )
	  os << "  [ optional ]";
	os << endl;

}

KInt	KonoeArgumentDescriptor::isNecessary( ) {

	return appearance == NECESSARY;

}
