//===================================================================
/*

	KonoeArgumentDescriptor.hh

	Version 0.0.1	03-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	08-Dec-2000	H. Sakamoto

*/
//===================================================================

#ifndef	__KONOEARGUMENTDESCRIPTOR_HH
#define	__KONOEARGUMENTDESCRIPTOR_HH

#include	<KonoePrimitives.hh>
#include	<iostream.h>

class	KonoeArgumentDescriptor {

public :
	enum	ArgumentType	{
			INTEGER,
			FLOATING,
			STRING,
			KEYWORD,
			SYMBOL,
			EXPRESSION
		};
	enum	Appearance	{
			OPTIONAL,
			NECESSARY
		};

protected :
	KChar	* name;
	const KInt	type;
	const KInt	appearance;
	KChar	* description;
	
public :

	KonoeArgumentDescriptor(
		const KChar * name,
		const KInt type,
		const KInt appearance = 0 );
	~KonoeArgumentDescriptor( );
	const KChar	* getName( ) const {
		return ( const KChar * ) name;	}
	const KInt	getType( ) const {
		return type;	}
	const KInt	getAppearance( ) const {
		return appearance;	}
	void	setDescription( KChar * description );
	void	printHelp( ostream & os );
	KInt	isNecessary( );
};

#endif
