//====================================================================
/*

	KonoeCommand.cc

	Version 0.0.1	06-Jul-1998	H. Sakamoto
	Version 0.0.2	03-Sep-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	19-May-2001	H. Sakamoto


*/
//====================================================================

#include	<ui/KonoeCommand.hh>
#include	<string.h>

KonoeCommand::KonoeCommand( ) :
	KonoeList<KonoeCommandArgument>( MAX_ARGUMENTS ) {

	objectname = 0;
	processname = 0;
	hostname = 0;
	methodname = 0;

}

KonoeCommand::~KonoeCommand( ) {

	if( objectname )
	  delete [] objectname;
	if( processname )
	  delete [] processname;
	if( hostname )
	  delete [] hostname;
	if( methodname )
	  delete [] methodname;

}

KInt	KonoeCommand::getArgumentCount( ) {

	return getCount( );

}


KonoeCommandArgument	* KonoeCommand::getArgument( KInt index ) {

	return get( index );

}

void	KonoeCommand::dump( ostream & os ) {

	KInt	argumentcount = getCount( );

	os << "Method = " << methodname;
	if( objectname )
	  os << "  Object = " << objectname;
	if( processname )
	  os << "  Process = " << processname;
	if( hostname )
	  os << "  Host = " << hostname;
	os << endl;
	reset( );
	for( int i = 0; i < argumentcount; i ++ ) {
	  os << "Argument " << i << " = ";
	  next( ) -> dump( os );
	}

}

void	KonoeCommand::setObjectName( KChar * name ) {

	objectname = new KChar[ strlen( name ) + 1 ];
	strcpy( objectname, name );

}

void	KonoeCommand::setProcessName( KChar * name ) {

	processname = new KChar[ strlen( name ) + 1 ];
	strcpy( processname, name );

}

void	KonoeCommand::setHostName( KChar * name ) {

	hostname = new KChar[ strlen( name ) + 1 ];
	strcpy( hostname, name );

}

void	KonoeCommand::setMethodName( KChar * name ) {

	methodname = new KChar[ strlen( name ) + 1 ];
	strcpy( methodname, name );

}

void	KonoeCommand::setExpression( KonoeExpression * exp ) {

	expression = exp;
	KonoeCommandArgument	* arg;

	reset( );
	while( arg = next( ) ) {
	    arg -> setExpression( exp );
	}
}
