//====================================================================
/*

	KonoeCommand.hh

	Version 0.0.1	 6-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998	S. Nishida
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	18-May-2001	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOECOMMAND_HH
#define	__KONOECOMMAND_HH

#include	<ui/KonoeCommandArgument.hh>
#include	<KonoeList.hh>
#include	<iostream.h>

#include	<ui/KonoeExpression.hh>

class	KonoeCommand	: public KonoeList<KonoeCommandArgument> {

public :
	enum	{	MAX_ARGUMENTS = 256	};
protected :
	KChar	* objectname;
	KChar	* processname;
	KChar	* hostname;
	KChar	* methodname;
	ostream	* outputstream;
	KonoeExpression	* expression;

public :
	KonoeCommand( );
	~KonoeCommand( );
	KInt	getArgumentCount( );
	KonoeCommandArgument	* getArgument( KInt index );
	const KChar	* getMethodName( ) {
		return ( const KChar * ) methodname;	}
	const KChar	* getObjectName( ) {
		return ( const KChar * ) objectname;	}
	const KChar	* getProcessName( ) {
		return ( const KChar * ) processname;	}
	const KChar	* getHostName( ) {
		return ( const KChar * ) hostname;	}
	void	setObjectName( KChar * objectname );
	void	setProcessName( KChar * processname );
	void	setHostName( KChar * hostname );
	void	setMethodName( KChar * methodname );
	void	dump( ostream & os );
	void	setOutputStream( ostream & os )	{
			outputstream = & os;	}
	ostream	& getOutputStream( )		{
			return * outputstream;	}
	void	setExpression( KonoeExpression * exp );
	KonoeExpression	* getExpression( )
			{	return expression;	}


};

#endif
