//=================================================================
/*

	KonoeCommandBufferOrderly.hh

	Version 0.0.1	24-May-2001	H. Sakamoto

*/
//=================================================================

#ifndef	__KONOECOMMANDBUFFERORDERLY_HH
#define	__KONOECOMMANDBUFFERORDERLY_HH

#include	<ui/KonoeOrderly.hh>
#include	<ui/KonoeCommandBuffer.hh>
#include	<KonoeCategories.hh>
#include	<ui/KonoeCommandCM.hh>

class	KonoeCommandInterpreter;

class	KonoeCommandBufferOrderly	: public KonoeOrderly {

public :
	enum	{	CLASS_ID	= KonoeCategories::CLI
				+ KonoeCommandCM::CID_COMMANDBUFFER	};

	enum	{	CMD_HELP,
			CMD_LIST,
			CMD_DELETE,
			CMD_INSERT,
			CMD_REPLACE,
			N_COMMANDS	};

	enum	{	ARG_LIST_FROM,
			ARG_LIST_TO,
			N_ARG_LIST	};

	enum	{	ARG_DELETE_FROM,
			ARG_DELETE_TO,
			N_ARG_DELETE	};

	enum	{	ARG_INSERT_AT,
			ARG_INSERT_LINE,
			N_ARG_INSERT	};

	enum	{	ARG_REPLACE_AT,
			ARG_REPLACE_LINE,
			N_ARG_REPLACE	};

protected :
	KonoeCommandBuffer	* target;
	KonoeCommandInterpreter	* interpreter;

	static const KChar	* classname;

	class ListUnit	: public KonoeCommandProcessor {

	public :
		ListUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

	class DeleteUnit	: public KonoeCommandProcessor {

	public :
		DeleteUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

	class InsertUnit	: public KonoeCommandProcessor {

	public :
		InsertUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

	class ReplaceUnit	: public KonoeCommandProcessor {

	public :
		ReplaceUnit( KonoeCommandDescriptor * cd, KonoeOrderly * ow );
		KInt	execute( KonoeCommand * cmd );

	};

public :
	KonoeCommandBufferOrderly( const KChar * objname );
	KInt	isOrderlyOf( void * address );
	const KChar	* getClassName( )
			{	return classname;	}
	KonoeOrderly	* clone( const KChar * name );
	void	* getTarget( )	{	return ( void * ) target;	}
	void	setTarget( void * target );
	void	setInterpreter( KonoeCommandInterpreter * pinterpreter )
			{	interpreter = pinterpreter;	}
	KonoeCommandInterpreter	* getInterpreter( )
			{	return interpreter;		}

};

#endif
