//===================================================================
/*

	KonoeCommandDescriptor.cc

	Version 0.0.1	03-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//==================================================================

#include	<ui/KonoeCommandDescriptor.hh>
#include	<string.h>

KonoeCommandDescriptor::KonoeCommandDescriptor( const KChar * pname,
		KInt tablesize ) {

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );
	description = 0;

	argumentlist = new KonoeList<KonoeArgumentDescriptor>( tablesize );

}

KonoeCommandDescriptor::~KonoeCommandDescriptor( ) {

	delete argumentlist;
	delete [] name;
	delete [] description;

}

KInt	KonoeCommandDescriptor::add( KonoeArgumentDescriptor * arg ) {

	return argumentlist -> add( arg );

}

void	KonoeCommandDescriptor::setDescription( KChar * string ) {

	delete [] description;
	description = new KChar[ strlen( string ) + 1 ];
	strcpy( description, string );

}

void	KonoeCommandDescriptor::printHelp( ostream & os, KInt flag ) {

	KonoeArgumentDescriptor	* argd;

	os << name << "  :  " << description << endl;
	if( flag ) {
	  os << "    Arguments available ..." << endl;
	  argumentlist -> reset( );
	  while( argd = argumentlist -> next( ) ) {
	    os << "\t";
	    argd -> printHelp( os );
	  }
	}
}

KInt	KonoeCommandDescriptor::getArgumentCount( ) {

	return argumentlist -> getCount( );

}

KonoeArgumentDescriptor	* KonoeCommandDescriptor::getArgument( KInt index ) {

	return argumentlist -> get( index );

}
