//====================================================================
/*

	KonoeCommandParser.hh

	Version 0.0.1	 3-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	25-Nov-2000	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOECOMMANDPARSER_HH
#define	__KONOECOMMANDPARSER_HH

#include	<KonoePrimitives.hh>
#include	<iostream.h>
#include	<ui/KonoeCommand.hh>

class	KonoeCommandParser	{

public :
	enum	{
			TOO_MANY_ARGUMENTS = -2,
			INVALID_SYNTAX = -1,
			NULL_LINE = 0,
			COMMAND_PARSED = 1	};

protected :

	enum	{	START,	VERB,	END_VERB,
			ARGUMENT,	END_ARGUMENT,
			QUOTEDSTRING,	IN_BRACE	};
	KChar	* commandline;
	KChar	* verb;
	KonoeCommand	* command;

	KChar	* getSubstring( KChar * strfrom, KChar * strto );
	KChar	* copyString( KChar * string );

	KInt	add_argument( KChar * strfrom, KChar * strto );

private :
	KInt	argumentcount;
	KInt	st;

public :
	KonoeCommandParser( );
	KInt	parse( KChar * commandline );
	KInt	analyzeVerb( );
	void	clear( );
	const KChar	* getVerb( ) {
		return ( const KChar * ) verb;	}
	KonoeCommand	* getCommand( ) {
		return command;			}
};

#endif
