//=================================================================
/*

	KonoeCommandProcessor.hh

	Version 0.0.1	16-Jul-1998	H. Sakamoto
	Version 0.0.2	 2-Aug-1998	Sanshiro Enomoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	19-May-2001	H. Sakamoto
	Version 0.6.2	28-May-2001	H. Sakamoto

*/
//=================================================================

#ifndef	__KONOECOMMANDPROCESSOR_HH
#define	__KONOECOMMANDPROCESSOR_HH

#include	<ui/KonoeCommandDescriptor.hh>
#include	<ui/KonoeCommand.hh>
#include	<iostream.h>

class	KonoeOrderly;

class	KonoeCommandProcessor	{

public :
	enum	{	E_ARGUMENT_MISSING	= -1,
			E_ARGUMENT_NOT_INTEGER	= -2,
			E_ARGUMENT_NOT_ALPHA	= -3,
			E_INVALID_ARGUMENT	= -4,
			E_ARGUMENT_OUT_OF_RANGE = -5,
			E_NO_SYMBOL_RESOLVER	= -6,
			E_NO_INTERPRETER	= -7	};

protected :

	KonoeCommandDescriptor	* descriptor;
	KonoeOrderly		* owner;
	KChar	* classname;
	KInt	always_executed;

public :

	KonoeCommandProcessor( KonoeCommandDescriptor * cd,
				KonoeOrderly * owner );
	~KonoeCommandProcessor( );

	const KChar	* getMethodName( );
	void		printHelp( ostream & os, KInt flag );

	void	setClassName( const KChar * classname );
	const KChar	* getClassName( )
			{	return classname;	}
	void	printErrorHeader( ostream & os );
	void	printError( ostream & os, KInt errorcode,
			const KChar * option = 0 );
	void	setAlways( KInt flag )	{	always_executed = flag;	}
	KInt	isAlways( )	{	return always_executed;		}

	virtual KInt	execute( KonoeCommand * cmd ) = 0;
	virtual KInt	checkArgument( KonoeCommand * cmd );

};


#endif
