//====================================================================
/*

	KonoeCommandSource.cc

	Version 0.0.1	 4-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//====================================================================

#include	<ui/KonoeCommandSource.hh>


const KChar	* KonoeTerminalCommandSource::getNext( ) {

	static KChar	buffer[ 256 ];

        cout << "CMD> ";
	cin.getline( buffer, sizeof( buffer ) );

	return buffer;
}

KonoeFileCommandSource::KonoeFileCommandSource( KChar *filename ) {

	file = new KonoeInputFile( filename );

}

KonoeFileCommandSource::~KonoeFileCommandSource( ) {

	delete file;

}

const KChar	* KonoeFileCommandSource::getNext( ) {

	static KChar	buffer[ 256 ];
	KChar	*ptr = buffer;

	do {
	  file -> get( ptr, 1 );
	  ptr++;
        } while ((ptr[-1] != '\n') && (ptr[-1] != '\0'));
	ptr[-1] = '\0';

	if (*buffer == '\0') {
	  return getNext( );
	}
	else {
	  return buffer;
        }
}


KonoeServerSocketCommandSource::KonoeServerSocketCommandSource( KInt port  ) {

	socket = new KonoeSCServerSocket( port );
	socket -> waitConnection( );
}

KonoeServerSocketCommandSource::~KonoeServerSocketCommandSource( ) {

	delete socket;

}

const KChar	* KonoeServerSocketCommandSource::getNext( ) {

	static KChar	buffer[ 256 ];

	do {
	  socket -> receive( buffer, 256 );
        } while ((*buffer == '\n') || (*buffer == '\0'));

	return buffer;
}


KonoeClientSocketCommandSource::KonoeClientSocketCommandSource( 
  KChar *hostname, KInt port  ) {

	socket = new KonoeClientSocket( hostname, port );
}

KonoeClientSocketCommandSource::~KonoeClientSocketCommandSource( ) {

	delete socket;

}

const KChar	* KonoeClientSocketCommandSource::getNext( ) {

	static KChar	buffer[ 256 ];

	do {
	  socket -> receive( buffer, 256 );
        } while ((*buffer == '\n') || (*buffer == '\0'));

        return buffer;
}
