//====================================================================
/*

	KonoeCommandSource.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi

*/
//====================================================================


#ifndef	__KONOECOMMANDSOURCE_HH
#define	__KONOECOMMANDSOURCE_HH

#include	<system/KonoeInputFile.hh>
#include	<system/KonoeSCServerSocket.hh>
#include	<system/KonoeClientSocket.hh>
#include	<iostream.h>


class KonoeCommandSource {

public:
	virtual	const KChar 	* getNext( ) = 0;
};



class KonoeTerminalCommandSource : public KonoeCommandSource {

public:
	virtual	const KChar	* getNext( );
};



class KonoeFileCommandSource : public KonoeCommandSource {

public:
        KonoeFileCommandSource( KChar *filename );
        virtual ~KonoeFileCommandSource( );
	virtual	const KChar	* getNext( );

protected:
        KonoeInputFile	*file;

};



class KonoeServerSocketCommandSource : public KonoeCommandSource {

public:
        KonoeServerSocketCommandSource( KInt port );
        virtual ~KonoeServerSocketCommandSource( );
	virtual	const KChar	* getNext( );
protected:
        KonoeSCServerSocket	*socket;

};



class KonoeClientSocketCommandSource : public KonoeCommandSource {

public:
        KonoeClientSocketCommandSource( KChar *hostname, KInt port );
        virtual ~KonoeClientSocketCommandSource( );
	virtual	const KChar	* getNext( );
protected:
        KonoeClientSocket	*socket;

};

#endif
