//=====================================================================
/*

	KonoeCommandVariable.cc

	Version 0.6.0	25-Nov-2000	H. Sakamoto
	Version 0.6.1	26-May-2001	H. Sakamoto

*/
//=====================================================================

#include	<ui/KonoeCommandVariable.hh>
#include	<string.h>

KonoeCommandVariable::KonoeCommandVariable( const KChar * pname, const KChar * pvalue ) {

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );

	cvalue = new KChar[ strlen( pvalue ) + 1 ];
	strcpy( cvalue, pvalue );

	type = STRING;

}

KonoeCommandVariable::KonoeCommandVariable( const KChar * pname, KInt pvalue ) {

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );

	ivalue = pvalue;

	type = INTEGER;

}

KonoeCommandVariable::KonoeCommandVariable( const KChar * pname, KFloat pvalue ) {

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );

	fvalue = pvalue;

	type = FLOATING;

}

KonoeCommandVariable::KonoeCommandVariable( const KChar * pname ) {

	name = new KChar[ strlen( pname ) + 1 ];
	strcpy( name, pname );

	type = UNDEFINED;

}

KonoeCommandVariable::~KonoeCommandVariable( ) {

	delete [] name;
	if( type == STRING )
		delete cvalue;

}

KInt	KonoeCommandVariable::setCValue( const KChar * pvalue ) {

	if( type == STRING ) {
		delete [] cvalue;
		cvalue = new KChar[ strlen( pvalue ) + 1 ];
	}
	else {
		cvalue = new KChar[ strlen( pvalue ) + 1 ];
		type = STRING;
	}
	strcpy( cvalue, pvalue );
	return 0;

}

KInt	KonoeCommandVariable::setIValue( KInt pvalue ) {

	if( type == STRING ) {
		delete [] cvalue;
	}
	ivalue = pvalue;
	type = INTEGER;
	return 0;

}

KInt	KonoeCommandVariable::setFValue( KFloat pvalue ) {

	if( type == STRING ) {
		delete [] cvalue;
	}
	fvalue = pvalue;
	type = FLOATING;
	return 0;

}

KInt	KonoeCommandVariable::match( const KChar * pname ) {

	if( strcmp( name, pname ) == 0 )
		return 1;
	else
		return 0;

}


void	KonoeCommandVariable::showName( ostream & os ) {

	os << name;

}

void	KonoeCommandVariable::showValue( ostream & os ) {

	switch( type ) {
	case INTEGER :
	    os << dec << ivalue << " ( 0x" << hex << ivalue << " )";
	    break;
	case FLOATING :
	    os << fvalue;
	    break;
	case STRING :
	    os << cvalue;
	    break;
	default :
	    os << "undefined";
	    break;
	}

}
