//=========================================================================
/*

	KonoeCommandVariable.hh

	Version 0.6.0	25-Nov-2000	H. Sakamoto
	Version 0.6.1	26-May-2001	H. Sakamoto

*/
//========================================================================

#ifndef	__KONOECOMMANDVARIABLE_HH
#define	__KONOECOMMANDVARIABLE_HH

#include	<ui/KonoeCommandArgument.hh>
#include	<ui/KonoeSymbol.hh>

class	KonoeCommandVariable	: public KonoeSymbol {

public :
	enum	{	INTEGER = KonoeCommandArgument::INTEGER,
			FLOATING = KonoeCommandArgument::FLOATING,
			STRING = KonoeCommandArgument::STRING,
			UNDEFINED = -1	};

protected :
	KChar	* name;
	KChar	* cvalue;
	KInt	ivalue;
	KFloat	fvalue;
	KInt	type;

public :
	KonoeCommandVariable( const KChar * name, const KChar * cvalue );
	KonoeCommandVariable( const KChar * name, KInt ivalue );
	KonoeCommandVariable( const KChar * name, KFloat fvalue );
	KonoeCommandVariable( const KChar * name );

	~KonoeCommandVariable( );

	KInt	getType( )	{	return type;	}
	KChar	* getName( )	{	return name;	}
	KChar	* getCValue( )	{	return cvalue;	}
	KInt	getIValue( )	{	return ivalue;	}
	KFloat	getFValue( )	{	return fvalue;	}
	KInt	setCValue( const KChar * cvalue );
	KInt	setIValue( KInt ivalue );
	KInt	setFValue( KFloat fvalue );
	void	showName( ostream & os );
	void	showValue( ostream & os );
	KInt	isInteger( )	{	return type == INTEGER;		}
	KInt	isString( )	{	return type == STRING;		}
	KInt	isFloating( )	{	return type == FLOATING;	}

	KInt	match( const KChar * name );

};
#endif

