//=====================================================================
/*

	KonoeCommandVariableTable.cc

	Version 0.6.0	25-Nov-2000	H. Sakamoto
	Version 0.6.1	26-May-2001	H. Sakamoto

*/
//=====================================================================

#include	<ui/KonoeCommandVariableTable.hh>

KonoeCommandVariableTable::KonoeCommandVariableTable( 
		KChar * pname, KInt ptablesize )
		: KonoeList<KonoeCommandVariable>( ptablesize ) {

	name = pname;

}

KonoeCommandVariableTable::~KonoeCommandVariableTable( ) {

}


KonoeSymbol *	KonoeCommandVariableTable::findSymbol( const KChar * pname ) {

	KonoeCommandVariable	* variable;

	reset( );
	while( variable = next( ) ) {
	    if( variable -> match( pname ) )
		return variable;
	}

	return 0;

}

KonoeSymbol *	KonoeCommandVariableTable::addSymbol( const KChar * pname ) {

	KonoeCommandVariable	* variable;
	KInt	st;

	variable = new KonoeCommandVariable( pname );
	st = add( variable );
	if( st < 0 )
	    return 0;	// failed to add into the list.

	return variable;

}

KInt	KonoeCommandVariableTable::getSymbolCount( ) {

	return n_entries;

}

KonoeSymbol	* KonoeCommandVariableTable::getSymbol( KInt index ) {

	return get( index );

}
