//=====================================================================
/*

	KonoeCommandVariableTable.hh

	Version 0.6.0	25-Nov-2000	H. Sakamoto
	Version 0.6.1	14-May-2001	H. Sakamoto
	Version 0.6.2	26-May-2001	H. Sakamoto

*/
//=====================================================================

#ifndef	__KONOECOMMANDVARIABLETABLE_HH
#define	__KONOECOMMANDVARIABLETABLE_HH

#include	<ui/KonoeCommandVariable.hh>
#include	<ui/KonoeSymbolResolver.hh>
#include	<KonoeList.hh>

class	KonoeCommandVariableTable
		: public KonoeList<KonoeCommandVariable>,
		  public KonoeSymbolResolver {

public :
	enum	{	DEFAULT_TABLESIZE = 256		};
protected :

	KChar	* name;

public :
	KonoeCommandVariableTable( KChar * name,
			KInt tablesize = DEFAULT_TABLESIZE );
	~KonoeCommandVariableTable( );

	KonoeSymbol *	findSymbol( const KChar * name );
	KonoeSymbol *	addSymbol( const KChar * name );
	KInt		getSymbolCount( );
	KonoeSymbol	* getSymbol( KInt index );
	KChar		* getResolverName( )	{	return name;	}

};

#endif

