//==================================================================
/*
	KonoeExpression.hh

	Version 0.6.0	09-Dec-2000	H. Sakamoto

*/
//==================================================================

#ifndef	__KONOEEXPRESSION_HH
#define	__KONOEEXPRESSION_HH

#include	<ui/KonoeSymbolResolverList.hh>

class	KonoeExpression	{

public :
	enum	{	MAX_NESTING = 64		};
	enum	{	E_INVALID_SYNTAX = -1,
			E_EMPTY_EXPRESSION = -2,
			E_NESTING_OVERFLOW = -3,
			E_SYMBOL_NOT_FOUND = -4		};
	enum	{	INTEGER,	FLOATING,
			STRING				};
protected :

	enum	{	INITIAL,	TERM,
			END_TERM,	OPERATOR,
			END_OPERATOR			};
	enum	{	STANDBY,	UNARY_OPERATOR,
			FIRST_TERM,	BINARY_OPERATOR,
			SECOND_TERM,	SECOND_OPERATOR	};

	KonoeSymbolResolverList	* resolverlist;

	KInt	nesting;
	KChar	unary_operator[ MAX_NESTING ];
	KChar	binary_operator[ MAX_NESTING ];
	KChar	second_operator[ MAX_NESTING ];
	KInt	first_term[ MAX_NESTING ];
	KInt	second_term[ MAX_NESTING ];
	KInt	mode[ MAX_NESTING ];
	KInt	type[ MAX_NESTING ];

	KInt	evaluate_bracket( KChar * source, KChar ** tail );
	KInt	evaluate_numeric( KChar * source, KChar ** tail );
	KInt	evaluate_symbol( KChar * source, KChar ** tail );
	KInt	do_arithmetic( KInt first, KInt second, KChar op );
	KInt	update_registers( KInt value );
	KChar	* check_symbol_name( KChar * string );

private :
	KInt	numeric_value;
	KonoeSymbol	* symbol;

public :
	KonoeExpression( KonoeSymbolResolverList * resolverlist );
	KInt	evaluate( KChar * string );
	KInt	getType( )	{	return type[ 0 ];	}
	KInt	getNumericValue( )	{
			return first_term[ 0 ];			}
	KInt	isInteger( )	{	return type[ 0 ] == INTEGER;	}
	KInt	toInteger( )	{	return first_term[ 0 ];		}

	KonoeSymbolResolverList	* getResolverList( ) { return resolverlist; }

};

#endif
