//====================================================================
/*

	KonoeKonoeCommander.hh

	Version 0.0.1	 4-Aug-1998	S. Nishida and S. Enomoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	08-Dec-2000	H. Sakamoto


*/
//====================================================================

#ifndef	__KONOEKONOECOMMANDER_HH
#define	__KONOEKONOECOMMANDER_HH

#include	<ui/KonoeCommander.hh>
#include	<system/KonoeObjectStreamOfficer.hh>
#include	<system/KonoeObjectFileOfficer.hh>
#include	<system/KonoeObjectSocketOfficer.hh>
#include	<system/KonoeSystemServiceOfficer.hh>
#include	<analysis/KonoePhysicalValueOfficer.hh>
#include	<analysis/KonoeHistogramOfficer.hh>
#include	<analysis/KonoeDataRecordOfficer.hh>

class	KonoeKonoeCommander	: public KonoeCommander	{
    
  public:
	enum	{	N_OFFICERS = 16,
				// don`t forget user defined officers.
			N_OBJECTSTREAMOBJECTS = 64,
			N_OBJECTFILEOBJECTS = 64,
			N_OBJECTSOCKETOBJECTS = 64,
			N_SYSTEMSERVICEOBJECTS = 64,
			N_PHYSICALVALUEOBJECTS = 64,
			N_HISTOGRAMOBJECTS = 64,
			N_DATARECORDOBJECTS = 64		};
    
  protected:
  // system
    KonoeObjectStreamOfficer	 * objectstreamofficer;
    KonoeObjectFileOfficer	 * objectfileofficer;
    KonoeObjectSocketOfficer	 * objectsocketofficer;
    KonoeSystemServiceOfficer	 * systemserviceofficer;
  // analysis
    KonoePhysicalValueOfficer	 * physicalvalueofficer;
    KonoeHistogramOfficer	 * histogramofficer;
    KonoeDataRecordOfficer	 * datarecordofficer;
  public:
    KonoeKonoeCommander( KChar * name,
	KInt ncommands = KonoeCommander::N_COMMANDS );
    
};

#endif

