//====================================================================
/*

	KonoeOfficer.cc

	Version 0.0.1	 2-Jul-1998	H. Sakamoto
	Version 0.0.2	 1-Aug-1998	Sanshiro Enomoto
	Version 0.4.0	 7-Sep-1998	S. Nishida
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	29-May-2001	H. Sakamoto

*/
//====================================================================

#include	<ui/KonoeOfficer.hh>
#include	<ui/KonoeCommander.hh>
#include	<string.h>
#include	<iostream.h>

KonoeOfficer::KonoeOfficer( KInt ptablesize, KInt ncommands,
		const KChar * name, KInt nclasses ) :
	KonoeList<KonoeOrderly>( ptablesize ),
	KonoeOrderly( ncommands, name ) {
	registeredorderly = new KonoeList<KonoeOrderly>( nclasses );

}

KInt	KonoeOfficer::registerOrderly( KonoeOrderly * orderly ) {

	orderly -> setOfficer( this );
	return registeredorderly -> add( orderly );

}


KonoeOrderly	* KonoeOfficer::findObject( const KChar * name ) {

	KonoeOrderly	* target;
	reset( );
	while( target = next( ) ) {
	  if( strcmp( name, target -> getObjectName( ) ) == 0 )
	    return target;
	}
	return 0;

}

void	KonoeOfficer::printObjectList( ostream & os ) {

	KonoeOrderly	* object;

	reset( );
	while( object = next( ) ) {
	  os << "\t" << object -> getObjectName( ) 
		<< " [ " << object -> getClassName( ) << " ]" << endl;
	}

}

KonoeOrderly	 * KonoeOfficer::hasClass( const KChar * classnm ) {

	KonoeOrderly	* object;

	registeredorderly -> reset( );
	while( object = registeredorderly -> next( ) ) {
	  if( strcmp( classnm, object -> getClassName( ) ) == 0 )
	    return object;
	}
	return 0;

}

KInt	KonoeOfficer::addObject( KonoeOrderly * orderly,
		const KChar * name, KonoeCommand * cmd ) {

	KonoeOrderly	* neworderly;

	neworderly = orderly -> clone( name );
	if( neworderly == 0 ) {
	  cout << "Error in cloning. No orderly generated" << endl;
	  return -1;
	}
	neworderly -> createObject( cmd );
	return add( neworderly );

}


void	KonoeOfficer::printClassList( ostream & os ) {

	KonoeOrderly	* orderly;

	registeredorderly -> reset( );
	while( orderly = registeredorderly -> next( ) ) {
	  os << "\t" << orderly -> getClassName( ) << endl;
	}
}

void		KonoeOfficer::setCommander(KonoeCommander *pcommander) {

	commander = pcommander;

}

KonoeCommander  * KonoeOfficer::getCommander( ) {

	return commander;

}


