//====================================================================
/*

	KonoeOrderly.hh

	Version 0.0.1	02-Jul-1998	H. Sakamoto
	Version 0.4.0	 6-Sep-1998
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
	Version 0.6.1	28-May-2001	H. Sakamoto

*/
//====================================================================

#ifndef	__KONOECOMMANDORDERLY_HH
#define	__KONOECOMMANDORDERLY_HH

#include	<KonoePrimitives.hh>
#include	<KonoeList.hh>
#include	<ui/KonoeCommandProcessor.hh>
#include	<ui/KonoeCommand.hh>

class	KonoeOfficer;

class	KonoeOrderly {

public :
	enum	{	INTEGER = KonoeArgumentDescriptor::INTEGER,
			FLOATING = KonoeArgumentDescriptor::FLOATING,
			STRING = KonoeArgumentDescriptor::STRING,
			KEYWORD = KonoeArgumentDescriptor::KEYWORD	};
	enum	{	OPTIONAL = KonoeArgumentDescriptor::OPTIONAL,
			NECESSARY = KonoeArgumentDescriptor::NECESSARY	};

protected :
	KChar		* objectname;
	KonoeList<KonoeCommandProcessor>	* commandlist;
	KonoeOfficer	* officer;
	KInt		classid;

public :
	KonoeOrderly( KInt tablesize, const KChar * name );
	~KonoeOrderly( );
	const KChar	* getObjectName( ) const;
	KInt		addCommand( KonoeCommandProcessor * cmd );
	KonoeCommandProcessor	* hasMethod( const KChar * method );
	KInt		getCommandCount( );
	void		setOfficer( KonoeOfficer * officer );
	KonoeOfficer	* getOfficer( )	{
			return officer;	}
	void		setClassID( KInt pclassid ) {
			classid = pclassid;		}
	KInt		getClassID( ) {
			return classid;			}

	virtual void	printHelp( KonoeCommand * command, ostream & os );
	virtual const KChar	* getClassName( ) = 0;
	virtual KInt	execute( KonoeCommand * command, KInt flag = 0 );
	virtual KInt	createObject( KonoeCommand * command );
	virtual KInt	deleteObject( KonoeCommand * command );
	virtual KInt	showTarget( KonoeCommand * command );
	virtual KInt	isOrderlyOf( void * address );
	virtual KonoeOrderly	* clone( const KChar * name );
	virtual	void *	getTarget( );
	virtual	void 	setTarget( void * ptarget);

};

#endif
