//=================================================================
/*

	KonoeRandomNumber.cc

	Version 0.3.0	06-Jun-1998	Sanshiro Enomoto

*/
//=================================================================


#include <stdlib.h>
#include <sys/time.h>
#include <math.h>
#include <KonoePrimitives.hh>
#include "KonoeRandomNumber.hh"


void KonoeRandomNumber::initialize(long seed)
{
    srand48(seed);
}

void KonoeRandomNumber::initialize(void)
{
    srand48(time(NULL));
}

// return non-negative long integers 
// uniformly distributed over the interval [0, 2**31)
KInt KonoeRandomNumber::getInt(void)
{
    return lrand48();
}

// return signed long integers
// uniformly distributed over the interval [-2**31, 2**31)
KInt KonoeRandomNumber::getSignedInt(void)
{
    return mrand48();
}

// return non-negative double-precision floating-point values
// uniformly distributed over the interval [0.0, 1.0)
KFloat KonoeRandomNumber::getFloat(void)
{
    return drand48();
}
