//=====================================================================
/*

    HistoDrawDemo.cc

    Version 0.0.1   31-Aug-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include "HistoDrawDemo.hh"

#include <iostream.h>

#include <ui/KonoeTclDrawCanvas.hh>
#include <ui/KonoeTclDrawPanel.hh>
#include <ui/KonoeTclDimension.hh>
#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeLinearDataScale.hh>

HistoDrawDemo::HistoDrawDemo()
{ ; }

HistoDrawDemo::HistoDrawDemo(KonoeTclWindow* kwin, char* kname)
{

  KonoeTclFrame* frm1 = new KonoeTclFrame(kwin, "f1");
  KonoeTclFrame* frm2 = new KonoeTclFrame(kwin, "f2");

  testHisto1 =
     new Konoe1DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 40 ) );

  testHisto1->clear();
  for(int i = 0; i < 20; i++ )
  testHisto1->fill( new KonoeFillData( 50.0 ) );
  for(int i = 0; i < 10; i++ )
  testHisto1->fill( new KonoeFillData( 12.0 ) );
  for(int i = 0; i < 5; i++ )
  testHisto1->fill( new KonoeFillData( 48.0 ) );
  for(int i = 0; i < 40; i++ )
  testHisto1->fill( new KonoeFillData( 90.0 ) );
  for(int i = 0; i < 90; i++ )
  testHisto1->fill( new KonoeFillData( 9.0 ) );

  testHisto1->dump(cout);

  
  testHisto2 =
      new Konoe1DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 40 ) );

  testHisto2->clear();
  for(int i = 0; i < 20; i++ )
  testHisto2->fill( new KonoeFillData( 90.0 ) );
  for(int i = 0; i < 10; i++ )
  testHisto2->fill( new KonoeFillData( 80.0 ) );
  for(int i = 0; i < 5; i++ )
  testHisto2->fill( new KonoeFillData( 60.0 ) );
  for(int i = 0; i < 90; i++ )
  testHisto2->fill( new KonoeFillData( 10.0 ) );
  for(int i = 0; i < 70; i++ )
  testHisto2->fill( new KonoeFillData( 19.0 ) );

  testHisto2->dump(cout);

  testPanel1 = new KonoeTclDrawPanel( frm1, "testpanel1");
  testPanel2 = new KonoeTclDrawPanel( frm1, "testpanel2");
  testPanel3 = new KonoeTclDrawPanel( frm2, "testpanel3");
  testPanel4 = new KonoeTclDrawPanel( frm2, "testpanel4");

  testCanvas1 =
    new KonoeTclDrawCanvas( testPanel1, "testcanvas1", testHisto1,
                            KonoeTclDimension(200,150),
                            "test 1",
                            new KonoeLinearDataScale(0.0,100.0,100));

  testCanvas2 =
    new KonoeTclDrawCanvas( testPanel2, "testcanvas2", testHisto2,
                              KonoeTclDimension(100, 200),
                              "test 2",
                              new KonoeLinearDataScale(0.0,100.0,100));

  testCanvas3=
    new KonoeTclDrawCanvas( testPanel3, "testcanvas3", testHisto1,
                              KonoeTclDimension(200, 200),
                              "test 3",
                              new KonoeLinearDataScale(0.0,400.0,100));

  testCanvas4 =
    new KonoeTclDrawCanvas( testPanel4, "testcanvas4", testHisto2,
                              KonoeTclDimension(250, 100),
                              "test 4",
                              new KonoeLinearDataScale(0.0,150.0,100));

 
  testPanel1->setCanvas( testCanvas1, "TESTDATA1" );
  testPanel2->setCanvas( testCanvas2, "TESTDATA2" );
  testPanel3->setCanvas( testCanvas3, "TESTDATA1" );
  testPanel4->setCanvas( testCanvas4, "TESTDATA2" );

  frm1->setLayoutType("left");
  frm1->setFrame();
  frm2->setLayoutType("left");
  frm2->setFrame();
}

HistoDrawDemo::~HistoDrawDemo()
{
  delete testHisto1;
  delete testHisto2;
  delete testCanvas1;
  delete testCanvas2;
  delete testCanvas3;
  delete testCanvas4;
  delete testPanel1;
  delete testPanel2;
  delete testPanel3;
  delete testPanel4;
}
