
/*

    EventDemo.cc

    Version 0.0.1   24-Nov-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <EventDemo.hh>

#include <ui/KonoeTclDrawPanel.hh>
#include <ui/KonoeTclPhysPlacement.hh>
#include <ui/KonoeTclEventViewCanvas.hh>
#include <ui/KonoeTclDrawableBox.hh>
#include <ui/KonoeTclDrawableHorizonLine.hh>
#include <ui/KonoeTclDrawableVerticalLine.hh>
#include <ui/KonoeTclRotationMatrix.hh>
#include <ui/KonoeTcl3DVector.hh>

EventDemo::EventDemo(KonoeTclWindow* kwin, KChar* kname)
{
  KInt i;


  myPhys1 = new KonoeTclPhysPlacement*[400];
  myPhys2 = new KonoeTclPhysPlacement*[100];
  myPhys3 = new KonoeTclPhysPlacement*[100];
  myPhys4 = new KonoeTclPhysPlacement*[100];
  myPhys5 = new KonoeTclPhysPlacement*[100];
  myPhys6 = new KonoeTclPhysPlacement*[100];
  myPhys7 = new KonoeTclPhysPlacement*[100];
  myPhys8 = new KonoeTclPhysPlacement*[100];
  myPhys9 = new KonoeTclPhysPlacement*[100];

  for(i=0; i<400; i++)
    myPhys1[i] = new KonoeTclPhysPlacement;

  for(i=0; i<100; i++){
    myPhys2[i] = new KonoeTclPhysPlacement;
    myPhys3[i] = new KonoeTclPhysPlacement;
    myPhys4[i] = new KonoeTclPhysPlacement;
    myPhys5[i] = new KonoeTclPhysPlacement;
    myPhys6[i] = new KonoeTclPhysPlacement;
    myPhys7[i] = new KonoeTclPhysPlacement;
    myPhys8[i] = new KonoeTclPhysPlacement;
    myPhys9[i] = new KonoeTclPhysPlacement;
  }

  createGeometory();

  myPhys1[250]->setVisAtt( 255, 0, 0);
  myPhys1[50]->setVisAtt ( 255, 0, 0);
  myPhys1[50]->setVisAtt ( 255, 0, 0);
  myPhys1[100]->setVisAtt( 255, 0, 0);
  myPhys1[380]->setVisAtt( 255, 0, 0);
  myPhys1[350]->setVisAtt( 255, 0, 0);
  myPhys1[300]->setVisAtt( 255, 0, 0);
  myPhys2[50]->setVisAtt( 255, 0, 0);
  myPhys3[1]->setVisAtt( 255, 0, 0);
  myPhys4[1]->setVisAtt( 255, 0, 0);
  myPhys5[99]->setVisAtt( 255, 0, 0);
  myPhys6[30]->setVisAtt( 255, 0, 0);
  myPhys7[80]->setVisAtt( 255, 0, 0);
  myPhys8[30]->setVisAtt( 255, 0, 0);
  myPhys9[60]->setVisAtt( 255, 0, 0);

  testPanel1 = new KonoeTclDrawPanel( kwin, kname );
  testEventViewer1 = new KonoeTclEventViewCanvas( 
                testPanel1, "testeventview1",
                KonoeTclDimension( 950, 550 ), "test1", 1200 );
  testEventViewer1->setSize(950, 550);

  testEventViewer1->setPhysicalVolume( myPhys1, 300, 700 );
  testEventViewer1->setPhysicalVolume( myPhys2, 0, 100 );
  testEventViewer1->setPhysicalVolume( myPhys3, 100, 200 );
  testEventViewer1->setPhysicalVolume( myPhys4, 200, 300 );
  testEventViewer1->setPhysicalVolume( myPhys5, 700, 800 );
  testEventViewer1->setPhysicalVolume( myPhys6, 800, 900 );
  testEventViewer1->setPhysicalVolume( myPhys7, 900, 1000 );
  testEventViewer1->setPhysicalVolume( myPhys8, 1000, 1100 );
  testEventViewer1->setPhysicalVolume( myPhys9, 1100, 1200 );

  testPanel1->setCanvas( testEventViewer1, "EventDisplaytest" );

  testEventViewer1->draw( );
  testEventViewer1->update();
}

EventDemo::~EventDemo()
{ ; }

void EventDemo::createGeometory()
{
  KonoeTclDrawableBox* myCalBox= new KonoeTclDrawableBox("MyCal", 10, 10, 10);
  KonoeTclRotationMatrix rm;
  rm.rotateZ(0);

  KonoeTclDrawableHorizonLine* myHolLine 
                = new KonoeTclDrawableHorizonLine( "MyHolLine", 100 );
  KonoeTclRotationMatrix rm2;
  rm2.rotateZ(0);

  KonoeTclDrawableVerticalLine* myVerLine
                = new KonoeTclDrawableVerticalLine( "MyVerLine", 100 );
  KonoeTclRotationMatrix rm3;
  rm3.rotateZ(0);

  KInt copyNo = 0;

  for(KInt i=0; i<20; i++){
    KInt locateX = 200 - i*20;
    for(KInt j=0; j<20; j++){
      KInt locateY = j*20 - 200;

      KonoeTcl3DVector vec1( locateX, locateY, 700 );

      myPhys1[copyNo]
          = new KonoeTclPhysPlacement( KonoeTclTransform(rm, vec1),
                                       myCalBox );
      myPhys1[copyNo]->replace( KonoeTcl2Dimension() );
      myPhys1[copyNo]->setVisAtt(0, 0, 255);
//      myPhys1[copyNo]->setSurf2Mode();
      myPhys1[copyNo]->setForceWireFrame();
      myPhys1[copyNo]->setThinGap();

      copyNo++;
    }
  }

  copyNo = 0;
  for(KInt i=0; i<100; i++){
    KInt locateY = -100 + 2*i;

    KonoeTcl3DVector vec2(0, locateY, 620);

    myPhys2[copyNo] =
        new KonoeTclPhysPlacement(KonoeTclTransform( rm, vec2 ), myHolLine);
    myPhys2[copyNo]->replace ( KonoeTcl2Dimension() );
    myPhys2[copyNo]->setVisAtt( 0, 255, 0);

    copyNo++;
  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateX = 100 - 2*i;

    KonoeTcl3DVector vec3(locateX, 0, 600);

    myPhys3[copyNo] =
      new KonoeTclPhysPlacement(KonoeTclTransform( rm3, vec3 ), myVerLine);
    myPhys3[copyNo]->replace (KonoeTcl2Dimension());
    myPhys3[copyNo]->setVisAtt( 0, 0, 255);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateY = -100 + 2*i;

    KonoeTcl3DVector vec4(0, locateY, 500);

    myPhys4[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm, vec4), myHolLine);
    myPhys4[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys4[copyNo]->setVisAtt( 0, 255, 0);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateX = 100 - 2*i;

    KonoeTcl3DVector vec5(locateX, 0, 480);

    myPhys5[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm3, vec5), myVerLine);
    myPhys5[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys5[copyNo]->setVisAtt( 0, 0, 255);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateY = -100 + 2*i;

    KonoeTcl3DVector vec6(0, locateY, 300);

    myPhys6[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm, vec6), myHolLine);
    myPhys6[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys6[copyNo]->setVisAtt( 0, 255, 0);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateX = 100 - 2*i;

    KonoeTcl3DVector vec7(locateX, 0, 280);

    myPhys7[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm3, vec7), myVerLine);
    myPhys7[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys7[copyNo]->setVisAtt( 0, 0, 255);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateY = -100 + 2*i;

    KonoeTcl3DVector vec8(0, locateY, 200);

    myPhys8[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm, vec8), myHolLine);
    myPhys8[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys8[copyNo]->setVisAtt( 0, 255, 0);

    copyNo++;

  }

  copyNo = 0;
  for (KInt i=0; i<100; i++) {

    KInt locateX = 100 - 2*i;

    KonoeTcl3DVector vec9(locateX, 0, 180);

    myPhys9[copyNo] =
       new KonoeTclPhysPlacement(KonoeTclTransform(rm3, vec9), myVerLine);
    myPhys9[copyNo]->replace ( KonoeTcl2Dimension ( ) );
    myPhys9[copyNo]->setVisAtt( 0, 0, 255);

    copyNo++;

  }
  
}
