//=====================================================================
/*

    Histo2DrawDemo.cc

    Version 0.0.1   26-Nov-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include "Histo2DrawDemo.hh"
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTcl2DrawCanvas.hh>
#include <ui/KonoeTcl2DrawPanel.hh>
#include <ui/KonoeTclDimension.hh>
#include <analysis/Konoe2DHistogram.hh>
#include <analysis/KonoeLinearDataScale.hh>
#include <analysis/KonoeFillData.hh>
#include <stdlib.h>
#include <math.h>

Histo2DrawDemo::Histo2DrawDemo(KonoeTclWindow* kwin, KChar* kname)
{
  testHisto = new Konoe2DHistogram( new KonoeLinearDataScale( 0.0, 100.0, 20 ),
                                   new KonoeLinearDataScale( 0.0, 100.0, 20 ) );
  testHisto->clear();

  for (KInt i=0; i<20000; i++){
    testHisto->fill( new KonoeFillData( gaussrand(), gaussrand() ) );
  }

  testPanel1 = new KonoeTcl2DrawPanel( kwin, kname );
  testCanvas1 = new KonoeTcl2DrawCanvas( testPanel1, "testcanvas", testHisto,
                                         KonoeTclDimension(300, 300),
                                         "test1",
                                  new KonoeLinearDataScale(0.0, 1000.0,1000) );

  testPanel1->setCanvas( testCanvas1, "TEST DATA1" );
  testPanel1->setFrame();
  testCanvas1->setSize(550, 500);
  testCanvas1->draw();
}

Histo2DrawDemo::~Histo2DrawDemo()
{
  delete testHisto;
  delete testCanvas1;
  delete testPanel1;
}

KFloat Histo2DrawDemo::gaussrand()
{
  KFloat V1 = 0, V2 = 0, S = 0;
  KInt phase = 0;
  KFloat X;

  if(phase == 0) {
    do {
      KFloat U1 = drand48();
      KFloat U2 = drand48();

      V1 = 2 * U1 - 1;
      V2 = 2 * U2 - 1;
      S = V1 * V1 + V2 * V2;
    } while(S >= 1 || S == 0);

    X = V1 * sqrt(-2 * log(S) / S);
  } else
    X = V2 * sqrt(-2 * log(S) / S);

  phase = 1 - phase;

  X = X*10+50;
  return X;
}
