//=====================================================================
/*

    StatusViewer.hh

    Version 0.0.1   16-Dec-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __STATUSVIEWER_HH
#define __STATUSVIEWER_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseAction.hh>

class KonoeTclWindow;
class KonoeTclDrawCanvas;
class KonoeTclDrawPanel;
class Konoe1DHistogram;
class KonoeTclButton;
class KonoeTclEntry;
class KonoeInputObjectStream;
class KonoeClientSocket;

class StatusViewer : public KonoeTclEventProcessor,
                     public KonoeTclMouseAction {

  public:
    StatusViewer(KonoeTclWindow* kwin, KChar* kname);
    ~StatusViewer();

    void connectButtonAction();
    void disConnectButtonAction();
    void startButtonAction();
    void stopButtonAction();

    void mouseAction( KonoeTclButton* kbtn, KInt type, KInt button,
                      Time time, KInt x, KInt y);

  private:

    KonoeTclDrawCanvas* testCanvas;
    KonoeTclDrawPanel* testPanel;
    Konoe1DHistogram* testHisto;

    KonoeTclButton* startButton;
    KonoeTclButton* stopButton;
    KonoeTclButton* connectButton;
    KonoeTclButton* disConnectButton;

    KonoeTclEntry* txthost;
    KonoeTclEntry* txtport;

    KChar connectSite[256];
    KInt connectPort;

    KonoeInputObjectStream* in;
    KonoeClientSocket* socket;

    KInt startflag;
};

#endif
