//=====================================================================
/*

    demosend.cc

    Version 0.0.1   16-Dec-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <system/KonoeServerSocket.hh>
#include <system/KonoeOutputObjSocket.hh>
#include <system/KonoeOutputObjFile.hh>

#include <analysis/Konoe1DHistogram.hh>
#include <analysis/KonoeLinearDataScale.hh>
#include <analysis/KonoeFillData.hh>

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, KChar* argv[])
{
  KInt port = 12000;

  if(argc > 1) port = atoi( argv[1] );

  KonoeOutputObjectStream* out1;

  KonoeServerSocket* socket1 = new KonoeServerSocket( port );
  out1 = new KonoeOutputObjSocket( socket1 );

  cerr << "waiting for connection(1)...";
    while ( socket1->waitConnection() == -1);
  cerr << " done." << endl;

  KonoeLinearDataScale* scale1 =
                    new KonoeLinearDataScale( 0.0, 100.0, 100);
  Konoe1DHistogram* histogram1 =
                    new Konoe1DHistogram( scale1 );

  KonoeStreamableObject* object1;

  KInt n = 0;

  while (1) {
    cout << "--- No. " << ++n << " ---" << endl;

    histogram1->clear();

    for( KInt i=0; i<100; i++ ){
      KFloat e = drand48()*50.;
      for( KInt j=0; j<(KInt)e; j++ ){
        KonoeFillData* data1 = new KonoeFillData(i);
        histogram1->fill( data1 );
        delete data1;
      }
    }

    object1 = histogram1;
    histogram1->dump( cout );
    out1->put( object1 );

    sleep(1);

  }

  return 0;
}
