#include "action.hh"
#include <string.h>

action::action(KonoeTclWindow* kwin)
{
  canvas = new KonoeTclCanvas(kwin, "canvas1");
  button1 = new KonoeTclButton(kwin, "button1", "Clear");
  button2 = new KonoeTclButton(kwin, "button2", "Exit");

  canvas->setEventProcessor(this);
  button1->setEventProcessor(this);
  button2->setEventProcessor(this);

  canvas->setBackGround("white");

  addMouseAction(button1);
  addMouseAction(button2);

  addTimer(canvas, 1000);
}

void action::mouseAction(KonoeTclButton* kbtn, KInt type,
                                     KInt button, Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
  if( 0<=x && x<kbtn->getWidth() && 0<=y && y<=kbtn->getHeight()){
    if(strcmp(kbtn->getName(), "button1") == 0)
      canvas->clearAll();
    else if(strcmp(kbtn->getName(), "button2") == 0){
      exit(0);
    }
  }
  }
}

void action::timer()
{
  static KInt x = 0;
  static KInt y = 0;
  static KInt w = 10;
  static KInt h = 10;

  canvas->setColor(200-x, 200-y, 255);
  canvas->drawRectangle(x, y, w, h);

  x += 10;
  y += 10;
}
