//=====================================================================
/*

    sample.cc

    Version 0.0.1   23-Jan-2001 T. Hosoi

*/
//====================================================================

#include "sample.hh"

sample::sample(KonoeTclWindow* kwin)
{
  initWidget(kwin);
}

sample::~sample()
{
  delete mainMenu;
  delete fileMenu;
  delete editMenu;
  delete listBox;
  delete itemLabel;
  delete itemEntry;
  delete addButton;
  delete frame;
}

void sample::initWidget(KonoeTclWindow* kwin)
{
//create new widget
  mainMenu = new KonoeTclMenu(kwin, "mainMenu");
  fileMenu = new KonoeTclMenu(mainMenu, "fileMenu");
  editMenu = new KonoeTclMenu(mainMenu, "editMenu");

  listBox = new KonoeTclListBox(kwin, "listBox", KVertical);

  frame = new KonoeTclFrame(kwin, "f");

  itemLabel = new KonoeTclLabel(frame, "itemLabel", "Item Label", 0, 0);
  itemEntry = new KonoeTclEntry(frame, "itemEntry", 0, 1);
  addButton = new KonoeTclButton(frame, "addButton", "Add", 1, 1);

  frame->setFrame();

//configuration of widget
  mainMenu->makeCascade(fileMenu, "File");
  mainMenu->makeCascade(editMenu, "Edit");
  fileMenu->addCommand("Exit", "exit");
  editMenu->addCommand("Bell", "bell");

  listBox->setBackGround("white");
  listBox->fillBoth();
  listBox->setExpand();

  itemEntry->setBackGround("white");
  itemEntry->setSize(20);

//add mouse listener
  addButton->addMouseListener(this);
}

void sample::mouseEvent(KonoeTclUIPrimitive* wid, KInt type, KInt button,
                                                 Time time, KInt x, KInt y)
{
  if(type == KMouseRelease && button == LButton){
    if( 0<=x && x<wid->getWidth() && 0<=y && y<=wid->getHeight()){
      if( strlen(itemEntry->getText()) > 0 )
        listBox->insert(itemEntry->getText());
    }
  }
}
