//=====================================================================
/*

    KonoeTclBalloon.cc

    Version 0.0.1   07-Jun-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclBalloon.hh>

KonoeTclBalloon::KonoeTclBalloon()
{
  defineBalloon();
}

KonoeTclBalloon::KonoeTclBalloon(KonoeTclUIPrimitive* widget, KChar* message)
{
  defineBalloon();
  setBalloon(widget, message);
}

KonoeTclBalloon::~KonoeTclBalloon()
{ ; }

void KonoeTclBalloon::defineBalloon()
{
  KChar* cmd = "namespace eval Balloon {\n"
"\n"
  "bind Bulle <ButtonRelease> {\n"
    "if {$Bulle(set) == 1 } {\n"
      "Balloon::kill_balloon\n"
    "}\n"
    "set Bulle(set) 0\n"
    "set Bulle(first) 1\n"
    "set Bulle(id) [after 500 {Balloon::balloon %W $Bulle(%W) %X %Y}]\n"
  "}\n"
"\n"
  "bind Bulle <Leave> {\n"
    "set Bulle(first) 0\n"
    "Balloon::kill_balloon\n"
  "}\n"
"}\n"
"\n"
"set Bulle(set) 0\n"
"set Bulle(first) 0\n"
"set Bulle(id) 0\n"
"\n"
"proc Balloon::set_balloon {target message} {\n"
    "global Bulle\n"
    "set Bulle($target) $message\n"
    "bindtags $target \"[bindtags $target] Bulle\"\n"
"}\n"
"\n"
"proc Balloon::kill_balloon {} {\n"
    "global Bulle\n"
    "after cancel $Bulle(id)\n"
    "if {[winfo exists .balloon] == 1} {\n"
        "destroy .balloon\n"
    "}\n"
    "set Bulle(set) 0\n"
"}\n"
"\n"
"proc Balloon::balloon {target message {cx 0} {cy 0} } {\n"
    "global Bulle\n"
    "if {$Bulle(first) == 1 } {\n"
        "set Bulle(first) 2\n"
    "if { $cx == 0 && $cy == 0 } {\n"
        "set x [expr [winfo rootx $target] + ([winfo width $target]/2)]\n"
        "set y [expr [winfo rooty $target] + [winfo height $target] + 4]\n"
    "} else {\n"
        "set x [expr $cx + 10]\n"
        "set y [expr $cy + 4]\n"
    "}\n"
        "toplevel .balloon -bg black\n"
        "wm overrideredirect .balloon 1\n"
        "label .balloon.l \\\n"
            "-text $message -relief flat \\\n"
            "-bg #ffffaa -fg black -padx 2 -pady 0 -anchor w\n"
        "pack .balloon.l -side left -padx 1 -pady 1\n"
        "wm geometry .balloon +${x}+${y}\n"
        "set Bulle(set) 1\n"
    "}\n"
"}\n";

  configCommand(cmd);
}

void KonoeTclBalloon::setBalloon(KonoeTclUIPrimitive* widget, KChar* message)
{
  KChar cmd[256];
  sprintf(cmd,"Balloon::set_balloon %s \"%s\"", widget->getPath(), message);
  configCommand(cmd);
}
