//=====================================================================
/*

    KonoeTclFMCanvas.cc

    Version 0.5.0   08-Sep-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMCanvas.hh>
#include <KonoeTclFMManager.hh>
#include <KonoeTclFMEntry.hh>
#include <KonoeTclFMIconData.hh>

#include <stdlib.h>
#include <string.h>

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclFrame.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclImage.hh>
#include <ui/KonoeTclDimension.hh>


#include <system/KonoeFileManagerCM.hh>
#include <system/KonoeFileManageServer.hh>
#include <system/KonoeFileRequest.hh>
#include <system/KonoeDirectoryRequest.hh>
#include <system/KonoePath.hh>
#include <system/KonoeNetworkFileManager.hh>
#include <system/KonoeTimeData.hh>
#include <system/KonoeFileStatus.hh>

class KonoeTclImage;

KonoeTclFMCanvas::KonoeTclFMCanvas(KonoeTclWindow* kwin, KChar* kname,
                                   KScrollType scrl)
  : KonoeTclCanvas(kwin, kname, scrl)
{
  kicondata = new KonoeTclFMIconData;
  comp = new KonoeTclImage("comp");
  dir  = new KonoeTclImage("dir");
  text = new KonoeTclImage("text");
  hist = new KonoeTclImage("hist");
  selectedStartX = 0;
  selectedStartY = 0;
}

KonoeTclFMCanvas::~KonoeTclFMCanvas()
{
  delete kicondata;
  delete comp;
  delete dir;
  delete text;
  delete hist;
}

void KonoeTclFMCanvas::getInfo(KFileMode mode)
{
  KChar dirName[256];
  KChar fullPath[256];
  KChar iconName[32];

cout << "1111111111111111111111!" << endl;
  kPath = new KonoePath( kfmgr->getSystemPath() );
  kDirInfo = kNetManager->getDirectoryInfomation(kPath);
  delete kPath;
cout << "22222222222222222222222" << endl;
  if(kDirInfo==0){
    cout << "DirectoryInfo get error" << endl;
  }
  else if( !kDirInfo->isNormal() ){
    KInt st;
    st = kDirInfo->getStatus();
    directoryInfoError(st);
cout << "3333333333333333333333" << endl;
  }
  else{
    kDirInfo->reset();
cout << "3333333333333333333333" << endl;
    fileCount = kDirInfo->getCount();
cout << "44444444444444444444" << endl;
    createFileName();
cout << "5555555555555555555" << endl;
    initFileStatus();
cout << "6666666666666666666" << endl;
    selectionFiles(mode);
cout << "777777777777777777" << endl;
    //strcpy(directoryName, kDirInfo->getDirectoryName());

    createIconImage();
cout << "888888888888888888" << endl;
    createIconXY();
cout << "999999999999999999" << endl;

    setIconType();
cout << "00000000000000000" << endl;
    setIconXY();

//    setScrollregion(getWidth(), iconXY[fileCount-1]->getHeight()+50);
  }
cout << "End of Cavas::getInfo" << endl;
}

void KonoeTclFMCanvas::selectionFiles(KFileMode mode)
{
  KInt realNum = 0;
  KonoeFileStatus* tmpfs;

  switch(mode){
    case KAllFiles:
      fileNameSort();
      break;
    case KHiddenFiles:
      for(KInt i=0; i < fileCount; i++){
        if(strcmp(fileName[i],".")==0 || strcmp(fileName[i],"..")==0){
          tmpfs = kFileStatus[i];
          kFileStatus[realNum] = tmpfs;
          realNum++;
        }
        else if(fileName[i][0] != '.'){
          tmpfs = kFileStatus[i];
          kFileStatus[realNum] = tmpfs;
          realNum++;
        }
      }
      fileCount = realNum;
      fileNameSort();
      break;
    default :
      ;
  }
}

void KonoeTclFMCanvas::buildGUI()
{
  cout << "Build GUI" << endl;
}

void KonoeTclFMCanvas::refresh()
{
cout << "DDDDDDD" << endl;
  KonoeTclCanvas::clearAll();
cout << "EEEEEEE" << endl;
  deleteFileName();
cout << "FFFFFFF" << endl;
  deleteIconImage();
cout << "GGGGGGG" << endl;
  deleteIconXY();
cout << "HHHHHHH" << endl;
  //getInfo(KHiddenFiles);
  getInfo(KAllFiles);
cout << "IIIIIII" << endl;
  drawIcon();
cout << "JJJJJJJ" << endl;
  setIconType();
cout << "KKKKKKK" << endl;
  setIconXY();
cout << "LLLLLLL" << endl;
}

void KonoeTclFMCanvas::selectClear()
{
  selected = 0;
}

void KonoeTclFMCanvas::directoryInfoError(KInt st)
{
  if( st == KonoeDirectoryInfomation::E_NOTEXIST ){
    cout << "not exist " << endl;
  }
  else if( st == KonoeDirectoryInfomation::E_PERMISSINDENIED ){
    cout << "permission denied" << endl;
  }
  else if( st == KonoeDirectoryInfomation::E_NOTDIRECTORY ){
    cout << "not directory" << endl;
  }
}

void KonoeTclFMCanvas::createIconImage()
{
    KChar iconName[16];
    iconImageType = new KInt[fileCount];

    iconImage = new KonoeTclImage*[fileCount];
    for(KInt i=0; i<fileCount; i++){
      sprintf(iconName, "iconimage_no_%d", i);
      iconImage[i] = new KonoeTclImage(iconName);
    }
}

void KonoeTclFMCanvas::createIconXY()
{
    iconXY = new KonoeTclDimension*[fileCount];
    for(KInt i=0; i<fileCount; i++){
      iconXY[i] = new KonoeTclDimension(0, 0);
    }
}

void KonoeTclFMCanvas::createFileName()
{
  fileName = new KChar*[fileCount];
  for(KInt i=0; i<fileCount; i++){
    fileName[i] = new KChar[256];
  }
}

void KonoeTclFMCanvas::deleteIconImage()
{
  delete [] iconImageType;
  if(iconImage!=NULL){
    for(KInt i=0; i< fileCount; i++){
      delete iconImage[i];
    }
    delete iconImage;
  }
}

void KonoeTclFMCanvas::deleteIconXY()
{
  if(iconXY!=NULL){
    for(KInt i=0; i< fileCount; i++){
      delete iconXY[i];
    }
    delete iconXY;
  }
}

void KonoeTclFMCanvas::deleteFileName()
{
  if(kFileStatus!=NULL && fileName!=NULL){
    for(KInt i=0; i<fileCount; i++){
      delete kFileStatus[i];
      delete fileName[i];
    }
    delete kFileStatus;
    delete fileName;
  }
}

void KonoeTclFMCanvas::initFileStatus()
{
  kFileStatus = new KonoeFileStatus*[fileCount];

  KChar tmpFile[256];

  for(KInt i=0; i<fileCount; i++){
    kFileInfo = kDirInfo->next();
    kFileStatus[i] = kFileInfo->getFileStatus();
    strcpy(tmpFile, kFileStatus[i]->getFileName());

    strcpy(tmpFile, strrchr(tmpFile, '/'));
    strcpy(fileName[i], strtok(tmpFile, "/"));
  }
}

KInt KonoeTclFMCanvas::getIconType(KInt id)
{
  return  iconImageType[id];
}

void KonoeTclFMCanvas::setIconType()
{
  for(KInt i=0; i<fileCount; i++){
//    if( kFileStatus->isComputer() ){
//      iconImageType[i] = KonoeTclFMCanvas::KComputer;
//    }
    if( kFileStatus[i] == NULL ) {
      cerr << "FileStatus is NULL" << endl;
    }
    else if( kFileStatus[i]->isDirectory() ) {
      iconImageType[i] = KonoeTclFMCanvas::KDirectory;
    }
    else if( kFileStatus[i]->isRegularFile() ) {
      iconImageType[i] = KonoeTclFMCanvas::KFile;
    }
//    else if( kFileStatus[i]->isHistogram() ) {
//      iconImageType[i] = KonoeTclFMCanvas::KHistogram;
//    }
    else{
      iconImageType[i] = KonoeTclFMCanvas::KFile;
    }
  }
}

void KonoeTclFMCanvas::setCanvasWindowSize()
{
  KInt sx;
  KInt sy;
  sx = parentWindow->getWidth();
  sy = parentWindow->getHeight();

  setSize( sx, sy );
}

void KonoeTclFMCanvas::cd(KChar* _path)
{
  KonoePath* kNetPath = new KonoePath(_path);
  kNetManager->cd(kNetPath);
  delete kNetPath;
  sprintf(kSystemPath, "%s", kNetManager->getPWD());
  kfmgr->setSystemPath( kSystemPath );
  kfmgr->getEntry()->setText(kSystemPath);
//kNetManager->cp("asaix2.cc.it-hiroshima.ac.jp", "abc", "asaix2.cc.it-hiroshima.ac.jp", "abcd", 29);
}

void KonoeTclFMCanvas::fileNameSort()
{
  KonoeFileStatus* tmp;

  for (KInt i = 0; i < fileCount - 1; i++) {
    for (KInt j = 0; j < fileCount - 1 - i; j++) {
      if (strcmp(kFileStatus[j]->getFileName(), 
                 kFileStatus[j + 1]->getFileName()) > 0) {
        tmp  = kFileStatus[j];
        kFileStatus[j] = kFileStatus[j + 1];
        kFileStatus[j + 1] = tmp;
      }
    }
  }
}
