//=====================================================================
/*

    KonoeTclFMEntry.cc

    Version 0.5.0   04-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMEntry.hh>
#include <KonoeTclFMManager.hh>
#include <KonoeTclFMCanvas.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclWindow.hh>

KonoeTclFMEntry::KonoeTclFMEntry(KonoeTclFMManager* _kfmgr, KonoeTclWindow* kwin)
  : KonoeTclEntry(kwin, "fmentry")
{
  kfmgr = _kfmgr;
  kfmgr->setEntry( this );
  parentWindow = kwin;
  //create(kwin, "fmentry");

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());

  KonoeTclMouseAction::addMouseAction( (KonoeTclEntry*) this );
  KonoeTclKeyAction::addKeyAction( (KonoeTclEntry*) this );
  KonoeTclUIPrimitive::setEventProcessor( (KonoeTclEventProcessor*) this );

  fillX();
  setBackGround("white");

  setText(kfmgr->getSystemPath());
}

KonoeTclFMEntry::~KonoeTclFMEntry()
{ ; }

void KonoeTclFMEntry::mouseAction(KonoeTclEntry* ket, KInt type, KInt button,
                                  Time time, KInt x, KInt y)
{
}

void KonoeTclFMEntry::keyAction(KonoeTclEntry* ket, KInt type, KeySym keysym,
                                KInt state)
{
  if(type == KKeyPress) 
  if(keysym == XK_Return){
    kfmgr->setSystemPath(getText());
    kfmgr->getCanvas()->cd(getText());
    kfmgr->getCanvas()->refresh();
  }
}
