//=====================================================================
/*

    KonoeTclFMFileStatus.cc

    Version 0.0.1   01-Feb-2000 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMFileStatus.hh>
#include <system/KonoeTimeData.hh>
#include <stdio.h>
#include <string.h>

KonoeTclFMFileStatus::KonoeTclFMFileStatus()
{ ; }

KonoeTclFMFileStatus::~KonoeTclFMFileStatus()
{ cout << "29857393846592836598256" << endl; }

KChar* KonoeTclFMFileStatus::getAccessPermission()
{
  KInt u_status = 0;
  KInt g_status = 0;
  KInt o_status = 0;

  if(userCanRead( ))      u_status+=4;
  if(userCanWrite( ))     u_status+=2;
  if(userCanExecute( ))   u_status+=1;
  if(groupCanRead( ))     g_status+=4;
  if(groupCanWrite( ))    g_status+=2;
  if(groupCanExecute( ))  g_status+=1;
  if(othersCanRead( ))    o_status+=4;
  if(othersCanWrite( ))   o_status+=2;
  if(othersCanExecute( )) o_status+=1;
  sprintf(accessPermission, "%ld%ld%ld", u_status, g_status, o_status);

  return accessPermission;
}


KChar* KonoeTclFMFileStatus::getFileType()
{
  if(isDirectory( )) return "Directory";
  if(isRegularFile( )) return "RegularFile";
  if(isCharacterSpecial( )) return "CharacterSpecial";
  if(isBlockSpecial( )) return "BlockSpecial";
  if(isSocket( )) return "Socket";
  if(isFIFO( )) return "FIFO";
  if(isSymbolicLink( )) return "SymbolicLink";
  else return "??????????";
}

KChar* KonoeTclFMFileStatus::getSize()
{
  sprintf(fileSize, "%ld", getFileSize());
  return fileSize;
}

KChar* KonoeTclFMFileStatus::getLastDataModification()
{
  KonoeTimeData* kt = getTimeOfLastDataModification( );
  sprintf(modTime, "%4ld/%2ld/%2ld %2ld:%2ld:%2ld",
          kt->getYear(), kt->getMonth(), kt->getDay(),
          kt->getHour(), kt->getMinute(), kt->getSecond() );
  return modTime;
}

KChar* KonoeTclFMFileStatus::getLastFileStatusChange()
{
  KonoeTimeData* kt = getTimeOfLastFileSatusChange( );
  sprintf(changeTime, "%4ld/%2ld/%2ld %2ld:%2ld:%2ld",
          kt->getYear(), kt->getMonth(), kt->getDay(),
          kt->getHour(), kt->getMinute(), kt->getSecond() );
  return changeTime;
}
