//=====================================================================
/*

    KonoeTclFMInfoPanel.hh

    Version 0.5.0   28-Oct-1999 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLFMINFOPANEL_HH
#define __KONOETCLFMINFOPANEL_HH

#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseAction.hh>

class KonoeTclWindow;
class KonoeTclSubWindow;
class KonoeTclFrame;
class KonoeTclLabel;
class KonoeTclButton;
class KonoeTclFMManager;
class KonoeFileStatus;

class KonoeTclFMInfoPanel : public KonoeTclEventProcessor,
                            public KonoeTclMouseAction {

  public:
    KonoeTclFMInfoPanel(KonoeTclFMManager* kfmgr, KonoeTclWindow* kwin);
    ~KonoeTclFMInfoPanel();

    void mouseAction( KonoeTclButton* kbtn, KInt type,
                      KInt button, Time time, KInt x, KInt y );

    void setupInformation(KonoeFileStatus* kfs);

  private:
    KonoeTclSubWindow* subwin;

    KonoeTclFrame* frm;

    KonoeTclLabel* lname;
    KonoeTclLabel* lsize;
    KonoeTclLabel* lowner;
    KonoeTclLabel* lgroup;
    KonoeTclLabel* lpermission;
    KonoeTclLabel* ltype;
    KonoeTclLabel* lsynbolic;
    KonoeTclLabel* lmodification;
    KonoeTclLabel* lstatuschange;

    KonoeTclLabel* rname;
    KonoeTclLabel* rsize;
    KonoeTclLabel* rowner;
    KonoeTclLabel* rgroup;
    KonoeTclLabel* rpermission;
    KonoeTclLabel* rtype;
    KonoeTclLabel* rsynbolic;
    KonoeTclLabel* rmodification;
    KonoeTclLabel* rstatuschange;

    KonoeTclButton* okbutton;
  private:
    KChar* getFileName(KonoeFileStatus* kfs);
    KChar* getSize(KonoeFileStatus* kfs);
    KChar* getOwnerName(KonoeFileStatus* kfs);
    KChar* getGroupName(KonoeFileStatus* kfs);
    KChar* getAccessPermission(KonoeFileStatus* kfs);
    KChar* getFileType(KonoeFileStatus* kfs);
    KChar* getLastDataModification(KonoeFileStatus* kfs);
    KChar* getLastFileStatusChange(KonoeFileStatus* kfs);

    KChar fileSize[32];
    KChar accessPermission[32];
    KChar modTime[32];
    KChar changeTime[32];
};

#endif
