//=====================================================================
/*

    KonoeTclFMInputPanel.cc

    Version 0.5.0   26-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMInputPanel.hh>

#include <KonoeTclFMManager.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclSubWindow.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclButton.hh>

KonoeTclFMInputPanel::KonoeTclFMInputPanel(KonoeTclFMManager* _kfmgr,
                                           KonoeTclWindow* _kwin,
                                           KChar* eventname)
{
  subwin = new KonoeTclSubWindow(_kwin, "ip_subwin", "Entry Panel");
//  subwin->create(_kwin, "ip_subwin");

  label = new KonoeTclLabel(subwin, "lbl", "0",0,0);
//  label->create(subwin, "lbl",0,0);
  label->setCaption(eventname);

  entry = new KonoeTclEntry(subwin, "ent",0,1);
  entry->setLayoutType("left");
//  entry->create(subwin, "ent",0,1);

  button = new KonoeTclButton(subwin, "okbutton_ip", "OK", 1,1);
  button->setLayoutType("left");
//  button->create(subwin, "okbutton_ip",1,1);

  addKeyAction(entry);
  entry->setEventProcessor( this );
  addMouseAction(button);
  button->setEventProcessor( this );

  KonoeTclFMEntry* fmentry;
  fmentry = _kfmgr->getEntry();
  entry->setText(fmentry->getText());
}

KonoeTclFMInputPanel::~KonoeTclFMInputPanel()
{
  delete label;
  delete entry;
  delete button;
}

void KonoeTclFMInputPanel::mouseAction( KonoeTclButton* kbtn, KInt type,
                                       KInt button, Time time, KInt x, KInt y )
{
  if(button == LButton ){
    ;
  }
}
