//=====================================================================
/*

    KonoeTclFMManager.cc

    Version 0.5.0   04-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMManager.hh>
#include <KonoeTclFMCanvas.hh>
#include <KonoeTclFMIconCanvas.hh>
#include <KonoeTclFMDetailCanvas.hh>
#include <KonoeTclFMSimpleCanvas.hh>
#include <KonoeTclFMEntry.hh>
#include <KonoeTclFMPopup.hh>
#include <KonoeTclFMPopupMenu.hh>
#include <KonoeTclFMPopupFile.hh>
#include <KonoeTclFMPopupEdit.hh>
#include <KonoeTclFMPopupView.hh>
#include <KonoeTclFMMenu.hh>

#include <ui/KonoeTclMainWindow.hh>
#include <ui/KonoeTclFrame.hh>
#include <system/KonoeFileManagerCM.hh>
#include <system/KonoeFileManageServer.hh>
#include <system/KonoeFileRequest.hh>
#include <system/KonoeDirectoryRequest.hh>
#include <system/KonoeNetworkFileManager.hh>

KonoeTclFMManager::KonoeTclFMManager()
{
  strcpy(kHost, "asaix2.cc.it-hiroshima.ac.jp.jp");
  strcpy(kSystemPath, "/");

  kNetManager = new KonoeNetworkFileManager( kHost );
}

KonoeTclFMManager::KonoeTclFMManager(KChar* _khost, KChar* _kpath)
{
  strcpy(kHost, _khost);
  strcpy(kSystemPath, _kpath);

cout << kHost << " m " << kSystemPath << endl;
  kNetManager = new KonoeNetworkFileManager( kHost );
}

KonoeTclFMManager::~KonoeTclFMManager()
{
  delete kNetManager;
  delete fmcanvas;
  delete fmentry;
  delete fmpopup;
}

void KonoeTclFMManager::go(KInt argc, KChar** argv)
{
  //if(argc==3)
  //kfmgr = new KonoeTclFMManager(argv[1], argv[2]);
  //else
  //kfmgr = new KonoeTclFMManager;

  KonoeTclMainWindow* main = new KonoeTclMainWindow("Konoe filemanager");
  main->setBackGround("white");

  KonoeTclFrame* frm1 = new KonoeTclFrame(main, "frm1");
  KonoeTclFMMenu* menu = new KonoeTclFMMenu(this, frm1);

  KonoeTclFMEntry* ent = new KonoeTclFMEntry(this, frm1);
  frm1->setFrame();
  frm1->fillBoth();

  KonoeTclFMIconCanvas* canvas = new KonoeTclFMIconCanvas(this, main);

  KonoeTclFMPopupMenu* popmenu = new KonoeTclFMPopupMenu(this, main, "popup_menu");

  KonoeTclFMPopupFile* popfile = new KonoeTclFMPopupFile(this, main, "popup_file");

  KonoeTclFMPopupEdit* popedit = new KonoeTclFMPopupEdit(this, main, "popup_edit");

  KonoeTclFMPopupView* popview = new KonoeTclFMPopupView(this, main, "popup_view");

  KChar cmd[256];
  sprintf(cmd, "proc bgerror { msg } { }");
  canvas->configCommand(cmd);
}

void KonoeTclFMManager::setPopupType(KPopupType type)
{
  switch(type){
    case KMenu:
      fmpopup = fmpopupmenu;
      break;
    case KFile:
      fmpopup = fmpopupfile;
      break;
    case KEdit:
      fmpopup = fmpopupedit;
      break;
    case KView:
      fmpopup = fmpopupview;
      break;
    default:
      ;
  }
}

