//=====================================================================
/*

    KonoeTclFMManager.hh

    Version 0.5.0   04-Oct-1999 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLFMMANAGER_HH
#define __KONOETCLFMMANAGER_HH

#include <KonoePrimitives.hh>
#include <KonoeTclFMCanvas.hh>
#include <KonoeTclFMEntry.hh>
#include <KonoeTclFMPopup.hh>
#include <KonoeTclFMMenu.hh>

#include <system/KonoeFileStatus.hh>
#include <system/KonoeNetworkFileManager.hh>
class KonoeTclFMPopupMenu;
class KonoeTclFMPopupFile;
class KonoeTclFMPopupEdit;
class KonoeTclFMPopupView;

enum KPopupType { KMenu, KFile, KEdit, KView };

class KonoeTclFMManager {

  public:
    KonoeTclFMManager();
    KonoeTclFMManager(KChar* _khost, KChar* _kpath);
    ~KonoeTclFMManager();

    void go(KInt argc, KChar** argv);

    inline void setHost(KChar* khost)
           { strcpy(kHost, khost); }
    inline void setSystemPath(KChar* ksyspath)
           { strcpy(kSystemPath, ksyspath); }
    inline void setCanvas(KonoeTclFMCanvas* _fmcanvas)
           { fmcanvas = _fmcanvas; }
    inline void setEntry(KonoeTclFMEntry* _fmentry)
           { fmentry = _fmentry; } 
    inline void setMenu(KonoeTclFMMenu* _fmmenu)
           { fmmenu = _fmmenu; }
    void setPopupType(KPopupType type);
    inline void setPopupMenu(KonoeTclFMPopupMenu* _popup)
           { fmpopupmenu = _popup; } 
    inline void setPopupFile(KonoeTclFMPopupFile* _popup)
           { fmpopupfile = _popup; } 
    inline void setPopupEdit(KonoeTclFMPopupEdit* _popup)
           { fmpopupedit = _popup; } 
    inline void setPopupView(KonoeTclFMPopupView* _popup)
           { fmpopupview = _popup; } 
    inline void setFileStatus(KonoeFileStatus* _kfs)
           { kfs = _kfs; }

    inline KChar* getHost() { return kHost; }
    inline KChar* getSystemPath() { return kSystemPath; }
    inline KonoeTclFMCanvas* getCanvas() { return fmcanvas; }
    inline KonoeTclFMEntry* getEntry() { return fmentry; }
    inline KonoeTclFMMenu* getMenu() { return fmmenu; }
    inline KonoeTclFMPopup* getPopup() { return fmpopup; }
    inline KonoeNetworkFileManager* getNetworkFileManager()
                                       { return kNetManager; }
    inline KonoeFileStatus* getFileStatus(){ return kfs; }

  private:
    KChar kHost[256];
    KChar kSystemPath[256];
    KonoeNetworkFileManager*   kNetManager;

    KonoeTclFMCanvas* fmcanvas;
    KonoeTclFMEntry* fmentry;
    KonoeTclFMMenu* fmmenu;
    KonoeTclFMPopup* fmpopup;
    KonoeTclFMPopupMenu* fmpopupmenu;
    KonoeTclFMPopupFile* fmpopupfile;
    KonoeTclFMPopupEdit* fmpopupedit;
    KonoeTclFMPopupView* fmpopupview;

    KonoeFileStatus* kfs;
};

#endif
