//=====================================================================
/*

    KonoeTclFMMenu.cc

    Version 0.5.0   06-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMMenu.hh>
#include <KonoeTclFMManager.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclUIPrimitive.hh>
#include <ui/KonoeTclFrame.hh>
#include <ui/KonoeTclButton.hh>

KonoeTclFMMenu::KonoeTclFMMenu()
{ ; }

KonoeTclFMMenu::KonoeTclFMMenu(KonoeTclFMManager* _kfmgr, KonoeTclWindow* kwin)
{
  kfmgr = _kfmgr;
  parentWindow = kwin;

  menufrm = new KonoeTclFrame(kwin, "menufrm");
//  menufrm->create(kwin, "menufrm");

  mbtn1 = new KonoeTclButton(menufrm, "mbtn1", "Files");
  mbtn2 = new KonoeTclButton(menufrm, "mbtn2", "Edit");
  mbtn3 = new KonoeTclButton(menufrm, "mbtn3", "View");

  mbtn1->setLayoutType("left");
  mbtn2->setLayoutType("left");
  mbtn3->setLayoutType("left");

//  mbtn1->create(menufrm, "mbtn1");
//  mbtn2->create(menufrm, "mbtn2");
//  mbtn3->create(menufrm, "mbtn3");

  mbtn1->setRelief(KFlat);
  mbtn2->setRelief(KFlat);
  mbtn3->setRelief(KFlat);

  mbtn1->setSide(KPutLeft);
  mbtn2->setSide(KPutLeft);
  mbtn3->setSide(KPutLeft);

  menufrm->setFrame();
  menufrm->setExpand();
  menufrm->fillBoth();

  addMouseAction(mbtn1);
  addMouseAction(mbtn2);
  addMouseAction(mbtn3);
  mbtn1->setEventProcessor( this );
  mbtn2->setEventProcessor( this );
  mbtn3->setEventProcessor( this );
}

KonoeTclFMMenu::~KonoeTclFMMenu()
{
  delete menufrm;
  delete mbtn1;
  delete mbtn2;
  delete mbtn3;
}

void KonoeTclFMMenu::mouseAction(KonoeTclButton* kme, KInt type,
                                 KInt button, Time time, KInt x, KInt y)
{
  KChar cap[256];
  strcpy(cap, kme->getCaption());

  KInt xx;
  KInt yy;
  xx = parentWindow->getRootX() + x;
  yy = parentWindow->getRootY() + kme->getHeight();

  if(type == KMouseRelease && button == LButton){
    if( strcmp( cap, "Files" ) == 0 ){
      kfmgr->setPopupType(KFile);
      (kfmgr->getPopup())->setPopup(xx, yy);
      mbtn1->resetRelief();
    }
    else if( strcmp( cap, "Edit" ) == 0 ){
      kfmgr->setPopupType(KEdit);
      (kfmgr->getPopup())->setPopup(xx, yy);
      mbtn2->resetRelief();
    }
    else if( strcmp( cap, "View" ) == 0 ){
      kfmgr->setPopupType(KView);
      (kfmgr->getPopup())->setPopup(xx, yy);
      mbtn3->resetRelief();
    }
  }
}
