//=====================================================================
/*

    KonoeTclFMModePanel.hh

    Version 0.5.0   26-Oct-1999 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLFMMODEPANEL_HH
#define __KONOETCLFMMODEPANEL_HH

#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseAction.hh>

class KonoeTclWindow;
class KonoeTclSubWindow;
class KonoeTclFrame;
class KonoeTclLabel;
class KonoeTclCheckButton;
class KonoeTclButton;
class KonoeTclFMManager;
class KonoeFileStatus;


class KonoeTclFMModePanel : public KonoeTclEventProcessor,
                            public KonoeTclMouseAction {

  public:
    KonoeTclFMModePanel(KonoeTclFMManager* kfmgr, KonoeTclWindow* _kwin);
    ~KonoeTclFMModePanel();

    void mouseAction( KonoeTclButton* kbtn, KInt type,
                      KInt button, Time time, KInt x, KInt y );
    void setupMode(KonoeFileStatus* kfs);
    void setMode(KInt u, KInt g, KInt o);

  private:
    void setupUserPanel();
    void setupGroupPanel();
    void setupOtherPanel();

    KonoeTclSubWindow* subwin;

    KonoeTclButton* okbutton;
    KonoeTclFrame* frm_u;
    KonoeTclFrame* frm_g;
    KonoeTclFrame* frm_o;
    KonoeTclLabel* lbl_u;
    KonoeTclLabel* lbl_g;
    KonoeTclLabel* lbl_o;
    KonoeTclCheckButton* chkbtn_ur;
    KonoeTclCheckButton* chkbtn_uw;
    KonoeTclCheckButton* chkbtn_ux;
    KonoeTclCheckButton* chkbtn_gr;
    KonoeTclCheckButton* chkbtn_gw;
    KonoeTclCheckButton* chkbtn_gx;
    KonoeTclCheckButton* chkbtn_or;
    KonoeTclCheckButton* chkbtn_ow;
    KonoeTclCheckButton* chkbtn_ox;
};

#endif
