//=====================================================================
/*

    KonoeTclFMPopup.cc

    Version 0.5.0   13-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMPopup.hh>
#include <KonoeTclFMManager.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclWindow.hh>

KonoeTclFMPopup::KonoeTclFMPopup(KonoeTclFMManager* _kfmgr,
                                 KonoeTclWindow* kwin, KChar* kname)
{
  kfmgr = _kfmgr;
  parentwin = kwin;

  setManager();
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", kname);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), kname);
  }

  KChar cmd[256];

  sprintf(cmd, "menu %s -tearoff no", path);
  configCommand(cmd);

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
  setGraphics(win);

  KonoeTclMouseAction::addMouseAction( (KonoeTclMenuButton*) this );
  KonoeTclUIPrimitive::setEventProcessor( (KonoeTclEventProcessor*) this );

  //setStatus();
}

KonoeTclFMPopup::~KonoeTclFMPopup()
{
  delete kfmgr;
}

KInt KonoeTclFMPopup::isRegion(KInt x, KInt y, KInt num)
{
  KDouble kWidth;
  KDouble kHeight;
  KDouble dx;
  KDouble dy;
  kWidth = getWidth();
  kHeight = getHeight()/(KDouble)num;
  dx = x;
  dy = (KDouble) y;

  KInt i = 1;

  if( 0 < dx && dx < kWidth && 0 < y )
  while(num > 0){
    if(dy < kHeight*i)
      return i;
    i++;
    num--;
  }
  else
    return 0;
}
