//=====================================================================
/*

    KonoeTclFMPopupMenu.cc

    Version 0.5.0   05-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMPopupMenu.hh>
#include <KonoeTclFMManager.hh>
#include <KonoeTclFMInputPanel.hh>
#include <KonoeTclFMModePanel.hh>
#include <KonoeTclFMInfoPanel.hh>

KonoeTclFMPopupMenu::KonoeTclFMPopupMenu()
{ ; }

KonoeTclFMPopupMenu::KonoeTclFMPopupMenu(KonoeTclFMManager* _kfmgr,
                                         KonoeTclWindow* kwin, KChar* kname)
                  : KonoeTclFMPopup(_kfmgr, kwin, kname)
{
  setStatus();
  _kfmgr->setPopupMenu( this );
}

KonoeTclFMPopupMenu::~KonoeTclFMPopupMenu()
{
cout << "MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM" << endl;
  delete ip;
  delete infopanel;
  delete mp;
}

void KonoeTclFMPopupMenu::setStatus()
{
  KonoeTclMenuButton::addCommand("Copy");
  KonoeTclMenuButton::addCommand("Cut");
  KonoeTclMenuButton::addCommand("Paste");
  KonoeTclMenuButton::addCommand("Rename");
  KonoeTclMenuButton::addCommand("Delete");
  KonoeTclMenuButton::addSeparator();
  KonoeTclMenuButton::addCommand("Property");
  KonoeTclMenuButton::addCommand("Change Mode");
}

void KonoeTclFMPopupMenu::mouseAction(KonoeTclMenuButton* kbt, KInt type,
                                      KInt button, Time time, KInt x, KInt y)
{
  if(type == KMousePress){
    KInt num = isRegion(x, y, 8);
    switch(num){
      case 1:
        if(ip!=NULL) delete ip;
        ip = new KonoeTclFMInputPanel(kfmgr, parentwin, "Copy to:");
        break;
      case 2:
        if(ip!=NULL) delete ip;
        ip = new KonoeTclFMInputPanel(kfmgr, parentwin, "Cut to:");
        break;
      case 3:
        if(infopanel!=NULL) delete infopanel;
        infopanel = new KonoeTclFMInfoPanel(kfmgr, parentwin);
        infopanel->setupInformation(kfmgr->getFileStatus());
        break;
      case 4:
        if(ip!=NULL) delete ip;
        ip = new KonoeTclFMInputPanel(kfmgr, parentwin, "Rename to:");
        break;
      case 5:
        if(mp!=NULL) delete mp;
        mp = new KonoeTclFMModePanel(kfmgr, parentwin);
        mp->setupMode(kfmgr->getFileStatus());
        break;
      case 6:
        break;
      case 7:
        if(infopanel!=NULL) delete infopanel;
        infopanel = new KonoeTclFMInfoPanel(kfmgr, parentwin);
        infopanel->setupInformation(kfmgr->getFileStatus());
        break;
      case 8:
        if(mp!=NULL) delete mp;
        mp = new KonoeTclFMModePanel(kfmgr, parentwin);
        mp->setupMode(kfmgr->getFileStatus());
        break;
      default:
        ;
    }
  }
}
