//=====================================================================
/*

    KonoeTclFMPopupView.cc

    Version 0.5.0   13-Oct-1999 T. Hosoi

*/
//====================================================================

#include <KonoeTclFMPopupView.hh>
#include <KonoeTclFMManager.hh>
#include <KonoeTclFMCanvas.hh>
#include <KonoeTclFMIconCanvas.hh>
#include <KonoeTclFMSimpleCanvas.hh>
#include <KonoeTclFMDetailCanvas.hh>

KonoeTclFMPopupView::KonoeTclFMPopupView()
{ ; }

KonoeTclFMPopupView::KonoeTclFMPopupView(KonoeTclFMManager* _kfmgr,
                                         KonoeTclWindow* kwin, KChar* kname)
                   : KonoeTclFMPopup(_kfmgr, kwin, kname)
{
  setStatus();
  _kfmgr->setPopupView( this );
}

KonoeTclFMPopupView::~KonoeTclFMPopupView()
{
  delete canvas;
  delete scan;
  delete dcan;
}

void KonoeTclFMPopupView::setStatus()
{
  KonoeTclMenuButton::addCommand("Icon Canvas");
  KonoeTclMenuButton::addCommand("Simple Canvas");
  KonoeTclMenuButton::addCommand("Detail Canvas");
  KonoeTclMenuButton::addSeparator();
  KonoeTclMenuButton::addCheckButton("xxx", "Show All Files");
}

void KonoeTclFMPopupView::mouseAction(KonoeTclMenuButton* kbt, KInt type,
                                      KInt button, Time time, KInt x, KInt y)
{
  KInt popupNum;
  popupNum = KonoeTclFMPopup::isRegion(x, y, 5);
  if(type == KMousePress && button == LButton){
    switch(popupNum){
      case 1:
        kfmgr->getCanvas()->setForget();
        delete kfmgr->getCanvas();
        canvas = new KonoeTclFMIconCanvas(kfmgr, parentwin);
        break;
      case 2:
        kfmgr->getCanvas()->setForget();
        delete kfmgr->getCanvas();
        scan = new KonoeTclFMSimpleCanvas(kfmgr, parentwin);
        break;
      case 3:
        kfmgr->getCanvas()->setForget();
        delete kfmgr->getCanvas();
        dcan = new KonoeTclFMDetailCanvas(kfmgr, parentwin);
        break;
      case 4:
        configCommand("set xxx OFF");
cout << "set xxx OFF" << endl;
        break;
      case 5:
        configCommand("set xxx ON");
cout << "set xxx ON" << endl;
        break;
      default:
        ;
    }
  }
}
