//=====================================================================
/*

    KonoeTcl1DHistogram.cc

    Version 0.0.1   14-Nov-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTcl1DHistogram.hh>
#include <analysis/KonoeDataScale.hh>

KonoeTcl1DHistogram::KonoeTcl1DHistogram(Konoe1DHistogram* h)
{
    binCount = h->getBinCount();
    KonoeDataScale* s = h->getScale();
    aScale = new KonoeLinearDataScale(s->getMinimum(),
                                      s->getMaximum(),
                                      s->getBinCount());

    value = new KFloat[binCount];
    KInt i;
    for(i=0; i<binCount; i++){
      value[i] = h->getOne(i);
    }
}

KonoeTcl1DHistogram::~KonoeTcl1DHistogram()
{
  delete aScale;
  delete [] value;
}

KFloat KonoeTcl1DHistogram::getOne(KInt n)
{
  return value[n];
}

void KonoeTcl1DHistogram::dump(ostream& os)
{
   KInt    i, j;
   KFloat    * p;
   p = value;
   i = 0;
   while( i < binCount) {
     os.width( 4 );
     os << i << ": ";
     j = i + 10;
     if( j > binCount)
     j = binCount;
     os.width( 6 );
     for( ; i < j ; i ++ )
     os << * p ++ << " ";
     os << endl;
   }
}
