//=====================================================================
/*

    KonoeTcl2DrawCanvas.hh

    Version 0.0.1   26-Nov-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCL2DRAWCANVAS_HH
#define __KONOETCL2DRAWCANVAS_HH

#include <ui/KonoeTclCanvas.hh>

class Konoe2DHistogram;
class KonoeTclWindow;
class KonoeTclDimension;
class KonoeTclScale;
class KonoeTclPhysPlacement;
class KonoeTclSpaceManager;
class KonoeDataScale;

class KonoeTcl2DrawCanvas : public KonoeTclCanvas {
  private:
    enum { isFalse=0, isTrue=1};

  public:
    KonoeTcl2DrawCanvas( KonoeTclWindow* kwin, KChar* kname,
                         Konoe2DHistogram* pHisto, KonoeTclDimension dimension,
                         KChar* pName );
    KonoeTcl2DrawCanvas( KonoeTclWindow* kwin, KChar* kname,
                         Konoe2DHistogram* pHisto, KonoeTclDimension dimension,
                         KChar* pName, KonoeDataScale* pScale );
    ~KonoeTcl2DrawCanvas();

    void createDrawParts();
    void draw();
    void update();
    void drawScale();

    void setSpaceManager( KonoeTclSpaceManager* pSpace );
    void setVerticalScale( KonoeDataScale* pScale );
    void setDataSource(Konoe2DHistogram* pHisto);
    void setMagnification(KFloat value);
    void setCenterEye(KInt eyeX, KInt eyeY);
    void setViewLotation(KFloat value);
    void setViewAngle(KFloat value);
    void setForceWireFrame();
    void setScale();
    void setVisAtt(KInt n, KInt RR, KInt GG, KInt BB);
    void setSize(KInt width, KInt height);

    void unsetForceWireFrame();
    void unsetScale();

    KonoeTclSpaceManager* getSpaceManager() { return spMan; }
    KonoeDataScale* getVerticalScale() { return yDataScale; }
    KBool isForceWire() { return forceWireFrame; }
    KBool isScale() { return scale; }

  private:
    Konoe2DHistogram* histogram;
    KonoeTclDimension dim;
    KonoeTclSpaceManager* spMan;
    KInt objTotal;
    KInt drawObjTotalx;
    KInt drawObjTotaly;
    KChar myName[256];
    KonoeTclScale* xScale;
    KonoeTclScale* yScale;
    KonoeTclPhysPlacement** myPhys;
    KonoeTclPhysPlacement* myXLine;
    KonoeTclPhysPlacement* myYLine;
    KonoeTclPhysPlacement* myZLine;
    KInt barwidthx;
    KInt barwidthy;
    KFloat magnification;
    KFloat magnificationX;
    KFloat magnificationY;
    KonoeDataScale* yDataScale;

    KBool forceWireFrame;
    KBool scale;
};

#endif
