//=====================================================================
/*

    KonoeTcl2DrawCanvasController.hh

    Version 0.0.1   02-Dec-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCL2DRAWCANVASCONTROLLER_HH
#define __KONOETCL2DRAWCANVASCONTROLLER_HH

#include <ui/KonoeTclSubWindow.hh>
#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
class KonoeTcl2DrawCanvas;

class KonoeTcl2DrawCanvasController : public KonoeTclEventProcessor,
                                      public KonoeTclMouseAction,
                                      public KonoeTclKeyAction,
                                      public KonoeTclWindowAction {

  public:
    KonoeTcl2DrawCanvasController(KonoeTcl2DrawCanvas* canv);
    ~KonoeTcl2DrawCanvasController();

  private:
    void initWidget();
    void writeProperty();
    void setButtonAction();
    void postscriptAction();

    void mouseAction(KonoeTclButton* btp, KInt type, KInt button,
                      Time time, KInt x, KInt y);
    void keyAction(KonoeTclEntry* kbt, KInt type, KeySym keysym, KInt state);
    void windowAction(KonoeTclWindow* kcv, XEvent* xev);

  private:
    KonoeTclSubWindow*   subWindow;
    KonoeTcl2DrawCanvas* dc2;

    enum { FrameNum = 9 };
    KonoeTclFrame** frame;

    KonoeTclLabel* viewLotationLabel;
    KonoeTclSlider* viewLotationSlider;
    KonoeTclLabel* viewAngleLabel;
    KonoeTclSlider* viewAngleSlider;

    KonoeTclLabel* verticalScaleLabel;
    KonoeTclEntry* verticalScaleEntry;

    KonoeTclLabel* canvasSizeLabel;
    KonoeTclEntry* canvasSizeXEntry;
    KonoeTclEntry* canvasSizeYEntry;

    KonoeTclLabel* viewingModeLabel;
    KonoeTclRadioButton* wireFrameRadio;
    KonoeTclRadioButton* surfaceRadio;

    KonoeTclLabel* targetPointLabel;
    KonoeTclLabel* xCoordLabel;
    KonoeTclEntry* xCoordEntry;
    KonoeTclLabel* yCoordLabel;
    KonoeTclEntry* yCoordEntry;

    KonoeTclLabel* magnificationLabel;
    KonoeTclEntry* magnificationEntry;

    KonoeTclLabel* displayAxesLabel;
    KonoeTclRadioButton* displayAxesYesRadio;
    KonoeTclRadioButton* displayAxesNoRadio;

    KonoeTclButton* postscriptButton;
    KonoeTclEntry* postscriptEntry;

    KonoeTclButton* setupButton;

};

#endif
