//=====================================================================
/*

    KonoeTclCalculator.hh

    Version 0.0.1   09-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLCALCULATOR_HH
#define __KONOETCLCALCULATOR_HH


class KonoeTclDrawCanvas;
class KonoeTclDimension;

#include <KonoePrimitives.hh>

class KonoeTclCalculator {

  public:
    KonoeTclCalculator();
    ~KonoeTclCalculator();

    KFloat calcMean(KonoeTclDrawCanvas* canv, KInt startX, KInt endX);
    KFloat calcVariance(KonoeTclDrawCanvas* canv, KInt startX, KInt endX);
    KFloat calcStandardDeviation(KonoeTclDrawCanvas* canv,
                                                  KInt startX, KInt endX);
    KInt   calcBinTotal(KonoeTclDrawCanvas* canv, KInt startX, KInt endX);

    KFloat getMax(KonoeTclDrawCanvas* canv);
    KInt getMaxBinNumber(KonoeTclDrawCanvas* canv);

    KonoeTclDimension getClickPoint(KonoeTclDrawCanvas* hist, KInt x, KInt y);
  private:
    KFloat totalData;
    KInt binCount;
};

#endif
