//=====================================================================
/*

    KonoeTclDataScale.cc

    Version 0.0.1   16-Nov-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDataScale.hh>

KonoeTclDataScale::KonoeTclDataScale(KonoeDataScale* dScale)
 : KonoeDataScale(0)
{
  minimum = dScale->getMinimum();
  maximum = dScale->getMaximum();
  bincount = dScale->getBinCount();
  binwidth = (maximum - minimum) / bincount;
}

KonoeTclDataScale::~KonoeTclDataScale()
{ ; }

KInt KonoeTclDataScale::getBinIndex( KFloat value )
{
  KFloat  i;

    i = ( value - minimum ) / binwidth;
    if( i < 0. )
        return UNDERFLOW;
    else if( (KInt)i >= bincount )
        return OVERFLOW;
    return (KInt)i;
}

KFloat KonoeTclDataScale::getBinLower( KInt binnumber )
{
  return minimum + binwidth * binnumber;
}

void KonoeTclDataScale::dump( ostream & os )
{
  os << "Linear scale. from " << minimum << " to "
     << maximum << " in " << bincount << " steps of "
     << binwidth << " wide bins" << endl;
}
