//=====================================================================
/*

    KonoeTclDataScale.hh

    Version 0.0.1   16-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDATASCALE_HH
#define __KONOETCLDATASCALE_HH

#include <analysis/KonoeDataScale.hh>

class KonoeTclDataScale : public KonoeDataScale {

  public:
    KonoeTclDataScale(KonoeDataScale* dScale);
    ~KonoeTclDataScale();

    KInt    getBinIndex( KFloat value );
    KFloat  getBinWidth( KInt /* binnumber */ ) { return binwidth; }
    KFloat  getBinLower( KInt binnumber );
    KInt    getBinCount() { return bincount; }
    KFloat  getMinimum() { return minimum; }
    KFloat  getMaximum() { return maximum; }

    void    dump( ostream & os );

  public:
    enum    { OVERFLOW = -1,  UNDERFLOW = -2 };

  private:
    KFloat  minimum;
    KFloat  maximum;
    KFloat  binwidth;
    KInt    bincount;

    KInt  put( KonoeOutputObjectStream * os, KChar level, KInt memberid )
           { return -1; }
    KInt  getStreamSize( ){ return -1; }
    KInt  fillPrimitiveMember( KInt memberid, KInt datatype,
              KInt datacount, void * data ){ return -1; }
    KInt  fillObjectMember( KInt memberid,
              KonoeStreamableObject * data ) { return -1; }
};

#endif
