//=====================================================================
/*

    KonoeTclDrawCanvasController.hh

    Version 0.0.1   07-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDRAWCANVASCONTROLLER_HH
#define __KONOETCLDRAWCANVASCONTROLLER_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>
#include <ui/KonoeTclDrawCanvas.hh>

class KonoeTclSubWindow;

class KonoeTclDrawCanvasController : public KonoeTclEventProcessor,
                                     public KonoeTclMouseAction,
                                     public KonoeTclKeyAction {

  public:
    KonoeTclDrawCanvasController(KonoeTclDrawCanvas* canv);
    KonoeTclDrawCanvasController(KonoeTclWindow* pwin);
    virtual ~KonoeTclDrawCanvasController();

    void setHistogramDrawSize();
    void setHistogramCanvasSize();
    void setVerticalScale();
    void setHorizontalScale();
    void setHorizontalMarkTotal();
    void setHorizontalBigMarkTotal();
    void setVerticalMarkTotal();
    void setVerticalBigMarkTotal();
    void setDrawTypeBox();
    void setHistoColor();
    void writeProperty();
    void setSaveFileFullPath(KChar* pFullPath);

    KonoeTclWindow* getWindow() { return drawCanvas->getParentWindow(); }

  protected:
    void createParts();
    virtual void mouseAction(KonoeTclButton* kbtn, KInt type, KInt button,
                     Time time, KInt x, KInt y);
    virtual void keyAction(KonoeTclEntry* kbt, KInt type, KeySym keysym,
                                                                 KInt state);
    virtual void keyAction(KonoeTclButton* kbt, KInt type, KeySym keysym,
                                                                  KInt state);
    virtual KInt saveAsButtonAction();
    virtual KInt saveAsXWDButtonAction();
    virtual KInt saveAsDataButtonAction();
    virtual KInt setButtonAction();

    KChar cmd[256];
    KChar fullPath[256];

    KonoeTclSubWindow* subWindow;
    KonoeTclFrame* defaultFrame;
    KonoeTclFrame* verticalScaleFrame;
    KonoeTclFrame* horizontalScaleFrame;
    KonoeTclFrame* drawTypeBoxFrame;
    KonoeTclDrawCanvas* drawCanvas;
    KonoeTclLabel* verticalScaleLabel;
    KonoeTclLabel* verticalMaxLabel;
    KonoeTclLabel* horizontalScaleLabel;
    KonoeTclLabel* horizontalMinLabel;
    KonoeTclLabel* horizontalMaxLabel;
    KonoeTclLabel* horizontalBinCountLabel;
    KonoeTclLabel* histCanvasSizeLabel;
    KonoeTclLabel* horizontalMarkTotalLabel;
    KonoeTclLabel* horizontalBigMarkTotalLabel;
    KonoeTclLabel* verticalMarkTotalLabel;
    KonoeTclLabel* verticalBigMarkTotalLabel;
    KonoeTclLabel* drawTypeBoxLabel;
    KonoeTclLabel* setHistColorLabel;

    KonoeTclEntry* verticalScaleEntry;
    KonoeTclEntry* horizontalMinEntry;
    KonoeTclEntry* horizontalMaxEntry;
    KonoeTclEntry* horizontalBinCountEntry;
    KonoeTclEntry* histCanvasSizeEntryX;
    KonoeTclEntry* histCanvasSizeEntryY;
    KonoeTclEntry* horizontalMarkTotalEntry;
    KonoeTclEntry* horizontalBigMarkTotalEntry;
    KonoeTclEntry* verticalMarkTotalEntry;
    KonoeTclEntry* verticalBigMarkTotalEntry;
    KonoeTclEntry* setHistColorEntry;
    KonoeTclEntry* saveAsEntry;
    KonoeTclEntry* saveAsXWDEntry;
    KonoeTclEntry* saveAsDataEntry;

    KonoeTclRadioButton* drawTypeBoxRadio;
    KonoeTclRadioButton* drawTypeFillRadio;
    KonoeTclRadioButton* drawTypeLineRadio;

    KonoeTclButton* saveAsButton;
    KonoeTclButton* saveAsXWDButton;
    KonoeTclButton* saveAsDataButton;
    KonoeTclButton* setButton;
};

#endif
