//=====================================================================
/*

    KonoeTclDrawCanvasMouseListener.hh

    Version 0.0.1   09-Nov-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDRAWCANVASMOUSELISTENER_HH
#define __KONOETCLDRAWCANVASMOUSELISTENER_HH

#include <ui/KonoeTclAction.hh>

class KonoeTclSubWindow;
class KonoeTclDrawPanel;
class KonoeTclDrawCanvas;
class KonoeTclDrawCanvasController;
class KonoeTclBalloon;

class KonoeTclDrawCanvasMouseListener : public KonoeTclEventProcessor,
                                      public KonoeTclMouseAction,
                                      public KonoeTclMouseMotion,
                                      public KonoeTclWindowAction {

  public:
    KonoeTclDrawCanvasMouseListener();
    ~KonoeTclDrawCanvasMouseListener();

    void setSaveFileFullPath(KChar* fullPath);

  private:
    virtual void mouseAction(KonoeTclCanvas* kbt, KInt type, KInt button,
                                         Time time, KInt x, KInt y);
    virtual void mouseMotion(KonoeTclCanvas* kbt, KInt type, KInt button,
                                         Time time, KInt x, KInt y);

    KonoeTclDimension getClickPoint(KInt x, KInt y);
    KInt calcSelectedBinCount(KInt startX, KInt startY);

    KFloat getMax();
    KInt getMaxBinNumber();

    KFloat calcMean(KInt startX, KInt startY);
    KFloat calcVariance(KInt startX, KInt endX);
    KFloat calcStandardDeviation(KInt startX, KInt endX);
    KInt   calcBinTotal(KInt startX, KInt endX);

    KonoeTclSubWindow* s;
    KonoeTclDrawPanel* p;
    KonoeTclDrawCanvas* c;
    KonoeTclDrawCanvas* drawCanvas;
    KonoeTclBalloon* balloon;
    KonoeTclDrawCanvasController* drawCanvasController;

    KBool isCreateDrawCanvas;
    KBool isCreateControlPanel;

    KChar fullPath[256];
};

#endif
