//=====================================================================
/*

    KonoeTclDrawableBox.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableBox.hh>
#include <iostream.h>
#include <string.h>
#include <ui/KonoeTclSpaceManager.hh>
#include <ui/KonoeTclCanvas.hh>

KonoeTclDrawableBox::KonoeTclDrawableBox()
{
  fDx = 0.;
  fDy = 0.;
  fDz = 0.;
  posX = 0.;
  posY = 0.;
  posZ = 0.;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
  setThin = 0;
}

KonoeTclDrawableBox::KonoeTclDrawableBox( KChar* pStr, 
                                      KDouble pDx, KDouble pDy, KDouble pDz )
{
  fDx = 0.;
  fDy = 0.;
  fDz = 0.;
  posX = 0.;
  posY = 0.;
  posZ = 0.;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
  setThin = 0;

  fDx = pDx;
  fDy = pDy;
  fDz = pDz;

  strcpy(myName, pStr);
}

KonoeTclDrawableBox::~KonoeTclDrawableBox()
{
  ;
}

void KonoeTclDrawableBox::setSpaceManager( KonoeTclSpaceManager* pManager )
{
  spMan = pManager;
}

void KonoeTclDrawableBox::setThinGap()
{
  if ( setThin == 0 ) {
    fDx -= 1;
    fDy -= 1;
    setThin = 1;
  }
}

void KonoeTclDrawableBox::realDrawReplace( KonoeTcl2Dimension myView )
{
  nowAngle = myView.getAngle();
  nowRotation  = myView.getRotation();
}

void KonoeTclDrawableBox::dump()
{
  if(wireFrame) cout << "Viewing Mode : WireFrame" << endl;
  else cout << "Viewing Mode : Surface" << endl;
  cout <<  "Name = " << myName <<
                     "  W =  " << fDx <<
                     "  H =  " << fDy <<
                     "  D =  " << fDz << endl;
  cout << "PosX = " << posX << " PosY = " << posY << " PosZ = " << posZ << endl;
}

void KonoeTclDrawableBox::setWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableBox::unsetWire()
{
  wireFrame = isFalse;
}

void KonoeTclDrawableBox::setSurf2()
{
  surf2  = isFalse;
}

void KonoeTclDrawableBox::unsetSurf2()
{
  surf2 = isTrue;
}

void KonoeTclDrawableBox::draw( KonoeTclTransform myTrans, KonoeTclGraphics* g,
                                KInt rr, KInt gg, KInt bb)
{
  if( wireFrame ){
    posX = myTrans.getX();
    posY = myTrans.getY();
    posZ = myTrans.getZ();
//    KFloat roteX = myTrans.getRX();
//    KFloat roteY = myTrans.getRY();
//    KFloat roteZ = myTrans.getRZ();

    KonoeTclSpaceManager spm = *spMan;
    spm.setViewLotation( spMan->getViewLotation() + rotY );
    spm.setViewAngle( spMan->getViewAngle() + rotX );

    KInt PolygonArayX[4];
    KInt PolygonArayY[4];

    g->setColor( rr, gg, bb ); 
    KonoeTclDimension nowDim;

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                        ( posX - fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                        ( posX - fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 4);

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 4);

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 2);

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 2);

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 2);

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    g->drawPolygon( PolygonArayX, PolygonArayY, 2);
  }
}

void KonoeTclDrawableBox::draw2( KonoeTclTransform myTrans,
                                 KonoeTclGraphics* g,
                                 KInt rr, KInt gg, KInt bb)
{

  if ( !wireFrame ){
    posX = myTrans.getX();
    posY = myTrans.getY();
    posZ = myTrans.getZ();
//    KFloat roteX = myTrans.getRX();
//    KFloat roteY = myTrans.getRY();
//    KFloat roteZ = myTrans.getRZ();

    KInt PolygonArayX[4];
    KInt PolygonArayY[4];

    KonoeTclSpaceManager spm = *spMan;
    spm.setViewLotation( spMan->getViewLotation() + rotY );
    spm.setViewAngle( spMan->getViewAngle() + rotX );

    KonoeTclDimension nowDim;

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->setColor ( rr*4/5, gg*4/5, bb*4/5  );
    g->drawFillPolygon (PolygonArayX, PolygonArayY, 4);
    g->setColor ( 0, 0, 0  );

    if ( surf2 ) {
      g->drawPolygon (PolygonArayX, PolygonArayY, 4);
    }

    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->setColor ( rr, gg, bb  );
    g->drawFillPolygon (PolygonArayX, PolygonArayY, 4);

    if ( surf2 ) {
      g->setColor ( 0, 0, 0  );
      g->drawPolygon (PolygonArayX, PolygonArayY, 4);
    }

  if( spm.getViewLotation() < 0) spm.setViewLotation( 0. );
  if( 3.14 <= spm.getViewLotation() ) spm.setViewLotation( 3.14 );

  if( 0 <= spm.getViewLotation() && spm.getViewLotation() < 1.57){
    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX - fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->setColor ( rr*3/5, gg*3/5, bb*3/5  );
    g->drawFillPolygon (PolygonArayX, PolygonArayY, 4);
  }

  else if( 1.57 <= spm.getViewLotation() && spm.getViewLotation() <= 3.14){
    nowDim =  spm.reLocation ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ - fDz ) );
    PolygonArayX[0] =  nowDim.getWidth();
    PolygonArayY[0] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ - fDz ) );
    PolygonArayX[1] =  nowDim.getWidth();
    PolygonArayY[1] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY + fDy, posZ + fDz ) );
    PolygonArayX[2] =  nowDim.getWidth();
    PolygonArayY[2] =  nowDim.getHeight();

    nowDim =  spm.reLocation  ( KonoeTcl3DVector
                       ( posX + fDx, posY - fDy, posZ + fDz ) );
    PolygonArayX[3] =  nowDim.getWidth();
    PolygonArayY[3] =  nowDim.getHeight();

    g->setColor ( rr*3/5, gg*3/5, bb*3/5  );
    g->drawFillPolygon (PolygonArayX, PolygonArayY, 4);
  }

    if ( surf2 ) {
      g->setColor ( 0, 0, 0  );
      g->drawPolygon (PolygonArayX, PolygonArayY, 4);
    }
  }

}

