//=====================================================================
/*

    KonoeTclDrawableBox.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
	Version 0.5.1	26-Jan-2000	H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDRAWABLEBOX_HH
#define __KONOETCLDRAWABLEBOX_HH

#include <ui/KonoeTclSolid.hh>
#include <ui/KonoeTcl3DVector.hh>

class KonoeTclSpaceManager;
class KonoeTcl2Dimension;
class KonoeTclTransform;
class KonoeTclGraphics;

class KonoeTclDrawableBox : public KonoeTclSolid {

  public:
    KonoeTclDrawableBox();
    KonoeTclDrawableBox(KChar* pStr, KDouble pDx, KDouble pDy, KDouble pDz);
    ~KonoeTclDrawableBox();

    void setSpaceManager( KonoeTclSpaceManager* pManager );
    KonoeTclSpaceManager* getSpaceManager() { return spMan; }
    void setThinGap();
    void realDrawReplace( KonoeTcl2Dimension myView );
    void dump();
    void setWire();
    void setSurf2();
    void unsetWire();
    void unsetSurf2();

    void rotateX( KFloat rX ) { rotX = rX; }
    void rotateY( KFloat rY ) { rotY = rY; }

    void draw( KonoeTclTransform myTrans, KonoeTclGraphics* g,
               KInt rr, KInt gg, KInt bb);
    void draw2( KonoeTclTransform myTrans, KonoeTclGraphics* g,
                KInt rr, KInt gg, KInt bb);
    KonoeTcl3DVector getBoxSize() {
      return KonoeTcl3DVector(fDx, fDy, fDz);
    }

  private:

	enum	{	isFalse = 0,	isTrue = 1	};

    KDouble fDx;
    KDouble fDy;
    KDouble fDz;
    KChar   myName[64];

    KDouble posX;
    KDouble posY;
    KDouble posZ;

    KDouble nowAngle;
    KDouble nowRotation;

    KBool wireFrame;
    KBool surf2;

    KonoeTclSpaceManager* spMan;

    KInt setThin;
};

#endif
