//=====================================================================
/*

    KonoeTclDrawableHorizonLine.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableHorizonLine.hh>
#include <string.h>
#include <iostream.h>
#include <ui/KonoeTcl3DVector.hh>

KonoeTclDrawableHorizonLine::KonoeTclDrawableHorizonLine()
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
}

KonoeTclDrawableHorizonLine::KonoeTclDrawableHorizonLine( KChar* pStr,
                                                          KDouble pD )
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;

  fD = pD;
  strcpy(myName, pStr);
}

KonoeTclDrawableHorizonLine::~KonoeTclDrawableHorizonLine()
{
  ;
}

void KonoeTclDrawableHorizonLine::setSpaceManager( 
                                               KonoeTclSpaceManager* pManage )
{
  spMan = pManage;
}

void KonoeTclDrawableHorizonLine::setThinGap()
{ ; }

void KonoeTclDrawableHorizonLine::realDrawReplace( KonoeTcl2Dimension myView )
{
  nowAngle = myView.getAngle();
  nowRotation = myView.getRotation();
}

void KonoeTclDrawableHorizonLine::dump()
{
  cout << "Name = " << myName << "  Length  =  " << fD << endl;
}

void KonoeTclDrawableHorizonLine::setWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableHorizonLine::unsetWire()
{
  wireFrame = isFalse;
}

void KonoeTclDrawableHorizonLine::setSurf2()
{
  surf2  = isFalse;
}

void KonoeTclDrawableHorizonLine::unsetSurf2()
{
  surf2 = isTrue;
}

void KonoeTclDrawableHorizonLine::draw( KonoeTclTransform myTrans,
                            KonoeTclGraphics* g , KInt rr, KInt gg, KInt bb )
{
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt PolygonArayX[2];
  KInt PolygonArayY[2];

  g->setColor(  rr, gg, bb );
  KonoeTclDimension nowDim;

  nowDim =  spMan->reLocation ( KonoeTcl3DVector  
                              ( myOrigX - fD , myOrigY, myOrigZ) );
  PolygonArayX[0] =  nowDim.getWidth();
  PolygonArayY[0] =  nowDim.getHeight();

  nowDim =  spMan->reLocation  ( KonoeTcl3DVector
                               ( myOrigX + fD, myOrigY, myOrigZ ) );
  PolygonArayX[1] =  nowDim.getWidth();
  PolygonArayY[1] =  nowDim.getHeight();

  g->drawLine ( PolygonArayX[0], PolygonArayY[0],
                  PolygonArayX[1], PolygonArayY[1] );
}

void KonoeTclDrawableHorizonLine::draw2( KonoeTclTransform myTrans,
                            KonoeTclGraphics* g , KInt rr, KInt gg, KInt bb )
{ ; }
