//=====================================================================
/*

    KonoeTclDrawableOval.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableOval.hh>
#include <ui/KonoeTclSpaceManager.hh>
#include <ui/KonoeTclTransform.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTcl3DVector.hh>
#include <ui/KonoeTcl2Dimension.hh>
#include <ui/KonoeTclDimension.hh>

KonoeTclDrawableOval::KonoeTclDrawableOval()
{
  fDim = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
}

KonoeTclDrawableOval::KonoeTclDrawableOval(KChar* pStr, KDouble pDim)
{
  fDim = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
  fDim = pDim;
  strcpy(myName, pStr);
}

KonoeTclDrawableOval::~KonoeTclDrawableOval()
{
  ;
}

void KonoeTclDrawableOval::setSpaceManager(KonoeTclSpaceManager* pManage)
{
  spMan = pManage;
}

void KonoeTclDrawableOval::realDrawReplace(KonoeTcl2Dimension myView)
{
  nowAngle = myView.getAngle();
  nowRotation = myView.getRotation();
}

void KonoeTclDrawableOval::dump()
{
  cout << "Name = " << myName << " Radius = " << fDim << endl;
}

void KonoeTclDrawableOval::setWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableOval::unsetWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableOval::setSurf2()
{
  surf2 = isFalse;
}

void KonoeTclDrawableOval::unsetSurf2()
{
  surf2 = isTrue;
}

void KonoeTclDrawableOval::draw(KonoeTclTransform myTrans,
                                KonoeTclGraphics* g,
                                KInt RR, KInt GG, KInt BB)
{
  if(wireFrame){
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt solidPosX;
  KInt solidPosY;

  solidPosX = (KInt)myOrigX;
  solidPosY = (KInt)myOrigY;

  KonoeTclDimension nowDim;

  if(spMan != NULL){
    nowDim = spMan->reLocation( KonoeTcl3DVector( myOrigX, myOrigY, myOrigZ) );

    solidPosX = nowDim.getWidth();
    solidPosY = nowDim.getHeight();
  }

  g->setColor(RR, BB, GG);
  g->drawOval(solidPosX, solidPosY, fDim, fDim);
  }
}

void KonoeTclDrawableOval::draw2(KonoeTclTransform myTrans,
                           KonoeTclGraphics* g, KInt RR, KInt GG, KInt BB)
{
  if(!wireFrame){
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt solidPosX;
  KInt solidPosY;

  solidPosX = (KInt)myOrigX;
  solidPosY = (KInt)myOrigY;

  KonoeTclDimension nowDim;

  if(spMan != NULL){
    nowDim = spMan->reLocation( KonoeTcl3DVector( myOrigX, myOrigY, myOrigZ) );

    solidPosX = nowDim.getWidth();
    solidPosY = nowDim.getHeight();
  }

  g->setColor(RR, BB, GG);
  g->drawFillOval(solidPosX , solidPosY, 5, 5);
  }
}
