//=====================================================================
/*

    KonoeTclDrawableOval.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDRAWABLEOVAL_HH
#define __KONOETCLDRAWABLEOVAL_HH

#include <ui/KonoeTclSolid.hh>

class KonoeTclSpaceManager;
class KonoeTclTransform;
class KonoeTclGraphics;
class KonoeTcl2Dimension;

class KonoeTclDrawableOval : public KonoeTclSolid {

  public:
    KonoeTclDrawableOval();
    KonoeTclDrawableOval(KChar* pStr, KDouble pDim);
    ~KonoeTclDrawableOval();

    void setSpaceManager( KonoeTclSpaceManager* pManage);
    void dump();
    void setWire();
    void unsetWire();
    void setSurf2();
    void unsetSurf2();
    void setThinGap() { ; }
    void realDrawReplace(KonoeTcl2Dimension myDim);
    void setOvalSize(KonoeTclDimension dim);

    void rotateX(KFloat rX) { rotX = rX; }
    void rotateY(KFloat rY) { rotY = rY; }

    void draw(KonoeTclTransform myTrans, KonoeTclGraphics* g,
                                           KInt RR, KInt GG, KInt BB);
    void draw2(KonoeTclTransform myTrans, KonoeTclGraphics* g,
                                           KInt RR, KInt GG, KInt BB);

  private:
    enum { isFalse = 0, isTrue = 1 };

    KDouble fDim;
    KChar myName[256];

    KDouble myOrigX;
    KDouble myOrigY;
    KDouble myOrigZ;

    KDouble nowAngle;
    KDouble nowRotation;

    KBool wireFrame;
    KBool surf2;

    KonoeTclSpaceManager* spMan;
};

#endif
