//=====================================================================
/*

    KonoeTclDrawableString.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableString.hh>
#include <ui/KonoeTcl3DVector.hh>
#include <ui/KonoeTclCanvas.hh>

KonoeTclDrawableString::KonoeTclDrawableString(KChar* pStr, KChar* fColor,
                                             KChar* pfontName, KInt _fontSize)
{
  str = new KChar[strlen(pStr)];
  strcpy(str, pStr);
  strcpy(fontColor, fColor);
  strcpy(fontName, pfontName);
  fontSize = _fontSize;

  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
}

KonoeTclDrawableString::~KonoeTclDrawableString()
{
  delete [] str;
}

void KonoeTclDrawableString::setSpaceManager( KonoeTclSpaceManager* pManage)
{
  spMan =  pManage;
}

void KonoeTclDrawableString::dump()
{
  cout << " String : " << str << endl;
}

void KonoeTclDrawableString::setString(KChar* pStr,
                                       KChar* fColor, KChar* fName, KInt fSize)
{
  delete [] str;
  str = new KChar[ strlen(pStr) ];
  strcpy(str, pStr);
  strcpy(fontColor, fColor);
  strcpy(fontName, fName);
  fontSize = fSize;
}

void KonoeTclDrawableString::draw(KonoeTclTransform myTrans,
                              KonoeTclGraphics* g, KInt RR, KInt GG, KInt BB)
{
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt solidPosX;
  KInt solidPosY;

  solidPosX = (KInt) myOrigX;
  solidPosY = (KInt) myOrigY;

  KonoeTclSpaceManager spm = *spMan;

  if(spMan){
    spm.setViewLotation( spMan->getViewLotation() + rotY );
    spm.setViewAngle( spMan->getViewAngle() + rotX );

    KonoeTclDimension nowDim =
        spm.reLocation( KonoeTcl3DVector(myOrigX, myOrigY, myOrigZ) );

    solidPosX = nowDim.getWidth();
    solidPosY = nowDim.getHeight();
  }

  //g->setColor(RR, GG, BB);
  g->setColor( fontColor );
  g->setFont(fontName, fontSize, 0, 0, 0, 0);
  g->drawText(solidPosX, solidPosY, str);
//  g->drawText(solidPosX, solidPosY, str, fontName, fontSize, 0, 0, 0, 0);
}
