//=====================================================================
/*

    KonoeTclDrawableVerticalLine.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableVerticalLine.hh>
#include <string.h>
#include <iostream.h>
#include <ui/KonoeTcl3DVector.hh>

KonoeTclDrawableVerticalLine::KonoeTclDrawableVerticalLine()
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
}

KonoeTclDrawableVerticalLine::KonoeTclDrawableVerticalLine( KChar* pStr,
                                                          KDouble pD ) 
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;

  fD = pD;
  strcpy(myName, pStr);
}

KonoeTclDrawableVerticalLine::~KonoeTclDrawableVerticalLine()
{
  ;
}

void KonoeTclDrawableVerticalLine::setSpaceManager(
                                               KonoeTclSpaceManager* pManage )
{
  spMan = pManage;
}

void KonoeTclDrawableVerticalLine::setThinGap()
{ ; }

void KonoeTclDrawableVerticalLine::realDrawReplace( KonoeTcl2Dimension myView)
{
  nowAngle = myView.getAngle();
  nowRotation = myView.getRotation();
}

void KonoeTclDrawableVerticalLine::dump()
{
  cout << "Name = " << myName << "  Length  =  " << fD << endl;
}

void KonoeTclDrawableVerticalLine::setWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableVerticalLine::unsetWire()
{
  wireFrame = isFalse;
}

void KonoeTclDrawableVerticalLine::setSurf2()
{
  surf2  = isFalse;
}

void KonoeTclDrawableVerticalLine::unsetSurf2()
{
  surf2 = isTrue;
}

void KonoeTclDrawableVerticalLine::draw( KonoeTclTransform myTrans,
                            KonoeTclGraphics* g , KInt rr, KInt gg, KInt bb )
{
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt PolygonArayX[2];
  KInt PolygonArayY[2];

  g->setColor(  rr, gg, bb );
  KonoeTclDimension nowDim;

  nowDim =  spMan->reLocation ( KonoeTcl3DVector
                              ( myOrigX , myOrigY + fD, myOrigZ) );
  PolygonArayX[0] =  nowDim.getWidth();
  PolygonArayY[0] =  nowDim.getHeight();

  nowDim =  spMan->reLocation  ( KonoeTcl3DVector
                               ( myOrigX , myOrigY - fD, myOrigZ ) );
  PolygonArayX[1] =  nowDim.getWidth();
  PolygonArayY[1] =  nowDim.getHeight();
  g->drawLine ( PolygonArayX[0], PolygonArayY[0],
                  PolygonArayX[1], PolygonArayY[1] );
}

void KonoeTclDrawableVerticalLine::draw2( KonoeTclTransform myTrans,
                            KonoeTclGraphics* g , KInt rr, KInt gg, KInt bb )
{ ; }
