//=====================================================================
/*

    KonoeTclDrawableVerticalLine.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.5.1   25-Jan-2000 H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLDRAWABLEVERTICALLINE_HH
#define __KONOETCLDRAWABLEVERTICALLINE_HH

#include <ui/KonoeTclSolid.hh>

class KonoeTclSpaceManager;
class KonoeTclTransform;
class KonoeTclGraphics;

class KonoeTclDrawableVerticalLine : public KonoeTclSolid {

  public:
    KonoeTclDrawableVerticalLine();
    KonoeTclDrawableVerticalLine( KChar* pStr, KDouble pD );
    ~KonoeTclDrawableVerticalLine();

    void setSpaceManager( KonoeTclSpaceManager* pManage );
    void setThinGap();
    void dump();
    void setWire();
    void setSurf2();
    void unsetWire();
    void unsetSurf2();
    void draw( KonoeTclTransform myTrans, KonoeTclGraphics* g ,
                                                 KInt RR, KInt GG, KInt BB );
    void draw2( KonoeTclTransform myTrans, KonoeTclGraphics* g ,
                                                 KInt RR, KInt GG, KInt BB );

    void rotateX(KFloat rX) { rotX = rX; }
    void rotateY(KFloat rY) { rotY = rY; }

    void realDrawReplace( KonoeTcl2Dimension myTrans );

  private:
	enum	{	isFalse = 0, isTrue = 1	};

    KDouble fD;
    KChar myName[256];

    KDouble myOrigX;
    KDouble myOrigY;
    KDouble myOrigZ;

    KDouble nowAngle;
    KDouble nowRotation;

    KBool wireFrame;
    KBool surf2;

    KonoeTclSpaceManager* spMan;

};

#endif
