//=====================================================================
/*

    KonoeTclDrawableXLine.cc

    Version 0.0.1   08-Dec-1999 T. Hosoi
	Version 0.5.1	26-Jan-2000	H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDrawableXLine.hh>
#include <ui/KonoeTclSpaceManager.hh>
#include <ui/KonoeTcl2Dimension.hh>
#include <ui/KonoeTcl3DVector.hh>
#include <ui/KonoeTclTransform.hh>
#include <ui/KonoeTclGraphics.hh>

KonoeTclDrawableXLine::KonoeTclDrawableXLine()
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
}

KonoeTclDrawableXLine::KonoeTclDrawableXLine(KChar* pStr, KFloat pD)
{
  fD = 0;
  myOrigX = 0;
  myOrigY = 0;
  myOrigZ = 0;
  nowAngle = 30;
  nowRotation = 60;
  wireFrame = isFalse;
  surf2 = isTrue;
  fD = pD;
  strcpy(myName, pStr);
}

KonoeTclDrawableXLine::~KonoeTclDrawableXLine()
{ ; }

void KonoeTclDrawableXLine::setSpaceManager( KonoeTclSpaceManager* pManage )
{
  spMan = pManage;
}

void KonoeTclDrawableXLine::setThinGap()
{
}

void KonoeTclDrawableXLine::realDrawReplace( KonoeTcl2Dimension myView )
{
  nowAngle = myView.getAngle();
  nowRotation = myView.getRotation();
}

void KonoeTclDrawableXLine::dump()
{
  cout << "Name = " << myName << " Length = " << fD << endl;
}

void KonoeTclDrawableXLine::setWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableXLine::unsetWire()
{
  wireFrame = isTrue;
}

void KonoeTclDrawableXLine::setSurf2()
{
  surf2 = isFalse;
}

void KonoeTclDrawableXLine::unsetSurf2()
{
  surf2 = isTrue;
}

void KonoeTclDrawableXLine::draw( KonoeTclTransform myTrans,
                                  KonoeTclGraphics* g,
                                  KInt RR, KInt GG, KInt BB )
{
  myOrigX = myTrans.getX();
  myOrigY = myTrans.getY();
  myOrigZ = myTrans.getZ();

  KInt PolygonArrayX[2];
  KInt PolygonArrayY[2];

  g->setColor( RR, GG, BB );
  KonoeTclDimension nowDim;

  nowDim = spMan->reLocation( KonoeTcl3DVector
                                       (myOrigX, myOrigY, myOrigZ + fD) );
  PolygonArrayX[0] = nowDim.getWidth();
  PolygonArrayY[0] = nowDim.getHeight();

  nowDim = spMan->reLocation( KonoeTcl3DVector
                                       (myOrigX, myOrigY, myOrigZ - fD ) );
  PolygonArrayX[1] = nowDim.getWidth();
  PolygonArrayY[1] = nowDim.getHeight();

  g->drawLine( PolygonArrayX[0], PolygonArrayY[0],
               PolygonArrayX[1], PolygonArrayY[1] );
}

void KonoeTclDrawableXLine::draw2( KonoeTclTransform myTrans,
                                   KonoeTclGraphics* g,
                                   KInt RR, KInt GG, KInt BB )
{
}
