//=====================================================================
/*

    KonoeTclDrawableXLine.hh

    Version 0.5.0   08-Dec-1999 T. Hosoi
    Version 0.5.1   25-Jan-2000 H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOEDRAWABLEXLINE_HH
#define __KONOEDRAWABLEXLINE_HH

#include <ui/KonoeTclSolid.hh>

class KonoeTclSpaceManager;
class KonoeTcl2Dimension;
class KonoeTclTransform;
class KonoeTclGraphics;

class KonoeTclDrawableXLine : public KonoeTclSolid {

  public:
    KonoeTclDrawableXLine();
    KonoeTclDrawableXLine(KChar* pStr, KFloat pD);
    ~KonoeTclDrawableXLine();

    void setSpaceManager( KonoeTclSpaceManager* pManage );
    void setThinGap();
    void realDrawReplace( KonoeTcl2Dimension myview );
    void dump();
    void setWire();
    void setSurf2();
    void unsetWire();
    void unsetSurf2();

    void rotateX(KFloat rX) { rotX = rX; }
    void rotateY(KFloat rY) { rotY = rY; }

    void draw( KonoeTclTransform myTrans, KonoeTclGraphics* g,
               KInt RR, KInt GG, KInt BB );
    void draw2( KonoeTclTransform myTrans, KonoeTclGraphics* g,
                KInt RR, KInt GG, KInt BB );

  private:
	enum	{	isFalse = 0,	isTrue = 1	};

    KFloat fD;
    KChar myName[64];
    KFloat myOrigX;
    KFloat myOrigY;
    KFloat myOrigZ;
    KFloat nowAngle;
    KFloat nowRotation;
    KBool wireFrame;
    KBool surf2;
    KonoeTclSpaceManager* spMan;
};

#endif
