//=====================================================================
/*

    KonoeTclEventHitCanvas.hh

    Version 0.6.0   06-Sep-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLEVENTHITCANVAS_HH
#define __KONOETCLEVENTHITCANVAS_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclTransform.hh>
class KonoeTclEventViewCanvas;
class KonoeTclPhysPlacement;
class KonoeTclSolid;
class KonoeTclSpaceManager;
class KonoeTclDrawableString;


class KonoeTclEventHitCanvas {

  public:
    KonoeTclEventHitCanvas();
    KonoeTclEventHitCanvas(KonoeTclEventViewCanvas* peventViewCanvas);
    ~KonoeTclEventHitCanvas();
    void draw();
    void setEventViewCanvas(KonoeTclEventViewCanvas* pevnetViewCanvas);
    void setString(KChar** str, KChar* fColor="black",
                   KChar* fName="times", KInt fSize=12);
    void unsetString() { isDrawString = KFalse; }
    void setVisAtt(KInt i, KInt RR, KInt GG, KInt BB);
    void rotateX(KFloat rx);
    void rotateY(KFloat ry);
    void rotateZ(KFloat rz);
    void setSlowDraw() { slowDraw = KTrue; }
    void unsetSlowDraw() { slowDraw = KFalse; }

  private:
    void initInstance();
    void createGeometry();
    void createBoxPhysicalVolume(KInt i);
    void createStringPhysicalVolume(KInt i);

  private:
    KonoeTclEventViewCanvas* eventViewCanvas;
    KonoeTclPhysPlacement** detectorElement;
    KonoeTclPhysPlacement** physicalVolume;
    KonoeTclSolid** solid;
    KonoeTclSpaceManager* spMan;
    KInt totalOfPhys;
    KInt* drawNumber;

    KonoeTclPhysPlacement** stringVolume;
    KonoeTclDrawableString** stringSolid;
    KBool   isDrawString;
    KChar** str;
    KInt*   hitColorR;
    KInt*   hitColorG;
    KInt*   hitColorB;
//    KChar fontColor[256];
//    KChar fontName[256];
//    KInt  fontSize;
    KFloat rotX;
    KFloat rotY;
    KBool slowDraw;
};

#endif
