//=====================================================================
/*

    KonoeTclEventHitPoint.cc

    Version 0.0.1   11-Sep-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclEventHitPoint.hh>
#include <ui/KonoeTclEventViewCanvas.hh>
#include <ui/KonoeTclPhysPlacement.hh>
#include <ui/KonoeTclDrawableOval.hh>
#include <ui/KonoeTcl3DVector.hh>
#include <ui/KonoeTclRotationMatrix.hh>
#include <ui/KonoeTclDimension.hh>

KonoeTclEventHitPoint::KonoeTclEventHitPoint(KonoeTclEventViewCanvas* canvas)
{
  eventCanvas = canvas;
  radius = 1.;

  physicalVolume = 0;
}

KonoeTclEventHitPoint::KonoeTclEventHitPoint(KonoeTclEventViewCanvas* canvas,
                                             KonoeTcl3DVector point)
{
  eventCanvas = canvas;
  hitPoint = point;

  drawOval = new KonoeTclDrawableOval("dummy", 0.);
  
  KonoeTclRotationMatrix rm;
  KonoeTclTransform trans(rm, hitPoint);

  physicalVolume = new KonoeTclPhysPlacement(trans, drawOval);
  radius = 1.;
  setPoint(point);
}

KonoeTclEventHitPoint::~KonoeTclEventHitPoint()
{
  delete eventCanvas;
}

void KonoeTclEventHitPoint::setPoint(KonoeTcl3DVector point)
{
  KonoeTcl3DVector vec;
  KFloat toRealSize = eventCanvas->getRealCanvasSize();
  vec = KonoeTcl3DVector(point.getX()*toRealSize,
                         point.getY()*toRealSize,
                         point.getZ()*toRealSize);
  hitPoint = vec;
}

void KonoeTclEventHitPoint::setRadius(KDouble pRadius)
{
  radius = pRadius;
}

void KonoeTclEventHitPoint::draw(KInt RR, KInt GG, KInt BB)
{
//  if(physicalVolume != NULL){ delete physicalVolume;
//  cout <<"#################  PhysicalValue delete " << endl;}
  delete physicalVolume;

  drawOval = new KonoeTclDrawableOval( "HitPoint", radius );

  KonoeTclRotationMatrix rm;
  KonoeTclTransform trans(rm, hitPoint);

  physicalVolume = new KonoeTclPhysPlacement(trans, drawOval);

  physicalVolume->replace(KonoeTcl2Dimension());
  physicalVolume->setSpaceManager(eventCanvas->getSpaceManager());
  physicalVolume->setVisAtt(RR, GG, BB);

  physicalVolume->draw(eventCanvas);
}
