//=====================================================================
/*

    KonoeTclHistoPanel.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclHistoPanel.hh>
#include <analysis/KonoeLinearDataScale.hh>
#include <analysis/Konoe1DHistogram.hh>
#include <ui/KonoeTclDimension.hh>
#include <ui/KonoeTclDrawCanvas.hh>
#include <ui/KonoeTclLabel.hh>

KonoeTclHistoPanel::KonoeTclHistoPanel( KonoeTclWindow* kwin, KChar* kname,
                                        Konoe1DHistogram* pHisto,
                                        KonoeTclDimension pDim, KChar* pString,
                                        KonoeLinearDataScale* pScale )
  : KonoeTclFrame(kwin, kname)
{
  KChar pname[256];
  sprintf(pname, "label_of_%s", pString);
  titleName = new KonoeTclLabel( this, pname, pString );
  sprintf(pname, "canvas_of_%s", pString);
  myCanvas = new KonoeTclDrawCanvas( this, pname, pHisto, pDim,
                                     pString, pScale );
}

KonoeTclHistoPanel::~KonoeTclHistoPanel()
{
  delete titleName;
  delete myCanvas;
}
