//=====================================================================
/*

    KonoeTclOfflineHistogram.hh

    Version 0.0.1   18-Dec-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLOFFLINEHISTOGRAM_HH
#define __KONOETCLOFFLINEHISTOGRAM_HH

#include <ui/KonoeTclWidget.hh>
#include <ui/KonoeTclAction.hh>

class KonoeTclWindow;
class KonoeTclDrawCanvas;
class KonoeTclDrawPanel;
class KonoeTclDrawCanvasMouseListener;

class KonoeStreamableObject;
class Konoe1DHistogram;
class Konoe1DHistogramList;

class KonoeTclOfflineHistogram : public KonoeTclEventProcessor,
                                 public KonoeTclMouseAction {

  public:
    KonoeTclOfflineHistogram(KonoeTclWindow* pwin, KChar* pfName);
    ~KonoeTclOfflineHistogram();

    void setSaveFileFullPath(KChar* fullPath);

  private:
    KInt readFromFile(KChar* pfName);
    void init1DPanel();
    void init1DListPanel();

    void reDrawHistogram();

    void mouseAction(KonoeTclButton* btn, KInt type, KInt button,
                     Time time, KInt x, KInt y);
    void prevAction();
    void nextAction();

  private:
    KonoeStreamableObject* object;
    KonoeTclWindow* kwin;
    KonoeTclDrawCanvas* drawCanvas;
    KonoeTclDrawPanel* drawPanel;
    KonoeTclDrawCanvasMouseListener* mouseListener;
    KChar fileName[256];

    KonoeTclFrame* controlFrame;
    KonoeTclLabel* currentHistLabel;
    KonoeTclButton* prevButton;
    KonoeTclButton* nextButton;

    Konoe1DHistogram* hist1d;
    Konoe1DHistogramList* hist1dlist;

    KInt histNum;
    KInt currentHist;
};

#endif
