//=====================================================================
/*

    KonoeTclPhysPlacement.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLPHYSPLACEMENT_HH
#define __KONOETCLPHYSPLACEMENT_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclSolid.hh>

class KonoeTclTransform;
class KonoeTclSolid;
class KonoeTclSpaceManager;
class KonoeTcl2Dimension;
class KonoeTclGraphics;

class KonoeTclPhysPlacement {

  public:
    KonoeTclPhysPlacement();
    KonoeTclPhysPlacement( KonoeTclTransform trans, KonoeTclSolid* solid );
    KonoeTclPhysPlacement( KonoeTclTransform trans, KonoeTclSolid* solid,
                           KonoeTclSpaceManager* pMan );
    ~KonoeTclPhysPlacement();

    inline void setForceWireFrame() { mySolid->setWire(); }
    inline void unsetForceWireFrame() { mySolid->unsetWire(); }
    inline void setSurf2Mode() { mySolid->setSurf2(); }
    inline void unsetSurf2Mode() { mySolid->unsetSurf2(); }
    inline void setThinGap() { mySolid->setThinGap(); }

    inline KonoeTclSpaceManager* getSpaceManager() { return spMan; }
    void setSpaceManager(KonoeTclSpaceManager* pMan);

    KFloat getDistanceToEye() { return distanceToEye; }
    KonoeTclTransform getTransform() { return myTrans; }
    KonoeTclSolid* getSolid() { return mySolid; }

    void setVisAtt( KInt rr, KInt gg, KInt bb );
    void replace( KonoeTcl2Dimension noView );
    void rotateX(KFloat rotX);
    void rotateY(KFloat rotY);

    void dump();
    void draw( KonoeTclGraphics* g );


  private:
    KonoeTclTransform myTrans;
    KonoeTclSolid* mySolid;
    KonoeTclSpaceManager* spMan;

    KInt RR;
    KInt GG;
    KInt BB;

    KFloat distanceToEye;
};

#endif
