//=====================================================================
/*

    KonoeTclScale.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.5.1   25-Jan-2000 H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclScale.hh>
#include <analysis/KonoeDataScale.hh>
#include <ui/KonoeTclDimension.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclCanvas.hh>

KonoeTclScale::KonoeTclScale()
{
  posiFrom = 0.0;
  posiTo = 100.0;
  markTotal = 20;
  bigMarkTotal = 5;
//  dim = NULL;
  markWidth = 5;
  bigMarkWidth = 10;
  binCount = 100;
}

KonoeTclScale::KonoeTclScale( KonoeDataScale* pScale, KonoeTclDimension pDim )
{
  posiFrom = pScale->getMinimum();
  posiTo = pScale->getMaximum();
  markTotal = 20;
  bigMarkTotal = 5;
  dim = pDim;
  markWidth = 5;
  bigMarkWidth = 10;
  binCount = pScale->getBinCount();
}

KonoeTclScale::~KonoeTclScale()
{ ; }

void KonoeTclScale::setDimension( KonoeTclDimension pDim )
{
  dim = pDim;
}

void KonoeTclScale::setMarkTotal(KInt n)
{
  markTotal = n;
}

void KonoeTclScale::setBigMarkTotal(KInt n)
{
  bigMarkTotal = n;
}

void KonoeTclScale::placement()
{ ; }

KInt KonoeTclScale::getCoordinate( KDouble value )
{
  KInt i;
  i = (KInt)(( value - posiFrom)
               *(KDouble)(dim.getHeight())/(posiTo - posiFrom));
  return i;
}

void KonoeTclScale::drawMe( KonoeTclGraphics* g )
{
	KInt	i;

  for( i=1; i<markTotal; i++){
    g->drawLine( dim.getOrigX() + i*dim.getWidth()/markTotal,
                 dim.getHeight() + dim.getOrigY() - markWidth,
                 dim.getOrigX() + i*dim.getWidth()/markTotal,
                 dim.getHeight() + dim.getOrigY() );
  }
  
  for( i=0; i<=bigMarkTotal; i++ ){
     KInt nowValue = dim.getOrigX() + i*dim.getWidth()/bigMarkTotal;
     KInt nowLabel = (KInt)(posiFrom + i*(posiTo-posiFrom)/bigMarkTotal);
     g->drawLine( nowValue,
                  dim.getHeight() + dim.getOrigY() - bigMarkWidth,
                  nowValue,
                  dim.getHeight() + dim.getOrigY() );
     //g->setFont("....");
     KChar nowlabel[128];
     sprintf( nowlabel, "%ld", nowLabel );
     g->drawText( nowValue, dim.getHeight() + dim.getOrigY() + 15,
                    nowlabel );
  }
}
