
//=====================================================================
/*

    KonoeTclScale.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLSCALE_HH
#define __KONOETCLSCALE_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclDimension.hh>

class KonoeDataScale;
class KonoeTclDimension;
class KonoeTclGraphics;

class KonoeTclScale {

  public:
    KonoeTclScale();
    KonoeTclScale( KonoeDataScale* pScale, KonoeTclDimension pDim );
    virtual ~KonoeTclScale();

    void setDimension( KonoeTclDimension pDim );
    void setMarkTotal(KInt n);
    void setBigMarkTotal(KInt n);
    void placement();
    KonoeTclDimension getDimension(){ return dim; }
    KInt getCoordinate( KDouble value );
    KDouble getMinimum() { return posiFrom; }
    KDouble getMaximum() { return posiTo; }
    KInt getMarkTotal() { return markTotal; }
    KInt getBigMarkTotal() { return bigMarkTotal; }
    KInt getBinCount() { return binCount; }
    virtual void drawMe( KonoeTclGraphics* g );

  protected:
    KDouble posiFrom;
    KDouble posiTo;
    KInt markTotal;
    KInt bigMarkTotal;
    KonoeTclDimension dim;
    KInt markWidth;
    KInt bigMarkWidth;
    KInt binCount;
};

#endif
