//=====================================================================
/*

    KonoeTclScaleVertical.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.5.1   25-Jan-2000 H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclScaleVertical.hh>
#include <ui/KonoeTclGraphics.hh>

KonoeTclScaleVertical::KonoeTclScaleVertical()
{ ; }

KonoeTclScaleVertical::KonoeTclScaleVertical( KonoeDataScale* pScale, KonoeTclDimension pDim ) : KonoeTclScale( pScale, pDim )
{ ; }

KonoeTclScaleVertical::~KonoeTclScaleVertical()
{ ; }

void KonoeTclScaleVertical::drawMe( KonoeTclGraphics* g )
{
  KInt i;

  for ( i = 1; i < markTotal; i++) {
    if( i%4 == 0){
      g->drawLine( dim.getOrigX(),
             dim.getOrigY()-(i*dim.getHeight())/markTotal+dim.getHeight(),
             dim.getOrigX()+bigMarkWidth,
             dim.getOrigY()-(i*dim.getHeight())/markTotal+dim.getHeight());
    }
    else{
      g->drawLine( dim.getOrigX(),
             dim.getOrigY()-(i*dim.getHeight())/markTotal+dim.getHeight(),
             dim.getOrigX()+markWidth,
             dim.getOrigY()-(i*dim.getHeight())/markTotal+dim.getHeight());
    }
  }

  for ( i = 0; i <= bigMarkTotal; i++) {
    KInt nowValue = dim.getOrigY()-(i*dim.getHeight())/bigMarkTotal;
    KInt nowLabel = (KInt)(posiFrom + i*(int)(posiTo-posiFrom)/bigMarkTotal);

    //g->drawLine( dim.getOrigX(),nowValue+dim.getHeight(),
    //            dim.getOrigX()+bigMarkWidth,nowValue+dim.getHeight());

    //g->setFont(new Font("Helvetica",Font.PLAIN,12) );

    KChar nowlabel[128];
    sprintf( nowlabel, "%ld", nowLabel );

    g->drawText( dim.getOrigX()-25, nowValue+dim.getHeight(),
                     nowlabel);
  }
}
