//=====================================================================
/*

    KonoeTclSolid.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLSOLID_HH
#define __KONOETCLSOLID_HH

#include <KonoePrimitives.hh>
#include <ui/KonoeTclTransform.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTcl2Dimension.hh>
#include <ui/KonoeTclSpaceManager.hh>

class KonoeTclSolid {

  public:
    KonoeTclSolid();
    virtual ~KonoeTclSolid();

    virtual void dump() = 0;
    virtual void draw( KonoeTclTransform pTrans, KonoeTclGraphics* g,
                       KInt rr, KInt gg, KInt bb ) = 0;
    virtual void draw2( KonoeTclTransform pTrans, KonoeTclGraphics* g,
                        KInt rr, KInt gg, KInt bb ) = 0;
    virtual void realDrawReplace( KonoeTcl2Dimension myTrans ) = 0;

    virtual void setWire() = 0;
    virtual void setSurf2() = 0;
    virtual void setThinGap() = 0;
    virtual void unsetWire() = 0;
    virtual void unsetSurf2() = 0;

    virtual void rotateX(KFloat rX) = 0;
    virtual void rotateY(KFloat rY) = 0;

    virtual KFloat getRotateX() { return rotX ;}
    virtual KFloat getRotateY() { return rotY ;}

    virtual void setSpaceManager( KonoeTclSpaceManager* pManager ) = 0;


  protected:
    KFloat rotX;
    KFloat rotY;
};

#endif
