//=====================================================================
/*

    KonoeTclSpaceManager.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLSPACEMANAGER_HH
#define __KONOETCLSPACEMANAGER_HH

#include <KonoePrimitives.hh>
#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif
#ifndef DEG
#define DEG			M_PI/180.
#endif

class KonoeTclDimension;
class KonoeTcl3DVector;

class KonoeTclSpaceManager {

  public:
    KonoeTclSpaceManager();
    ~KonoeTclSpaceManager();

    void setViewLotation( KFloat diff );
    void setViewAngle( KFloat diff );
    KonoeTclDimension reLocation( KonoeTcl3DVector pVec );
    void offsetScale();
    void setMagnification(KFloat value);
    void setCenterEye(KInt eyeX, KInt eyeY);

    KFloat getViewLotation() const { return viewLotation; }
    KFloat getViewAngle() const { return viewAngle; }
    KInt   getOriginX() const { return originXX; }
    KInt   getOriginY() const { return originYY; }
    KInt   getAxisLengthReal() const { return axisLengthReal; }
    KInt   getCenterPositionX() const { return centerPositionX; }
    KInt   getCenterPositionY() const { return centerPositionY;}
    KInt   getCenterEyeX() const { return centerEyeX; }
    KInt   getCenterEyeY() const { return centerEyeY; }
    KInt   getOffsetX() const { return offsetX; }
    KInt   getOffsetY() const { return offsetY; }
    KInt   getReTargetX() const { return reTargetX; }
    KInt   getReTargetY() const { return reTargetY; }
    KFloat getMagnification() const { return magnification; }

  private:
    KFloat viewLotation;
    KFloat viewAngle;
    KInt originXX;
    KInt originYY;
    KInt axisLengthReal;
    KInt centerPositionX;
    KInt centerPositionY;
    KInt centerEyeX;
    KInt centerEyeY;

    KInt offsetX;
    KInt offsetY;
    KInt reTargetX;
    KInt reTargetY;

    KFloat magnification;
};

#endif
