//=====================================================================
/*

    KonoeTclTransform.cc

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <iostream.h>
#include <math.h>
#include <ui/KonoeTclTransform.hh>
#include <ui/KonoeTcl3DVector.hh>
#include <ui/KonoeTclRotationMatrix.hh>

KonoeTclTransform::KonoeTclTransform()
{ ; }

KonoeTclTransform::KonoeTclTransform( KonoeTclRotationMatrix pRote,
                                      KonoeTcl3DVector pVec )
{
  myRoteX = pRote.getRX();
  myRoteY = pRote.getRY();
  myRoteZ = pRote.getRZ();

  myPosiX = pVec.getX();
  myPosiY = pVec.getY();
  myPosiZ = pVec.getZ();
}

KonoeTclTransform::~KonoeTclTransform()
{ ; }

void KonoeTclTransform::dump()
{
  cout << "Rotation = " << myRoteX << " " << myRoteY << " " << myRoteZ << endl;
  cout << "Position = " << myPosiX << " " << myPosiY << " " << myPosiZ << endl;
}

KDouble KonoeTclTransform::distanceToPoint( KonoeTcl3DVector pVec )
{
//  KDouble distance = (myPosiX - pVec.getX())*(myPosiX - pVec.getX()) +
//                     (myPosiY - pVec.getY())*(myPosiY - pVec.getY()) +
//                     (myPosiZ - pVec.getZ())*(myPosiZ - pVec.getZ())*
//                     (myPosiZ - pVec.getZ())*(myPosiZ - pVec.getZ())*
//                     (myPosiZ - pVec.getZ())*(myPosiZ - pVec.getZ());
  KDouble distance = sqrt((myPosiX - pVec.getX())*(myPosiX - pVec.getX())+
                          (myPosiY - pVec.getY())*(myPosiY - pVec.getY())+
                          (myPosiZ - pVec.getZ())*(myPosiZ - pVec.getZ()));

  return distance;
}
