//=====================================================================
/*

    KonoeTclTransform.hh

    Version 0.0.1   26-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLTRANSFORM_HH
#define __KONOETCLTRANSFORM_HH

#include <KonoePrimitives.hh>

class KonoeTcl3DVector;
class KonoeTclRotationMatrix;

class KonoeTclTransform {

  public:
    KonoeTclTransform();
    KonoeTclTransform( KonoeTclRotationMatrix pRote, KonoeTcl3DVector pVec);
    ~KonoeTclTransform();

    inline KDouble getX() { return myPosiX; }
    inline KDouble getY() { return myPosiY; }
    inline KDouble getZ() { return myPosiZ; }
    inline KDouble getRX() { return myRoteX; }
    inline KDouble getRY() { return myRoteY; }
    inline KDouble getRZ() { return myRoteZ; }

    void dump();
    KDouble distanceToPoint( KonoeTcl3DVector pVec );

  private:
    KDouble myRoteX;
    KDouble myRoteY;
    KDouble myRoteZ;
    KDouble myPosiX;
    KDouble myPosiY;
    KDouble myPosiZ;
};

#endif
