//=====================================================================
/*

    KonoeTclButton.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLBUTTON_HH
#define __KONOETCLBUTTON_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclGraphics.hh>
#include <iostream.h>


class KonoeTclButton : public KonoeTclGraphics {
  public:
    KonoeTclButton();
    KonoeTclButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap);
    KonoeTclButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap, 
                   KInt col, KInt row);
    ~KonoeTclButton();

    void setPosition(KInt sx, KInt sy);
    void setCaption(KChar* cap);
    void setWidth(KInt wid);
    void setHeight(KInt hei);
    void setSize(KInt wid, KInt hei);
    void enable();
    void disable();

    inline const KChar* getCaption() { return caption; }

    void mouseActionUI(KonoeTclButton* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclButton* kbt, XEvent* xe);
    void keyActionUI(KonoeTclButton* kbt, XEvent* xe);
    void windowActionUI(KonoeTclButton* kbt, XEvent* xe);

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar caption[256];
};

#endif
