//=====================================================================
/*

    KonoeTclCheckButton.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLCHECKBUTTON_HH
#define __KONOETCLCHECKBUTTON_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclGraphics.hh>

class KonoeTclCheckButton : public KonoeTclGraphics {
  public:
    KonoeTclCheckButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap);
    KonoeTclCheckButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap,
                        KInt col, KInt row);
    ~KonoeTclCheckButton();

    void mouseActionUI(KonoeTclCheckButton* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclCheckButton* kbt, XEvent* xe);
    void keyActionUI(KonoeTclCheckButton* kbt, XEvent* xe);
    void windowActionUI(KonoeTclCheckButton* kbt, XEvent* xe);

    void setCaption(KChar* cap);
    void setSelect();
    void deSelect();
    void toggle();
    void invoke();
    KChar* getValue();
    KInt isChecked();
    void enable();
    void disable();

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar caption[32];
};

#endif
