//=====================================================================
/*

    KonoeTclDialogBox.cc

    Version 0.5.0   18-Oct-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclDialogBox.hh>
#include <ui/KonoeTclManager.hh>

KonoeTclDialogBox::KonoeTclDialogBox()
{ 
  setManager();
}

KonoeTclDialogBox::KonoeTclDialogBox(KChar* mes)
{
  setManager();
  KChar cmd[256];
  sprintf(cmd, "tk_messageBox -message \"%s\" -type ok", mes);
  configCommand(cmd);
}

KonoeTclDialogBox::~KonoeTclDialogBox()
{ ; }

void KonoeTclDialogBox::create(KonoeTclWindow* kwin, KChar* kname)
{
  ;
}

KAnswer KonoeTclDialogBox::create(KonoeTclWindow* kwin, KChar* mes, 
                               KType ptype, KChar* tit, KIconType iconType)
{
  KChar cmd[256];
  KChar ktype[32];
  KChar kiconType[32];

  switch(ptype){
    case KAbortRetryIgnore:
      sprintf(ktype, "abortretryignore");
      break;
    case KOk:
      sprintf(ktype, "ok");
      break;
    case KOkCancel:
      sprintf(ktype, "okcancel");
      break;
    case KRetryCancel:
      sprintf(ktype, "retrycancel");
      break;
    case KYesNo:
      sprintf(ktype, "yesno");
      break;
    case KYesNoCancel:
      sprintf(ktype, "yesnocancel");
      break;
    default:
      sprintf(ktype, "ok");
  }

  switch(iconType){
    case KError:
      sprintf(kiconType, "error");
      break;
    case KInfo:
      sprintf(kiconType, "info");
      break;
    case KQuestion:
      sprintf(kiconType, "question");
      break;
    case KWarning:
      sprintf(kiconType, "warning");
      break;
    default:
      sprintf(kiconType, "info");
  }

  KChar mbReturnValue[32];
  strcpy(mbReturnValue, "messageBoxReturnValue");

  sprintf(cmd, "set %s [ tk_messageBox -parent %s -message \"%s\" -type %s -title \"%s\" -icon %s ]", mbReturnValue, kwin->getPath(), mes, ktype, tit, kiconType);
  configCommand(cmd);

  KChar answer[32];

  strcpy(answer, Tcl_GetVar(mgr->getInterp(), mbReturnValue, TCL_GLOBAL_ONLY));

  KAnswer answerValue;

  if( strcmp(answer, "abort") == 0 )         answerValue = KABORT;
  else if( strcmp(answer, "retry") == 0 )    answerValue = KRETRY;   
  else if( strcmp(answer, "ignore") == 0 )   answerValue = KIGNORE;
  else if( strcmp(answer, "ok") == 0 )       answerValue = KOK;
  else if( strcmp(answer, "cancel") == 0 )   answerValue = KCANCEL;
  else if( strcmp(answer, "yes") == 0 )      answerValue = KYES;
  else if( strcmp(answer, "no") == 0 )       answerValue = KNO;

  return answerValue;
}
