//=====================================================================
/*

    KonoeTclEntry.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLENTRY_HH
#define __KONOETCLENTRY_HH

#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclGraphics.hh>

class KonoeTclEntry : public KonoeTclGraphics {
  public:
    KonoeTclEntry(KonoeTclWindow* kwin, KChar* kname);
    KonoeTclEntry(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    ~KonoeTclEntry();

    void mouseActionUI(KonoeTclEntry* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclEntry* kbt, XEvent* xe);
    void keyActionUI(KonoeTclEntry* kbt, XEvent* xe);
    void windowActionUI(KonoeTclEntry* kbt, XEvent* xe);

    void setText(KChar* txt);
    void setSize(KInt n);
    void enable();
    void disable();
    void selectAll();
    KChar* getText();

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar caption[256];
};

#endif
