//=====================================================================
/*

    KonoeTclEventProcessor.hh

    Version 0.0.1   17-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLEVENTPROCESSOR_HH
#define __KONOETCLEVENTPROCESSOR_HH

#include <ui/KonoeTclButton.hh>
#include <ui/KonoeTclCanvas.hh>
#include <ui/KonoeTclCheckButton.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclListBox.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclMessage.hh>
#include <ui/KonoeTclRadioButton.hh>
#include <ui/KonoeTclSlider.hh>
#include <ui/KonoeTclText.hh>
#include <ui/KonoeTclWindow.hh>

class KonoeTclButton;
class KonoeTclCanvas;
class KonoeTclCheckButton;
class KonoeTclEntry;
class KonoeTclLabel;
class KonoeTclListBox;
class KonoeTclMenu;
class KonoeTclMenuButton;
class KonoeTclMessage;
class KonoeTclRadioButton;
class KonoeTclSlider;
class KonoeTclText;

#include <ui/KonoeTclActionDefinition.hh>

class KonoeTclEventProcessor {
  public:
    KonoeTclEventProcessor();
    virtual ~KonoeTclEventProcessor();

    virtual void paint(){;}
    virtual void timer(){;}
    virtual void timer(KonoeTclUIPrimitive* uip){;}

    virtual void mouseAction(KonoeTclButton* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclCanvas* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclCheckButton* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclEntry* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclLabel* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclListBox* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclMenu* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclMenuButton* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclMessage* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclRadioButton* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclSlider* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclText* kbt, XEvent* xev){;}
    virtual void mouseAction(KonoeTclWindow* kbt, XEvent* xev){;}

    virtual void mouseAction(KonoeTclButton* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclCanvas* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclCheckButton* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclEntry* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclLabel* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclListBox* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclMenu* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclMenuButton* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclMessage* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclRadioButton* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclSlider* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclText* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}
    virtual void mouseAction(KonoeTclWindow* kbt, KInt type, KInt button,
                             Time time, KInt x, KInt y){;}

    virtual void mouseMotion(KonoeTclButton* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclCanvas* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclCheckButton* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclEntry* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclLabel* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclListBox* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclMenu* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclMenuButton* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclMessage* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclRadioButton* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclSlider* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclText* kbt, XEvent* xev){;}
    virtual void mouseMotion(KonoeTclWindow* kbt, XEvent* xev){;}

    virtual void mouseMotion(KonoeTclButton* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclCanvas* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclCheckButton* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclEntry* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclLabel* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclListBox* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclMenu* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclMenuButton* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclMessage* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclRadioButton* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclSlider* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclText* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}
    virtual void mouseMotion(KonoeTclWindow* kbt, KInt type, KInt state,
                             Time time, KInt x, KInt y){;}

    virtual void keyAction(KonoeTclButton* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclCanvas* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclCheckButton* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclEntry* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclLabel* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclListBox* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclMenu* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclMenuButton* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclMessage* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclRadioButton* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclSlider* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclText* kbt, XEvent* xev){;}
    virtual void keyAction(KonoeTclWindow* kbt, XEvent* xev){;}

    virtual void keyAction(KonoeTclButton* kbt, KInt type, KeySym keysym,
                           KInt state){;}
    virtual void keyAction(KonoeTclCanvas* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclCheckButton* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclEntry* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclLabel* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclListBox* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclMenu* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclMenuButton* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclMessage* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclRadioButton* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclSlider* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclText* kbt, KInt type, KeySym keysym, 
                           KInt state){;}
    virtual void keyAction(KonoeTclWindow* kbt, KInt type, KeySym keysym, 
                           KInt state){;}

    virtual void windowAction(KonoeTclButton* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclCanvas* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclCheckButton* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclEntry* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclLabel* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclListBox* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclMenu* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclMenuButton* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclMessage* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclRadioButton* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclSlider* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclText* kbt, XEvent* xev){;}
    virtual void windowAction(KonoeTclWindow* kbt, XEvent* xev){;}

  protected:
};

#endif
