//=====================================================================
/*

    KonoeTclFrame.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclFrame.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclManager.hh>

KonoeTclFrame::KonoeTclFrame(KonoeTclWindow* kwin, KChar* kname)
{
  parentWindow = kwin;
  create(kwin, kname);
}

KonoeTclFrame::KonoeTclFrame(KonoeTclWindow* kwin, KChar* kname,
                                                   KInt col, KInt row)
{
  parentWindow = kwin;
  create(kwin, kname, col, row);
}

KonoeTclFrame::~KonoeTclFrame()
{ ; } 

void KonoeTclFrame::create(KonoeTclWindow* kwin, KChar* kname)
{
  setManager();
  strcpy(name, kname);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }

  KChar cmd[256];
  sprintf(cmd, "frame %s", path); 
  configNoUpdate(cmd);
  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
}

void KonoeTclFrame::create(KonoeTclWindow* kwin, KChar* kname,
                                                 KInt col, KInt row)
{
  setManager();
  strcpy(name, kname);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }

  KChar cmd[256];

  sprintf(cmd, "frame %s", path); 
  configNoUpdate(cmd);

  sprintf(cmd, "grid %s -column %d -row %d", path, col, row);
  configNoUpdate(cmd);

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
}

void KonoeTclFrame::setFrame()
{
  KChar cmd[256];
  sprintf(cmd, "pack %s -side %s", path, type);
  configNoUpdate(cmd);
  //configCommand(cmd);
}

void KonoeTclFrame::setSize(KInt x, KInt y)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -width %ld -height %ld", path, x, y);
  configNoUpdate(cmd);
}
