//=====================================================================
/*

    KonoeTclGraphics.cc

    Version 0.0.1   17-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclEventProcessor.hh>

KonoeTclGraphics::KonoeTclGraphics()
{
  color = new KChar[32];
} 

KonoeTclGraphics::~KonoeTclGraphics()
{
  delete [] color;
  Tk_FreeGC(disp, gc);
}

void KonoeTclGraphics::setGraphics(Tk_Window kwin)
{
  disp = Tk_Display(kwin);
  if(disp == NULL) cerr << "Display is NULL" << endl;
  xwin  = Tk_WindowId(kwin);

  gc = Tk_GetGC(kwin, 0, 0);
  if(gc == NULL) cerr << "GC is NULL" << endl;

  setColor("black");
}

void KonoeTclGraphics::setColor(KInt rr, KInt gg, KInt bb)
{
  KChar* color16 = new KChar[16];
  color16[0] = '\0';

  KonoeTclCore::transformColor(color16, rr, gg, bb);
  
  setColor( color16 );
  delete [] color16;
}

void KonoeTclGraphics::setColor(KChar* col)
{
  if(color!=NULL) delete [] color;
  color = new KChar[32];
  strcpy(color, col);
}

void KonoeTclGraphics::paintUI()
{
  kEventProcessor->paint();
}

void KonoeTclGraphics::drawLine(KInt x1, KInt y1, KInt x2, KInt y2)
{
  Colormap colmap;
  XColor exact;
  colmap = DefaultColormap(disp, 0);
  XAllocNamedColor(disp, colmap, color, &xcolor, &exact);
  XSetForeground( disp, gc, xcolor.pixel);
  XDrawLine(disp, xwin, gc, x1, y1, x2, y2);
  XMapWindow(disp, xwin);
  XFlush(disp);
}

void KonoeTclGraphics::drawRectangle(KInt x, KInt y, KInt w, KInt h)
{
  Colormap colmap;
  XColor exact;
  colmap = DefaultColormap(disp, 0);
  XAllocNamedColor(disp, colmap, color, &xcolor, &exact);
  XSetForeground( disp, gc, xcolor.pixel);
  XDrawRectangle(disp, xwin, gc, x, y, w, h);
  XMapWindow(disp, xwin);
  XFlush(disp);
}

void KonoeTclGraphics::drawFillRectangle(KInt x, KInt y, KInt w, KInt h)
{
  Colormap colmap;
  XColor exact;
  colmap = DefaultColormap(disp, 0);
  XAllocNamedColor(disp, colmap, color, &xcolor, &exact);
  XSetForeground( disp, gc, xcolor.pixel);
  XFillRectangle(disp, xwin, gc, x, y, w+2, h+2);
  XMapWindow(disp, xwin);
  XFlush(disp);
}

void KonoeTclGraphics::drawOval(KInt x1, KInt y1, KInt x2, KInt y2)
{
;
}

void KonoeTclGraphics::drawFillOval(KInt x1, KInt y1, KInt x2, KInt y2)
{
;
}

void KonoeTclGraphics::drawArc(KInt x1, KInt y1, KInt x2, KInt y2)
{
;
}

void KonoeTclGraphics::drawText(KInt x, KInt y, KChar* text)
{
  Colormap colmap;
  XColor exact;
  colmap = DefaultColormap(disp, 0);
  XAllocNamedColor(disp, colmap, color, &xcolor, &exact);
  XSetForeground( disp, gc, xcolor.pixel);
  XDrawString(disp, xwin, gc, x, y, text, strlen(text));
  XMapWindow(disp, xwin);
  XFlush(disp);
}

void KonoeTclGraphics::drawString(KInt x, KInt y, KChar* text)
{
  Colormap colmap;
  XColor exact;
  colmap = DefaultColormap(disp, 0);
  XAllocNamedColor(disp, colmap, color, &xcolor, &exact);
  XSetForeground( disp, gc, xcolor.pixel);
  XDrawString(disp, xwin, gc, x, y, text, strlen(text));
  XMapWindow(disp, xwin);
  XFlush(disp);
}

void KonoeTclGraphics::drawPolygon(KInt xPoints[], KInt yPoints[], KInt nPoints)
{ ; }

void KonoeTclGraphics::drawFillPolygon(KInt xPoints[], KInt yPoints[],
                                                                  KInt nPoints)
{ ; }
