//=====================================================================
/*

    KonoeTclGraphics.hh

    Version 0.0.1   17-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLGRAPHICS_HH
#define __KONOETCLGRAPHICS_HH

#include <ui/KonoeTclUIPrimitive.hh>

class KonoeTclGraphics : virtual public KonoeTclUIPrimitive {
  public:
    KonoeTclGraphics();
    virtual ~KonoeTclGraphics();

    void setGraphics(Tk_Window kwin);
    void setColor(KInt rr, KInt gg, KInt bb);
    void setColor(KChar* col);
    KChar* getColor(){ return color; }
    
    void paintUI();

    virtual void drawLine(KInt x, KInt y, KInt w, KInt h);
    virtual void drawRectangle(KInt x, KInt y, KInt w, KInt h);
    virtual void drawFillRectangle(KInt x, KInt y, KInt w, KInt h);
    virtual void drawOval(KInt x1, KInt y1, KInt x2, KInt y2);
    virtual void drawFillOval(KInt x1, KInt y1, KInt x2, KInt y2);
    virtual void drawArc(KInt x1, KInt y1, KInt x2, KInt y2);
    //virtual void drawFillArc(KInt x1, KInt y1, KInt x2, KInt y2);
    virtual void drawText(KInt x, KInt y, KChar* text);
    virtual void drawString(KInt x, KInt y, KChar* text);
    //virtual void drawText(KInt x, KInt y, KChar* text, KInt width);
    virtual void drawPolygon(KInt xPoints[], KInt yPoints[], KInt nPoints);
    virtual void drawFillPolygon(KInt xPoints[], KInt yPoints[], KInt nPoints);


  protected:
    Display* disp;
    Window xwin;
    GC gc;
    XGCValues xgcv;
    XColor xcolor;
    KChar* color;

};

#endif
