//=====================================================================
/*

    KonoeTclImage.cc

    Version 0.0.1   09-Sep-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclImage.hh>

#include <iostream.h>
#include <string.h>

KonoeTclImage::KonoeTclImage()
{ ; }

KonoeTclImage::KonoeTclImage(KChar* kname)
{
  setManager();
  strcpy(imageName, kname);

  KChar cmd[256];

  sprintf(cmd, "image create photo %s", imageName);
  configNoUpdate(cmd);
}

KonoeTclImage::KonoeTclImage(KChar* kname, KChar* filepath)
{
  setManager();
  strcpy(imageName, kname);

  KChar cmd[256];

  sprintf(cmd, "image create photo %s -file %s", imageName, filepath);
  configNoUpdate(cmd);
}

KonoeTclImage::~KonoeTclImage()
{ ; }

void KonoeTclImage::setBackGround(KChar* col)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -background %s", imageName, col);
  configCommand(cmd);
}

void KonoeTclImage::setFormat(KChar* kformat)
{
  KChar cmd[256];

  sprintf(cmd, "%s configure -format %s", imageName, kformat);
  configCommand(cmd);
}

void KonoeTclImage::setFile(KChar* kpath)
{
  KChar cmd[256];

  sprintf(cmd, "%s configure -file %s", imageName, kpath);
  configCommand(cmd);
}

void KonoeTclImage::setData(KChar* kmime)
{
  KInt dsize = strlen(kmime) + 1;
  KChar* cmd = new KChar[dsize+256];
  
  sprintf(cmd, "%s  configure -data %s", imageName, kmime);
  configCommand(cmd);

  delete [] cmd;
}

void KonoeTclImage::setGamma(KDouble kgamma)
{
  KChar cmd[256];

  sprintf(cmd, "%s configure -gamma %f", imageName, kgamma);
  configCommand(cmd);
}

void KonoeTclImage::setHeight(KInt h)
{
  KChar cmd[256];

  sprintf(cmd, "%s configure -height %ld", imageName, h);
  configCommand(cmd);
}

void KonoeTclImage::setWidth(KInt w)
{
  KChar cmd[256];

  sprintf(cmd, "%s configure -width %ld", imageName, w);
  configCommand(cmd);
}

void KonoeTclImage::copyImage(KonoeTclImage* image)
{
  KChar cmd[256];

  sprintf(cmd, "%s copy %s", imageName, image->getName());
  configCommand(cmd);
}

void KonoeTclImage::deleteImage()
{
  KChar cmd[256];

  sprintf(cmd, "image delete %s", imageName);
  configCommand(cmd);
}
