//=====================================================================
/*

    KonoeTclKeyAction.cc

    Version 0.5.0   04-Oct-1999 T. Hosoi
    Version 0.5.1   25-Jan-2000 H. Sakamoto
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <KonoePrimitives.hh>
#include <ui/KonoeTclKeyAction.hh>

KonoeTclKeyAction::KonoeTclKeyAction()
{ ; }

KonoeTclKeyAction::~KonoeTclKeyAction()
{ ; }

void KonoeTclKeyAction::addKeyAction(KonoeTclButton* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
              (void(*)(void*, _XEvent*)) keyActionButton, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclCanvas* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
              (void(*)(void*, _XEvent*)) keyActionCanvas, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclCheckButton* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
              (void(*)(void*, _XEvent*)) keyActionCheckButton, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclEntry* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyPressMask,
              (void(*)(void*, _XEvent*)) keyActionEntry, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclLabel* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
            (void(*)(void*, _XEvent*)) keyActionLabel, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclListBox* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
            (void(*)(void*, _XEvent*)) keyActionListBox, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclMenu* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress  | KeyReleaseMask,
           (void(*)(void*, _XEvent*)) keyActionMenu, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclMenuButton* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
          (void(*)(void*, _XEvent*)) keyActionMenuButton, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclMessage* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
         (void(*)(void*, _XEvent*)) keyActionMessage, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclSlider* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
         (void(*)(void*, _XEvent*)) keyActionSlider, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclText* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
         (void(*)(void*, _XEvent*)) keyActionText, (ClientData) bt);
}

void KonoeTclKeyAction::addKeyAction(KonoeTclWindow* bt)
{
  Tk_CreateEventHandler(bt->getWindow(), KeyPress | KeyReleaseMask,
         (void(*)(void*, _XEvent*)) keyActionWindow, (ClientData) bt);
}

void KonoeTclKeyAction::keyActionButton(KonoeTclButton* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionCanvas(KonoeTclCanvas* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionCheckButton(KonoeTclCheckButton* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionEntry(KonoeTclEntry* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionLabel(KonoeTclLabel* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionListBox(KonoeTclListBox* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionMenu(KonoeTclMenu* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionMenuButton(KonoeTclMenuButton* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionMessage(KonoeTclMessage* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionRadioButton(KonoeTclRadioButton* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionSlider(KonoeTclSlider* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionText(KonoeTclText* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}

void KonoeTclKeyAction::keyActionWindow(KonoeTclWindow* kbt, XEvent* xe)
{
  kbt->keyActionUI(kbt, xe);
}
