//=====================================================================
/*

    KonoeTclKeyAction.hh

    Version 0.5.0   04-Oct-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLKEYACTION_HH
#define __KONOETCLKEYACTION_HH

#include <tk.h>
#include <ui/KonoeTclUIPrimitive.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclButton.hh>
#include <ui/KonoeTclCanvas.hh>
#include <ui/KonoeTclCheckButton.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclListBox.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclMessage.hh>
#include <ui/KonoeTclRadioButton.hh>
#include <ui/KonoeTclSlider.hh>
#include <ui/KonoeTclText.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclEventProcessor.hh>
#include <X11/keysym.h>

class KonoeTclKeyAction {

  public:
    KonoeTclKeyAction();
    virtual ~KonoeTclKeyAction();

    void addKeyAction(KonoeTclButton* bt);
    void addKeyAction(KonoeTclCanvas* bt);
    void addKeyAction(KonoeTclCheckButton* bt);
    void addKeyAction(KonoeTclEntry* bt);
    void addKeyAction(KonoeTclLabel* bt);
    void addKeyAction(KonoeTclListBox* bt);
    void addKeyAction(KonoeTclMenu* bt);
    void addKeyAction(KonoeTclMenuButton* bt);
    void addKeyAction(KonoeTclMessage* bt);
    void addKeyAction(KonoeTclRadioButton* bt);
    void addKeyAction(KonoeTclSlider* bt);
    void addKeyAction(KonoeTclText* bt);
    void addKeyAction(KonoeTclWindow* bt);

  protected:

    static void keyActionButton(KonoeTclButton* kbt, XEvent* xe);
    static void keyActionCanvas(KonoeTclCanvas* kbt, XEvent* xe);
    static void keyActionCheckButton(KonoeTclCheckButton* kbt, XEvent* xe);
    static void keyActionEntry(KonoeTclEntry* kbt, XEvent* xe);
    static void keyActionLabel(KonoeTclLabel* kbt, XEvent* xe);
    static void keyActionListBox(KonoeTclListBox* kbt, XEvent* xe);
    static void keyActionMenu(KonoeTclMenu* kbt, XEvent* xe);
    static void keyActionMenuButton(KonoeTclMenuButton* kbt, XEvent* xe);
    static void keyActionMessage(KonoeTclMessage* kbt, XEvent* xe);
    static void keyActionRadioButton(KonoeTclRadioButton* kbt, XEvent* xe);
    static void keyActionSlider(KonoeTclSlider* kbt, XEvent* xe);
    static void keyActionText(KonoeTclText* kbt, XEvent* xe);
    static void keyActionWindow(KonoeTclWindow* kbt, XEvent* xe);

};

#endif
