//=====================================================================
/*

    KonoeTclLabel.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclEventProcessor.hh>

KonoeTclLabel::KonoeTclLabel(KonoeTclWindow* kwin, KChar* kname, KChar* cap)
{ 
  parentWindow = kwin;
  strcpy(caption, cap); 
  setWidgetType(Label);
  create(kwin, kname);
}

KonoeTclLabel::KonoeTclLabel(KonoeTclWindow* kwin, KChar* kname, KChar* cap,
                             KInt col, KInt row)
{ 
  parentWindow = kwin;
  strcpy(caption, cap); 
  setWidgetType(Label);
  create(kwin, kname, col, row);
}

KonoeTclLabel::~KonoeTclLabel()
{ ; }

void KonoeTclLabel::create(KonoeTclWindow* kwin, KChar* kname)
{
  createProcess(kwin, kname);

  KChar cmd[256];

  sprintf(cmd, "label %s -text \"%s\"", path, caption);
  configNoUpdate(cmd);
  sprintf(cmd, "pack %s -side %s", path, type);
  configNoUpdate(cmd);
  //configCommand(cmd);

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
  setGraphics(win);
}

void KonoeTclLabel::create(KonoeTclWindow* kwin, KChar* kname,
                           KInt col, KInt row)
{
  createProcess(kwin, kname);

  KChar cmd[256];

  sprintf(cmd, "label %s -text \"%s\"", path, caption);
  configNoUpdate(cmd);

  sprintf(cmd, "grid %s -column %ld -row %ld", path, col, row);
  configNoUpdate(cmd);

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
  setGraphics(win);
}

void KonoeTclLabel::createProcess(KonoeTclWindow* kwin, KChar* kname)
{
  setManager();
  strcpy(name, kname);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }
}

void KonoeTclLabel::mouseActionUI(KonoeTclLabel* bt, XEvent* xev)
{
  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  button = xev->xbutton.button;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseAction(bt, btype, button, time,x, y);
  kEventProcessor->mouseAction(bt, xev);
}

void KonoeTclLabel::mouseMotionUI(KonoeTclLabel* bt, XEvent* xev)
{
  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  state = xev->xbutton.state;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseMotion(bt, btype, state, time,x, y);
  kEventProcessor->mouseMotion(bt, xev);
}

void KonoeTclLabel::keyActionUI(KonoeTclLabel * bt, XEvent* xev)
{
  KChar buffer[20];
  KInt bufsize = 20;
  KeySym keysym;
  KInt btype;
  KInt state;

  XLookupString(&(xev->xkey), buffer, bufsize, &keysym, (XComposeStatus*) NULL);
  btype = xev->xkey.type;
  state = xev->xkey.state;

  kEventProcessor->keyAction(bt, btype, keysym, state);
  kEventProcessor->keyAction(bt, xev);
}

void KonoeTclLabel::windowActionUI(KonoeTclLabel* bt, XEvent* xev)
{
  kEventProcessor->windowAction(bt, xev);
}

void KonoeTclLabel::setCaption(KChar* cap)
{
  strcpy(caption, cap);
  KChar cmd[256];
  sprintf(cmd, "%s configure -text \"%s\"", path, caption);
  configNoUpdate(cmd);
}

void KonoeTclLabel::setPosition(KInt sx, KInt sy)
{
  KChar cmd[256];
  sprintf(cmd, "place %s -x %ld -y %ld", path, sx, sy);
  configCommand(cmd);
}
