//=====================================================================
/*

    KonoeTclListBox.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLLISTBOX_HH
#define __KONOETCLLISTBOX_HH

#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclFrame.hh>

enum {KSingle, KBrowse, KMultiple, KExtended };

class KonoeTclListBox :public KonoeTclGraphics {
  public:
    KonoeTclListBox(KonoeTclWindow* kwin, KChar* kname);
    KonoeTclListBox(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    KonoeTclListBox(KonoeTclWindow* kwin, KChar* kname, KScrollType scrl);
    KonoeTclListBox(KonoeTclWindow* kwin, KChar* kname, KScrollType scrl,
                    KInt col, KInt row);
    ~KonoeTclListBox();

    void mouseActionUI(KonoeTclListBox* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclListBox* kbt, XEvent* xe);
    void keyActionUI(KonoeTclListBox* kbt, XEvent* xe);
    void windowActionUI(KonoeTclListBox* kbt, XEvent* xe);

    void setSize(KInt w, KInt h);
    void insert(KChar* kitem);
    void insert(KInt nPos, KChar* kitem);
    void deleteItem(KInt firstPos, KInt lastPos);
    void deleteItem(KInt nPos);
    /* single, browse, multiple, extended */
    void setMode(KChar* mode);
    void setMode(KInt mode);
    void setSelectBackGround(KChar* col);
    void setSelectForeGround(KChar* col);
    void exportSelection();
    KInt   getTotalIndex();
    KChar* getSelectedIndex();

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createWithScrollBar(KonoeTclWindow* kwin, KChar* kname);
    void createWithScrollBar(KonoeTclWindow* kwin, KChar* kname,
                             KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar scrll[256];
    KonoeTclFrame* scrollFrame;
};

#endif
