//=====================================================================
/*

    KonoeTclMainWindow.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <iostream.h>
#include <tcl.h>
#include <tk.h>
#include <ui/KonoeTclMainWindow.hh>
#include <ui/KonoeTclManager.hh>

KonoeTclMainWindow::KonoeTclMainWindow()
{
  createMainWindow();
}

KonoeTclMainWindow::KonoeTclMainWindow(KChar* title)
{
  createMainWindow(title);
}

void KonoeTclMainWindow::createMainWindow()
{
  //KonoeTclManager* mgr = new KonoeTclManager;
  mgr = new KonoeTclManager;
  setManager();
  sprintf(path, ".");
  win = Tk_MainWindow(mgr->getInterp());
  Display* disp = Tk_Display(win);
  if(disp == NULL)
    cerr << "Error: Can't open Display" << endl;
  Tcl_Eval(mgr->getInterp(), "update");
}

void KonoeTclMainWindow::createMainWindow(KChar* title)
{
  //KonoeTclManager* mgr = new KonoeTclManager;
  mgr = new KonoeTclManager;
  setManager();
  sprintf(path, ".");

  KChar cmd[256];

  sprintf(cmd, "wm title . \"%s\"", title);
  configCommand(cmd);

  win = Tk_MainWindow(mgr->getInterp());
  Display* disp = Tk_Display(win);
  if(disp == NULL)
    cerr << "Error: Can't open Display" << endl;
  Tcl_Eval(mgr->getInterp(), "update");
}

void KonoeTclMainWindow::mainLoop()
{
  Tk_MainLoop();
}

void KonoeTclMainWindow::setTitle(KChar* title)
{
  char cmd[256];
  sprintf(cmd, "wm title %s \"%s\"", path, title);
  configNoUpdate(cmd);
}
