//=====================================================================
/*

    KonoeTclMenu.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi , H. Yumura
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclEventProcessor.hh>

KonoeTclMenu::KonoeTclMenu(KonoeTclWindow* kwin, KChar* kname)
{
  parentWindow = kwin;
  setManager();
  strcpy(name, kname);
  setWidgetType(Menu);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }

  KChar cmd[256];

  sprintf(cmd,"%s configure -menu %s",kwin->getPath(), path);
  configNoUpdate(cmd);

  sprintf(cmd,"menu %s -tearoff no", path);
  configNoUpdate(cmd);

   win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
   setGraphics(win);
}

KonoeTclMenu::~KonoeTclMenu()
{ ; }

void KonoeTclMenu::addCommand(KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd, "%s add command -label \"%s\"",path, lab);
  configNoUpdate(cmd);

}

void KonoeTclMenu::addCommand(KChar* lab, KChar* com)
{
  KChar cmd[256];

  sprintf(cmd, "%s add command -label \"%s\" -command %s",path,  lab, com);
  configNoUpdate(cmd);

}

void KonoeTclMenu::addRadioButton(KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd, "%s add radiobutton -label \"%s\" ",path,lab);
  configNoUpdate(cmd);

}
void KonoeTclMenu::addCheckButton(KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd, "%s add checkbutton -label \"%s\" ",path,lab);
  configNoUpdate(cmd);

}
void KonoeTclMenu::addSeparator()
{
  KChar cmd[256];

  sprintf(cmd, "%s add separator ",path);
  configNoUpdate(cmd);

}

void KonoeTclMenu::makeCascade(KonoeTclWindow* kwin, KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd,"%s add cascade -label \"%s\" -menu %s",path,lab,kwin->getPath());
  configNoUpdate(cmd);  

}

void KonoeTclMenu::setPopup(KInt x, KInt y)
{
  KChar cmd[256];
  sprintf(cmd, "tk_popup %s %ld %ld", path, x, y);
  configNoUpdate(cmd);
}

void KonoeTclMenu::mouseActionUI(KonoeTclMenu* bt, XEvent* xev)
{
  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  button = xev->xbutton.button;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseAction(bt, btype, button, time,x, y);
  kEventProcessor->mouseAction(bt, xev);
}

void KonoeTclMenu::mouseMotionUI(KonoeTclMenu* bt, XEvent* xev)
{
  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  state = xev->xbutton.state;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseMotion(bt, btype, state, time,x, y);
  kEventProcessor->mouseMotion(bt, xev);
}

void KonoeTclMenu::keyActionUI(KonoeTclMenu* bt, XEvent* xev)
{
  KChar buffer[20];
  KInt bufsize = 20;
  KeySym keysym;
  KInt btype;
  KInt state;

  XLookupString(&(xev->xkey), buffer, bufsize, &keysym, (XComposeStatus*) NULL);
  btype = xev->xkey.type;
  state = xev->xkey.state;

  kEventProcessor->keyAction(bt, btype, keysym, state);
  kEventProcessor->keyAction(bt, xev);
}

void KonoeTclMenu::windowActionUI(KonoeTclMenu* bt, XEvent* xev)
{
  kEventProcessor->windowAction(bt, xev);
}

