//=====================================================================
/*

    KonoeTclMenuButton.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi , H. Yumura
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclEventProcessor.hh>

KonoeTclMenuButton::KonoeTclMenuButton(KonoeTclWindow* kwin, KChar* kname,
                                       KChar* cap)
{ 
  parentWindow = kwin;
  setManager();
  strcpy(name, kname);
  strcpy(caption, cap);
  setWidgetType(MenuButton);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }

  KChar cmd[256];

  sprintf(cmd, "menubutton %s -text \"%s\"", path, cap);
  configNoUpdate(cmd); 


  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
  setGraphics(win);

}

KonoeTclMenuButton::~KonoeTclMenuButton()
{ ; }

void KonoeTclMenuButton::create(KonoeTclWindow* kwin, KChar* kname){;}

void KonoeTclMenuButton::createMButton()
{ 
  KChar cmd[256];

  sprintf(cmd, "pack %s -side %s", path, type);
  configNoUpdate(cmd);

}

void KonoeTclMenuButton::addCommand(KChar* cap)
{
  KChar cmd[256];
  sprintf(cmd, "%s add command -label \"%s\"", path, cap);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::addSeparator()
{
  KChar cmd[256];

  sprintf(cmd, "%s add separator ",path);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::addRadioButton(KChar* groupName, KChar* value,
                                        KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd, "%s add radiobutton -label \"%s\" -variable %s, \
                -value %s",path, lab, groupName, value);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::addCheckButton(KChar* cname, KChar* lab)
{
  KChar cmd[256];

  sprintf(cmd, "%s add checkbutton -label \"%s\" -variable %s -onvalue ON \
                -offvalue OFF", path, lab, cname);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::setPosition(KInt sx, KInt sy)
{
  KChar cmd[256];
  sprintf(cmd, "place %s -x %ld -y %ld", path, sx, sy);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::setCaption(KChar* cap)
{
  strcpy(caption, cap);
  KChar cmd[256];
  sprintf(cmd, "%s configure -text \"%s\"", path, caption);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::setPopup(KInt x, KInt y)
{
  KChar cmd[256];
  sprintf(cmd, "tk_popup %s %ld %ld", path, x, y);
  configNoUpdate(cmd);
}

void KonoeTclMenuButton::mouseActionUI(KonoeTclMenuButton* bt, XEvent* xev)
{
  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  button = xev->xbutton.button;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseAction(bt, btype, button, time,x, y);
  kEventProcessor->mouseAction(bt, xev);
}

void KonoeTclMenuButton::mouseMotionUI(KonoeTclMenuButton* bt, XEvent* xev)
{
  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  state = xev->xbutton.state;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseMotion(bt, btype, state, time,x, y);
  kEventProcessor->mouseMotion(bt, xev);
}

void KonoeTclMenuButton::windowActionUI(KonoeTclMenuButton* bt, XEvent* xev)
{
  kEventProcessor->windowAction(bt, xev);
}

void KonoeTclMenuButton::keyActionUI(KonoeTclMenuButton* bt, XEvent* xev)
{
  KChar buffer[20];
  KInt bufsize = 20;
  KeySym keysym;
  KInt btype;
  KInt state;

  XLookupString(&(xev->xkey), buffer, bufsize, &keysym, (XComposeStatus*) NULL);
  btype = xev->xkey.type;
  state = xev->xkey.state;

  kEventProcessor->keyAction(bt, btype, keysym, state);
  kEventProcessor->keyAction(bt, xev);
}
