//=====================================================================
/*

    KonoeTclMenuButton.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi , H. Yumura
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================


#ifndef __KONOETCLMENUBUTTON_HH
#define __KONOETCLMENUBUTTON_HH

#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclWindow.hh>

class KonoeTclMenuButton : public KonoeTclGraphics,
                           public KonoeTclWindow {
  public:
    KonoeTclMenuButton(){;}
    KonoeTclMenuButton(KonoeTclWindow*, KChar* kname, KChar* caption);
    virtual ~KonoeTclMenuButton();


   void create(KonoeTclWindow* kwin, KChar* kname);
   void createMButton();
   void addCommand(KChar* cap);
   void addSeparator();
   void addRadioButton(KChar* groupName, KChar* value, KChar* lab);
   void addCheckButton(KChar* cname, KChar* lab);

   void setPopup(KInt x, KInt y);
 
   void mouseActionUI(KonoeTclMenuButton* kbt, XEvent* xe);
   void mouseMotionUI(KonoeTclMenuButton* kbt, XEvent* xe);
   void keyActionUI(KonoeTclMenuButton* kbt, XEvent* xe);
   void windowActionUI(KonoeTclMenuButton* kbt, XEvent* xe);

   void setPosition(KInt sx, KInt sy);
   void setCaption(KChar* cap);

   inline KChar* getCaption() { return caption; }

  private:
    KChar caption[256];
};
    
#endif
