//=====================================================================
/*

    KonoeTclMessage.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <ui/KonoeTclMessage.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclEventProcessor.hh>

KonoeTclMessage::KonoeTclMessage(KonoeTclWindow* kwin, KChar* kname)
{
  parentWindow = kwin;
  setWidgetType(Message);
  create(kwin, kname);
}

KonoeTclMessage::KonoeTclMessage(KonoeTclWindow* kwin, KChar* kname, KChar* cap)
{
  parentWindow = kwin;
  strcpy(caption, cap);
  setWidgetType(Message);
  create(kwin, kname);
}

KonoeTclMessage::~KonoeTclMessage()
{ ; }

void KonoeTclMessage::create(KonoeTclWindow* kwin, KChar* kname)
{
  setManager();
  strcpy(name, kname);
  if(strcmp(kwin->getPath(), ".") == 0){
    sprintf(path, ".%s", name);
  }
  else{
    sprintf(path, "%s.%s", kwin->getPath(), name);
  }

  KChar cmd[256];

  sprintf(cmd, "message %s -text \"%s\"", path, caption);
  configNoUpdate(cmd);

  sprintf(cmd, "pack %s -side %s", path, type);
  configNoUpdate(cmd);
  //configCommand(cmd);

  win = Tk_NameToWindow(mgr->getInterp(), path, kwin->getWindow());
  setGraphics(win);
}

void KonoeTclMessage::mouseActionUI(KonoeTclMessage* bt, XEvent* xev)
{
  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  button = xev->xbutton.button;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseAction(bt, btype, button, time,x, y);
  kEventProcessor->mouseAction(bt, xev);
}

void KonoeTclMessage::mouseMotionUI(KonoeTclMessage* bt, XEvent* xev)
{
  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xev->xbutton.type;
  state = xev->xbutton.state;
  time = xev->xbutton.time;
  x = xev->xbutton.x;
  y = xev->xbutton.y;

  kEventProcessor->mouseMotion(bt, btype, state, time,x, y);
  kEventProcessor->mouseMotion(bt, xev);
}

void KonoeTclMessage::keyActionUI(KonoeTclMessage* bt, XEvent* xev)
{
  kEventProcessor->keyAction(bt, xev);
}

void KonoeTclMessage::windowActionUI(KonoeTclMessage* bt, XEvent* xev)
{
  kEventProcessor->windowAction(bt, xev);
}

void KonoeTclMessage::setWidth(KInt w){
  KChar cmd[256];
  sprintf(cmd, "%s configure -width %ld", path, w);
  configCommand(cmd);
}
