//=====================================================================
/*

    KonoeTclMouseAction.cc

    Version 0.0.1   17-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLMOUSEACTION_HH
#define __KONOETCLMOUSEACTION_HH

#include <tk.h>
#include <ui/KonoeTclUIPrimitive.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclButton.hh>
#include <ui/KonoeTclCanvas.hh>
#include <ui/KonoeTclCheckButton.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclListBox.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclMessage.hh>
#include <ui/KonoeTclRadioButton.hh>
#include <ui/KonoeTclSlider.hh>
#include <ui/KonoeTclText.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclEventProcessor.hh>


class KonoeTclMouseAction{
  public:
    KonoeTclMouseAction();
    virtual ~KonoeTclMouseAction();

    void addMouseAction(KonoeTclButton* bt);
    void removeMouseAction(KonoeTclButton* bt);
    void addMouseAction(KonoeTclCanvas* bt);
    void addMouseAction(KonoeTclCheckButton* bt);
    void addMouseAction(KonoeTclEntry* bt);
    void addMouseAction(KonoeTclLabel* bt);
    void addMouseAction(KonoeTclListBox* bt);
    void addMouseAction(KonoeTclMenu* bt);
    void addMouseAction(KonoeTclMenuButton* bt);
    void addMouseAction(KonoeTclMessage* bt);
    void addMouseAction(KonoeTclRadioButton* bt);
    void addMouseAction(KonoeTclSlider* bt);
    void addMouseAction(KonoeTclText* bt);
    void addMouseAction(KonoeTclWindow* bt);

  private:

    static void mouseActionButton(KonoeTclButton* kbt, XEvent* xe);
    static void mouseActionCanvas(KonoeTclCanvas* kbt, XEvent* xe);
    static void mouseActionCheckButton(KonoeTclCheckButton* kbt, XEvent* xe);
    static void mouseActionEntry(KonoeTclEntry* kbt, XEvent* xe);
    static void mouseActionLabel(KonoeTclLabel* kbt, XEvent* xe);
    static void mouseActionListBox(KonoeTclListBox* kbt, XEvent* xe);
    static void mouseActionMenu(KonoeTclMenu* kbt, XEvent* xe);
    static void mouseActionMenuButton(KonoeTclMenuButton* kbt, XEvent* xe);
    static void mouseActionMessage(KonoeTclMessage* kbt, XEvent* xe);
    static void mouseActionRadioButton(KonoeTclRadioButton* kbt, XEvent* xe);
    static void mouseActionSlider(KonoeTclSlider* kbt, XEvent* xe);
    static void mouseActionText(KonoeTclText* kbt, XEvent* xe);
    static void mouseActionWindow(KonoeTclWindow* kbt, XEvent* xe);

    enum widgetType { Button=0, Canvas, CheckButton, Entry, Label, ListBox,
                      Menu, MenuButton, Message, RadioButton, Slider, Text };
};

#endif
