//=====================================================================
/*

    KonoeTclMouseMotion.hh

    Version 0.5.0   07-Oct-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLMOUSEMOTION_HH
#define __KONOETCLMOUSEMOTION_HH

#include <tk.h>
#include <ui/KonoeTclUIPrimitive.hh>
#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclButton.hh>
#include <ui/KonoeTclCanvas.hh>
#include <ui/KonoeTclCheckButton.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclListBox.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclMessage.hh>
#include <ui/KonoeTclRadioButton.hh>
#include <ui/KonoeTclSlider.hh>
#include <ui/KonoeTclText.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclEventProcessor.hh>

class KonoeTclMouseMotion {

  public:
    KonoeTclMouseMotion();
    virtual ~KonoeTclMouseMotion();

    void addMouseMotion(KonoeTclButton* bt);
    void addMouseMotion(KonoeTclCanvas* bt);
    void addMouseMotion(KonoeTclCheckButton* bt);
    void addMouseMotion(KonoeTclEntry* bt);
    void addMouseMotion(KonoeTclLabel* bt);
    void addMouseMotion(KonoeTclListBox* bt);
    void addMouseMotion(KonoeTclMenu* bt);
    void addMouseMotion(KonoeTclMenuButton* bt);
    void addMouseMotion(KonoeTclMessage* bt);
    void addMouseMotion(KonoeTclRadioButton* bt);
    void addMouseMotion(KonoeTclSlider* bt);
    void addMouseMotion(KonoeTclText* bt);
    void addMouseMotion(KonoeTclWindow* bt);

  private:

    static void mouseMotionButton(KonoeTclButton* kbt, XEvent* xe);
    static void mouseMotionCanvas(KonoeTclCanvas* kbt, XEvent* xe);
    static void mouseMotionCheckButton(KonoeTclCheckButton* kbt, XEvent* xe);
    static void mouseMotionEntry(KonoeTclEntry* kbt, XEvent* xe);
    static void mouseMotionLabel(KonoeTclLabel* kbt, XEvent* xe);
    static void mouseMotionListBox(KonoeTclListBox* kbt, XEvent* xe);
    static void mouseMotionMenu(KonoeTclMenu* kbt, XEvent* xe);
    static void mouseMotionMenuButton(KonoeTclMenuButton* kbt, XEvent* xe);
    static void mouseMotionMessage(KonoeTclMessage* kbt, XEvent* xe);
    static void mouseMotionRadioButton(KonoeTclRadioButton* kbt, XEvent* xe);
    static void mouseMotionSlider(KonoeTclSlider* kbt, XEvent* xe);
    static void mouseMotionText(KonoeTclText* kbt, XEvent* xe);
    static void mouseMotionWindow(KonoeTclWindow* kbt, XEvent* xe);

};

#endif
