//=====================================================================
/*

    KonoeTclProgressBar.cc

    Version 0.5.0   22-Nov-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <ui/KonoeTclProgressBar.hh>
#include <ui/KonoeTclWindow.hh>

#include <string.h>

KonoeTclProgressBar::KonoeTclProgressBar(KonoeTclWindow* kwin, KChar* kname) :
  KonoeTclCanvas(kwin, kname)
{
  parentWindow = kwin;
  strcpy(fcolor, "blue");
  strcpy(bcolor, "white");
  strcpy(txtColor, "black");
  
  width = 300;
  height = 30;
  max = 100;
  min = 0;
  value = 0;
  KonoeTclCanvas::setSize(width, height);
}

KonoeTclProgressBar::~KonoeTclProgressBar()
{ ; }

void KonoeTclProgressBar::create(KonoeTclWindow* kwin, KChar* kname)
{
  //KonoeTclCanvas::create(kwin, kname);
  KonoeTclCanvas::setSize(width, height);
}

void KonoeTclProgressBar::setValue(KInt v)
{
  value = v;
  setColor(bcolor);
  drawFillRectangle(0, 0, width, height);
  setColor(fcolor);
  barlength = (KInt) v*width/(max-min);
  drawFillRectangle(0, 0, barlength, height);
}

void KonoeTclProgressBar::setBarWidth(KInt l)
{
  width = l;
  setSize(width, height);
  setValue(value);
}

void KonoeTclProgressBar::setBarHeight(KInt l)
{
  height = l;
  setSize(width, height);
  setValue(value);
}

void KonoeTclProgressBar::setBarSize(KInt w, KInt h)
{
  width = w;
  height = h;
  setSize(width, height);
  setValue(value);
}

void KonoeTclProgressBar::setForwardColor(KChar* pcolor)
{
  strcpy(fcolor, pcolor);
  setValue(value);
}

void KonoeTclProgressBar::setBackgroundColor(KChar* pcolor)
{
  strcpy(bcolor, pcolor);
  setValue(value);
}

void KonoeTclProgressBar::setMax(KInt v)
{
  max = v;
  setValue(value);
}

void KonoeTclProgressBar::setMin(KInt v)
{
  min = v;
  setValue(value);
}

void KonoeTclProgressBar::setMinMax(KInt minvalue, KInt maxvalue)
{
  min = minvalue;
  max = maxvalue;
  setValue(value);
}

void KonoeTclProgressBar::setText(KChar* txt)
{
  setColor(txtColor);
  drawText(width/2, height/2, txt);
}

void KonoeTclProgressBar::setTextColor(KChar* col)
{
  strcpy(txtColor, col);
}
