//=====================================================================
/*

    KonoeTclProgressBar.hh

    Version 0.5.0   22-Nov-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLPROGRESSBAR_HH
#define __KONOETCLPROGRESSBAR_HH

#include <ui/KonoeTclCanvas.hh>

class KonoeTclWindow;

class KonoeTclProgressBar : public KonoeTclCanvas {

  public:
    KonoeTclProgressBar(KonoeTclWindow* kwin, KChar* kname);
    ~KonoeTclProgressBar();

    void setValue(KInt v);
    void setBarWidth(KInt l);
    void setBarHeight(KInt l);
    void setBarSize(KInt w, KInt h);

    void setForwardColor(KChar* color);
    void setBackgroundColor(KChar* color);

    void setMax(KInt v);
    void setMin(KInt v);
    void setMinMax(KInt minvalue, KInt maxvalue);

    void setText(KChar* txt);
    void setTextColor(KChar* txt);

    inline KInt getValue() const { return value; }
    inline KInt getBarLength() const { return barlength; }
    inline KInt getMax() const { return max; }
    inline KInt getMin() const { return min; }

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    KInt value;
    KInt width;
    KInt height;
    KInt min;
    KInt max;
    KInt barlength;
    KBool orientation;

    KChar fcolor[64];
    KChar bcolor[64];
    KChar txtColor[64];
};

#endif
