//=====================================================================
/*

    KonoeTclRadioButton.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLRADIOBUTTON_HH
#define __KONOETCLRADIOBUTTON_HH

#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclWindow.hh>

class KonoeTclRadioButton : public KonoeTclGraphics {
  public:
    KonoeTclRadioButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap);
    KonoeTclRadioButton(KonoeTclWindow* kwin, KChar* kname, KChar* cap, 
                        KInt col, KInt row);
    ~KonoeTclRadioButton();

    void mouseActionUI(KonoeTclRadioButton* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclRadioButton* kbt, XEvent* xe);
    void keyActionUI(KonoeTclRadioButton* kbt, XEvent* xe);
    void windowActionUI(KonoeTclRadioButton* kbt, XEvent* xe);

    void  setCaption(KChar* cap);
    void  setGroup(KChar* grp);
    void  setSelect();
    inline KChar* getGroup() { return group; }
    KChar* getValue();
    void enable();
    void disable();

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar caption[256];
    KChar group[32];
};

#endif
