//=====================================================================
/*

    KonoeTclSlider.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#ifndef __KONOETCLSLIDER_HH
#define __KONOETCLSLIDER_HH

#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclWindow.hh>

class KonoeTclSlider : public KonoeTclGraphics {
  public:
    KonoeTclSlider(KonoeTclWindow* kwin, KChar* kname, KChar* cap);
    KonoeTclSlider(KonoeTclWindow* kwin, KChar* kname, KChar* cap,
                   KInt col, KInt row);
    ~KonoeTclSlider();

    void mouseActionUI(KonoeTclSlider* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclSlider* kbt, XEvent* xe);
    void keyActionUI(KonoeTclSlider* kbt, XEvent* xe);
    void windowActionUI(KonoeTclSlider* kbt, XEvent* xe);

    void setCaption(KChar* cap);
    void setMinMax(KInt mn, KInt mx);
    void setLength(KInt l);
    void setShowValue(KInt b);
    void setOrient(KChar* o);
    void setTickInterval(KInt v);
    void setResolution(KInt v);
    void setBigIncrement(KInt v);
    void setWidth(KInt w);
    void setValue(KInt v);

    KInt  getIndex();

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar caption[32];
};

#endif
