//=====================================================================
/*

    KonoeTclText.hh

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi
    Version 0.6.2   05-Nov-2000 K. Sakai, Y. Ikuta

*/
//====================================================================

#ifndef __KONOETCLTEXT
#define __KONOETCLTEXT

#include <ui/KonoeTclGraphics.hh>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclFrame.hh>

class KonoeTclText : public KonoeTclGraphics {
  public:
    KonoeTclText(KonoeTclWindow* kwin, KChar* kname);
    KonoeTclText(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    KonoeTclText(KonoeTclWindow* kwin, KChar* kname, KScrollType scrl);
    KonoeTclText(KonoeTclWindow* kwin, KChar* kname, KScrollType scrl,
                 KInt col, KInt row);
    ~KonoeTclText();

    void mouseActionUI(KonoeTclText* kbt, XEvent* xe);
    void mouseMotionUI(KonoeTclText* kbt, XEvent* xe);
    void keyActionUI(KonoeTclText* kbt, XEvent* xe);
    void windowActionUI(KonoeTclText* kbt, XEvent* xe);

    void setSize(KInt width, KInt height);
    void insert(KChar* contents);
    void insert(KChar* contents,KChar* tag);
    KDouble index(KChar* _pos);
    void clear();
    void tagClear(KChar* _tag);

    KChar* getText();

    void deleteText(KInt startID, KInt endID);
    void setBackGround(KChar* col );
    void setBackGround(KChar* _tag,KChar* _color );
    void setForeGround(KChar* _tag,KChar* _color );
    void setBorderWidth(KChar* _tag ,KInt pix);
    void setTagFont(KChar* _tag ,KChar* _font );
    void setJustify(KChar* _tag,KChar* _justify);
    void setLmargin1(KChar* _tag,KInt pix);
    void setLmargin2(KChar* _tag,KInt pix);
    void setOffset(KChar* _tag,KInt pix);
    void setOverStrike(KChar* _tag,KInt boolean);
    void setRelief(KChar* _tag,KChar* _relief);
    void setRmargin(KChar* _tag,KInt pix);
    void setSpacing1(KChar* _tag,KInt pix);
    void setSpacing2(KChar* _tag,KInt pix);
    void setSpacing3(KChar* _tag,KInt pix);
    void setTabs(KChar* _tag,KChar* tablist);
    void setUnderLine(KChar* _tag,KInt boolean);
    void setWrap(KChar* _tag,KChar* mode);
    void scrollOneUnitToBottom();
    void scrollOneUnitToTop();
    void scrollOneUnitToRight();
    void scrollOneUnitToLeft();
    void scrollOnePageToBottom();
    void scrollOnePageToTop();
    void scrollOnePageToRight();
    void scrollOnePageToLeft();
    void scrollXTo(KFloat value);
    void scrollYTo(KFloat value);
    KFloat getCurrentXPosition();
    KFloat getCurrentYPosition();
    void printText();
    KInt search(KChar* search_string);

  private:
    void create(KonoeTclWindow* kwin, KChar* kname);
    void create(KonoeTclWindow* kwin, KChar* kname, KInt col, KInt row);
    void createWithScrollBar(KonoeTclWindow* kwin, KChar* kname);
    void createWithScrollBar(KonoeTclWindow* kwin, KChar* kname,
                             KInt col, KInt row);
    void createProcess(KonoeTclWindow* kwin, KChar* kname);
    KChar scrll[256];
    KonoeTclFrame* scrollFrame;
};

#endif
