//=====================================================================
/*

    KonoeTclUIPrimitive.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <string.h>
#include <stdlib.h>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclUIPrimitive.hh>
#include <ui/KonoeTclEventProcessor.hh>
#include <ui/KonoeTclMouseListener.hh>
#include <ui/KonoeTclMouseMotionListener.hh>
#include <ui/KonoeTclKeyListener.hh>
#include <ui/KonoeTclWindowListener.hh>
#include <ui/KonoeTclDimension.hh>

KonoeTclUIPrimitive::KonoeTclUIPrimitive()
{
  strcpy(type, "top");
  t = Button;
  isEnable = KTrue;
}

KonoeTclUIPrimitive::~KonoeTclUIPrimitive()
{
  ;
}

void KonoeTclUIPrimitive::addMouseListener(KonoeTclMouseListener* l)
{
  listener = l;
  l->setWidget( this );
}

void KonoeTclUIPrimitive::addMouseMotionListener(KonoeTclMouseMotionListener* l)
{
  listener = l;
  l->setWidget( this );
}

void KonoeTclUIPrimitive::addKeyListener(KonoeTclKeyListener* l)
{
  listener = l;
  l->setWidget( this );
}

void KonoeTclUIPrimitive::addWindowListener(KonoeTclWindowListener* l)
{
  listener = l;
  l->setWidget( this );
}

void KonoeTclUIPrimitive::mouseEvent(KonoeTclUIPrimitive* wid, XEvent* xe)
{
  KonoeTclMouseListener* l = (KonoeTclMouseListener*) listener;

  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xe->xbutton.type;
  button = xe->xbutton.button;
  time = xe->xbutton.time;
  x = xe->xbutton.x;
  y = xe->xbutton.y;

  if( isEnable ){
    l->mouseEvent(wid, xe);
    l->mouseEvent(wid, btype, button, time, x, y);
  }
}

void KonoeTclUIPrimitive::mouseMotionEvent(KonoeTclUIPrimitive* wid, XEvent* xe)
{
  KonoeTclMouseMotionListener* l = (KonoeTclMouseMotionListener*) listener;

  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xe->xbutton.type;
  state = xe->xbutton.state;
  time = xe->xbutton.time;
  x = xe->xbutton.x;
  y = xe->xbutton.y;

  if( isEnable ){
    l->mouseMotionEvent(wid, xe);
    l->mouseMotionEvent(wid, btype, state, time, x, y);
  }
}

void KonoeTclUIPrimitive::keyEvent(KonoeTclUIPrimitive* wid, XEvent* xe)
{
  KonoeTclKeyListener* l = (KonoeTclKeyListener*) listener;

  KChar buffer[20];
  KInt bufsize = 20;
  KeySym keysym;
  KInt btype;
  KInt state;

  XLookupString(&(xe->xkey), buffer, bufsize, &keysym, (XComposeStatus*) NULL);
  btype = xe->xkey.type;
  state = xe->xkey.state;

  if( isEnable ){
    l->keyEvent(wid, xe);
    l->keyEvent(wid, btype, keysym, state);
  }
}

void KonoeTclUIPrimitive::windowEvent(KonoeTclUIPrimitive* wid, XEvent* xe)
{
  KonoeTclWindowListener* l = (KonoeTclWindowListener*) listener;

  if( isEnable ){
    l->windowEvent(wid, xe);
  }
}

void KonoeTclUIPrimitive::timerUI()
{
  kEventProcessor->timer();
}

void KonoeTclUIPrimitive::timerUI(KonoeTclUIPrimitive* uip)
{
  kEventProcessor->timer(uip);
}

KonoeTclDimension KonoeTclUIPrimitive::getScreenSize()
{
  KInt w;
  KInt h;
  KChar cmd[256];
  KChar tcl_screenWidth[32];
  strcpy(tcl_screenWidth, "width_of_widget");
  KChar tcl_screenHeight[32];
  strcpy(tcl_screenHeight, "height_of_widget"); 

  sprintf(cmd, "set %s [ winfo width %s ]", tcl_screenWidth,path);
  configNoUpdate(cmd);
  sprintf(cmd, "set %s [ winfo height %s ]", tcl_screenHeight,path);
  configCommand(cmd);

  KChar widgetWidth[8];
  KChar widgetHeight[8];
  strcpy(widgetWidth,
         Tcl_GetVar(mgr->getInterp(), tcl_screenWidth, TCL_GLOBAL_ONLY));
  strcpy(widgetHeight,
         Tcl_GetVar(mgr->getInterp(), tcl_screenHeight,TCL_GLOBAL_ONLY));

  w = atoi( widgetWidth );
  h = atoi( widgetHeight );

  screenSize.setWidth( w );
  screenSize.setHeight( h );

  return screenSize;
}

void KonoeTclUIPrimitive::fillX()
{
  KChar cmd[256];
  sprintf(cmd, "pack %s -fill x", path);
  configCommand(cmd);
}

void KonoeTclUIPrimitive::fillY()
{
  KChar cmd[256];
  sprintf(cmd, "pack %s -fill y", path);
  configCommand(cmd);
}

void KonoeTclUIPrimitive::fillBoth()
{
  KChar cmd[256];
  sprintf(cmd, "pack %s -fill both", path);
  configCommand(cmd);
}

void KonoeTclUIPrimitive::setExpand()
{
  KChar cmd[256];
  sprintf(cmd, "pack %s -expand yes", path);
  configCommand(cmd);
}

void KonoeTclUIPrimitive::setRelief(KInt _reliefType)
{
  reliefType = _reliefType;
  KChar cmd[256];
  KChar rtype[16];
  switch(_reliefType){
    case KFlat:
      strcpy(rtype, "flat");
      break;
    case KGroove:
      strcpy(rtype, "groove");
      break;
    case KRaised:
      strcpy(rtype, "raised");
      break;
    case KRidge:
      strcpy(rtype, "ridge");
      break;
    case KSolid:
      strcpy(rtype, "solid");
      break;
    case KSunken:
      strcpy(rtype, "sunken");
      break;
    default:
      strcpy(rtype, "raised");
  }
  sprintf(cmd, "%s configure -relief %s", path, rtype);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::resetRelief()
{
  setRelief(reliefType);
}

void KonoeTclUIPrimitive::setBorderWidth(KInt bord)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -borderwidth %ld",path, bord);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setSide(KInt side)
{
  KChar cmd[256];
  KChar kside[12];

  switch(side){
    case KPutTop:
      strcpy(kside, "top");
      break;
    case KPutBottom:
      strcpy(kside, "bottom");
      break;
    case KPutLeft:
      strcpy(kside, "left");
      break;
    case KPutRight:
      strcpy(kside, "right");
      break;
    case KPutCenter:
      strcpy(kside, "center");
      break;
    default:
      strcpy(kside, "center");
  }
  sprintf(cmd, "pack %s -side %s", path, kside);
  configCommand(cmd);
}

void KonoeTclUIPrimitive::setIpadx(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "pack configure %s -ipadx %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setIpady(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "pack configure %s -ipady %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setPadx(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "pack configure %s -padx %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setPady(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "pack configure %s -pady %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setAnchor(KAnchor anchorType)
{
  KChar cmd[256];
  KChar kAnchor[16];

  switch(anchorType){
    case KN: sprintf(kAnchor, "n"); break;
    case KNE: sprintf(kAnchor, "ne"); break;
    case KNW: sprintf(kAnchor, "nw"); break;
    case KS: sprintf(kAnchor, "s"); break;
    case KSE: sprintf(kAnchor, "se"); break;
    case KSW: sprintf(kAnchor, "sw"); break;
    case KE: sprintf(kAnchor, "e"); break;
    case KW: sprintf(kAnchor, "w"); break;
    case KC: sprintf(kAnchor, "c"); break;
    default: sprintf(kAnchor, "c");
  }

  sprintf(cmd, "%s configure -anchor %s", path, kAnchor);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setForget()
{
  KChar cmd[256];
  sprintf(cmd, "pack forget %s", path);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setWidth(KInt w)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -width %d", path, w);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setHeight(KInt h)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -height %d", path, h);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridColumn(KInt n)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -column %ld", path, n);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridColumnspan(KInt n)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -columnspan %ld", path, n);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridIn(KChar* pPath)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -in %s", path, pPath);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridIpadx(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -ipadx %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridIpady(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -ipady %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridPadx(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -padx %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridPady(KInt amount)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -pady %ld", path, amount);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridRow(KInt n)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -row %ld", path, n);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridRowspan(KInt n)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -rowspan %ld", path, n);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridSticky(KChar* style)
{
  KChar cmd[256];
  sprintf(cmd, "grid configure %s -sticky %s", path, style);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridColMinsize(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid columnconfigure %s %ld -minsize %ld", 
                                  getParentPath(), id, value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridColWeight(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid columnconfigure %s %ld -weight %ld", 
                                  getParentPath(), id, value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridColPad(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid columnconfigure %s %ld -pad %ld", 
                                  getParentPath(), id,  value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridRowMinsize(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid rowconfigure %s %ld -minsize %ld",
                               getParentPath(), id, value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridRowWeight(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid rowconfigure %s %ld -weight %ld", 
                               getParentPath(), id, value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridRowPad(KInt id, KInt value)
{
  KChar cmd[256];
  sprintf(cmd, "grid rowconfigure %s %ld -pad %ld",
                               getParentPath(), id, value);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setGridForget()
{
  KChar cmd[256];
  sprintf(cmd, "grid forget %s", path);
  configNoUpdate(cmd);
}

KonoeTclDimension KonoeTclUIPrimitive::getGridLocation(KInt x, KInt y)
{
  KChar cmd[256];
  KChar wcmd[256];

  sprintf(cmd, "grid location %s %ld %ld", getParentPath(), x, y);
  sprintf(wcmd, "set %s [ %s ]", tcl_tmpvalue, cmd);
  configCommand(cmd);

  KChar klist[256];
  strcpy(klist,
         Tcl_GetVar(mgr->getInterp(), tcl_tmpvalue, TCL_GLOBAL_ONLY));

  KChar col[16];
  KChar row[16];
  strcpy(col, strtok(klist, " "));
  strcpy(row, strtok(NULL, " "));

  KInt colnum;
  KInt rownum;

  colnum = atoi(col);
  rownum = atoi(row);

  dim.setHeight( colnum );
  dim.setWidth( rownum );

  return dim;
}

KonoeTclDimension KonoeTclUIPrimitive::getGridSize()
{
  KChar cmd[256];
  KChar wcmd[256];

  sprintf(cmd, "grid size %s", getParentPath());
  sprintf(wcmd, "set %s [ %s ]", tcl_tmpvalue, cmd);
  configCommand(cmd);

  KChar klist[256];
  strcpy(klist,
         Tcl_GetVar(mgr->getInterp(), tcl_tmpvalue, TCL_GLOBAL_ONLY));

  KChar w[16];
  KChar h[16];
  strcpy(w, strtok(klist, " "));
  strcpy(h, strtok(NULL, " "));

  KInt wnum;
  KInt hnum;

  wnum = atoi(w);
  hnum = atoi(h);

  dim.setHeight( wnum );
  dim.setWidth( hnum );

  return dim;
}

void KonoeTclUIPrimitive::setFont(KChar* pname, KInt size, KInt weight,
                                  KInt slant, KInt underline, KInt overstrike)
{
  KChar cWeight[16];
  KChar cSlant[16];
  KChar cUnderline[16];
  KChar cOverstrike[16];

  if(weight) strcpy(cWeight, "bold");
  else       strcpy(cWeight, "normal");
  if(slant) strcpy(cSlant, "italic");
  else      strcpy(cSlant, "roman");
  if(underline) strcpy(cUnderline, "underline");
  else          strcpy(cUnderline, "");
  if(overstrike) strcpy(cOverstrike, "overstrike");
  else           strcpy(cOverstrike, "");

  KChar cmd[256];
  sprintf(cmd, "%s configure -font { {%s} %d { %s %s %s %s}}", path,
                pname, size ,cWeight, cSlant, cUnderline, cOverstrike);
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::getAllFontName()
{
  KChar cmd[256];
  sprintf(cmd, "puts [ font families ]");
  configNoUpdate(cmd);
}

void KonoeTclUIPrimitive::setCursor(KChar* cursorName)
{
  KChar cmd[256];
  sprintf(cmd, "%s configure -cursor %s", path, cursorName);
  configNoUpdate(cmd);
}
