//=====================================================================
/*

    KonoeTclWindow.cc

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <tcl.h>
#include <tk.h>
#include <ui/KonoeTclWindow.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclEventProcessor.hh>

void KonoeTclWindow::setGeometry(KonoeTclWindow* kwin,
                                 KInt x, KInt y, KInt w, KInt h)
{
  KChar cmd[256];
  sprintf(cmd, "wm geometry %s %ldx%ld+%ld+%ld", kwin->getPath(), w, h, x, y);
  Tcl_Eval(mgr->getInterp(), cmd);
  Tcl_Eval(mgr->getInterp(), "update");
}

void KonoeTclWindow::show()
{
  KChar cmd[256];
  sprintf(cmd, "wm deiconify %s", this->getPath());
  configCommand(cmd);
}

void KonoeTclWindow::hide()
{
  KChar cmd[256];
  sprintf(cmd, "wm withdraw %s", this->getPath());
  configCommand(cmd);
}

void KonoeTclWindow::show(KonoeTclWindow* kwin)
{
  KChar cmd[256];
  sprintf(cmd, "wm deiconify %s", kwin->getPath());
  configCommand(cmd);
}

void KonoeTclWindow::hide(KonoeTclWindow* kwin)
{
  KChar cmd[256];
  sprintf(cmd, "wm withdraw %s", kwin->getPath());
  configCommand(cmd);
}

void KonoeTclWindow::destroy()
{
  KChar cmd[256];
  sprintf(cmd, "destroy %s", getPath());
  configCommand(cmd);
}

void KonoeTclWindow::setFocusModel(KChar* model)
{
  KChar cmd[256];
  sprintf(cmd, "wm focusmodel %s", model);
  configNoUpdate(cmd);
}

void KonoeTclWindow::mouseActionUI(KonoeTclWindow* kbt, XEvent* xe)
{
  KInt btype;
  KInt button;
  Time time;
  KInt x;
  KInt y;

  btype = xe->xbutton.type;
  button = xe->xbutton.button;
  time = xe->xbutton.time;
  x = xe->xbutton.x;
  y = xe->xbutton.y;

  kEventProcessor->mouseAction(kbt, btype, button, time,x, y);
  kEventProcessor->mouseAction(kbt, xe);
}

void KonoeTclWindow::mouseMotionUI(KonoeTclWindow* kbt, XEvent* xe)
{
  KInt btype;
  KInt state;
  Time time;
  KInt x;
  KInt y;

  btype = xe->xbutton.type;
  state = xe->xbutton.state;
  time = xe->xbutton.time;
  x = xe->xbutton.x;
  y = xe->xbutton.y;

  kEventProcessor->mouseMotion(kbt, btype, state, time,x, y);
  kEventProcessor->mouseMotion(kbt, xe);
}

void KonoeTclWindow::keyActionUI(KonoeTclWindow* kbt, XEvent* xev)
{
  KChar buffer[20];
  KInt bufsize = 20;
  KeySym keysym;
  KInt btype;
  KInt state;

  XLookupString(&(xev->xkey), buffer, bufsize, &keysym, (XComposeStatus*) NULL);
  btype = xev->xkey.type;
  state = xev->xkey.state;

  kEventProcessor->keyAction(kbt, btype, keysym, state);
  kEventProcessor->keyAction(kbt, xev);
}

void KonoeTclWindow::windowActionUI(KonoeTclWindow* kbt, XEvent* xev)
{
  kEventProcessor->windowAction(kbt, xev);
}
