//=====================================================================
/*

    main.cc

      Sample Program

    Version 0.0.1   05-Aug-1999 T. Hosoi
    Version 0.5.0   28-Sep-1999 T. Hosoi
    Version 0.6.0   01-Feb-2000 T. Hosoi
    Version 0.6.1   05-Apr-2000 T. Hosoi

*/
//====================================================================

#include <iostream.h>
#include <ui/KonoeTclMainWindow.hh>
#include <ui/KonoeTclSubWindow.hh>
#include <ui/KonoeTclManager.hh>
#include <ui/KonoeTclFrame.hh>
#include <ui/KonoeTclCanvas.hh>
#include <ui/KonoeTclButton.hh>
#include <ui/KonoeTclLabel.hh>
#include <ui/KonoeTclEntry.hh>
#include <ui/KonoeTclRadioButton.hh>
#include <ui/KonoeTclCheckButton.hh>
#include <ui/KonoeTclListBox.hh>
#include <ui/KonoeTclSlider.hh>
#include <ui/KonoeTclMenu.hh>
#include <ui/KonoeTclMenuButton.hh>
#include <ui/KonoeTclText.hh>
#include <ui/KonoeTclDialogBox.hh>

KonoeTclSubWindow* sub;
KonoeTclCanvas* cvs;
KonoeTclRadioButton* r4;
KonoeTclCheckButton* c1;
KonoeTclEntry* ent;
KonoeTclListBox* klb;
KonoeTclSlider* sca;
KonoeTclDialogBox* dbox;

static void Button1EventProc(ClientData clientData, XEvent* eventPtr){
  KonoeTclButton* bt = (KonoeTclButton*) clientData;
  if(eventPtr->type == ButtonPress){
    if(eventPtr->xbutton.button == 1){
      cvs->setColor("black");
      cvs->drawLine(5,5,120,80);
      cvs->setColor("green");
      cvs->drawRectangle(5,5,120,80);
      cvs->setColor("#ff0000");
      cvs->drawText(65,65,"ABCDEFG");
      cvs->drawLine(65,0,65,150);
      cvs->setColor("blue");
      cvs->drawFillRectangle(130,70,240,120);

      KInt x[] = { 10,20,50,40,10 };
      KInt y[] = { 80,70,60,100,120 };
      cvs->setColor("red");
      cvs->drawPolygon(x, y, 5);
      sub->show(sub);
    }
  }
  bt->setRelief(KRaised);
}

static void Button2EventProc(ClientData clientData, XEvent* eventPtr){
  KonoeTclRadioButton* bt = (KonoeTclRadioButton*) clientData;
  if(eventPtr->type == ButtonPress){
    if(eventPtr->xbutton.button == 1){
      dbox = new KonoeTclDialogBox();
      if(KYES == dbox->create(sub, 
                 "Canvas Clear.\nPrint Status.\nHide SubWindow.",
                  KYesNoCancel, "Message", KInfo)){
        cvs->setColor("white");
        cvs->drawFillRectangle(0,0,300,150);
        cout << "Selected RadioButton : " << r4->getValue() << endl;
        cout << "CheckButton State    : " << c1->getValue() << endl;
        cout << "Text of Entry        : " << ent->getText() << endl;
        cout << "Total ListBox Item   : " << klb->getTotalIndex() << endl;
        cout << "Selected ListBox Item: " << klb->getSelectedIndex() << endl;
        cout << "Number of Slider      : " << sca->getIndex() << endl;
        sub->hide(sub);
      }
      else ;
    }
  }
  bt->setRelief(KRaised);
}

static void timerHandler(ClientData clientData){
  static KInt x;
  static KInt y;
  x += 10;
  y += 10;
  if(x > 150){
    x = 0;
    y = 0;
  }
  cvs->setColor("black");
  cvs->drawRectangle(x, y, x+10, y+10);
  Tcl_CreateTimerHandler(1000, timerHandler, clientData);
}

int main()
{
  KonoeTclMainWindow* mainw = new KonoeTclMainWindow("Sample Program");

  KonoeTclManager* magr = mainw->getManager();

  KonoeTclFrame* frm = new KonoeTclFrame(mainw, "f");

  cvs = new KonoeTclCanvas(mainw, "c");
  cvs->setSize(300, 150);
  cvs->setBackGround("white");

  KonoeTclButton* btn = new KonoeTclButton(frm,"b", "Button1");
  btn->setBackGround("tomato");
  btn->setFont("times", 24, 0, 0, 1, 0);
  btn->setCursor("mouse");

  Tk_CreateEventHandler(btn->getWindow(), ButtonPress, 
                        Button1EventProc, (ClientData) btn);


  KonoeTclButton* btn2 = new KonoeTclButton(frm,"bb","Button2");
  btn2->setFont("lucida", 12, 1, 0, 0, 0);
  btn2->setCursor("hand2");


  Tk_CreateEventHandler(btn2->getWindow(), ButtonPress, 
                        Button2EventProc, (ClientData) btn2);


  ent = new KonoeTclEntry(frm,"e");
  ent->setText("Write text to entry");

  KonoeTclLabel* lbl = new KonoeTclLabel(frm,"l","Label No.1");

  frm->setFrame();

  KonoeTclRadioButton* r1 = new KonoeTclRadioButton(mainw, "r1_g1", "Radio1");
  r1->setSelect();
  KonoeTclRadioButton* r2 = new KonoeTclRadioButton(mainw, "r2_g1", "radio2");
  KonoeTclRadioButton* r3 = new KonoeTclRadioButton(mainw, "r3_g2", "radio3");
  //KonoeTclRadioButton* r4 = new KonoeTclRadioButton("radio4");
  r4 = new KonoeTclRadioButton(mainw, "r4_g2", "radio4");
  Tk_CreateEventHandler(r4->getWindow(), ButtonPress, 
                        Button2EventProc, (ClientData) r4);

  c1 = new KonoeTclCheckButton(mainw, "c11", "check1");
  c1->setCaption("Check1");
  c1->setSelect();
  
  KonoeTclCheckButton* c2 = new KonoeTclCheckButton(mainw, "c22", "check2");

  klb = new KonoeTclListBox(frm, "l1");
  klb->setSize(10, 5);
  klb->insert("AAAA");
  klb->insert("BBBB");
  klb->insert("CCCC");
  klb->insert("DDDD");
  klb->insert("EEEE");
  klb->insert("FFFF");
  klb->setMode("extended");

  sca = new KonoeTclSlider(mainw, "s", "Slider");
  sca->setMinMax(0, 100);
  //sca->setShowValue(false);
  

  Tcl_CreateTimerHandler(1000, timerHandler, (ClientData) magr->getInterp());

  sub = new KonoeTclSubWindow(mainw, "sub", "Sub Window");
  sub->setGeometry(sub, 100,100,200,200);

  KonoeTclCanvas* cvs2 = new KonoeTclCanvas(sub, "cvs2");
  cvs2->setSize(300, 150);
  cvs2->setBackGround("white");

  KonoeTclCheckButton* c3 = new KonoeTclCheckButton(sub, "c33", "check3");

  KonoeTclMenu* men1 = new KonoeTclMenu(mainw, "m1");
  KonoeTclMenu* men2 = new KonoeTclMenu(men1, "m2");
  men2->addCommand("Exit", "exit");
  men1->makeCascade(men2, "File");

  KonoeTclMenuButton* mbutton = new KonoeTclMenuButton( frm, "mb1", "MBUTTON");
  KonoeTclMenu* mbm2 = new KonoeTclMenu(mbutton, "m2");
  mbm2->addCommand("Exit", "exit");
  mbutton->createMButton();

/*
  KonoeTclText* txt = new KonoeTclText;
  txt->create(mainw, "t");
  txt->insert("TEST Text\n");

  KChar cmd[256];
  for(int i=0; i<20; i++){
    sprintf(cmd, "%d\n", i);
    txt->insert(cmd);
  }
*/

  mainw->mainLoop();

  return 0;
}
